////////////////////////////////////////////////////////////////////////////////
///
/// BackupActivity.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BackupActivity.h"


BackupActivity::BackupActivity()
{
	InitLists();
	setDefaults();
}

BackupActivity::BackupActivity(const BackupActivity& rObject)
: CBaseNode()
{
	Copy(rObject);
}

BackupActivity::BackupActivity(const BackupActivity* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BackupActivity& BackupActivity::operator=(const BackupActivity& rObject)
{
	Copy(rObject);
	return *this;
}

BackupActivity::BackupActivity(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BackupActivity::~BackupActivity()
{
	ClearLists();
}


BackupEscort* BackupActivity::getEscort() const
{
	if (!m_lstEscort.isEmpty())
	{
		return m_lstEscort[0];
	}
	return 0;
}

void BackupActivity::setEscort(BackupEscort* pEscort)
{
	ClearList<BackupEscort>(m_lstEscort);
	if (pEscort)
	{
		m_lstEscort += pEscort;
	}
}

BackupSnapshot* BackupActivity::getSnapshot() const
{
	if (!m_lstSnapshot.isEmpty())
	{
		return m_lstSnapshot[0];
	}
	return 0;
}

void BackupActivity::setSnapshot(BackupSnapshot* pSnapshot)
{
	ClearList<BackupSnapshot>(m_lstSnapshot);
	if (pSnapshot)
	{
		m_lstSnapshot += pSnapshot;
	}
}

QString BackupActivity::getUuid() const
{
	return m_qsUuid;
}

void BackupActivity::setUuid(QString value)
{
	m_qsUuid = value;
}

void BackupActivity::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid();
}

QDomElement BackupActivity::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BackupActivity") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "Escort";
	nMaxItemId = getMaxItemId<BackupEscort>(m_lstEscort, "Escort", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstEscort.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const BackupEscort* object = m_lstEscort[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Escort", mapMaxDynListIds));

	dyn_lists += "Snapshot";
	nMaxItemId = getMaxItemId<BackupSnapshot>(m_lstSnapshot, "Snapshot", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstSnapshot.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const BackupSnapshot* object = m_lstSnapshot[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Snapshot", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BackupActivity::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BackupActivity") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BackupActivity': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_Escort = getMaxItemId2(element, "Escort");
	QMap<int , QString > mapEscort;
	if (unite_with_loaded)
		fillItemIdMap<BackupEscort>(m_lstEscort, mapEscort);
	int nMaxItemId_Snapshot = getMaxItemId2(element, "Snapshot");
	QMap<int , QString > mapSnapshot;
	if (unite_with_loaded)
		fillItemIdMap<BackupSnapshot>(m_lstSnapshot, mapSnapshot);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Escort_count = 1;
	int Snapshot_count = 1;
	int Uuid_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		if (tag_name == "Escort")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Escort++ : nItemId;
			BackupEscort* object = new BackupEscort();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapEscort.contains(nItemId))
				object->fromString(mapEscort.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstEscort += object;
			--Escort_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Snapshot")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Snapshot++ : nItemId;
			BackupSnapshot* object = new BackupSnapshot();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapSnapshot.contains(nItemId))
				object->fromString(mapSnapshot.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstSnapshot += object;
			--Snapshot_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Escort_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupActivity': tag 'Escort' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Snapshot_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupActivity': tag 'Snapshot' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupActivity': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_Escort, "Escort");
	syncMaxItemId(nMaxItemId_Snapshot, "Snapshot");


	return 0;
}

void BackupActivity::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<BackupEscort>(m_lstEscort, "Escort");
	setItemIds.clear();
	for(i = 0; i < m_lstEscort.size(); ++i)
	{
		BackupEscort* object = m_lstEscort[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Escort");

	nMaxItemId = getMaxItemId<BackupSnapshot>(m_lstSnapshot, "Snapshot");
	setItemIds.clear();
	for(i = 0; i < m_lstSnapshot.size(); ++i)
	{
		BackupSnapshot* object = m_lstSnapshot[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Snapshot");

}

void BackupActivity::Copy(const BackupActivity& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());

	ClearList<BackupEscort >(m_lstEscort);
	for(i = 0; i < rObject.m_lstEscort.size(); i++)
		m_lstEscort += new BackupEscort(rObject.m_lstEscort[i]);

	ClearList<BackupSnapshot >(m_lstSnapshot);
	for(i = 0; i < rObject.m_lstSnapshot.size(); i++)
		m_lstSnapshot += new BackupSnapshot(rObject.m_lstSnapshot[i]);

	CustomCopy(&rObject);

}

void BackupActivity::InitLists()
{
	InitList<BackupEscort>(1, m_lstEscort);
	InitList<BackupSnapshot>(1, m_lstSnapshot);
	CustomInit();
}

void BackupActivity::ClearLists()
{
	ClearList<BackupEscort>(m_lstEscort);
	ClearList<BackupSnapshot>(m_lstSnapshot);
}

void BackupActivity::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Escort") )
		ClearList<BackupEscort>(m_lstEscort);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Snapshot") )
		ClearList<BackupSnapshot>(m_lstSnapshot);
}

