////////////////////////////////////////////////////////////////////////////////
///
/// BackupEscort.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BackupEscort.h"


BackupEscort::BackupEscort()
{
	InitLists();
	setDefaults();
}

BackupEscort::BackupEscort(const BackupEscort& rObject)
: CBaseNode()
{
	Copy(rObject);
}

BackupEscort::BackupEscort(const BackupEscort* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BackupEscort& BackupEscort::operator=(const BackupEscort& rObject)
{
	Copy(rObject);
	return *this;
}

BackupEscort::BackupEscort(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BackupEscort::~BackupEscort()
{
	ClearLists();
}


EscortFilesList* BackupEscort::getFiles() const
{
	if (!m_lstFiles.isEmpty())
	{
		return m_lstFiles[0];
	}
	return 0;
}

void BackupEscort::setFiles(EscortFilesList* pFiles)
{
	ClearList<EscortFilesList>(m_lstFiles);
	if (pFiles)
	{
		m_lstFiles += pFiles;
	}
}

EscortFoldersList* BackupEscort::getFolders() const
{
	if (!m_lstFolders.isEmpty())
	{
		return m_lstFolders[0];
	}
	return 0;
}

void BackupEscort::setFolders(EscortFoldersList* pFolders)
{
	ClearList<EscortFoldersList>(m_lstFolders);
	if (pFolders)
	{
		m_lstFolders += pFolders;
	}
}

void BackupEscort::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement BackupEscort::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Escort") : m_qsExtRootTagName);

	for(i = 0; i < m_lstFiles.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const EscortFilesList* object = m_lstFiles[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstFolders.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const EscortFoldersList* object = m_lstFolders[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BackupEscort::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Escort") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BackupEscort': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Files_count = 1;
	int Folders_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "Files" && Files_count > 0)
		{
			unused_tag = false;
			EscortFilesList* object = m_lstFiles[1 - Files_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Files_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Folders" && Folders_count > 0)
		{
			unused_tag = false;
			EscortFoldersList* object = m_lstFolders[1 - Folders_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Folders_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Files_count >= 1)
	{
		m_lstWarningList += "Warning in class 'BackupEscort': tag 'Files' is absent";
	}

	if (Folders_count >= 1)
	{
		m_lstWarningList += "Warning in class 'BackupEscort': tag 'Folders' is absent";
	}



	return 0;
}

void BackupEscort::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstFiles.size(); ++i)
	{
		EscortFilesList* object = m_lstFiles[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

	for(i = 0; i < m_lstFolders.size(); ++i)
	{
		EscortFoldersList* object = m_lstFolders[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void BackupEscort::Copy(const BackupEscort& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<EscortFilesList >(m_lstFiles);
	for(i = 0; i < rObject.m_lstFiles.size(); i++)
		m_lstFiles += new EscortFilesList(rObject.m_lstFiles[i]);

	ClearList<EscortFoldersList >(m_lstFolders);
	for(i = 0; i < rObject.m_lstFolders.size(); i++)
		m_lstFolders += new EscortFoldersList(rObject.m_lstFolders[i]);

	CustomCopy(&rObject);

}

void BackupEscort::InitLists()
{
	InitList<EscortFilesList>(1, m_lstFiles);
	InitList<EscortFoldersList>(1, m_lstFolders);
	CustomInit();
}

void BackupEscort::ClearLists()
{
	ClearList<EscortFilesList>(m_lstFiles);
	ClearList<EscortFoldersList>(m_lstFolders);
}

void BackupEscort::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstFiles.size() && ! unite_with_loaded; i++)
	{
		m_lstFiles[i]->ClearListsInReadXml();
		m_lstFiles[i]->setDefaults();
		m_lstFiles[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstFolders.size() && ! unite_with_loaded; i++)
	{
		m_lstFolders[i]->ClearListsInReadXml();
		m_lstFolders[i]->setDefaults();
		m_lstFolders[i]->setSectionFakeFlag(true);
	}
}

