////////////////////////////////////////////////////////////////////////////////
///
/// BackupSnapshot.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BackupSnapshot.h"


BackupSnapshot::BackupSnapshot()
{
	InitLists();
	setDefaults();
}

BackupSnapshot::BackupSnapshot(const BackupSnapshot& rObject)
: CBaseNode()
{
	Copy(rObject);
}

BackupSnapshot::BackupSnapshot(const BackupSnapshot* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BackupSnapshot& BackupSnapshot::operator=(const BackupSnapshot& rObject)
{
	Copy(rObject);
	return *this;
}

BackupSnapshot::BackupSnapshot(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BackupSnapshot::~BackupSnapshot()
{
	ClearLists();
}


QString BackupSnapshot::getUuid() const
{
	return m_qsUuid;
}

void BackupSnapshot::setUuid(QString value)
{
	m_qsUuid = value;
}

void BackupSnapshot::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid();
}

QDomElement BackupSnapshot::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Snapshot") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "SnapshotComponents";
	nMaxItemId = getMaxItemId<SnapshotComponent>(m_lstSnapshotComponents, "SnapshotComponents", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstSnapshotComponents.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const SnapshotComponent* object = m_lstSnapshotComponents[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "SnapshotComponents", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BackupSnapshot::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Snapshot") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BackupSnapshot': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_SnapshotComponents = getMaxItemId2(element, "SnapshotComponents");
	QMap<int , QString > mapSnapshotComponents;
	if (unite_with_loaded)
		fillItemIdMap<SnapshotComponent>(m_lstSnapshotComponents, mapSnapshotComponents);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int SnapshotComponents_count = 0;
	int Uuid_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		if (tag_name == "SnapshotComponents")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_SnapshotComponents++ : nItemId;
			SnapshotComponent* object = new SnapshotComponent();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapSnapshotComponents.contains(nItemId))
				object->fromString(mapSnapshotComponents.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstSnapshotComponents += object;
			--SnapshotComponents_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (SnapshotComponents_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupSnapshot': tag 'SnapshotComponents' is absent";
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupSnapshot': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_SnapshotComponents, "SnapshotComponents");


	return 0;
}

void BackupSnapshot::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<SnapshotComponent>(m_lstSnapshotComponents, "SnapshotComponents");
	setItemIds.clear();
	for(i = 0; i < m_lstSnapshotComponents.size(); ++i)
	{
		SnapshotComponent* object = m_lstSnapshotComponents[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "SnapshotComponents");

}

void BackupSnapshot::Copy(const BackupSnapshot& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());

	ClearList<SnapshotComponent >(m_lstSnapshotComponents);
	for(i = 0; i < rObject.m_lstSnapshotComponents.size(); i++)
		m_lstSnapshotComponents += new SnapshotComponent(rObject.m_lstSnapshotComponents[i]);

	CustomCopy(&rObject);

}

void BackupSnapshot::InitLists()
{
	CustomInit();
}

void BackupSnapshot::ClearLists()
{
	ClearList<SnapshotComponent>(m_lstSnapshotComponents);
}

void BackupSnapshot::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("SnapshotComponents") )
		ClearList<SnapshotComponent>(m_lstSnapshotComponents);
}

