////////////////////////////////////////////////////////////////////////////////
///
/// SnapshotComponent.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "SnapshotComponent.h"


SnapshotComponent::SnapshotComponent()
{
	InitLists();
	setDefaults();
}

SnapshotComponent::SnapshotComponent(const SnapshotComponent& rObject)
: CBaseNode()
{
	Copy(rObject);
}

SnapshotComponent::SnapshotComponent(const SnapshotComponent* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

SnapshotComponent& SnapshotComponent::operator=(const SnapshotComponent& rObject)
{
	Copy(rObject);
	return *this;
}

SnapshotComponent::SnapshotComponent(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

SnapshotComponent::~SnapshotComponent()
{
	ClearLists();
}


CVmHardDisk* SnapshotComponent::getDevice() const
{
	if (!m_lstDevice.isEmpty())
	{
		return m_lstDevice[0];
	}
	return 0;
}

void SnapshotComponent::setDevice(CVmHardDisk* pDevice)
{
	ClearList<CVmHardDisk>(m_lstDevice);
	if (pDevice)
	{
		m_lstDevice += pDevice;
	}
}

QString SnapshotComponent::getState() const
{
	return m_qsState;
}

void SnapshotComponent::setState(QString value)
{
	m_qsState = value;
}

void SnapshotComponent::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("State").isNull() )
		setState();
}

QDomElement SnapshotComponent::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("SnapshotComponents") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("State");
	text_element = Document->createTextNode( QString("%1").arg(getState()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstDevice.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmHardDisk* object = m_lstDevice[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int SnapshotComponent::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("SnapshotComponents") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'SnapshotComponent': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Device_count = 1;
	int State_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "State";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (State_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "State")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setState(text_element.data());
			--State_count;
		}


		if (tag_name == "Device" && Device_count > 0)
		{
			unused_tag = false;
			CVmHardDisk* object = m_lstDevice[1 - Device_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Device_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Device_count >= 1)
	{
		m_lstWarningList += "Warning in class 'SnapshotComponent': tag 'Device' is absent";
	}

	if (State_count > 0)
	{
		m_qsErrorMessage = "Error in class 'SnapshotComponent': tag 'State' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void SnapshotComponent::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstDevice.size(); ++i)
	{
		CVmHardDisk* object = m_lstDevice[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void SnapshotComponent::Copy(const SnapshotComponent& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setState(rObject.getState());

	ClearList<CVmHardDisk >(m_lstDevice);
	for(i = 0; i < rObject.m_lstDevice.size(); i++)
		m_lstDevice += new CVmHardDisk(rObject.m_lstDevice[i]);

	CustomCopy(&rObject);

}

void SnapshotComponent::InitLists()
{
	InitList<CVmHardDisk>(1, m_lstDevice);
	CustomInit();
}

void SnapshotComponent::ClearLists()
{
	ClearList<CVmHardDisk>(m_lstDevice);
}

void SnapshotComponent::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstDevice.size() && ! unite_with_loaded; i++)
	{
		m_lstDevice[i]->ClearListsInReadXml();
		m_lstDevice[i]->setDefaults();
		m_lstDevice[i]->setSectionFakeFlag(true);
	}
}

