////////////////////////////////////////////////////////////////////////////////
///
/// BackupItem.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BackupItem.h"


BackupItem::BackupItem()
{
	InitLists();
	setDefaults();
}

BackupItem::BackupItem(const BackupItem& rObject)
: CBaseNode()
{
	Copy(rObject);
}

BackupItem::BackupItem(const BackupItem* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BackupItem& BackupItem::operator=(const BackupItem& rObject)
{
	Copy(rObject);
	return *this;
}

BackupItem::BackupItem(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BackupItem::~BackupItem()
{
	ClearLists();
}


CBackupDisks* BackupItem::getBackupDisks() const
{
	if (!m_lstBackupDisks.isEmpty())
	{
		return m_lstBackupDisks[0];
	}
	return 0;
}

void BackupItem::setBackupDisks(CBackupDisks* pBackupDisks)
{
	ClearList<CBackupDisks>(m_lstBackupDisks);
	if (pBackupDisks)
	{
		m_lstBackupDisks += pBackupDisks;
	}
}

QString BackupItem::getUuid() const
{
	return m_qsUuid;
}

void BackupItem::setUuid(QString value)
{
	m_qsUuid = value;
}

QString BackupItem::getId() const
{
	return m_qsId;
}

void BackupItem::setId(QString value)
{
	m_qsId = value;
}

QString BackupItem::getHost() const
{
	return m_qsHost;
}

void BackupItem::setHost(QString value)
{
	m_qsHost = value;
}

QString BackupItem::getServerUuid() const
{
	return m_qsServerUuid;
}

void BackupItem::setServerUuid(QString value)
{
	m_qsServerUuid = value;
}

QDateTime BackupItem::getDateTime() const
{
	return m_dtDateTime;
}

void BackupItem::setDateTime(QDateTime value)
{
	QTime t = value.time(); t.setHMS(t.hour(), t.minute(), t.second()); value.setTime(t);
	m_dtDateTime = value;
}

QString BackupItem::getCreator() const
{
	return m_qsCreator;
}

void BackupItem::setCreator(QString value)
{
	m_qsCreator = value;
}

qulonglong BackupItem::getSize() const
{
	return m_ullSize;
}

void BackupItem::setSize(qulonglong value)
{
	m_ullSize = value;
}

QString BackupItem::getType() const
{
	return m_qsType;
}

void BackupItem::setType(QString value)
{
	m_qsType = value;
}

QString BackupItem::getDescription() const
{
	return m_qsDescription;
}

void BackupItem::setDescription(QString value)
{
	m_qsDescription = value;
}

QList<QString> BackupItem::getTibFileList() const
{
	return m_lstTibFileList;
}

void BackupItem::setTibFileList(QList<QString> value)
{
	m_lstTibFileList = value;
}

qulonglong BackupItem::getOriginalSize() const
{
	return m_ullOriginalSize;
}

void BackupItem::setOriginalSize(qulonglong value)
{
	m_ullOriginalSize = value;
}

unsigned int BackupItem::getBundlePermissions() const
{
	return m_uiBundlePermissions;
}

void BackupItem::setBundlePermissions(unsigned int value)
{
	m_uiBundlePermissions = value;
}

unsigned int BackupItem::getFlags() const
{
	return m_uiFlags;
}

void BackupItem::setFlags(unsigned int value)
{
	m_uiFlags = value;
}

unsigned int BackupItem::getLastNumber() const
{
	return m_uiLastNumber;
}

void BackupItem::setLastNumber(unsigned int value)
{
	m_uiLastNumber = value;
}

void BackupItem::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid();
	if ( ! RootElement || ! RootElement->firstChildElement("Id").isNull() )
		setId();
	if ( ! RootElement || ! RootElement->firstChildElement("Host").isNull() )
		setHost();
	if ( ! RootElement || ! RootElement->firstChildElement("ServerUuid").isNull() )
		setServerUuid();
	if ( ! RootElement || ! RootElement->firstChildElement("DateTime").isNull() )
		setDateTime();
	if ( ! RootElement || ! RootElement->firstChildElement("Creator").isNull() )
		setCreator();
	if ( ! RootElement || ! RootElement->firstChildElement("Size").isNull() )
		setSize();
	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("Description").isNull() )
		setDescription();
	if ( ! RootElement || dyn_lists.contains("TibFileList") )
		setTibFileList();
	if ( ! RootElement || ! RootElement->firstChildElement("OriginalSize").isNull() )
		setOriginalSize();
	if ( ! RootElement || ! RootElement->firstChildElement("BundlePermissions").isNull() )
		setBundlePermissions();
	if ( ! RootElement || ! RootElement->firstChildElement("Flags").isNull() )
		setFlags();
	if ( ! RootElement || ! RootElement->firstChildElement("LastNumber").isNull() )
		setLastNumber();
}

QDomElement BackupItem::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BackupItem") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Id");
	text_element = Document->createTextNode( QString("%1").arg(getId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Host");
	text_element = Document->createTextNode( QString("%1").arg(getHost()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ServerUuid");
	text_element = Document->createTextNode( QString("%1").arg(getServerUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DateTime");
	text_element = Document->createTextNode( QString("%1").arg(getDateTime().toUTC().toString(XML_DATETIME_FORMAT)) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Creator");
	text_element = Document->createTextNode( QString("%1").arg(getCreator()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Size");
	text_element = Document->createTextNode( QString("%1").arg(getSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Description");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "TibFileList";
	for(i = 0; i < m_lstTibFileList.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("TibFileList");
		text_element = Document->createTextNode( QString("%1").arg(m_lstTibFileList[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	dyn_lists += "PartialBackupItem";
	nMaxItemId = getMaxItemId<PartialBackupItem>(m_lstPartialBackupItem, "PartialBackupItem", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstPartialBackupItem.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const PartialBackupItem* object = m_lstPartialBackupItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "PartialBackupItem", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OriginalSize");
	text_element = Document->createTextNode( QString("%1").arg(getOriginalSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BundlePermissions");
	text_element = Document->createTextNode( QString("%1").arg(getBundlePermissions()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Flags");
	text_element = Document->createTextNode( QString("%1").arg(getFlags()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("LastNumber");
	text_element = Document->createTextNode( QString("%1").arg(getLastNumber()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstBackupDisks.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CBackupDisks* object = m_lstBackupDisks[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BackupItem::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BackupItem") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BackupItem': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_PartialBackupItem = getMaxItemId2(element, "PartialBackupItem");
	QMap<int , QString > mapPartialBackupItem;
	if (unite_with_loaded)
		fillItemIdMap<PartialBackupItem>(m_lstPartialBackupItem, mapPartialBackupItem);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int PartialBackupItem_count = 0;
	int BackupDisks_count = 1;
	int Uuid_count = 1;
	int Id_count = 1;
	int Host_count = 1;
	int ServerUuid_count = 1;
	int DateTime_count = 1;
	int Creator_count = 1;
	int Size_count = 1;
	int Type_count = 1;
	int Description_count = 1;
	int TibFileList_count = 0;
	int OriginalSize_count = 0;
	int BundlePermissions_count = 0;
	int Flags_count = 0;
	int LastNumber_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Id";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Id_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Id")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setId(text_element.data());
			--Id_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Host";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Host_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Host")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHost(text_element.data());
			--Host_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ServerUuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ServerUuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ServerUuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setServerUuid(text_element.data());
			--ServerUuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DateTime";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DateTime_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DateTime")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDateTime(toLocalTime( QDateTime::fromString( text_element.data(), XML_DATETIME_FORMAT ) ));
			--DateTime_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Creator";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Creator_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Creator")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCreator(text_element.data());
			--Creator_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Size";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Size_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Size")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSize(text_element.data().toULongLong());
			--Size_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType(text_element.data());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Description";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Description_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Description")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--Description_count;
		}


		if (tag_name == "TibFileList")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstTibFileList += text_element.data();
			--TibFileList_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "OriginalSize";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OriginalSize_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OriginalSize")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOriginalSize(text_element.data().toULongLong());
			--OriginalSize_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "BundlePermissions";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BundlePermissions_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BundlePermissions")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBundlePermissions(text_element.data().toUInt());
			--BundlePermissions_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Flags";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Flags_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Flags")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setFlags(text_element.data().toUInt());
			--Flags_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "LastNumber";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (LastNumber_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "LastNumber")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setLastNumber(text_element.data().toUInt());
			--LastNumber_count;
		}


		if (tag_name == "PartialBackupItem")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_PartialBackupItem++ : nItemId;
			PartialBackupItem* object = new PartialBackupItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapPartialBackupItem.contains(nItemId))
				object->fromString(mapPartialBackupItem.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstPartialBackupItem += object;
			--PartialBackupItem_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "BackupDisks" && BackupDisks_count > 0)
		{
			unused_tag = false;
			CBackupDisks* object = m_lstBackupDisks[1 - BackupDisks_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--BackupDisks_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (PartialBackupItem_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'PartialBackupItem' is absent";
	}

	if (BackupDisks_count >= 1)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'BackupDisks' is absent";
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Id_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Id' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Host_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Host' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ServerUuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'ServerUuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (DateTime_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'DateTime' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Creator_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Creator' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Size_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Size' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Description_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BackupItem': tag 'Description' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (TibFileList_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'TibFileList' is absent";
	}

	if (OriginalSize_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'OriginalSize' is absent";
	}

	if (BundlePermissions_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'BundlePermissions' is absent";
	}

	if (Flags_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'Flags' is absent";
	}

	if (LastNumber_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupItem': tag 'LastNumber' is absent";
	}

	syncMaxItemId(nMaxItemId_PartialBackupItem, "PartialBackupItem");


	return 0;
}

void BackupItem::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<PartialBackupItem>(m_lstPartialBackupItem, "PartialBackupItem");
	setItemIds.clear();
	for(i = 0; i < m_lstPartialBackupItem.size(); ++i)
	{
		PartialBackupItem* object = m_lstPartialBackupItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "PartialBackupItem");

	for(i = 0; i < m_lstBackupDisks.size(); ++i)
	{
		CBackupDisks* object = m_lstBackupDisks[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void BackupItem::Copy(const BackupItem& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());
	setId(rObject.getId());
	setHost(rObject.getHost());
	setServerUuid(rObject.getServerUuid());
	setDateTime(rObject.getDateTime());
	setCreator(rObject.getCreator());
	setSize(rObject.getSize());
	setType(rObject.getType());
	setDescription(rObject.getDescription());
	setTibFileList(rObject.getTibFileList());
	setOriginalSize(rObject.getOriginalSize());
	setBundlePermissions(rObject.getBundlePermissions());
	setFlags(rObject.getFlags());
	setLastNumber(rObject.getLastNumber());

	ClearList<PartialBackupItem >(m_lstPartialBackupItem);
	for(i = 0; i < rObject.m_lstPartialBackupItem.size(); i++)
		m_lstPartialBackupItem += new PartialBackupItem(rObject.m_lstPartialBackupItem[i]);

	ClearList<CBackupDisks >(m_lstBackupDisks);
	for(i = 0; i < rObject.m_lstBackupDisks.size(); i++)
		m_lstBackupDisks += new CBackupDisks(rObject.m_lstBackupDisks[i]);

	CustomCopy(&rObject);

}

void BackupItem::InitLists()
{
	InitList<CBackupDisks>(1, m_lstBackupDisks);
	CustomInit();
}

void BackupItem::ClearLists()
{
	ClearList<PartialBackupItem>(m_lstPartialBackupItem);
	ClearList<CBackupDisks>(m_lstBackupDisks);
}

void BackupItem::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("PartialBackupItem") )
		ClearList<PartialBackupItem>(m_lstPartialBackupItem);
	for(i = 0; i < m_lstBackupDisks.size() && ! unite_with_loaded; i++)
	{
		m_lstBackupDisks[i]->ClearListsInReadXml();
		m_lstBackupDisks[i]->setDefaults();
		m_lstBackupDisks[i]->setSectionFakeFlag(true);
	}
}

