////////////////////////////////////////////////////////////////////////////////
///
/// BackupTree.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BackupTree.h"


BackupTree::BackupTree()
{
	InitLists();
	setDefaults();
}

BackupTree::BackupTree(const BackupTree& rObject)
: CBaseNode()
{
	Copy(rObject);
}

BackupTree::BackupTree(const BackupTree* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BackupTree& BackupTree::operator=(const BackupTree& rObject)
{
	Copy(rObject);
	return *this;
}

BackupTree::BackupTree(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BackupTree::~BackupTree()
{
	ClearLists();
}


void BackupTree::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement BackupTree::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BackupTree") : m_qsExtRootTagName);

	dyn_lists += "VmItem";
	nMaxItemId = getMaxItemId<VmItem>(m_lstVmItem, "VmItem", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVmItem.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const VmItem* object = m_lstVmItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VmItem", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BackupTree::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BackupTree") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BackupTree': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VmItem = getMaxItemId2(element, "VmItem");
	QMap<int , QString > mapVmItem;
	if (unite_with_loaded)
		fillItemIdMap<VmItem>(m_lstVmItem, mapVmItem);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int VmItem_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "VmItem")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VmItem++ : nItemId;
			VmItem* object = new VmItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapVmItem.contains(nItemId))
				object->fromString(mapVmItem.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVmItem += object;
			--VmItem_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (VmItem_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BackupTree': tag 'VmItem' is absent";
	}

	syncMaxItemId(nMaxItemId_VmItem, "VmItem");


	return 0;
}

void BackupTree::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<VmItem>(m_lstVmItem, "VmItem");
	setItemIds.clear();
	for(i = 0; i < m_lstVmItem.size(); ++i)
	{
		VmItem* object = m_lstVmItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VmItem");

}

void BackupTree::Copy(const BackupTree& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<VmItem >(m_lstVmItem);
	for(i = 0; i < rObject.m_lstVmItem.size(); i++)
		m_lstVmItem += new VmItem(rObject.m_lstVmItem[i]);

	CustomCopy(&rObject);

}

void BackupTree::InitLists()
{
	CustomInit();
}

void BackupTree::ClearLists()
{
	ClearList<VmItem>(m_lstVmItem);
}

void BackupTree::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VmItem") )
		ClearList<VmItem>(m_lstVmItem);
}

