////////////////////////////////////////////////////////////////////////////////
///
/// CBackupDisk.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CBackupDisk.h"


CBackupDisk::CBackupDisk()
{
	InitLists();
	setDefaults();
}

CBackupDisk::CBackupDisk(const CBackupDisk& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CBackupDisk::CBackupDisk(const CBackupDisk* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CBackupDisk& CBackupDisk::operator=(const CBackupDisk& rObject)
{
	Copy(rObject);
	return *this;
}

CBackupDisk::CBackupDisk(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CBackupDisk::~CBackupDisk()
{
	ClearLists();
}


CVmHddEncryption* CBackupDisk::getEncryption() const
{
	if (!m_lstEncryption.isEmpty())
	{
		return m_lstEncryption[0];
	}
	return 0;
}

void CBackupDisk::setEncryption(CVmHddEncryption* pEncryption)
{
	ClearList<CVmHddEncryption>(m_lstEncryption);
	if (pEncryption)
	{
		m_lstEncryption += pEncryption;
	}
}

QString CBackupDisk::getName() const
{
	return m_qsName;
}

void CBackupDisk::setName(QString value)
{
	m_qsName = value;
}

QString CBackupDisk::getOriginalPath() const
{
	return m_qsOriginalPath;
}

void CBackupDisk::setOriginalPath(QString value)
{
	m_qsOriginalPath = value;
}

qulonglong CBackupDisk::getSize() const
{
	return m_ullSize;
}

void CBackupDisk::setSize(qulonglong value)
{
	m_ullSize = value;
}

void CBackupDisk::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setName();
	if ( ! RootElement || ! RootElement->firstChildElement("OriginalPath").isNull() )
		setOriginalPath();
	if ( ! RootElement || ! RootElement->firstChildElement("Size").isNull() )
		setSize();
}

QDomElement CBackupDisk::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BackupDisk") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OriginalPath");
	text_element = Document->createTextNode( QString("%1").arg(getOriginalPath()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Size");
	text_element = Document->createTextNode( QString("%1").arg(getSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstEncryption.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmHddEncryption* object = m_lstEncryption[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CBackupDisk::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BackupDisk") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CBackupDisk': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Encryption_count = 1;
	int Name_count = 1;
	int OriginalPath_count = 1;
	int Size_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OriginalPath";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OriginalPath_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OriginalPath")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOriginalPath(text_element.data());
			--OriginalPath_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Size";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Size_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Size")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSize(text_element.data().toULongLong());
			--Size_count;
		}


		if (tag_name == "Encryption" && Encryption_count > 0)
		{
			unused_tag = false;
			CVmHddEncryption* object = m_lstEncryption[1 - Encryption_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Encryption_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Encryption_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CBackupDisk': tag 'Encryption' is absent";
	}

	if (Name_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CBackupDisk': tag 'Name' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (OriginalPath_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CBackupDisk': tag 'OriginalPath' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Size_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CBackupDisk': tag 'Size' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void CBackupDisk::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstEncryption.size(); ++i)
	{
		CVmHddEncryption* object = m_lstEncryption[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void CBackupDisk::Copy(const CBackupDisk& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setName(rObject.getName());
	setOriginalPath(rObject.getOriginalPath());
	setSize(rObject.getSize());

	ClearList<CVmHddEncryption >(m_lstEncryption);
	for(i = 0; i < rObject.m_lstEncryption.size(); i++)
		m_lstEncryption += new CVmHddEncryption(rObject.m_lstEncryption[i]);

	CustomCopy(&rObject);

}

void CBackupDisk::InitLists()
{
	InitList<CVmHddEncryption>(1, m_lstEncryption);
	CustomInit();
}

void CBackupDisk::ClearLists()
{
	ClearList<CVmHddEncryption>(m_lstEncryption);
}

void CBackupDisk::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstEncryption.size() && ! unite_with_loaded; i++)
	{
		m_lstEncryption[i]->ClearListsInReadXml();
		m_lstEncryption[i]->setDefaults();
		m_lstEncryption[i]->setSectionFakeFlag(true);
	}
}

