////////////////////////////////////////////////////////////////////////////////
///
/// VmItem.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "VmItem.h"


VmItem::VmItem()
{
	InitLists();
	setDefaults();
}

VmItem::VmItem(const VmItem& rObject)
: CBaseNode()
{
	Copy(rObject);
}

VmItem::VmItem(const VmItem* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

VmItem& VmItem::operator=(const VmItem& rObject)
{
	Copy(rObject);
	return *this;
}

VmItem::VmItem(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

VmItem::~VmItem()
{
	ClearLists();
}


PRL_VM_BACKUP_TYPE VmItem::getVmType() const
{
	return m_ctVmType;
}

void VmItem::setVmType(PRL_VM_BACKUP_TYPE value)
{
	m_ctVmType = value;
}

QString VmItem::getUuid() const
{
	return m_qsUuid;
}

void VmItem::setUuid(QString value)
{
	m_qsUuid = value;
}

QString VmItem::getName() const
{
	return m_qsName;
}

void VmItem::setName(QString value)
{
	m_qsName = value;
}

unsigned int VmItem::getVersion() const
{
	return m_uiVersion;
}

void VmItem::setVersion(unsigned int value)
{
	m_uiVersion = value;
}

void VmItem::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("VmType").isNull() )
		setVmType();
	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid();
	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setName();
	if ( ! RootElement || ! RootElement->firstChildElement("Version").isNull() )
		setVersion();
}

QDomElement VmItem::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VmItem") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VmType");
	text_element = Document->createTextNode( QString("%1").arg(getVmType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Version");
	text_element = Document->createTextNode( QString("%1").arg(getVersion()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "BackupItem";
	nMaxItemId = getMaxItemId<BackupItem>(m_lstBackupItem, "BackupItem", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstBackupItem.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const BackupItem* object = m_lstBackupItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "BackupItem", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int VmItem::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VmItem") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'VmItem': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_BackupItem = getMaxItemId2(element, "BackupItem");
	QMap<int , QString > mapBackupItem;
	if (unite_with_loaded)
		fillItemIdMap<BackupItem>(m_lstBackupItem, mapBackupItem);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int BackupItem_count = 0;
	int VmType_count = 0;
	int Uuid_count = 1;
	int Name_count = 1;
	int Version_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "VmType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VmType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VmType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVmType((PRL_VM_BACKUP_TYPE )text_element.data().toLongLong());
			--VmType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Version";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Version_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Version")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVersion(text_element.data().toUInt());
			--Version_count;
		}


		if (tag_name == "BackupItem")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_BackupItem++ : nItemId;
			BackupItem* object = new BackupItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapBackupItem.contains(nItemId))
				object->fromString(mapBackupItem.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstBackupItem += object;
			--BackupItem_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (BackupItem_count >= 0)
	{
		m_lstWarningList += "Warning in class 'VmItem': tag 'BackupItem' is absent";
	}

	if (VmType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'VmItem': tag 'VmType' is absent";
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VmItem': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Name_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VmItem': tag 'Name' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Version_count >= 0)
	{
		m_lstWarningList += "Warning in class 'VmItem': tag 'Version' is absent";
	}

	syncMaxItemId(nMaxItemId_BackupItem, "BackupItem");


	return 0;
}

void VmItem::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<BackupItem>(m_lstBackupItem, "BackupItem");
	setItemIds.clear();
	for(i = 0; i < m_lstBackupItem.size(); ++i)
	{
		BackupItem* object = m_lstBackupItem[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "BackupItem");

}

void VmItem::Copy(const VmItem& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setVmType(rObject.getVmType());
	setUuid(rObject.getUuid());
	setName(rObject.getName());
	setVersion(rObject.getVersion());

	ClearList<BackupItem >(m_lstBackupItem);
	for(i = 0; i < rObject.m_lstBackupItem.size(); i++)
		m_lstBackupItem += new BackupItem(rObject.m_lstBackupItem[i]);

	CustomCopy(&rObject);

}

void VmItem::InitLists()
{
	CustomInit();
}

void VmItem::ClearLists()
{
	ClearList<BackupItem>(m_lstBackupItem);
}

void VmItem::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("BackupItem") )
		ClearList<BackupItem>(m_lstBackupItem);
}

