////////////////////////////////////////////////////////////////////////////////
///
/// CCpuPool.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CCpuPool.h"


CCpuPool::CCpuPool()
{
	InitLists();
	setDefaults();
}

CCpuPool::CCpuPool(const CCpuPool& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CCpuPool::CCpuPool(const CCpuPool* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CCpuPool& CCpuPool::operator=(const CCpuPool& rObject)
{
	Copy(rObject);
	return *this;
}

CCpuPool::CCpuPool(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CCpuPool::~CCpuPool()
{
	ClearLists();
}


CCpuPoolInfo* CCpuPool::getCpuPoolInfo() const
{
	if (!m_lstCpuPoolInfo.isEmpty())
	{
		return m_lstCpuPoolInfo[0];
	}
	return 0;
}

void CCpuPool::setCpuPoolInfo(CCpuPoolInfo* pCpuPoolInfo)
{
	ClearList<CCpuPoolInfo>(m_lstCpuPoolInfo);
	if (pCpuPoolInfo)
	{
		m_lstCpuPoolInfo += pCpuPoolInfo;
	}
}

CCpuFeatures* CCpuPool::getCpuMask() const
{
	if (!m_lstCpuMask.isEmpty())
	{
		return m_lstCpuMask[0];
	}
	return 0;
}

void CCpuPool::setCpuMask(CCpuFeatures* pCpuMask)
{
	ClearList<CCpuFeatures>(m_lstCpuMask);
	if (pCpuMask)
	{
		m_lstCpuMask += pCpuMask;
	}
}

void CCpuPool::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant CCpuPool::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "CpuPoolInfo.";
	if (path.startsWith(list_tag) && ! m_lstCpuPoolInfo.isEmpty() && m_lstCpuPoolInfo.first())
		return m_lstCpuPoolInfo.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "CpuMask.";
	if (path.startsWith(list_tag) && ! m_lstCpuMask.isEmpty() && m_lstCpuMask.first())
		return m_lstCpuMask.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CCpuPool::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "CpuPoolInfo.";
	if (path.startsWith(list_tag) && ! m_lstCpuPoolInfo.isEmpty() && m_lstCpuPoolInfo.first())
		return m_lstCpuPoolInfo.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "CpuMask.";
	if (path.startsWith(list_tag) && ! m_lstCpuMask.isEmpty() && m_lstCpuMask.first())
		return m_lstCpuMask.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

int CCpuPool::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "CpuPoolInfo.";
	if (path.startsWith(list_tag) && ! m_lstCpuPoolInfo.isEmpty() && m_lstCpuPoolInfo.first())
		return m_lstCpuPoolInfo.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "CpuMask.";
	if (path.startsWith(list_tag) && ! m_lstCpuMask.isEmpty() && m_lstCpuMask.first())
		return m_lstCpuMask.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CCpuPool::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "CpuPoolInfo.";
	if (path.startsWith(list_tag) && ! m_lstCpuPoolInfo.isEmpty() && m_lstCpuPoolInfo.first())
		return m_lstCpuPoolInfo.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "CpuMask.";
	if (path.startsWith(list_tag) && ! m_lstCpuMask.isEmpty() && m_lstCpuMask.first())
		return m_lstCpuMask.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CCpuPool::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("CpuPool") : m_qsExtRootTagName);

	for(i = 0; i < m_lstCpuPoolInfo.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CCpuPoolInfo* object = m_lstCpuPoolInfo[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstCpuMask.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CCpuFeatures* object = m_lstCpuMask[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CCpuPool::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("CpuPool") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CCpuPool': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int CpuPoolInfo_count = 1;
	int CpuMask_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "CpuPoolInfo" && CpuPoolInfo_count > 0)
		{
			unused_tag = false;
			CCpuPoolInfo* object = m_lstCpuPoolInfo[1 - CpuPoolInfo_count];
			object->makeFullItemId(getFullItemId(), "CpuPoolInfo");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--CpuPoolInfo_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "CpuMask" && CpuMask_count > 0)
		{
			unused_tag = false;
			CCpuFeatures* object = m_lstCpuMask[1 - CpuMask_count];
			object->makeFullItemId(getFullItemId(), "CpuMask");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--CpuMask_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (CpuPoolInfo_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CCpuPool': tag 'CpuPoolInfo' is absent";
	}

	if (CpuMask_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CCpuPool': tag 'CpuMask' is absent";
	}



	return 0;
}

void CCpuPool::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstCpuPoolInfo.size(); ++i)
	{
		CCpuPoolInfo* object = m_lstCpuPoolInfo[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "CpuPoolInfo");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstCpuMask.size(); ++i)
	{
		CCpuFeatures* object = m_lstCpuMask[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "CpuMask");
		object->syncItemIds();
	}

}

bool CCpuPool::merge(CCpuPool* pCur, CCpuPool* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "CpuPool";

	for(i = 0; i < m_lstCpuPoolInfo.size(); i++)
	{
		if ( m_lstCpuPoolInfo[i]->merge(pCur->m_lstCpuPoolInfo[i], pPrev->m_lstCpuPoolInfo[i], nOptions) ) continue;
		QString qsIdx = (m_lstCpuPoolInfo.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstCpuPoolInfo[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstCpuMask.size(); i++)
	{
		if ( m_lstCpuMask[i]->merge(pCur->m_lstCpuMask[i], pPrev->m_lstCpuMask[i], nOptions) ) continue;
		QString qsIdx = (m_lstCpuMask.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstCpuMask[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CCpuPool::diff(const CCpuPool* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	for(i = 0; i < m_lstCpuPoolInfo.size(); ++i)
		m_lstCpuPoolInfo[i]->diff(pOld->m_lstCpuPoolInfo[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstCpuMask.size(); ++i)
		m_lstCpuMask[i]->diff(pOld->m_lstCpuMask[i], lstDiffFullItemIds);

}

void CCpuPool::Copy(const CCpuPool& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CCpuPoolInfo >(m_lstCpuPoolInfo);
	for(i = 0; i < rObject.m_lstCpuPoolInfo.size(); i++)
		m_lstCpuPoolInfo += new CCpuPoolInfo(rObject.m_lstCpuPoolInfo[i]);

	ClearList<CCpuFeatures >(m_lstCpuMask);
	for(i = 0; i < rObject.m_lstCpuMask.size(); i++)
		m_lstCpuMask += new CCpuFeatures(rObject.m_lstCpuMask[i]);

	CustomCopy(&rObject);

}

void CCpuPool::InitLists()
{
	InitList<CCpuPoolInfo>(1, m_lstCpuPoolInfo);
	InitList<CCpuFeatures>(1, m_lstCpuMask);
	CustomInit();
}

void CCpuPool::ClearLists()
{
	ClearList<CCpuPoolInfo>(m_lstCpuPoolInfo);
	ClearList<CCpuFeatures>(m_lstCpuMask);
}

void CCpuPool::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstCpuPoolInfo.size() && ! unite_with_loaded; i++)
	{
		m_lstCpuPoolInfo[i]->ClearListsInReadXml();
		m_lstCpuPoolInfo[i]->setDefaults();
		m_lstCpuPoolInfo[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstCpuMask.size() && ! unite_with_loaded; i++)
	{
		m_lstCpuMask[i]->ClearListsInReadXml();
		m_lstCpuMask[i]->setDefaults();
		m_lstCpuMask[i]->setSectionFakeFlag(true);
	}
}

