////////////////////////////////////////////////////////////////////////////////
///
/// ParametersNode.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "ParametersNode.h"


ParametersNode::ParametersNode()
{
	InitLists();
	setDefaults();
}

ParametersNode::ParametersNode(const ParametersNode& rObject)
: CBaseNode()
{
	Copy(rObject);
}

ParametersNode::ParametersNode(const ParametersNode* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

ParametersNode& ParametersNode::operator=(const ParametersNode& rObject)
{
	Copy(rObject);
	return *this;
}

ParametersNode::ParametersNode(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

ParametersNode::~ParametersNode()
{
	ClearLists();
}


MiscNode* ParametersNode::getUserData() const
{
	if (!m_lstMiscellaneous.isEmpty())
	{
		return m_lstMiscellaneous[0];
	}
	return 0;
}

void ParametersNode::setUserData(MiscNode* pMiscellaneous)
{
	ClearList<MiscNode>(m_lstMiscellaneous);
	if (pMiscellaneous)
	{
		m_lstMiscellaneous += pMiscellaneous;
	}
}

qulonglong ParametersNode::getSize() const
{
	return m_ullDisk_size;
}

void ParametersNode::setSize(qulonglong value)
{
	m_ullDisk_size = value;
}

qulonglong ParametersNode::getCylinders() const
{
	return m_ullCylinders;
}

void ParametersNode::setCylinders(qulonglong value)
{
	m_ullCylinders = value;
}

unsigned char ParametersNode::getHeads() const
{
	return m_ucHeads;
}

void ParametersNode::setHeads(unsigned char value)
{
	m_ucHeads = value;
}

unsigned char ParametersNode::getSectors() const
{
	return m_ucSectors;
}

void ParametersNode::setSectors(unsigned char value)
{
	m_ucSectors = value;
}

qulonglong ParametersNode::getPadding() const
{
	return m_ullPadding;
}

void ParametersNode::setPadding(qulonglong value)
{
	m_ullPadding = value;
}

void ParametersNode::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Disk_size").isNull() )
		setSize();
	if ( ! RootElement || ! RootElement->firstChildElement("Cylinders").isNull() )
		setCylinders();
	if ( ! RootElement || ! RootElement->firstChildElement("Heads").isNull() )
		setHeads();
	if ( ! RootElement || ! RootElement->firstChildElement("Sectors").isNull() )
		setSectors();
	if ( ! RootElement || ! RootElement->firstChildElement("Padding").isNull() )
		setPadding();
}

QDomElement ParametersNode::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Disk_Parameters") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Disk_size");
	text_element = Document->createTextNode( QString("%1").arg(getSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Cylinders");
	text_element = Document->createTextNode( QString("%1").arg(getCylinders()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Heads");
	text_element = Document->createTextNode( QString("%1").arg(getHeads()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Sectors");
	text_element = Document->createTextNode( QString("%1").arg(getSectors()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Padding");
	text_element = Document->createTextNode( QString("%1").arg(getPadding()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "Miscellaneous";
	nMaxItemId = getMaxItemId<MiscNode>(m_lstMiscellaneous, "Miscellaneous", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstMiscellaneous.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const MiscNode* object = m_lstMiscellaneous[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Miscellaneous", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int ParametersNode::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Disk_Parameters") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_Miscellaneous = getMaxItemId2(element, "Miscellaneous");
	QMap<int , QString > mapMiscellaneous;
	if (unite_with_loaded)
		fillItemIdMap<MiscNode>(m_lstMiscellaneous, mapMiscellaneous);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Miscellaneous_count = 1;
	int Disk_size_count = 1;
	int Cylinders_count = 1;
	int Heads_count = 1;
	int Sectors_count = 1;
	int Padding_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Disk_size";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Disk_size_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Disk_size")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSize(text_element.data().toULongLong());
			--Disk_size_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Cylinders";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Cylinders_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Cylinders")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCylinders(text_element.data().toULongLong());
			--Cylinders_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Heads";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Heads_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Heads")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHeads((unsigned char )text_element.data().toUInt());
			--Heads_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Sectors";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Sectors_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Sectors")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSectors((unsigned char )text_element.data().toUInt());
			--Sectors_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Padding";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Padding_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Padding")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setPadding(text_element.data().toULongLong());
			--Padding_count;
		}


		if (tag_name == "Miscellaneous")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Miscellaneous++ : nItemId;
			MiscNode* object = new MiscNode();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapMiscellaneous.contains(nItemId))
				object->fromString(mapMiscellaneous.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstMiscellaneous += object;
			--Miscellaneous_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Miscellaneous_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Miscellaneous' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Disk_size_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Disk_size' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Cylinders_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Cylinders' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Heads_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Heads' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Sectors_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Sectors' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Padding_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ParametersNode': tag 'Padding' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_Miscellaneous, "Miscellaneous");


	return 0;
}

void ParametersNode::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<MiscNode>(m_lstMiscellaneous, "Miscellaneous");
	setItemIds.clear();
	for(i = 0; i < m_lstMiscellaneous.size(); ++i)
	{
		MiscNode* object = m_lstMiscellaneous[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Miscellaneous");

}

void ParametersNode::Copy(const ParametersNode& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setSize(rObject.getSize());
	setCylinders(rObject.getCylinders());
	setHeads(rObject.getHeads());
	setSectors(rObject.getSectors());
	setPadding(rObject.getPadding());

	ClearList<MiscNode >(m_lstMiscellaneous);
	for(i = 0; i < rObject.m_lstMiscellaneous.size(); i++)
		m_lstMiscellaneous += new MiscNode(rObject.m_lstMiscellaneous[i]);

	CustomCopy(&rObject);

}

void ParametersNode::InitLists()
{
	InitList<MiscNode>(1, m_lstMiscellaneous);
	CustomInit();
}

void ParametersNode::ClearLists()
{
	ClearList<MiscNode>(m_lstMiscellaneous);
}

void ParametersNode::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Miscellaneous") )
		ClearList<MiscNode>(m_lstMiscellaneous);
}

