////////////////////////////////////////////////////////////////////////////////
///
/// StorageNode.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "StorageNode.h"


StorageNode::StorageNode()
{
	InitLists();
	setDefaults();
}

StorageNode::StorageNode(const StorageNode& rObject)
: CBaseNode()
{
	Copy(rObject);
}

StorageNode::StorageNode(const StorageNode* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

StorageNode& StorageNode::operator=(const StorageNode& rObject)
{
	Copy(rObject);
	return *this;
}

StorageNode::StorageNode(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

StorageNode::~StorageNode()
{
	ClearLists();
}


ImageNode* StorageNode::getImage() const
{
	if (!m_lstImage.isEmpty())
	{
		return m_lstImage[0];
	}
	return 0;
}

void StorageNode::setImage(ImageNode* pImage)
{
	ClearList<ImageNode>(m_lstImage);
	if (pImage)
	{
		m_lstImage += pImage;
	}
}

qulonglong StorageNode::getStart() const
{
	return m_ullStart;
}

void StorageNode::setStart(qulonglong value)
{
	m_ullStart = value;
}

qulonglong StorageNode::getEnd() const
{
	return m_ullEnd;
}

void StorageNode::setEnd(qulonglong value)
{
	m_ullEnd = value;
}

unsigned int StorageNode::getBlockSize() const
{
	return m_uiBlockSize;
}

void StorageNode::setBlockSize(unsigned int value)
{
	m_uiBlockSize = value;
}

void StorageNode::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Start").isNull() )
		setStart();
	if ( ! RootElement || ! RootElement->firstChildElement("End").isNull() )
		setEnd();
	if ( ! RootElement || ! RootElement->firstChildElement("BlockSize").isNull() )
		setBlockSize();
}

QDomElement StorageNode::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Storage") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Start");
	text_element = Document->createTextNode( QString("%1").arg(getStart()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("End");
	text_element = Document->createTextNode( QString("%1").arg(getEnd()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BlockSize");
	text_element = Document->createTextNode( QString("%1").arg(getBlockSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "Image";
	nMaxItemId = getMaxItemId<ImageNode>(m_lstImage, "Image", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstImage.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const ImageNode* object = m_lstImage[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Image", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int StorageNode::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Storage") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'StorageNode': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_Image = getMaxItemId2(element, "Image");
	QMap<int , QString > mapImage;
	if (unite_with_loaded)
		fillItemIdMap<ImageNode>(m_lstImage, mapImage);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Image_count = 1;
	int Start_count = 1;
	int End_count = 1;
	int BlockSize_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Start";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Start_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Start")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setStart(text_element.data().toULongLong());
			--Start_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "End";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (End_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "End")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnd(text_element.data().toULongLong());
			--End_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "BlockSize";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BlockSize_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BlockSize")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBlockSize(text_element.data().toUInt());
			--BlockSize_count;
		}


		if (tag_name == "Image")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Image++ : nItemId;
			ImageNode* object = new ImageNode();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapImage.contains(nItemId))
				object->fromString(mapImage.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstImage += object;
			--Image_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Image_count > 0)
	{
		m_qsErrorMessage = "Error in class 'StorageNode': tag 'Image' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Start_count > 0)
	{
		m_qsErrorMessage = "Error in class 'StorageNode': tag 'Start' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (End_count > 0)
	{
		m_qsErrorMessage = "Error in class 'StorageNode': tag 'End' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (BlockSize_count > 0)
	{
		m_qsErrorMessage = "Error in class 'StorageNode': tag 'BlockSize' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_Image, "Image");


	return 0;
}

void StorageNode::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<ImageNode>(m_lstImage, "Image");
	setItemIds.clear();
	for(i = 0; i < m_lstImage.size(); ++i)
	{
		ImageNode* object = m_lstImage[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Image");

}

void StorageNode::Copy(const StorageNode& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setStart(rObject.getStart());
	setEnd(rObject.getEnd());
	setBlockSize(rObject.getBlockSize());

	ClearList<ImageNode >(m_lstImage);
	for(i = 0; i < rObject.m_lstImage.size(); i++)
		m_lstImage += new ImageNode(rObject.m_lstImage[i]);

	CustomCopy(&rObject);

}

void StorageNode::InitLists()
{
	InitList<ImageNode>(1, m_lstImage);
	CustomInit();
}

void StorageNode::ClearLists()
{
	ClearList<ImageNode>(m_lstImage);
}

void StorageNode::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Image") )
		ClearList<ImageNode>(m_lstImage);
}

