////////////////////////////////////////////////////////////////////////////////
///
/// CDispLicense.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CDispLicense.h"


CDispLicense::CDispLicense()
{
	InitLists();
	setDefaults();
}

CDispLicense::CDispLicense(const CDispLicense& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CDispLicense::CDispLicense(const CDispLicense* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CDispLicense& CDispLicense::operator=(const CDispLicense& rObject)
{
	Copy(rObject);
	return *this;
}

CDispLicense::CDispLicense(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CDispLicense::~CDispLicense()
{
	ClearLists();
}


CDispLicense::CDispLicense(const QString& key, const QString& user, const QString& company)
{
	cleanupClassProperties();

	setKey( key );
	setUser( user );
	setCompany( company );
	setLicenseConfirmed(false);
	setLicenseActivationStatus(PVE::LAS_UNKNOWN);
	setRegistrationStatus(COMMON_NOT_INITIALIZED_INT_VALUE);
}

CDispLicenseParsedKey* CDispLicense::getParsedKey() const
{
	if (!m_lstParsedKey.isEmpty())
	{
		return m_lstParsedKey[0];
	}
	return 0;
}

void CDispLicense::setParsedKey(CDispLicenseParsedKey* pParsedKey)
{
	ClearList<CDispLicenseParsedKey>(m_lstParsedKey);
	if (pParsedKey)
	{
		m_lstParsedKey += pParsedKey;
	}
}

QString CDispLicense::getKey() const
{
	return m_qsKey;
}

void CDispLicense::setKey(QString value)
{
	m_qsKey = value;
}

QString CDispLicense::getUser() const
{
	return m_qsUser;
}

void CDispLicense::setUser(QString value)
{
	m_qsUser = value;
}

QString CDispLicense::getCompany() const
{
	return m_qsCompany;
}

void CDispLicense::setCompany(QString value)
{
	m_qsCompany = value;
}

QString CDispLicense::getProductId() const
{
	return m_qsProductId;
}

void CDispLicense::setProductId(QString value)
{
	m_qsProductId = value;
}

QDateTime CDispLicense::getOfflineExpirationDate() const
{
	return m_dtOfflineExpirationDate;
}

void CDispLicense::setOfflineExpirationDate(QDateTime value)
{
	QTime t = value.time(); t.setHMS(t.hour(), t.minute(), t.second()); value.setTime(t);
	m_dtOfflineExpirationDate = value;
}

bool CDispLicense::isLicenseConfirmed() const
{
	return m_bLicenseConfirmed;
}

void CDispLicense::setLicenseConfirmed(bool value)
{
	m_bLicenseConfirmed = value;
}

QDateTime CDispLicense::getConfirmationDate() const
{
	return m_dtConfirmationDate;
}

void CDispLicense::setConfirmationDate(QDateTime value)
{
	QTime t = value.time(); t.setHMS(t.hour(), t.minute(), t.second()); value.setTime(t);
	m_dtConfirmationDate = value;
}

PVE::LicenseActivationStatus CDispLicense::getLicenseActivationStatus() const
{
	return m_ctLicenseActivationStatus;
}

void CDispLicense::setLicenseActivationStatus(PVE::LicenseActivationStatus value)
{
	m_ctLicenseActivationStatus = value;
}

int CDispLicense::getRegistrationStatus() const
{
	return m_iRegistrationStatus;
}

void CDispLicense::setRegistrationStatus(int value)
{
	m_iRegistrationStatus = value;
}

QDateTime CDispLicense::getRegistrationDate() const
{
	return m_dtRegistrationDate;
}

void CDispLicense::setRegistrationDate(QDateTime value)
{
	QTime t = value.time(); t.setHMS(t.hour(), t.minute(), t.second()); value.setTime(t);
	m_dtRegistrationDate = value;
}

void CDispLicense::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Key").isNull() )
		setKey();
	if ( ! RootElement || ! RootElement->firstChildElement("User").isNull() )
		setUser();
	if ( ! RootElement || ! RootElement->firstChildElement("Company").isNull() )
		setCompany();
	if ( ! RootElement || ! RootElement->firstChildElement("ProductId").isNull() )
		setProductId();
	if ( ! RootElement || ! RootElement->firstChildElement("OfflineExpirationDate").isNull() )
		setOfflineExpirationDate();
	if ( ! RootElement || ! RootElement->firstChildElement("LicenseConfirmed").isNull() )
		setLicenseConfirmed();
	if ( ! RootElement || ! RootElement->firstChildElement("ConfirmationDate").isNull() )
		setConfirmationDate();
	if ( ! RootElement || ! RootElement->firstChildElement("LicenseActivationStatus").isNull() )
		setLicenseActivationStatus();
	if ( ! RootElement || ! RootElement->firstChildElement("RegistrationStatus").isNull() )
		setRegistrationStatus();
	if ( ! RootElement || ! RootElement->firstChildElement("RegistrationDate").isNull() )
		setRegistrationDate();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::LicenseActivationStatus >("PVE::LicenseActivationStatus");
		first_time = false;
	}

}

QVariant CDispLicense::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Key.patch_stamp")
		value.setValue(getFieldPatchedValue("Key"));

	if (path == "Key")
		value.setValue(getKey());

	if (path == "User.patch_stamp")
		value.setValue(getFieldPatchedValue("User"));

	if (path == "User")
		value.setValue(getUser());

	if (path == "Company.patch_stamp")
		value.setValue(getFieldPatchedValue("Company"));

	if (path == "Company")
		value.setValue(getCompany());

	if (path == "ProductId.patch_stamp")
		value.setValue(getFieldPatchedValue("ProductId"));

	if (path == "ProductId")
		value.setValue(getProductId());

	if (path == "OfflineExpirationDate.patch_stamp")
		value.setValue(getFieldPatchedValue("OfflineExpirationDate"));

	if (path == "OfflineExpirationDate")
		value.setValue(getOfflineExpirationDate());

	if (path == "LicenseConfirmed.patch_stamp")
		value.setValue(getFieldPatchedValue("LicenseConfirmed"));

	if (path == "LicenseConfirmed")
		value.setValue(isLicenseConfirmed());

	if (path == "ConfirmationDate.patch_stamp")
		value.setValue(getFieldPatchedValue("ConfirmationDate"));

	if (path == "ConfirmationDate")
		value.setValue(getConfirmationDate());

	if (path == "LicenseActivationStatus.patch_stamp")
		value.setValue(getFieldPatchedValue("LicenseActivationStatus"));

	if (path == "LicenseActivationStatus")
		value.setValue((qlonglong )getLicenseActivationStatus());

	if (path == "RegistrationStatus.patch_stamp")
		value.setValue(getFieldPatchedValue("RegistrationStatus"));

	if (path == "RegistrationStatus")
		value.setValue(getRegistrationStatus());

	if (path == "RegistrationDate.patch_stamp")
		value.setValue(getFieldPatchedValue("RegistrationDate"));

	if (path == "RegistrationDate")
		value.setValue(getRegistrationDate());

	list_tag = "ParsedKey[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i] && nItemId == m_lstParsedKey[i]->getItemId())
				return m_lstParsedKey[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("ParsedKey.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i] && nMaxId < m_lstParsedKey[i]->getItemId())
				nMaxId = m_lstParsedKey[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("ParsedKey.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i]) lstIds += m_lstParsedKey[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CDispLicense::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Key.patch_stamp")
	{
		markPatchedField("Key", value.toString());
		return true;
	}

	if (path == "Key")
	{
		if (pbValueChanged)
			*pbValueChanged = (getKey() != value.value< QString >());
		setKey(value.value< QString >());
		return true;
	}

	if (path == "User.patch_stamp")
	{
		markPatchedField("User", value.toString());
		return true;
	}

	if (path == "User")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUser() != value.value< QString >());
		setUser(value.value< QString >());
		return true;
	}

	if (path == "Company.patch_stamp")
	{
		markPatchedField("Company", value.toString());
		return true;
	}

	if (path == "Company")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCompany() != value.value< QString >());
		setCompany(value.value< QString >());
		return true;
	}

	if (path == "ProductId.patch_stamp")
	{
		markPatchedField("ProductId", value.toString());
		return true;
	}

	if (path == "ProductId")
	{
		if (pbValueChanged)
			*pbValueChanged = (getProductId() != value.value< QString >());
		setProductId(value.value< QString >());
		return true;
	}

	if (path == "OfflineExpirationDate.patch_stamp")
	{
		markPatchedField("OfflineExpirationDate", value.toString());
		return true;
	}

	if (path == "OfflineExpirationDate")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOfflineExpirationDate() != value.value< QDateTime >());
		setOfflineExpirationDate(value.value< QDateTime >());
		return true;
	}

	if (path == "LicenseConfirmed.patch_stamp")
	{
		markPatchedField("LicenseConfirmed", value.toString());
		return true;
	}

	if (path == "LicenseConfirmed")
	{
		if (pbValueChanged)
			*pbValueChanged = (isLicenseConfirmed() != value.value< bool >());
		setLicenseConfirmed(value.value< bool >());
		return true;
	}

	if (path == "ConfirmationDate.patch_stamp")
	{
		markPatchedField("ConfirmationDate", value.toString());
		return true;
	}

	if (path == "ConfirmationDate")
	{
		if (pbValueChanged)
			*pbValueChanged = (getConfirmationDate() != value.value< QDateTime >());
		setConfirmationDate(value.value< QDateTime >());
		return true;
	}

	if (path == "LicenseActivationStatus.patch_stamp")
	{
		markPatchedField("LicenseActivationStatus", value.toString());
		return true;
	}

	if (path == "LicenseActivationStatus")
	{
		if (pbValueChanged)
			*pbValueChanged = (getLicenseActivationStatus() != (PVE::LicenseActivationStatus )value.value< qlonglong >());
		setLicenseActivationStatus((PVE::LicenseActivationStatus )value.value< qlonglong >());
		return true;
	}

	if (path == "RegistrationStatus.patch_stamp")
	{
		markPatchedField("RegistrationStatus", value.toString());
		return true;
	}

	if (path == "RegistrationStatus")
	{
		if (pbValueChanged)
			*pbValueChanged = (getRegistrationStatus() != value.value< int >());
		setRegistrationStatus(value.value< int >());
		return true;
	}

	if (path == "RegistrationDate.patch_stamp")
	{
		markPatchedField("RegistrationDate", value.toString());
		return true;
	}

	if (path == "RegistrationDate")
	{
		if (pbValueChanged)
			*pbValueChanged = (getRegistrationDate() != value.value< QDateTime >());
		setRegistrationDate(value.value< QDateTime >());
		return true;
	}

	list_tag = "ParsedKey[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i] && nItemId == m_lstParsedKey[i]->getItemId())
				return m_lstParsedKey[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CDispLicense::getKey_id() const
{
	return getFullItemId().isEmpty() ? "Key" : getFullItemId() + ".Key";
}
QString CDispLicense::getUser_id() const
{
	return getFullItemId().isEmpty() ? "User" : getFullItemId() + ".User";
}
QString CDispLicense::getCompany_id() const
{
	return getFullItemId().isEmpty() ? "Company" : getFullItemId() + ".Company";
}
QString CDispLicense::getProductId_id() const
{
	return getFullItemId().isEmpty() ? "ProductId" : getFullItemId() + ".ProductId";
}
QString CDispLicense::getOfflineExpirationDate_id() const
{
	return getFullItemId().isEmpty() ? "OfflineExpirationDate" : getFullItemId() + ".OfflineExpirationDate";
}
QString CDispLicense::getLicenseConfirmed_id() const
{
	return getFullItemId().isEmpty() ? "LicenseConfirmed" : getFullItemId() + ".LicenseConfirmed";
}
QString CDispLicense::getConfirmationDate_id() const
{
	return getFullItemId().isEmpty() ? "ConfirmationDate" : getFullItemId() + ".ConfirmationDate";
}
QString CDispLicense::getLicenseActivationStatus_id() const
{
	return getFullItemId().isEmpty() ? "LicenseActivationStatus" : getFullItemId() + ".LicenseActivationStatus";
}
QString CDispLicense::getRegistrationStatus_id() const
{
	return getFullItemId().isEmpty() ? "RegistrationStatus" : getFullItemId() + ".RegistrationStatus";
}
QString CDispLicense::getRegistrationDate_id() const
{
	return getFullItemId().isEmpty() ? "RegistrationDate" : getFullItemId() + ".RegistrationDate";
}

int CDispLicense::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "ParsedKey")
	{
		m_lstParsedKey += new CDispLicenseParsedKey;
		nNewItemId = getMaxItemId<CDispLicenseParsedKey>(m_lstParsedKey, "ParsedKey");
		m_lstParsedKey.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "ParsedKey");
	}

	list_tag = "ParsedKey[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i] && nItemId == m_lstParsedKey[i]->getItemId())
				return m_lstParsedKey[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CDispLicense::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ParsedKey[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParsedKey.size(); ++i)
			if (m_lstParsedKey[i] && nItemId == m_lstParsedKey[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstParsedKey[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstParsedKey.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CDispLicense::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("License") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Key");
	text_element = Document->createTextNode( QString("%1").arg(getKey()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("User");
	text_element = Document->createTextNode( QString("%1").arg(getUser()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "ParsedKey";
	nMaxItemId = getMaxItemId<CDispLicenseParsedKey>(m_lstParsedKey, "ParsedKey", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstParsedKey.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CDispLicenseParsedKey* object = m_lstParsedKey[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "ParsedKey", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Company");
	text_element = Document->createTextNode( QString("%1").arg(getCompany()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ProductId");
	text_element = Document->createTextNode( QString("%1").arg(getProductId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OfflineExpirationDate");
	text_element = Document->createTextNode( QString("%1").arg(getOfflineExpirationDate().toUTC().toString(XML_DATETIME_FORMAT)) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("LicenseConfirmed");
	text_element = Document->createTextNode( QString("%1").arg(isLicenseConfirmed()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConfirmationDate");
	text_element = Document->createTextNode( QString("%1").arg(getConfirmationDate().toUTC().toString(XML_DATETIME_FORMAT)) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("LicenseActivationStatus");
	text_element = Document->createTextNode( QString("%1").arg(getLicenseActivationStatus()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("RegistrationStatus");
	text_element = Document->createTextNode( QString("%1").arg(getRegistrationStatus()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("RegistrationDate");
	text_element = Document->createTextNode( QString("%1").arg(getRegistrationDate().toUTC().toString(XML_DATETIME_FORMAT)) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CDispLicense::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("License") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CDispLicense': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_ParsedKey = getMaxItemId2(element, "ParsedKey");
	QMap<int , QString > mapParsedKey;
	if (unite_with_loaded)
		fillItemIdMap<CDispLicenseParsedKey>(m_lstParsedKey, mapParsedKey);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int ParsedKey_count = 0;
	int Key_count = 1;
	int User_count = 1;
	int Company_count = 1;
	int ProductId_count = 0;
	int OfflineExpirationDate_count = 0;
	int LicenseConfirmed_count = 0;
	int ConfirmationDate_count = 0;
	int LicenseActivationStatus_count = 0;
	int RegistrationStatus_count = 0;
	int RegistrationDate_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Key";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Key_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Key")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setKey(text_element.data());
			--Key_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "User";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (User_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "User")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUser(text_element.data());
			--User_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Company";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Company_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Company")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCompany(text_element.data());
			--Company_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ProductId";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ProductId_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ProductId")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setProductId(text_element.data());
			--ProductId_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OfflineExpirationDate";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OfflineExpirationDate_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OfflineExpirationDate")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOfflineExpirationDate(toLocalTime( QDateTime::fromString( text_element.data(), XML_DATETIME_FORMAT ) ));
			--OfflineExpirationDate_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "LicenseConfirmed";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (LicenseConfirmed_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "LicenseConfirmed")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setLicenseConfirmed(text_element.data().toInt() != 0);
			--LicenseConfirmed_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ConfirmationDate";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConfirmationDate_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConfirmationDate")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConfirmationDate(toLocalTime( QDateTime::fromString( text_element.data(), XML_DATETIME_FORMAT ) ));
			--ConfirmationDate_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "LicenseActivationStatus";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (LicenseActivationStatus_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "LicenseActivationStatus")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setLicenseActivationStatus((PVE::LicenseActivationStatus )text_element.data().toLongLong());
			--LicenseActivationStatus_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "RegistrationStatus";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (RegistrationStatus_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "RegistrationStatus")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRegistrationStatus(text_element.data().toInt());
			--RegistrationStatus_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "RegistrationDate";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (RegistrationDate_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "RegistrationDate")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRegistrationDate(toLocalTime( QDateTime::fromString( text_element.data(), XML_DATETIME_FORMAT ) ));
			--RegistrationDate_count;
		}


		if (tag_name == "ParsedKey")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_ParsedKey++ : nItemId;
			CDispLicenseParsedKey* object = new CDispLicenseParsedKey();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "ParsedKey", object->getItemId());
			if (unite_with_loaded && mapParsedKey.contains(nItemId))
				object->fromString(mapParsedKey.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstParsedKey += object;
			--ParsedKey_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (ParsedKey_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'ParsedKey' is absent";
	}

	if (Key_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDispLicense': tag 'Key' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (User_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDispLicense': tag 'User' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Company_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDispLicense': tag 'Company' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ProductId_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'ProductId' is absent";
	}

	if (OfflineExpirationDate_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'OfflineExpirationDate' is absent";
	}

	if (LicenseConfirmed_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'LicenseConfirmed' is absent";
	}

	if (ConfirmationDate_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'ConfirmationDate' is absent";
	}

	if (LicenseActivationStatus_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'LicenseActivationStatus' is absent";
	}

	if (RegistrationStatus_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'RegistrationStatus' is absent";
	}

	if (RegistrationDate_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispLicense': tag 'RegistrationDate' is absent";
	}

	syncMaxItemId(nMaxItemId_ParsedKey, "ParsedKey");


	return 0;
}

void CDispLicense::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CDispLicenseParsedKey>(m_lstParsedKey, "ParsedKey");
	setItemIds.clear();
	for(i = 0; i < m_lstParsedKey.size(); ++i)
	{
		CDispLicenseParsedKey* object = m_lstParsedKey[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "ParsedKey", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "ParsedKey");

}

bool CDispLicense::merge(CDispLicense* pCur, CDispLicense* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "License";

	if (getKey() != pCur->getKey() && getKey() == pPrev->getKey())
		setKey(pCur->getKey());
	else if (getKey() != pCur->getKey() && getKey() != pPrev->getKey() && pCur->getKey() != pPrev->getKey())
	{
		m_qsErrorMessage += ".Key";
		return false;
	}

	if (getUser() != pCur->getUser() && getUser() == pPrev->getUser())
		setUser(pCur->getUser());
	else if (getUser() != pCur->getUser() && getUser() != pPrev->getUser() && pCur->getUser() != pPrev->getUser())
	{
		m_qsErrorMessage += ".User";
		return false;
	}

	if (getCompany() != pCur->getCompany() && getCompany() == pPrev->getCompany())
		setCompany(pCur->getCompany());
	else if (getCompany() != pCur->getCompany() && getCompany() != pPrev->getCompany() && pCur->getCompany() != pPrev->getCompany())
	{
		m_qsErrorMessage += ".Company";
		return false;
	}

	if (getProductId() != pCur->getProductId() && getProductId() == pPrev->getProductId())
		setProductId(pCur->getProductId());
	else if (getProductId() != pCur->getProductId() && getProductId() != pPrev->getProductId() && pCur->getProductId() != pPrev->getProductId())
	{
		m_qsErrorMessage += ".ProductId";
		return false;
	}

	if (nOptions & moEnableFixedFields)
		setOfflineExpirationDate(pPrev->getOfflineExpirationDate());
	if (getOfflineExpirationDate() != pCur->getOfflineExpirationDate() && getOfflineExpirationDate() == pPrev->getOfflineExpirationDate())
		setOfflineExpirationDate(pCur->getOfflineExpirationDate());
	else if (getOfflineExpirationDate() != pCur->getOfflineExpirationDate() && getOfflineExpirationDate() != pPrev->getOfflineExpirationDate() && pCur->getOfflineExpirationDate() != pPrev->getOfflineExpirationDate())
	{
		m_qsErrorMessage += ".OfflineExpirationDate";
		return false;
	}

	if (isLicenseConfirmed() != pCur->isLicenseConfirmed() && isLicenseConfirmed() == pPrev->isLicenseConfirmed())
		setLicenseConfirmed(pCur->isLicenseConfirmed());
	else if (isLicenseConfirmed() != pCur->isLicenseConfirmed() && isLicenseConfirmed() != pPrev->isLicenseConfirmed() && pCur->isLicenseConfirmed() != pPrev->isLicenseConfirmed())
	{
		m_qsErrorMessage += ".LicenseConfirmed";
		return false;
	}

	if (nOptions & moEnableFixedFields)
		setConfirmationDate(pPrev->getConfirmationDate());
	if (getConfirmationDate() != pCur->getConfirmationDate() && getConfirmationDate() == pPrev->getConfirmationDate())
		setConfirmationDate(pCur->getConfirmationDate());
	else if (getConfirmationDate() != pCur->getConfirmationDate() && getConfirmationDate() != pPrev->getConfirmationDate() && pCur->getConfirmationDate() != pPrev->getConfirmationDate())
	{
		m_qsErrorMessage += ".ConfirmationDate";
		return false;
	}

	if (getLicenseActivationStatus() != pCur->getLicenseActivationStatus() && getLicenseActivationStatus() == pPrev->getLicenseActivationStatus())
		setLicenseActivationStatus(pCur->getLicenseActivationStatus());
	else if (getLicenseActivationStatus() != pCur->getLicenseActivationStatus() && getLicenseActivationStatus() != pPrev->getLicenseActivationStatus() && pCur->getLicenseActivationStatus() != pPrev->getLicenseActivationStatus())
	{
		m_qsErrorMessage += ".LicenseActivationStatus";
		return false;
	}

	if (getRegistrationStatus() != pCur->getRegistrationStatus() && getRegistrationStatus() == pPrev->getRegistrationStatus())
		setRegistrationStatus(pCur->getRegistrationStatus());
	else if (getRegistrationStatus() != pCur->getRegistrationStatus() && getRegistrationStatus() != pPrev->getRegistrationStatus() && pCur->getRegistrationStatus() != pPrev->getRegistrationStatus())
	{
		m_qsErrorMessage += ".RegistrationStatus";
		return false;
	}

	if (nOptions & moEnableFixedFields)
		setRegistrationDate(pPrev->getRegistrationDate());
	if (getRegistrationDate() != pCur->getRegistrationDate() && getRegistrationDate() == pPrev->getRegistrationDate())
		setRegistrationDate(pCur->getRegistrationDate());
	else if (getRegistrationDate() != pCur->getRegistrationDate() && getRegistrationDate() != pPrev->getRegistrationDate() && pCur->getRegistrationDate() != pPrev->getRegistrationDate())
	{
		m_qsErrorMessage += ".RegistrationDate";
		return false;
	}

	if ( ! mergeList<CDispLicenseParsedKey>(m_lstParsedKey, pCur->m_lstParsedKey, pPrev->m_lstParsedKey, "ParsedKey", nOptions) )
		return false;

	return true;
}

void CDispLicense::diff(const CDispLicense* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getKey() != pOld->getKey())
		lstDiffFullItemIds += getKey_id();

	if (getUser() != pOld->getUser())
		lstDiffFullItemIds += getUser_id();

	if (getCompany() != pOld->getCompany())
		lstDiffFullItemIds += getCompany_id();

	if (getProductId() != pOld->getProductId())
		lstDiffFullItemIds += getProductId_id();

	if (getOfflineExpirationDate() != pOld->getOfflineExpirationDate())
		lstDiffFullItemIds += getOfflineExpirationDate_id();

	if (isLicenseConfirmed() != pOld->isLicenseConfirmed())
		lstDiffFullItemIds += getLicenseConfirmed_id();

	if (getConfirmationDate() != pOld->getConfirmationDate())
		lstDiffFullItemIds += getConfirmationDate_id();

	if (getLicenseActivationStatus() != pOld->getLicenseActivationStatus())
		lstDiffFullItemIds += getLicenseActivationStatus_id();

	if (getRegistrationStatus() != pOld->getRegistrationStatus())
		lstDiffFullItemIds += getRegistrationStatus_id();

	if (getRegistrationDate() != pOld->getRegistrationDate())
		lstDiffFullItemIds += getRegistrationDate_id();

	diffList<CDispLicenseParsedKey>(m_lstParsedKey, pOld->m_lstParsedKey, lstDiffFullItemIds);

}

void CDispLicense::Copy(const CDispLicense& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setKey(rObject.getKey());
	setUser(rObject.getUser());
	setCompany(rObject.getCompany());
	setProductId(rObject.getProductId());
	setOfflineExpirationDate(rObject.getOfflineExpirationDate());
	setLicenseConfirmed(rObject.isLicenseConfirmed());
	setConfirmationDate(rObject.getConfirmationDate());
	setLicenseActivationStatus(rObject.getLicenseActivationStatus());
	setRegistrationStatus(rObject.getRegistrationStatus());
	setRegistrationDate(rObject.getRegistrationDate());

	ClearList<CDispLicenseParsedKey >(m_lstParsedKey);
	for(i = 0; i < rObject.m_lstParsedKey.size(); i++)
		m_lstParsedKey += new CDispLicenseParsedKey(rObject.m_lstParsedKey[i]);

	CustomCopy(&rObject);

}

void CDispLicense::InitLists()
{
	CustomInit();
}

void CDispLicense::ClearLists()
{
	ClearList<CDispLicenseParsedKey>(m_lstParsedKey);
}

void CDispLicense::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("ParsedKey") )
		ClearList<CDispLicenseParsedKey>(m_lstParsedKey);
}

