////////////////////////////////////////////////////////////////////////////////
///
/// CDispNetAdapter.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CDISPNETADAPTER_H
#define CDISPNETADAPTER_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CDispDhcpPreferences.h"
#include "CDispDhcpPreferences.h"
#include "CDispPortForwarding.h"


class CDispNetAdapter : public CBaseNode
{

public:

	CDispNetAdapter();
	CDispNetAdapter(const CDispNetAdapter& rObject);
	CDispNetAdapter(const CDispNetAdapter* pObject);
	CDispNetAdapter(QFile* pFile);
	CDispNetAdapter& operator=(const CDispNetAdapter& rObject);
	virtual ~CDispNetAdapter();


	virtual void CustomInit()
	{
		getDhcpV6Preferences()->setExtRootTagName("DhcpV6Scope");

		getDhcpV6Preferences()->setDhcpScopeStartIp( QHostAddress(XML_DEFAULT_IP6_ADDRESS) );
		getDhcpV6Preferences()->setDhcpScopeEndIp( QHostAddress(XML_DEFAULT_IP6_ADDRESS) );
		getDhcpV6Preferences()->setDhcpScopeMask( QHostAddress(XML_DEFAULT_IP6_MASK) );
	}


	void setDhcpV6Preferences(CDispDhcpPreferences* pDhcp6Scope)
	{
		if (pDhcp6Scope)
			pDhcp6Scope->setExtRootTagName("DhcpV6Scope");
		setDhcpV6PreferencesOrig(pDhcp6Scope);
	}
	CDispDhcpPreferences* getDhcpV6Preferences() const
	{
		return getDhcpV6PreferencesOrig();
	}

	QList<CDispDhcpPreferences* >		m_lstDhcpScope;
	QList<CDispDhcpPreferences* >		m_lstDhcpV6Scope;
	QList<CDispPortForwarding* >		m_lstPortForwarding;

	CDispDhcpPreferences* getDhcpPreferences() const;
	void setDhcpPreferences(CDispDhcpPreferences* pDhcpScope);

	CDispDhcpPreferences* getDhcpV6PreferencesOrig() const;
	void setDhcpV6PreferencesOrig(CDispDhcpPreferences* pDhcpV6Scope);

	CDispPortForwarding* getPortForwarding() const;
	void setPortForwarding(CDispPortForwarding* pPortForwarding);


	QString getUuid() const;
	void setUuid(QString value = QString());

	bool isEnabled() const;
	void setEnabled(bool value = false);

	bool isHiddenAdapter() const;
	void setHiddenAdapter(bool value = true);

	PRL_NET_ADAPTER_EMULATED_TYPE getNetworkType() const;
	void setNetworkType(PRL_NET_ADAPTER_EMULATED_TYPE value = PNA_HOST_ONLY);

	QString getSysName() const;
	void setSysName(QString value = QString());

	QString getName() const;
	void setName(QString value = QString());

	int getIndex() const;
	void setIndex(int value = 0);

	bool isNatEnabled() const;
	void setNatEnabled(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getUuid_id() const;
	QString getEnabled_id() const;
	QString getHiddenAdapter_id() const;
	QString getNetworkType_id() const;
	QString getSysName_id() const;
	QString getName_id() const;
	QString getIndex_id() const;
	QString getNatEnabled_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CDispNetAdapter* pCur, CDispNetAdapter* pPrev, MergeOptions nOptions);

	void diff(const CDispNetAdapter* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsUuid;
	bool		m_bEnabled;
	bool		m_bHiddenAdapter;
	PRL_NET_ADAPTER_EMULATED_TYPE		m_ctEmulatedType;
	QString		m_qsSysName;
	QString		m_qsName;
	int		m_iIndex;
	bool		m_bNatEnabled;

	void Copy(const CDispNetAdapter& rObject);

};

#ifndef DM_79465381
#define DM_79465381
Q_DECLARE_METATYPE(PRL_NET_ADAPTER_EMULATED_TYPE)
#endif


#endif
