////////////////////////////////////////////////////////////////////////////////
///
/// CDispNetworkPreferences.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CDispNetworkPreferences.h"


CDispNetworkPreferences::CDispNetworkPreferences()
{
	InitLists();
	setDefaults();
}

CDispNetworkPreferences::CDispNetworkPreferences(const CDispNetworkPreferences& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CDispNetworkPreferences::CDispNetworkPreferences(const CDispNetworkPreferences* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CDispNetworkPreferences& CDispNetworkPreferences::operator=(const CDispNetworkPreferences& rObject)
{
	Copy(rObject);
	return *this;
}

CDispNetworkPreferences::CDispNetworkPreferences(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CDispNetworkPreferences::~CDispNetworkPreferences()
{
	ClearLists();
}


void CDispNetworkPreferences::addNetAdapter( CDispNetAdapter* pAdapter )
{
	m_lstNetAdapters.append( pAdapter );
}

void CDispNetworkPreferences::removeNetAdapter( CDispNetAdapter* pAdapter )
{
   m_lstNetAdapters.removeAll( pAdapter );
   delete pAdapter;
}

CDispNetAdapter* CDispNetworkPreferences::getAdapterByName(
	const QString& qsName )  const
{
	for ( int i = 0; i < m_lstNetAdapters.count(); i++ )
	{
		CDispNetAdapter* pAdapter = m_lstNetAdapters.at( i );
		if ( pAdapter->getName() == qsName )
			return pAdapter;
	}
	return NULL;
}

CDispNetAdapter* CDispNetworkPreferences::getAdapterByIndex( int nIndex ) const
{
	nIndex &= 0xfffffff;
	for ( int i = 0; i < m_lstNetAdapters.count(); i++ )
	{
		CDispNetAdapter* pAdapter = m_lstNetAdapters.at( i );
		if ( pAdapter->getIndex() == nIndex )
			return pAdapter;
	}
	return NULL;
}

bool CDispNetworkPreferences::doesAdapterNameExist( const QString& qsName ) const
{
	for ( int i = 0; i < m_lstNetAdapters.count(); i++ )
	{
		CDispNetAdapter* pAdapter = m_lstNetAdapters.at( i );
		if ( pAdapter->getName() == qsName )
			return true;
	}
	return false;
}

CNetworkClassesConfig* CDispNetworkPreferences::getNetworkClassesConfig() const
{
	if (!m_lstNetworkClassesConfig.isEmpty())
	{
		return m_lstNetworkClassesConfig[0];
	}
	return 0;
}

void CDispNetworkPreferences::setNetworkClassesConfig(CNetworkClassesConfig* pNetworkClassesConfig)
{
	ClearList<CNetworkClassesConfig>(m_lstNetworkClassesConfig);
	if (pNetworkClassesConfig)
	{
		m_lstNetworkClassesConfig += pNetworkClassesConfig;
	}
}

CNetworkShapingConfig* CDispNetworkPreferences::getNetworkShapingConfig() const
{
	if (!m_lstNetworkShapingConfig.isEmpty())
	{
		return m_lstNetworkShapingConfig[0];
	}
	return 0;
}

void CDispNetworkPreferences::setNetworkShapingConfig(CNetworkShapingConfig* pNetworkShapingConfig)
{
	ClearList<CNetworkShapingConfig>(m_lstNetworkShapingConfig);
	if (pNetworkShapingConfig)
	{
		m_lstNetworkShapingConfig += pNetworkShapingConfig;
	}
}

void CDispNetworkPreferences::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant CDispNetworkPreferences::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "NetworkClassesConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkClassesConfig.isEmpty() && m_lstNetworkClassesConfig.first())
		return m_lstNetworkClassesConfig.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "NetworkShapingConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkShapingConfig.isEmpty() && m_lstNetworkShapingConfig.first())
		return m_lstNetworkShapingConfig.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i] && nItemId == m_lstNetAdapters[i]->getItemId())
				return m_lstNetAdapters[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("NetworkAdapter.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i] && nMaxId < m_lstNetAdapters[i]->getItemId())
				nMaxId = m_lstNetAdapters[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("NetworkAdapter.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i]) lstIds += m_lstNetAdapters[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CDispNetworkPreferences::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "NetworkClassesConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkClassesConfig.isEmpty() && m_lstNetworkClassesConfig.first())
		return m_lstNetworkClassesConfig.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "NetworkShapingConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkShapingConfig.isEmpty() && m_lstNetworkShapingConfig.first())
		return m_lstNetworkShapingConfig.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i] && nItemId == m_lstNetAdapters[i]->getItemId())
				return m_lstNetAdapters[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

int CDispNetworkPreferences::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "NetworkClassesConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkClassesConfig.isEmpty() && m_lstNetworkClassesConfig.first())
		return m_lstNetworkClassesConfig.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "NetworkShapingConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkShapingConfig.isEmpty() && m_lstNetworkShapingConfig.first())
		return m_lstNetworkShapingConfig.first()->addListItem(path.mid(list_tag.size()));

	if (path == "NetworkAdapter")
	{
		m_lstNetAdapters += new CDispNetAdapter;
		nNewItemId = getMaxItemId<CDispNetAdapter>(m_lstNetAdapters, "NetworkAdapter");
		m_lstNetAdapters.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "NetworkAdapter");
	}

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i] && nItemId == m_lstNetAdapters[i]->getItemId())
				return m_lstNetAdapters[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CDispNetworkPreferences::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "NetworkClassesConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkClassesConfig.isEmpty() && m_lstNetworkClassesConfig.first())
		return m_lstNetworkClassesConfig.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "NetworkShapingConfig.";
	if (path.startsWith(list_tag) && ! m_lstNetworkShapingConfig.isEmpty() && m_lstNetworkShapingConfig.first())
		return m_lstNetworkShapingConfig.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetAdapters.size(); ++i)
			if (m_lstNetAdapters[i] && nItemId == m_lstNetAdapters[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstNetAdapters[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstNetAdapters.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CDispNetworkPreferences::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkPreferences") : m_qsExtRootTagName);

	for(i = 0; i < m_lstNetworkClassesConfig.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CNetworkClassesConfig* object = m_lstNetworkClassesConfig[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstNetworkShapingConfig.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CNetworkShapingConfig* object = m_lstNetworkShapingConfig[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	dyn_lists += "NetworkAdapter";
	nMaxItemId = getMaxItemId<CDispNetAdapter>(m_lstNetAdapters, "NetworkAdapter", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstNetAdapters.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CDispNetAdapter* object = m_lstNetAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "NetworkAdapter", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CDispNetworkPreferences::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkPreferences") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CDispNetworkPreferences': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_NetworkAdapter = getMaxItemId2(element, "NetworkAdapter");
	QMap<int , QString > mapNetworkAdapter;
	if (unite_with_loaded)
		fillItemIdMap<CDispNetAdapter>(m_lstNetAdapters, mapNetworkAdapter);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int NetworkClassesConfig_count = 1;
	int NetworkShapingConfig_count = 1;
	int NetAdapters_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "NetworkClassesConfig" && NetworkClassesConfig_count > 0)
		{
			unused_tag = false;
			CNetworkClassesConfig* object = m_lstNetworkClassesConfig[1 - NetworkClassesConfig_count];
			object->makeFullItemId(getFullItemId(), "NetworkClassesConfig");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--NetworkClassesConfig_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "NetworkShapingConfig" && NetworkShapingConfig_count > 0)
		{
			unused_tag = false;
			CNetworkShapingConfig* object = m_lstNetworkShapingConfig[1 - NetworkShapingConfig_count];
			object->makeFullItemId(getFullItemId(), "NetworkShapingConfig");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--NetworkShapingConfig_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "NetworkAdapter")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_NetworkAdapter++ : nItemId;
			CDispNetAdapter* object = new CDispNetAdapter();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "NetworkAdapter", object->getItemId());
			if (unite_with_loaded && mapNetworkAdapter.contains(nItemId))
				object->fromString(mapNetworkAdapter.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstNetAdapters += object;
			--NetAdapters_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (NetworkClassesConfig_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CDispNetworkPreferences': tag 'NetworkClassesConfig' is absent";
	}

	if (NetworkShapingConfig_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CDispNetworkPreferences': tag 'NetworkShapingConfig' is absent";
	}

	if (NetAdapters_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispNetworkPreferences': tag 'NetworkAdapter' is absent";
	}

	syncMaxItemId(nMaxItemId_NetworkAdapter, "NetworkAdapter");


	return 0;
}

void CDispNetworkPreferences::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstNetworkClassesConfig.size(); ++i)
	{
		CNetworkClassesConfig* object = m_lstNetworkClassesConfig[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "NetworkClassesConfig");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstNetworkShapingConfig.size(); ++i)
	{
		CNetworkShapingConfig* object = m_lstNetworkShapingConfig[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "NetworkShapingConfig");
		object->syncItemIds();
	}

	nMaxItemId = getMaxItemId<CDispNetAdapter>(m_lstNetAdapters, "NetworkAdapter");
	setItemIds.clear();
	for(i = 0; i < m_lstNetAdapters.size(); ++i)
	{
		CDispNetAdapter* object = m_lstNetAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "NetworkAdapter", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "NetworkAdapter");

}

bool CDispNetworkPreferences::merge(CDispNetworkPreferences* pCur, CDispNetworkPreferences* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "NetworkPreferences";

	for(i = 0; i < m_lstNetworkClassesConfig.size(); i++)
	{
		if ( m_lstNetworkClassesConfig[i]->merge(pCur->m_lstNetworkClassesConfig[i], pPrev->m_lstNetworkClassesConfig[i], nOptions) ) continue;
		QString qsIdx = (m_lstNetworkClassesConfig.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstNetworkClassesConfig[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstNetworkShapingConfig.size(); i++)
	{
		if ( m_lstNetworkShapingConfig[i]->merge(pCur->m_lstNetworkShapingConfig[i], pPrev->m_lstNetworkShapingConfig[i], nOptions) ) continue;
		QString qsIdx = (m_lstNetworkShapingConfig.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstNetworkShapingConfig[i]->GetErrorMessage();
		return false;
	}

	if ( ! mergeList<CDispNetAdapter>(m_lstNetAdapters, pCur->m_lstNetAdapters, pPrev->m_lstNetAdapters, "NetworkAdapter", nOptions) )
		return false;

	return true;
}

void CDispNetworkPreferences::diff(const CDispNetworkPreferences* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	for(i = 0; i < m_lstNetworkClassesConfig.size(); ++i)
		m_lstNetworkClassesConfig[i]->diff(pOld->m_lstNetworkClassesConfig[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstNetworkShapingConfig.size(); ++i)
		m_lstNetworkShapingConfig[i]->diff(pOld->m_lstNetworkShapingConfig[i], lstDiffFullItemIds);

	diffList<CDispNetAdapter>(m_lstNetAdapters, pOld->m_lstNetAdapters, lstDiffFullItemIds);

}

void CDispNetworkPreferences::Copy(const CDispNetworkPreferences& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CNetworkClassesConfig >(m_lstNetworkClassesConfig);
	for(i = 0; i < rObject.m_lstNetworkClassesConfig.size(); i++)
		m_lstNetworkClassesConfig += new CNetworkClassesConfig(rObject.m_lstNetworkClassesConfig[i]);

	ClearList<CNetworkShapingConfig >(m_lstNetworkShapingConfig);
	for(i = 0; i < rObject.m_lstNetworkShapingConfig.size(); i++)
		m_lstNetworkShapingConfig += new CNetworkShapingConfig(rObject.m_lstNetworkShapingConfig[i]);

	ClearList<CDispNetAdapter >(m_lstNetAdapters);
	for(i = 0; i < rObject.m_lstNetAdapters.size(); i++)
		m_lstNetAdapters += new CDispNetAdapter(rObject.m_lstNetAdapters[i]);

	CustomCopy(&rObject);

}

void CDispNetworkPreferences::InitLists()
{
	InitList<CNetworkClassesConfig>(1, m_lstNetworkClassesConfig);
	InitList<CNetworkShapingConfig>(1, m_lstNetworkShapingConfig);
	CustomInit();
}

void CDispNetworkPreferences::ClearLists()
{
	ClearList<CNetworkClassesConfig>(m_lstNetworkClassesConfig);
	ClearList<CNetworkShapingConfig>(m_lstNetworkShapingConfig);
	ClearList<CDispNetAdapter>(m_lstNetAdapters);
}

void CDispNetworkPreferences::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("NetworkAdapter") )
		ClearList<CDispNetAdapter>(m_lstNetAdapters);
	for(i = 0; i < m_lstNetworkClassesConfig.size() && ! unite_with_loaded; i++)
	{
		m_lstNetworkClassesConfig[i]->ClearListsInReadXml();
		m_lstNetworkClassesConfig[i]->setDefaults();
		m_lstNetworkClassesConfig[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstNetworkShapingConfig.size() && ! unite_with_loaded; i++)
	{
		m_lstNetworkShapingConfig[i]->ClearListsInReadXml();
		m_lstNetworkShapingConfig[i]->setDefaults();
		m_lstNetworkShapingConfig[i]->setSectionFakeFlag(true);
	}
}

