////////////////////////////////////////////////////////////////////////////////
///
/// CDispNetworkPreferences.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CDISPNETWORKPREFERENCES_H
#define CDISPNETWORKPREFERENCES_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "../NetworkConfig/CNetworkClassesConfig.h"
#include "../NetworkConfig/CNetworkShapingConfig.h"
#include "CDispNetAdapter.h"


class CDispNetworkPreferences : public CBaseNode
{

public:

	CDispNetworkPreferences();
	CDispNetworkPreferences(const CDispNetworkPreferences& rObject);
	CDispNetworkPreferences(const CDispNetworkPreferences* pObject);
	CDispNetworkPreferences(QFile* pFile);
	CDispNetworkPreferences& operator=(const CDispNetworkPreferences& rObject);
	virtual ~CDispNetworkPreferences();


private:
    bool m_bNoSave;

public:
    bool getNoSaveFlag() { return m_bNoSave; }
    void setNoSaveFlag(bool bNoSave) { m_bNoSave = bNoSave; }
    virtual void CustomInit() { m_bNoSave = false; }

    virtual void CustomCopy(const CBaseNode* pBN) { if (pBN) m_bNoSave = ((CDispNetworkPreferences* )pBN)->m_bNoSave; }

	// Get network adapters list
	QList<CDispNetAdapter* >* getNetAdapters()  { return &m_lstNetAdapters; }
	// Add network adapter to the list
	void addNetAdapter(CDispNetAdapter* );
    // Remove network adapter from list
    void removeNetAdapter(CDispNetAdapter* );
	// Get a network adapter by its name
	CDispNetAdapter* getAdapterByName( const QString& )  const;
	// Get a network adapter by its index
	CDispNetAdapter* getAdapterByIndex( int )  const;
	// Check if an adapter exists with the name.
	bool doesAdapterNameExist( const QString& )  const;

	QList<CNetworkClassesConfig* >		m_lstNetworkClassesConfig;
	QList<CNetworkShapingConfig* >		m_lstNetworkShapingConfig;
	QList<CDispNetAdapter* >		m_lstNetAdapters;

	CNetworkClassesConfig* getNetworkClassesConfig() const;
	void setNetworkClassesConfig(CNetworkClassesConfig* pNetworkClassesConfig);

	CNetworkShapingConfig* getNetworkShapingConfig() const;
	void setNetworkShapingConfig(CNetworkShapingConfig* pNetworkShapingConfig);


	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CDispNetworkPreferences* pCur, CDispNetworkPreferences* pPrev, MergeOptions nOptions);

	void diff(const CDispNetworkPreferences* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:


	void Copy(const CDispNetworkPreferences& rObject);

};



#endif
