////////////////////////////////////////////////////////////////////////////////
///
/// CDispUsbPreferences.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CDispUsbPreferences.h"


CDispUsbPreferences::CDispUsbPreferences()
{
	InitLists();
	setDefaults();
}

CDispUsbPreferences::CDispUsbPreferences(const CDispUsbPreferences& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CDispUsbPreferences::CDispUsbPreferences(const CDispUsbPreferences* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CDispUsbPreferences& CDispUsbPreferences::operator=(const CDispUsbPreferences& rObject)
{
	Copy(rObject);
	return *this;
}

CDispUsbPreferences::CDispUsbPreferences(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CDispUsbPreferences::~CDispUsbPreferences()
{
	ClearLists();
}


CDispUsbVirtualDisks* CDispUsbPreferences::getUsbVirtualDisks() const
{
	if (!m_lstUsbVirtualDisks.isEmpty())
	{
		return m_lstUsbVirtualDisks[0];
	}
	return 0;
}

void CDispUsbPreferences::setUsbVirtualDisks(CDispUsbVirtualDisks* pUsbVirtualDisks)
{
	ClearList<CDispUsbVirtualDisks>(m_lstUsbVirtualDisks);
	if (pUsbVirtualDisks)
	{
		m_lstUsbVirtualDisks += pUsbVirtualDisks;
	}
}

QList<QString> CDispUsbPreferences::getUsbBlackList() const
{
	return m_lstUsbBlackList;
}

void CDispUsbPreferences::setUsbBlackList(QList<QString> value)
{
	m_lstUsbBlackList = value;
}

void CDispUsbPreferences::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || dyn_lists.contains("UsbBlackList") )
		setUsbBlackList();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< QList<QString> >("QList<QString>");
		first_time = false;
	}

}

QVariant CDispUsbPreferences::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "UsbBlackList.patch_stamp")
		value.setValue(getFieldPatchedValue("UsbBlackList"));

	if (path == "UsbBlackList")
		value.setValue(getUsbBlackList());

	list_tag = "UsbIdentity[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i] && nItemId == m_lstAuthenticUsbMap[i]->getItemId())
				return m_lstAuthenticUsbMap[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("UsbIdentity.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i] && nMaxId < m_lstAuthenticUsbMap[i]->getItemId())
				nMaxId = m_lstAuthenticUsbMap[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("UsbIdentity.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i]) lstIds += m_lstAuthenticUsbMap[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "UsbVirtualDisks.";
	if (path.startsWith(list_tag) && ! m_lstUsbVirtualDisks.isEmpty() && m_lstUsbVirtualDisks.first())
		return m_lstUsbVirtualDisks.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CDispUsbPreferences::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "UsbBlackList.patch_stamp")
	{
		markPatchedField("UsbBlackList", value.toString());
		return true;
	}

	if (path == "UsbBlackList")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUsbBlackList() != value.value< QList<QString> >());
		setUsbBlackList(value.value< QList<QString> >());
		return true;
	}

	list_tag = "UsbIdentity[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i] && nItemId == m_lstAuthenticUsbMap[i]->getItemId())
				return m_lstAuthenticUsbMap[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "UsbVirtualDisks.";
	if (path.startsWith(list_tag) && ! m_lstUsbVirtualDisks.isEmpty() && m_lstUsbVirtualDisks.first())
		return m_lstUsbVirtualDisks.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CDispUsbPreferences::getUsbBlackList_id() const
{
	return getFullItemId().isEmpty() ? "UsbBlackList" : getFullItemId() + ".UsbBlackList";
}

int CDispUsbPreferences::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "UsbIdentity")
	{
		m_lstAuthenticUsbMap += new CDispUsbIdentity;
		nNewItemId = getMaxItemId<CDispUsbIdentity>(m_lstAuthenticUsbMap, "UsbIdentity");
		m_lstAuthenticUsbMap.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "UsbIdentity");
	}

	list_tag = "UsbIdentity[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i] && nItemId == m_lstAuthenticUsbMap[i]->getItemId())
				return m_lstAuthenticUsbMap[i]->addListItem(path.mid(idx + 2));
	}

	list_tag = "UsbVirtualDisks.";
	if (path.startsWith(list_tag) && ! m_lstUsbVirtualDisks.isEmpty() && m_lstUsbVirtualDisks.first())
		return m_lstUsbVirtualDisks.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CDispUsbPreferences::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "UsbIdentity[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
			if (m_lstAuthenticUsbMap[i] && nItemId == m_lstAuthenticUsbMap[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstAuthenticUsbMap[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstAuthenticUsbMap.takeAt(i);
				return true;
			}
	}

	list_tag = "UsbVirtualDisks.";
	if (path.startsWith(list_tag) && ! m_lstUsbVirtualDisks.isEmpty() && m_lstUsbVirtualDisks.first())
		return m_lstUsbVirtualDisks.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CDispUsbPreferences::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("UsbPreferences") : m_qsExtRootTagName);

	dyn_lists += "UsbIdentity";
	nMaxItemId = getMaxItemId<CDispUsbIdentity>(m_lstAuthenticUsbMap, "UsbIdentity", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstAuthenticUsbMap.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CDispUsbIdentity* object = m_lstAuthenticUsbMap[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "UsbIdentity", mapMaxDynListIds));

	dyn_lists += "UsbBlackList";
	for(i = 0; i < m_lstUsbBlackList.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("UsbBlackList");
		text_element = Document->createTextNode( QString("%1").arg(m_lstUsbBlackList[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	for(i = 0; i < m_lstUsbVirtualDisks.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CDispUsbVirtualDisks* object = m_lstUsbVirtualDisks[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CDispUsbPreferences::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("UsbPreferences") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CDispUsbPreferences': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_UsbIdentity = getMaxItemId2(element, "UsbIdentity");
	QMap<int , QString > mapUsbIdentity;
	if (unite_with_loaded)
		fillItemIdMap<CDispUsbIdentity>(m_lstAuthenticUsbMap, mapUsbIdentity);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int AuthenticUsbMap_count = 0;
	int UsbVirtualDisks_count = 1;
	int UsbBlackList_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		if (tag_name == "UsbBlackList")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstUsbBlackList += text_element.data();
			--UsbBlackList_count;
		}
		if (tag_name == "UsbIdentity")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_UsbIdentity++ : nItemId;
			CDispUsbIdentity* object = new CDispUsbIdentity();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "UsbIdentity", object->getItemId());
			if (unite_with_loaded && mapUsbIdentity.contains(nItemId))
				object->fromString(mapUsbIdentity.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstAuthenticUsbMap += object;
			--AuthenticUsbMap_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "UsbVirtualDisks" && UsbVirtualDisks_count > 0)
		{
			unused_tag = false;
			CDispUsbVirtualDisks* object = m_lstUsbVirtualDisks[1 - UsbVirtualDisks_count];
			object->makeFullItemId(getFullItemId(), "UsbVirtualDisks");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--UsbVirtualDisks_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (AuthenticUsbMap_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispUsbPreferences': tag 'UsbIdentity' is absent";
	}

	if (UsbVirtualDisks_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CDispUsbPreferences': tag 'UsbVirtualDisks' is absent";
	}

	if (UsbBlackList_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CDispUsbPreferences': tag 'UsbBlackList' is absent";
	}

	syncMaxItemId(nMaxItemId_UsbIdentity, "UsbIdentity");


	return 0;
}

void CDispUsbPreferences::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CDispUsbIdentity>(m_lstAuthenticUsbMap, "UsbIdentity");
	setItemIds.clear();
	for(i = 0; i < m_lstAuthenticUsbMap.size(); ++i)
	{
		CDispUsbIdentity* object = m_lstAuthenticUsbMap[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "UsbIdentity", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "UsbIdentity");

	for(i = 0; i < m_lstUsbVirtualDisks.size(); ++i)
	{
		CDispUsbVirtualDisks* object = m_lstUsbVirtualDisks[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "UsbVirtualDisks");
		object->syncItemIds();
	}

}

bool CDispUsbPreferences::merge(CDispUsbPreferences* pCur, CDispUsbPreferences* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "UsbPreferences";

	if (getUsbBlackList() != pCur->getUsbBlackList() && getUsbBlackList() == pPrev->getUsbBlackList())
		setUsbBlackList(pCur->getUsbBlackList());
	else if (getUsbBlackList() != pCur->getUsbBlackList() && getUsbBlackList() != pPrev->getUsbBlackList() && pCur->getUsbBlackList() != pPrev->getUsbBlackList())
	{
		m_qsErrorMessage += ".UsbBlackList";
		return false;
	}

	if ( ! mergeList<CDispUsbIdentity>(m_lstAuthenticUsbMap, pCur->m_lstAuthenticUsbMap, pPrev->m_lstAuthenticUsbMap, "UsbIdentity", nOptions) )
		return false;

	for(i = 0; i < m_lstUsbVirtualDisks.size(); i++)
	{
		if ( m_lstUsbVirtualDisks[i]->merge(pCur->m_lstUsbVirtualDisks[i], pPrev->m_lstUsbVirtualDisks[i], nOptions) ) continue;
		QString qsIdx = (m_lstUsbVirtualDisks.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstUsbVirtualDisks[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CDispUsbPreferences::diff(const CDispUsbPreferences* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getUsbBlackList() != pOld->getUsbBlackList())
		lstDiffFullItemIds += getUsbBlackList_id();

	diffList<CDispUsbIdentity>(m_lstAuthenticUsbMap, pOld->m_lstAuthenticUsbMap, lstDiffFullItemIds);

	for(i = 0; i < m_lstUsbVirtualDisks.size(); ++i)
		m_lstUsbVirtualDisks[i]->diff(pOld->m_lstUsbVirtualDisks[i], lstDiffFullItemIds);

}

void CDispUsbPreferences::Copy(const CDispUsbPreferences& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUsbBlackList(rObject.getUsbBlackList());

	ClearList<CDispUsbIdentity >(m_lstAuthenticUsbMap);
	for(i = 0; i < rObject.m_lstAuthenticUsbMap.size(); i++)
		m_lstAuthenticUsbMap += new CDispUsbIdentity(rObject.m_lstAuthenticUsbMap[i]);

	ClearList<CDispUsbVirtualDisks >(m_lstUsbVirtualDisks);
	for(i = 0; i < rObject.m_lstUsbVirtualDisks.size(); i++)
		m_lstUsbVirtualDisks += new CDispUsbVirtualDisks(rObject.m_lstUsbVirtualDisks[i]);

	CustomCopy(&rObject);

}

void CDispUsbPreferences::InitLists()
{
	InitList<CDispUsbVirtualDisks>(1, m_lstUsbVirtualDisks);
	CustomInit();
}

void CDispUsbPreferences::ClearLists()
{
	ClearList<CDispUsbIdentity>(m_lstAuthenticUsbMap);
	ClearList<CDispUsbVirtualDisks>(m_lstUsbVirtualDisks);
}

void CDispUsbPreferences::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("UsbIdentity") )
		ClearList<CDispUsbIdentity>(m_lstAuthenticUsbMap);
	for(i = 0; i < m_lstUsbVirtualDisks.size() && ! unite_with_loaded; i++)
	{
		m_lstUsbVirtualDisks[i]->ClearListsInReadXml();
		m_lstUsbVirtualDisks[i]->setDefaults();
		m_lstUsbVirtualDisks[i]->setSectionFakeFlag(true);
	}
}

