////////////////////////////////////////////////////////////////////////////////
///
/// CDispWorkspacePreferences.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CDISPWORKSPACEPREFERENCES_H
#define CDISPWORKSPACEPREFERENCES_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include <prlsdk/PrlPorts.h>
#include "CDspLimits.h"


class CDispWorkspacePreferences : public CBaseNode
{

public:

	CDispWorkspacePreferences();
	CDispWorkspacePreferences(const CDispWorkspacePreferences& rObject);
	CDispWorkspacePreferences(const CDispWorkspacePreferences* pObject);
	CDispWorkspacePreferences(QFile* pFile);
	CDispWorkspacePreferences& operator=(const CDispWorkspacePreferences& rObject);
	virtual ~CDispWorkspacePreferences();


    enum SecurityLevel
    {
          LowLevel = 0,
          NormalLevel,
          HighLevel
    };

	QList<CDspLimits* >		m_lstLimits;

	CDspLimits* getLimits() const;
	void setLimits(CDspLimits* pLimits);


	QString getDefaultVmDirectory() const;
	void setDefaultVmDirectory(QString value = QString());

	bool isDistributedDirectory() const;
	void setDistributedDirectory(bool value = false);

	bool isDefaultUseConsole() const;
	void setDefaultUseConsole(bool value = true);

	bool isDefaultChangeSettings() const;
	void setDefaultChangeSettings(bool value = false);

	unsigned int getDispatcherPort() const;
	void setDispatcherPort(unsigned int value = (PRL_DISPATCHER_LISTEN_PORT));

	bool isListenAnyAddr() const;
	void setListenAnyAddr(bool value = false);

	bool isAllowMobileClients() const;
	void setAllowMobileClients(bool value = false);

	bool isAllowDirectMobile() const;
	void setAllowDirectMobile(bool value = (false));

	bool isAllowMultiplePMC() const;
	void setAllowMultiplePMC(bool value = false);

	PRL_MOBILE_ADVANCED_AUTH_MODE getMobileAdvancedAuthMode() const;
	void setMobileAdvancedAuthMode(PRL_MOBILE_ADVANCED_AUTH_MODE value = PMAA_NO_ADVANCED_AUTH_NEEDED);

	QString getHostId() const;
	void setHostId(QString value = QString());

	unsigned int getDefaultCommandHistorySize() const;
	void setDefaultCommandHistorySize(unsigned int value = 50);

	PRL_SECURITY_LEVEL getMinimalSecurityLevel() const;
	void setMinimalSecurityLevel(PRL_SECURITY_LEVEL value = PSL_LOW_SECURITY);

	unsigned int getVmTimeoutOnShutdown() const;
	void setVmTimeoutOnShutdown(unsigned int value = 120);

	bool isAllowVmForceShutdown() const;
	void setAllowVmForceShutdown(bool value = true);

	unsigned int getVmUptimeSyncTimeoutInMinutes() const;
	void setVmUptimeSyncTimeoutInMinutes(unsigned int value = 15);

	bool isAllowUseNetworkShares() const;
	void setAllowUseNetworkShares(bool value = false);

	QString getSwapPathForVMOnNetworkShares() const;
	void setSwapPathForVMOnNetworkShares(QString value = QString());

	bool isClusterModeEnabled() const;
	void setClusterModeEnabled(bool value = false);

	bool isVmConfigWatcherEnabled() const;
	void setVmConfigWatcherEnabled(bool value = false);

	PRL_USB_DEVICE_AUTO_CONNECT_OPTION getUsbConnectionType() const;
	void setUsbConnectionType(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value = PUD_ASK_USER_WHAT_TODO);

	bool isEnableSpokenCommands() const;
	void setEnableSpokenCommands(bool value = false);

	bool isEnableSendStatisticReport() const;
	void setEnableSendStatisticReport(bool value = false);

	PVE::ConfirmationModeValue getConfirmationModeByDefault() const;
	void setConfirmationModeByDefault(PVE::ConfirmationModeValue value = PVE::CMV_DEFAULT);

	bool isDefaultPlainDiskAllowed() const;
	void setDefaultPlainDiskAllowed(bool value = false);

	bool isPluginsAllowed() const;
	void setPluginsAllowed(bool value = false);

	bool isVmConfigCacheEnabled() const;
	void setVmConfigCacheEnabled(bool value = true);

	bool isHeadlessModeEnabled() const;
	void setHeadlessModeEnabled(bool value = true);

	bool isDisableCheckOnlineVolumeLicenseKeys() const;
	void setDisableCheckOnlineVolumeLicenseKeys(bool value = false);

	bool isDisableCheckEtcHosts() const;
	void setDisableCheckEtcHosts(bool value = false);

	bool isMountNTFSToHostOnConnectionToVm() const;
	void setMountNTFSToHostOnConnectionToVm(bool value = false);

	unsigned int getVmGuestCollectPeriod() const;
	void setVmGuestCollectPeriod(unsigned int value = 5);

	unsigned int getVmGuestCpuLimitType() const;
	void setVmGuestCpuLimitType(unsigned int value = 0);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getDefaultVmDirectory_id() const;
	QString getDistributedDirectory_id() const;
	QString getDefaultUseConsole_id() const;
	QString getDefaultChangeSettings_id() const;
	QString getDispatcherPort_id() const;
	QString getListenAnyAddr_id() const;
	QString getAllowMobileClients_id() const;
	QString getAllowDirectMobile_id() const;
	QString getAllowMultiplePMC_id() const;
	QString getMobileAdvancedAuthMode_id() const;
	QString getHostId_id() const;
	QString getDefaultCommandHistorySize_id() const;
	QString getMinimalSecurityLevel_id() const;
	QString getVmTimeoutOnShutdown_id() const;
	QString getAllowVmForceShutdown_id() const;
	QString getVmUptimeSyncTimeoutInMinutes_id() const;
	QString getAllowUseNetworkShares_id() const;
	QString getSwapPathForVMOnNetworkShares_id() const;
	QString getClusterModeEnabled_id() const;
	QString getVmConfigWatcherEnabled_id() const;
	QString getUsbConnectionType_id() const;
	QString getEnableSpokenCommands_id() const;
	QString getEnableSendStatisticReport_id() const;
	QString getConfirmationModeByDefault_id() const;
	QString getDefaultPlainDiskAllowed_id() const;
	QString getPluginsAllowed_id() const;
	QString getVmConfigCacheEnabled_id() const;
	QString getHeadlessModeEnabled_id() const;
	QString getDisableCheckOnlineVolumeLicenseKeys_id() const;
	QString getDisableCheckEtcHosts_id() const;
	QString getMountNTFSToHostOnConnectionToVm_id() const;
	QString getVmGuestCollectPeriod_id() const;
	QString getVmGuestCpuLimitType_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CDispWorkspacePreferences* pCur, CDispWorkspacePreferences* pPrev, MergeOptions nOptions);

	void diff(const CDispWorkspacePreferences* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsDefaultVmDirectory;
	bool		m_bDistributedDirectory;
	bool		m_bDefaultUseConsole;
	bool		m_bDefaultChangeSettings;
	unsigned int		m_uiDispatcherPort;
	bool		m_bListenAnyAddr;
	bool		m_bAllowMobileClients;
	bool		m_bAllowDirectMobile;
	bool		m_bAllowMultiplePMC;
	PRL_MOBILE_ADVANCED_AUTH_MODE		m_ctMobileAdvancedAuthMode;
	QString		m_qsHostId;
	unsigned int		m_uiDefaultCommandHistorySize;
	PRL_SECURITY_LEVEL		m_ctMinimalSecurityLevel;
	unsigned int		m_uiVmTimeoutOnShutdown;
	bool		m_bAllowVmForceShutdown;
	unsigned int		m_uiVmUptimeSyncTimeoutInMinutes;
	bool		m_bAllowUseNetworkShares;
	QString		m_qsSwapPathForVMOnNetworkShares;
	bool		m_bClusterModeEnabled;
	bool		m_bVmConfigWatcherEnabled;
	PRL_USB_DEVICE_AUTO_CONNECT_OPTION		m_ctUsbConnectionType;
	bool		m_bEnableSpokenCommands;
	bool		m_bEnableSendStatisticReport;
	PVE::ConfirmationModeValue		m_ctConfirmationModeByDefault;
	bool		m_bDefaultPlainDiskAllowed;
	bool		m_bPluginsAllowed;
	bool		m_bVmConfigCacheEnabled;
	bool		m_bHeadlessModeEnabled;
	bool		m_bSpecialOption;
	bool		m_bSpecialOption2;
	bool		m_bMountNTFSToHostOnConnectionToVm;
	unsigned int		m_uiVmGuestCollectPeriod;
	unsigned int		m_uiVmGuestCpuLimitType;

	void Copy(const CDispWorkspacePreferences& rObject);

};

#ifndef DM_245168101
#define DM_245168101
Q_DECLARE_METATYPE(PRL_MOBILE_ADVANCED_AUTH_MODE)
#endif
#ifndef DM_159966844
#define DM_159966844
Q_DECLARE_METATYPE(PRL_SECURITY_LEVEL)
#endif
#ifndef DM_154204158
#define DM_154204158
Q_DECLARE_METATYPE(PRL_USB_DEVICE_AUTO_CONNECT_OPTION)
#endif
#ifndef DM_159745461
#define DM_159745461
Q_DECLARE_METATYPE(PVE::ConfirmationModeValue)
#endif


#endif
