////////////////////////////////////////////////////////////////////////////////
///
/// Validity.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "Validity.h"


Validity::Validity()
{
	InitLists();
	setDefaults();
}

Validity::Validity(const Validity& rObject)
: CBaseNode()
{
	Copy(rObject);
}

Validity::Validity(const Validity* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

Validity& Validity::operator=(const Validity& rObject)
{
	Copy(rObject);
	return *this;
}

Validity::Validity(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

Validity::~Validity()
{
	ClearLists();
}


QString Validity::getIssued() const
{
	return m_qsIssued;
}

void Validity::setIssued(QString value)
{
	m_qsIssued = value;
}

QString Validity::getUnit() const
{
	return m_qsUnit;
}

void Validity::setUnit(QString value)
{
	m_qsUnit = value;
}

QString Validity::getPeriod() const
{
	return m_qsPeriod;
}

void Validity::setPeriod(QString value)
{
	m_qsPeriod = value;
}

void Validity::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Issued").isNull() )
		setIssued();
	if ( ! RootElement || ! RootElement->firstChildElement("Unit").isNull() )
		setUnit();
	if ( ! RootElement || ! RootElement->firstChildElement("Period").isNull() )
		setPeriod();
}

QVariant Validity::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Issued.patch_stamp")
		value.setValue(getFieldPatchedValue("Issued"));

	if (path == "Issued")
		value.setValue(getIssued());

	if (path == "Unit.patch_stamp")
		value.setValue(getFieldPatchedValue("Unit"));

	if (path == "Unit")
		value.setValue(getUnit());

	if (path == "Period.patch_stamp")
		value.setValue(getFieldPatchedValue("Period"));

	if (path == "Period")
		value.setValue(getPeriod());

	return value;
}

bool Validity::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Issued.patch_stamp")
	{
		markPatchedField("Issued", value.toString());
		return true;
	}

	if (path == "Issued")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIssued() != value.value< QString >());
		setIssued(value.value< QString >());
		return true;
	}

	if (path == "Unit.patch_stamp")
	{
		markPatchedField("Unit", value.toString());
		return true;
	}

	if (path == "Unit")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUnit() != value.value< QString >());
		setUnit(value.value< QString >());
		return true;
	}

	if (path == "Period.patch_stamp")
	{
		markPatchedField("Period", value.toString());
		return true;
	}

	if (path == "Period")
	{
		if (pbValueChanged)
			*pbValueChanged = (getPeriod() != value.value< QString >());
		setPeriod(value.value< QString >());
		return true;
	}

	return false;
}

QString Validity::getIssued_id() const
{
	return getFullItemId().isEmpty() ? "Issued" : getFullItemId() + ".Issued";
}
QString Validity::getUnit_id() const
{
	return getFullItemId().isEmpty() ? "Unit" : getFullItemId() + ".Unit";
}
QString Validity::getPeriod_id() const
{
	return getFullItemId().isEmpty() ? "Period" : getFullItemId() + ".Period";
}

int Validity::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool Validity::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement Validity::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Validity") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Issued");
	text_element = Document->createTextNode( QString("%1").arg(getIssued()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Unit");
	text_element = Document->createTextNode( QString("%1").arg(getUnit()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Period");
	text_element = Document->createTextNode( QString("%1").arg(getPeriod()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int Validity::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Validity") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'Validity': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Issued_count = 0;
	int Unit_count = 0;
	int Period_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Issued";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Issued_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Issued")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIssued(text_element.data());
			--Issued_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Unit";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Unit_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Unit")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUnit(text_element.data());
			--Unit_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Period";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Period_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Period")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setPeriod(text_element.data());
			--Period_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Issued_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Validity': tag 'Issued' is absent";
	}

	if (Unit_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Validity': tag 'Unit' is absent";
	}

	if (Period_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Validity': tag 'Period' is absent";
	}



	return 0;
}

void Validity::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool Validity::merge(Validity* pCur, Validity* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Validity";

	if (getIssued() != pCur->getIssued() && getIssued() == pPrev->getIssued())
		setIssued(pCur->getIssued());
	else if (getIssued() != pCur->getIssued() && getIssued() != pPrev->getIssued() && pCur->getIssued() != pPrev->getIssued())
	{
		m_qsErrorMessage += ".Issued";
		return false;
	}

	if (getUnit() != pCur->getUnit() && getUnit() == pPrev->getUnit())
		setUnit(pCur->getUnit());
	else if (getUnit() != pCur->getUnit() && getUnit() != pPrev->getUnit() && pCur->getUnit() != pPrev->getUnit())
	{
		m_qsErrorMessage += ".Unit";
		return false;
	}

	if (getPeriod() != pCur->getPeriod() && getPeriod() == pPrev->getPeriod())
		setPeriod(pCur->getPeriod());
	else if (getPeriod() != pCur->getPeriod() && getPeriod() != pPrev->getPeriod() && pCur->getPeriod() != pPrev->getPeriod())
	{
		m_qsErrorMessage += ".Period";
		return false;
	}

	return true;
}

void Validity::diff(const Validity* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIssued() != pOld->getIssued())
		lstDiffFullItemIds += getIssued_id();

	if (getUnit() != pOld->getUnit())
		lstDiffFullItemIds += getUnit_id();

	if (getPeriod() != pOld->getPeriod())
		lstDiffFullItemIds += getPeriod_id();

}

void Validity::Copy(const Validity& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIssued(rObject.getIssued());
	setUnit(rObject.getUnit());
	setPeriod(rObject.getPeriod());

	CustomCopy(&rObject);

}

void Validity::InitLists()
{
	CustomInit();
}

void Validity::ClearLists()
{
}

void Validity::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

