////////////////////////////////////////////////////////////////////////////////
///
/// CHostHardwareInfoBase.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CHOSTHARDWAREINFOBASE_H
#define CHOSTHARDWAREINFOBASE_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CPSRasterizer.h"
#include "CHwMemorySettings.h"
#include "CHwNetworkSettings.h"
#include "CHwDeviceInterfaceSettings.h"
#include "FloppyDisks.h"
#include "CdROMs.h"
#include "HardDisks.h"
#include "SerialPorts.h"
#include "ParallelPorts.h"
#include "NetworkAdapters.h"
#include "VirtualNetworkAdapters.h"
#include "SoundDevices.h"
#include "UsbDevices.h"
#include "Printers.h"
#include "CHwCpu.h"
#include "CHwOsVersion.h"
#include "GenericPciDevices.h"
#include "GenericScsiDevices.h"


class CHostHardwareInfoBase : public CBaseNode
{

public:

	CHostHardwareInfoBase();
	CHostHardwareInfoBase(const CHostHardwareInfoBase& rObject);
	CHostHardwareInfoBase(const CHostHardwareInfoBase* pObject);
	CHostHardwareInfoBase(QFile* pFile);
	CHostHardwareInfoBase& operator=(const CHostHardwareInfoBase& rObject);
	virtual ~CHostHardwareInfoBase();


	QList<CPSRasterizer* >		m_lstPSRasterizer;
	QList<CHwMemorySettings* >		m_lstMemorySettings;
	QList<CHwNetworkSettings* >		m_lstNetworkSettings;
	QList<CHwDeviceInterfaceSettings* >		m_lstDeviceInterfaceSettings;
	QList<FloppyDisks* >		m_lstFloppyDisksBase;
	QList<CdROMs* >		m_lstCdROMs;
	QList<HardDisks* >		m_lstHardDisksBase;
	QList<SerialPorts* >		m_lstSerialPortsBase;
	QList<ParallelPorts* >		m_lstParallelPortsBase;
	QList<NetworkAdapters* >		m_lstNetworkAdaptersBase;
	QList<VirtualNetworkAdapters* >		m_lstVirtualNetworkAdaptersBase;
	QList<SoundDevices* >		m_lstSoundDevices;
	QList<UsbDevices* >		m_lstUsbDevicesBase;
	QList<Printers* >		m_lstPrintersBase;
	QList<CHwCpu* >		m_lstCpu;
	QList<CHwOsVersion* >		m_lstOsVersion;
	QList<GenericPciDevices* >		m_lstGenericPciDevicesBase;
	QList<GenericScsiDevices* >		m_lstGenericScsiDevicesBase;

	CPSRasterizer* getPSRasterizer() const;
	void setPSRasterizer(CPSRasterizer* pPSRasterizer);

	CHwMemorySettings* getMemorySettings() const;
	void setMemorySettings(CHwMemorySettings* pMemorySettings);

	CHwNetworkSettings* getNetworkSettings() const;
	void setNetworkSettings(CHwNetworkSettings* pNetworkSettings);

	CHwDeviceInterfaceSettings* getDeviceInterfaceSettings() const;
	void setDeviceInterfaceSettings(CHwDeviceInterfaceSettings* pDeviceInterfaceSettings);

	FloppyDisks* getFloppyDisks() const;
	void setFloppyDisks(FloppyDisks* pFloppyDisksBase);

	CdROMs* getCdROMs() const;
	void setCdROMs(CdROMs* pCdROMs);

	HardDisks* getHardDisks() const;
	void setHardDisks(HardDisks* pHardDisksBase);

	SerialPorts* getSerialPorts() const;
	void setSerialPorts(SerialPorts* pSerialPortsBase);

	ParallelPorts* getParallelPorts() const;
	void setParallelPorts(ParallelPorts* pParallelPortsBase);

	NetworkAdapters* getNetworkAdapters() const;
	void setNetworkAdapters(NetworkAdapters* pNetworkAdaptersBase);

	VirtualNetworkAdapters* getVirtualNetworkAdapters() const;
	void setVirtualNetworkAdapters(VirtualNetworkAdapters* pVirtualNetworkAdaptersBase);

	SoundDevices* getSoundDevices() const;
	void setSoundDevices(SoundDevices* pSoundDevices);

	UsbDevices* getUsbDevices() const;
	void setUsbDevices(UsbDevices* pUsbDevicesBase);

	Printers* getPrinters() const;
	void setPrinters(Printers* pPrintersBase);

	CHwCpu* getCpu() const;
	void setCpu(CHwCpu* pCpu);

	CHwOsVersion* getOsVersion() const;
	void setOsVersion(CHwOsVersion* pOsVersion);

	GenericPciDevices* getGenericPciDevices() const;
	void setGenericPciDevices(GenericPciDevices* pGenericPciDevicesBase);

	GenericScsiDevices* getGenericScsiDevices() const;
	void setGenericScsiDevices(GenericScsiDevices* pGenericScsiDevicesBase);


	unsigned int getSoundDefaultEnabled() const;
	void setSoundDefaultEnabled(unsigned int value = 0);

	unsigned int getUsbSupported() const;
	void setUsbSupported(unsigned int value = 0);

	bool isVtdSupported() const;
	void setVtdSupported(bool value = false);

	bool isHostNotebookFlag() const;
	void setHostNotebookFlag(bool value = false);

	unsigned int getVtdInitializationCode() const;
	void setVtdInitializationCode(unsigned int value = PVSC_NOT_PRESENT);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	unsigned int		m_uiSoundDefaultEnabled;
	unsigned int		m_uiUsbSupported;
	bool		m_bVtdSupported;
	bool		m_bHostNotebookFlag;
	unsigned int		m_uiVtdInitializationCode;

	void Copy(const CHostHardwareInfoBase& rObject);

};



#endif
