////////////////////////////////////////////////////////////////////////////////
///
/// CHwFileSystemInfo.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwFileSystemInfo.h"


CHwFileSystemInfo::CHwFileSystemInfo()
{
	InitLists();
	setDefaults();
}

CHwFileSystemInfo::CHwFileSystemInfo(const CHwFileSystemInfo& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CHwFileSystemInfo::CHwFileSystemInfo(const CHwFileSystemInfo* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwFileSystemInfo& CHwFileSystemInfo::operator=(const CHwFileSystemInfo& rObject)
{
	Copy(rObject);
	return *this;
}

CHwFileSystemInfo::CHwFileSystemInfo(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwFileSystemInfo::~CHwFileSystemInfo()
{
	ClearLists();
}


CHwFsItem* CHwFileSystemInfo::getParentElement() const
{
	if (!m_lstParentElement.isEmpty())
	{
		return m_lstParentElement[0];
	}
	return 0;
}

void CHwFileSystemInfo::setParentElement(CHwFsItem* pParentElement)
{
	ClearList<CHwFsItem>(m_lstParentElement);
	if (pParentElement)
	{
		m_lstParentElement += pParentElement;
	}
}

unsigned int CHwFileSystemInfo::getFileSystemGenre() const
{
	return m_uiType;
}

void CHwFileSystemInfo::setFileSystemGenre(unsigned int value)
{
	m_uiType = value;
}

PRL_FILE_SYSTEM_FS_TYPE CHwFileSystemInfo::getFileSystemType() const
{
	return m_ctFsType;
}

void CHwFileSystemInfo::setFileSystemType(PRL_FILE_SYSTEM_FS_TYPE value)
{
	m_ctFsType = value;
}

void CHwFileSystemInfo::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setFileSystemGenre();
	if ( ! RootElement || ! RootElement->firstChildElement("FsType").isNull() )
		setFileSystemType();
}

QDomElement CHwFileSystemInfo::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("FileSystemInfo") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getFileSystemGenre()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("FsType");
	text_element = Document->createTextNode( QString("%1").arg(getFileSystemType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "ParentElement";
	nMaxItemId = getMaxItemId<CHwFsItem>(m_lstParentElement, "ParentElement", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstParentElement.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHwFsItem* object = m_lstParentElement[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "ParentElement", mapMaxDynListIds));

	dyn_lists += "FsElement";
	nMaxItemId = getMaxItemId<CHwFsItem>(m_lstFileSystemItems, "FsElement", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstFileSystemItems.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHwFsItem* object = m_lstFileSystemItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "FsElement", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwFileSystemInfo::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("FileSystemInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwFileSystemInfo': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_ParentElement = getMaxItemId2(element, "ParentElement");
	QMap<int , QString > mapParentElement;
	if (unite_with_loaded)
		fillItemIdMap<CHwFsItem>(m_lstParentElement, mapParentElement);
	int nMaxItemId_FsElement = getMaxItemId2(element, "FsElement");
	QMap<int , QString > mapFsElement;
	if (unite_with_loaded)
		fillItemIdMap<CHwFsItem>(m_lstFileSystemItems, mapFsElement);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int ParentElement_count = 0;
	int FileSystemItems_count = 0;
	int Type_count = 1;
	int FsType_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setFileSystemGenre(text_element.data().toUInt());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "FsType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (FsType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "FsType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setFileSystemType((PRL_FILE_SYSTEM_FS_TYPE )text_element.data().toLongLong());
			--FsType_count;
		}


		if (tag_name == "ParentElement")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_ParentElement++ : nItemId;
			CHwFsItem* object = new CHwFsItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapParentElement.contains(nItemId))
				object->fromString(mapParentElement.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstParentElement += object;
			--ParentElement_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "FsElement")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_FsElement++ : nItemId;
			CHwFsItem* object = new CHwFsItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapFsElement.contains(nItemId))
				object->fromString(mapFsElement.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstFileSystemItems += object;
			--FileSystemItems_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (ParentElement_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwFileSystemInfo': tag 'ParentElement' is absent";
	}

	if (FileSystemItems_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwFileSystemInfo': tag 'FsElement' is absent";
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwFileSystemInfo': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (FsType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwFileSystemInfo': tag 'FsType' is absent";
	}

	syncMaxItemId(nMaxItemId_ParentElement, "ParentElement");
	syncMaxItemId(nMaxItemId_FsElement, "FsElement");


	return 0;
}

void CHwFileSystemInfo::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CHwFsItem>(m_lstParentElement, "ParentElement");
	setItemIds.clear();
	for(i = 0; i < m_lstParentElement.size(); ++i)
	{
		CHwFsItem* object = m_lstParentElement[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "ParentElement");

	nMaxItemId = getMaxItemId<CHwFsItem>(m_lstFileSystemItems, "FsElement");
	setItemIds.clear();
	for(i = 0; i < m_lstFileSystemItems.size(); ++i)
	{
		CHwFsItem* object = m_lstFileSystemItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "FsElement");

}

void CHwFileSystemInfo::Copy(const CHwFileSystemInfo& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setFileSystemGenre(rObject.getFileSystemGenre());
	setFileSystemType(rObject.getFileSystemType());

	ClearList<CHwFsItem >(m_lstParentElement);
	for(i = 0; i < rObject.m_lstParentElement.size(); i++)
		m_lstParentElement += new CHwFsItem(rObject.m_lstParentElement[i]);

	ClearList<CHwFsItem >(m_lstFileSystemItems);
	for(i = 0; i < rObject.m_lstFileSystemItems.size(); i++)
		m_lstFileSystemItems += new CHwFsItem(rObject.m_lstFileSystemItems[i]);

	CustomCopy(&rObject);

}

void CHwFileSystemInfo::InitLists()
{
	CustomInit();
}

void CHwFileSystemInfo::ClearLists()
{
	ClearList<CHwFsItem>(m_lstParentElement);
	ClearList<CHwFsItem>(m_lstFileSystemItems);
}

void CHwFileSystemInfo::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("ParentElement") )
		ClearList<CHwFsItem>(m_lstParentElement);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("FsElement") )
		ClearList<CHwFsItem>(m_lstFileSystemItems);
}

