////////////////////////////////////////////////////////////////////////////////
///
/// CHwFsItem.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CHWFSITEM_H
#define CHWFSITEM_H


#include <prlcommon/PrlObjects/CBaseNode.h>


class CHwFsItem : public CBaseNode
{

public:

	CHwFsItem();
	CHwFsItem(const CHwFsItem& rObject);
	CHwFsItem(const CHwFsItem* pObject);
	CHwFsItem(QFile* pFile);
	CHwFsItem& operator=(const CHwFsItem& rObject);
	virtual ~CHwFsItem();


	// is file system item a drive
	bool isDrive() const {
		return (getType() == PSE_DRIVE) ? true : false;
	};

	// is file system item is directory
	bool isFile() const {
		return (getType() == PSE_FILE) ? true : false;
	};

	// is file system item is directory
	bool isDir() const {
		return (getType() == PSE_DIRECTORY) ? true : false;
	};

	// get user friendly absolute partition name
	QString getRelativeName() const {
		QFileInfo info(getName());
		return info.fileName();
	}

	CHwFsItem( QString name, qint64 size = 0, unsigned int type = PSE_FILE,
		QDateTime modified = QDateTime::currentDateTime(), unsigned int permissions = 0 )
	{
		setName(name);
		setSize(size);
		setType(type);
		setModified(modified);
		setPermissions(permissions);
	};



	unsigned int getType() const;
	void setType(unsigned int value = PSE_FILE);

	QString getName() const;
	void setName(QString value = QString());

	qint64 getSize() const;
	void setSize(qint64 value = (qint64 )0);

	QDateTime getModified() const;
	void setModified(QDateTime value = QDateTime::currentDateTime());

	unsigned int getPermissions() const;
	void setPermissions(unsigned int value = 0);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	unsigned int		m_uiType;
	QString		m_qsName;
	qint64		m_ctSize;
	QDateTime		m_dtModified;
	unsigned int		m_uiPermissions;

	void Copy(const CHwFsItem& rObject);

};



#endif
