////////////////////////////////////////////////////////////////////////////////
///
/// CHwHardDisk.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwHardDisk.h"


CHwHardDisk::CHwHardDisk()
{
	InitLists();
	setDefaults();
}

CHwHardDisk::CHwHardDisk(const CHwHardDisk& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CHwHardDisk::CHwHardDisk(const CHwHardDisk* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwHardDisk& CHwHardDisk::operator=(const CHwHardDisk& rObject)
{
	Copy(rObject);
	return *this;
}

CHwHardDisk::CHwHardDisk(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwHardDisk::~CHwHardDisk()
{
	ClearLists();
}


QList<CHwHddPartition* > CHwHardDisk::getAllPartitions(const QList<CHwHddPartition* >& list) const
{
    QList<CHwHddPartition* > all;
    foreach( CHwHddPartition* part, list )
    {
        all += part;
        all += getAllPartitions(part->m_lstPartitions);
    }
    return all;
}

CHwHardDisk::CHwHardDisk(QString dev_name, qint64 dev_size, unsigned int type,
	 QString dev_id, unsigned int index)
{
	cleanupClassProperties();

	m_qsName = dev_name;
	m_qsUuid = dev_id;
	m_ctSize = dev_size;
	m_uiType = type;
	m_uiIndex = index;
	m_bRemovable = false;
	m_bExternal = false;
}

QString CHwHardDisk::getDeviceName() const
{
	return m_qsName;
}

void CHwHardDisk::setDeviceName(QString value)
{
	m_qsName = value;
}

qint64 CHwHardDisk::getDeviceSize() const
{
	return m_ctSize;
}

void CHwHardDisk::setDeviceSize(qint64 value)
{
	m_ctSize = value;
}

QString CHwHardDisk::getDeviceId() const
{
	return m_qsUuid;
}

void CHwHardDisk::setDeviceId(QString value)
{
	m_qsUuid = value;
}

unsigned int CHwHardDisk::getType() const
{
	return m_uiType;
}

void CHwHardDisk::setType(unsigned int value)
{
	m_uiType = value;
}

unsigned int CHwHardDisk::getDiskIndex() const
{
	return m_uiIndex;
}

void CHwHardDisk::setDiskIndex(unsigned int value)
{
	m_uiIndex = value;
}

bool CHwHardDisk::isRemovable() const
{
	return m_bRemovable;
}

void CHwHardDisk::setRemovable(bool value)
{
	m_bRemovable = value;
}

bool CHwHardDisk::isExternal() const
{
	return m_bExternal;
}

void CHwHardDisk::setExternal(bool value)
{
	m_bExternal = value;
}

void CHwHardDisk::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setDeviceName();
	if ( ! RootElement || ! RootElement->firstChildElement("Size").isNull() )
		setDeviceSize();
	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setDeviceId(Uuid::createUuid().toString());
	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("Index").isNull() )
		setDiskIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Removable").isNull() )
		setRemovable();
	if ( ! RootElement || ! RootElement->firstChildElement("External").isNull() )
		setExternal();
}

QDomElement CHwHardDisk::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("HardDisk") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Size");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Index");
	text_element = Document->createTextNode( QString("%1").arg(getDiskIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "Partition";
	nMaxItemId = getMaxItemId<CHwHddPartition>(m_lstPartitions, "Partition", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstPartitions.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHwHddPartition* object = m_lstPartitions[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Partition", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Removable");
	text_element = Document->createTextNode( QString("%1").arg(isRemovable()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("External");
	text_element = Document->createTextNode( QString("%1").arg(isExternal()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwHardDisk::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("HardDisk") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_Partition = getMaxItemId2(element, "Partition");
	QMap<int , QString > mapPartition;
	if (unite_with_loaded)
		fillItemIdMap<CHwHddPartition>(m_lstPartitions, mapPartition);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Partitions_count = 0;
	int Name_count = 1;
	int Size_count = 1;
	int Uuid_count = 1;
	int Type_count = 1;
	int Index_count = 1;
	int Removable_count = 0;
	int External_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Size";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Size_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Size")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceSize((qint64 )text_element.data().toLongLong());
			--Size_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceId(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType(text_element.data().toUInt());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDiskIndex(text_element.data().toUInt());
			--Index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Removable";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Removable_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Removable")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemovable(text_element.data().toInt() != 0);
			--Removable_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "External";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (External_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "External")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setExternal(text_element.data().toInt() != 0);
			--External_count;
		}


		if (tag_name == "Partition")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Partition++ : nItemId;
			CHwHddPartition* object = new CHwHddPartition();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapPartition.contains(nItemId))
				object->fromString(mapPartition.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstPartitions += object;
			--Partitions_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Partitions_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwHardDisk': tag 'Partition' is absent";
	}

	if (Name_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': tag 'Name' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Size_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': tag 'Size' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwHardDisk': tag 'Index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Removable_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwHardDisk': tag 'Removable' is absent";
	}

	if (External_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwHardDisk': tag 'External' is absent";
	}

	syncMaxItemId(nMaxItemId_Partition, "Partition");


	return 0;
}

void CHwHardDisk::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CHwHddPartition>(m_lstPartitions, "Partition");
	setItemIds.clear();
	for(i = 0; i < m_lstPartitions.size(); ++i)
	{
		CHwHddPartition* object = m_lstPartitions[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Partition");

}

void CHwHardDisk::Copy(const CHwHardDisk& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDeviceName(rObject.getDeviceName());
	setDeviceSize(rObject.getDeviceSize());
	setDeviceId(rObject.getDeviceId());
	setType(rObject.getType());
	setDiskIndex(rObject.getDiskIndex());
	setRemovable(rObject.isRemovable());
	setExternal(rObject.isExternal());

	ClearList<CHwHddPartition >(m_lstPartitions);
	for(i = 0; i < rObject.m_lstPartitions.size(); i++)
		m_lstPartitions += new CHwHddPartition(rObject.m_lstPartitions[i]);

	CustomCopy(&rObject);

}

void CHwHardDisk::InitLists()
{
	CustomInit();
}

void CHwHardDisk::ClearLists()
{
	ClearList<CHwHddPartition>(m_lstPartitions);
}

void CHwHardDisk::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Partition") )
		ClearList<CHwHddPartition>(m_lstPartitions);
}

