////////////////////////////////////////////////////////////////////////////////
///
/// CHwNetAdapter.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwNetAdapter.h"


CHwNetAdapter::CHwNetAdapter()
{
	InitLists();
	setDefaults();
}

CHwNetAdapter::CHwNetAdapter(const CHwNetAdapter& rObject)
: CHwGenericDevice()
{
	Copy(rObject);
}

CHwNetAdapter::CHwNetAdapter(const CHwNetAdapter* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwNetAdapter& CHwNetAdapter::operator=(const CHwNetAdapter& rObject)
{
	Copy(rObject);
	return *this;
}

CHwNetAdapter::CHwNetAdapter(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwNetAdapter::~CHwNetAdapter()
{
	ClearLists();
}


CHwNetAdapter::CHwNetAdapter(PRL_DEVICE_TYPE dev_type, const QString& dev_name, const QString& dev_sys_name,  int sysIndex, const QString& macAddress, unsigned short vlanTag, bool flgEnabled, QString uuid)
: CHwGenericDevice( dev_type, dev_name, dev_sys_name/*, parent */)
{
    Q_UNUSED(uuid);

     InitLists();


    setDeviceName(dev_name);
    setDeviceId(dev_sys_name);
    setSysIndex( sysIndex );
	setMacAddress( macAddress);
    setNetAdapterType( PHI_REAL_NET_ADAPTER );
    setEnabled( flgEnabled );
    setConfigureWithDhcp(false);
    setConfigureWithDhcpIPv6(false);
	setVLANTag(vlanTag);
}

QString CHwNetAdapter::getDeviceName() const
{
	return m_qsName;
}

void CHwNetAdapter::setDeviceName(QString value)
{
	m_qsName = value;
}

QString CHwNetAdapter::getDeviceId() const
{
	return m_qsUuid;
}

void CHwNetAdapter::setDeviceId(QString value)
{
	m_qsUuid = value;
}

int CHwNetAdapter::getSysIndex() const
{
	return m_iindex;
}

void CHwNetAdapter::setSysIndex(int value)
{
	m_iindex = value;
}

PRL_HW_INFO_NET_ADAPTER_TYPE CHwNetAdapter::getNetAdapterType() const
{
	return m_ctType;
}

void CHwNetAdapter::setNetAdapterType(PRL_HW_INFO_NET_ADAPTER_TYPE value)
{
	m_ctType = value;
}

bool CHwNetAdapter::isEnabled() const
{
	return m_bEnabled;
}

void CHwNetAdapter::setEnabled(bool value)
{
	m_bEnabled = value;
}

QString CHwNetAdapter::getMacAddress() const
{
	return m_qsMacAddress;
}

void CHwNetAdapter::setMacAddress(QString value)
{
	m_qsMacAddress = value;
}

QList<QString> CHwNetAdapter::getNetAddresses() const
{
	return m_lstNetAddress;
}

void CHwNetAdapter::setNetAddresses(QList<QString> value)
{
	m_lstNetAddress = value;
}

bool CHwNetAdapter::isConfigureWithDhcp() const
{
	return m_bConfigureWithDhcp;
}

void CHwNetAdapter::setConfigureWithDhcp(bool value)
{
	m_bConfigureWithDhcp = value;
}

QString CHwNetAdapter::getDefaultGateway() const
{
	return m_qsDefaultGateway;
}

void CHwNetAdapter::setDefaultGateway(QString value)
{
	m_qsDefaultGateway = value;
}

bool CHwNetAdapter::isConfigureWithDhcpIPv6() const
{
	return m_bConfigureWithDhcpIPv6;
}

void CHwNetAdapter::setConfigureWithDhcpIPv6(bool value)
{
	m_bConfigureWithDhcpIPv6 = value;
}

QString CHwNetAdapter::getDefaultGatewayIPv6() const
{
	return m_qsDefaultGatewayIPv6;
}

void CHwNetAdapter::setDefaultGatewayIPv6(QString value)
{
	m_qsDefaultGatewayIPv6 = value;
}

QList<QString> CHwNetAdapter::getDnsIPAddresses() const
{
	return m_lstDnsIPAddress;
}

void CHwNetAdapter::setDnsIPAddresses(QList<QString> value)
{
	m_lstDnsIPAddress = value;
}

QList<QString> CHwNetAdapter::getSearchDomains() const
{
	return m_lstSearchDomain;
}

void CHwNetAdapter::setSearchDomains(QList<QString> value)
{
	m_lstSearchDomain = value;
}

unsigned short CHwNetAdapter::getVLANTag() const
{
	return m_usVLANTag;
}

void CHwNetAdapter::setVLANTag(unsigned short value)
{
	m_usVLANTag = value;
}

void CHwNetAdapter::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setDeviceName();
	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setDeviceId(Uuid::createUuid().toString());
	if ( ! RootElement || ! RootElement->firstChildElement("index").isNull() )
		setSysIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setNetAdapterType();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("MacAddress").isNull() )
		setMacAddress();
	if ( ! RootElement || dyn_lists.contains("NetAddress") )
		setNetAddresses();
	if ( ! RootElement || ! RootElement->firstChildElement("ConfigureWithDhcp").isNull() )
		setConfigureWithDhcp();
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultGateway").isNull() )
		setDefaultGateway();
	if ( ! RootElement || ! RootElement->firstChildElement("ConfigureWithDhcpIPv6").isNull() )
		setConfigureWithDhcpIPv6();
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultGatewayIPv6").isNull() )
		setDefaultGatewayIPv6();
	if ( ! RootElement || dyn_lists.contains("DnsIPAddress") )
		setDnsIPAddresses();
	if ( ! RootElement || dyn_lists.contains("SearchDomain") )
		setSearchDomains();
	if ( ! RootElement || ! RootElement->firstChildElement("VLANTag").isNull() )
		setVLANTag();
}

QDomElement CHwNetAdapter::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkAdapter") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("index");
	text_element = Document->createTextNode( QString("%1").arg(getSysIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getNetAdapterType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("MacAddress");
	text_element = Document->createTextNode( QString("%1").arg(getMacAddress()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "NetAddress";
	for(i = 0; i < m_lstNetAddress.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("NetAddress");
		text_element = Document->createTextNode( QString("%1").arg(m_lstNetAddress[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConfigureWithDhcp");
	text_element = Document->createTextNode( QString("%1").arg(isConfigureWithDhcp()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultGateway");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultGateway()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConfigureWithDhcpIPv6");
	text_element = Document->createTextNode( QString("%1").arg(isConfigureWithDhcpIPv6()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultGatewayIPv6");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultGatewayIPv6()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "DnsIPAddress";
	for(i = 0; i < m_lstDnsIPAddress.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("DnsIPAddress");
		text_element = Document->createTextNode( QString("%1").arg(m_lstDnsIPAddress[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	dyn_lists += "SearchDomain";
	for(i = 0; i < m_lstSearchDomain.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("SearchDomain");
		text_element = Document->createTextNode( QString("%1").arg(m_lstSearchDomain[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VLANTag");
	text_element = Document->createTextNode( QString("%1").arg(getVLANTag()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwNetAdapter::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkAdapter") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Name_count = 1;
	int Uuid_count = 1;
	int index_count = 1;
	int Type_count = 1;
	int Enabled_count = 1;
	int MacAddress_count = 0;
	int NetAddress_count = 0;
	int ConfigureWithDhcp_count = 0;
	int DefaultGateway_count = 0;
	int ConfigureWithDhcpIPv6_count = 0;
	int DefaultGatewayIPv6_count = 0;
	int DnsIPAddress_count = 0;
	int SearchDomain_count = 0;
	int VLANTag_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceId(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSysIndex(text_element.data().toInt());
			--index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNetAdapterType((PRL_HW_INFO_NET_ADAPTER_TYPE )text_element.data().toLongLong());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "MacAddress";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (MacAddress_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "MacAddress")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMacAddress(text_element.data());
			--MacAddress_count;
		}


		if (tag_name == "NetAddress")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstNetAddress += text_element.data();
			--NetAddress_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "ConfigureWithDhcp";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConfigureWithDhcp_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConfigureWithDhcp")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConfigureWithDhcp(text_element.data().toInt() != 0);
			--ConfigureWithDhcp_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultGateway";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultGateway_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultGateway")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultGateway(text_element.data());
			--DefaultGateway_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ConfigureWithDhcpIPv6";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConfigureWithDhcpIPv6_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConfigureWithDhcpIPv6")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConfigureWithDhcpIPv6(text_element.data().toInt() != 0);
			--ConfigureWithDhcpIPv6_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultGatewayIPv6";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultGatewayIPv6_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultGatewayIPv6")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultGatewayIPv6(text_element.data());
			--DefaultGatewayIPv6_count;
		}


		if (tag_name == "DnsIPAddress")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstDnsIPAddress += text_element.data();
			--DnsIPAddress_count;
		}
		if (tag_name == "SearchDomain")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstSearchDomain += text_element.data();
			--SearchDomain_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "VLANTag";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VLANTag_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VLANTag")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVLANTag((unsigned short )text_element.data().toUInt());
			--VLANTag_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Name_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': tag 'Name' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': tag 'index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetAdapter': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (MacAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'MacAddress' is absent";
	}

	if (NetAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'NetAddress' is absent";
	}

	if (ConfigureWithDhcp_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'ConfigureWithDhcp' is absent";
	}

	if (DefaultGateway_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'DefaultGateway' is absent";
	}

	if (ConfigureWithDhcpIPv6_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'ConfigureWithDhcpIPv6' is absent";
	}

	if (DefaultGatewayIPv6_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'DefaultGatewayIPv6' is absent";
	}

	if (DnsIPAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'DnsIPAddress' is absent";
	}

	if (SearchDomain_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'SearchDomain' is absent";
	}

	if (VLANTag_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetAdapter': tag 'VLANTag' is absent";
	}



    if ( isConfigureWithDhcp() )
        setConfigureWithDhcp( getNetAddresses().isEmpty() );
	return 0;
}

void CHwNetAdapter::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void CHwNetAdapter::Copy(const CHwNetAdapter& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDeviceName(rObject.getDeviceName());
	setDeviceId(rObject.getDeviceId());
	setSysIndex(rObject.getSysIndex());
	setNetAdapterType(rObject.getNetAdapterType());
	setEnabled(rObject.isEnabled());
	setMacAddress(rObject.getMacAddress());
	setNetAddresses(rObject.getNetAddresses());
	setConfigureWithDhcp(rObject.isConfigureWithDhcp());
	setDefaultGateway(rObject.getDefaultGateway());
	setConfigureWithDhcpIPv6(rObject.isConfigureWithDhcpIPv6());
	setDefaultGatewayIPv6(rObject.getDefaultGatewayIPv6());
	setDnsIPAddresses(rObject.getDnsIPAddresses());
	setSearchDomains(rObject.getSearchDomains());
	setVLANTag(rObject.getVLANTag());

	CustomCopy(&rObject);

}

void CHwNetAdapter::InitLists()
{
	CustomInit();
}

void CHwNetAdapter::ClearLists()
{
}

void CHwNetAdapter::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

