////////////////////////////////////////////////////////////////////////////////
///
/// CHwNetworkSettings.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwNetworkSettings.h"


CHwNetworkSettings::CHwNetworkSettings()
{
	InitLists();
	setDefaults();
}

CHwNetworkSettings::CHwNetworkSettings(const CHwNetworkSettings& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CHwNetworkSettings::CHwNetworkSettings(const CHwNetworkSettings* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwNetworkSettings& CHwNetworkSettings::operator=(const CHwNetworkSettings& rObject)
{
	Copy(rObject);
	return *this;
}

CHwNetworkSettings::CHwNetworkSettings(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwNetworkSettings::~CHwNetworkSettings()
{
	ClearLists();
}


CHwGlobalNetwork* CHwNetworkSettings::getGlobalNetwork() const
{
	if (!m_lstGlobalNetwork.isEmpty())
	{
		return m_lstGlobalNetwork[0];
	}
	return 0;
}

void CHwNetworkSettings::setGlobalNetwork(CHwGlobalNetwork* pGlobalNetwork)
{
	ClearList<CHwGlobalNetwork>(m_lstGlobalNetwork);
	if (pGlobalNetwork)
	{
		m_lstGlobalNetwork += pGlobalNetwork;
	}
}

unsigned int CHwNetworkSettings::getMaxVmNetAdapters() const
{
	return m_uiMaxVmNetAdapters;
}

void CHwNetworkSettings::setMaxVmNetAdapters(unsigned int value)
{
	m_uiMaxVmNetAdapters = value;
}

unsigned int CHwNetworkSettings::getMaxHostNetAdapters() const
{
	return m_uiMaxHostNetAdapters;
}

void CHwNetworkSettings::setMaxHostNetAdapters(unsigned int value)
{
	m_uiMaxHostNetAdapters = value;
}

void CHwNetworkSettings::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("MaxVmNetAdapters").isNull() )
		setMaxVmNetAdapters();
	if ( ! RootElement || ! RootElement->firstChildElement("MaxHostNetAdapters").isNull() )
		setMaxHostNetAdapters();
}

QDomElement CHwNetworkSettings::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkSettings") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("MaxVmNetAdapters");
	text_element = Document->createTextNode( QString("%1").arg(getMaxVmNetAdapters()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("MaxHostNetAdapters");
	text_element = Document->createTextNode( QString("%1").arg(getMaxHostNetAdapters()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstGlobalNetwork.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHwGlobalNetwork* object = m_lstGlobalNetwork[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwNetworkSettings::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkSettings") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwNetworkSettings': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int GlobalNetwork_count = 1;
	int MaxVmNetAdapters_count = 1;
	int MaxHostNetAdapters_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "MaxVmNetAdapters";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (MaxVmNetAdapters_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "MaxVmNetAdapters")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMaxVmNetAdapters(text_element.data().toUInt());
			--MaxVmNetAdapters_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "MaxHostNetAdapters";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (MaxHostNetAdapters_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "MaxHostNetAdapters")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMaxHostNetAdapters(text_element.data().toUInt());
			--MaxHostNetAdapters_count;
		}


		if (tag_name == "GlobalNetwork" && GlobalNetwork_count > 0)
		{
			unused_tag = false;
			CHwGlobalNetwork* object = m_lstGlobalNetwork[1 - GlobalNetwork_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--GlobalNetwork_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (GlobalNetwork_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CHwNetworkSettings': tag 'GlobalNetwork' is absent";
	}

	if (MaxVmNetAdapters_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CHwNetworkSettings': tag 'MaxVmNetAdapters' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (MaxHostNetAdapters_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwNetworkSettings': tag 'MaxHostNetAdapters' is absent";
	}



	return 0;
}

void CHwNetworkSettings::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstGlobalNetwork.size(); ++i)
	{
		CHwGlobalNetwork* object = m_lstGlobalNetwork[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void CHwNetworkSettings::Copy(const CHwNetworkSettings& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setMaxVmNetAdapters(rObject.getMaxVmNetAdapters());
	setMaxHostNetAdapters(rObject.getMaxHostNetAdapters());

	ClearList<CHwGlobalNetwork >(m_lstGlobalNetwork);
	for(i = 0; i < rObject.m_lstGlobalNetwork.size(); i++)
		m_lstGlobalNetwork += new CHwGlobalNetwork(rObject.m_lstGlobalNetwork[i]);

	CustomCopy(&rObject);

}

void CHwNetworkSettings::InitLists()
{
	InitList<CHwGlobalNetwork>(1, m_lstGlobalNetwork);
	CustomInit();
}

void CHwNetworkSettings::ClearLists()
{
	ClearList<CHwGlobalNetwork>(m_lstGlobalNetwork);
}

void CHwNetworkSettings::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstGlobalNetwork.size() && ! unite_with_loaded; i++)
	{
		m_lstGlobalNetwork[i]->ClearListsInReadXml();
		m_lstGlobalNetwork[i]->setDefaults();
		m_lstGlobalNetwork[i]->setSectionFakeFlag(true);
	}
}

