////////////////////////////////////////////////////////////////////////////////
///
/// CHwPrinter.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwPrinter.h"


CHwPrinter::CHwPrinter()
{
	InitLists();
	setDefaults();
}

CHwPrinter::CHwPrinter(const CHwPrinter& rObject)
: CHwGenericDevice()
{
	Copy(rObject);
}

CHwPrinter::CHwPrinter(const CHwPrinter* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwPrinter& CHwPrinter::operator=(const CHwPrinter& rObject)
{
	Copy(rObject);
	return *this;
}

CHwPrinter::CHwPrinter(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwPrinter::~CHwPrinter()
{
	ClearLists();
}


bool CHwPrinter::isDefault() const
{
	return m_bDefault;
}

void CHwPrinter::setDefault(bool value)
{
	m_bDefault = value;
}

void CHwPrinter::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setDeviceName();
	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setDeviceId();
	if ( ! RootElement || ! RootElement->firstChildElement("Default").isNull() )
		setDefault();
}

QDomElement CHwPrinter::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Printer") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Default");
	text_element = Document->createTextNode( QString("%1").arg(isDefault()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwPrinter::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Printer") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwPrinter': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Name_count = 0;
	int Uuid_count = 0;
	int Default_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceId(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Default";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Default_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Default")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefault(text_element.data().toInt() != 0);
			--Default_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Name_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwPrinter': tag 'Name' is absent";
	}

	if (Uuid_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwPrinter': tag 'Uuid' is absent";
	}

	if (Default_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwPrinter': tag 'Default' is absent";
	}



	return 0;
}

void CHwPrinter::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void CHwPrinter::Copy(const CHwPrinter& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDeviceName(rObject.getDeviceName());
	setDeviceId(rObject.getDeviceId());
	setDefault(rObject.isDefault());

	CustomCopy(&rObject);

}

void CHwPrinter::InitLists()
{
	CustomInit();
}

void CHwPrinter::ClearLists()
{
}

void CHwPrinter::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

