////////////////////////////////////////////////////////////////////////////////
///
/// CHwUsbDevice.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CHwUsbDevice.h"


CHwUsbDevice::CHwUsbDevice()
{
	InitLists();
	setDefaults();
}

CHwUsbDevice::CHwUsbDevice(const CHwUsbDevice& rObject)
: CHwGenericDevice()
{
	Copy(rObject);
}

CHwUsbDevice::CHwUsbDevice(const CHwUsbDevice* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CHwUsbDevice& CHwUsbDevice::operator=(const CHwUsbDevice& rObject)
{
	Copy(rObject);
	return *this;
}

CHwUsbDevice::CHwUsbDevice(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CHwUsbDevice::~CHwUsbDevice()
{
	ClearLists();
}


PRL_USB_DEVICE_TYPE CHwUsbDevice::getUsbType() const
{
	return m_ctUsbType;
}

void CHwUsbDevice::setUsbType(PRL_USB_DEVICE_TYPE value)
{
	m_ctUsbType = value;
}

void CHwUsbDevice::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setDeviceName();
	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setDeviceId();
	if ( ! RootElement || dyn_lists.contains("VmUuid") )
		setVmUuids();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceState").isNull() )
		setDeviceState(PGS_CONNECTED_TO_HOST);
	if ( ! RootElement || ! RootElement->firstChildElement("UsbType").isNull() )
		setUsbType(PUDT_OTHER);
}

QDomElement CHwUsbDevice::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("UsbDevice") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceId()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "VmUuid";
	for(i = 0; i < m_lstVmUuid.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("VmUuid");
		text_element = Document->createTextNode( QString("%1").arg(m_lstVmUuid[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceState");
	text_element = Document->createTextNode( QString("%1").arg(getDeviceState()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UsbType");
	text_element = Document->createTextNode( QString("%1").arg(getUsbType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CHwUsbDevice::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("UsbDevice") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CHwUsbDevice': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Name_count = 0;
	int Uuid_count = 0;
	int VmUuid_count = 0;
	int DeviceState_count = 0;
	int UsbType_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceId(text_element.data());
			--Uuid_count;
		}


		if (tag_name == "VmUuid")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstVmUuid += text_element.data();
			--VmUuid_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "DeviceState";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceState_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceState")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDeviceState((PRL_GENERIC_DEVICE_STATE )text_element.data().toLongLong());
			--DeviceState_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UsbType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UsbType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UsbType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUsbType((PRL_USB_DEVICE_TYPE )text_element.data().toLongLong());
			--UsbType_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Name_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwUsbDevice': tag 'Name' is absent";
	}

	if (Uuid_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwUsbDevice': tag 'Uuid' is absent";
	}

	if (VmUuid_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwUsbDevice': tag 'VmUuid' is absent";
	}

	if (DeviceState_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwUsbDevice': tag 'DeviceState' is absent";
	}

	if (UsbType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CHwUsbDevice': tag 'UsbType' is absent";
	}



	return 0;
}

void CHwUsbDevice::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void CHwUsbDevice::Copy(const CHwUsbDevice& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDeviceName(rObject.getDeviceName());
	setDeviceId(rObject.getDeviceId());
	setVmUuids(rObject.getVmUuids());
	setDeviceState(rObject.getDeviceState());
	setUsbType(rObject.getUsbType());

	CustomCopy(&rObject);

}

void CHwUsbDevice::InitLists()
{
	CustomInit();
}

void CHwUsbDevice::ClearLists()
{
}

void CHwUsbDevice::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

