////////////////////////////////////////////////////////////////////////////////
///
/// CPSRasterizer.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CPSRasterizer.h"


CPSRasterizer::CPSRasterizer()
{
	InitLists();
	setDefaults();
}

CPSRasterizer::CPSRasterizer(const CPSRasterizer& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CPSRasterizer::CPSRasterizer(const CPSRasterizer* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CPSRasterizer& CPSRasterizer::operator=(const CPSRasterizer& rObject)
{
	Copy(rObject);
	return *this;
}

CPSRasterizer::CPSRasterizer(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CPSRasterizer::~CPSRasterizer()
{
	ClearLists();
}


QString CPSRasterizer::getDescription() const
{
	return m_qsDescription;
}

void CPSRasterizer::setDescription(QString value)
{
	m_qsDescription = value;
}

QString CPSRasterizer::getExecutable() const
{
	return m_qsExecutable;
}

void CPSRasterizer::setExecutable(QString value)
{
	m_qsExecutable = value;
}

void CPSRasterizer::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Description").isNull() )
		setDescription();
	if ( ! RootElement || ! RootElement->firstChildElement("Executable").isNull() )
		setExecutable();
}

QDomElement CPSRasterizer::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("PSRasterizer") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Description");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Executable");
	text_element = Document->createTextNode( QString("%1").arg(getExecutable()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CPSRasterizer::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("PSRasterizer") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CPSRasterizer': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Description_count = 0;
	int Executable_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Description";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Description_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Description")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--Description_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Executable";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Executable_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Executable")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setExecutable(text_element.data());
			--Executable_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Description_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CPSRasterizer': tag 'Description' is absent";
	}

	if (Executable_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CPSRasterizer': tag 'Executable' is absent";
	}



	return 0;
}

void CPSRasterizer::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void CPSRasterizer::Copy(const CPSRasterizer& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setDescription(rObject.getDescription());
	setExecutable(rObject.getExecutable());

	CustomCopy(&rObject);

}

void CPSRasterizer::InitLists()
{
	CustomInit();
}

void CPSRasterizer::ClearLists()
{
}

void CPSRasterizer::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

