////////////////////////////////////////////////////////////////////////////////
///
/// NetworkAdapters.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "NetworkAdapters.h"


NetworkAdapters::NetworkAdapters()
{
	InitLists();
	setDefaults();
}

NetworkAdapters::NetworkAdapters(const NetworkAdapters& rObject)
: CBaseNode()
{
	Copy(rObject);
}

NetworkAdapters::NetworkAdapters(const NetworkAdapters* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

NetworkAdapters& NetworkAdapters::operator=(const NetworkAdapters& rObject)
{
	Copy(rObject);
	return *this;
}

NetworkAdapters::NetworkAdapters(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

NetworkAdapters::~NetworkAdapters()
{
	ClearLists();
}


void NetworkAdapters::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement NetworkAdapters::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkAdapters") : m_qsExtRootTagName);

	dyn_lists += "NetworkAdapter";
	nMaxItemId = getMaxItemId<CHwNetAdapter>(m_lstNetworkAdapter, "NetworkAdapter", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkAdapter.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHwNetAdapter* object = m_lstNetworkAdapter[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "NetworkAdapter", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int NetworkAdapters::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkAdapters") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'NetworkAdapters': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_NetworkAdapter = getMaxItemId2(element, "NetworkAdapter");
	QMap<int , QString > mapNetworkAdapter;
	if (unite_with_loaded)
		fillItemIdMap<CHwNetAdapter>(m_lstNetworkAdapter, mapNetworkAdapter);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int NetworkAdapter_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "NetworkAdapter")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_NetworkAdapter++ : nItemId;
			CHwNetAdapter* object = new CHwNetAdapter();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapNetworkAdapter.contains(nItemId))
				object->fromString(mapNetworkAdapter.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstNetworkAdapter += object;
			--NetworkAdapter_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (NetworkAdapter_count >= 0)
	{
		m_lstWarningList += "Warning in class 'NetworkAdapters': tag 'NetworkAdapter' is absent";
	}

	syncMaxItemId(nMaxItemId_NetworkAdapter, "NetworkAdapter");


	return 0;
}

void NetworkAdapters::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CHwNetAdapter>(m_lstNetworkAdapter, "NetworkAdapter");
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkAdapter.size(); ++i)
	{
		CHwNetAdapter* object = m_lstNetworkAdapter[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "NetworkAdapter");

}

void NetworkAdapters::Copy(const NetworkAdapters& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CHwNetAdapter >(m_lstNetworkAdapter);
	for(i = 0; i < rObject.m_lstNetworkAdapter.size(); i++)
		m_lstNetworkAdapter += new CHwNetAdapter(rObject.m_lstNetworkAdapter[i]);

	CustomCopy(&rObject);

}

void NetworkAdapters::InitLists()
{
	CustomInit();
}

void NetworkAdapters::ClearLists()
{
	ClearList<CHwNetAdapter>(m_lstNetworkAdapter);
}

void NetworkAdapters::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("NetworkAdapter") )
		ClearList<CHwNetAdapter>(m_lstNetworkAdapter);
}

