////////////////////////////////////////////////////////////////////////////////
///
/// SoundDevices.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "SoundDevices.h"


SoundDevices::SoundDevices()
{
	InitLists();
	setDefaults();
}

SoundDevices::SoundDevices(const SoundDevices& rObject)
: CBaseNode()
{
	Copy(rObject);
}

SoundDevices::SoundDevices(const SoundDevices* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

SoundDevices& SoundDevices::operator=(const SoundDevices& rObject)
{
	Copy(rObject);
	return *this;
}

SoundDevices::SoundDevices(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

SoundDevices::~SoundDevices()
{
	ClearLists();
}


OutputDevices* SoundDevices::getOutputDevices() const
{
	if (!m_lstOutputDevices.isEmpty())
	{
		return m_lstOutputDevices[0];
	}
	return 0;
}

void SoundDevices::setOutputDevices(OutputDevices* pOutputDevices)
{
	ClearList<OutputDevices>(m_lstOutputDevices);
	if (pOutputDevices)
	{
		m_lstOutputDevices += pOutputDevices;
	}
}

MixerDevices* SoundDevices::getMixerDevices() const
{
	if (!m_lstMixerDevices.isEmpty())
	{
		return m_lstMixerDevices[0];
	}
	return 0;
}

void SoundDevices::setMixerDevices(MixerDevices* pMixerDevices)
{
	ClearList<MixerDevices>(m_lstMixerDevices);
	if (pMixerDevices)
	{
		m_lstMixerDevices += pMixerDevices;
	}
}

void SoundDevices::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement SoundDevices::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("SoundDevices") : m_qsExtRootTagName);

	for(i = 0; i < m_lstOutputDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const OutputDevices* object = m_lstOutputDevices[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstMixerDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const MixerDevices* object = m_lstMixerDevices[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int SoundDevices::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("SoundDevices") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'SoundDevices': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int OutputDevices_count = 1;
	int MixerDevices_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "OutputDevices" && OutputDevices_count > 0)
		{
			unused_tag = false;
			OutputDevices* object = m_lstOutputDevices[1 - OutputDevices_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--OutputDevices_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "MixerDevices" && MixerDevices_count > 0)
		{
			unused_tag = false;
			MixerDevices* object = m_lstMixerDevices[1 - MixerDevices_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--MixerDevices_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (OutputDevices_count >= 1)
	{
		m_lstWarningList += "Warning in class 'SoundDevices': tag 'OutputDevices' is absent";
	}

	if (MixerDevices_count >= 1)
	{
		m_lstWarningList += "Warning in class 'SoundDevices': tag 'MixerDevices' is absent";
	}



	return 0;
}

void SoundDevices::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstOutputDevices.size(); ++i)
	{
		OutputDevices* object = m_lstOutputDevices[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

	for(i = 0; i < m_lstMixerDevices.size(); ++i)
	{
		MixerDevices* object = m_lstMixerDevices[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void SoundDevices::Copy(const SoundDevices& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<OutputDevices >(m_lstOutputDevices);
	for(i = 0; i < rObject.m_lstOutputDevices.size(); i++)
		m_lstOutputDevices += new OutputDevices(rObject.m_lstOutputDevices[i]);

	ClearList<MixerDevices >(m_lstMixerDevices);
	for(i = 0; i < rObject.m_lstMixerDevices.size(); i++)
		m_lstMixerDevices += new MixerDevices(rObject.m_lstMixerDevices[i]);

	CustomCopy(&rObject);

}

void SoundDevices::InitLists()
{
	InitList<OutputDevices>(1, m_lstOutputDevices);
	InitList<MixerDevices>(1, m_lstMixerDevices);
	CustomInit();
}

void SoundDevices::ClearLists()
{
	ClearList<OutputDevices>(m_lstOutputDevices);
	ClearList<MixerDevices>(m_lstMixerDevices);
}

void SoundDevices::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstOutputDevices.size() && ! unite_with_loaded; i++)
	{
		m_lstOutputDevices[i]->ClearListsInReadXml();
		m_lstOutputDevices[i]->setDefaults();
		m_lstOutputDevices[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstMixerDevices.size() && ! unite_with_loaded; i++)
	{
		m_lstMixerDevices[i]->ClearListsInReadXml();
		m_lstMixerDevices[i]->setDefaults();
		m_lstMixerDevices[i]->setSectionFakeFlag(true);
	}
}

