////////////////////////////////////////////////////////////////////////////////
///
/// CDHCPServer.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CDHCPServer.h"


CDHCPServer::CDHCPServer()
{
	InitLists();
	setDefaults();
}

CDHCPServer::CDHCPServer(const CDHCPServer& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CDHCPServer::CDHCPServer(const CDHCPServer* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CDHCPServer& CDHCPServer::operator=(const CDHCPServer& rObject)
{
	Copy(rObject);
	return *this;
}

CDHCPServer::CDHCPServer(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CDHCPServer::~CDHCPServer()
{
	ClearLists();
}


CIPReservations* CDHCPServer::getIPReservations() const
{
	if (!m_lstIPReservations.isEmpty())
	{
		return m_lstIPReservations[0];
	}
	return 0;
}

void CDHCPServer::setIPReservations(CIPReservations* pIPReservations)
{
	ClearList<CIPReservations>(m_lstIPReservations);
	if (pIPReservations)
	{
		m_lstIPReservations += pIPReservations;
	}
}

bool CDHCPServer::isEnabled() const
{
	return m_bEnabled;
}

void CDHCPServer::setEnabled(bool value)
{
	m_bEnabled = value;
}

QHostAddress CDHCPServer::getIPScopeStart() const
{
	return m_haIPScopeStart;
}

void CDHCPServer::setIPScopeStart(QHostAddress value)
{
	m_haIPScopeStart = value;
}

QHostAddress CDHCPServer::getIPScopeEnd() const
{
	return m_haIPScopeEnd;
}

void CDHCPServer::setIPScopeEnd(QHostAddress value)
{
	m_haIPScopeEnd = value;
}

void CDHCPServer::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("IPScopeStart").isNull() )
		setIPScopeStart();
	if ( ! RootElement || ! RootElement->firstChildElement("IPScopeEnd").isNull() )
		setIPScopeEnd();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< QHostAddress >("QHostAddress");
		qRegisterMetaType< QHostAddress >("QHostAddress");
		first_time = false;
	}

}

QVariant CDHCPServer::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "IPScopeStart.patch_stamp")
		value.setValue(getFieldPatchedValue("IPScopeStart"));

	if (path == "IPScopeStart")
		value.setValue(getIPScopeStart());

	if (path == "IPScopeEnd.patch_stamp")
		value.setValue(getFieldPatchedValue("IPScopeEnd"));

	if (path == "IPScopeEnd")
		value.setValue(getIPScopeEnd());

	list_tag = "IPReservations.";
	if (path.startsWith(list_tag) && ! m_lstIPReservations.isEmpty() && m_lstIPReservations.first())
		return m_lstIPReservations.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CDHCPServer::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "IPScopeStart.patch_stamp")
	{
		markPatchedField("IPScopeStart", value.toString());
		return true;
	}

	if (path == "IPScopeStart")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIPScopeStart() != value.value< QHostAddress >());
		setIPScopeStart(value.value< QHostAddress >());
		return true;
	}

	if (path == "IPScopeEnd.patch_stamp")
	{
		markPatchedField("IPScopeEnd", value.toString());
		return true;
	}

	if (path == "IPScopeEnd")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIPScopeEnd() != value.value< QHostAddress >());
		setIPScopeEnd(value.value< QHostAddress >());
		return true;
	}

	list_tag = "IPReservations.";
	if (path.startsWith(list_tag) && ! m_lstIPReservations.isEmpty() && m_lstIPReservations.first())
		return m_lstIPReservations.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CDHCPServer::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CDHCPServer::getIPScopeStart_id() const
{
	return getFullItemId().isEmpty() ? "IPScopeStart" : getFullItemId() + ".IPScopeStart";
}
QString CDHCPServer::getIPScopeEnd_id() const
{
	return getFullItemId().isEmpty() ? "IPScopeEnd" : getFullItemId() + ".IPScopeEnd";
}

int CDHCPServer::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "IPReservations.";
	if (path.startsWith(list_tag) && ! m_lstIPReservations.isEmpty() && m_lstIPReservations.first())
		return m_lstIPReservations.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CDHCPServer::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "IPReservations.";
	if (path.startsWith(list_tag) && ! m_lstIPReservations.isEmpty() && m_lstIPReservations.first())
		return m_lstIPReservations.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CDHCPServer::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("DHCPServer") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IPScopeStart");
	text_element = Document->createTextNode( QString("%1").arg(getIPScopeStart().toString()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IPScopeEnd");
	text_element = Document->createTextNode( QString("%1").arg(getIPScopeEnd().toString()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstIPReservations.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CIPReservations* object = m_lstIPReservations[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CDHCPServer::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("DHCPServer") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CDHCPServer': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int IPReservations_count = 1;
	int Enabled_count = 1;
	int IPScopeStart_count = 1;
	int IPScopeEnd_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IPScopeStart";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IPScopeStart_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IPScopeStart")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIPScopeStart(QHostAddress( text_element.data() ));
			--IPScopeStart_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IPScopeEnd";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IPScopeEnd_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IPScopeEnd")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIPScopeEnd(QHostAddress( text_element.data() ));
			--IPScopeEnd_count;
		}


		if (tag_name == "IPReservations" && IPReservations_count > 0)
		{
			unused_tag = false;
			CIPReservations* object = m_lstIPReservations[1 - IPReservations_count];
			object->makeFullItemId(getFullItemId(), "IPReservations");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--IPReservations_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (IPReservations_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CDHCPServer': tag 'IPReservations' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDHCPServer': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (IPScopeStart_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDHCPServer': tag 'IPScopeStart' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (IPScopeEnd_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CDHCPServer': tag 'IPScopeEnd' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void CDHCPServer::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstIPReservations.size(); ++i)
	{
		CIPReservations* object = m_lstIPReservations[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "IPReservations");
		object->syncItemIds();
	}

}

bool CDHCPServer::merge(CDHCPServer* pCur, CDHCPServer* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "DHCPServer";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getIPScopeStart() != pCur->getIPScopeStart() && getIPScopeStart() == pPrev->getIPScopeStart())
		setIPScopeStart(pCur->getIPScopeStart());
	else if (getIPScopeStart() != pCur->getIPScopeStart() && getIPScopeStart() != pPrev->getIPScopeStart() && pCur->getIPScopeStart() != pPrev->getIPScopeStart())
	{
		m_qsErrorMessage += ".IPScopeStart";
		return false;
	}

	if (getIPScopeEnd() != pCur->getIPScopeEnd() && getIPScopeEnd() == pPrev->getIPScopeEnd())
		setIPScopeEnd(pCur->getIPScopeEnd());
	else if (getIPScopeEnd() != pCur->getIPScopeEnd() && getIPScopeEnd() != pPrev->getIPScopeEnd() && pCur->getIPScopeEnd() != pPrev->getIPScopeEnd())
	{
		m_qsErrorMessage += ".IPScopeEnd";
		return false;
	}

	for(i = 0; i < m_lstIPReservations.size(); i++)
	{
		if ( m_lstIPReservations[i]->merge(pCur->m_lstIPReservations[i], pPrev->m_lstIPReservations[i], nOptions) ) continue;
		QString qsIdx = (m_lstIPReservations.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstIPReservations[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CDHCPServer::diff(const CDHCPServer* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getIPScopeStart() != pOld->getIPScopeStart())
		lstDiffFullItemIds += getIPScopeStart_id();

	if (getIPScopeEnd() != pOld->getIPScopeEnd())
		lstDiffFullItemIds += getIPScopeEnd_id();

	for(i = 0; i < m_lstIPReservations.size(); ++i)
		m_lstIPReservations[i]->diff(pOld->m_lstIPReservations[i], lstDiffFullItemIds);

}

void CDHCPServer::Copy(const CDHCPServer& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());
	setIPScopeStart(rObject.getIPScopeStart());
	setIPScopeEnd(rObject.getIPScopeEnd());

	ClearList<CIPReservations >(m_lstIPReservations);
	for(i = 0; i < rObject.m_lstIPReservations.size(); i++)
		m_lstIPReservations += new CIPReservations(rObject.m_lstIPReservations[i]);

	CustomCopy(&rObject);

}

void CDHCPServer::InitLists()
{
	InitList<CIPReservations>(1, m_lstIPReservations);
	CustomInit();
}

void CDHCPServer::ClearLists()
{
	ClearList<CIPReservations>(m_lstIPReservations);
}

void CDHCPServer::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstIPReservations.size() && ! unite_with_loaded; i++)
	{
		m_lstIPReservations[i]->ClearListsInReadXml();
		m_lstIPReservations[i]->setDefaults();
		m_lstIPReservations[i]->setSectionFakeFlag(true);
	}
}

