////////////////////////////////////////////////////////////////////////////////
///
/// CHostOnlyNetwork.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CHOSTONLYNETWORK_H
#define CHOSTONLYNETWORK_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CParallelsAdapter.h"
#include "CDHCPServer.h"
#include "CDHCPServer.h"
#include "CNATServer.h"


class CHostOnlyNetwork : public CBaseNode
{

public:

	CHostOnlyNetwork();
	CHostOnlyNetwork(const CHostOnlyNetwork& rObject);
	CHostOnlyNetwork(const CHostOnlyNetwork* pObject);
	CHostOnlyNetwork(QFile* pFile);
	CHostOnlyNetwork& operator=(const CHostOnlyNetwork& rObject);
	virtual ~CHostOnlyNetwork();


	virtual void CustomInit()
	{
		getDHCPv6Server()->setExtRootTagName("DHCPv6Server");
		getDHCPv6Server()->setIPScopeStart( QHostAddress(XML_DEFAULT_IP6_ADDRESS) );
		getDHCPv6Server()->setIPScopeEnd( QHostAddress(XML_DEFAULT_IP6_ADDRESS) );
	}


	void setDHCPv6Server(CDHCPServer* pDHCPv6Server)
	{
		if (pDHCPv6Server)
			pDHCPv6Server->setExtRootTagName("DHCPv6Server");
		setDHCPv6ServerOrig(pDHCPv6Server);
	}
	CDHCPServer* getDHCPv6Server() const
	{
		return getDHCPv6ServerOrig();
	}

	QList<CParallelsAdapter* >		m_lstParallelsAdapter;
	QList<CDHCPServer* >		m_lstDHCPServer;
	QList<CDHCPServer* >		m_lstDHCPv6Server;
	QList<CNATServer* >		m_lstNATServer;

	CParallelsAdapter* getParallelsAdapter() const;
	void setParallelsAdapter(CParallelsAdapter* pParallelsAdapter);

	CDHCPServer* getDHCPServer() const;
	void setDHCPServer(CDHCPServer* pDHCPServer);

	CDHCPServer* getDHCPv6ServerOrig() const;
	void setDHCPv6ServerOrig(CDHCPServer* pDHCPv6Server);

	CNATServer* getNATServer() const;
	void setNATServer(CNATServer* pNATServer);


	QHostAddress getHostIPAddress() const;
	void setHostIPAddress(QHostAddress value = QHostAddress(XML_DEFAULT_IP_ADDRESS));

	QHostAddress getDhcpIPAddress() const;
	void setDhcpIPAddress(QHostAddress value = QHostAddress(XML_DEFAULT_IP_ADDRESS));

	QHostAddress getIPNetMask() const;
	void setIPNetMask(QHostAddress value = QHostAddress(XML_DEFAULT_SUBNET_MASK));

	QHostAddress getHostIP6Address() const;
	void setHostIP6Address(QHostAddress value = QHostAddress(XML_DEFAULT_IP6_ADDRESS));

	QHostAddress getDhcpIP6Address() const;
	void setDhcpIP6Address(QHostAddress value = QHostAddress(XML_DEFAULT_IP6_ADDRESS));

	QHostAddress getIP6NetMask() const;
	void setIP6NetMask(QHostAddress value = QHostAddress(XML_DEFAULT_IP6_MASK));

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getHostIPAddress_id() const;
	QString getDhcpIPAddress_id() const;
	QString getIPNetMask_id() const;
	QString getHostIP6Address_id() const;
	QString getDhcpIP6Address_id() const;
	QString getIP6NetMask_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CHostOnlyNetwork* pCur, CHostOnlyNetwork* pPrev, MergeOptions nOptions);

	void diff(const CHostOnlyNetwork* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QHostAddress		m_haHostIPAddress;
	QHostAddress		m_haDhcpIPAddress;
	QHostAddress		m_haIPNetMask;
	QHostAddress		m_haHostIP6Address;
	QHostAddress		m_haDhcpIP6Address;
	QHostAddress		m_haIP6NetMask;

	void Copy(const CHostOnlyNetwork& rObject);

};

#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif
#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif
#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif
#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif
#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif
#ifndef DM_219503011
#define DM_219503011
Q_DECLARE_METATYPE(QHostAddress)
#endif


#endif
