////////////////////////////////////////////////////////////////////////////////
///
/// CIPAddressList.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CIPAddressList.h"


CIPAddressList::CIPAddressList()
{
	InitLists();
	setDefaults();
}

CIPAddressList::CIPAddressList(const CIPAddressList& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CIPAddressList::CIPAddressList(const CIPAddressList* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CIPAddressList& CIPAddressList::operator=(const CIPAddressList& rObject)
{
	Copy(rObject);
	return *this;
}

CIPAddressList::CIPAddressList(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CIPAddressList::~CIPAddressList()
{
	ClearLists();
}


QList<QString> CIPAddressList::getIPAddress() const
{
	return m_lstIPAddress;
}

void CIPAddressList::setIPAddress(QList<QString> value)
{
	m_lstIPAddress = value;
}

void CIPAddressList::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || dyn_lists.contains("IPAddress") )
		setIPAddress();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< QList<QString> >("QList<QString>");
		first_time = false;
	}

}

QVariant CIPAddressList::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "IPAddress.patch_stamp")
		value.setValue(getFieldPatchedValue("IPAddress"));

	if (path == "IPAddress")
		value.setValue(getIPAddress());

	return value;
}

bool CIPAddressList::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "IPAddress.patch_stamp")
	{
		markPatchedField("IPAddress", value.toString());
		return true;
	}

	if (path == "IPAddress")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIPAddress() != value.value< QList<QString> >());
		setIPAddress(value.value< QList<QString> >());
		return true;
	}

	return false;
}

QString CIPAddressList::getIPAddress_id() const
{
	return getFullItemId().isEmpty() ? "IPAddress" : getFullItemId() + ".IPAddress";
}

int CIPAddressList::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CIPAddressList::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CIPAddressList::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("IPAddressList") : m_qsExtRootTagName);

	dyn_lists += "IPAddress";
	for(i = 0; i < m_lstIPAddress.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("IPAddress");
		text_element = Document->createTextNode( QString("%1").arg(m_lstIPAddress[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CIPAddressList::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("IPAddressList") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CIPAddressList': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int IPAddress_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		if (tag_name == "IPAddress")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstIPAddress += text_element.data();
			--IPAddress_count;
		}
		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (IPAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CIPAddressList': tag 'IPAddress' is absent";
	}



	return 0;
}

void CIPAddressList::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CIPAddressList::merge(CIPAddressList* pCur, CIPAddressList* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "IPAddressList";

	if (getIPAddress() != pCur->getIPAddress() && getIPAddress() == pPrev->getIPAddress())
		setIPAddress(pCur->getIPAddress());
	else if (getIPAddress() != pCur->getIPAddress() && getIPAddress() != pPrev->getIPAddress() && pCur->getIPAddress() != pPrev->getIPAddress())
	{
		m_qsErrorMessage += ".IPAddress";
		return false;
	}

	return true;
}

void CIPAddressList::diff(const CIPAddressList* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIPAddress() != pOld->getIPAddress())
		lstDiffFullItemIds += getIPAddress_id();

}

void CIPAddressList::Copy(const CIPAddressList& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIPAddress(rObject.getIPAddress());

	CustomCopy(&rObject);

}

void CIPAddressList::InitLists()
{
	CustomInit();
}

void CIPAddressList::ClearLists()
{
}

void CIPAddressList::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

