////////////////////////////////////////////////////////////////////////////////
///
/// CIPAddressMapping.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CIPAddressMapping.h"


CIPAddressMapping::CIPAddressMapping()
{
	InitLists();
	setDefaults();
}

CIPAddressMapping::CIPAddressMapping(const CIPAddressMapping& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CIPAddressMapping::CIPAddressMapping(const CIPAddressMapping* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CIPAddressMapping& CIPAddressMapping::operator=(const CIPAddressMapping& rObject)
{
	Copy(rObject);
	return *this;
}

CIPAddressMapping::CIPAddressMapping(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CIPAddressMapping::~CIPAddressMapping()
{
	ClearLists();
}


CIPAddressList* CIPAddressMapping::getIPAddressList() const
{
	if (!m_lstIPAddressList.isEmpty())
	{
		return m_lstIPAddressList[0];
	}
	return 0;
}

void CIPAddressMapping::setIPAddressList(CIPAddressList* pIPAddressList)
{
	ClearList<CIPAddressList>(m_lstIPAddressList);
	if (pIPAddressList)
	{
		m_lstIPAddressList += pIPAddressList;
	}
}

QString CIPAddressMapping::getInterfaceName() const
{
	return m_qsInterfaceName;
}

void CIPAddressMapping::setInterfaceName(QString value)
{
	m_qsInterfaceName = value;
}

void CIPAddressMapping::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("InterfaceName").isNull() )
		setInterfaceName();
}

QVariant CIPAddressMapping::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "InterfaceName.patch_stamp")
		value.setValue(getFieldPatchedValue("InterfaceName"));

	if (path == "InterfaceName")
		value.setValue(getInterfaceName());

	list_tag = "IPAddressList.";
	if (path.startsWith(list_tag) && ! m_lstIPAddressList.isEmpty() && m_lstIPAddressList.first())
		return m_lstIPAddressList.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CIPAddressMapping::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "InterfaceName.patch_stamp")
	{
		markPatchedField("InterfaceName", value.toString());
		return true;
	}

	if (path == "InterfaceName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getInterfaceName() != value.value< QString >());
		setInterfaceName(value.value< QString >());
		return true;
	}

	list_tag = "IPAddressList.";
	if (path.startsWith(list_tag) && ! m_lstIPAddressList.isEmpty() && m_lstIPAddressList.first())
		return m_lstIPAddressList.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CIPAddressMapping::getInterfaceName_id() const
{
	return getFullItemId().isEmpty() ? "InterfaceName" : getFullItemId() + ".InterfaceName";
}

int CIPAddressMapping::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "IPAddressList.";
	if (path.startsWith(list_tag) && ! m_lstIPAddressList.isEmpty() && m_lstIPAddressList.first())
		return m_lstIPAddressList.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CIPAddressMapping::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "IPAddressList.";
	if (path.startsWith(list_tag) && ! m_lstIPAddressList.isEmpty() && m_lstIPAddressList.first())
		return m_lstIPAddressList.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CIPAddressMapping::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("IPAddressMapping") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("InterfaceName");
	text_element = Document->createTextNode( QString("%1").arg(getInterfaceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "IPAddressList";
	nMaxItemId = getMaxItemId<CIPAddressList>(m_lstIPAddressList, "IPAddressList", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstIPAddressList.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CIPAddressList* object = m_lstIPAddressList[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "IPAddressList", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CIPAddressMapping::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("IPAddressMapping") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CIPAddressMapping': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_IPAddressList = getMaxItemId2(element, "IPAddressList");
	QMap<int , QString > mapIPAddressList;
	if (unite_with_loaded)
		fillItemIdMap<CIPAddressList>(m_lstIPAddressList, mapIPAddressList);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int IPAddressList_count = 1;
	int InterfaceName_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "InterfaceName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (InterfaceName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "InterfaceName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setInterfaceName(text_element.data());
			--InterfaceName_count;
		}


		if (tag_name == "IPAddressList")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_IPAddressList++ : nItemId;
			CIPAddressList* object = new CIPAddressList();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "IPAddressList", object->getItemId());
			if (unite_with_loaded && mapIPAddressList.contains(nItemId))
				object->fromString(mapIPAddressList.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstIPAddressList += object;
			--IPAddressList_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (IPAddressList_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CIPAddressMapping': tag 'IPAddressList' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (InterfaceName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CIPAddressMapping': tag 'InterfaceName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_IPAddressList, "IPAddressList");


	return 0;
}

void CIPAddressMapping::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CIPAddressList>(m_lstIPAddressList, "IPAddressList");
	setItemIds.clear();
	for(i = 0; i < m_lstIPAddressList.size(); ++i)
	{
		CIPAddressList* object = m_lstIPAddressList[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "IPAddressList", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "IPAddressList");

}

bool CIPAddressMapping::merge(CIPAddressMapping* pCur, CIPAddressMapping* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "IPAddressMapping";

	if (getInterfaceName() != pCur->getInterfaceName() && getInterfaceName() == pPrev->getInterfaceName())
		setInterfaceName(pCur->getInterfaceName());
	else if (getInterfaceName() != pCur->getInterfaceName() && getInterfaceName() != pPrev->getInterfaceName() && pCur->getInterfaceName() != pPrev->getInterfaceName())
	{
		m_qsErrorMessage += ".InterfaceName";
		return false;
	}

	if ( ! mergeList<CIPAddressList>(m_lstIPAddressList, pCur->m_lstIPAddressList, pPrev->m_lstIPAddressList, "IPAddressList", nOptions) )
		return false;

	return true;
}

void CIPAddressMapping::diff(const CIPAddressMapping* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getInterfaceName() != pOld->getInterfaceName())
		lstDiffFullItemIds += getInterfaceName_id();

	diffList<CIPAddressList>(m_lstIPAddressList, pOld->m_lstIPAddressList, lstDiffFullItemIds);

}

void CIPAddressMapping::Copy(const CIPAddressMapping& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setInterfaceName(rObject.getInterfaceName());

	ClearList<CIPAddressList >(m_lstIPAddressList);
	for(i = 0; i < rObject.m_lstIPAddressList.size(); i++)
		m_lstIPAddressList += new CIPAddressList(rObject.m_lstIPAddressList[i]);

	CustomCopy(&rObject);

}

void CIPAddressMapping::InitLists()
{
	InitList<CIPAddressList>(1, m_lstIPAddressList);
	CustomInit();
}

void CIPAddressMapping::ClearLists()
{
	ClearList<CIPAddressList>(m_lstIPAddressList);
}

void CIPAddressMapping::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("IPAddressList") )
		ClearList<CIPAddressList>(m_lstIPAddressList);
}

