////////////////////////////////////////////////////////////////////////////////
///
/// CNATServer.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CNATServer.h"


CNATServer::CNATServer()
{
	InitLists();
	setDefaults();
}

CNATServer::CNATServer(const CNATServer& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CNATServer::CNATServer(const CNATServer* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CNATServer& CNATServer::operator=(const CNATServer& rObject)
{
	Copy(rObject);
	return *this;
}

CNATServer::CNATServer(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CNATServer::~CNATServer()
{
	ClearLists();
}


CPortForwarding* CNATServer::getPortForwarding() const
{
	if (!m_lstPortForwarding.isEmpty())
	{
		return m_lstPortForwarding[0];
	}
	return 0;
}

void CNATServer::setPortForwarding(CPortForwarding* pPortForwarding)
{
	ClearList<CPortForwarding>(m_lstPortForwarding);
	if (pPortForwarding)
	{
		m_lstPortForwarding += pPortForwarding;
	}
}

bool CNATServer::isEnabled() const
{
	return m_bEnabled;
}

void CNATServer::setEnabled(bool value)
{
	m_bEnabled = value;
}

unsigned int CNATServer::getIdleConnectionTimeoutSecs() const
{
	return m_uiIdleConnectionTimeoutSecs;
}

void CNATServer::setIdleConnectionTimeoutSecs(unsigned int value)
{
	m_uiIdleConnectionTimeoutSecs = value;
}

bool CNATServer::isUseIPFilter() const
{
	return m_bUseIPFilter;
}

void CNATServer::setUseIPFilter(bool value)
{
	m_bUseIPFilter = value;
}

void CNATServer::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("IdleConnectionTimeoutSecs").isNull() )
		setIdleConnectionTimeoutSecs();
	if ( ! RootElement || ! RootElement->firstChildElement("UseIPFilter").isNull() )
		setUseIPFilter();
}

QVariant CNATServer::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "IdleConnectionTimeoutSecs.patch_stamp")
		value.setValue(getFieldPatchedValue("IdleConnectionTimeoutSecs"));

	if (path == "IdleConnectionTimeoutSecs")
		value.setValue(getIdleConnectionTimeoutSecs());

	if (path == "UseIPFilter.patch_stamp")
		value.setValue(getFieldPatchedValue("UseIPFilter"));

	if (path == "UseIPFilter")
		value.setValue(isUseIPFilter());

	list_tag = "PortForwarding.";
	if (path.startsWith(list_tag) && ! m_lstPortForwarding.isEmpty() && m_lstPortForwarding.first())
		return m_lstPortForwarding.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CNATServer::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "IdleConnectionTimeoutSecs.patch_stamp")
	{
		markPatchedField("IdleConnectionTimeoutSecs", value.toString());
		return true;
	}

	if (path == "IdleConnectionTimeoutSecs")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIdleConnectionTimeoutSecs() != value.value< unsigned int >());
		setIdleConnectionTimeoutSecs(value.value< unsigned int >());
		return true;
	}

	if (path == "UseIPFilter.patch_stamp")
	{
		markPatchedField("UseIPFilter", value.toString());
		return true;
	}

	if (path == "UseIPFilter")
	{
		if (pbValueChanged)
			*pbValueChanged = (isUseIPFilter() != value.value< bool >());
		setUseIPFilter(value.value< bool >());
		return true;
	}

	list_tag = "PortForwarding.";
	if (path.startsWith(list_tag) && ! m_lstPortForwarding.isEmpty() && m_lstPortForwarding.first())
		return m_lstPortForwarding.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CNATServer::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CNATServer::getIdleConnectionTimeoutSecs_id() const
{
	return getFullItemId().isEmpty() ? "IdleConnectionTimeoutSecs" : getFullItemId() + ".IdleConnectionTimeoutSecs";
}
QString CNATServer::getUseIPFilter_id() const
{
	return getFullItemId().isEmpty() ? "UseIPFilter" : getFullItemId() + ".UseIPFilter";
}

int CNATServer::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "PortForwarding.";
	if (path.startsWith(list_tag) && ! m_lstPortForwarding.isEmpty() && m_lstPortForwarding.first())
		return m_lstPortForwarding.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CNATServer::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "PortForwarding.";
	if (path.startsWith(list_tag) && ! m_lstPortForwarding.isEmpty() && m_lstPortForwarding.first())
		return m_lstPortForwarding.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CNATServer::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NATServer") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstPortForwarding.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CPortForwarding* object = m_lstPortForwarding[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IdleConnectionTimeoutSecs");
	text_element = Document->createTextNode( QString("%1").arg(getIdleConnectionTimeoutSecs()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UseIPFilter");
	text_element = Document->createTextNode( QString("%1").arg(isUseIPFilter()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CNATServer::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NATServer") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CNATServer': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int PortForwarding_count = 1;
	int Enabled_count = 1;
	int IdleConnectionTimeoutSecs_count = 0;
	int UseIPFilter_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IdleConnectionTimeoutSecs";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IdleConnectionTimeoutSecs_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IdleConnectionTimeoutSecs")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIdleConnectionTimeoutSecs(text_element.data().toUInt());
			--IdleConnectionTimeoutSecs_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UseIPFilter";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UseIPFilter_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UseIPFilter")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUseIPFilter(text_element.data().toInt() != 0);
			--UseIPFilter_count;
		}


		if (tag_name == "PortForwarding" && PortForwarding_count > 0)
		{
			unused_tag = false;
			CPortForwarding* object = m_lstPortForwarding[1 - PortForwarding_count];
			object->makeFullItemId(getFullItemId(), "PortForwarding");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--PortForwarding_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (PortForwarding_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CNATServer': tag 'PortForwarding' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CNATServer': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (IdleConnectionTimeoutSecs_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CNATServer': tag 'IdleConnectionTimeoutSecs' is absent";
	}

	if (UseIPFilter_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CNATServer': tag 'UseIPFilter' is absent";
	}



	return 0;
}

void CNATServer::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstPortForwarding.size(); ++i)
	{
		CPortForwarding* object = m_lstPortForwarding[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "PortForwarding");
		object->syncItemIds();
	}

}

bool CNATServer::merge(CNATServer* pCur, CNATServer* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "NATServer";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getIdleConnectionTimeoutSecs() != pCur->getIdleConnectionTimeoutSecs() && getIdleConnectionTimeoutSecs() == pPrev->getIdleConnectionTimeoutSecs())
		setIdleConnectionTimeoutSecs(pCur->getIdleConnectionTimeoutSecs());
	else if (getIdleConnectionTimeoutSecs() != pCur->getIdleConnectionTimeoutSecs() && getIdleConnectionTimeoutSecs() != pPrev->getIdleConnectionTimeoutSecs() && pCur->getIdleConnectionTimeoutSecs() != pPrev->getIdleConnectionTimeoutSecs())
	{
		m_qsErrorMessage += ".IdleConnectionTimeoutSecs";
		return false;
	}

	if (isUseIPFilter() != pCur->isUseIPFilter() && isUseIPFilter() == pPrev->isUseIPFilter())
		setUseIPFilter(pCur->isUseIPFilter());
	else if (isUseIPFilter() != pCur->isUseIPFilter() && isUseIPFilter() != pPrev->isUseIPFilter() && pCur->isUseIPFilter() != pPrev->isUseIPFilter())
	{
		m_qsErrorMessage += ".UseIPFilter";
		return false;
	}

	for(i = 0; i < m_lstPortForwarding.size(); i++)
	{
		if ( m_lstPortForwarding[i]->merge(pCur->m_lstPortForwarding[i], pPrev->m_lstPortForwarding[i], nOptions) ) continue;
		QString qsIdx = (m_lstPortForwarding.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstPortForwarding[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CNATServer::diff(const CNATServer* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getIdleConnectionTimeoutSecs() != pOld->getIdleConnectionTimeoutSecs())
		lstDiffFullItemIds += getIdleConnectionTimeoutSecs_id();

	if (isUseIPFilter() != pOld->isUseIPFilter())
		lstDiffFullItemIds += getUseIPFilter_id();

	for(i = 0; i < m_lstPortForwarding.size(); ++i)
		m_lstPortForwarding[i]->diff(pOld->m_lstPortForwarding[i], lstDiffFullItemIds);

}

void CNATServer::Copy(const CNATServer& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());
	setIdleConnectionTimeoutSecs(rObject.getIdleConnectionTimeoutSecs());
	setUseIPFilter(rObject.isUseIPFilter());

	ClearList<CPortForwarding >(m_lstPortForwarding);
	for(i = 0; i < rObject.m_lstPortForwarding.size(); i++)
		m_lstPortForwarding += new CPortForwarding(rObject.m_lstPortForwarding[i]);

	CustomCopy(&rObject);

}

void CNATServer::InitLists()
{
	InitList<CPortForwarding>(1, m_lstPortForwarding);
	CustomInit();
}

void CNATServer::ClearLists()
{
	ClearList<CPortForwarding>(m_lstPortForwarding);
}

void CNATServer::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstPortForwarding.size() && ! unite_with_loaded; i++)
	{
		m_lstPortForwarding[i]->ClearListsInReadXml();
		m_lstPortForwarding[i]->setDefaults();
		m_lstPortForwarding[i]->setSectionFakeFlag(true);
	}
}

