////////////////////////////////////////////////////////////////////////////////
///
/// CNetworkShapingConfig.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CNetworkShapingConfig.h"


CNetworkShapingConfig::CNetworkShapingConfig()
{
	InitLists();
	setDefaults();
}

CNetworkShapingConfig::CNetworkShapingConfig(const CNetworkShapingConfig& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CNetworkShapingConfig::CNetworkShapingConfig(const CNetworkShapingConfig* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CNetworkShapingConfig& CNetworkShapingConfig::operator=(const CNetworkShapingConfig& rObject)
{
	Copy(rObject);
	return *this;
}

CNetworkShapingConfig::CNetworkShapingConfig(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CNetworkShapingConfig::~CNetworkShapingConfig()
{
	ClearLists();
}


bool CNetworkShapingConfig::isEnabled() const
{
	return m_bEnabled;
}

void CNetworkShapingConfig::setEnabled(bool value)
{
	m_bEnabled = value;
}

void CNetworkShapingConfig::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
}

QVariant CNetworkShapingConfig::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	list_tag = "DeviceBandwidth[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i] && nItemId == m_lstDevicesBandwidth[i]->getItemId())
				return m_lstDevicesBandwidth[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("DeviceBandwidth.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i] && nMaxId < m_lstDevicesBandwidth[i]->getItemId())
				nMaxId = m_lstDevicesBandwidth[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("DeviceBandwidth.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i]) lstIds += m_lstDevicesBandwidth[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "NetworkShaping[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i] && nItemId == m_lstNetworkShaping[i]->getItemId())
				return m_lstNetworkShaping[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("NetworkShaping.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i] && nMaxId < m_lstNetworkShaping[i]->getItemId())
				nMaxId = m_lstNetworkShaping[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("NetworkShaping.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i]) lstIds += m_lstNetworkShaping[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CNetworkShapingConfig::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	list_tag = "DeviceBandwidth[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i] && nItemId == m_lstDevicesBandwidth[i]->getItemId())
				return m_lstDevicesBandwidth[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "NetworkShaping[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i] && nItemId == m_lstNetworkShaping[i]->getItemId())
				return m_lstNetworkShaping[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CNetworkShapingConfig::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}

int CNetworkShapingConfig::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "DeviceBandwidth")
	{
		m_lstDevicesBandwidth += new CDeviceBandwidth;
		nNewItemId = getMaxItemId<CDeviceBandwidth>(m_lstDevicesBandwidth, "DeviceBandwidth");
		m_lstDevicesBandwidth.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "DeviceBandwidth");
	}

	list_tag = "DeviceBandwidth[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i] && nItemId == m_lstDevicesBandwidth[i]->getItemId())
				return m_lstDevicesBandwidth[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "NetworkShaping")
	{
		m_lstNetworkShaping += new CNetworkShaping;
		nNewItemId = getMaxItemId<CNetworkShaping>(m_lstNetworkShaping, "NetworkShaping");
		m_lstNetworkShaping.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "NetworkShaping");
	}

	list_tag = "NetworkShaping[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i] && nItemId == m_lstNetworkShaping[i]->getItemId())
				return m_lstNetworkShaping[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CNetworkShapingConfig::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "DeviceBandwidth[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstDevicesBandwidth.size(); ++i)
			if (m_lstDevicesBandwidth[i] && nItemId == m_lstDevicesBandwidth[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstDevicesBandwidth[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstDevicesBandwidth.takeAt(i);
				return true;
			}
	}

	list_tag = "NetworkShaping[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkShaping.size(); ++i)
			if (m_lstNetworkShaping[i] && nItemId == m_lstNetworkShaping[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstNetworkShaping[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstNetworkShaping.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CNetworkShapingConfig::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkShapingConfig") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "DeviceBandwidth";
	nMaxItemId = getMaxItemId<CDeviceBandwidth>(m_lstDevicesBandwidth, "DeviceBandwidth", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstDevicesBandwidth.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CDeviceBandwidth* object = m_lstDevicesBandwidth[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "DeviceBandwidth", mapMaxDynListIds));

	dyn_lists += "NetworkShaping";
	nMaxItemId = getMaxItemId<CNetworkShaping>(m_lstNetworkShaping, "NetworkShaping", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkShaping.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CNetworkShaping* object = m_lstNetworkShaping[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "NetworkShaping", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CNetworkShapingConfig::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkShapingConfig") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CNetworkShapingConfig': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_DeviceBandwidth = getMaxItemId2(element, "DeviceBandwidth");
	QMap<int , QString > mapDeviceBandwidth;
	if (unite_with_loaded)
		fillItemIdMap<CDeviceBandwidth>(m_lstDevicesBandwidth, mapDeviceBandwidth);
	int nMaxItemId_NetworkShaping = getMaxItemId2(element, "NetworkShaping");
	QMap<int , QString > mapNetworkShaping;
	if (unite_with_loaded)
		fillItemIdMap<CNetworkShaping>(m_lstNetworkShaping, mapNetworkShaping);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int DevicesBandwidth_count = 0;
	int NetworkShaping_count = 0;
	int Enabled_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		if (tag_name == "DeviceBandwidth")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_DeviceBandwidth++ : nItemId;
			CDeviceBandwidth* object = new CDeviceBandwidth();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "DeviceBandwidth", object->getItemId());
			if (unite_with_loaded && mapDeviceBandwidth.contains(nItemId))
				object->fromString(mapDeviceBandwidth.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstDevicesBandwidth += object;
			--DevicesBandwidth_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "NetworkShaping")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_NetworkShaping++ : nItemId;
			CNetworkShaping* object = new CNetworkShaping();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "NetworkShaping", object->getItemId());
			if (unite_with_loaded && mapNetworkShaping.contains(nItemId))
				object->fromString(mapNetworkShaping.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstNetworkShaping += object;
			--NetworkShaping_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (DevicesBandwidth_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CNetworkShapingConfig': tag 'DeviceBandwidth' is absent";
	}

	if (NetworkShaping_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CNetworkShapingConfig': tag 'NetworkShaping' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CNetworkShapingConfig': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_DeviceBandwidth, "DeviceBandwidth");
	syncMaxItemId(nMaxItemId_NetworkShaping, "NetworkShaping");


	return 0;
}

void CNetworkShapingConfig::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CDeviceBandwidth>(m_lstDevicesBandwidth, "DeviceBandwidth");
	setItemIds.clear();
	for(i = 0; i < m_lstDevicesBandwidth.size(); ++i)
	{
		CDeviceBandwidth* object = m_lstDevicesBandwidth[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "DeviceBandwidth", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "DeviceBandwidth");

	nMaxItemId = getMaxItemId<CNetworkShaping>(m_lstNetworkShaping, "NetworkShaping");
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkShaping.size(); ++i)
	{
		CNetworkShaping* object = m_lstNetworkShaping[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "NetworkShaping", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "NetworkShaping");

}

bool CNetworkShapingConfig::merge(CNetworkShapingConfig* pCur, CNetworkShapingConfig* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "NetworkShapingConfig";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if ( ! mergeList<CDeviceBandwidth>(m_lstDevicesBandwidth, pCur->m_lstDevicesBandwidth, pPrev->m_lstDevicesBandwidth, "DeviceBandwidth", nOptions) )
		return false;

	if ( ! mergeList<CNetworkShaping>(m_lstNetworkShaping, pCur->m_lstNetworkShaping, pPrev->m_lstNetworkShaping, "NetworkShaping", nOptions) )
		return false;

	return true;
}

void CNetworkShapingConfig::diff(const CNetworkShapingConfig* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	diffList<CDeviceBandwidth>(m_lstDevicesBandwidth, pOld->m_lstDevicesBandwidth, lstDiffFullItemIds);

	diffList<CNetworkShaping>(m_lstNetworkShaping, pOld->m_lstNetworkShaping, lstDiffFullItemIds);

}

void CNetworkShapingConfig::Copy(const CNetworkShapingConfig& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());

	ClearList<CDeviceBandwidth >(m_lstDevicesBandwidth);
	for(i = 0; i < rObject.m_lstDevicesBandwidth.size(); i++)
		m_lstDevicesBandwidth += new CDeviceBandwidth(rObject.m_lstDevicesBandwidth[i]);

	ClearList<CNetworkShaping >(m_lstNetworkShaping);
	for(i = 0; i < rObject.m_lstNetworkShaping.size(); i++)
		m_lstNetworkShaping += new CNetworkShaping(rObject.m_lstNetworkShaping[i]);

	CustomCopy(&rObject);

}

void CNetworkShapingConfig::InitLists()
{
	CustomInit();
}

void CNetworkShapingConfig::ClearLists()
{
	ClearList<CDeviceBandwidth>(m_lstDevicesBandwidth);
	ClearList<CNetworkShaping>(m_lstNetworkShaping);
}

void CNetworkShapingConfig::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("DeviceBandwidth") )
		ClearList<CDeviceBandwidth>(m_lstDevicesBandwidth);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("NetworkShaping") )
		ClearList<CNetworkShaping>(m_lstNetworkShaping);
}

