////////////////////////////////////////////////////////////////////////////////
///
/// CPortForwarding.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CPortForwarding.h"


CPortForwarding::CPortForwarding()
{
	InitLists();
	setDefaults();
}

CPortForwarding::CPortForwarding(const CPortForwarding& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CPortForwarding::CPortForwarding(const CPortForwarding* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CPortForwarding& CPortForwarding::operator=(const CPortForwarding& rObject)
{
	Copy(rObject);
	return *this;
}

CPortForwarding::CPortForwarding(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CPortForwarding::~CPortForwarding()
{
	ClearLists();
}


CTCPForwardsList* CPortForwarding::getTCP() const
{
	if (!m_lstTCP.isEmpty())
	{
		return m_lstTCP[0];
	}
	return 0;
}

void CPortForwarding::setTCP(CTCPForwardsList* pTCP)
{
	ClearList<CTCPForwardsList>(m_lstTCP);
	if (pTCP)
	{
		m_lstTCP += pTCP;
	}
}

CUDPForwardsList* CPortForwarding::getUDP() const
{
	if (!m_lstUDP.isEmpty())
	{
		return m_lstUDP[0];
	}
	return 0;
}

void CPortForwarding::setUDP(CUDPForwardsList* pUDP)
{
	ClearList<CUDPForwardsList>(m_lstUDP);
	if (pUDP)
	{
		m_lstUDP += pUDP;
	}
}

void CPortForwarding::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant CPortForwarding::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "TCP.";
	if (path.startsWith(list_tag) && ! m_lstTCP.isEmpty() && m_lstTCP.first())
		return m_lstTCP.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "UDP.";
	if (path.startsWith(list_tag) && ! m_lstUDP.isEmpty() && m_lstUDP.first())
		return m_lstUDP.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CPortForwarding::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "TCP.";
	if (path.startsWith(list_tag) && ! m_lstTCP.isEmpty() && m_lstTCP.first())
		return m_lstTCP.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "UDP.";
	if (path.startsWith(list_tag) && ! m_lstUDP.isEmpty() && m_lstUDP.first())
		return m_lstUDP.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

int CPortForwarding::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "TCP.";
	if (path.startsWith(list_tag) && ! m_lstTCP.isEmpty() && m_lstTCP.first())
		return m_lstTCP.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "UDP.";
	if (path.startsWith(list_tag) && ! m_lstUDP.isEmpty() && m_lstUDP.first())
		return m_lstUDP.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CPortForwarding::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "TCP.";
	if (path.startsWith(list_tag) && ! m_lstTCP.isEmpty() && m_lstTCP.first())
		return m_lstTCP.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "UDP.";
	if (path.startsWith(list_tag) && ! m_lstUDP.isEmpty() && m_lstUDP.first())
		return m_lstUDP.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CPortForwarding::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("PortForwarding") : m_qsExtRootTagName);

	for(i = 0; i < m_lstTCP.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CTCPForwardsList* object = m_lstTCP[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstUDP.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CUDPForwardsList* object = m_lstUDP[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CPortForwarding::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("PortForwarding") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CPortForwarding': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int TCP_count = 1;
	int UDP_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "TCP" && TCP_count > 0)
		{
			unused_tag = false;
			CTCPForwardsList* object = m_lstTCP[1 - TCP_count];
			object->makeFullItemId(getFullItemId(), "TCP");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--TCP_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "UDP" && UDP_count > 0)
		{
			unused_tag = false;
			CUDPForwardsList* object = m_lstUDP[1 - UDP_count];
			object->makeFullItemId(getFullItemId(), "UDP");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--UDP_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (TCP_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CPortForwarding': tag 'TCP' is absent";
	}

	if (UDP_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CPortForwarding': tag 'UDP' is absent";
	}



	return 0;
}

void CPortForwarding::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstTCP.size(); ++i)
	{
		CTCPForwardsList* object = m_lstTCP[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "TCP");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstUDP.size(); ++i)
	{
		CUDPForwardsList* object = m_lstUDP[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "UDP");
		object->syncItemIds();
	}

}

bool CPortForwarding::merge(CPortForwarding* pCur, CPortForwarding* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "PortForwarding";

	for(i = 0; i < m_lstTCP.size(); i++)
	{
		if ( m_lstTCP[i]->merge(pCur->m_lstTCP[i], pPrev->m_lstTCP[i], nOptions) ) continue;
		QString qsIdx = (m_lstTCP.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstTCP[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstUDP.size(); i++)
	{
		if ( m_lstUDP[i]->merge(pCur->m_lstUDP[i], pPrev->m_lstUDP[i], nOptions) ) continue;
		QString qsIdx = (m_lstUDP.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstUDP[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CPortForwarding::diff(const CPortForwarding* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	for(i = 0; i < m_lstTCP.size(); ++i)
		m_lstTCP[i]->diff(pOld->m_lstTCP[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstUDP.size(); ++i)
		m_lstUDP[i]->diff(pOld->m_lstUDP[i], lstDiffFullItemIds);

}

void CPortForwarding::Copy(const CPortForwarding& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CTCPForwardsList >(m_lstTCP);
	for(i = 0; i < rObject.m_lstTCP.size(); i++)
		m_lstTCP += new CTCPForwardsList(rObject.m_lstTCP[i]);

	ClearList<CUDPForwardsList >(m_lstUDP);
	for(i = 0; i < rObject.m_lstUDP.size(); i++)
		m_lstUDP += new CUDPForwardsList(rObject.m_lstUDP[i]);

	CustomCopy(&rObject);

}

void CPortForwarding::InitLists()
{
	InitList<CTCPForwardsList>(1, m_lstTCP);
	InitList<CUDPForwardsList>(1, m_lstUDP);
	CustomInit();
}

void CPortForwarding::ClearLists()
{
	ClearList<CTCPForwardsList>(m_lstTCP);
	ClearList<CUDPForwardsList>(m_lstUDP);
}

void CPortForwarding::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstTCP.size() && ! unite_with_loaded; i++)
	{
		m_lstTCP[i]->ClearListsInReadXml();
		m_lstTCP[i]->setDefaults();
		m_lstTCP[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstUDP.size() && ! unite_with_loaded; i++)
	{
		m_lstUDP[i]->ClearListsInReadXml();
		m_lstUDP[i]->setDefaults();
		m_lstUDP[i]->setSectionFakeFlag(true);
	}
}

