////////////////////////////////////////////////////////////////////////////////
///
/// CVZVirtualNetwork.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVZVirtualNetwork.h"


CVZVirtualNetwork::CVZVirtualNetwork()
{
	InitLists();
	setDefaults();
}

CVZVirtualNetwork::CVZVirtualNetwork(const CVZVirtualNetwork& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CVZVirtualNetwork::CVZVirtualNetwork(const CVZVirtualNetwork* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVZVirtualNetwork& CVZVirtualNetwork::operator=(const CVZVirtualNetwork& rObject)
{
	Copy(rObject);
	return *this;
}

CVZVirtualNetwork::CVZVirtualNetwork(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVZVirtualNetwork::~CVZVirtualNetwork()
{
	ClearLists();
}


CSlaveInterfaces* CVZVirtualNetwork::getSlaveInterfaces() const
{
	if (!m_lstSlaveInterfaces.isEmpty())
	{
		return m_lstSlaveInterfaces[0];
	}
	return 0;
}

void CVZVirtualNetwork::setSlaveInterfaces(CSlaveInterfaces* pSlaveInterfaces)
{
	ClearList<CSlaveInterfaces>(m_lstSlaveInterfaces);
	if (pSlaveInterfaces)
	{
		m_lstSlaveInterfaces += pSlaveInterfaces;
	}
}

QString CVZVirtualNetwork::getBridgeName() const
{
	return m_qsBridgeName;
}

void CVZVirtualNetwork::setBridgeName(QString value)
{
	m_qsBridgeName = value;
}

QString CVZVirtualNetwork::getMasterInterface() const
{
	return m_qsMasterInterface;
}

void CVZVirtualNetwork::setMasterInterface(QString value)
{
	m_qsMasterInterface = value;
}

void CVZVirtualNetwork::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("BridgeName").isNull() )
		setBridgeName();
	if ( ! RootElement || ! RootElement->firstChildElement("MasterInterface").isNull() )
		setMasterInterface();
}

QVariant CVZVirtualNetwork::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "BridgeName.patch_stamp")
		value.setValue(getFieldPatchedValue("BridgeName"));

	if (path == "BridgeName")
		value.setValue(getBridgeName());

	if (path == "MasterInterface.patch_stamp")
		value.setValue(getFieldPatchedValue("MasterInterface"));

	if (path == "MasterInterface")
		value.setValue(getMasterInterface());

	list_tag = "SlaveInterfaces[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i] && nItemId == m_lstSlaveInterfaces[i]->getItemId())
				return m_lstSlaveInterfaces[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("SlaveInterfaces.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i] && nMaxId < m_lstSlaveInterfaces[i]->getItemId())
				nMaxId = m_lstSlaveInterfaces[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("SlaveInterfaces.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i]) lstIds += m_lstSlaveInterfaces[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVZVirtualNetwork::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "BridgeName.patch_stamp")
	{
		markPatchedField("BridgeName", value.toString());
		return true;
	}

	if (path == "BridgeName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBridgeName() != value.value< QString >());
		setBridgeName(value.value< QString >());
		return true;
	}

	if (path == "MasterInterface.patch_stamp")
	{
		markPatchedField("MasterInterface", value.toString());
		return true;
	}

	if (path == "MasterInterface")
	{
		if (pbValueChanged)
			*pbValueChanged = (getMasterInterface() != value.value< QString >());
		setMasterInterface(value.value< QString >());
		return true;
	}

	list_tag = "SlaveInterfaces[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i] && nItemId == m_lstSlaveInterfaces[i]->getItemId())
				return m_lstSlaveInterfaces[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVZVirtualNetwork::getBridgeName_id() const
{
	return getFullItemId().isEmpty() ? "BridgeName" : getFullItemId() + ".BridgeName";
}
QString CVZVirtualNetwork::getMasterInterface_id() const
{
	return getFullItemId().isEmpty() ? "MasterInterface" : getFullItemId() + ".MasterInterface";
}

int CVZVirtualNetwork::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "SlaveInterfaces")
	{
		m_lstSlaveInterfaces += new CSlaveInterfaces;
		nNewItemId = getMaxItemId<CSlaveInterfaces>(m_lstSlaveInterfaces, "SlaveInterfaces");
		m_lstSlaveInterfaces.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "SlaveInterfaces");
	}

	list_tag = "SlaveInterfaces[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i] && nItemId == m_lstSlaveInterfaces[i]->getItemId())
				return m_lstSlaveInterfaces[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVZVirtualNetwork::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "SlaveInterfaces[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSlaveInterfaces.size(); ++i)
			if (m_lstSlaveInterfaces[i] && nItemId == m_lstSlaveInterfaces[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstSlaveInterfaces[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstSlaveInterfaces.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVZVirtualNetwork::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VZVirtualNetwork") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BridgeName");
	text_element = Document->createTextNode( QString("%1").arg(getBridgeName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("MasterInterface");
	text_element = Document->createTextNode( QString("%1").arg(getMasterInterface()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "SlaveInterfaces";
	nMaxItemId = getMaxItemId<CSlaveInterfaces>(m_lstSlaveInterfaces, "SlaveInterfaces", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstSlaveInterfaces.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CSlaveInterfaces* object = m_lstSlaveInterfaces[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "SlaveInterfaces", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVZVirtualNetwork::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VZVirtualNetwork") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVZVirtualNetwork': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_SlaveInterfaces = getMaxItemId2(element, "SlaveInterfaces");
	QMap<int , QString > mapSlaveInterfaces;
	if (unite_with_loaded)
		fillItemIdMap<CSlaveInterfaces>(m_lstSlaveInterfaces, mapSlaveInterfaces);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int SlaveInterfaces_count = 0;
	int BridgeName_count = 1;
	int MasterInterface_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "BridgeName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BridgeName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BridgeName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBridgeName(text_element.data());
			--BridgeName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "MasterInterface";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (MasterInterface_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "MasterInterface")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMasterInterface(text_element.data());
			--MasterInterface_count;
		}


		if (tag_name == "SlaveInterfaces")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_SlaveInterfaces++ : nItemId;
			CSlaveInterfaces* object = new CSlaveInterfaces();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "SlaveInterfaces", object->getItemId());
			if (unite_with_loaded && mapSlaveInterfaces.contains(nItemId))
				object->fromString(mapSlaveInterfaces.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstSlaveInterfaces += object;
			--SlaveInterfaces_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (SlaveInterfaces_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVZVirtualNetwork': tag 'SlaveInterfaces' is absent";
	}

	if (BridgeName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVZVirtualNetwork': tag 'BridgeName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (MasterInterface_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVZVirtualNetwork': tag 'MasterInterface' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_SlaveInterfaces, "SlaveInterfaces");


	return 0;
}

void CVZVirtualNetwork::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CSlaveInterfaces>(m_lstSlaveInterfaces, "SlaveInterfaces");
	setItemIds.clear();
	for(i = 0; i < m_lstSlaveInterfaces.size(); ++i)
	{
		CSlaveInterfaces* object = m_lstSlaveInterfaces[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "SlaveInterfaces", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "SlaveInterfaces");

}

bool CVZVirtualNetwork::merge(CVZVirtualNetwork* pCur, CVZVirtualNetwork* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "VZVirtualNetwork";

	if (getBridgeName() != pCur->getBridgeName() && getBridgeName() == pPrev->getBridgeName())
		setBridgeName(pCur->getBridgeName());
	else if (getBridgeName() != pCur->getBridgeName() && getBridgeName() != pPrev->getBridgeName() && pCur->getBridgeName() != pPrev->getBridgeName())
	{
		m_qsErrorMessage += ".BridgeName";
		return false;
	}

	if (getMasterInterface() != pCur->getMasterInterface() && getMasterInterface() == pPrev->getMasterInterface())
		setMasterInterface(pCur->getMasterInterface());
	else if (getMasterInterface() != pCur->getMasterInterface() && getMasterInterface() != pPrev->getMasterInterface() && pCur->getMasterInterface() != pPrev->getMasterInterface())
	{
		m_qsErrorMessage += ".MasterInterface";
		return false;
	}

	if ( ! mergeList<CSlaveInterfaces>(m_lstSlaveInterfaces, pCur->m_lstSlaveInterfaces, pPrev->m_lstSlaveInterfaces, "SlaveInterfaces", nOptions) )
		return false;

	return true;
}

void CVZVirtualNetwork::diff(const CVZVirtualNetwork* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getBridgeName() != pOld->getBridgeName())
		lstDiffFullItemIds += getBridgeName_id();

	if (getMasterInterface() != pOld->getMasterInterface())
		lstDiffFullItemIds += getMasterInterface_id();

	diffList<CSlaveInterfaces>(m_lstSlaveInterfaces, pOld->m_lstSlaveInterfaces, lstDiffFullItemIds);

}

void CVZVirtualNetwork::Copy(const CVZVirtualNetwork& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setBridgeName(rObject.getBridgeName());
	setMasterInterface(rObject.getMasterInterface());

	ClearList<CSlaveInterfaces >(m_lstSlaveInterfaces);
	for(i = 0; i < rObject.m_lstSlaveInterfaces.size(); i++)
		m_lstSlaveInterfaces += new CSlaveInterfaces(rObject.m_lstSlaveInterfaces[i]);

	CustomCopy(&rObject);

}

void CVZVirtualNetwork::InitLists()
{
	CustomInit();
}

void CVZVirtualNetwork::ClearLists()
{
	ClearList<CSlaveInterfaces>(m_lstSlaveInterfaces);
}

void CVZVirtualNetwork::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("SlaveInterfaces") )
		ClearList<CSlaveInterfaces>(m_lstSlaveInterfaces);
}

