////////////////////////////////////////////////////////////////////////////////
///
/// CVirtualNetwork.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVirtualNetwork.h"


CVirtualNetwork::CVirtualNetwork()
{
	InitLists();
	setDefaults();
}

CVirtualNetwork::CVirtualNetwork(const CVirtualNetwork& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CVirtualNetwork::CVirtualNetwork(const CVirtualNetwork* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVirtualNetwork& CVirtualNetwork::operator=(const CVirtualNetwork& rObject)
{
	Copy(rObject);
	return *this;
}

CVirtualNetwork::CVirtualNetwork(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVirtualNetwork::~CVirtualNetwork()
{
	ClearLists();
}


CHostOnlyNetwork* CVirtualNetwork::getHostOnlyNetwork() const
{
	if (!m_lstHostOnlyNetwork.isEmpty())
	{
		return m_lstHostOnlyNetwork[0];
	}
	return 0;
}

void CVirtualNetwork::setHostOnlyNetwork(CHostOnlyNetwork* pHostOnlyNetwork)
{
	ClearList<CHostOnlyNetwork>(m_lstHostOnlyNetwork);
	if (pHostOnlyNetwork)
	{
		m_lstHostOnlyNetwork += pHostOnlyNetwork;
	}
}

CVZVirtualNetwork* CVirtualNetwork::getVZVirtualNetwork() const
{
	if (!m_lstVZVirtualNetwork.isEmpty())
	{
		return m_lstVZVirtualNetwork[0];
	}
	return 0;
}

void CVirtualNetwork::setVZVirtualNetwork(CVZVirtualNetwork* pVZVirtualNetwork)
{
	ClearList<CVZVirtualNetwork>(m_lstVZVirtualNetwork);
	if (pVZVirtualNetwork)
	{
		m_lstVZVirtualNetwork += pVZVirtualNetwork;
	}
}

QString CVirtualNetwork::getUuid() const
{
	return m_qsUuid;
}

void CVirtualNetwork::setUuid(QString value)
{
	m_qsUuid = value;
}

QString CVirtualNetwork::getNetworkID() const
{
	return m_qsNetworkID;
}

void CVirtualNetwork::setNetworkID(QString value)
{
	m_qsNetworkID = value;
}

QString CVirtualNetwork::getDescription() const
{
	return m_qsDescription;
}

void CVirtualNetwork::setDescription(QString value)
{
	m_qsDescription = value;
}

bool CVirtualNetwork::isEnabled() const
{
	return m_bEnabled;
}

void CVirtualNetwork::setEnabled(bool value)
{
	m_bEnabled = value;
}

PRL_NET_VIRTUAL_NETWORK_TYPE CVirtualNetwork::getNetworkType() const
{
	return m_ctNetworkType;
}

void CVirtualNetwork::setNetworkType(PRL_NET_VIRTUAL_NETWORK_TYPE value)
{
	m_ctNetworkType = value;
}

QString CVirtualNetwork::getBoundCardMac() const
{
	return m_qsBoundCardMac;
}

void CVirtualNetwork::setBoundCardMac(QString value)
{
	m_qsBoundCardMac = value;
}

unsigned short CVirtualNetwork::getVLANTag() const
{
	return m_usVLANTag;
}

void CVirtualNetwork::setVLANTag(unsigned short value)
{
	m_usVLANTag = value;
}

void CVirtualNetwork::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid(Uuid::createUuid().toString());
	if ( ! RootElement || ! RootElement->firstChildElement("NetworkID").isNull() )
		setNetworkID();
	if ( ! RootElement || ! RootElement->firstChildElement("Description").isNull() )
		setDescription();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("NetworkType").isNull() )
		setNetworkType();
	if ( ! RootElement || ! RootElement->firstChildElement("BoundCardMac").isNull() )
		setBoundCardMac();
	if ( ! RootElement || ! RootElement->firstChildElement("VLANTag").isNull() )
		setVLANTag();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_NET_VIRTUAL_NETWORK_TYPE >("PRL_NET_VIRTUAL_NETWORK_TYPE");
		first_time = false;
	}

}

QVariant CVirtualNetwork::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Uuid.patch_stamp")
		value.setValue(getFieldPatchedValue("Uuid"));

	if (path == "Uuid")
		value.setValue(getUuid());

	if (path == "NetworkID.patch_stamp")
		value.setValue(getFieldPatchedValue("NetworkID"));

	if (path == "NetworkID")
		value.setValue(getNetworkID());

	if (path == "Description.patch_stamp")
		value.setValue(getFieldPatchedValue("Description"));

	if (path == "Description")
		value.setValue(getDescription());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "NetworkType.patch_stamp")
		value.setValue(getFieldPatchedValue("NetworkType"));

	if (path == "NetworkType")
		value.setValue((qlonglong )getNetworkType());

	if (path == "BoundCardMac.patch_stamp")
		value.setValue(getFieldPatchedValue("BoundCardMac"));

	if (path == "BoundCardMac")
		value.setValue(getBoundCardMac());

	if (path == "VLANTag.patch_stamp")
		value.setValue(getFieldPatchedValue("VLANTag"));

	if (path == "VLANTag")
		value.setValue(getVLANTag());

	list_tag = "HostOnlyNetwork.";
	if (path.startsWith(list_tag) && ! m_lstHostOnlyNetwork.isEmpty() && m_lstHostOnlyNetwork.first())
		return m_lstHostOnlyNetwork.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "VZVirtualNetwork[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i] && nItemId == m_lstVZVirtualNetwork[i]->getItemId())
				return m_lstVZVirtualNetwork[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("VZVirtualNetwork.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i] && nMaxId < m_lstVZVirtualNetwork[i]->getItemId())
				nMaxId = m_lstVZVirtualNetwork[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("VZVirtualNetwork.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i]) lstIds += m_lstVZVirtualNetwork[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVirtualNetwork::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Uuid.patch_stamp")
	{
		markPatchedField("Uuid", value.toString());
		return true;
	}

	if (path == "Uuid")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUuid() != value.value< QString >());
		setUuid(value.value< QString >());
		return true;
	}

	if (path == "NetworkID.patch_stamp")
	{
		markPatchedField("NetworkID", value.toString());
		return true;
	}

	if (path == "NetworkID")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNetworkID() != value.value< QString >());
		setNetworkID(value.value< QString >());
		return true;
	}

	if (path == "Description.patch_stamp")
	{
		markPatchedField("Description", value.toString());
		return true;
	}

	if (path == "Description")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDescription() != value.value< QString >());
		setDescription(value.value< QString >());
		return true;
	}

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "NetworkType.patch_stamp")
	{
		markPatchedField("NetworkType", value.toString());
		return true;
	}

	if (path == "NetworkType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNetworkType() != (PRL_NET_VIRTUAL_NETWORK_TYPE )value.value< qlonglong >());
		setNetworkType((PRL_NET_VIRTUAL_NETWORK_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "BoundCardMac.patch_stamp")
	{
		markPatchedField("BoundCardMac", value.toString());
		return true;
	}

	if (path == "BoundCardMac")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBoundCardMac() != value.value< QString >());
		setBoundCardMac(value.value< QString >());
		return true;
	}

	if (path == "VLANTag.patch_stamp")
	{
		markPatchedField("VLANTag", value.toString());
		return true;
	}

	if (path == "VLANTag")
	{
		if (pbValueChanged)
			*pbValueChanged = (getVLANTag() != value.value< unsigned short >());
		setVLANTag(value.value< unsigned short >());
		return true;
	}

	list_tag = "HostOnlyNetwork.";
	if (path.startsWith(list_tag) && ! m_lstHostOnlyNetwork.isEmpty() && m_lstHostOnlyNetwork.first())
		return m_lstHostOnlyNetwork.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "VZVirtualNetwork[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i] && nItemId == m_lstVZVirtualNetwork[i]->getItemId())
				return m_lstVZVirtualNetwork[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVirtualNetwork::getUuid_id() const
{
	return getFullItemId().isEmpty() ? "Uuid" : getFullItemId() + ".Uuid";
}
QString CVirtualNetwork::getNetworkID_id() const
{
	return getFullItemId().isEmpty() ? "NetworkID" : getFullItemId() + ".NetworkID";
}
QString CVirtualNetwork::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "Description" : getFullItemId() + ".Description";
}
QString CVirtualNetwork::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVirtualNetwork::getNetworkType_id() const
{
	return getFullItemId().isEmpty() ? "NetworkType" : getFullItemId() + ".NetworkType";
}
QString CVirtualNetwork::getBoundCardMac_id() const
{
	return getFullItemId().isEmpty() ? "BoundCardMac" : getFullItemId() + ".BoundCardMac";
}
QString CVirtualNetwork::getVLANTag_id() const
{
	return getFullItemId().isEmpty() ? "VLANTag" : getFullItemId() + ".VLANTag";
}

int CVirtualNetwork::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "HostOnlyNetwork.";
	if (path.startsWith(list_tag) && ! m_lstHostOnlyNetwork.isEmpty() && m_lstHostOnlyNetwork.first())
		return m_lstHostOnlyNetwork.first()->addListItem(path.mid(list_tag.size()));

	if (path == "VZVirtualNetwork")
	{
		m_lstVZVirtualNetwork += new CVZVirtualNetwork;
		nNewItemId = getMaxItemId<CVZVirtualNetwork>(m_lstVZVirtualNetwork, "VZVirtualNetwork");
		m_lstVZVirtualNetwork.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "VZVirtualNetwork");
	}

	list_tag = "VZVirtualNetwork[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i] && nItemId == m_lstVZVirtualNetwork[i]->getItemId())
				return m_lstVZVirtualNetwork[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVirtualNetwork::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "HostOnlyNetwork.";
	if (path.startsWith(list_tag) && ! m_lstHostOnlyNetwork.isEmpty() && m_lstHostOnlyNetwork.first())
		return m_lstHostOnlyNetwork.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "VZVirtualNetwork[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
			if (m_lstVZVirtualNetwork[i] && nItemId == m_lstVZVirtualNetwork[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstVZVirtualNetwork[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstVZVirtualNetwork.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVirtualNetwork::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VirtualNetwork") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("NetworkID");
	text_element = Document->createTextNode( QString("%1").arg(getNetworkID()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Description");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("NetworkType");
	text_element = Document->createTextNode( QString("%1").arg(getNetworkType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BoundCardMac");
	text_element = Document->createTextNode( QString("%1").arg(getBoundCardMac()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VLANTag");
	text_element = Document->createTextNode( QString("%1").arg(getVLANTag()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstHostOnlyNetwork.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CHostOnlyNetwork* object = m_lstHostOnlyNetwork[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	dyn_lists += "VZVirtualNetwork";
	nMaxItemId = getMaxItemId<CVZVirtualNetwork>(m_lstVZVirtualNetwork, "VZVirtualNetwork", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVZVirtualNetwork.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVZVirtualNetwork* object = m_lstVZVirtualNetwork[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VZVirtualNetwork", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVirtualNetwork::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VirtualNetwork") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VZVirtualNetwork = getMaxItemId2(element, "VZVirtualNetwork");
	QMap<int , QString > mapVZVirtualNetwork;
	if (unite_with_loaded)
		fillItemIdMap<CVZVirtualNetwork>(m_lstVZVirtualNetwork, mapVZVirtualNetwork);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int HostOnlyNetwork_count = 1;
	int VZVirtualNetwork_count = 0;
	int Uuid_count = 0;
	int NetworkID_count = 1;
	int Description_count = 1;
	int Enabled_count = 1;
	int NetworkType_count = 1;
	int BoundCardMac_count = 1;
	int VLANTag_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "NetworkID";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (NetworkID_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "NetworkID")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNetworkID(text_element.data());
			--NetworkID_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Description";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Description_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Description")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--Description_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "NetworkType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (NetworkType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "NetworkType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNetworkType((PRL_NET_VIRTUAL_NETWORK_TYPE )text_element.data().toLongLong());
			--NetworkType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "BoundCardMac";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BoundCardMac_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BoundCardMac")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBoundCardMac(text_element.data());
			--BoundCardMac_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VLANTag";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VLANTag_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VLANTag")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVLANTag((unsigned short )text_element.data().toUInt());
			--VLANTag_count;
		}


		if (tag_name == "HostOnlyNetwork" && HostOnlyNetwork_count > 0)
		{
			unused_tag = false;
			CHostOnlyNetwork* object = m_lstHostOnlyNetwork[1 - HostOnlyNetwork_count];
			object->makeFullItemId(getFullItemId(), "HostOnlyNetwork");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--HostOnlyNetwork_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "VZVirtualNetwork")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VZVirtualNetwork++ : nItemId;
			CVZVirtualNetwork* object = new CVZVirtualNetwork();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "VZVirtualNetwork", object->getItemId());
			if (unite_with_loaded && mapVZVirtualNetwork.contains(nItemId))
				object->fromString(mapVZVirtualNetwork.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVZVirtualNetwork += object;
			--VZVirtualNetwork_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (HostOnlyNetwork_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVirtualNetwork': tag 'HostOnlyNetwork' is absent";
	}

	if (VZVirtualNetwork_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVirtualNetwork': tag 'VZVirtualNetwork' is absent";
	}

	if (Uuid_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVirtualNetwork': tag 'Uuid' is absent";
	}

	if (NetworkID_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'NetworkID' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Description_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'Description' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (NetworkType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'NetworkType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (BoundCardMac_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'BoundCardMac' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (VLANTag_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVirtualNetwork': tag 'VLANTag' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_VZVirtualNetwork, "VZVirtualNetwork");


	return 0;
}

void CVirtualNetwork::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstHostOnlyNetwork.size(); ++i)
	{
		CHostOnlyNetwork* object = m_lstHostOnlyNetwork[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "HostOnlyNetwork");
		object->syncItemIds();
	}

	nMaxItemId = getMaxItemId<CVZVirtualNetwork>(m_lstVZVirtualNetwork, "VZVirtualNetwork");
	setItemIds.clear();
	for(i = 0; i < m_lstVZVirtualNetwork.size(); ++i)
	{
		CVZVirtualNetwork* object = m_lstVZVirtualNetwork[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "VZVirtualNetwork", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VZVirtualNetwork");

}

bool CVirtualNetwork::merge(CVirtualNetwork* pCur, CVirtualNetwork* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "VirtualNetwork";

	if (getUuid() != pCur->getUuid() && getUuid() == pPrev->getUuid())
		setUuid(pCur->getUuid());
	else if (getUuid() != pCur->getUuid() && getUuid() != pPrev->getUuid() && pCur->getUuid() != pPrev->getUuid())
	{
		m_qsErrorMessage += ".Uuid";
		return false;
	}

	if (getNetworkID() != pCur->getNetworkID() && getNetworkID() == pPrev->getNetworkID())
		setNetworkID(pCur->getNetworkID());
	else if (getNetworkID() != pCur->getNetworkID() && getNetworkID() != pPrev->getNetworkID() && pCur->getNetworkID() != pPrev->getNetworkID())
	{
		m_qsErrorMessage += ".NetworkID";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".Description";
		return false;
	}

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getNetworkType() != pCur->getNetworkType() && getNetworkType() == pPrev->getNetworkType())
		setNetworkType(pCur->getNetworkType());
	else if (getNetworkType() != pCur->getNetworkType() && getNetworkType() != pPrev->getNetworkType() && pCur->getNetworkType() != pPrev->getNetworkType())
	{
		m_qsErrorMessage += ".NetworkType";
		return false;
	}

	if (getBoundCardMac() != pCur->getBoundCardMac() && getBoundCardMac() == pPrev->getBoundCardMac())
		setBoundCardMac(pCur->getBoundCardMac());
	else if (getBoundCardMac() != pCur->getBoundCardMac() && getBoundCardMac() != pPrev->getBoundCardMac() && pCur->getBoundCardMac() != pPrev->getBoundCardMac())
	{
		m_qsErrorMessage += ".BoundCardMac";
		return false;
	}

	if (getVLANTag() != pCur->getVLANTag() && getVLANTag() == pPrev->getVLANTag())
		setVLANTag(pCur->getVLANTag());
	else if (getVLANTag() != pCur->getVLANTag() && getVLANTag() != pPrev->getVLANTag() && pCur->getVLANTag() != pPrev->getVLANTag())
	{
		m_qsErrorMessage += ".VLANTag";
		return false;
	}

	for(i = 0; i < m_lstHostOnlyNetwork.size(); i++)
	{
		if ( m_lstHostOnlyNetwork[i]->merge(pCur->m_lstHostOnlyNetwork[i], pPrev->m_lstHostOnlyNetwork[i], nOptions) ) continue;
		QString qsIdx = (m_lstHostOnlyNetwork.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstHostOnlyNetwork[i]->GetErrorMessage();
		return false;
	}

	if ( ! mergeList<CVZVirtualNetwork>(m_lstVZVirtualNetwork, pCur->m_lstVZVirtualNetwork, pPrev->m_lstVZVirtualNetwork, "VZVirtualNetwork", nOptions) )
		return false;

	return true;
}

void CVirtualNetwork::diff(const CVirtualNetwork* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getUuid() != pOld->getUuid())
		lstDiffFullItemIds += getUuid_id();

	if (getNetworkID() != pOld->getNetworkID())
		lstDiffFullItemIds += getNetworkID_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getNetworkType() != pOld->getNetworkType())
		lstDiffFullItemIds += getNetworkType_id();

	if (getBoundCardMac() != pOld->getBoundCardMac())
		lstDiffFullItemIds += getBoundCardMac_id();

	if (getVLANTag() != pOld->getVLANTag())
		lstDiffFullItemIds += getVLANTag_id();

	for(i = 0; i < m_lstHostOnlyNetwork.size(); ++i)
		m_lstHostOnlyNetwork[i]->diff(pOld->m_lstHostOnlyNetwork[i], lstDiffFullItemIds);

	diffList<CVZVirtualNetwork>(m_lstVZVirtualNetwork, pOld->m_lstVZVirtualNetwork, lstDiffFullItemIds);

}

void CVirtualNetwork::Copy(const CVirtualNetwork& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());
	setNetworkID(rObject.getNetworkID());
	setDescription(rObject.getDescription());
	setEnabled(rObject.isEnabled());
	setNetworkType(rObject.getNetworkType());
	setBoundCardMac(rObject.getBoundCardMac());
	setVLANTag(rObject.getVLANTag());

	ClearList<CHostOnlyNetwork >(m_lstHostOnlyNetwork);
	for(i = 0; i < rObject.m_lstHostOnlyNetwork.size(); i++)
		m_lstHostOnlyNetwork += new CHostOnlyNetwork(rObject.m_lstHostOnlyNetwork[i]);

	ClearList<CVZVirtualNetwork >(m_lstVZVirtualNetwork);
	for(i = 0; i < rObject.m_lstVZVirtualNetwork.size(); i++)
		m_lstVZVirtualNetwork += new CVZVirtualNetwork(rObject.m_lstVZVirtualNetwork[i]);

	CustomCopy(&rObject);

}

void CVirtualNetwork::InitLists()
{
	InitList<CHostOnlyNetwork>(1, m_lstHostOnlyNetwork);
	CustomInit();
}

void CVirtualNetwork::ClearLists()
{
	ClearList<CHostOnlyNetwork>(m_lstHostOnlyNetwork);
	ClearList<CVZVirtualNetwork>(m_lstVZVirtualNetwork);
}

void CVirtualNetwork::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VZVirtualNetwork") )
		ClearList<CVZVirtualNetwork>(m_lstVZVirtualNetwork);
	for(i = 0; i < m_lstHostOnlyNetwork.size() && ! unite_with_loaded; i++)
	{
		m_lstHostOnlyNetwork[i]->ClearListsInReadXml();
		m_lstHostOnlyNetwork[i]->setDefaults();
		m_lstHostOnlyNetwork[i]->setSectionFakeFlag(true);
	}
}

