////////////////////////////////////////////////////////////////////////////////
///
/// CVirtualNetwork.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVIRTUALNETWORK_H
#define CVIRTUALNETWORK_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CHostOnlyNetwork.h"
#include "CVZVirtualNetwork.h"


class CVirtualNetwork : public CBaseNode
{

public:

	CVirtualNetwork();
	CVirtualNetwork(const CVirtualNetwork& rObject);
	CVirtualNetwork(const CVirtualNetwork* pObject);
	CVirtualNetwork(QFile* pFile);
	CVirtualNetwork& operator=(const CVirtualNetwork& rObject);
	virtual ~CVirtualNetwork();


    bool isBridgedToDefaultAdapter() const { return 0 == QString::compare(m_qsBoundCardMac, "FF:FF:FF:FF:FF:FF", Qt::CaseInsensitive); }

    void setBridgedToDefaultAdapter() { m_qsBoundCardMac="FF:FF:FF:FF:FF:FF"; }

	QList<CHostOnlyNetwork* >		m_lstHostOnlyNetwork;
	QList<CVZVirtualNetwork* >		m_lstVZVirtualNetwork;

	CHostOnlyNetwork* getHostOnlyNetwork() const;
	void setHostOnlyNetwork(CHostOnlyNetwork* pHostOnlyNetwork);

	CVZVirtualNetwork* getVZVirtualNetwork() const;
	void setVZVirtualNetwork(CVZVirtualNetwork* pVZVirtualNetwork);


	QString getUuid() const;
	void setUuid(QString value = QString());

	QString getNetworkID() const;
	void setNetworkID(QString value = QString());

	QString getDescription() const;
	void setDescription(QString value = QString());

	bool isEnabled() const;
	void setEnabled(bool value = true);

	PRL_NET_VIRTUAL_NETWORK_TYPE getNetworkType() const;
	void setNetworkType(PRL_NET_VIRTUAL_NETWORK_TYPE value = PVN_HOST_ONLY);

	QString getBoundCardMac() const;
	void setBoundCardMac(QString value = QString());

	unsigned short getVLANTag() const;
	void setVLANTag(unsigned short value = PRL_INVALID_VLAN_TAG);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getUuid_id() const;
	QString getNetworkID_id() const;
	QString getDescription_id() const;
	QString getEnabled_id() const;
	QString getNetworkType_id() const;
	QString getBoundCardMac_id() const;
	QString getVLANTag_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVirtualNetwork* pCur, CVirtualNetwork* pPrev, MergeOptions nOptions);

	void diff(const CVirtualNetwork* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsUuid;
	QString		m_qsNetworkID;
	QString		m_qsDescription;
	bool		m_bEnabled;
	PRL_NET_VIRTUAL_NETWORK_TYPE		m_ctNetworkType;
	QString		m_qsBoundCardMac;
	unsigned short		m_usVLANTag;

	void Copy(const CVirtualNetwork& rObject);

};

#ifndef DM_128295173
#define DM_128295173
Q_DECLARE_METATYPE(PRL_NET_VIRTUAL_NETWORK_TYPE)
#endif


#endif
