////////////////////////////////////////////////////////////////////////////////
///
/// CProblemReport.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CPROBLEMREPORT_H
#define CPROBLEMREPORT_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "../DispConfig/CDispLicense.h"
#include "CRepContactInfo.h"
#include "ContainersInfo.h"
#include "CRepUserDefinedData.h"
#include "CRepVzReport.h"
#include "CRepAdvancedVmInfo.h"
#include "CRepAutoStatisticInfo.h"
#include "CRepCrashDump.h"
#include "CRepMemoryDump.h"
#include "CRepSystemLogs.h"
#include "ClientInfo.h"
#include "CRepVersionMatrix.h"
#include "GuestCommands.h"
#include "CRepSignInfo.h"


class CProblemReport : public QObject
				, public CBaseNode
{

public:

	CProblemReport();
	CProblemReport(const CProblemReport& rObject);
	CProblemReport(const CProblemReport* pObject);
	CProblemReport(QFile* pFile);
	CProblemReport& operator=(const CProblemReport& rObject);
	virtual ~CProblemReport();


virtual void appendTemplateSystemLog(const QString &, const QString &, int );

virtual void appendSystemLog(const QString &, const QString & );

    virtual void clearSystemLogs();

    virtual void appendSystemLog(CRepSystemLog * plog);

    virtual void appendMemoryDump(CRepMemoryDump * pDump);

    virtual void appendCrashDump(CRepCrashDump * pDump);

    void CustomInit();
   virtual void clearMemoryDumps()
   {
       ClearList<CRepMemoryDump >(m_lstMemoryDumps);
   }

   virtual void clearCrashDumps()
   {
       ClearList<CRepCrashDump >(m_lstCrashDumps);
   }

	QList<CDispLicense* >		m_lstLicense;
	QList<CRepContactInfo* >		m_lstContactInfo;
	QList<ContainersInfo* >		m_lstContainersInfo;
	QList<CRepUserDefinedData* >		m_lstUserDefined;
	QList<CRepVzReport* >		m_lstVzReport;
	QList<CRepAdvancedVmInfo* >		m_lstAdvancedVmInfo;
	QList<CRepAutoStatisticInfo* >		m_lstAutoStatisticInfo;
	QList<CRepCrashDump* >		m_lstCrashDumps;
	QList<CRepMemoryDump* >		m_lstMemoryDumps;
	QList<CRepSystemLogs* >		m_lstSystemLogs;
	QList<ClientInfo* >		m_lstClientInfo;
	QList<CRepVersionMatrix* >		m_lstVersionMatrix;
	QList<GuestCommands* >		m_lstGuestCommands;
	QList<CRepSignInfo* >		m_lstSignInfo;

	CDispLicense* getLicense() const;
	void setLicense(CDispLicense* pLicense);

	CRepContactInfo* getContactInfo() const;
	void setContactInfo(CRepContactInfo* pContactInfo);

	ContainersInfo* getContainersInfo() const;
	void setContainersInfo(ContainersInfo* pContainersInfo);

	CRepUserDefinedData* getUserDefinedData() const;
	void setUserDefinedData(CRepUserDefinedData* pUserDefined);

	virtual CRepVzReport* getVzReport() const;
	virtual void setVzReport(CRepVzReport* pVzReport);

	virtual CRepAdvancedVmInfo* getAdvancedVmInfo() const;
	virtual void setAdvancedVmInfo(CRepAdvancedVmInfo* pAdvancedVmInfo);

	CRepAutoStatisticInfo* getAutoStatisticInfo() const;
	void setAutoStatisticInfo(CRepAutoStatisticInfo* pAutoStatisticInfo);

	CRepSystemLogs* getSystemLogs() const;
	void setSystemLogs(CRepSystemLogs* pSystemLogs);

	virtual ClientInfo* getClientInfo() const;
	virtual void setClientInfo(ClientInfo* pClientInfo);

	CRepVersionMatrix* getVersionMatrix() const;
	void setVersionMatrix(CRepVersionMatrix* pVersionMatrix);

	GuestCommands* getGuestCommands() const;
	void setGuestCommands(GuestCommands* pGuestCommands);

	CRepSignInfo* getSignInfo() const;
	void setSignInfo(CRepSignInfo* pSignInfo);


	PRL_PROBLEM_REPORT_TYPE getReportType() const;
	void setReportType(PRL_PROBLEM_REPORT_TYPE value = PRT_REPORT_TYPE_UNDEFINED);

	QString getServerVersion() const;
	void setServerVersion(QString value = XML_DEFAULT_STRING_DATA);

	QString getServerRevision() const;
	void setServerRevision(QString value = XML_DEFAULT_STRING_DATA);

	QString getIsoVersion() const;
	void setIsoVersion(QString value = QString());

	QString getProductName() const;
	void setProductName(QString value = VER_SHORTPRODUCTNAME_STR);

	PRL_PROBLEM_REPORT_REASON getReportReason() const;
	void setReportReason(PRL_PROBLEM_REPORT_REASON value = PRR_UNKNOWN);

	unsigned int getProblemCode() const;
	void setProblemCode(unsigned int value = 0);

	QString getClientVersion() const;
	void setClientVersion(QString value = VER_FULL_BUILD_NUMBER_STR);

	QString getClientRevision() const;
	void setClientRevision(QString value = VER_FEATURES_STR);

	QString getComputerModel() const;
	void setComputerModel(QString value = XML_DEFAULT_STRING_DATA);

	int getTimeZone() const;
	void setTimeZone(int value = 0);

	QString getTimeZoneStr() const;
	void setTimeZoneStr(QString value = XML_DEFAULT_STRING_DATA);

	QString getPreamble() const;
	void setPreamble(QString value = QString());

	virtual QString getHostStatistic() const;
	virtual void setHostStatistic(QString value = QString());

	virtual QString getHostInfo() const;
	virtual void setHostInfo(QString value = QString());

	virtual QString getMoreHostInfo() const;
	virtual void setMoreHostInfo(QString value = QString());

	virtual QString getAllProcesses() const;
	virtual void setAllProcesses(QString value = QString());

	virtual QString getAllProcessesSamples() const;
	virtual void setAllProcessesSamples(QString value = QString());

	virtual QString getLoadedDrivers() const;
	virtual void setLoadedDrivers(QString value = QString());

	virtual QString getClientProxyInfo() const;
	virtual void setClientProxyInfo(QString value = QString());

	virtual QString getAppConfig() const;
	virtual void setAppConfig(QString value = QString());

	virtual QString getNetConfig() const;
	virtual void setNetConfig(QString value = QString());

	virtual QString getMonitorData() const;
	virtual void setMonitorData(QString value = QString());

	virtual QString getPerformanceCounters() const;
	virtual void setPerformanceCounters(QString value = QString());

	virtual QString getVmConfig() const;
	virtual void setVmConfig(QString value = QString());

	virtual QString getVmDomain() const;
	virtual void setVmDomain(QString value = QString());

	virtual QString getVmUpdaterInfo() const;
	virtual void setVmUpdaterInfo(QString value = QString());

	virtual QString getGuestOs() const;
	virtual void setGuestOs(QString value = QString());

	virtual QString getVmDirectory() const;
	virtual void setVmDirectory(QString value = QString());

	virtual QString getInstalledSoftware() const;
	virtual void setInstalledSoftware(QString value = QString());

	virtual QString getAppSwitchPackages() const;
	virtual void setAppSwitchPackages(QString value = QString());

	QString getAppSwitchAppList() const;
	void setAppSwitchAppList(QString value = QString());

	QString getAudioPluginsInfo() const;
	void setAudioPluginsInfo(QString value = QString());

	QString getMountInfo() const;
	void setMountInfo(QString value = QString());

	virtual QString getLaunchdInfo() const;
	virtual void setLaunchdInfo(QString value = QString());

	QString getFilesMd5InProductBundle() const;
	void setFilesMd5InProductBundle(QString value = QString());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PRL_PROBLEM_REPORT_TYPE		m_ctType;
	QString		m_qsServerVersion;
	QString		m_qsServerRevision;
	QString		m_qsIsoVersion;
	QString		m_qsProductName;
	PRL_PROBLEM_REPORT_REASON		m_ctReportReason;
	unsigned int		m_uiProblemCode;
	QString		m_qsClientVersion;
	QString		m_qsClientRevision;
	QString		m_qsComputerModel;
	int		m_iTimeZone;
	QString		m_qsTimeZoneStr;
	QString		m_qsPreamble;
	QString		m_qsHostStatistic;
	QString		m_qsHostInfo;
	QString		m_qsMoreHostInfo;
	QString		m_qsAllProcesses;
	QString		m_qsAllProcessesSamples;
	QString		m_qsLoadedDrivers;
	QString		m_qsClientProxyInfo;
	QString		m_qsAppConfig;
	QString		m_qsNetConfig;
	QString		m_qsMonitorData;
	QString		m_qsPerformanceCounters;
	QString		m_qsCurrentVm;
	QString		m_qsCurrentVmDomain;
	QString		m_qsAutoupdate;
	QString		m_qsGuestOs;
	QString		m_qsVmDirectory;
	QString		m_qsInstalledSoftware;
	QString		m_qsAppSwitchPackages;
	QString		m_qsAppSwitchAppList;
	QString		m_qsAudioPluginsInfo;
	QString		m_qsMountInfo;
	QString		m_qsLaunchdInfo;
	QString		m_qsFilesMd5InProductBundle;

	void Copy(const CProblemReport& rObject);

};



#endif
