////////////////////////////////////////////////////////////////////////////////
///
/// CRepVersionMatrix.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CRepVersionMatrix.h"


CRepVersionMatrix::CRepVersionMatrix()
{
	InitLists();
	setDefaults();
}

CRepVersionMatrix::CRepVersionMatrix(const CRepVersionMatrix& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CRepVersionMatrix::CRepVersionMatrix(const CRepVersionMatrix* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CRepVersionMatrix& CRepVersionMatrix::operator=(const CRepVersionMatrix& rObject)
{
	Copy(rObject);
	return *this;
}

CRepVersionMatrix::CRepVersionMatrix(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CRepVersionMatrix::~CRepVersionMatrix()
{
	ClearLists();
}


void CRepVersionMatrix::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement CRepVersionMatrix::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VersionMatrix") : m_qsExtRootTagName);

	dyn_lists += "VersionItem";
	nMaxItemId = getMaxItemId<CRepVersionItem>(m_lstVersionItems, "VersionItem", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVersionItems.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CRepVersionItem* object = m_lstVersionItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VersionItem", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CRepVersionMatrix::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VersionMatrix") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CRepVersionMatrix': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VersionItem = getMaxItemId2(element, "VersionItem");
	QMap<int , QString > mapVersionItem;
	if (unite_with_loaded)
		fillItemIdMap<CRepVersionItem>(m_lstVersionItems, mapVersionItem);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int VersionItems_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "VersionItem")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VersionItem++ : nItemId;
			CRepVersionItem* object = new CRepVersionItem();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapVersionItem.contains(nItemId))
				object->fromString(mapVersionItem.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVersionItems += object;
			--VersionItems_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (VersionItems_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CRepVersionMatrix': tag 'VersionItem' is absent";
	}

	syncMaxItemId(nMaxItemId_VersionItem, "VersionItem");


	return 0;
}

void CRepVersionMatrix::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CRepVersionItem>(m_lstVersionItems, "VersionItem");
	setItemIds.clear();
	for(i = 0; i < m_lstVersionItems.size(); ++i)
	{
		CRepVersionItem* object = m_lstVersionItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VersionItem");

}

void CRepVersionMatrix::Copy(const CRepVersionMatrix& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CRepVersionItem >(m_lstVersionItems);
	for(i = 0; i < rObject.m_lstVersionItems.size(); i++)
		m_lstVersionItems += new CRepVersionItem(rObject.m_lstVersionItems[i]);

	CustomCopy(&rObject);

}

void CRepVersionMatrix::InitLists()
{
	CustomInit();
}

void CRepVersionMatrix::ClearLists()
{
	ClearList<CRepVersionItem>(m_lstVersionItems);
}

void CRepVersionMatrix::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VersionItem") )
		ClearList<CRepVersionItem>(m_lstVersionItems);
}

