////////////////////////////////////////////////////////////////////////////////
///
/// ContainersInfo.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "ContainersInfo.h"


ContainersInfo::ContainersInfo()
{
	InitLists();
	setDefaults();
}

ContainersInfo::ContainersInfo(const ContainersInfo& rObject)
: CBaseNode()
{
	Copy(rObject);
}

ContainersInfo::ContainersInfo(const ContainersInfo* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

ContainersInfo& ContainersInfo::operator=(const ContainersInfo& rObject)
{
	Copy(rObject);
	return *this;
}

ContainersInfo::ContainersInfo(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

ContainersInfo::~ContainersInfo()
{
	ClearLists();
}


QString ContainersInfo::getVzConfig() const
{
	return m_qsVzConfig;
}

void ContainersInfo::setVzConfig(QString value)
{
	m_qsVzConfig = value;
}

QString ContainersInfo::getVzNetConfig() const
{
	return m_qsVzNetConfig;
}

void ContainersInfo::setVzNetConfig(QString value)
{
	m_qsVzNetConfig = value;
}

unsigned int ContainersInfo::getContainersRunning() const
{
	return m_uiContainersRunning;
}

void ContainersInfo::setContainersRunning(unsigned int value)
{
	m_uiContainersRunning = value;
}

void ContainersInfo::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("VzConfig").isNull() )
		setVzConfig();
	if ( ! RootElement || ! RootElement->firstChildElement("VzNetConfig").isNull() )
		setVzNetConfig();
	if ( ! RootElement || ! RootElement->firstChildElement("ContainersRunning").isNull() )
		setContainersRunning();
}

QDomElement ContainersInfo::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ContainersInfo") : m_qsExtRootTagName);

	if (!getVzConfig().isEmpty())
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("VzConfig");
		cdata_element = Document->createCDATASection( QString("%1").arg(getVzConfig()) );
		root_element.appendChild(element);
		element.appendChild(cdata_element);

	}

	if (!getVzNetConfig().isEmpty())
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("VzNetConfig");
		cdata_element = Document->createCDATASection( QString("%1").arg(getVzNetConfig()) );
		root_element.appendChild(element);
		element.appendChild(cdata_element);

	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ContainersRunning");
	text_element = Document->createTextNode( QString("%1").arg(getContainersRunning()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int ContainersInfo::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ContainersInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'ContainersInfo': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int VzConfig_count = 0;
	int VzNetConfig_count = 0;
	int ContainersRunning_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "VzConfig";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VzConfig_count - 0) == 0)
		{
			cdata_element = temp_doc.createCDATASection( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VzConfig")
		{
			is_set = true;
			cdata_element = element.firstChild().toCDATASection();
		}

		if (is_set)
		{
			unused_tag = false;
			setVzConfig(cdata_element.data());
			--VzConfig_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VzNetConfig";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VzNetConfig_count - 0) == 0)
		{
			cdata_element = temp_doc.createCDATASection( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VzNetConfig")
		{
			is_set = true;
			cdata_element = element.firstChild().toCDATASection();
		}

		if (is_set)
		{
			unused_tag = false;
			setVzNetConfig(cdata_element.data());
			--VzNetConfig_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ContainersRunning";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ContainersRunning_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ContainersRunning")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setContainersRunning(text_element.data().toUInt());
			--ContainersRunning_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (VzConfig_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ContainersInfo': tag 'VzConfig' is absent";
	}

	if (VzNetConfig_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ContainersInfo': tag 'VzNetConfig' is absent";
	}

	if (ContainersRunning_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ContainersInfo': tag 'ContainersRunning' is absent";
	}



	return 0;
}

void ContainersInfo::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void ContainersInfo::Copy(const ContainersInfo& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setVzConfig(rObject.getVzConfig());
	setVzNetConfig(rObject.getVzNetConfig());
	setContainersRunning(rObject.getContainersRunning());

	CustomCopy(&rObject);

}

void ContainersInfo::InitLists()
{
	CustomInit();
}

void ContainersInfo::ClearLists()
{
}

void ContainersInfo::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

