////////////////////////////////////////////////////////////////////////////////
///
/// HiDPIVmSettings.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "HiDPIVmSettings.h"


HiDPIVmSettings::HiDPIVmSettings()
{
	InitLists();
	setDefaults();
}

HiDPIVmSettings::HiDPIVmSettings(const HiDPIVmSettings& rObject)
: CBaseNode()
{
	Copy(rObject);
}

HiDPIVmSettings::HiDPIVmSettings(const HiDPIVmSettings* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

HiDPIVmSettings& HiDPIVmSettings::operator=(const HiDPIVmSettings& rObject)
{
	Copy(rObject);
	return *this;
}

HiDPIVmSettings::HiDPIVmSettings(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

HiDPIVmSettings::~HiDPIVmSettings()
{
	ClearLists();
}


bool HiDPIVmSettings::isEnableHiResDrawing() const
{
	return m_bEnableHiResDrawing;
}

void HiDPIVmSettings::setEnableHiResDrawing(bool value)
{
	m_bEnableHiResDrawing = value;
}

bool HiDPIVmSettings::isUseHiResInGuest() const
{
	return m_bUseHiResInGuest;
}

void HiDPIVmSettings::setUseHiResInGuest(bool value)
{
	m_bUseHiResInGuest = value;
}

void HiDPIVmSettings::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("EnableHiResDrawing").isNull() )
		setEnableHiResDrawing();
	if ( ! RootElement || ! RootElement->firstChildElement("UseHiResInGuest").isNull() )
		setUseHiResInGuest();
}

QDomElement HiDPIVmSettings::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("HiDPIVmSettings") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EnableHiResDrawing");
	text_element = Document->createTextNode( QString("%1").arg(isEnableHiResDrawing()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UseHiResInGuest");
	text_element = Document->createTextNode( QString("%1").arg(isUseHiResInGuest()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int HiDPIVmSettings::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("HiDPIVmSettings") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'HiDPIVmSettings': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int EnableHiResDrawing_count = 0;
	int UseHiResInGuest_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "EnableHiResDrawing";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EnableHiResDrawing_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EnableHiResDrawing")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnableHiResDrawing(text_element.data().toInt() != 0);
			--EnableHiResDrawing_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UseHiResInGuest";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UseHiResInGuest_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UseHiResInGuest")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUseHiResInGuest(text_element.data().toInt() != 0);
			--UseHiResInGuest_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (EnableHiResDrawing_count >= 0)
	{
		m_lstWarningList += "Warning in class 'HiDPIVmSettings': tag 'EnableHiResDrawing' is absent";
	}

	if (UseHiResInGuest_count >= 0)
	{
		m_lstWarningList += "Warning in class 'HiDPIVmSettings': tag 'UseHiResInGuest' is absent";
	}



	return 0;
}

void HiDPIVmSettings::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void HiDPIVmSettings::Copy(const HiDPIVmSettings& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnableHiResDrawing(rObject.isEnableHiResDrawing());
	setUseHiResInGuest(rObject.isUseHiResInGuest());

	CustomCopy(&rObject);

}

void HiDPIVmSettings::InitLists()
{
	CustomInit();
}

void HiDPIVmSettings::ClearLists()
{
}

void HiDPIVmSettings::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

