////////////////////////////////////////////////////////////////////////////////
///
/// UserInfo.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "UserInfo.h"


UserInfo::UserInfo()
{
	InitLists();
	setDefaults();
}

UserInfo::UserInfo(const UserInfo& rObject)
: CBaseNode()
{
	Copy(rObject);
}

UserInfo::UserInfo(const UserInfo* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

UserInfo& UserInfo::operator=(const UserInfo& rObject)
{
	Copy(rObject);
	return *this;
}

UserInfo::UserInfo(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

UserInfo::~UserInfo()
{
	ClearLists();
}


SessionInfoList* UserInfo::getSessionInfoList() const
{
	if (!m_lstSessionInfoList.isEmpty())
	{
		return m_lstSessionInfoList[0];
	}
	return 0;
}

void UserInfo::setSessionInfoList(SessionInfoList* pSessionInfoList)
{
	ClearList<SessionInfoList>(m_lstSessionInfoList);
	if (pSessionInfoList)
	{
		m_lstSessionInfoList += pSessionInfoList;
	}
}

QString UserInfo::getUuid() const
{
	return m_qsUuid;
}

void UserInfo::setUuid(QString value)
{
	m_qsUuid = value;
}

QString UserInfo::getName() const
{
	return m_qsName;
}

void UserInfo::setName(QString value)
{
	m_qsName = value;
}

unsigned int UserInfo::getSessionCount() const
{
	return m_uiSessionCount;
}

void UserInfo::setSessionCount(unsigned int value)
{
	m_uiSessionCount = value;
}

QString UserInfo::getDefaultVmFolder() const
{
	return m_qsDefaultVmFolder;
}

void UserInfo::setDefaultVmFolder(QString value)
{
	m_qsDefaultVmFolder = value;
}

bool UserInfo::isChangeServerSettings() const
{
	return m_bChangeServerSettings;
}

void UserInfo::setChangeServerSettings(bool value)
{
	m_bChangeServerSettings = value;
}

void UserInfo::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid();
	if ( ! RootElement || ! RootElement->firstChildElement("Name").isNull() )
		setName();
	if ( ! RootElement || ! RootElement->firstChildElement("SessionCount").isNull() )
		setSessionCount();
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultVmFolder").isNull() )
		setDefaultVmFolder();
	if ( ! RootElement || ! RootElement->firstChildElement("ChangeServerSettings").isNull() )
		setChangeServerSettings();
}

QDomElement UserInfo::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("UserInfo") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Name");
	text_element = Document->createTextNode( QString("%1").arg(getName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SessionCount");
	text_element = Document->createTextNode( QString("%1").arg(getSessionCount()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultVmFolder");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultVmFolder()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ChangeServerSettings");
	text_element = Document->createTextNode( QString("%1").arg(isChangeServerSettings()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstSessionInfoList.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const SessionInfoList* object = m_lstSessionInfoList[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int UserInfo::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("UserInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'UserInfo': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int SessionInfoList_count = 1;
	int Uuid_count = 1;
	int Name_count = 1;
	int SessionCount_count = 1;
	int DefaultVmFolder_count = 1;
	int ChangeServerSettings_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Name";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Name_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Name")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setName(text_element.data());
			--Name_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SessionCount";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SessionCount_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SessionCount")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSessionCount(text_element.data().toUInt());
			--SessionCount_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultVmFolder";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultVmFolder_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultVmFolder")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultVmFolder(text_element.data());
			--DefaultVmFolder_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ChangeServerSettings";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ChangeServerSettings_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ChangeServerSettings")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setChangeServerSettings(text_element.data().toInt() != 0);
			--ChangeServerSettings_count;
		}


		if (tag_name == "SessionInfoList" && SessionInfoList_count > 0)
		{
			unused_tag = false;
			SessionInfoList* object = m_lstSessionInfoList[1 - SessionInfoList_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--SessionInfoList_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (SessionInfoList_count >= 1)
	{
		m_lstWarningList += "Warning in class 'UserInfo': tag 'SessionInfoList' is absent";
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'UserInfo': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Name_count > 0)
	{
		m_qsErrorMessage = "Error in class 'UserInfo': tag 'Name' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SessionCount_count > 0)
	{
		m_qsErrorMessage = "Error in class 'UserInfo': tag 'SessionCount' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (DefaultVmFolder_count > 0)
	{
		m_qsErrorMessage = "Error in class 'UserInfo': tag 'DefaultVmFolder' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ChangeServerSettings_count > 0)
	{
		m_qsErrorMessage = "Error in class 'UserInfo': tag 'ChangeServerSettings' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void UserInfo::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstSessionInfoList.size(); ++i)
	{
		SessionInfoList* object = m_lstSessionInfoList[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void UserInfo::Copy(const UserInfo& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());
	setName(rObject.getName());
	setSessionCount(rObject.getSessionCount());
	setDefaultVmFolder(rObject.getDefaultVmFolder());
	setChangeServerSettings(rObject.isChangeServerSettings());

	ClearList<SessionInfoList >(m_lstSessionInfoList);
	for(i = 0; i < rObject.m_lstSessionInfoList.size(); i++)
		m_lstSessionInfoList += new SessionInfoList(rObject.m_lstSessionInfoList[i]);

	CustomCopy(&rObject);

}

void UserInfo::InitLists()
{
	InitList<SessionInfoList>(1, m_lstSessionInfoList);
	CustomInit();
}

void UserInfo::ClearLists()
{
	ClearList<SessionInfoList>(m_lstSessionInfoList);
}

void UserInfo::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstSessionInfoList.size() && ! unite_with_loaded; i++)
	{
		m_lstSessionInfoList[i]->ClearListsInReadXml();
		m_lstSessionInfoList[i]->setDefaults();
		m_lstSessionInfoList[i]->setSectionFakeFlag(true);
	}
}

