////////////////////////////////////////////////////////////////////////////////
///
/// AccessControlList.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "AccessControlList.h"


AccessControlList::AccessControlList()
{
	InitLists();
	setDefaults();
}

AccessControlList::AccessControlList(const AccessControlList& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

AccessControlList::AccessControlList(const AccessControlList* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

AccessControlList& AccessControlList::operator=(const AccessControlList& rObject)
{
	Copy(rObject);
	return *this;
}

AccessControlList::AccessControlList(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

AccessControlList::~AccessControlList()
{
	ClearLists();
}


QList<PRL_ALLOWED_VM_COMMAND> AccessControlList::getAccessControl() const
{
	return m_lstAccessControl;
}

void AccessControlList::setAccessControl(QList<PRL_ALLOWED_VM_COMMAND> value)
{
	bool bValueChanged = (m_lstAccessControl != value);
	m_lstAccessControl = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAccessControlChanged(value);
	}
}

void AccessControlList::slotChangeAccessControl(QList<PRL_ALLOWED_VM_COMMAND> value)
{
	setAccessControl(value);
}

void AccessControlList::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || dyn_lists.contains("AccessControl") )
		setAccessControl();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< QList<PRL_ALLOWED_VM_COMMAND> >("QList<PRL_ALLOWED_VM_COMMAND>");
		first_time = false;
	}

}

QVariant AccessControlList::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "AccessControl.patch_stamp")
		value.setValue(getFieldPatchedValue("AccessControl"));

	if (path == "AccessControl")
		value.setValue(getAccessControl());

	return value;
}

bool AccessControlList::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "AccessControl.patch_stamp")
	{
		markPatchedField("AccessControl", value.toString());
		return true;
	}

	if (path == "AccessControl")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAccessControl() != value.value< QList<PRL_ALLOWED_VM_COMMAND> >());
		setAccessControl(value.value< QList<PRL_ALLOWED_VM_COMMAND> >());
		return true;
	}

	return false;
}

QString AccessControlList::getAccessControl_id() const
{
	return getFullItemId().isEmpty() ? "AccessControl" : getFullItemId() + ".AccessControl";
}

int AccessControlList::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool AccessControlList::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement AccessControlList::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("AccessControlList") : m_qsExtRootTagName);

	dyn_lists += "AccessControl";
	for(i = 0; i < m_lstAccessControl.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("AccessControl");
		text_element = Document->createTextNode( QString("%1").arg(m_lstAccessControl[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int AccessControlList::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("AccessControlList") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'AccessControlList': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int AccessControl_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		if (tag_name == "AccessControl")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstAccessControl += (PRL_ALLOWED_VM_COMMAND )text_element.data().toLongLong();
			--AccessControl_count;
		}
		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (AccessControl_count >= 0)
	{
		m_lstWarningList += "Warning in class 'AccessControlList': tag 'AccessControl' is absent";
	}



	return 0;
}

void AccessControlList::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool AccessControlList::merge(AccessControlList* pCur, AccessControlList* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "AccessControlList";

	if (getAccessControl() != pCur->getAccessControl() && getAccessControl() == pPrev->getAccessControl())
		setAccessControl(pCur->getAccessControl());
	else if (getAccessControl() != pCur->getAccessControl() && getAccessControl() != pPrev->getAccessControl() && pCur->getAccessControl() != pPrev->getAccessControl())
	{
		m_qsErrorMessage += ".AccessControl";
		return false;
	}

	return true;
}

void AccessControlList::diff(const AccessControlList* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getAccessControl() != pOld->getAccessControl())
		lstDiffFullItemIds += getAccessControl_id();

}

void AccessControlList::Copy(const AccessControlList& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setAccessControl(rObject.getAccessControl());

	CustomCopy(&rObject);

}

void AccessControlList::InitLists()
{
	CustomInit();
}

void AccessControlList::ClearLists()
{
}

void AccessControlList::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

