////////////////////////////////////////////////////////////////////////////////
///
/// BootDevice.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BootDevice.h"


BootDevice::BootDevice()
{
	InitLists();
	setDefaults();
}

BootDevice::BootDevice(const BootDevice& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

BootDevice::BootDevice(const BootDevice* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BootDevice& BootDevice::operator=(const BootDevice& rObject)
{
	Copy(rObject);
	return *this;
}

BootDevice::BootDevice(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BootDevice::~BootDevice()
{
	ClearLists();
}


unsigned int BootDevice::getIndex() const
{
	return m_uiIndex;
}

void BootDevice::setIndex(unsigned int value)
{
	bool bValueChanged = (m_uiIndex != value);
	m_uiIndex = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalIndexChanged(value);
	}
}

void BootDevice::slotChangeIndex(unsigned int value)
{
	setIndex(value);
}

PRL_DEVICE_TYPE BootDevice::getType() const
{
	return m_ctType;
}

void BootDevice::setType(PRL_DEVICE_TYPE value)
{
	bool bValueChanged = (m_ctType != value);
	m_ctType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTypeChanged(value);
	}
}

void BootDevice::slotChangeType(PRL_DEVICE_TYPE value)
{
	setType(value);
}

unsigned int BootDevice::getBootingNumber() const
{
	return m_uiBootingNumber;
}

void BootDevice::setBootingNumber(unsigned int value)
{
	bool bValueChanged = (m_uiBootingNumber != value);
	m_uiBootingNumber = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalBootingNumberChanged(value);
	}
}

void BootDevice::slotChangeBootingNumber(unsigned int value)
{
	setBootingNumber(value);
}

bool BootDevice::isInUse() const
{
	return m_bInUse;
}

void BootDevice::setInUse(bool value)
{
	bool bValueChanged = (m_bInUse != value);
	m_bInUse = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalInUseChanged(value);
	}
}

void BootDevice::slotChangeInUse(bool value)
{
	setInUse(value);
}

void BootDevice::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Index").isNull() )
		setIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("BootingNumber").isNull() )
		setBootingNumber();
	if ( ! RootElement || ! RootElement->firstChildElement("InUse").isNull() )
		setInUse();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_DEVICE_TYPE >("PRL_DEVICE_TYPE");
		first_time = false;
	}

}

QVariant BootDevice::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Index.patch_stamp")
		value.setValue(getFieldPatchedValue("Index"));

	if (path == "Index")
		value.setValue(getIndex());

	if (path == "Type.patch_stamp")
		value.setValue(getFieldPatchedValue("Type"));

	if (path == "Type")
		value.setValue((qlonglong )getType());

	if (path == "BootingNumber.patch_stamp")
		value.setValue(getFieldPatchedValue("BootingNumber"));

	if (path == "BootingNumber")
		value.setValue(getBootingNumber());

	if (path == "InUse.patch_stamp")
		value.setValue(getFieldPatchedValue("InUse"));

	if (path == "InUse")
		value.setValue(isInUse());

	return value;
}

bool BootDevice::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Index.patch_stamp")
	{
		markPatchedField("Index", value.toString());
		return true;
	}

	if (path == "Index")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIndex() != value.value< unsigned int >());
		setIndex(value.value< unsigned int >());
		return true;
	}

	if (path == "Type.patch_stamp")
	{
		markPatchedField("Type", value.toString());
		return true;
	}

	if (path == "Type")
	{
		if (pbValueChanged)
			*pbValueChanged = (getType() != (PRL_DEVICE_TYPE )value.value< qlonglong >());
		setType((PRL_DEVICE_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "BootingNumber.patch_stamp")
	{
		markPatchedField("BootingNumber", value.toString());
		return true;
	}

	if (path == "BootingNumber")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBootingNumber() != value.value< unsigned int >());
		setBootingNumber(value.value< unsigned int >());
		return true;
	}

	if (path == "InUse.patch_stamp")
	{
		markPatchedField("InUse", value.toString());
		return true;
	}

	if (path == "InUse")
	{
		if (pbValueChanged)
			*pbValueChanged = (isInUse() != value.value< bool >());
		setInUse(value.value< bool >());
		return true;
	}

	return false;
}

QString BootDevice::getIndex_id() const
{
	return getFullItemId().isEmpty() ? "Index" : getFullItemId() + ".Index";
}
QString BootDevice::getType_id() const
{
	return getFullItemId().isEmpty() ? "Type" : getFullItemId() + ".Type";
}
QString BootDevice::getBootingNumber_id() const
{
	return getFullItemId().isEmpty() ? "BootingNumber" : getFullItemId() + ".BootingNumber";
}
QString BootDevice::getInUse_id() const
{
	return getFullItemId().isEmpty() ? "InUse" : getFullItemId() + ".InUse";
}

int BootDevice::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool BootDevice::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement BootDevice::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BootDevice") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Index");
	text_element = Document->createTextNode( QString("%1").arg(getIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BootingNumber");
	text_element = Document->createTextNode( QString("%1").arg(getBootingNumber()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("InUse");
	text_element = Document->createTextNode( QString("%1").arg(isInUse()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BootDevice::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BootDevice") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BootDevice': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Index_count = 1;
	int Type_count = 1;
	int BootingNumber_count = 1;
	int InUse_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIndex(text_element.data().toUInt());
			--Index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType((PRL_DEVICE_TYPE )text_element.data().toLongLong());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "BootingNumber";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BootingNumber_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BootingNumber")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBootingNumber(text_element.data().toUInt());
			--BootingNumber_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "InUse";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (InUse_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "InUse")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setInUse(text_element.data().toInt() != 0);
			--InUse_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BootDevice': tag 'Index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BootDevice': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (BootingNumber_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BootDevice': tag 'BootingNumber' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (InUse_count > 0)
	{
		m_qsErrorMessage = "Error in class 'BootDevice': tag 'InUse' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void BootDevice::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool BootDevice::merge(BootDevice* pCur, BootDevice* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "BootDevice";

	if (getIndex() != pCur->getIndex() && getIndex() == pPrev->getIndex())
		setIndex(pCur->getIndex());
	else if (getIndex() != pCur->getIndex() && getIndex() != pPrev->getIndex() && pCur->getIndex() != pPrev->getIndex())
	{
		m_qsErrorMessage += ".Index";
		return false;
	}

	if (getType() != pCur->getType() && getType() == pPrev->getType())
		setType(pCur->getType());
	else if (getType() != pCur->getType() && getType() != pPrev->getType() && pCur->getType() != pPrev->getType())
	{
		m_qsErrorMessage += ".Type";
		return false;
	}

	if (getBootingNumber() != pCur->getBootingNumber() && getBootingNumber() == pPrev->getBootingNumber())
		setBootingNumber(pCur->getBootingNumber());
	else if (getBootingNumber() != pCur->getBootingNumber() && getBootingNumber() != pPrev->getBootingNumber() && pCur->getBootingNumber() != pPrev->getBootingNumber())
	{
		m_qsErrorMessage += ".BootingNumber";
		return false;
	}

	if (isInUse() != pCur->isInUse() && isInUse() == pPrev->isInUse())
		setInUse(pCur->isInUse());
	else if (isInUse() != pCur->isInUse() && isInUse() != pPrev->isInUse() && pCur->isInUse() != pPrev->isInUse())
	{
		m_qsErrorMessage += ".InUse";
		return false;
	}

	return true;
}

void BootDevice::diff(const BootDevice* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIndex() != pOld->getIndex())
		lstDiffFullItemIds += getIndex_id();

	if (getType() != pOld->getType())
		lstDiffFullItemIds += getType_id();

	if (getBootingNumber() != pOld->getBootingNumber())
		lstDiffFullItemIds += getBootingNumber_id();

	if (isInUse() != pOld->isInUse())
		lstDiffFullItemIds += getInUse_id();

}

void BootDevice::Copy(const BootDevice& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIndex(rObject.getIndex());
	setType(rObject.getType());
	setBootingNumber(rObject.getBootingNumber());
	setInUse(rObject.isInUse());

	CustomCopy(&rObject);

}

void BootDevice::InitLists()
{
	CustomInit();
}

void BootDevice::ClearLists()
{
}

void BootDevice::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

