////////////////////////////////////////////////////////////////////////////////
///
/// BootDevice.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef BOOTDEVICE_H
#define BOOTDEVICE_H


#include <prlcommon/PrlObjects/CBaseNode.h>


class BootDevice : public CBaseNodeSignals
{
	Q_OBJECT

public:

	BootDevice();
	BootDevice(const BootDevice& rObject);
	BootDevice(const BootDevice* pObject);
	BootDevice(QFile* pFile);
	BootDevice& operator=(const BootDevice& rObject);
	virtual ~BootDevice();




	unsigned int getIndex() const;
	void setIndex(unsigned int value = 0);

	PRL_DEVICE_TYPE getType() const;
	void setType(PRL_DEVICE_TYPE value = PDE_HARD_DISK);

	unsigned int getBootingNumber() const;
	void setBootingNumber(unsigned int value = 0);

	bool isInUse() const;
	void setInUse(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getIndex_id() const;
	QString getType_id() const;
	QString getBootingNumber_id() const;
	QString getInUse_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(BootDevice* pCur, BootDevice* pPrev, MergeOptions nOptions);

	void diff(const BootDevice* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	unsigned int		m_uiIndex;
	PRL_DEVICE_TYPE		m_ctType;
	unsigned int		m_uiBootingNumber;
	bool		m_bInUse;

	void Copy(const BootDevice& rObject);

signals:

	void signalIndexChanged(unsigned int value, QString object_id = QString());
	void signalTypeChanged(PRL_DEVICE_TYPE value, QString object_id = QString());
	void signalBootingNumberChanged(unsigned int value, QString object_id = QString());
	void signalInUseChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeIndex(unsigned int value);
	void slotChangeType(PRL_DEVICE_TYPE value);
	void slotChangeBootingNumber(unsigned int value);
	void slotChangeInUse(bool value);

};

#ifndef DM_63217189
#define DM_63217189
Q_DECLARE_METATYPE(PRL_DEVICE_TYPE)
#endif

class CVmBootDeviceBase : public BootDevice
{
public:
	CVmBootDeviceBase()
	: BootDevice(),
	  deviceType(m_ctType),
	  deviceIndex(m_uiIndex),
	  sequenceNumber(m_uiBootingNumber),
	  inUseStatus(m_bInUse)
	{
	}
	CVmBootDeviceBase(const CVmBootDeviceBase& bd)
	: BootDevice(bd),
	  deviceType(m_ctType),
	  deviceIndex(m_uiIndex),
	  sequenceNumber(m_uiBootingNumber),
	  inUseStatus(m_bInUse)
	{
	}
	CVmBootDeviceBase(const CVmBootDeviceBase* pBd)
	: BootDevice(pBd),
	  deviceType(m_ctType),
	  deviceIndex(m_uiIndex),
	  sequenceNumber(m_uiBootingNumber),
	  inUseStatus(m_bInUse)
	{
	}
	virtual ~CVmBootDeviceBase()
	{
	}
	CVmBootDeviceBase( PRL_DEVICE_TYPE devType, uint devIdx, uint numb, bool inUse ) :
	deviceType(m_ctType),
	deviceIndex(m_uiIndex),
	sequenceNumber(m_uiBootingNumber),
	inUseStatus(m_bInUse)
	{
		deviceType =  devType;
		deviceIndex = devIdx;
		sequenceNumber = numb;
		inUseStatus = inUse;
	}
	// compare operator
	bool operator==( const CVmBootDeviceBase& cVmBootDevice)
	{
		if ((deviceType == cVmBootDevice.deviceType) &&
		(deviceIndex == cVmBootDevice.deviceIndex) &&
		(sequenceNumber == cVmBootDevice.sequenceNumber) &&
		(inUseStatus == cVmBootDevice.inUseStatus)
		)
			return true;
		return false;
	};
public:
        // Device type
        PRL_DEVICE_TYPE& deviceType;
        // Device index
        uint& deviceIndex;
        // Number of this device in the booting sequence
        uint& sequenceNumber;
        // A flag shows either the device is used in the booting process
        bool& inUseStatus;
};


#endif
