////////////////////////////////////////////////////////////////////////////////
///
/// BootingOrder.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "BootingOrder.h"


BootingOrder::BootingOrder()
{
	InitLists();
	setDefaults();
}

BootingOrder::BootingOrder(const BootingOrder& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

BootingOrder::BootingOrder(const BootingOrder* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

BootingOrder& BootingOrder::operator=(const BootingOrder& rObject)
{
	Copy(rObject);
	return *this;
}

BootingOrder::BootingOrder(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

BootingOrder::~BootingOrder()
{
	ClearLists();
}


void BootingOrder::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant BootingOrder::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "BootDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i] && nItemId == m_lstBootDevice[i]->getItemId())
				return m_lstBootDevice[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("BootDevice.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i] && nMaxId < m_lstBootDevice[i]->getItemId())
				nMaxId = m_lstBootDevice[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("BootDevice.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i]) lstIds += m_lstBootDevice[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool BootingOrder::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "BootDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i] && nItemId == m_lstBootDevice[i]->getItemId())
				return m_lstBootDevice[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

int BootingOrder::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "BootDevice")
	{
		m_lstBootDevice += new CVmBootDeviceBase;
		nNewItemId = getMaxItemId<CVmBootDeviceBase>(m_lstBootDevice, "BootDevice");
		m_lstBootDevice.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "BootDevice");
	}

	list_tag = "BootDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i] && nItemId == m_lstBootDevice[i]->getItemId())
				return m_lstBootDevice[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool BootingOrder::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "BootDevice[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstBootDevice.size(); ++i)
			if (m_lstBootDevice[i] && nItemId == m_lstBootDevice[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstBootDevice[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstBootDevice.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement BootingOrder::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("BootingOrder") : m_qsExtRootTagName);

	dyn_lists += "BootDevice";
	nMaxItemId = getMaxItemId<CVmBootDeviceBase>(m_lstBootDevice, "BootDevice", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstBootDevice.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmBootDeviceBase* object = m_lstBootDevice[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "BootDevice", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int BootingOrder::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("BootingOrder") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'BootingOrder': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_BootDevice = getMaxItemId2(element, "BootDevice");
	QMap<int , QString > mapBootDevice;
	if (unite_with_loaded)
		fillItemIdMap<CVmBootDeviceBase>(m_lstBootDevice, mapBootDevice);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int BootDevice_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "BootDevice")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_BootDevice++ : nItemId;
			CVmBootDeviceBase* object = new CVmBootDeviceBase();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "BootDevice", object->getItemId());
			if (unite_with_loaded && mapBootDevice.contains(nItemId))
				object->fromString(mapBootDevice.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstBootDevice += object;
			--BootDevice_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (BootDevice_count >= 0)
	{
		m_lstWarningList += "Warning in class 'BootingOrder': tag 'BootDevice' is absent";
	}

	syncMaxItemId(nMaxItemId_BootDevice, "BootDevice");


	return 0;
}

void BootingOrder::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CVmBootDeviceBase>(m_lstBootDevice, "BootDevice");
	setItemIds.clear();
	for(i = 0; i < m_lstBootDevice.size(); ++i)
	{
		CVmBootDeviceBase* object = m_lstBootDevice[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "BootDevice", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "BootDevice");

}

bool BootingOrder::merge(BootingOrder* pCur, BootingOrder* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "BootingOrder";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if ( ! mergeList<CVmBootDeviceBase>(m_lstBootDevice, pCur->m_lstBootDevice, pPrev->m_lstBootDevice, "BootDevice", nOptions) )
		return false;

	return true;
}

void BootingOrder::diff(const BootingOrder* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	diffList<CVmBootDeviceBase>(m_lstBootDevice, pOld->m_lstBootDevice, lstDiffFullItemIds);

}

void BootingOrder::Copy(const BootingOrder& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CVmBootDeviceBase >(m_lstBootDevice);
	for(i = 0; i < rObject.m_lstBootDevice.size(); i++)
		m_lstBootDevice += new CVmBootDeviceBase(rObject.m_lstBootDevice[i]);

	CustomCopy(&rObject);

}

void BootingOrder::InitLists()
{
	CustomInit();
}

void BootingOrder::ClearLists()
{
	ClearList<CVmBootDeviceBase>(m_lstBootDevice);
}

void BootingOrder::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("BootDevice") )
		ClearList<CVmBootDeviceBase>(m_lstBootDevice);
}

