////////////////////////////////////////////////////////////////////////////////
///
/// CVaConfig.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVACONFIG_H
#define CVACONFIG_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVaLicences.h"
#include "CVaRequirements.h"
#include "CVaAdminInterface.h"


class CVaConfig : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVaConfig();
	CVaConfig(const CVaConfig& rObject);
	CVaConfig(const CVaConfig* pObject);
	CVaConfig(QFile* pFile);
	CVaConfig& operator=(const CVaConfig& rObject);
	virtual ~CVaConfig();


	const QList<CVaAdminInterface* >* getAdminInterfaces() const
	{ return &m_lstAdminInterfaces; }
	void addAdminInterface( CVaAdminInterface* value )
	{ m_lstAdminInterfaces.append( value ); }
	void clearAdminInterfaces();

	const QStringList* getDownloadUrls() const
	{ return (QStringList* )&m_lstDownloadURL; }
	void addDownloadUrl( const QString& value )
	{ m_lstDownloadURL.append( value ); }
	void deleteDownloadUrl( const QString& value )
	{ m_lstDownloadURL.removeAll( value ); }
	bool hasDownloadUrl( const QString& value )
	{ return m_lstDownloadURL.contains( value ); }
	void clearDownloadUrls() { m_lstDownloadURL.clear(); }

	QList<CVaLicences* >		m_lstLicences;
	QList<CVaRequirements* >		m_lstRequirements;
	QList<CVaAdminInterface* >		m_lstAdminInterfaces;

	CVaLicences* getLicences() const;
	void setLicences(CVaLicences* pLicences);

	CVaRequirements* getRequirements() const;
	void setRequirements(CVaRequirements* pRequirements);


	PVE::VaCategory getCategory() const;
	void setCategory(PVE::VaCategory value = PVE::VaCategoryDevelopment);

	QString getTitle() const;
	void setTitle(QString value = QString());

	QString getAbstract() const;
	void setAbstract(QString value = QString());

	PVE::VaDevelopmentStatus getDevelopmentStatus() const;
	void setDevelopmentStatus(PVE::VaDevelopmentStatus value = PVE::VaDevelopmentStatusDevelopment);

	QString getVersion() const;
	void setVersion(QString value = QString());

	QString getLastUpdate() const;
	void setLastUpdate(QString value = QString());

	QString getOsUtilized() const;
	void setOsUtilized(QString value = QString());

	QString getPackageSize() const;
	void setPackageSize(QString value = QString());

	QString getDescription() const;
	void setDescription(QString value = QString());

	QString getToolsVersion() const;
	void setToolsVersion(QString value = QString());

	QList<QString> getDownloadURL() const;
	void setDownloadURL(QList<QString> value = QList<QString>());

	QString getAuthorName() const;
	void setAuthorName(QString value = QString());

	QString getAuthorEmail() const;
	void setAuthorEmail(QString value = QString());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getCategory_id() const;
	QString getTitle_id() const;
	QString getAbstract_id() const;
	QString getDevelopmentStatus_id() const;
	QString getVersion_id() const;
	QString getLastUpdate_id() const;
	QString getOsUtilized_id() const;
	QString getPackageSize_id() const;
	QString getDescription_id() const;
	QString getToolsVersion_id() const;
	QString getDownloadURL_id() const;
	QString getAuthorName_id() const;
	QString getAuthorEmail_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVaConfig* pCur, CVaConfig* pPrev, MergeOptions nOptions);

	void diff(const CVaConfig* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PVE::VaCategory		m_ctCategory;
	QString		m_qsTitle;
	QString		m_qsAbstract;
	PVE::VaDevelopmentStatus		m_ctDevelopmentStatus;
	QString		m_qsVersion;
	QString		m_qsLastUpdate;
	QString		m_qsOsUtilized;
	QString		m_qsPackageSize;
	QString		m_qsDescription;
	QString		m_qsToolsVersion;
	QList<QString>		m_lstDownloadURL;
	QString		m_qsAuthorName;
	QString		m_qsAuthorEmail;

	void Copy(const CVaConfig& rObject);

signals:

	void signalCategoryChanged(PVE::VaCategory value, QString object_id = QString());
	void signalTitleChanged(QString value, QString object_id = QString());
	void signalAbstractChanged(QString value, QString object_id = QString());
	void signalDevelopmentStatusChanged(PVE::VaDevelopmentStatus value, QString object_id = QString());
	void signalVersionChanged(QString value, QString object_id = QString());
	void signalLastUpdateChanged(QString value, QString object_id = QString());
	void signalOsUtilizedChanged(QString value, QString object_id = QString());
	void signalPackageSizeChanged(QString value, QString object_id = QString());
	void signalDescriptionChanged(QString value, QString object_id = QString());
	void signalToolsVersionChanged(QString value, QString object_id = QString());
	void signalDownloadURLChanged(QList<QString> value, QString object_id = QString());
	void signalAuthorNameChanged(QString value, QString object_id = QString());
	void signalAuthorEmailChanged(QString value, QString object_id = QString());

private slots:

	void slotChangeCategory(PVE::VaCategory value);
	void slotChangeTitle(QString value);
	void slotChangeAbstract(QString value);
	void slotChangeDevelopmentStatus(PVE::VaDevelopmentStatus value);
	void slotChangeVersion(QString value);
	void slotChangeLastUpdate(QString value);
	void slotChangeOsUtilized(QString value);
	void slotChangePackageSize(QString value);
	void slotChangeDescription(QString value);
	void slotChangeToolsVersion(QString value);
	void slotChangeDownloadURL(QList<QString> value);
	void slotChangeAuthorName(QString value);
	void slotChangeAuthorEmail(QString value);

};

#ifndef DM_152386329
#define DM_152386329
Q_DECLARE_METATYPE(PVE::VaCategory)
#endif
#ifndef DM_81503939
#define DM_81503939
Q_DECLARE_METATYPE(PVE::VaDevelopmentStatus)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif


#endif
