////////////////////////////////////////////////////////////////////////////////
///
/// CVaRequirements.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVaRequirements.h"


CVaRequirements::CVaRequirements()
{
	InitLists();
	setDefaults();
}

CVaRequirements::CVaRequirements(const CVaRequirements& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVaRequirements::CVaRequirements(const CVaRequirements* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVaRequirements& CVaRequirements::operator=(const CVaRequirements& rObject)
{
	Copy(rObject);
	return *this;
}

CVaRequirements::CVaRequirements(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVaRequirements::~CVaRequirements()
{
	ClearLists();
}


QString CVaRequirements::getCpuType() const
{
	return m_qsCPU;
}

void CVaRequirements::setCpuType(QString value)
{
	bool bValueChanged = (m_qsCPU != value);
	m_qsCPU = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuTypeChanged(value);
	}
}

void CVaRequirements::slotChangeCpuType(QString value)
{
	setCpuType(value);
}

QString CVaRequirements::getMemorySize() const
{
	return m_qsMemory;
}

void CVaRequirements::setMemorySize(QString value)
{
	bool bValueChanged = (m_qsMemory != value);
	m_qsMemory = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalMemorySizeChanged(value);
	}
}

void CVaRequirements::slotChangeMemorySize(QString value)
{
	setMemorySize(value);
}

QString CVaRequirements::getDiskSize() const
{
	return m_qsDisk;
}

void CVaRequirements::setDiskSize(QString value)
{
	bool bValueChanged = (m_qsDisk != value);
	m_qsDisk = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDiskSizeChanged(value);
	}
}

void CVaRequirements::slotChangeDiskSize(QString value)
{
	setDiskSize(value);
}

QString CVaRequirements::getOther() const
{
	return m_qsOther;
}

void CVaRequirements::setOther(QString value)
{
	bool bValueChanged = (m_qsOther != value);
	m_qsOther = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOtherChanged(value);
	}
}

void CVaRequirements::slotChangeOther(QString value)
{
	setOther(value);
}

void CVaRequirements::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("CPU").isNull() )
		setCpuType();
	if ( ! RootElement || ! RootElement->firstChildElement("Memory").isNull() )
		setMemorySize();
	if ( ! RootElement || ! RootElement->firstChildElement("Disk").isNull() )
		setDiskSize();
	if ( ! RootElement || ! RootElement->firstChildElement("Other").isNull() )
		setOther();
}

QVariant CVaRequirements::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "CPU.patch_stamp")
		value.setValue(getFieldPatchedValue("CPU"));

	if (path == "CPU")
		value.setValue(getCpuType());

	if (path == "Memory.patch_stamp")
		value.setValue(getFieldPatchedValue("Memory"));

	if (path == "Memory")
		value.setValue(getMemorySize());

	if (path == "Disk.patch_stamp")
		value.setValue(getFieldPatchedValue("Disk"));

	if (path == "Disk")
		value.setValue(getDiskSize());

	if (path == "Other.patch_stamp")
		value.setValue(getFieldPatchedValue("Other"));

	if (path == "Other")
		value.setValue(getOther());

	return value;
}

bool CVaRequirements::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "CPU.patch_stamp")
	{
		markPatchedField("CPU", value.toString());
		return true;
	}

	if (path == "CPU")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuType() != value.value< QString >());
		setCpuType(value.value< QString >());
		return true;
	}

	if (path == "Memory.patch_stamp")
	{
		markPatchedField("Memory", value.toString());
		return true;
	}

	if (path == "Memory")
	{
		if (pbValueChanged)
			*pbValueChanged = (getMemorySize() != value.value< QString >());
		setMemorySize(value.value< QString >());
		return true;
	}

	if (path == "Disk.patch_stamp")
	{
		markPatchedField("Disk", value.toString());
		return true;
	}

	if (path == "Disk")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDiskSize() != value.value< QString >());
		setDiskSize(value.value< QString >());
		return true;
	}

	if (path == "Other.patch_stamp")
	{
		markPatchedField("Other", value.toString());
		return true;
	}

	if (path == "Other")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOther() != value.value< QString >());
		setOther(value.value< QString >());
		return true;
	}

	return false;
}

QString CVaRequirements::getCpuType_id() const
{
	return getFullItemId().isEmpty() ? "CPU" : getFullItemId() + ".CPU";
}
QString CVaRequirements::getMemorySize_id() const
{
	return getFullItemId().isEmpty() ? "Memory" : getFullItemId() + ".Memory";
}
QString CVaRequirements::getDiskSize_id() const
{
	return getFullItemId().isEmpty() ? "Disk" : getFullItemId() + ".Disk";
}
QString CVaRequirements::getOther_id() const
{
	return getFullItemId().isEmpty() ? "Other" : getFullItemId() + ".Other";
}

int CVaRequirements::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVaRequirements::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVaRequirements::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Requirements") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CPU");
	text_element = Document->createTextNode( QString("%1").arg(getCpuType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Memory");
	text_element = Document->createTextNode( QString("%1").arg(getMemorySize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Disk");
	text_element = Document->createTextNode( QString("%1").arg(getDiskSize()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Other");
	text_element = Document->createTextNode( QString("%1").arg(getOther()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVaRequirements::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Requirements") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVaRequirements': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int CPU_count = 1;
	int Memory_count = 1;
	int Disk_count = 1;
	int Other_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "CPU";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CPU_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CPU")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuType(text_element.data());
			--CPU_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Memory";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Memory_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Memory")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMemorySize(text_element.data());
			--Memory_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Disk";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Disk_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Disk")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDiskSize(text_element.data());
			--Disk_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Other";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Other_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Other")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOther(text_element.data());
			--Other_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (CPU_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVaRequirements': tag 'CPU' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Memory_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVaRequirements': tag 'Memory' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Disk_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVaRequirements': tag 'Disk' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Other_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVaRequirements': tag 'Other' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void CVaRequirements::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVaRequirements::merge(CVaRequirements* pCur, CVaRequirements* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Requirements";

	if (getCpuType() != pCur->getCpuType() && getCpuType() == pPrev->getCpuType())
		setCpuType(pCur->getCpuType());
	else if (getCpuType() != pCur->getCpuType() && getCpuType() != pPrev->getCpuType() && pCur->getCpuType() != pPrev->getCpuType())
	{
		m_qsErrorMessage += ".CPU";
		return false;
	}

	if (getMemorySize() != pCur->getMemorySize() && getMemorySize() == pPrev->getMemorySize())
		setMemorySize(pCur->getMemorySize());
	else if (getMemorySize() != pCur->getMemorySize() && getMemorySize() != pPrev->getMemorySize() && pCur->getMemorySize() != pPrev->getMemorySize())
	{
		m_qsErrorMessage += ".Memory";
		return false;
	}

	if (getDiskSize() != pCur->getDiskSize() && getDiskSize() == pPrev->getDiskSize())
		setDiskSize(pCur->getDiskSize());
	else if (getDiskSize() != pCur->getDiskSize() && getDiskSize() != pPrev->getDiskSize() && pCur->getDiskSize() != pPrev->getDiskSize())
	{
		m_qsErrorMessage += ".Disk";
		return false;
	}

	if (getOther() != pCur->getOther() && getOther() == pPrev->getOther())
		setOther(pCur->getOther());
	else if (getOther() != pCur->getOther() && getOther() != pPrev->getOther() && pCur->getOther() != pPrev->getOther())
	{
		m_qsErrorMessage += ".Other";
		return false;
	}

	return true;
}

void CVaRequirements::diff(const CVaRequirements* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getCpuType() != pOld->getCpuType())
		lstDiffFullItemIds += getCpuType_id();

	if (getMemorySize() != pOld->getMemorySize())
		lstDiffFullItemIds += getMemorySize_id();

	if (getDiskSize() != pOld->getDiskSize())
		lstDiffFullItemIds += getDiskSize_id();

	if (getOther() != pOld->getOther())
		lstDiffFullItemIds += getOther_id();

}

void CVaRequirements::Copy(const CVaRequirements& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setCpuType(rObject.getCpuType());
	setMemorySize(rObject.getMemorySize());
	setDiskSize(rObject.getDiskSize());
	setOther(rObject.getOther());

	CustomCopy(&rObject);

}

void CVaRequirements::InitLists()
{
	CustomInit();
}

void CVaRequirements::ClearLists()
{
}

void CVaRequirements::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

