////////////////////////////////////////////////////////////////////////////////
///
/// CVmConfiguration.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmConfiguration.h"


CVmConfiguration::CVmConfiguration()
{
	InitLists();
	setDefaults();
}

CVmConfiguration::CVmConfiguration(const CVmConfiguration& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmConfiguration::CVmConfiguration(const CVmConfiguration* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmConfiguration& CVmConfiguration::operator=(const CVmConfiguration& rObject)
{
	Copy(rObject);
	return *this;
}

CVmConfiguration::CVmConfiguration(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmConfiguration::~CVmConfiguration()
{
	ClearLists();
}


bool CVmConfiguration::hasEnabledGenericPciDevices() const
{
	CVmHardware* pHwList = getVmHardwareList();
	foreach( CVmGenericPciDevice* pVmDev, pHwList->m_lstGenericPciDevices )
	{
		if( pVmDev->getEnabled() != PVE::DeviceEnabled )
			continue;
		return true;
	}

	foreach( CVmPciVideoAdapter* pVmDev, pHwList->m_lstPciVideoAdapters )
	{
		if( pVmDev->getEnabled() != PVE::DeviceEnabled )
			continue;
		return true;
	}

	foreach( CVmGenericNetworkAdapter* pVmDev, pHwList->m_lstNetworkAdapters )
	{
		if( pVmDev->getEnabled() != PVE::DeviceEnabled )
			continue;

		if(pVmDev->getEmulatedType() != PNA_DIRECT_ASSIGN)
			continue;

		return true;
	}

	return false;
}

int CVmConfiguration::readXml(QDomDocument* Document)
{
    QDomElement element = Document->firstChildElement();
    return readXml(&element);
}

int CVmConfiguration::saveToFile(QFile* config_file, bool do_replace, bool BNeedToSaveRelativePath)
{

	m_qsFileName = config_file->fileName();

    if (BNeedToSaveRelativePath)
		setRelativePath();

    int res = CBaseNode::saveToFile(config_file, do_replace, BNeedToSaveRelativePath);

    if (BNeedToSaveRelativePath)
		setAbsolutePath();
    return res;
}

int CVmConfiguration::saveToFile(QString config_file, bool do_replace, bool BNeedToSaveRelativePath)
{
    QFile outFile( config_file );
    return this->saveToFile( &outFile, do_replace,BNeedToSaveRelativePath);;
}

int CVmConfiguration::loadFromFile(QFile* config_file, bool BNeedLoadRelativePath)
{
    if ( CBaseNode::loadFromFile(config_file) )
    {
        return PRL_ERR_PARSE_VM_CONFIG;
    }

    if (BNeedLoadRelativePath)
		setAbsolutePath();
    return 0;
}

void CVmConfiguration::setRelativePath(const QString& home_)
{
	CVmHardware* pHwList = getVmHardwareList();
	if (pHwList)
		pHwList->SetDevicesPathToRelative(home_.isEmpty() ? getConfigDirectory() : home_);

	CVmStartupBios* bios = getVmSettings()->getVmStartupOptions()->getBios();
	if (!QFileInfo(bios->getNVRAM()).isRelative())
		bios->setNVRAM(QDir(getConfigDirectory()).relativeFilePath(bios->getNVRAM()));
}

void CVmConfiguration::setAbsolutePath()
{
	CVmHardware* pHwList = getVmHardwareList();
	if (pHwList)
		pHwList->RevertDevicesPathToAbsolute(getConfigDirectory());

	CVmStartupBios* bios = getVmSettings()->getVmStartupOptions()->getBios();
	if (!bios->getNVRAM().isEmpty() && QFileInfo(bios->getNVRAM()).isRelative())
		bios->setNVRAM(QDir(getConfigDirectory()).absoluteFilePath(bios->getNVRAM()));
}

#include "Build/Current.ver"
QString CVmConfiguration::makeAppVersion()
{
	return QString( "%1" ).arg( VER_FULL_BUILD_NUMBER_STR );
}

QString CVmConfiguration::getConfigDirectory() const
{
    QString strVmDir = this->getOutFileName();
    strVmDir = QDir::fromNativeSeparators( strVmDir );
    strVmDir = QFileInfo(strVmDir).dir().absolutePath();
    return strVmDir;
}

CVmIdentification* CVmConfiguration::getVmIdentification() const
{
	if (!m_lstIdentification.isEmpty())
	{
		return m_lstIdentification[0];
	}
	return 0;
}

void CVmConfiguration::setVmIdentification(CVmIdentification* pIdentification)
{
	ClearList<CVmIdentification>(m_lstIdentification);
	if (pIdentification)
	{
		m_lstIdentification += pIdentification;
	}
}

CVmSecurity* CVmConfiguration::getVmSecurity() const
{
	if (!m_lstSecurity.isEmpty())
	{
		return m_lstSecurity[0];
	}
	return 0;
}

void CVmConfiguration::setVmSecurity(CVmSecurity* pSecurity)
{
	ClearList<CVmSecurity>(m_lstSecurity);
	if (pSecurity)
	{
		m_lstSecurity += pSecurity;
	}
}

CVmSettings* CVmConfiguration::getVmSettings() const
{
	if (!m_lstSettings.isEmpty())
	{
		return m_lstSettings[0];
	}
	return 0;
}

void CVmConfiguration::setVmSettings(CVmSettings* pSettings)
{
	ClearList<CVmSettings>(m_lstSettings);
	if (pSettings)
	{
		m_lstSettings += pSettings;
	}
}

CCtSettings* CVmConfiguration::getCtSettings() const
{
	if (!m_lstCtSettings.isEmpty())
	{
		return m_lstCtSettings[0];
	}
	return 0;
}

void CVmConfiguration::setCtSettings(CCtSettings* pCtSettings)
{
	ClearList<CCtSettings>(m_lstCtSettings);
	if (pCtSettings)
	{
		m_lstCtSettings += pCtSettings;
	}
}

CVmHardware* CVmConfiguration::getVmHardwareList() const
{
	if (!m_lstHardware.isEmpty())
	{
		return m_lstHardware[0];
	}
	return 0;
}

void CVmConfiguration::setVmHardwareList(CVmHardware* pHardware)
{
	ClearList<CVmHardware>(m_lstHardware);
	if (pHardware)
	{
		m_lstHardware += pHardware;
	}
}

CVaConfig* CVmConfiguration::getVaConfig() const
{
	if (!m_lstVirtualAppliance.isEmpty())
	{
		return m_lstVirtualAppliance[0];
	}
	return 0;
}

void CVmConfiguration::setVaConfig(CVaConfig* pVirtualAppliance)
{
	ClearList<CVaConfig>(m_lstVirtualAppliance);
	if (pVirtualAppliance)
	{
		m_lstVirtualAppliance += pVirtualAppliance;
	}
}

QString CVmConfiguration::getAppVersion() const
{
	return m_qsAppVersion;
}

void CVmConfiguration::setAppVersion(QString value)
{
	bool bValueChanged = (m_qsAppVersion != value);
	m_qsAppVersion = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAppVersionChanged(value);
	}
}

void CVmConfiguration::slotChangeAppVersion(QString value)
{
	setAppVersion(value);
}

unsigned int CVmConfiguration::getValidRc() const
{
	return m_uiValidRc;
}

void CVmConfiguration::setValidRc(unsigned int value)
{
	bool bValueChanged = (m_uiValidRc != value);
	m_uiValidRc = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalValidRcChanged(value);
	}
}

void CVmConfiguration::slotChangeValidRc(unsigned int value)
{
	setValidRc(value);
}

PRL_VM_TYPE CVmConfiguration::getVmType() const
{
	return m_ctVmType;
}

void CVmConfiguration::setVmType(PRL_VM_TYPE value)
{
	bool bValueChanged = (m_ctVmType != value);
	m_ctVmType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalVmTypeChanged(value);
	}
}

void CVmConfiguration::slotChangeVmType(PRL_VM_TYPE value)
{
	setVmType(value);
}

unsigned int CVmConfiguration::getInstalledSoftware() const
{
	return m_uiInstalledSoftware;
}

void CVmConfiguration::setInstalledSoftware(unsigned int value)
{
	bool bValueChanged = (m_uiInstalledSoftware != value);
	m_uiInstalledSoftware = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalInstalledSoftwareChanged(value);
	}
}

void CVmConfiguration::slotChangeInstalledSoftware(unsigned int value)
{
	setInstalledSoftware(value);
}

void CVmConfiguration::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("AppVersion").isNull() )
		setAppVersion(makeAppVersion());
	if ( ! RootElement || ! RootElement->firstChildElement("ValidRc").isNull() )
		setValidRc();
	if ( ! RootElement || ! RootElement->firstChildElement("VmType").isNull() )
		setVmType();
	if ( ! RootElement || ! RootElement->firstChildElement("InstalledSoftware").isNull() )
		setInstalledSoftware();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_VM_TYPE >("PRL_VM_TYPE");
		first_time = false;
	}

}

QVariant CVmConfiguration::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "AppVersion.patch_stamp")
		value.setValue(getFieldPatchedValue("AppVersion"));

	if (path == "AppVersion")
		value.setValue(getAppVersion());

	if (path == "ValidRc.patch_stamp")
		value.setValue(getFieldPatchedValue("ValidRc"));

	if (path == "ValidRc")
		value.setValue(getValidRc());

	if (path == "VmType.patch_stamp")
		value.setValue(getFieldPatchedValue("VmType"));

	if (path == "VmType")
		value.setValue((qlonglong )getVmType());

	if (path == "InstalledSoftware.patch_stamp")
		value.setValue(getFieldPatchedValue("InstalledSoftware"));

	if (path == "InstalledSoftware")
		value.setValue(getInstalledSoftware());

	list_tag = "Identification.";
	if (path.startsWith(list_tag) && ! m_lstIdentification.isEmpty() && m_lstIdentification.first())
		return m_lstIdentification.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Security.";
	if (path.startsWith(list_tag) && ! m_lstSecurity.isEmpty() && m_lstSecurity.first())
		return m_lstSecurity.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Settings.";
	if (path.startsWith(list_tag) && ! m_lstSettings.isEmpty() && m_lstSettings.first())
		return m_lstSettings.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "CtSettings.";
	if (path.startsWith(list_tag) && ! m_lstCtSettings.isEmpty() && m_lstCtSettings.first())
		return m_lstCtSettings.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Hardware.";
	if (path.startsWith(list_tag) && ! m_lstHardware.isEmpty() && m_lstHardware.first())
		return m_lstHardware.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "VirtualAppliance[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i] && nItemId == m_lstVirtualAppliance[i]->getItemId())
				return m_lstVirtualAppliance[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("VirtualAppliance.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i] && nMaxId < m_lstVirtualAppliance[i]->getItemId())
				nMaxId = m_lstVirtualAppliance[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("VirtualAppliance.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i]) lstIds += m_lstVirtualAppliance[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmConfiguration::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "AppVersion.patch_stamp")
	{
		markPatchedField("AppVersion", value.toString());
		return true;
	}

	if (path == "AppVersion")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAppVersion() != value.value< QString >());
		setAppVersion(value.value< QString >());
		return true;
	}

	if (path == "ValidRc.patch_stamp")
	{
		markPatchedField("ValidRc", value.toString());
		return true;
	}

	if (path == "ValidRc")
	{
		if (pbValueChanged)
			*pbValueChanged = (getValidRc() != value.value< unsigned int >());
		setValidRc(value.value< unsigned int >());
		return true;
	}

	if (path == "VmType.patch_stamp")
	{
		markPatchedField("VmType", value.toString());
		return true;
	}

	if (path == "VmType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getVmType() != (PRL_VM_TYPE )value.value< qlonglong >());
		setVmType((PRL_VM_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "InstalledSoftware.patch_stamp")
	{
		markPatchedField("InstalledSoftware", value.toString());
		return true;
	}

	if (path == "InstalledSoftware")
	{
		if (pbValueChanged)
			*pbValueChanged = (getInstalledSoftware() != value.value< unsigned int >());
		setInstalledSoftware(value.value< unsigned int >());
		return true;
	}

	list_tag = "Identification.";
	if (path.startsWith(list_tag) && ! m_lstIdentification.isEmpty() && m_lstIdentification.first())
		return m_lstIdentification.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Security.";
	if (path.startsWith(list_tag) && ! m_lstSecurity.isEmpty() && m_lstSecurity.first())
		return m_lstSecurity.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Settings.";
	if (path.startsWith(list_tag) && ! m_lstSettings.isEmpty() && m_lstSettings.first())
		return m_lstSettings.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "CtSettings.";
	if (path.startsWith(list_tag) && ! m_lstCtSettings.isEmpty() && m_lstCtSettings.first())
		return m_lstCtSettings.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Hardware.";
	if (path.startsWith(list_tag) && ! m_lstHardware.isEmpty() && m_lstHardware.first())
		return m_lstHardware.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "VirtualAppliance[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i] && nItemId == m_lstVirtualAppliance[i]->getItemId())
				return m_lstVirtualAppliance[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVmConfiguration::getAppVersion_id() const
{
	return getFullItemId().isEmpty() ? "AppVersion" : getFullItemId() + ".AppVersion";
}
QString CVmConfiguration::getValidRc_id() const
{
	return getFullItemId().isEmpty() ? "ValidRc" : getFullItemId() + ".ValidRc";
}
QString CVmConfiguration::getVmType_id() const
{
	return getFullItemId().isEmpty() ? "VmType" : getFullItemId() + ".VmType";
}
QString CVmConfiguration::getInstalledSoftware_id() const
{
	return getFullItemId().isEmpty() ? "InstalledSoftware" : getFullItemId() + ".InstalledSoftware";
}

int CVmConfiguration::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Identification.";
	if (path.startsWith(list_tag) && ! m_lstIdentification.isEmpty() && m_lstIdentification.first())
		return m_lstIdentification.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Security.";
	if (path.startsWith(list_tag) && ! m_lstSecurity.isEmpty() && m_lstSecurity.first())
		return m_lstSecurity.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Settings.";
	if (path.startsWith(list_tag) && ! m_lstSettings.isEmpty() && m_lstSettings.first())
		return m_lstSettings.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "CtSettings.";
	if (path.startsWith(list_tag) && ! m_lstCtSettings.isEmpty() && m_lstCtSettings.first())
		return m_lstCtSettings.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Hardware.";
	if (path.startsWith(list_tag) && ! m_lstHardware.isEmpty() && m_lstHardware.first())
		return m_lstHardware.first()->addListItem(path.mid(list_tag.size()));

	if (path == "VirtualAppliance")
	{
		m_lstVirtualAppliance += new CVaConfig;
		nNewItemId = getMaxItemId<CVaConfig>(m_lstVirtualAppliance, "VirtualAppliance");
		m_lstVirtualAppliance.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "VirtualAppliance");
	}

	list_tag = "VirtualAppliance[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i] && nItemId == m_lstVirtualAppliance[i]->getItemId())
				return m_lstVirtualAppliance[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmConfiguration::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Identification.";
	if (path.startsWith(list_tag) && ! m_lstIdentification.isEmpty() && m_lstIdentification.first())
		return m_lstIdentification.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Security.";
	if (path.startsWith(list_tag) && ! m_lstSecurity.isEmpty() && m_lstSecurity.first())
		return m_lstSecurity.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Settings.";
	if (path.startsWith(list_tag) && ! m_lstSettings.isEmpty() && m_lstSettings.first())
		return m_lstSettings.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "CtSettings.";
	if (path.startsWith(list_tag) && ! m_lstCtSettings.isEmpty() && m_lstCtSettings.first())
		return m_lstCtSettings.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Hardware.";
	if (path.startsWith(list_tag) && ! m_lstHardware.isEmpty() && m_lstHardware.first())
		return m_lstHardware.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "VirtualAppliance[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVirtualAppliance.size(); ++i)
			if (m_lstVirtualAppliance[i] && nItemId == m_lstVirtualAppliance[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstVirtualAppliance[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstVirtualAppliance.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmConfiguration::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ParallelsVirtualMachine") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AppVersion");
	text_element = Document->createTextNode( QString("%1").arg(getAppVersion()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ValidRc");
	text_element = Document->createTextNode( QString("%1").arg(getValidRc()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( ! no_save_option )
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("VmType");
		text_element = Document->createTextNode( QString("%1").arg(getVmType()) );
		root_element.appendChild(element);
		element.appendChild(text_element);

	}

	for(i = 0; i < m_lstIdentification.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmIdentification* object = m_lstIdentification[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstSecurity.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSecurity* object = m_lstSecurity[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstSettings.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSettings* object = m_lstSettings[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstCtSettings.size() && ( ! no_save_option ); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CCtSettings* object = m_lstCtSettings[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstHardware.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmHardware* object = m_lstHardware[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	dyn_lists += "VirtualAppliance";
	nMaxItemId = getMaxItemId<CVaConfig>(m_lstVirtualAppliance, "VirtualAppliance", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVirtualAppliance.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVaConfig* object = m_lstVirtualAppliance[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VirtualAppliance", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("InstalledSoftware");
	text_element = Document->createTextNode( QString("%1").arg(getInstalledSoftware()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmConfiguration::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ParallelsVirtualMachine") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmConfiguration': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VirtualAppliance = getMaxItemId2(element, "VirtualAppliance");
	QMap<int , QString > mapVirtualAppliance;
	if (unite_with_loaded)
		fillItemIdMap<CVaConfig>(m_lstVirtualAppliance, mapVirtualAppliance);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Identification_count = 1;
	int Security_count = 1;
	int Settings_count = 1;
	int CtSettings_count = 1;
	int Hardware_count = 1;
	int VirtualAppliance_count = 0;
	int AppVersion_count = 1;
	int ValidRc_count = 0;
	int VmType_count = 0;
	int InstalledSoftware_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "appVersion";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AppVersion_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AppVersion")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAppVersion(text_element.data());
			--AppVersion_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ValidRc";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ValidRc_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ValidRc")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setValidRc(text_element.data().toUInt());
			--ValidRc_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VmType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VmType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VmType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVmType((PRL_VM_TYPE )text_element.data().toLongLong());
			--VmType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "InstalledSoftware";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (InstalledSoftware_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "InstalledSoftware")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setInstalledSoftware(text_element.data().toUInt());
			--InstalledSoftware_count;
		}


		if (tag_name == "Identification" && Identification_count > 0)
		{
			unused_tag = false;
			CVmIdentification* object = m_lstIdentification[1 - Identification_count];
			object->makeFullItemId(getFullItemId(), "Identification");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Identification_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Security" && Security_count > 0)
		{
			unused_tag = false;
			CVmSecurity* object = m_lstSecurity[1 - Security_count];
			object->makeFullItemId(getFullItemId(), "Security");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Security_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Settings" && Settings_count > 0)
		{
			unused_tag = false;
			CVmSettings* object = m_lstSettings[1 - Settings_count];
			object->makeFullItemId(getFullItemId(), "Settings");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Settings_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "CtSettings" && CtSettings_count > 0)
		{
			unused_tag = false;
			CCtSettings* object = m_lstCtSettings[1 - CtSettings_count];
			object->makeFullItemId(getFullItemId(), "CtSettings");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--CtSettings_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Hardware" && Hardware_count > 0)
		{
			unused_tag = false;
			CVmHardware* object = m_lstHardware[1 - Hardware_count];
			object->makeFullItemId(getFullItemId(), "Hardware");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Hardware_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "VirtualAppliance")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VirtualAppliance++ : nItemId;
			CVaConfig* object = new CVaConfig();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "VirtualAppliance", object->getItemId());
			if (unite_with_loaded && mapVirtualAppliance.contains(nItemId))
				object->fromString(mapVirtualAppliance.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVirtualAppliance += object;
			--VirtualAppliance_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Identification_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'Identification' is absent";
	}

	if (Security_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'Security' is absent";
	}

	if (Settings_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'Settings' is absent";
	}

	if (CtSettings_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'CtSettings' is absent";
	}

	if (Hardware_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'Hardware' is absent";
	}

	if (VirtualAppliance_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'VirtualAppliance' is absent";
	}

	if (AppVersion_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmConfiguration': tag 'AppVersion' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ValidRc_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'ValidRc' is absent";
	}

	if (VmType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'VmType' is absent";
	}

	if (InstalledSoftware_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmConfiguration': tag 'InstalledSoftware' is absent";
	}

	syncMaxItemId(nMaxItemId_VirtualAppliance, "VirtualAppliance");


	return 0;
}

void CVmConfiguration::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstIdentification.size(); ++i)
	{
		CVmIdentification* object = m_lstIdentification[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Identification");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstSecurity.size(); ++i)
	{
		CVmSecurity* object = m_lstSecurity[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Security");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstSettings.size(); ++i)
	{
		CVmSettings* object = m_lstSettings[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Settings");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstCtSettings.size(); ++i)
	{
		CCtSettings* object = m_lstCtSettings[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "CtSettings");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstHardware.size(); ++i)
	{
		CVmHardware* object = m_lstHardware[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Hardware");
		object->syncItemIds();
	}

	nMaxItemId = getMaxItemId<CVaConfig>(m_lstVirtualAppliance, "VirtualAppliance");
	setItemIds.clear();
	for(i = 0; i < m_lstVirtualAppliance.size(); ++i)
	{
		CVaConfig* object = m_lstVirtualAppliance[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "VirtualAppliance", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VirtualAppliance");

}

bool CVmConfiguration::merge(CVmConfiguration* pCur, CVmConfiguration* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ParallelsVirtualMachine";

	if (getAppVersion() != pCur->getAppVersion() && getAppVersion() == pPrev->getAppVersion())
		setAppVersion(pCur->getAppVersion());
	else if (getAppVersion() != pCur->getAppVersion() && getAppVersion() != pPrev->getAppVersion() && pCur->getAppVersion() != pPrev->getAppVersion())
	{
		m_qsErrorMessage += ".AppVersion";
		return false;
	}

	if (getValidRc() != pCur->getValidRc() && getValidRc() == pPrev->getValidRc())
		setValidRc(pCur->getValidRc());
	else if (getValidRc() != pCur->getValidRc() && getValidRc() != pPrev->getValidRc() && pCur->getValidRc() != pPrev->getValidRc())
	{
		m_qsErrorMessage += ".ValidRc";
		return false;
	}

	if (getVmType() != pCur->getVmType() && getVmType() == pPrev->getVmType())
		setVmType(pCur->getVmType());
	else if (getVmType() != pCur->getVmType() && getVmType() != pPrev->getVmType() && pCur->getVmType() != pPrev->getVmType())
	{
		m_qsErrorMessage += ".VmType";
		return false;
	}

	if (getInstalledSoftware() != pCur->getInstalledSoftware() && getInstalledSoftware() == pPrev->getInstalledSoftware())
		setInstalledSoftware(pCur->getInstalledSoftware());
	else if (getInstalledSoftware() != pCur->getInstalledSoftware() && getInstalledSoftware() != pPrev->getInstalledSoftware() && pCur->getInstalledSoftware() != pPrev->getInstalledSoftware())
	{
		m_qsErrorMessage += ".InstalledSoftware";
		return false;
	}

	for(i = 0; i < m_lstIdentification.size(); i++)
	{
		if ( m_lstIdentification[i]->merge(pCur->m_lstIdentification[i], pPrev->m_lstIdentification[i], nOptions) ) continue;
		QString qsIdx = (m_lstIdentification.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstIdentification[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstSecurity.size(); i++)
	{
		if ( m_lstSecurity[i]->merge(pCur->m_lstSecurity[i], pPrev->m_lstSecurity[i], nOptions) ) continue;
		QString qsIdx = (m_lstSecurity.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstSecurity[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstSettings.size(); i++)
	{
		if ( m_lstSettings[i]->merge(pCur->m_lstSettings[i], pPrev->m_lstSettings[i], nOptions) ) continue;
		QString qsIdx = (m_lstSettings.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstSettings[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstCtSettings.size(); i++)
	{
		if ( m_lstCtSettings[i]->merge(pCur->m_lstCtSettings[i], pPrev->m_lstCtSettings[i], nOptions) ) continue;
		QString qsIdx = (m_lstCtSettings.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstCtSettings[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstHardware.size(); i++)
	{
		if ( m_lstHardware[i]->merge(pCur->m_lstHardware[i], pPrev->m_lstHardware[i], nOptions) ) continue;
		QString qsIdx = (m_lstHardware.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstHardware[i]->GetErrorMessage();
		return false;
	}

	if ( ! mergeList<CVaConfig>(m_lstVirtualAppliance, pCur->m_lstVirtualAppliance, pPrev->m_lstVirtualAppliance, "VirtualAppliance", nOptions) )
		return false;

	return true;
}

void CVmConfiguration::diff(const CVmConfiguration* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getAppVersion() != pOld->getAppVersion())
		lstDiffFullItemIds += getAppVersion_id();

	if (getValidRc() != pOld->getValidRc())
		lstDiffFullItemIds += getValidRc_id();

	if (getVmType() != pOld->getVmType())
		lstDiffFullItemIds += getVmType_id();

	if (getInstalledSoftware() != pOld->getInstalledSoftware())
		lstDiffFullItemIds += getInstalledSoftware_id();

	for(i = 0; i < m_lstIdentification.size(); ++i)
		m_lstIdentification[i]->diff(pOld->m_lstIdentification[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstSecurity.size(); ++i)
		m_lstSecurity[i]->diff(pOld->m_lstSecurity[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstSettings.size(); ++i)
		m_lstSettings[i]->diff(pOld->m_lstSettings[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstCtSettings.size(); ++i)
		m_lstCtSettings[i]->diff(pOld->m_lstCtSettings[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstHardware.size(); ++i)
		m_lstHardware[i]->diff(pOld->m_lstHardware[i], lstDiffFullItemIds);

	diffList<CVaConfig>(m_lstVirtualAppliance, pOld->m_lstVirtualAppliance, lstDiffFullItemIds);

}

void CVmConfiguration::Copy(const CVmConfiguration& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setAppVersion(rObject.getAppVersion());
	setValidRc(rObject.getValidRc());
	setVmType(rObject.getVmType());
	setInstalledSoftware(rObject.getInstalledSoftware());

	ClearList<CVmIdentification >(m_lstIdentification);
	for(i = 0; i < rObject.m_lstIdentification.size(); i++)
		m_lstIdentification += new CVmIdentification(rObject.m_lstIdentification[i]);

	ClearList<CVmSecurity >(m_lstSecurity);
	for(i = 0; i < rObject.m_lstSecurity.size(); i++)
		m_lstSecurity += new CVmSecurity(rObject.m_lstSecurity[i]);

	ClearList<CVmSettings >(m_lstSettings);
	for(i = 0; i < rObject.m_lstSettings.size(); i++)
		m_lstSettings += new CVmSettings(rObject.m_lstSettings[i]);

	ClearList<CCtSettings >(m_lstCtSettings);
	for(i = 0; i < rObject.m_lstCtSettings.size(); i++)
		m_lstCtSettings += new CCtSettings(rObject.m_lstCtSettings[i]);

	ClearList<CVmHardware >(m_lstHardware);
	for(i = 0; i < rObject.m_lstHardware.size(); i++)
		m_lstHardware += new CVmHardware(rObject.m_lstHardware[i]);

	ClearList<CVaConfig >(m_lstVirtualAppliance);
	for(i = 0; i < rObject.m_lstVirtualAppliance.size(); i++)
		m_lstVirtualAppliance += new CVaConfig(rObject.m_lstVirtualAppliance[i]);

	CustomCopy(&rObject);

}

void CVmConfiguration::InitLists()
{
	InitList<CVmIdentification>(1, m_lstIdentification);
	InitList<CVmSecurity>(1, m_lstSecurity);
	InitList<CVmSettings>(1, m_lstSettings);
	InitList<CCtSettings>(1, m_lstCtSettings);
	InitList<CVmHardware>(1, m_lstHardware);
	CustomInit();
}

void CVmConfiguration::ClearLists()
{
	ClearList<CVmIdentification>(m_lstIdentification);
	ClearList<CVmSecurity>(m_lstSecurity);
	ClearList<CVmSettings>(m_lstSettings);
	ClearList<CCtSettings>(m_lstCtSettings);
	ClearList<CVmHardware>(m_lstHardware);
	ClearList<CVaConfig>(m_lstVirtualAppliance);
}

void CVmConfiguration::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VirtualAppliance") )
		ClearList<CVaConfig>(m_lstVirtualAppliance);
	for(i = 0; i < m_lstIdentification.size() && ! unite_with_loaded; i++)
	{
		m_lstIdentification[i]->ClearListsInReadXml();
		m_lstIdentification[i]->setDefaults();
		m_lstIdentification[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstSecurity.size() && ! unite_with_loaded; i++)
	{
		m_lstSecurity[i]->ClearListsInReadXml();
		m_lstSecurity[i]->setDefaults();
		m_lstSecurity[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstSettings.size() && ! unite_with_loaded; i++)
	{
		m_lstSettings[i]->ClearListsInReadXml();
		m_lstSettings[i]->setDefaults();
		m_lstSettings[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstCtSettings.size() && ! unite_with_loaded; i++)
	{
		m_lstCtSettings[i]->ClearListsInReadXml();
		m_lstCtSettings[i]->setDefaults();
		m_lstCtSettings[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstHardware.size() && ! unite_with_loaded; i++)
	{
		m_lstHardware[i]->ClearListsInReadXml();
		m_lstHardware[i]->setDefaults();
		m_lstHardware[i]->setSectionFakeFlag(true);
	}
}

