////////////////////////////////////////////////////////////////////////////////
///
/// CVmConfiguration.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMCONFIGURATION_H
#define CVMCONFIGURATION_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmIdentification.h"
#include "CVmSecurity.h"
#include "CVmSettings.h"
#include "CCtSettings.h"
#include "CVmHardware.h"
#include "CVaConfig.h"


class CVmConfiguration : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmConfiguration();
	CVmConfiguration(const CVmConfiguration& rObject);
	CVmConfiguration(const CVmConfiguration* pObject);
	CVmConfiguration(QFile* pFile);
	CVmConfiguration& operator=(const CVmConfiguration& rObject);
	virtual ~CVmConfiguration();


    bool hasEnabledGenericPciDevices() const;

    CVmConfiguration(QString s) { InitLists(); fromString(s); }
    int readXml(QDomDocument* Document);

    QDomDocument getXml() { return CBaseNode::getXml(); }
    int saveToFile(QFile* config_file, bool do_replace = true, bool BNeedToSaveRelativePath = true);
    int saveToFile(QString config_file, bool do_replace = true, bool BNeedToSaveRelativePath = true);
    int loadFromFile(QFile* config_file,bool BNeedLoadAbsolutePath = true);

	void setRelativePath(const QString& home_ = QString());
	void setAbsolutePath();

    static QString makeAppVersion();

    // Get Configuration directory name
    QString getConfigDirectory() const;

	QList<CVmIdentification* >		m_lstIdentification;
	QList<CVmSecurity* >		m_lstSecurity;
	QList<CVmSettings* >		m_lstSettings;
	QList<CCtSettings* >		m_lstCtSettings;
	QList<CVmHardware* >		m_lstHardware;
	QList<CVaConfig* >		m_lstVirtualAppliance;

	CVmIdentification* getVmIdentification() const;
	void setVmIdentification(CVmIdentification* pIdentification);

	CVmSecurity* getVmSecurity() const;
	void setVmSecurity(CVmSecurity* pSecurity);

	CVmSettings* getVmSettings() const;
	void setVmSettings(CVmSettings* pSettings);

	CCtSettings* getCtSettings() const;
	void setCtSettings(CCtSettings* pCtSettings);

	CVmHardware* getVmHardwareList() const;
	void setVmHardwareList(CVmHardware* pHardware);

	CVaConfig* getVaConfig() const;
	void setVaConfig(CVaConfig* pVirtualAppliance);


	QString getAppVersion() const;
	void setAppVersion(QString value = QString());

	unsigned int getValidRc() const;
	void setValidRc(unsigned int value = 0);

	PRL_VM_TYPE getVmType() const;
	void setVmType(PRL_VM_TYPE value = PVT_VM);

	unsigned int getInstalledSoftware() const;
	void setInstalledSoftware(unsigned int value = 0);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getAppVersion_id() const;
	QString getValidRc_id() const;
	QString getVmType_id() const;
	QString getInstalledSoftware_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmConfiguration* pCur, CVmConfiguration* pPrev, MergeOptions nOptions);

	void diff(const CVmConfiguration* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsAppVersion;
	unsigned int		m_uiValidRc;
	PRL_VM_TYPE		m_ctVmType;
	unsigned int		m_uiInstalledSoftware;

	void Copy(const CVmConfiguration& rObject);

signals:

	void signalAppVersionChanged(QString value, QString object_id = QString());
	void signalValidRcChanged(unsigned int value, QString object_id = QString());
	void signalVmTypeChanged(PRL_VM_TYPE value, QString object_id = QString());
	void signalInstalledSoftwareChanged(unsigned int value, QString object_id = QString());

private slots:

	void slotChangeAppVersion(QString value);
	void slotChangeValidRc(unsigned int value);
	void slotChangeVmType(PRL_VM_TYPE value);
	void slotChangeInstalledSoftware(unsigned int value);

};

#ifndef DM_194935493
#define DM_194935493
Q_DECLARE_METATYPE(PRL_VM_TYPE)
#endif

template <class T> QString ElementToString(T Element, const QString& tagName)
{
	QDomDocument xmlDummyParentDoc;
	QDomElement xmlVmConfigRoot;
	QDomNode xmlXmlVersionNode;

	xmlXmlVersionNode = xmlDummyParentDoc.createProcessingInstruction(
		XML_DOC_VERSION_TAG, XML_DOC_VERSION_DATA );
	xmlDummyParentDoc.insertBefore( xmlXmlVersionNode, xmlDummyParentDoc.firstChild() );

	// create root element
	xmlVmConfigRoot = xmlDummyParentDoc.createElement( tagName );
	xmlDummyParentDoc.appendChild( xmlVmConfigRoot );
	// append given element
	QDomElement root_element = Element->getXml( &xmlDummyParentDoc );
	root_element.setAttribute("id", Element->getItemId());
	xmlVmConfigRoot.appendChild(root_element);

	QString strOutput;
	QTextStream out( &strOutput );

	xmlDummyParentDoc.save( out, 3 );
	out.flush();

	return strOutput;
}

template <class T> bool StringToElement(T Element, const QString& source_string)
{
	QDomDocument xmlSourceDoc;
	// Parse error string
	QString strErrMsg;
	// Parse error line
	int iErrLine;
	// Parse error column
	int iErrCol;

	bool parse_rc = xmlSourceDoc.setContent( source_string,
		true, &strErrMsg, &iErrLine, &iErrCol );
	if( !parse_rc )
	{
		return false;
	}

	// setup root element
	QDomElement xmlVmConfigRoot = xmlSourceDoc.documentElement();
	QDomElement xmlHddChild = xmlVmConfigRoot.firstChild().toElement();

	int read_rc = Element->readXml( &xmlHddChild );
	if ( IS_OPERATION_SUCCEEDED( read_rc ) )
	{
		Element->setItemId( xmlHddChild.attribute("id", "-1").toInt() );
		return true;
	}

	read_rc = Element->readXml( &xmlVmConfigRoot );
	if ( ! IS_OPERATION_SUCCEEDED( read_rc ) )
	{
		return false;
	}
	Element->setItemId( xmlVmConfigRoot.attribute("id", "-1").toInt() );

	return true;
}


#endif
