////////////////////////////////////////////////////////////////////////////////
///
/// CVmCpu.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmCpu.h"


CVmCpu::CVmCpu()
{
	InitLists();
	setDefaults();
}

CVmCpu::CVmCpu(const CVmCpu& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmCpu::CVmCpu(const CVmCpu* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmCpu& CVmCpu::operator=(const CVmCpu& rObject)
{
	Copy(rObject);
	return *this;
}

CVmCpu::CVmCpu(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmCpu::~CVmCpu()
{
	ClearLists();
}



void CVmCpu::setCpuLimitData(PRL_CONST_CPULIMIT_DATA_PTR cpulimit)
{
	setCpuLimitValue(cpulimit->value);
	setCpuLimitType(cpulimit->type);

	if (cpulimit->type == PRL_CPULIMIT_MHZ)
		setCpuLimit(0);
	else if (cpulimit->type == PRL_CPULIMIT_PERCENTS)
		setCpuLimit(cpulimit->value);
}

void CVmCpu::getCpuLimitData(PRL_CPULIMIT_DATA_PTR cpulimit)
{
	cpulimit->value = getCpuLimitValue();
	cpulimit->type = getCpuLimitType();

}
								
void CVmCpu::setCpuLimitPercents(unsigned int value)
{
	PRL_CPULIMIT_DATA cpulimit;

	cpulimit.value = value;
	cpulimit.type = PRL_CPULIMIT_PERCENTS;

	setCpuLimitData(&cpulimit);
}
								
bool CVmCpu::operator==(CVmCpu& cVmCpu)
{
	return (
		(getNumber() == cVmCpu.getNumber()) &&
		(getMode() == cVmCpu.getMode()) &&
		(getAccelerationLevel() == cVmCpu.getAccelerationLevel()) &&
		(isEnableHotplug() == cVmCpu.isEnableHotplug()) &&
		(getEnableVTxSupport() == cVmCpu.getEnableVTxSupport())
		);
}

unsigned int CVmCpu::getNumber() const
{
	return m_uiNumber;
}

void CVmCpu::setNumber(unsigned int value)
{
	bool bValueChanged = (m_uiNumber != value);
	m_uiNumber = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalNumberChanged(value);
	}
}

void CVmCpu::slotChangeNumber(unsigned int value)
{
	setNumber(value);
}

PRL_CPU_MODE CVmCpu::getMode() const
{
	return m_ctMode;
}

void CVmCpu::setMode(PRL_CPU_MODE value)
{
	bool bValueChanged = (m_ctMode != value);
	m_ctMode = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalModeChanged(value);
	}
}

void CVmCpu::slotChangeMode(PRL_CPU_MODE value)
{
	setMode(value);
}

PRL_VM_ACCELERATION_LEVEL CVmCpu::getAccelerationLevel() const
{
	return m_ctAccelerationLevel;
}

void CVmCpu::setAccelerationLevel(PRL_VM_ACCELERATION_LEVEL value)
{
	bool bValueChanged = (m_ctAccelerationLevel != value);
	m_ctAccelerationLevel = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAccelerationLevelChanged(value);
	}
}

void CVmCpu::slotChangeAccelerationLevel(PRL_VM_ACCELERATION_LEVEL value)
{
	setAccelerationLevel(value);
}

PVE::VTxSupportFlag CVmCpu::getEnableVTxSupport() const
{
	return m_ctEnableVTxSupport;
}

void CVmCpu::setEnableVTxSupport(PVE::VTxSupportFlag value)
{
	bool bValueChanged = (m_ctEnableVTxSupport != value);
	m_ctEnableVTxSupport = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnableVTxSupportChanged(value);
	}
}

void CVmCpu::slotChangeEnableVTxSupport(PVE::VTxSupportFlag value)
{
	setEnableVTxSupport(value);
}

bool CVmCpu::isEnableHotplug() const
{
	return m_bEnableHotplug;
}

void CVmCpu::setEnableHotplug(bool value)
{
	bool bValueChanged = (m_bEnableHotplug != value);
	m_bEnableHotplug = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnableHotplugChanged(value);
	}
}

void CVmCpu::slotChangeEnableHotplug(bool value)
{
	setEnableHotplug(value);
}

unsigned int CVmCpu::getCpuUnits() const
{
	return m_uiCpuUnits;
}

void CVmCpu::setCpuUnits(unsigned int value)
{
	bool bValueChanged = (m_uiCpuUnits != value);
	m_uiCpuUnits = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuUnitsChanged(value);
	}
}

void CVmCpu::slotChangeCpuUnits(unsigned int value)
{
	setCpuUnits(value);
}

unsigned int CVmCpu::getCpuLimit() const
{
	return m_uiCpuLimit;
}

void CVmCpu::setCpuLimit(unsigned int value)
{
	bool bValueChanged = (m_uiCpuLimit != value);
	m_uiCpuLimit = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuLimitChanged(value);
	}
}

void CVmCpu::slotChangeCpuLimit(unsigned int value)
{
	setCpuLimit(value);
}

PRL_CPULIMIT_TYPE CVmCpu::getCpuLimitType() const
{
	return m_ctCpuLimitType;
}

void CVmCpu::setCpuLimitType(PRL_CPULIMIT_TYPE value)
{
	bool bValueChanged = (m_ctCpuLimitType != value);
	m_ctCpuLimitType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuLimitTypeChanged(value);
	}
}

void CVmCpu::slotChangeCpuLimitType(PRL_CPULIMIT_TYPE value)
{
	setCpuLimitType(value);
}

unsigned int CVmCpu::getCpuLimitValue() const
{
	return m_uiCpuLimitValue;
}

void CVmCpu::setCpuLimitValue(unsigned int value)
{
	bool bValueChanged = (m_uiCpuLimitValue != value);
	m_uiCpuLimitValue = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuLimitValueChanged(value);
	}
}

void CVmCpu::slotChangeCpuLimitValue(unsigned int value)
{
	setCpuLimitValue(value);
}

unsigned int CVmCpu::getGuestLimitType() const
{
	return m_uiGuestLimitType;
}

void CVmCpu::setGuestLimitType(unsigned int value)
{
	bool bValueChanged = (m_uiGuestLimitType != value);
	m_uiGuestLimitType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalGuestLimitTypeChanged(value);
	}
}

void CVmCpu::slotChangeGuestLimitType(unsigned int value)
{
	setGuestLimitType(value);
}

QString CVmCpu::getCpuMask() const
{
	return m_qsCpuMask;
}

void CVmCpu::setCpuMask(QString value)
{
	bool bValueChanged = (m_qsCpuMask != value);
	m_qsCpuMask = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuMaskChanged(value);
	}
}

void CVmCpu::slotChangeCpuMask(QString value)
{
	setCpuMask(value);
}

QString CVmCpu::getNodeMask() const
{
	return m_qsNodeMask;
}

void CVmCpu::setNodeMask(QString value)
{
	bool bValueChanged = (m_qsNodeMask != value);
	m_qsNodeMask = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalNodeMaskChanged(value);
	}
}

void CVmCpu::slotChangeNodeMask(QString value)
{
	setNodeMask(value);
}

bool CVmCpu::isVirtualizedHV() const
{
	return m_bVirtualizedHV;
}

void CVmCpu::setVirtualizedHV(bool value)
{
	bool bValueChanged = (m_bVirtualizedHV != value);
	m_bVirtualizedHV = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalVirtualizedHVChanged(value);
	}
}

void CVmCpu::slotChangeVirtualizedHV(bool value)
{
	setVirtualizedHV(value);
}

bool CVmCpu::isVirtualizePMU() const
{
	return m_bVirtualizePMU;
}

void CVmCpu::setVirtualizePMU(bool value)
{
	bool bValueChanged = (m_bVirtualizePMU != value);
	m_bVirtualizePMU = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalVirtualizePMUChanged(value);
	}
}

void CVmCpu::slotChangeVirtualizePMU(bool value)
{
	setVirtualizePMU(value);
}

unsigned int CVmCpu::getSockets() const
{
	return m_uiSockets;
}

void CVmCpu::setSockets(unsigned int value)
{
	bool bValueChanged = (m_uiSockets != value);
	m_uiSockets = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalSocketsChanged(value);
	}
}

void CVmCpu::slotChangeSockets(unsigned int value)
{
	setSockets(value);
}

void CVmCpu::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Number").isNull() )
		setNumber();
	if ( ! RootElement || ! RootElement->firstChildElement("Mode").isNull() )
		setMode();
	if ( ! RootElement || ! RootElement->firstChildElement("AccelerationLevel").isNull() )
		setAccelerationLevel();
	if ( ! RootElement || ! RootElement->firstChildElement("EnableVTxSupport").isNull() )
		setEnableVTxSupport();
	if ( ! RootElement || ! RootElement->firstChildElement("EnableHotplug").isNull() )
		setEnableHotplug();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuUnits").isNull() )
		setCpuUnits();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuLimit").isNull() )
		setCpuLimit();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuLimitType").isNull() )
		setCpuLimitType();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuLimitValue").isNull() )
		setCpuLimitValue();
	if ( ! RootElement || ! RootElement->firstChildElement("GuestLimitType").isNull() )
		setGuestLimitType();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuMask").isNull() )
		setCpuMask();
	if ( ! RootElement || ! RootElement->firstChildElement("NodeMask").isNull() )
		setNodeMask();
	if ( ! RootElement || ! RootElement->firstChildElement("VirtualizedHV").isNull() )
		setVirtualizedHV();
	if ( ! RootElement || ! RootElement->firstChildElement("VirtualizePMU").isNull() )
		setVirtualizePMU();
	if ( ! RootElement || ! RootElement->firstChildElement("Sockets").isNull() )
		setSockets();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_CPU_MODE >("PRL_CPU_MODE");
		qRegisterMetaType< PRL_VM_ACCELERATION_LEVEL >("PRL_VM_ACCELERATION_LEVEL");
		qRegisterMetaType< PVE::VTxSupportFlag >("PVE::VTxSupportFlag");
		qRegisterMetaType< PRL_CPULIMIT_TYPE >("PRL_CPULIMIT_TYPE");
		first_time = false;
	}

}

QVariant CVmCpu::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Number.patch_stamp")
		value.setValue(getFieldPatchedValue("Number"));

	if (path == "Number")
		value.setValue(getNumber());

	if (path == "Mode.patch_stamp")
		value.setValue(getFieldPatchedValue("Mode"));

	if (path == "Mode")
		value.setValue((qlonglong )getMode());

	if (path == "AccelerationLevel.patch_stamp")
		value.setValue(getFieldPatchedValue("AccelerationLevel"));

	if (path == "AccelerationLevel")
		value.setValue((qlonglong )getAccelerationLevel());

	if (path == "EnableVTxSupport.patch_stamp")
		value.setValue(getFieldPatchedValue("EnableVTxSupport"));

	if (path == "EnableVTxSupport")
		value.setValue((qlonglong )getEnableVTxSupport());

	if (path == "EnableHotplug.patch_stamp")
		value.setValue(getFieldPatchedValue("EnableHotplug"));

	if (path == "EnableHotplug")
		value.setValue(isEnableHotplug());

	if (path == "CpuUnits.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuUnits"));

	if (path == "CpuUnits")
		value.setValue(getCpuUnits());

	if (path == "CpuLimit.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuLimit"));

	if (path == "CpuLimit")
		value.setValue(getCpuLimit());

	if (path == "CpuLimitType.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuLimitType"));

	if (path == "CpuLimitType")
		value.setValue((qlonglong )getCpuLimitType());

	if (path == "CpuLimitValue.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuLimitValue"));

	if (path == "CpuLimitValue")
		value.setValue(getCpuLimitValue());

	if (path == "GuestLimitType.patch_stamp")
		value.setValue(getFieldPatchedValue("GuestLimitType"));

	if (path == "GuestLimitType")
		value.setValue(getGuestLimitType());

	if (path == "CpuMask.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuMask"));

	if (path == "CpuMask")
		value.setValue(getCpuMask());

	if (path == "NodeMask.patch_stamp")
		value.setValue(getFieldPatchedValue("NodeMask"));

	if (path == "NodeMask")
		value.setValue(getNodeMask());

	if (path == "VirtualizedHV.patch_stamp")
		value.setValue(getFieldPatchedValue("VirtualizedHV"));

	if (path == "VirtualizedHV")
		value.setValue(isVirtualizedHV());

	if (path == "VirtualizePMU.patch_stamp")
		value.setValue(getFieldPatchedValue("VirtualizePMU"));

	if (path == "VirtualizePMU")
		value.setValue(isVirtualizePMU());

	if (path == "Sockets.patch_stamp")
		value.setValue(getFieldPatchedValue("Sockets"));

	if (path == "Sockets")
		value.setValue(getSockets());

	return value;
}

bool CVmCpu::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Number.patch_stamp")
	{
		markPatchedField("Number", value.toString());
		return true;
	}

	if (path == "Number")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNumber() != value.value< unsigned int >());
		setNumber(value.value< unsigned int >());
		return true;
	}

	if (path == "Mode.patch_stamp")
	{
		markPatchedField("Mode", value.toString());
		return true;
	}

	if (path == "Mode")
	{
		if (pbValueChanged)
			*pbValueChanged = (getMode() != (PRL_CPU_MODE )value.value< qlonglong >());
		setMode((PRL_CPU_MODE )value.value< qlonglong >());
		return true;
	}

	if (path == "AccelerationLevel.patch_stamp")
	{
		markPatchedField("AccelerationLevel", value.toString());
		return true;
	}

	if (path == "AccelerationLevel")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAccelerationLevel() != (PRL_VM_ACCELERATION_LEVEL )value.value< qlonglong >());
		setAccelerationLevel((PRL_VM_ACCELERATION_LEVEL )value.value< qlonglong >());
		return true;
	}

	if (path == "EnableVTxSupport.patch_stamp")
	{
		markPatchedField("EnableVTxSupport", value.toString());
		return true;
	}

	if (path == "EnableVTxSupport")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEnableVTxSupport() != (PVE::VTxSupportFlag )value.value< qlonglong >());
		setEnableVTxSupport((PVE::VTxSupportFlag )value.value< qlonglong >());
		return true;
	}

	if (path == "EnableHotplug.patch_stamp")
	{
		markPatchedField("EnableHotplug", value.toString());
		return true;
	}

	if (path == "EnableHotplug")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnableHotplug() != value.value< bool >());
		setEnableHotplug(value.value< bool >());
		return true;
	}

	if (path == "CpuUnits.patch_stamp")
	{
		markPatchedField("CpuUnits", value.toString());
		return true;
	}

	if (path == "CpuUnits")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuUnits() != value.value< unsigned int >());
		setCpuUnits(value.value< unsigned int >());
		return true;
	}

	if (path == "CpuLimit.patch_stamp")
	{
		markPatchedField("CpuLimit", value.toString());
		return true;
	}

	if (path == "CpuLimit")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuLimit() != value.value< unsigned int >());
		setCpuLimit(value.value< unsigned int >());
		return true;
	}

	if (path == "CpuLimitType.patch_stamp")
	{
		markPatchedField("CpuLimitType", value.toString());
		return true;
	}

	if (path == "CpuLimitType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuLimitType() != (PRL_CPULIMIT_TYPE )value.value< qlonglong >());
		setCpuLimitType((PRL_CPULIMIT_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "CpuLimitValue.patch_stamp")
	{
		markPatchedField("CpuLimitValue", value.toString());
		return true;
	}

	if (path == "CpuLimitValue")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuLimitValue() != value.value< unsigned int >());
		setCpuLimitValue(value.value< unsigned int >());
		return true;
	}

	if (path == "GuestLimitType.patch_stamp")
	{
		markPatchedField("GuestLimitType", value.toString());
		return true;
	}

	if (path == "GuestLimitType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getGuestLimitType() != value.value< unsigned int >());
		setGuestLimitType(value.value< unsigned int >());
		return true;
	}

	if (path == "CpuMask.patch_stamp")
	{
		markPatchedField("CpuMask", value.toString());
		return true;
	}

	if (path == "CpuMask")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCpuMask() != value.value< QString >());
		setCpuMask(value.value< QString >());
		return true;
	}

	if (path == "NodeMask.patch_stamp")
	{
		markPatchedField("NodeMask", value.toString());
		return true;
	}

	if (path == "NodeMask")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNodeMask() != value.value< QString >());
		setNodeMask(value.value< QString >());
		return true;
	}

	if (path == "VirtualizedHV.patch_stamp")
	{
		markPatchedField("VirtualizedHV", value.toString());
		return true;
	}

	if (path == "VirtualizedHV")
	{
		if (pbValueChanged)
			*pbValueChanged = (isVirtualizedHV() != value.value< bool >());
		setVirtualizedHV(value.value< bool >());
		return true;
	}

	if (path == "VirtualizePMU.patch_stamp")
	{
		markPatchedField("VirtualizePMU", value.toString());
		return true;
	}

	if (path == "VirtualizePMU")
	{
		if (pbValueChanged)
			*pbValueChanged = (isVirtualizePMU() != value.value< bool >());
		setVirtualizePMU(value.value< bool >());
		return true;
	}

	if (path == "Sockets.patch_stamp")
	{
		markPatchedField("Sockets", value.toString());
		return true;
	}

	if (path == "Sockets")
	{
		if (pbValueChanged)
			*pbValueChanged = (getSockets() != value.value< unsigned int >());
		setSockets(value.value< unsigned int >());
		return true;
	}

	return false;
}

QString CVmCpu::getNumber_id() const
{
	return getFullItemId().isEmpty() ? "Number" : getFullItemId() + ".Number";
}
QString CVmCpu::getMode_id() const
{
	return getFullItemId().isEmpty() ? "Mode" : getFullItemId() + ".Mode";
}
QString CVmCpu::getAccelerationLevel_id() const
{
	return getFullItemId().isEmpty() ? "AccelerationLevel" : getFullItemId() + ".AccelerationLevel";
}
QString CVmCpu::getEnableVTxSupport_id() const
{
	return getFullItemId().isEmpty() ? "EnableVTxSupport" : getFullItemId() + ".EnableVTxSupport";
}
QString CVmCpu::getEnableHotplug_id() const
{
	return getFullItemId().isEmpty() ? "EnableHotplug" : getFullItemId() + ".EnableHotplug";
}
QString CVmCpu::getCpuUnits_id() const
{
	return getFullItemId().isEmpty() ? "CpuUnits" : getFullItemId() + ".CpuUnits";
}
QString CVmCpu::getCpuLimit_id() const
{
	return getFullItemId().isEmpty() ? "CpuLimit" : getFullItemId() + ".CpuLimit";
}
QString CVmCpu::getCpuLimitType_id() const
{
	return getFullItemId().isEmpty() ? "CpuLimitType" : getFullItemId() + ".CpuLimitType";
}
QString CVmCpu::getCpuLimitValue_id() const
{
	return getFullItemId().isEmpty() ? "CpuLimitValue" : getFullItemId() + ".CpuLimitValue";
}
QString CVmCpu::getGuestLimitType_id() const
{
	return getFullItemId().isEmpty() ? "GuestLimitType" : getFullItemId() + ".GuestLimitType";
}
QString CVmCpu::getCpuMask_id() const
{
	return getFullItemId().isEmpty() ? "CpuMask" : getFullItemId() + ".CpuMask";
}
QString CVmCpu::getNodeMask_id() const
{
	return getFullItemId().isEmpty() ? "NodeMask" : getFullItemId() + ".NodeMask";
}
QString CVmCpu::getVirtualizedHV_id() const
{
	return getFullItemId().isEmpty() ? "VirtualizedHV" : getFullItemId() + ".VirtualizedHV";
}
QString CVmCpu::getVirtualizePMU_id() const
{
	return getFullItemId().isEmpty() ? "VirtualizePMU" : getFullItemId() + ".VirtualizePMU";
}
QString CVmCpu::getSockets_id() const
{
	return getFullItemId().isEmpty() ? "Sockets" : getFullItemId() + ".Sockets";
}

int CVmCpu::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmCpu::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmCpu::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Cpu") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Number");
	text_element = Document->createTextNode( QString("%1").arg(getNumber()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Mode");
	text_element = Document->createTextNode( QString("%1").arg(getMode()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AccelerationLevel");
	text_element = Document->createTextNode( QString("%1").arg(getAccelerationLevel()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EnableVTxSupport");
	text_element = Document->createTextNode( QString("%1").arg(getEnableVTxSupport()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EnableHotplug");
	text_element = Document->createTextNode( QString("%1").arg(isEnableHotplug()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuUnits");
	text_element = Document->createTextNode( QString("%1").arg(getCpuUnits()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuLimit");
	text_element = Document->createTextNode( QString("%1").arg(getCpuLimit()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuLimitType");
	text_element = Document->createTextNode( QString("%1").arg(getCpuLimitType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuLimitValue");
	text_element = Document->createTextNode( QString("%1").arg(getCpuLimitValue()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("GuestLimitType");
	text_element = Document->createTextNode( QString("%1").arg(getGuestLimitType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuMask");
	text_element = Document->createTextNode( QString("%1").arg(getCpuMask()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("NodeMask");
	text_element = Document->createTextNode( QString("%1").arg(getNodeMask()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VirtualizedHV");
	text_element = Document->createTextNode( QString("%1").arg(isVirtualizedHV()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VirtualizePMU");
	text_element = Document->createTextNode( QString("%1").arg(isVirtualizePMU()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Sockets");
	text_element = Document->createTextNode( QString("%1").arg(getSockets()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmCpu::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Cpu") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmCpu': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Number_count = 1;
	int Mode_count = 1;
	int AccelerationLevel_count = 1;
	int EnableVTxSupport_count = 1;
	int EnableHotplug_count = 0;
	int CpuUnits_count = 0;
	int CpuLimit_count = 0;
	int CpuLimitType_count = 0;
	int CpuLimitValue_count = 0;
	int GuestLimitType_count = 0;
	int CpuMask_count = 0;
	int NodeMask_count = 0;
	int VirtualizedHV_count = 0;
	int VirtualizePMU_count = 0;
	int Sockets_count = 0;

	QString EnableVTxSupport_patch_stamp = RootElement->attribute("EnableVTxSupport_patch");
	if (unite_with_loaded && RootElement->firstChildElement("EnableVTxSupport").isNull())
		EnableVTxSupport_patch_stamp = getFieldPatchedValue("EnableVTxSupport");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Number";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Number_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Number")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNumber(text_element.data().toUInt());
			--Number_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Mode";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Mode_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Mode")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMode((PRL_CPU_MODE )text_element.data().toLongLong());
			--Mode_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AccelerationLevel";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AccelerationLevel_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AccelerationLevel")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAccelerationLevel((PRL_VM_ACCELERATION_LEVEL )text_element.data().toLongLong());
			--AccelerationLevel_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EnableVTxSupport";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EnableVTxSupport_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EnableVTxSupport")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnableVTxSupport((PVE::VTxSupportFlag )text_element.data().toLongLong());
			--EnableVTxSupport_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EnableHotplug";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EnableHotplug_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EnableHotplug")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnableHotplug(text_element.data().toInt() != 0);
			--EnableHotplug_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuUnits";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuUnits_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuUnits")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuUnits(text_element.data().toUInt());
			--CpuUnits_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuLimit";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuLimit_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuLimit")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuLimit(text_element.data().toUInt());
			--CpuLimit_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuLimitType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuLimitType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuLimitType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuLimitType((PRL_CPULIMIT_TYPE )text_element.data().toLongLong());
			--CpuLimitType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuLimitValue";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuLimitValue_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuLimitValue")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuLimitValue(text_element.data().toUInt());
			--CpuLimitValue_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "GuestLimitType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (GuestLimitType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "GuestLimitType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setGuestLimitType(text_element.data().toUInt());
			--GuestLimitType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuMask";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuMask_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuMask")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuMask(text_element.data());
			--CpuMask_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "NodeMask";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (NodeMask_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "NodeMask")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNodeMask(text_element.data());
			--NodeMask_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VirtualizedHV";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VirtualizedHV_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VirtualizedHV")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVirtualizedHV(text_element.data().toInt() != 0);
			--VirtualizedHV_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VirtualizePMU";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VirtualizePMU_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VirtualizePMU")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVirtualizePMU(text_element.data().toInt() != 0);
			--VirtualizePMU_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Sockets";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Sockets_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Sockets")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSockets(text_element.data().toUInt());
			--Sockets_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Number_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmCpu': tag 'Number' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Mode_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmCpu': tag 'Mode' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (AccelerationLevel_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmCpu': tag 'AccelerationLevel' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EnableVTxSupport_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmCpu': tag 'EnableVTxSupport' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EnableHotplug_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'EnableHotplug' is absent";
	}

	if (CpuUnits_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'CpuUnits' is absent";
	}

	if (CpuLimit_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'CpuLimit' is absent";
	}

	if (CpuLimitType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'CpuLimitType' is absent";
	}

	if (CpuLimitValue_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'CpuLimitValue' is absent";
	}

	if (GuestLimitType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'GuestLimitType' is absent";
	}

	if (CpuMask_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'CpuMask' is absent";
	}

	if (NodeMask_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'NodeMask' is absent";
	}

	if (VirtualizedHV_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'VirtualizedHV' is absent";
	}

	if (VirtualizePMU_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'VirtualizePMU' is absent";
	}

	if (Sockets_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmCpu': tag 'Sockets' is absent";
	}



	m_mapPatchedFields.insert("EnableVTxSupport", EnableVTxSupport_patch_stamp);


	return 0;
}

void CVmCpu::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmCpu::merge(CVmCpu* pCur, CVmCpu* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Cpu";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getNumber() != pCur->getNumber() && getNumber() == pPrev->getNumber())
		setNumber(pCur->getNumber());
	else if (getNumber() != pCur->getNumber() && getNumber() != pPrev->getNumber() && pCur->getNumber() != pPrev->getNumber())
	{
		m_qsErrorMessage += ".Number";
		return false;
	}

	if (getMode() != pCur->getMode() && getMode() == pPrev->getMode())
		setMode(pCur->getMode());
	else if (getMode() != pCur->getMode() && getMode() != pPrev->getMode() && pCur->getMode() != pPrev->getMode())
	{
		m_qsErrorMessage += ".Mode";
		return false;
	}

	if (getAccelerationLevel() != pCur->getAccelerationLevel() && getAccelerationLevel() == pPrev->getAccelerationLevel())
		setAccelerationLevel(pCur->getAccelerationLevel());
	else if (getAccelerationLevel() != pCur->getAccelerationLevel() && getAccelerationLevel() != pPrev->getAccelerationLevel() && pCur->getAccelerationLevel() != pPrev->getAccelerationLevel())
	{
		m_qsErrorMessage += ".AccelerationLevel";
		return false;
	}

	if (getEnableVTxSupport() != pCur->getEnableVTxSupport() && getEnableVTxSupport() == pPrev->getEnableVTxSupport())
		setEnableVTxSupport(pCur->getEnableVTxSupport());
	else if (getEnableVTxSupport() != pCur->getEnableVTxSupport() && getEnableVTxSupport() != pPrev->getEnableVTxSupport() && pCur->getEnableVTxSupport() != pPrev->getEnableVTxSupport())
	{
		m_qsErrorMessage += ".EnableVTxSupport";
		return false;
	}

	if (isEnableHotplug() != pCur->isEnableHotplug() && isEnableHotplug() == pPrev->isEnableHotplug())
		setEnableHotplug(pCur->isEnableHotplug());
	else if (isEnableHotplug() != pCur->isEnableHotplug() && isEnableHotplug() != pPrev->isEnableHotplug() && pCur->isEnableHotplug() != pPrev->isEnableHotplug())
	{
		m_qsErrorMessage += ".EnableHotplug";
		return false;
	}

	if (getCpuUnits() != pCur->getCpuUnits() && getCpuUnits() == pPrev->getCpuUnits())
		setCpuUnits(pCur->getCpuUnits());
	else if (getCpuUnits() != pCur->getCpuUnits() && getCpuUnits() != pPrev->getCpuUnits() && pCur->getCpuUnits() != pPrev->getCpuUnits())
	{
		m_qsErrorMessage += ".CpuUnits";
		return false;
	}

	if (getCpuLimit() != pCur->getCpuLimit() && getCpuLimit() == pPrev->getCpuLimit())
		setCpuLimit(pCur->getCpuLimit());
	else if (getCpuLimit() != pCur->getCpuLimit() && getCpuLimit() != pPrev->getCpuLimit() && pCur->getCpuLimit() != pPrev->getCpuLimit())
	{
		m_qsErrorMessage += ".CpuLimit";
		return false;
	}

	if (getCpuLimitType() != pCur->getCpuLimitType() && getCpuLimitType() == pPrev->getCpuLimitType())
		setCpuLimitType(pCur->getCpuLimitType());
	else if (getCpuLimitType() != pCur->getCpuLimitType() && getCpuLimitType() != pPrev->getCpuLimitType() && pCur->getCpuLimitType() != pPrev->getCpuLimitType())
	{
		m_qsErrorMessage += ".CpuLimitType";
		return false;
	}

	if (getCpuLimitValue() != pCur->getCpuLimitValue() && getCpuLimitValue() == pPrev->getCpuLimitValue())
		setCpuLimitValue(pCur->getCpuLimitValue());
	else if (getCpuLimitValue() != pCur->getCpuLimitValue() && getCpuLimitValue() != pPrev->getCpuLimitValue() && pCur->getCpuLimitValue() != pPrev->getCpuLimitValue())
	{
		m_qsErrorMessage += ".CpuLimitValue";
		return false;
	}

	if (getGuestLimitType() != pCur->getGuestLimitType() && getGuestLimitType() == pPrev->getGuestLimitType())
		setGuestLimitType(pCur->getGuestLimitType());
	else if (getGuestLimitType() != pCur->getGuestLimitType() && getGuestLimitType() != pPrev->getGuestLimitType() && pCur->getGuestLimitType() != pPrev->getGuestLimitType())
	{
		m_qsErrorMessage += ".GuestLimitType";
		return false;
	}

	if (getCpuMask() != pCur->getCpuMask() && getCpuMask() == pPrev->getCpuMask())
		setCpuMask(pCur->getCpuMask());
	else if (getCpuMask() != pCur->getCpuMask() && getCpuMask() != pPrev->getCpuMask() && pCur->getCpuMask() != pPrev->getCpuMask())
	{
		m_qsErrorMessage += ".CpuMask";
		return false;
	}

	if (getNodeMask() != pCur->getNodeMask() && getNodeMask() == pPrev->getNodeMask())
		setNodeMask(pCur->getNodeMask());
	else if (getNodeMask() != pCur->getNodeMask() && getNodeMask() != pPrev->getNodeMask() && pCur->getNodeMask() != pPrev->getNodeMask())
	{
		m_qsErrorMessage += ".NodeMask";
		return false;
	}

	if (isVirtualizedHV() != pCur->isVirtualizedHV() && isVirtualizedHV() == pPrev->isVirtualizedHV())
		setVirtualizedHV(pCur->isVirtualizedHV());
	else if (isVirtualizedHV() != pCur->isVirtualizedHV() && isVirtualizedHV() != pPrev->isVirtualizedHV() && pCur->isVirtualizedHV() != pPrev->isVirtualizedHV())
	{
		m_qsErrorMessage += ".VirtualizedHV";
		return false;
	}

	if (isVirtualizePMU() != pCur->isVirtualizePMU() && isVirtualizePMU() == pPrev->isVirtualizePMU())
		setVirtualizePMU(pCur->isVirtualizePMU());
	else if (isVirtualizePMU() != pCur->isVirtualizePMU() && isVirtualizePMU() != pPrev->isVirtualizePMU() && pCur->isVirtualizePMU() != pPrev->isVirtualizePMU())
	{
		m_qsErrorMessage += ".VirtualizePMU";
		return false;
	}

	if (getSockets() != pCur->getSockets() && getSockets() == pPrev->getSockets())
		setSockets(pCur->getSockets());
	else if (getSockets() != pCur->getSockets() && getSockets() != pPrev->getSockets() && pCur->getSockets() != pPrev->getSockets())
	{
		m_qsErrorMessage += ".Sockets";
		return false;
	}

	return true;
}

void CVmCpu::diff(const CVmCpu* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getNumber() != pOld->getNumber())
		lstDiffFullItemIds += getNumber_id();

	if (getMode() != pOld->getMode())
		lstDiffFullItemIds += getMode_id();

	if (getAccelerationLevel() != pOld->getAccelerationLevel())
		lstDiffFullItemIds += getAccelerationLevel_id();

	if (getEnableVTxSupport() != pOld->getEnableVTxSupport())
		lstDiffFullItemIds += getEnableVTxSupport_id();

	if (isEnableHotplug() != pOld->isEnableHotplug())
		lstDiffFullItemIds += getEnableHotplug_id();

	if (getCpuUnits() != pOld->getCpuUnits())
		lstDiffFullItemIds += getCpuUnits_id();

	if (getCpuLimit() != pOld->getCpuLimit())
		lstDiffFullItemIds += getCpuLimit_id();

	if (getCpuLimitType() != pOld->getCpuLimitType())
		lstDiffFullItemIds += getCpuLimitType_id();

	if (getCpuLimitValue() != pOld->getCpuLimitValue())
		lstDiffFullItemIds += getCpuLimitValue_id();

	if (getGuestLimitType() != pOld->getGuestLimitType())
		lstDiffFullItemIds += getGuestLimitType_id();

	if (getCpuMask() != pOld->getCpuMask())
		lstDiffFullItemIds += getCpuMask_id();

	if (getNodeMask() != pOld->getNodeMask())
		lstDiffFullItemIds += getNodeMask_id();

	if (isVirtualizedHV() != pOld->isVirtualizedHV())
		lstDiffFullItemIds += getVirtualizedHV_id();

	if (isVirtualizePMU() != pOld->isVirtualizePMU())
		lstDiffFullItemIds += getVirtualizePMU_id();

	if (getSockets() != pOld->getSockets())
		lstDiffFullItemIds += getSockets_id();

}

void CVmCpu::Copy(const CVmCpu& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setNumber(rObject.getNumber());
	setMode(rObject.getMode());
	setAccelerationLevel(rObject.getAccelerationLevel());
	setEnableVTxSupport(rObject.getEnableVTxSupport());
	setEnableHotplug(rObject.isEnableHotplug());
	setCpuUnits(rObject.getCpuUnits());
	setCpuLimit(rObject.getCpuLimit());
	setCpuLimitType(rObject.getCpuLimitType());
	setCpuLimitValue(rObject.getCpuLimitValue());
	setGuestLimitType(rObject.getGuestLimitType());
	setCpuMask(rObject.getCpuMask());
	setNodeMask(rObject.getNodeMask());
	setVirtualizedHV(rObject.isVirtualizedHV());
	setVirtualizePMU(rObject.isVirtualizePMU());
	setSockets(rObject.getSockets());

	CustomCopy(&rObject);

}

void CVmCpu::InitLists()
{
	CustomInit();
}

void CVmCpu::ClearLists()
{
}

void CVmCpu::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

