////////////////////////////////////////////////////////////////////////////////
///
/// CVmCpu.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMCPU_H
#define CVMCPU_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include <prlsdk/PrlIOStructs.h>


class CVmCpu : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmCpu();
	CVmCpu(const CVmCpu& rObject);
	CVmCpu(const CVmCpu* pObject);
	CVmCpu(QFile* pFile);
	CVmCpu& operator=(const CVmCpu& rObject);
	virtual ~CVmCpu();


void setCpuLimitData(PRL_CONST_CPULIMIT_DATA_PTR cpulimit);
void getCpuLimitData(PRL_CPULIMIT_DATA_PTR cpulimit);
								
void setCpuLimitPercents(unsigned int value);
							
    bool    operator==(CVmCpu& cVmCpu);



	unsigned int getNumber() const;
	void setNumber(unsigned int value = XML_DEFAULT_VM_CPU_NUMBER);

	PRL_CPU_MODE getMode() const;
	void setMode(PRL_CPU_MODE value = PCM_CPU_MODE_64);

	PRL_VM_ACCELERATION_LEVEL getAccelerationLevel() const;
	void setAccelerationLevel(PRL_VM_ACCELERATION_LEVEL value = PVA_ACCELERATION_HIGH);

	PVE::VTxSupportFlag getEnableVTxSupport() const;
	void setEnableVTxSupport(PVE::VTxSupportFlag value = PVE::VTxSupportEnabled);

	bool isEnableHotplug() const;
	void setEnableHotplug(bool value = false);

	unsigned int getCpuUnits() const;
	void setCpuUnits(unsigned int value = 0);

	unsigned int getCpuLimit() const;
	void setCpuLimit(unsigned int value = 0);

	PRL_CPULIMIT_TYPE getCpuLimitType() const;
	void setCpuLimitType(PRL_CPULIMIT_TYPE value = PRL_CPULIMIT_MHZ);

	unsigned int getCpuLimitValue() const;
	void setCpuLimitValue(unsigned int value = 0);

	unsigned int getGuestLimitType() const;
	void setGuestLimitType(unsigned int value = 0);

	QString getCpuMask() const;
	void setCpuMask(QString value = QString());

	QString getNodeMask() const;
	void setNodeMask(QString value = QString());

	bool isVirtualizedHV() const;
	void setVirtualizedHV(bool value = false);

	bool isVirtualizePMU() const;
	void setVirtualizePMU(bool value = false);

	unsigned int getSockets() const;
	void setSockets(unsigned int value = 1);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getNumber_id() const;
	QString getMode_id() const;
	QString getAccelerationLevel_id() const;
	QString getEnableVTxSupport_id() const;
	QString getEnableHotplug_id() const;
	QString getCpuUnits_id() const;
	QString getCpuLimit_id() const;
	QString getCpuLimitType_id() const;
	QString getCpuLimitValue_id() const;
	QString getGuestLimitType_id() const;
	QString getCpuMask_id() const;
	QString getNodeMask_id() const;
	QString getVirtualizedHV_id() const;
	QString getVirtualizePMU_id() const;
	QString getSockets_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmCpu* pCur, CVmCpu* pPrev, MergeOptions nOptions);

	void diff(const CVmCpu* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	unsigned int		m_uiNumber;
	PRL_CPU_MODE		m_ctMode;
	PRL_VM_ACCELERATION_LEVEL		m_ctAccelerationLevel;
	PVE::VTxSupportFlag		m_ctEnableVTxSupport;
	bool		m_bEnableHotplug;
	unsigned int		m_uiCpuUnits;
	unsigned int		m_uiCpuLimit;
	PRL_CPULIMIT_TYPE		m_ctCpuLimitType;
	unsigned int		m_uiCpuLimitValue;
	unsigned int		m_uiGuestLimitType;
	QString		m_qsCpuMask;
	QString		m_qsNodeMask;
	bool		m_bVirtualizedHV;
	bool		m_bVirtualizePMU;
	unsigned int		m_uiSockets;

	void Copy(const CVmCpu& rObject);

signals:

	void signalNumberChanged(unsigned int value, QString object_id = QString());
	void signalModeChanged(PRL_CPU_MODE value, QString object_id = QString());
	void signalAccelerationLevelChanged(PRL_VM_ACCELERATION_LEVEL value, QString object_id = QString());
	void signalEnableVTxSupportChanged(PVE::VTxSupportFlag value, QString object_id = QString());
	void signalEnableHotplugChanged(bool value, QString object_id = QString());
	void signalCpuUnitsChanged(unsigned int value, QString object_id = QString());
	void signalCpuLimitChanged(unsigned int value, QString object_id = QString());
	void signalCpuLimitTypeChanged(PRL_CPULIMIT_TYPE value, QString object_id = QString());
	void signalCpuLimitValueChanged(unsigned int value, QString object_id = QString());
	void signalGuestLimitTypeChanged(unsigned int value, QString object_id = QString());
	void signalCpuMaskChanged(QString value, QString object_id = QString());
	void signalNodeMaskChanged(QString value, QString object_id = QString());
	void signalVirtualizedHVChanged(bool value, QString object_id = QString());
	void signalVirtualizePMUChanged(bool value, QString object_id = QString());
	void signalSocketsChanged(unsigned int value, QString object_id = QString());

private slots:

	void slotChangeNumber(unsigned int value);
	void slotChangeMode(PRL_CPU_MODE value);
	void slotChangeAccelerationLevel(PRL_VM_ACCELERATION_LEVEL value);
	void slotChangeEnableVTxSupport(PVE::VTxSupportFlag value);
	void slotChangeEnableHotplug(bool value);
	void slotChangeCpuUnits(unsigned int value);
	void slotChangeCpuLimit(unsigned int value);
	void slotChangeCpuLimitType(PRL_CPULIMIT_TYPE value);
	void slotChangeCpuLimitValue(unsigned int value);
	void slotChangeGuestLimitType(unsigned int value);
	void slotChangeCpuMask(QString value);
	void slotChangeNodeMask(QString value);
	void slotChangeVirtualizedHV(bool value);
	void slotChangeVirtualizePMU(bool value);
	void slotChangeSockets(unsigned int value);

};

#ifndef DM_253650053
#define DM_253650053
Q_DECLARE_METATYPE(PRL_CPU_MODE)
#endif
#ifndef DM_37898876
#define DM_37898876
Q_DECLARE_METATYPE(PRL_VM_ACCELERATION_LEVEL)
#endif
#ifndef DM_126755031
#define DM_126755031
Q_DECLARE_METATYPE(PVE::VTxSupportFlag)
#endif
#ifndef DM_260917893
#define DM_260917893
Q_DECLARE_METATYPE(PRL_CPULIMIT_TYPE)
#endif


#endif
