////////////////////////////////////////////////////////////////////////////////
///
/// CVmExpiration.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmExpiration.h"


CVmExpiration::CVmExpiration()
{
	InitLists();
	setDefaults();
}

CVmExpiration::CVmExpiration(const CVmExpiration& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmExpiration::CVmExpiration(const CVmExpiration* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmExpiration& CVmExpiration::operator=(const CVmExpiration& rObject)
{
	Copy(rObject);
	return *this;
}

CVmExpiration::CVmExpiration(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmExpiration::~CVmExpiration()
{
	ClearLists();
}


bool CVmExpiration::isEnabled() const
{
	return m_bEnabled;
}

void CVmExpiration::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void CVmExpiration::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

QDateTime CVmExpiration::getExpirationDate() const
{
	return m_dtExpirationDate;
}

void CVmExpiration::setExpirationDate(QDateTime value)
{
	QTime t = value.time(); t.setHMS(t.hour(), t.minute(), t.second()); value.setTime(t);
	bool bValueChanged = (m_dtExpirationDate != value);
	m_dtExpirationDate = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalExpirationDateChanged(value);
	}
}

void CVmExpiration::slotChangeExpirationDate(QDateTime value)
{
	setExpirationDate(value);
}

QUrl CVmExpiration::getTrustedTimeServerUrl() const
{
	return m_urlTrustedTimeServerUrl;
}

void CVmExpiration::setTrustedTimeServerUrl(QUrl value)
{
	bool bValueChanged = (m_urlTrustedTimeServerUrl != value);
	m_urlTrustedTimeServerUrl = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTrustedTimeServerUrlChanged(value);
	}
}

void CVmExpiration::slotChangeTrustedTimeServerUrl(QUrl value)
{
	setTrustedTimeServerUrl(value);
}

QString CVmExpiration::getNote() const
{
	return m_qsNote;
}

void CVmExpiration::setNote(QString value)
{
	bool bValueChanged = (m_qsNote != value);
	m_qsNote = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalNoteChanged(value);
	}
}

void CVmExpiration::slotChangeNote(QString value)
{
	setNote(value);
}

unsigned int CVmExpiration::getTimeCheckIntervalSeconds() const
{
	return m_uiTimeCheckIntervalSeconds;
}

void CVmExpiration::setTimeCheckIntervalSeconds(unsigned int value)
{
	bool bValueChanged = (m_uiTimeCheckIntervalSeconds != value);
	m_uiTimeCheckIntervalSeconds = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTimeCheckIntervalSecondsChanged(value);
	}
}

void CVmExpiration::slotChangeTimeCheckIntervalSeconds(unsigned int value)
{
	setTimeCheckIntervalSeconds(value);
}

unsigned int CVmExpiration::getOfflineTimeToLiveSeconds() const
{
	return m_uiOfflineTimeToLiveSeconds;
}

void CVmExpiration::setOfflineTimeToLiveSeconds(unsigned int value)
{
	bool bValueChanged = (m_uiOfflineTimeToLiveSeconds != value);
	m_uiOfflineTimeToLiveSeconds = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOfflineTimeToLiveSecondsChanged(value);
	}
}

void CVmExpiration::slotChangeOfflineTimeToLiveSeconds(unsigned int value)
{
	setOfflineTimeToLiveSeconds(value);
}

void CVmExpiration::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("ExpirationDate").isNull() )
		setExpirationDate(QDateTime(
													QDateTime::fromString(XML_DEFAULT_DATE_TIME, XML_DATETIME_FORMAT).date(),
													QDateTime::fromString(XML_DEFAULT_DATE_TIME, XML_DATETIME_FORMAT).time(),
													Qt::UTC));
	if ( ! RootElement || ! RootElement->firstChildElement("TrustedTimeServerUrl").isNull() )
		setTrustedTimeServerUrl();
	if ( ! RootElement || ! RootElement->firstChildElement("Note").isNull() )
		setNote();
	if ( ! RootElement || ! RootElement->firstChildElement("TimeCheckIntervalSeconds").isNull() )
		setTimeCheckIntervalSeconds();
	if ( ! RootElement || ! RootElement->firstChildElement("OfflineTimeToLiveSeconds").isNull() )
		setOfflineTimeToLiveSeconds();
}

QVariant CVmExpiration::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "ExpirationDate.patch_stamp")
		value.setValue(getFieldPatchedValue("ExpirationDate"));

	if (path == "ExpirationDate")
		value.setValue(getExpirationDate());

	if (path == "TrustedTimeServerUrl.patch_stamp")
		value.setValue(getFieldPatchedValue("TrustedTimeServerUrl"));

	if (path == "TrustedTimeServerUrl")
		value.setValue(getTrustedTimeServerUrl());

	if (path == "Note.patch_stamp")
		value.setValue(getFieldPatchedValue("Note"));

	if (path == "Note")
		value.setValue(getNote());

	if (path == "TimeCheckIntervalSeconds.patch_stamp")
		value.setValue(getFieldPatchedValue("TimeCheckIntervalSeconds"));

	if (path == "TimeCheckIntervalSeconds")
		value.setValue(getTimeCheckIntervalSeconds());

	if (path == "OfflineTimeToLiveSeconds.patch_stamp")
		value.setValue(getFieldPatchedValue("OfflineTimeToLiveSeconds"));

	if (path == "OfflineTimeToLiveSeconds")
		value.setValue(getOfflineTimeToLiveSeconds());

	return value;
}

bool CVmExpiration::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "ExpirationDate.patch_stamp")
	{
		markPatchedField("ExpirationDate", value.toString());
		return true;
	}

	if (path == "ExpirationDate")
	{
		if (pbValueChanged)
			*pbValueChanged = (getExpirationDate() != value.value< QDateTime >());
		setExpirationDate(value.value< QDateTime >());
		return true;
	}

	if (path == "TrustedTimeServerUrl.patch_stamp")
	{
		markPatchedField("TrustedTimeServerUrl", value.toString());
		return true;
	}

	if (path == "TrustedTimeServerUrl")
	{
		if (pbValueChanged)
			*pbValueChanged = (getTrustedTimeServerUrl() != value.value< QUrl >());
		setTrustedTimeServerUrl(value.value< QUrl >());
		return true;
	}

	if (path == "Note.patch_stamp")
	{
		markPatchedField("Note", value.toString());
		return true;
	}

	if (path == "Note")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNote() != value.value< QString >());
		setNote(value.value< QString >());
		return true;
	}

	if (path == "TimeCheckIntervalSeconds.patch_stamp")
	{
		markPatchedField("TimeCheckIntervalSeconds", value.toString());
		return true;
	}

	if (path == "TimeCheckIntervalSeconds")
	{
		if (pbValueChanged)
			*pbValueChanged = (getTimeCheckIntervalSeconds() != value.value< unsigned int >());
		setTimeCheckIntervalSeconds(value.value< unsigned int >());
		return true;
	}

	if (path == "OfflineTimeToLiveSeconds.patch_stamp")
	{
		markPatchedField("OfflineTimeToLiveSeconds", value.toString());
		return true;
	}

	if (path == "OfflineTimeToLiveSeconds")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOfflineTimeToLiveSeconds() != value.value< unsigned int >());
		setOfflineTimeToLiveSeconds(value.value< unsigned int >());
		return true;
	}

	return false;
}

QString CVmExpiration::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmExpiration::getExpirationDate_id() const
{
	return getFullItemId().isEmpty() ? "ExpirationDate" : getFullItemId() + ".ExpirationDate";
}
QString CVmExpiration::getTrustedTimeServerUrl_id() const
{
	return getFullItemId().isEmpty() ? "TrustedTimeServerUrl" : getFullItemId() + ".TrustedTimeServerUrl";
}
QString CVmExpiration::getNote_id() const
{
	return getFullItemId().isEmpty() ? "Note" : getFullItemId() + ".Note";
}
QString CVmExpiration::getTimeCheckIntervalSeconds_id() const
{
	return getFullItemId().isEmpty() ? "TimeCheckIntervalSeconds" : getFullItemId() + ".TimeCheckIntervalSeconds";
}
QString CVmExpiration::getOfflineTimeToLiveSeconds_id() const
{
	return getFullItemId().isEmpty() ? "OfflineTimeToLiveSeconds" : getFullItemId() + ".OfflineTimeToLiveSeconds";
}

int CVmExpiration::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmExpiration::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmExpiration::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ExpirationInfo") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ExpirationDate");
	text_element = Document->createTextNode( QString("%1").arg(getExpirationDate().toUTC().toString(XML_DATETIME_FORMAT)) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("TrustedTimeServerUrl");
	text_element = Document->createTextNode( QString("%1").arg(getTrustedTimeServerUrl().toString()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Note");
	text_element = Document->createTextNode( QString("%1").arg(getNote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("TimeCheckIntervalSeconds");
	text_element = Document->createTextNode( QString("%1").arg(getTimeCheckIntervalSeconds()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OfflineTimeToLiveSeconds");
	text_element = Document->createTextNode( QString("%1").arg(getOfflineTimeToLiveSeconds()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmExpiration::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ExpirationInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmExpiration': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Enabled_count = 0;
	int ExpirationDate_count = 0;
	int TrustedTimeServerUrl_count = 0;
	int Note_count = 0;
	int TimeCheckIntervalSeconds_count = 0;
	int OfflineTimeToLiveSeconds_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ExpirationDate";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ExpirationDate_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ExpirationDate")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setExpirationDate(toLocalTime( QDateTime::fromString( text_element.data(), XML_DATETIME_FORMAT ) ));
			--ExpirationDate_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "TrustedTimeServerUrl";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (TrustedTimeServerUrl_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "TrustedTimeServerUrl")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setTrustedTimeServerUrl(text_element.data());
			--TrustedTimeServerUrl_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Note";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Note_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Note")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNote(text_element.data());
			--Note_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "TimeCheckIntervalSeconds";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (TimeCheckIntervalSeconds_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "TimeCheckIntervalSeconds")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setTimeCheckIntervalSeconds(text_element.data().toUInt());
			--TimeCheckIntervalSeconds_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OfflineTimeToLiveSeconds";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OfflineTimeToLiveSeconds_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OfflineTimeToLiveSeconds")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOfflineTimeToLiveSeconds(text_element.data().toUInt());
			--OfflineTimeToLiveSeconds_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Enabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'Enabled' is absent";
	}

	if (ExpirationDate_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'ExpirationDate' is absent";
	}

	if (TrustedTimeServerUrl_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'TrustedTimeServerUrl' is absent";
	}

	if (Note_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'Note' is absent";
	}

	if (TimeCheckIntervalSeconds_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'TimeCheckIntervalSeconds' is absent";
	}

	if (OfflineTimeToLiveSeconds_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmExpiration': tag 'OfflineTimeToLiveSeconds' is absent";
	}



	return 0;
}

void CVmExpiration::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmExpiration::merge(CVmExpiration* pCur, CVmExpiration* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ExpirationInfo";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getExpirationDate() != pCur->getExpirationDate() && getExpirationDate() == pPrev->getExpirationDate())
		setExpirationDate(pCur->getExpirationDate());
	else if (getExpirationDate() != pCur->getExpirationDate() && getExpirationDate() != pPrev->getExpirationDate() && pCur->getExpirationDate() != pPrev->getExpirationDate())
	{
		m_qsErrorMessage += ".ExpirationDate";
		return false;
	}

	if (getTrustedTimeServerUrl() != pCur->getTrustedTimeServerUrl() && getTrustedTimeServerUrl() == pPrev->getTrustedTimeServerUrl())
		setTrustedTimeServerUrl(pCur->getTrustedTimeServerUrl());
	else if (getTrustedTimeServerUrl() != pCur->getTrustedTimeServerUrl() && getTrustedTimeServerUrl() != pPrev->getTrustedTimeServerUrl() && pCur->getTrustedTimeServerUrl() != pPrev->getTrustedTimeServerUrl())
	{
		m_qsErrorMessage += ".TrustedTimeServerUrl";
		return false;
	}

	if (getNote() != pCur->getNote() && getNote() == pPrev->getNote())
		setNote(pCur->getNote());
	else if (getNote() != pCur->getNote() && getNote() != pPrev->getNote() && pCur->getNote() != pPrev->getNote())
	{
		m_qsErrorMessage += ".Note";
		return false;
	}

	if (getTimeCheckIntervalSeconds() != pCur->getTimeCheckIntervalSeconds() && getTimeCheckIntervalSeconds() == pPrev->getTimeCheckIntervalSeconds())
		setTimeCheckIntervalSeconds(pCur->getTimeCheckIntervalSeconds());
	else if (getTimeCheckIntervalSeconds() != pCur->getTimeCheckIntervalSeconds() && getTimeCheckIntervalSeconds() != pPrev->getTimeCheckIntervalSeconds() && pCur->getTimeCheckIntervalSeconds() != pPrev->getTimeCheckIntervalSeconds())
	{
		m_qsErrorMessage += ".TimeCheckIntervalSeconds";
		return false;
	}

	if (getOfflineTimeToLiveSeconds() != pCur->getOfflineTimeToLiveSeconds() && getOfflineTimeToLiveSeconds() == pPrev->getOfflineTimeToLiveSeconds())
		setOfflineTimeToLiveSeconds(pCur->getOfflineTimeToLiveSeconds());
	else if (getOfflineTimeToLiveSeconds() != pCur->getOfflineTimeToLiveSeconds() && getOfflineTimeToLiveSeconds() != pPrev->getOfflineTimeToLiveSeconds() && pCur->getOfflineTimeToLiveSeconds() != pPrev->getOfflineTimeToLiveSeconds())
	{
		m_qsErrorMessage += ".OfflineTimeToLiveSeconds";
		return false;
	}

	return true;
}

void CVmExpiration::diff(const CVmExpiration* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getExpirationDate() != pOld->getExpirationDate())
		lstDiffFullItemIds += getExpirationDate_id();

	if (getTrustedTimeServerUrl() != pOld->getTrustedTimeServerUrl())
		lstDiffFullItemIds += getTrustedTimeServerUrl_id();

	if (getNote() != pOld->getNote())
		lstDiffFullItemIds += getNote_id();

	if (getTimeCheckIntervalSeconds() != pOld->getTimeCheckIntervalSeconds())
		lstDiffFullItemIds += getTimeCheckIntervalSeconds_id();

	if (getOfflineTimeToLiveSeconds() != pOld->getOfflineTimeToLiveSeconds())
		lstDiffFullItemIds += getOfflineTimeToLiveSeconds_id();

}

void CVmExpiration::Copy(const CVmExpiration& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());
	setExpirationDate(rObject.getExpirationDate());
	setTrustedTimeServerUrl(rObject.getTrustedTimeServerUrl().toString());
	setNote(rObject.getNote());
	setTimeCheckIntervalSeconds(rObject.getTimeCheckIntervalSeconds());
	setOfflineTimeToLiveSeconds(rObject.getOfflineTimeToLiveSeconds());

	CustomCopy(&rObject);

}

void CVmExpiration::InitLists()
{
	CustomInit();
}

void CVmExpiration::ClearLists()
{
}

void CVmExpiration::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

