////////////////////////////////////////////////////////////////////////////////
///
/// CVmGenericNetworkAdapter.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmGenericNetworkAdapter.h"


CVmGenericNetworkAdapter::CVmGenericNetworkAdapter()
{
	InitLists();
	setDefaults();
}

CVmGenericNetworkAdapter::CVmGenericNetworkAdapter(const CVmGenericNetworkAdapter& rObject)
: CVmClusteredDevice()
{
	Copy(rObject);
}

CVmGenericNetworkAdapter::CVmGenericNetworkAdapter(const CVmGenericNetworkAdapter* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmGenericNetworkAdapter& CVmGenericNetworkAdapter::operator=(const CVmGenericNetworkAdapter& rObject)
{
	Copy(rObject);
	return *this;
}

CVmGenericNetworkAdapter::CVmGenericNetworkAdapter(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmGenericNetworkAdapter::~CVmGenericNetworkAdapter()
{
	ClearLists();
}


#include <prlcommon/HostUtils/HostUtils.h>
void CVmGenericNetworkAdapter::setConfigureWithDhcpIPv6Ex(bool value)
{
	setConfigureWithDhcpIPv6(value);
	if (value)
	{	//clean v6 IPs
		QList<QString> lstNetAddress = getNetAddresses();
		for(int i = lstNetAddress.size()-1; i >= 0; i--)
			if (isIPv6(lstNetAddress[i]))
				lstNetAddress.removeAt(i);
		setNetAddresses(lstNetAddress);
	}
}

void CVmGenericNetworkAdapter::setConfigureWithDhcpEx(bool value)
{
	setConfigureWithDhcp(value);
	if (value)
	{	//clean v4 IPs
		QList<QString> lstNetAddress = getNetAddresses();
		for(int i = lstNetAddress.size()-1; i >= 0; i--)
			if (!isIPv6(lstNetAddress[i]))
				lstNetAddress.removeAt(i);
		setNetAddresses(lstNetAddress);
	}
}

bool CVmGenericNetworkAdapter::isIPv6(const QString &ip)
{
	return (ip.indexOf(':') >= 0);
}

bool CVmGenericNetworkAdapter::operator==( const CVmGenericNetworkAdapter& cVmGenericNetworkAdapter)
{
    if ( !CVmClusteredDevice::operator ==(cVmGenericNetworkAdapter) )
        return false;

    if (getBoundAdapterIndex() == cVmGenericNetworkAdapter.getBoundAdapterIndex()
        && getBoundAdapterName() == cVmGenericNetworkAdapter.getBoundAdapterName()
        && getVirtualNetworkID() == cVmGenericNetworkAdapter.getVirtualNetworkID()
        && getMacAddress() == cVmGenericNetworkAdapter.getMacAddress()
        && isRouter() == cVmGenericNetworkAdapter.isRouter()
        && getDHCPUseHostMac() == cVmGenericNetworkAdapter.getDHCPUseHostMac()
        && getNetAddresses() == cVmGenericNetworkAdapter.getNetAddresses()
        && isAutoApply() == cVmGenericNetworkAdapter.isAutoApply()
        && getDefaultGateway() == cVmGenericNetworkAdapter.getDefaultGateway()
        && getDnsIPAddresses() == cVmGenericNetworkAdapter.getDnsIPAddresses()
        && getSearchDomains() == cVmGenericNetworkAdapter.getSearchDomains()
        && isConfigureWithDhcp() == cVmGenericNetworkAdapter.isConfigureWithDhcp()
        && isConfigureWithDhcpIPv6() == cVmGenericNetworkAdapter.isConfigureWithDhcpIPv6()
        && getAdapterType() == cVmGenericNetworkAdapter.getAdapterType()
	&& *getPktFilter() == *cVmGenericNetworkAdapter.getPktFilter())
    {
        return true;
    }

    return false;
}

CNetPktFilter* CVmGenericNetworkAdapter::getPktFilter() const
{
	if (!m_lstPktFilter.isEmpty())
	{
		return m_lstPktFilter[0];
	}
	return 0;
}

void CVmGenericNetworkAdapter::setPktFilter(CNetPktFilter* pPktFilter)
{
	ClearList<CNetPktFilter>(m_lstPktFilter);
	if (pPktFilter)
	{
		m_lstPktFilter += pPktFilter;
	}
}

CVmNetFirewall* CVmGenericNetworkAdapter::getFirewall() const
{
	if (!m_lstFirewall.isEmpty())
	{
		return m_lstFirewall[0];
	}
	return 0;
}

void CVmGenericNetworkAdapter::setFirewall(CVmNetFirewall* pFirewall)
{
	ClearList<CVmNetFirewall>(m_lstFirewall);
	if (pFirewall)
	{
		m_lstFirewall += pFirewall;
	}
}

int CVmGenericNetworkAdapter::getBoundAdapterIndex() const
{
	return m_iAdapterNumber;
}

void CVmGenericNetworkAdapter::setBoundAdapterIndex(int value)
{
	bool bValueChanged = (m_iAdapterNumber != value);
	m_iAdapterNumber = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalBoundAdapterIndexChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeBoundAdapterIndex(int value)
{
	setBoundAdapterIndex(value);
}

QString CVmGenericNetworkAdapter::getBoundAdapterName() const
{
	return m_qsAdapterName;
}

void CVmGenericNetworkAdapter::setBoundAdapterName(QString value)
{
	bool bValueChanged = (m_qsAdapterName != value);
	m_qsAdapterName = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalBoundAdapterNameChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeBoundAdapterName(QString value)
{
	setBoundAdapterName(value);
}

QString CVmGenericNetworkAdapter::getMacAddress() const
{
	return m_qsMAC;
}

void CVmGenericNetworkAdapter::setMacAddress(QString value)
{
	bool bValueChanged = (m_qsMAC != value);
	m_qsMAC = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalMacAddressChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeMacAddress(QString value)
{
	setMacAddress(value);
}

QString CVmGenericNetworkAdapter::getHostMacAddress() const
{
	return m_qsHostMAC;
}

void CVmGenericNetworkAdapter::setHostMacAddress(QString value)
{
	bool bValueChanged = (m_qsHostMAC != value);
	m_qsHostMAC = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalHostMacAddressChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeHostMacAddress(QString value)
{
	setHostMacAddress(value);
}

QString CVmGenericNetworkAdapter::getHostInterfaceName() const
{
	return m_qsHostInterfaceName;
}

void CVmGenericNetworkAdapter::setHostInterfaceName(QString value)
{
	bool bValueChanged = (m_qsHostInterfaceName != value);
	m_qsHostInterfaceName = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalHostInterfaceNameChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeHostInterfaceName(QString value)
{
	setHostInterfaceName(value);
}

bool CVmGenericNetworkAdapter::isRouter() const
{
	return m_bRouter;
}

void CVmGenericNetworkAdapter::setRouter(bool value)
{
	bool bValueChanged = (m_bRouter != value);
	m_bRouter = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalRouterChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeRouter(bool value)
{
	setRouter(value);
}

unsigned int CVmGenericNetworkAdapter::getDHCPUseHostMac() const
{
	return m_uiDHCPUseHostMac;
}

void CVmGenericNetworkAdapter::setDHCPUseHostMac(unsigned int value)
{
	bool bValueChanged = (m_uiDHCPUseHostMac != value);
	m_uiDHCPUseHostMac = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDHCPUseHostMacChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeDHCPUseHostMac(unsigned int value)
{
	setDHCPUseHostMac(value);
}

bool CVmGenericNetworkAdapter::isForceHostMacAddress() const
{
	return m_bForceHostMacAddress;
}

void CVmGenericNetworkAdapter::setForceHostMacAddress(bool value)
{
	bool bValueChanged = (m_bForceHostMacAddress != value);
	m_bForceHostMacAddress = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalForceHostMacAddressChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeForceHostMacAddress(bool value)
{
	setForceHostMacAddress(value);
}

QString CVmGenericNetworkAdapter::getVirtualNetworkID() const
{
	return m_qsVirtualNetworkID;
}

void CVmGenericNetworkAdapter::setVirtualNetworkID(QString value)
{
	bool bValueChanged = (m_qsVirtualNetworkID != value);
	m_qsVirtualNetworkID = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalVirtualNetworkIDChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeVirtualNetworkID(QString value)
{
	setVirtualNetworkID(value);
}

PRL_VM_NET_ADAPTER_TYPE CVmGenericNetworkAdapter::getAdapterType() const
{
	return m_ctAdapterType;
}

void CVmGenericNetworkAdapter::setAdapterType(PRL_VM_NET_ADAPTER_TYPE value)
{
	bool bValueChanged = (m_ctAdapterType != value);
	m_ctAdapterType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAdapterTypeChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeAdapterType(PRL_VM_NET_ADAPTER_TYPE value)
{
	setAdapterType(value);
}

bool CVmGenericNetworkAdapter::isStaticAddress() const
{
	return m_bStaticAddress;
}

void CVmGenericNetworkAdapter::setStaticAddress(bool value)
{
	bool bValueChanged = (m_bStaticAddress != value);
	m_bStaticAddress = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalStaticAddressChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeStaticAddress(bool value)
{
	setStaticAddress(value);
}

bool CVmGenericNetworkAdapter::isAutoApply() const
{
	return m_bAutoApply;
}

void CVmGenericNetworkAdapter::setAutoApply(bool value)
{
	bool bValueChanged = (m_bAutoApply != value);
	m_bAutoApply = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAutoApplyChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeAutoApply(bool value)
{
	setAutoApply(value);
}

QList<QString> CVmGenericNetworkAdapter::getNetAddresses() const
{
	return m_lstNetAddress;
}

void CVmGenericNetworkAdapter::setNetAddresses(QList<QString> value)
{
	bool bValueChanged = (m_lstNetAddress != value);
	m_lstNetAddress = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalNetAddressesChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeNetAddresses(QList<QString> value)
{
	setNetAddresses(value);
}

bool CVmGenericNetworkAdapter::isConfigureWithDhcp() const
{
	return m_bConfigureWithDhcp;
}

void CVmGenericNetworkAdapter::setConfigureWithDhcp(bool value)
{
	bool bValueChanged = (m_bConfigureWithDhcp != value);
	m_bConfigureWithDhcp = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalConfigureWithDhcpChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeConfigureWithDhcp(bool value)
{
	setConfigureWithDhcp(value);
}

QString CVmGenericNetworkAdapter::getDefaultGateway() const
{
	return m_qsDefaultGateway;
}

void CVmGenericNetworkAdapter::setDefaultGateway(QString value)
{
	bool bValueChanged = (m_qsDefaultGateway != value);
	m_qsDefaultGateway = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDefaultGatewayChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeDefaultGateway(QString value)
{
	setDefaultGateway(value);
}

bool CVmGenericNetworkAdapter::isConfigureWithDhcpIPv6() const
{
	return m_bConfigureWithDhcpIPv6;
}

void CVmGenericNetworkAdapter::setConfigureWithDhcpIPv6(bool value)
{
	bool bValueChanged = (m_bConfigureWithDhcpIPv6 != value);
	m_bConfigureWithDhcpIPv6 = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalConfigureWithDhcpIPv6Changed(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeConfigureWithDhcpIPv6(bool value)
{
	setConfigureWithDhcpIPv6(value);
}

QString CVmGenericNetworkAdapter::getDefaultGatewayIPv6() const
{
	return m_qsDefaultGatewayIPv6;
}

void CVmGenericNetworkAdapter::setDefaultGatewayIPv6(QString value)
{
	bool bValueChanged = (m_qsDefaultGatewayIPv6 != value);
	m_qsDefaultGatewayIPv6 = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDefaultGatewayIPv6Changed(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeDefaultGatewayIPv6(QString value)
{
	setDefaultGatewayIPv6(value);
}

QList<QString> CVmGenericNetworkAdapter::getDnsIPAddresses() const
{
	return m_lstDnsIPAddress;
}

void CVmGenericNetworkAdapter::setDnsIPAddresses(QList<QString> value)
{
	bool bValueChanged = (m_lstDnsIPAddress != value);
	m_lstDnsIPAddress = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDnsIPAddressesChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeDnsIPAddresses(QList<QString> value)
{
	setDnsIPAddresses(value);
}

QList<QString> CVmGenericNetworkAdapter::getSearchDomains() const
{
	return m_lstSearchDomain;
}

void CVmGenericNetworkAdapter::setSearchDomains(QList<QString> value)
{
	bool bValueChanged = (m_lstSearchDomain != value);
	m_lstSearchDomain = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalSearchDomainsChanged(value, getObjectId());
	}
}

void CVmGenericNetworkAdapter::slotChangeSearchDomains(QList<QString> value)
{
	setSearchDomains(value);
}

void CVmGenericNetworkAdapter::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Index").isNull() )
		setIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Connected").isNull() )
		setConnected();
	if ( ! RootElement || ! RootElement->firstChildElement("EmulatedType").isNull() )
		setEmulatedType(PNA_BRIDGED_NETWORK);
	if ( ! RootElement || ! RootElement->firstChildElement("SystemName").isNull() )
		setSystemName();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
	if ( ! RootElement || ! RootElement->firstChildElement("Remote").isNull() )
		setRemote();
	if ( ! RootElement || ! RootElement->firstChildElement("AdapterNumber").isNull() )
		setBoundAdapterIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("AdapterName").isNull() )
		setBoundAdapterName();
	if ( ! RootElement || ! RootElement->firstChildElement("MAC").isNull() )
		setMacAddress();
	if ( ! RootElement || ! RootElement->firstChildElement("HostMAC").isNull() )
		setHostMacAddress();
	if ( ! RootElement || ! RootElement->firstChildElement("HostInterfaceName").isNull() )
		setHostInterfaceName();
	if ( ! RootElement || ! RootElement->firstChildElement("Router").isNull() )
		setRouter();
	if ( ! RootElement || ! RootElement->firstChildElement("DHCPUseHostMac").isNull() )
		setDHCPUseHostMac();
	if ( ! RootElement || ! RootElement->firstChildElement("ForceHostMacAddress").isNull() )
		setForceHostMacAddress();
	if ( ! RootElement || ! RootElement->firstChildElement("VirtualNetworkID").isNull() )
		setVirtualNetworkID();
	if ( ! RootElement || ! RootElement->firstChildElement("AdapterType").isNull() )
		setAdapterType();
	if ( ! RootElement || ! RootElement->firstChildElement("StaticAddress").isNull() )
		setStaticAddress();
	if ( ! RootElement || ! RootElement->firstChildElement("AutoApply").isNull() )
		setAutoApply();
	if ( ! RootElement || dyn_lists.contains("NetAddress") )
		setNetAddresses();
	if ( ! RootElement || ! RootElement->firstChildElement("ConfigureWithDhcp").isNull() )
		setConfigureWithDhcp();
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultGateway").isNull() )
		setDefaultGateway();
	if ( ! RootElement || ! RootElement->firstChildElement("ConfigureWithDhcpIPv6").isNull() )
		setConfigureWithDhcpIPv6();
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultGatewayIPv6").isNull() )
		setDefaultGatewayIPv6();
	if ( ! RootElement || dyn_lists.contains("DnsIPAddress") )
		setDnsIPAddresses();
	if ( ! RootElement || dyn_lists.contains("SearchDomain") )
		setSearchDomains();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceDescription").isNull() )
		setDescription();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::DeviceEnabledState >("PVE::DeviceEnabledState");
		qRegisterMetaType< PVE::DeviceConnectedState >("PVE::DeviceConnectedState");
		qRegisterMetaType< PRL_VM_NET_ADAPTER_TYPE >("PRL_VM_NET_ADAPTER_TYPE");
		qRegisterMetaType< QList<QString> >("QList<QString>");
		qRegisterMetaType< QList<QString> >("QList<QString>");
		qRegisterMetaType< QList<QString> >("QList<QString>");
		first_time = false;
	}

}

QVariant CVmGenericNetworkAdapter::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Index.patch_stamp")
		value.setValue(getFieldPatchedValue("Index"));

	if (path == "Index")
		value.setValue(CVmDevice::getIndex());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue((qlonglong )CVmDevice::getEnabled());

	if (path == "Connected.patch_stamp")
		value.setValue(getFieldPatchedValue("Connected"));

	if (path == "Connected")
		value.setValue((qlonglong )CVmDevice::getConnected());

	if (path == "EmulatedType.patch_stamp")
		value.setValue(getFieldPatchedValue("EmulatedType"));

	if (path == "EmulatedType")
		value.setValue(CVmDevice::getEmulatedType());

	if (path == "SystemName.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemName"));

	if (path == "SystemName")
		value.setValue(CVmDevice::getSystemName());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(CVmDevice::getUserFriendlyName());

	if (path == "Remote.patch_stamp")
		value.setValue(getFieldPatchedValue("Remote"));

	if (path == "Remote")
		value.setValue(CVmDevice::isRemote());

	if (path == "AdapterNumber.patch_stamp")
		value.setValue(getFieldPatchedValue("AdapterNumber"));

	if (path == "AdapterNumber")
		value.setValue(getBoundAdapterIndex());

	if (path == "AdapterName.patch_stamp")
		value.setValue(getFieldPatchedValue("AdapterName"));

	if (path == "AdapterName")
		value.setValue(getBoundAdapterName());

	if (path == "MAC.patch_stamp")
		value.setValue(getFieldPatchedValue("MAC"));

	if (path == "MAC")
		value.setValue(getMacAddress());

	if (path == "HostMAC.patch_stamp")
		value.setValue(getFieldPatchedValue("HostMAC"));

	if (path == "HostMAC")
		value.setValue(getHostMacAddress());

	if (path == "HostInterfaceName.patch_stamp")
		value.setValue(getFieldPatchedValue("HostInterfaceName"));

	if (path == "HostInterfaceName")
		value.setValue(getHostInterfaceName());

	if (path == "Router.patch_stamp")
		value.setValue(getFieldPatchedValue("Router"));

	if (path == "Router")
		value.setValue(isRouter());

	if (path == "DHCPUseHostMac.patch_stamp")
		value.setValue(getFieldPatchedValue("DHCPUseHostMac"));

	if (path == "DHCPUseHostMac")
		value.setValue(getDHCPUseHostMac());

	if (path == "ForceHostMacAddress.patch_stamp")
		value.setValue(getFieldPatchedValue("ForceHostMacAddress"));

	if (path == "ForceHostMacAddress")
		value.setValue(isForceHostMacAddress());

	if (path == "VirtualNetworkID.patch_stamp")
		value.setValue(getFieldPatchedValue("VirtualNetworkID"));

	if (path == "VirtualNetworkID")
		value.setValue(getVirtualNetworkID());

	if (path == "AdapterType.patch_stamp")
		value.setValue(getFieldPatchedValue("AdapterType"));

	if (path == "AdapterType")
		value.setValue((qlonglong )getAdapterType());

	if (path == "StaticAddress.patch_stamp")
		value.setValue(getFieldPatchedValue("StaticAddress"));

	if (path == "StaticAddress")
		value.setValue(isStaticAddress());

	if (path == "AutoApply.patch_stamp")
		value.setValue(getFieldPatchedValue("AutoApply"));

	if (path == "AutoApply")
		value.setValue(isAutoApply());

	if (path == "NetAddress.patch_stamp")
		value.setValue(getFieldPatchedValue("NetAddress"));

	if (path == "NetAddress")
		value.setValue(getNetAddresses());

	if (path == "ConfigureWithDhcp.patch_stamp")
		value.setValue(getFieldPatchedValue("ConfigureWithDhcp"));

	if (path == "ConfigureWithDhcp")
		value.setValue(isConfigureWithDhcp());

	if (path == "DefaultGateway.patch_stamp")
		value.setValue(getFieldPatchedValue("DefaultGateway"));

	if (path == "DefaultGateway")
		value.setValue(getDefaultGateway());

	if (path == "ConfigureWithDhcpIPv6.patch_stamp")
		value.setValue(getFieldPatchedValue("ConfigureWithDhcpIPv6"));

	if (path == "ConfigureWithDhcpIPv6")
		value.setValue(isConfigureWithDhcpIPv6());

	if (path == "DefaultGatewayIPv6.patch_stamp")
		value.setValue(getFieldPatchedValue("DefaultGatewayIPv6"));

	if (path == "DefaultGatewayIPv6")
		value.setValue(getDefaultGatewayIPv6());

	if (path == "DnsIPAddress.patch_stamp")
		value.setValue(getFieldPatchedValue("DnsIPAddress"));

	if (path == "DnsIPAddress")
		value.setValue(getDnsIPAddresses());

	if (path == "SearchDomain.patch_stamp")
		value.setValue(getFieldPatchedValue("SearchDomain"));

	if (path == "SearchDomain")
		value.setValue(getSearchDomains());

	if (path == "DeviceDescription.patch_stamp")
		value.setValue(getFieldPatchedValue("DeviceDescription"));

	if (path == "DeviceDescription")
		value.setValue(CVmDevice::getDescription());

	list_tag = "PktFilter.";
	if (path.startsWith(list_tag) && ! m_lstPktFilter.isEmpty() && m_lstPktFilter.first())
		return m_lstPktFilter.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Firewall.";
	if (path.startsWith(list_tag) && ! m_lstFirewall.isEmpty() && m_lstFirewall.first())
		return m_lstFirewall.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmGenericNetworkAdapter::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Index.patch_stamp")
	{
		markPatchedField("Index", value.toString());
		return true;
	}

	if (path == "Index")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getIndex() != value.value< unsigned int >());
		CVmDevice::setIndex(value.value< unsigned int >());
		return true;
	}

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEnabled() != (PVE::DeviceEnabledState )value.value< qlonglong >());
		CVmDevice::setEnabled((PVE::DeviceEnabledState )value.value< qlonglong >());
		return true;
	}

	if (path == "Connected.patch_stamp")
	{
		markPatchedField("Connected", value.toString());
		return true;
	}

	if (path == "Connected")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getConnected() != (PVE::DeviceConnectedState )value.value< qlonglong >());
		CVmDevice::setConnected((PVE::DeviceConnectedState )value.value< qlonglong >());
		return true;
	}

	if (path == "EmulatedType.patch_stamp")
	{
		markPatchedField("EmulatedType", value.toString());
		return true;
	}

	if (path == "EmulatedType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEmulatedType() != value.value< unsigned int >());
		CVmDevice::setEmulatedType(value.value< unsigned int >());
		return true;
	}

	if (path == "SystemName.patch_stamp")
	{
		markPatchedField("SystemName", value.toString());
		return true;
	}

	if (path == "SystemName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getSystemName() != value.value< QString >());
		CVmDevice::setSystemName(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getUserFriendlyName() != value.value< QString >());
		CVmDevice::setUserFriendlyName(value.value< QString >());
		return true;
	}

	if (path == "Remote.patch_stamp")
	{
		markPatchedField("Remote", value.toString());
		return true;
	}

	if (path == "Remote")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::isRemote() != value.value< bool >());
		CVmDevice::setRemote(value.value< bool >());
		return true;
	}

	if (path == "AdapterNumber.patch_stamp")
	{
		markPatchedField("AdapterNumber", value.toString());
		return true;
	}

	if (path == "AdapterNumber")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBoundAdapterIndex() != value.value< int >());
		setBoundAdapterIndex(value.value< int >());
		return true;
	}

	if (path == "AdapterName.patch_stamp")
	{
		markPatchedField("AdapterName", value.toString());
		return true;
	}

	if (path == "AdapterName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBoundAdapterName() != value.value< QString >());
		setBoundAdapterName(value.value< QString >());
		return true;
	}

	if (path == "MAC.patch_stamp")
	{
		markPatchedField("MAC", value.toString());
		return true;
	}

	if (path == "MAC")
	{
		if (pbValueChanged)
			*pbValueChanged = (getMacAddress() != value.value< QString >());
		setMacAddress(value.value< QString >());
		return true;
	}

	if (path == "HostMAC.patch_stamp")
	{
		markPatchedField("HostMAC", value.toString());
		return true;
	}

	if (path == "HostMAC")
	{
		if (pbValueChanged)
			*pbValueChanged = (getHostMacAddress() != value.value< QString >());
		setHostMacAddress(value.value< QString >());
		return true;
	}

	if (path == "HostInterfaceName.patch_stamp")
	{
		markPatchedField("HostInterfaceName", value.toString());
		return true;
	}

	if (path == "HostInterfaceName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getHostInterfaceName() != value.value< QString >());
		setHostInterfaceName(value.value< QString >());
		return true;
	}

	if (path == "Router.patch_stamp")
	{
		markPatchedField("Router", value.toString());
		return true;
	}

	if (path == "Router")
	{
		if (pbValueChanged)
			*pbValueChanged = (isRouter() != value.value< bool >());
		setRouter(value.value< bool >());
		return true;
	}

	if (path == "DHCPUseHostMac.patch_stamp")
	{
		markPatchedField("DHCPUseHostMac", value.toString());
		return true;
	}

	if (path == "DHCPUseHostMac")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDHCPUseHostMac() != value.value< unsigned int >());
		setDHCPUseHostMac(value.value< unsigned int >());
		return true;
	}

	if (path == "ForceHostMacAddress.patch_stamp")
	{
		markPatchedField("ForceHostMacAddress", value.toString());
		return true;
	}

	if (path == "ForceHostMacAddress")
	{
		if (pbValueChanged)
			*pbValueChanged = (isForceHostMacAddress() != value.value< bool >());
		setForceHostMacAddress(value.value< bool >());
		return true;
	}

	if (path == "VirtualNetworkID.patch_stamp")
	{
		markPatchedField("VirtualNetworkID", value.toString());
		return true;
	}

	if (path == "VirtualNetworkID")
	{
		if (pbValueChanged)
			*pbValueChanged = (getVirtualNetworkID() != value.value< QString >());
		setVirtualNetworkID(value.value< QString >());
		return true;
	}

	if (path == "AdapterType.patch_stamp")
	{
		markPatchedField("AdapterType", value.toString());
		return true;
	}

	if (path == "AdapterType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAdapterType() != (PRL_VM_NET_ADAPTER_TYPE )value.value< qlonglong >());
		setAdapterType((PRL_VM_NET_ADAPTER_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "StaticAddress.patch_stamp")
	{
		markPatchedField("StaticAddress", value.toString());
		return true;
	}

	if (path == "StaticAddress")
	{
		if (pbValueChanged)
			*pbValueChanged = (isStaticAddress() != value.value< bool >());
		setStaticAddress(value.value< bool >());
		return true;
	}

	if (path == "AutoApply.patch_stamp")
	{
		markPatchedField("AutoApply", value.toString());
		return true;
	}

	if (path == "AutoApply")
	{
		if (pbValueChanged)
			*pbValueChanged = (isAutoApply() != value.value< bool >());
		setAutoApply(value.value< bool >());
		return true;
	}

	if (path == "NetAddress.patch_stamp")
	{
		markPatchedField("NetAddress", value.toString());
		return true;
	}

	if (path == "NetAddress")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNetAddresses() != value.value< QList<QString> >());
		setNetAddresses(value.value< QList<QString> >());
		return true;
	}

	if (path == "ConfigureWithDhcp.patch_stamp")
	{
		markPatchedField("ConfigureWithDhcp", value.toString());
		return true;
	}

	if (path == "ConfigureWithDhcp")
	{
		if (pbValueChanged)
			*pbValueChanged = (isConfigureWithDhcp() != value.value< bool >());
		setConfigureWithDhcp(value.value< bool >());
		return true;
	}

	if (path == "DefaultGateway.patch_stamp")
	{
		markPatchedField("DefaultGateway", value.toString());
		return true;
	}

	if (path == "DefaultGateway")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDefaultGateway() != value.value< QString >());
		setDefaultGateway(value.value< QString >());
		return true;
	}

	if (path == "ConfigureWithDhcpIPv6.patch_stamp")
	{
		markPatchedField("ConfigureWithDhcpIPv6", value.toString());
		return true;
	}

	if (path == "ConfigureWithDhcpIPv6")
	{
		if (pbValueChanged)
			*pbValueChanged = (isConfigureWithDhcpIPv6() != value.value< bool >());
		setConfigureWithDhcpIPv6(value.value< bool >());
		return true;
	}

	if (path == "DefaultGatewayIPv6.patch_stamp")
	{
		markPatchedField("DefaultGatewayIPv6", value.toString());
		return true;
	}

	if (path == "DefaultGatewayIPv6")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDefaultGatewayIPv6() != value.value< QString >());
		setDefaultGatewayIPv6(value.value< QString >());
		return true;
	}

	if (path == "DnsIPAddress.patch_stamp")
	{
		markPatchedField("DnsIPAddress", value.toString());
		return true;
	}

	if (path == "DnsIPAddress")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDnsIPAddresses() != value.value< QList<QString> >());
		setDnsIPAddresses(value.value< QList<QString> >());
		return true;
	}

	if (path == "SearchDomain.patch_stamp")
	{
		markPatchedField("SearchDomain", value.toString());
		return true;
	}

	if (path == "SearchDomain")
	{
		if (pbValueChanged)
			*pbValueChanged = (getSearchDomains() != value.value< QList<QString> >());
		setSearchDomains(value.value< QList<QString> >());
		return true;
	}

	if (path == "DeviceDescription.patch_stamp")
	{
		markPatchedField("DeviceDescription", value.toString());
		return true;
	}

	if (path == "DeviceDescription")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getDescription() != value.value< QString >());
		CVmDevice::setDescription(value.value< QString >());
		return true;
	}

	list_tag = "PktFilter.";
	if (path.startsWith(list_tag) && ! m_lstPktFilter.isEmpty() && m_lstPktFilter.first())
		return m_lstPktFilter.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Firewall.";
	if (path.startsWith(list_tag) && ! m_lstFirewall.isEmpty() && m_lstFirewall.first())
		return m_lstFirewall.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmGenericNetworkAdapter::getIndex_id() const
{
	return getFullItemId().isEmpty() ? "Index" : getFullItemId() + ".Index";
}
QString CVmGenericNetworkAdapter::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmGenericNetworkAdapter::getConnected_id() const
{
	return getFullItemId().isEmpty() ? "Connected" : getFullItemId() + ".Connected";
}
QString CVmGenericNetworkAdapter::getEmulatedType_id() const
{
	return getFullItemId().isEmpty() ? "EmulatedType" : getFullItemId() + ".EmulatedType";
}
QString CVmGenericNetworkAdapter::getSystemName_id() const
{
	return getFullItemId().isEmpty() ? "SystemName" : getFullItemId() + ".SystemName";
}
QString CVmGenericNetworkAdapter::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}
QString CVmGenericNetworkAdapter::getRemote_id() const
{
	return getFullItemId().isEmpty() ? "Remote" : getFullItemId() + ".Remote";
}
QString CVmGenericNetworkAdapter::getBoundAdapterIndex_id() const
{
	return getFullItemId().isEmpty() ? "AdapterNumber" : getFullItemId() + ".AdapterNumber";
}
QString CVmGenericNetworkAdapter::getBoundAdapterName_id() const
{
	return getFullItemId().isEmpty() ? "AdapterName" : getFullItemId() + ".AdapterName";
}
QString CVmGenericNetworkAdapter::getMacAddress_id() const
{
	return getFullItemId().isEmpty() ? "MAC" : getFullItemId() + ".MAC";
}
QString CVmGenericNetworkAdapter::getHostMacAddress_id() const
{
	return getFullItemId().isEmpty() ? "HostMAC" : getFullItemId() + ".HostMAC";
}
QString CVmGenericNetworkAdapter::getHostInterfaceName_id() const
{
	return getFullItemId().isEmpty() ? "HostInterfaceName" : getFullItemId() + ".HostInterfaceName";
}
QString CVmGenericNetworkAdapter::getRouter_id() const
{
	return getFullItemId().isEmpty() ? "Router" : getFullItemId() + ".Router";
}
QString CVmGenericNetworkAdapter::getDHCPUseHostMac_id() const
{
	return getFullItemId().isEmpty() ? "DHCPUseHostMac" : getFullItemId() + ".DHCPUseHostMac";
}
QString CVmGenericNetworkAdapter::getForceHostMacAddress_id() const
{
	return getFullItemId().isEmpty() ? "ForceHostMacAddress" : getFullItemId() + ".ForceHostMacAddress";
}
QString CVmGenericNetworkAdapter::getVirtualNetworkID_id() const
{
	return getFullItemId().isEmpty() ? "VirtualNetworkID" : getFullItemId() + ".VirtualNetworkID";
}
QString CVmGenericNetworkAdapter::getAdapterType_id() const
{
	return getFullItemId().isEmpty() ? "AdapterType" : getFullItemId() + ".AdapterType";
}
QString CVmGenericNetworkAdapter::getStaticAddress_id() const
{
	return getFullItemId().isEmpty() ? "StaticAddress" : getFullItemId() + ".StaticAddress";
}
QString CVmGenericNetworkAdapter::getAutoApply_id() const
{
	return getFullItemId().isEmpty() ? "AutoApply" : getFullItemId() + ".AutoApply";
}
QString CVmGenericNetworkAdapter::getNetAddresses_id() const
{
	return getFullItemId().isEmpty() ? "NetAddress" : getFullItemId() + ".NetAddress";
}
QString CVmGenericNetworkAdapter::getConfigureWithDhcp_id() const
{
	return getFullItemId().isEmpty() ? "ConfigureWithDhcp" : getFullItemId() + ".ConfigureWithDhcp";
}
QString CVmGenericNetworkAdapter::getDefaultGateway_id() const
{
	return getFullItemId().isEmpty() ? "DefaultGateway" : getFullItemId() + ".DefaultGateway";
}
QString CVmGenericNetworkAdapter::getConfigureWithDhcpIPv6_id() const
{
	return getFullItemId().isEmpty() ? "ConfigureWithDhcpIPv6" : getFullItemId() + ".ConfigureWithDhcpIPv6";
}
QString CVmGenericNetworkAdapter::getDefaultGatewayIPv6_id() const
{
	return getFullItemId().isEmpty() ? "DefaultGatewayIPv6" : getFullItemId() + ".DefaultGatewayIPv6";
}
QString CVmGenericNetworkAdapter::getDnsIPAddresses_id() const
{
	return getFullItemId().isEmpty() ? "DnsIPAddress" : getFullItemId() + ".DnsIPAddress";
}
QString CVmGenericNetworkAdapter::getSearchDomains_id() const
{
	return getFullItemId().isEmpty() ? "SearchDomain" : getFullItemId() + ".SearchDomain";
}
QString CVmGenericNetworkAdapter::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "DeviceDescription" : getFullItemId() + ".DeviceDescription";
}

int CVmGenericNetworkAdapter::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "PktFilter.";
	if (path.startsWith(list_tag) && ! m_lstPktFilter.isEmpty() && m_lstPktFilter.first())
		return m_lstPktFilter.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Firewall.";
	if (path.startsWith(list_tag) && ! m_lstFirewall.isEmpty() && m_lstFirewall.first())
		return m_lstFirewall.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmGenericNetworkAdapter::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "PktFilter.";
	if (path.startsWith(list_tag) && ! m_lstPktFilter.isEmpty() && m_lstPktFilter.first())
		return m_lstPktFilter.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Firewall.";
	if (path.startsWith(list_tag) && ! m_lstFirewall.isEmpty() && m_lstFirewall.first())
		return m_lstFirewall.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmGenericNetworkAdapter::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkAdapter") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Index");
	text_element = Document->createTextNode( QString("%1").arg(getIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(getEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Connected");
	text_element = Document->createTextNode( QString("%1").arg(getConnected()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EmulatedType");
	text_element = Document->createTextNode( QString("%1").arg(getEmulatedType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemName");
	text_element = Document->createTextNode( QString("%1").arg(getSystemName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Remote");
	text_element = Document->createTextNode( QString("%1").arg(isRemote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AdapterNumber");
	text_element = Document->createTextNode( QString("%1").arg(getBoundAdapterIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AdapterName");
	text_element = Document->createTextNode( QString("%1").arg(getBoundAdapterName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("MAC");
	text_element = Document->createTextNode( QString("%1").arg(getMacAddress()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("HostMAC");
	text_element = Document->createTextNode( QString("%1").arg(getHostMacAddress()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("HostInterfaceName");
	text_element = Document->createTextNode( QString("%1").arg(getHostInterfaceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Router");
	text_element = Document->createTextNode( QString("%1").arg(isRouter()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DHCPUseHostMac");
	text_element = Document->createTextNode( QString("%1").arg(getDHCPUseHostMac()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ForceHostMacAddress");
	text_element = Document->createTextNode( QString("%1").arg(isForceHostMacAddress()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("VirtualNetworkID");
	text_element = Document->createTextNode( QString("%1").arg(getVirtualNetworkID()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AdapterType");
	text_element = Document->createTextNode( QString("%1").arg(getAdapterType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("StaticAddress");
	text_element = Document->createTextNode( QString("%1").arg(isStaticAddress()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstPktFilter.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CNetPktFilter* object = m_lstPktFilter[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AutoApply");
	text_element = Document->createTextNode( QString("%1").arg(isAutoApply()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "NetAddress";
	for(i = 0; i < m_lstNetAddress.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("NetAddress");
		text_element = Document->createTextNode( QString("%1").arg(m_lstNetAddress[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConfigureWithDhcp");
	text_element = Document->createTextNode( QString("%1").arg(isConfigureWithDhcp()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultGateway");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultGateway()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConfigureWithDhcpIPv6");
	text_element = Document->createTextNode( QString("%1").arg(isConfigureWithDhcpIPv6()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultGatewayIPv6");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultGatewayIPv6()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "DnsIPAddress";
	for(i = 0; i < m_lstDnsIPAddress.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("DnsIPAddress");
		text_element = Document->createTextNode( QString("%1").arg(m_lstDnsIPAddress[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	dyn_lists += "SearchDomain";
	for(i = 0; i < m_lstSearchDomain.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("SearchDomain");
		text_element = Document->createTextNode( QString("%1").arg(m_lstSearchDomain[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	for(i = 0; i < m_lstFirewall.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmNetFirewall* object = m_lstFirewall[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceDescription");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmGenericNetworkAdapter::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkAdapter") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int PktFilter_count = 1;
	int Firewall_count = 1;
	int Index_count = 1;
	int Enabled_count = 1;
	int Connected_count = 1;
	int EmulatedType_count = 1;
	int SystemName_count = 1;
	int UserFriendlyName_count = 1;
	int Remote_count = 1;
	int AdapterNumber_count = 1;
	int AdapterName_count = 1;
	int MAC_count = 0;
	int HostMAC_count = 0;
	int HostInterfaceName_count = 0;
	int Router_count = 0;
	int DHCPUseHostMac_count = 0;
	int ForceHostMacAddress_count = 0;
	int VirtualNetworkID_count = 0;
	int AdapterType_count = 0;
	int StaticAddress_count = 0;
	int AutoApply_count = 0;
	int NetAddress_count = 0;
	int ConfigureWithDhcp_count = 0;
	int DefaultGateway_count = 0;
	int ConfigureWithDhcpIPv6_count = 0;
	int DefaultGatewayIPv6_count = 0;
	int DnsIPAddress_count = 0;
	int SearchDomain_count = 0;
	int DeviceDescription_count = 0;

	QString AdapterType_patch_stamp = RootElement->attribute("AdapterType_patch");
	if (unite_with_loaded && RootElement->firstChildElement("AdapterType").isNull())
		AdapterType_patch_stamp = getFieldPatchedValue("AdapterType");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIndex(text_element.data().toUInt());
			--Index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled((PVE::DeviceEnabledState )text_element.data().toLongLong());
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Connected";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Connected_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Connected")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnected((PVE::DeviceConnectedState )text_element.data().toLongLong());
			--Connected_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EmulatedType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EmulatedType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EmulatedType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEmulatedType(text_element.data().toUInt());
			--EmulatedType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemName(text_element.data());
			--SystemName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Remote";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Remote_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Remote")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemote(text_element.data().toInt() != 0);
			--Remote_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AdapterNumber";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AdapterNumber_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AdapterNumber")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBoundAdapterIndex(text_element.data().toInt());
			--AdapterNumber_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AdapterName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AdapterName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AdapterName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBoundAdapterName(text_element.data());
			--AdapterName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "MAC";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (MAC_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "MAC")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMacAddress(text_element.data());
			--MAC_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "HostMAC";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (HostMAC_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "HostMAC")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHostMacAddress(text_element.data());
			--HostMAC_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "HostInterfaceName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (HostInterfaceName_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "HostInterfaceName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHostInterfaceName(text_element.data());
			--HostInterfaceName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Router";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Router_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Router")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRouter(text_element.data().toInt() != 0);
			--Router_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DHCPUseHostMac";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DHCPUseHostMac_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DHCPUseHostMac")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDHCPUseHostMac(text_element.data().toUInt());
			--DHCPUseHostMac_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ForceHostMacAddress";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ForceHostMacAddress_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ForceHostMacAddress")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setForceHostMacAddress(text_element.data().toInt() != 0);
			--ForceHostMacAddress_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "VirtualNetworkID";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (VirtualNetworkID_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "VirtualNetworkID")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVirtualNetworkID(text_element.data());
			--VirtualNetworkID_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AdapterType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AdapterType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AdapterType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAdapterType((PRL_VM_NET_ADAPTER_TYPE )text_element.data().toLongLong());
			--AdapterType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "StaticAddress";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (StaticAddress_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "StaticAddress")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setStaticAddress(text_element.data().toInt() != 0);
			--StaticAddress_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AutoApply";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AutoApply_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AutoApply")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAutoApply(text_element.data().toInt() != 0);
			--AutoApply_count;
		}


		if (tag_name == "NetAddress")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstNetAddress += text_element.data();
			--NetAddress_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "ConfigureWithDhcp";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConfigureWithDhcp_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConfigureWithDhcp")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConfigureWithDhcp(text_element.data().toInt() != 0);
			--ConfigureWithDhcp_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultGateway";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultGateway_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultGateway")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultGateway(text_element.data());
			--DefaultGateway_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ConfigureWithDhcpIPv6";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConfigureWithDhcpIPv6_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConfigureWithDhcpIPv6")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConfigureWithDhcpIPv6(text_element.data().toInt() != 0);
			--ConfigureWithDhcpIPv6_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultGatewayIPv6";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultGatewayIPv6_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultGatewayIPv6")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultGatewayIPv6(text_element.data());
			--DefaultGatewayIPv6_count;
		}


		if (tag_name == "DnsIPAddress")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstDnsIPAddress += text_element.data();
			--DnsIPAddress_count;
		}
		if (tag_name == "SearchDomain")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstSearchDomain += text_element.data();
			--SearchDomain_count;
		}
		pElement = 0;
		is_set = false;
		attribute = "DeviceDescription";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceDescription_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceDescription")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--DeviceDescription_count;
		}


		if (tag_name == "PktFilter" && PktFilter_count > 0)
		{
			unused_tag = false;
			CNetPktFilter* object = m_lstPktFilter[1 - PktFilter_count];
			object->makeFullItemId(getFullItemId(), "PktFilter");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--PktFilter_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Firewall" && Firewall_count > 0)
		{
			unused_tag = false;
			CVmNetFirewall* object = m_lstFirewall[1 - Firewall_count];
			object->makeFullItemId(getFullItemId(), "Firewall");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Firewall_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (PktFilter_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'PktFilter' is absent";
	}

	if (Firewall_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'Firewall' is absent";
	}

	if (Index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'Index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Connected_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'Connected' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EmulatedType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'EmulatedType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SystemName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'SystemName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Remote_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'Remote' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (AdapterNumber_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'AdapterNumber' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (AdapterName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericNetworkAdapter': tag 'AdapterName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (MAC_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'MAC' is absent";
	}

	if (HostMAC_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'HostMAC' is absent";
	}

	if (HostInterfaceName_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'HostInterfaceName' is absent";
	}

	if (Router_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'Router' is absent";
	}

	if (DHCPUseHostMac_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'DHCPUseHostMac' is absent";
	}

	if (ForceHostMacAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'ForceHostMacAddress' is absent";
	}

	if (VirtualNetworkID_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'VirtualNetworkID' is absent";
	}

	if (AdapterType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'AdapterType' is absent";
	}

	if (StaticAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'StaticAddress' is absent";
	}

	if (AutoApply_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'AutoApply' is absent";
	}

	if (NetAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'NetAddress' is absent";
	}

	if (ConfigureWithDhcp_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'ConfigureWithDhcp' is absent";
	}

	if (DefaultGateway_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'DefaultGateway' is absent";
	}

	if (ConfigureWithDhcpIPv6_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'ConfigureWithDhcpIPv6' is absent";
	}

	if (DefaultGatewayIPv6_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'DefaultGatewayIPv6' is absent";
	}

	if (DnsIPAddress_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'DnsIPAddress' is absent";
	}

	if (SearchDomain_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'SearchDomain' is absent";
	}

	if (DeviceDescription_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericNetworkAdapter': tag 'DeviceDescription' is absent";
	}



	if ( AdapterType_patch_stamp != "1" && AdapterType_count < 0 )
	{
		QString value = RootElement->firstChildElement("AdapterType").firstChild().toText().data();
		if ( value == "e1000" )
			setAdapterType(PNT_E1000);
		else if ( value == "rtl" )
			setAdapterType(PNT_RTL);
		else if ( value.isEmpty() )
			setAdapterType(PNT_UNDEFINED);
		AdapterType_patch_stamp = "1";
	}
	m_mapPatchedFields.insert("AdapterType", AdapterType_patch_stamp);


    if ( isConfigureWithDhcpIPv6() )
    {   //if exist v6 ip - set v6 dhcp to false
	foreach(const QString &ip, m_lstNetAddress)
	{
		if ( isIPv6(ip) )
		{
        		setConfigureWithDhcpIPv6( false );
			break;
		}
	}
    }
    if ( isConfigureWithDhcp() )
    {   //if exist v4 ip - set v4 dhcp to false
	foreach(const QString &ip, m_lstNetAddress)
	{
		if ( !isIPv6(ip) )
		{
        		setConfigureWithDhcp( false );
			break;
		}
	}

    }
	return 0;
}

void CVmGenericNetworkAdapter::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstPktFilter.size(); ++i)
	{
		CNetPktFilter* object = m_lstPktFilter[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "PktFilter");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstFirewall.size(); ++i)
	{
		CVmNetFirewall* object = m_lstFirewall[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Firewall");
		object->syncItemIds();
	}

}

bool CVmGenericNetworkAdapter::merge(CVmGenericNetworkAdapter* pCur, CVmGenericNetworkAdapter* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "NetworkAdapter";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getIndex() != pCur->getIndex() && getIndex() == pPrev->getIndex())
		setIndex(pCur->getIndex());
	else if (getIndex() != pCur->getIndex() && getIndex() != pPrev->getIndex() && pCur->getIndex() != pPrev->getIndex())
	{
		m_qsErrorMessage += ".Index";
		return false;
	}

	if (getEnabled() != pCur->getEnabled() && getEnabled() == pPrev->getEnabled())
		setEnabled(pCur->getEnabled());
	else if (getEnabled() != pCur->getEnabled() && getEnabled() != pPrev->getEnabled() && pCur->getEnabled() != pPrev->getEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getConnected() != pCur->getConnected() && getConnected() == pPrev->getConnected())
		setConnected(pCur->getConnected());
	else if (getConnected() != pCur->getConnected() && getConnected() != pPrev->getConnected() && pCur->getConnected() != pPrev->getConnected())
	{
		m_qsErrorMessage += ".Connected";
		return false;
	}

	if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() == pPrev->getEmulatedType())
		setEmulatedType(pCur->getEmulatedType());
	else if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() != pPrev->getEmulatedType() && pCur->getEmulatedType() != pPrev->getEmulatedType())
	{
		m_qsErrorMessage += ".EmulatedType";
		return false;
	}

	if (getSystemName() != pCur->getSystemName() && getSystemName() == pPrev->getSystemName())
		setSystemName(pCur->getSystemName());
	else if (getSystemName() != pCur->getSystemName() && getSystemName() != pPrev->getSystemName() && pCur->getSystemName() != pPrev->getSystemName())
	{
		m_qsErrorMessage += ".SystemName";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if (isRemote() != pCur->isRemote() && isRemote() == pPrev->isRemote())
		setRemote(pCur->isRemote());
	else if (isRemote() != pCur->isRemote() && isRemote() != pPrev->isRemote() && pCur->isRemote() != pPrev->isRemote())
	{
		m_qsErrorMessage += ".Remote";
		return false;
	}

	if (getBoundAdapterIndex() != pCur->getBoundAdapterIndex() && getBoundAdapterIndex() == pPrev->getBoundAdapterIndex())
		setBoundAdapterIndex(pCur->getBoundAdapterIndex());
	else if (getBoundAdapterIndex() != pCur->getBoundAdapterIndex() && getBoundAdapterIndex() != pPrev->getBoundAdapterIndex() && pCur->getBoundAdapterIndex() != pPrev->getBoundAdapterIndex())
	{
		m_qsErrorMessage += ".AdapterNumber";
		return false;
	}

	if (getBoundAdapterName() != pCur->getBoundAdapterName() && getBoundAdapterName() == pPrev->getBoundAdapterName())
		setBoundAdapterName(pCur->getBoundAdapterName());
	else if (getBoundAdapterName() != pCur->getBoundAdapterName() && getBoundAdapterName() != pPrev->getBoundAdapterName() && pCur->getBoundAdapterName() != pPrev->getBoundAdapterName())
	{
		m_qsErrorMessage += ".AdapterName";
		return false;
	}

	if (getMacAddress() != pCur->getMacAddress() && getMacAddress() == pPrev->getMacAddress())
		setMacAddress(pCur->getMacAddress());
	else if (getMacAddress() != pCur->getMacAddress() && getMacAddress() != pPrev->getMacAddress() && pCur->getMacAddress() != pPrev->getMacAddress())
	{
		m_qsErrorMessage += ".MAC";
		return false;
	}

	if (getHostMacAddress() != pCur->getHostMacAddress() && getHostMacAddress() == pPrev->getHostMacAddress())
		setHostMacAddress(pCur->getHostMacAddress());
	else if (getHostMacAddress() != pCur->getHostMacAddress() && getHostMacAddress() != pPrev->getHostMacAddress() && pCur->getHostMacAddress() != pPrev->getHostMacAddress())
	{
		m_qsErrorMessage += ".HostMAC";
		return false;
	}

	if (getHostInterfaceName() != pCur->getHostInterfaceName() && getHostInterfaceName() == pPrev->getHostInterfaceName())
		setHostInterfaceName(pCur->getHostInterfaceName());
	else if (getHostInterfaceName() != pCur->getHostInterfaceName() && getHostInterfaceName() != pPrev->getHostInterfaceName() && pCur->getHostInterfaceName() != pPrev->getHostInterfaceName())
	{
		m_qsErrorMessage += ".HostInterfaceName";
		return false;
	}

	if (isRouter() != pCur->isRouter() && isRouter() == pPrev->isRouter())
		setRouter(pCur->isRouter());
	else if (isRouter() != pCur->isRouter() && isRouter() != pPrev->isRouter() && pCur->isRouter() != pPrev->isRouter())
	{
		m_qsErrorMessage += ".Router";
		return false;
	}

	if (getDHCPUseHostMac() != pCur->getDHCPUseHostMac() && getDHCPUseHostMac() == pPrev->getDHCPUseHostMac())
		setDHCPUseHostMac(pCur->getDHCPUseHostMac());
	else if (getDHCPUseHostMac() != pCur->getDHCPUseHostMac() && getDHCPUseHostMac() != pPrev->getDHCPUseHostMac() && pCur->getDHCPUseHostMac() != pPrev->getDHCPUseHostMac())
	{
		m_qsErrorMessage += ".DHCPUseHostMac";
		return false;
	}

	if (isForceHostMacAddress() != pCur->isForceHostMacAddress() && isForceHostMacAddress() == pPrev->isForceHostMacAddress())
		setForceHostMacAddress(pCur->isForceHostMacAddress());
	else if (isForceHostMacAddress() != pCur->isForceHostMacAddress() && isForceHostMacAddress() != pPrev->isForceHostMacAddress() && pCur->isForceHostMacAddress() != pPrev->isForceHostMacAddress())
	{
		m_qsErrorMessage += ".ForceHostMacAddress";
		return false;
	}

	if (getVirtualNetworkID() != pCur->getVirtualNetworkID() && getVirtualNetworkID() == pPrev->getVirtualNetworkID())
		setVirtualNetworkID(pCur->getVirtualNetworkID());
	else if (getVirtualNetworkID() != pCur->getVirtualNetworkID() && getVirtualNetworkID() != pPrev->getVirtualNetworkID() && pCur->getVirtualNetworkID() != pPrev->getVirtualNetworkID())
	{
		m_qsErrorMessage += ".VirtualNetworkID";
		return false;
	}

	if (getAdapterType() != pCur->getAdapterType() && getAdapterType() == pPrev->getAdapterType())
		setAdapterType(pCur->getAdapterType());
	else if (getAdapterType() != pCur->getAdapterType() && getAdapterType() != pPrev->getAdapterType() && pCur->getAdapterType() != pPrev->getAdapterType())
	{
		m_qsErrorMessage += ".AdapterType";
		return false;
	}

	if (isStaticAddress() != pCur->isStaticAddress() && isStaticAddress() == pPrev->isStaticAddress())
		setStaticAddress(pCur->isStaticAddress());
	else if (isStaticAddress() != pCur->isStaticAddress() && isStaticAddress() != pPrev->isStaticAddress() && pCur->isStaticAddress() != pPrev->isStaticAddress())
	{
		m_qsErrorMessage += ".StaticAddress";
		return false;
	}

	if (isAutoApply() != pCur->isAutoApply() && isAutoApply() == pPrev->isAutoApply())
		setAutoApply(pCur->isAutoApply());
	else if (isAutoApply() != pCur->isAutoApply() && isAutoApply() != pPrev->isAutoApply() && pCur->isAutoApply() != pPrev->isAutoApply())
	{
		m_qsErrorMessage += ".AutoApply";
		return false;
	}

	if (getNetAddresses() != pCur->getNetAddresses() && getNetAddresses() == pPrev->getNetAddresses())
		setNetAddresses(pCur->getNetAddresses());
	else if (getNetAddresses() != pCur->getNetAddresses() && getNetAddresses() != pPrev->getNetAddresses() && pCur->getNetAddresses() != pPrev->getNetAddresses())
	{
		m_qsErrorMessage += ".NetAddress";
		return false;
	}

	if (isConfigureWithDhcp() != pCur->isConfigureWithDhcp() && isConfigureWithDhcp() == pPrev->isConfigureWithDhcp())
		setConfigureWithDhcp(pCur->isConfigureWithDhcp());
	else if (isConfigureWithDhcp() != pCur->isConfigureWithDhcp() && isConfigureWithDhcp() != pPrev->isConfigureWithDhcp() && pCur->isConfigureWithDhcp() != pPrev->isConfigureWithDhcp())
	{
		m_qsErrorMessage += ".ConfigureWithDhcp";
		return false;
	}

	if (getDefaultGateway() != pCur->getDefaultGateway() && getDefaultGateway() == pPrev->getDefaultGateway())
		setDefaultGateway(pCur->getDefaultGateway());
	else if (getDefaultGateway() != pCur->getDefaultGateway() && getDefaultGateway() != pPrev->getDefaultGateway() && pCur->getDefaultGateway() != pPrev->getDefaultGateway())
	{
		m_qsErrorMessage += ".DefaultGateway";
		return false;
	}

	if (isConfigureWithDhcpIPv6() != pCur->isConfigureWithDhcpIPv6() && isConfigureWithDhcpIPv6() == pPrev->isConfigureWithDhcpIPv6())
		setConfigureWithDhcpIPv6(pCur->isConfigureWithDhcpIPv6());
	else if (isConfigureWithDhcpIPv6() != pCur->isConfigureWithDhcpIPv6() && isConfigureWithDhcpIPv6() != pPrev->isConfigureWithDhcpIPv6() && pCur->isConfigureWithDhcpIPv6() != pPrev->isConfigureWithDhcpIPv6())
	{
		m_qsErrorMessage += ".ConfigureWithDhcpIPv6";
		return false;
	}

	if (getDefaultGatewayIPv6() != pCur->getDefaultGatewayIPv6() && getDefaultGatewayIPv6() == pPrev->getDefaultGatewayIPv6())
		setDefaultGatewayIPv6(pCur->getDefaultGatewayIPv6());
	else if (getDefaultGatewayIPv6() != pCur->getDefaultGatewayIPv6() && getDefaultGatewayIPv6() != pPrev->getDefaultGatewayIPv6() && pCur->getDefaultGatewayIPv6() != pPrev->getDefaultGatewayIPv6())
	{
		m_qsErrorMessage += ".DefaultGatewayIPv6";
		return false;
	}

	if (getDnsIPAddresses() != pCur->getDnsIPAddresses() && getDnsIPAddresses() == pPrev->getDnsIPAddresses())
		setDnsIPAddresses(pCur->getDnsIPAddresses());
	else if (getDnsIPAddresses() != pCur->getDnsIPAddresses() && getDnsIPAddresses() != pPrev->getDnsIPAddresses() && pCur->getDnsIPAddresses() != pPrev->getDnsIPAddresses())
	{
		m_qsErrorMessage += ".DnsIPAddress";
		return false;
	}

	if (getSearchDomains() != pCur->getSearchDomains() && getSearchDomains() == pPrev->getSearchDomains())
		setSearchDomains(pCur->getSearchDomains());
	else if (getSearchDomains() != pCur->getSearchDomains() && getSearchDomains() != pPrev->getSearchDomains() && pCur->getSearchDomains() != pPrev->getSearchDomains())
	{
		m_qsErrorMessage += ".SearchDomain";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".DeviceDescription";
		return false;
	}

	for(i = 0; i < m_lstPktFilter.size(); i++)
	{
		if ( m_lstPktFilter[i]->merge(pCur->m_lstPktFilter[i], pPrev->m_lstPktFilter[i], nOptions) ) continue;
		QString qsIdx = (m_lstPktFilter.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstPktFilter[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstFirewall.size(); i++)
	{
		if ( m_lstFirewall[i]->merge(pCur->m_lstFirewall[i], pPrev->m_lstFirewall[i], nOptions) ) continue;
		QString qsIdx = (m_lstFirewall.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstFirewall[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmGenericNetworkAdapter::diff(const CVmGenericNetworkAdapter* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIndex() != pOld->getIndex())
		lstDiffFullItemIds += getIndex_id();

	if (getEnabled() != pOld->getEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getConnected() != pOld->getConnected())
		lstDiffFullItemIds += getConnected_id();

	if (getEmulatedType() != pOld->getEmulatedType())
		lstDiffFullItemIds += getEmulatedType_id();

	if (getSystemName() != pOld->getSystemName())
		lstDiffFullItemIds += getSystemName_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	if (isRemote() != pOld->isRemote())
		lstDiffFullItemIds += getRemote_id();

	if (getBoundAdapterIndex() != pOld->getBoundAdapterIndex())
		lstDiffFullItemIds += getBoundAdapterIndex_id();

	if (getBoundAdapterName() != pOld->getBoundAdapterName())
		lstDiffFullItemIds += getBoundAdapterName_id();

	if (getMacAddress() != pOld->getMacAddress())
		lstDiffFullItemIds += getMacAddress_id();

	if (getHostMacAddress() != pOld->getHostMacAddress())
		lstDiffFullItemIds += getHostMacAddress_id();

	if (getHostInterfaceName() != pOld->getHostInterfaceName())
		lstDiffFullItemIds += getHostInterfaceName_id();

	if (isRouter() != pOld->isRouter())
		lstDiffFullItemIds += getRouter_id();

	if (getDHCPUseHostMac() != pOld->getDHCPUseHostMac())
		lstDiffFullItemIds += getDHCPUseHostMac_id();

	if (isForceHostMacAddress() != pOld->isForceHostMacAddress())
		lstDiffFullItemIds += getForceHostMacAddress_id();

	if (getVirtualNetworkID() != pOld->getVirtualNetworkID())
		lstDiffFullItemIds += getVirtualNetworkID_id();

	if (getAdapterType() != pOld->getAdapterType())
		lstDiffFullItemIds += getAdapterType_id();

	if (isStaticAddress() != pOld->isStaticAddress())
		lstDiffFullItemIds += getStaticAddress_id();

	if (isAutoApply() != pOld->isAutoApply())
		lstDiffFullItemIds += getAutoApply_id();

	if (getNetAddresses() != pOld->getNetAddresses())
		lstDiffFullItemIds += getNetAddresses_id();

	if (isConfigureWithDhcp() != pOld->isConfigureWithDhcp())
		lstDiffFullItemIds += getConfigureWithDhcp_id();

	if (getDefaultGateway() != pOld->getDefaultGateway())
		lstDiffFullItemIds += getDefaultGateway_id();

	if (isConfigureWithDhcpIPv6() != pOld->isConfigureWithDhcpIPv6())
		lstDiffFullItemIds += getConfigureWithDhcpIPv6_id();

	if (getDefaultGatewayIPv6() != pOld->getDefaultGatewayIPv6())
		lstDiffFullItemIds += getDefaultGatewayIPv6_id();

	if (getDnsIPAddresses() != pOld->getDnsIPAddresses())
		lstDiffFullItemIds += getDnsIPAddresses_id();

	if (getSearchDomains() != pOld->getSearchDomains())
		lstDiffFullItemIds += getSearchDomains_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

	for(i = 0; i < m_lstPktFilter.size(); ++i)
		m_lstPktFilter[i]->diff(pOld->m_lstPktFilter[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstFirewall.size(); ++i)
		m_lstFirewall[i]->diff(pOld->m_lstFirewall[i], lstDiffFullItemIds);

}

void CVmGenericNetworkAdapter::Copy(const CVmGenericNetworkAdapter& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIndex(rObject.getIndex());
	setEnabled(rObject.getEnabled());
	setConnected(rObject.getConnected());
	setEmulatedType(rObject.getEmulatedType());
	setSystemName(rObject.getSystemName());
	setUserFriendlyName(rObject.getUserFriendlyName());
	setRemote(rObject.isRemote());
	setBoundAdapterIndex(rObject.getBoundAdapterIndex());
	setBoundAdapterName(rObject.getBoundAdapterName());
	setMacAddress(rObject.getMacAddress());
	setHostMacAddress(rObject.getHostMacAddress());
	setHostInterfaceName(rObject.getHostInterfaceName());
	setRouter(rObject.isRouter());
	setDHCPUseHostMac(rObject.getDHCPUseHostMac());
	setForceHostMacAddress(rObject.isForceHostMacAddress());
	setVirtualNetworkID(rObject.getVirtualNetworkID());
	setAdapterType(rObject.getAdapterType());
	setStaticAddress(rObject.isStaticAddress());
	setAutoApply(rObject.isAutoApply());
	setNetAddresses(rObject.getNetAddresses());
	setConfigureWithDhcp(rObject.isConfigureWithDhcp());
	setDefaultGateway(rObject.getDefaultGateway());
	setConfigureWithDhcpIPv6(rObject.isConfigureWithDhcpIPv6());
	setDefaultGatewayIPv6(rObject.getDefaultGatewayIPv6());
	setDnsIPAddresses(rObject.getDnsIPAddresses());
	setSearchDomains(rObject.getSearchDomains());
	setDescription(rObject.getDescription());

	ClearList<CNetPktFilter >(m_lstPktFilter);
	for(i = 0; i < rObject.m_lstPktFilter.size(); i++)
		m_lstPktFilter += new CNetPktFilter(rObject.m_lstPktFilter[i]);

	ClearList<CVmNetFirewall >(m_lstFirewall);
	for(i = 0; i < rObject.m_lstFirewall.size(); i++)
		m_lstFirewall += new CVmNetFirewall(rObject.m_lstFirewall[i]);

	CustomCopy(&rObject);

}

void CVmGenericNetworkAdapter::InitLists()
{
	InitList<CNetPktFilter>(1, m_lstPktFilter);
	InitList<CVmNetFirewall>(1, m_lstFirewall);
	CustomInit();
}

void CVmGenericNetworkAdapter::ClearLists()
{
	ClearList<CNetPktFilter>(m_lstPktFilter);
	ClearList<CVmNetFirewall>(m_lstFirewall);
}

void CVmGenericNetworkAdapter::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstPktFilter.size() && ! unite_with_loaded; i++)
	{
		m_lstPktFilter[i]->ClearListsInReadXml();
		m_lstPktFilter[i]->setDefaults();
		m_lstPktFilter[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstFirewall.size() && ! unite_with_loaded; i++)
	{
		m_lstFirewall[i]->ClearListsInReadXml();
		m_lstFirewall[i]->setDefaults();
		m_lstFirewall[i]->setSectionFakeFlag(true);
	}
}

