////////////////////////////////////////////////////////////////////////////////
///
/// CVmGenericNetworkAdapter.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMGENERICNETWORKADAPTER_H
#define CVMGENERICNETWORKADAPTER_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmClusteredDevice.h"
#include "CNetPktFilter.h"
#include "CVmNetFirewall.h"


class CVmGenericNetworkAdapter : public CVmClusteredDevice
{
	Q_OBJECT

public:

	CVmGenericNetworkAdapter();
	CVmGenericNetworkAdapter(const CVmGenericNetworkAdapter& rObject);
	CVmGenericNetworkAdapter(const CVmGenericNetworkAdapter* pObject);
	CVmGenericNetworkAdapter(QFile* pFile);
	CVmGenericNetworkAdapter& operator=(const CVmGenericNetworkAdapter& rObject);
	virtual ~CVmGenericNetworkAdapter();


    bool isVenetDevice() const { return (PNA_ROUTED == (PRL_NET_ADAPTER_EMULATED_TYPE)CVmDevice::getEmulatedType()); }

    bool isVtdDevice() const { return (PNA_DIRECT_ASSIGN == (PRL_NET_ADAPTER_EMULATED_TYPE)CVmDevice::getEmulatedType()); }

    PRL_NET_ADAPTER_EMULATED_TYPE getEmulatedType() const { return (PRL_NET_ADAPTER_EMULATED_TYPE )CVmDevice::getEmulatedType(); }

    virtual PRL_DEVICE_TYPE getDeviceType() const { return PDE_GENERIC_NETWORK_ADAPTER; }

    void setConfigureWithDhcpIPv6Ex(bool value);

    void setConfigureWithDhcpEx(bool value);

    bool isIPv6(const QString &ip);

    virtual bool operator==( const CVmGenericNetworkAdapter& cVmGenericNetworkAdapter);

	QList<CNetPktFilter* >		m_lstPktFilter;
	QList<CVmNetFirewall* >		m_lstFirewall;

	CNetPktFilter* getPktFilter() const;
	void setPktFilter(CNetPktFilter* pPktFilter);

	CVmNetFirewall* getFirewall() const;
	void setFirewall(CVmNetFirewall* pFirewall);


	int getBoundAdapterIndex() const;
	void setBoundAdapterIndex(int value = 0);

	QString getBoundAdapterName() const;
	void setBoundAdapterName(QString value = QString());

	QString getMacAddress() const;
	void setMacAddress(QString value = QString());

	QString getHostMacAddress() const;
	void setHostMacAddress(QString value = QString());

	QString getHostInterfaceName() const;
	void setHostInterfaceName(QString value = QString());

	bool isRouter() const;
	void setRouter(bool value = false);

	unsigned int getDHCPUseHostMac() const;
	void setDHCPUseHostMac(unsigned int value = PNWR_AUTO);

	bool isForceHostMacAddress() const;
	void setForceHostMacAddress(bool value = false);

	QString getVirtualNetworkID() const;
	void setVirtualNetworkID(QString value = QString());

	PRL_VM_NET_ADAPTER_TYPE getAdapterType() const;
	void setAdapterType(PRL_VM_NET_ADAPTER_TYPE value = PNT_UNDEFINED);

	bool isStaticAddress() const;
	void setStaticAddress(bool value = false);

	bool isAutoApply() const;
	void setAutoApply(bool value = false);

	QList<QString> getNetAddresses() const;
	void setNetAddresses(QList<QString> value = QList<QString>());

	bool isConfigureWithDhcp() const;
	void setConfigureWithDhcp(bool value = false);

	QString getDefaultGateway() const;
	void setDefaultGateway(QString value = QString());

	bool isConfigureWithDhcpIPv6() const;
	void setConfigureWithDhcpIPv6(bool value = false);

	QString getDefaultGatewayIPv6() const;
	void setDefaultGatewayIPv6(QString value = QString());

	QList<QString> getDnsIPAddresses() const;
	void setDnsIPAddresses(QList<QString> value = QList<QString>());

	QList<QString> getSearchDomains() const;
	void setSearchDomains(QList<QString> value = QList<QString>());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getIndex_id() const;
	QString getEnabled_id() const;
	QString getConnected_id() const;
	QString getEmulatedType_id() const;
	QString getSystemName_id() const;
	QString getUserFriendlyName_id() const;
	QString getRemote_id() const;
	QString getBoundAdapterIndex_id() const;
	QString getBoundAdapterName_id() const;
	QString getMacAddress_id() const;
	QString getHostMacAddress_id() const;
	QString getHostInterfaceName_id() const;
	QString getRouter_id() const;
	QString getDHCPUseHostMac_id() const;
	QString getForceHostMacAddress_id() const;
	QString getVirtualNetworkID_id() const;
	QString getAdapterType_id() const;
	QString getStaticAddress_id() const;
	QString getAutoApply_id() const;
	QString getNetAddresses_id() const;
	QString getConfigureWithDhcp_id() const;
	QString getDefaultGateway_id() const;
	QString getConfigureWithDhcpIPv6_id() const;
	QString getDefaultGatewayIPv6_id() const;
	QString getDnsIPAddresses_id() const;
	QString getSearchDomains_id() const;
	QString getDescription_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmGenericNetworkAdapter* pCur, CVmGenericNetworkAdapter* pPrev, MergeOptions nOptions);

	void diff(const CVmGenericNetworkAdapter* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	int		m_iAdapterNumber;
	QString		m_qsAdapterName;
	QString		m_qsMAC;
	QString		m_qsHostMAC;
	QString		m_qsHostInterfaceName;
	bool		m_bRouter;
	unsigned int		m_uiDHCPUseHostMac;
	bool		m_bForceHostMacAddress;
	QString		m_qsVirtualNetworkID;
	PRL_VM_NET_ADAPTER_TYPE		m_ctAdapterType;
	bool		m_bStaticAddress;
	bool		m_bAutoApply;
	QList<QString>		m_lstNetAddress;
	bool		m_bConfigureWithDhcp;
	QString		m_qsDefaultGateway;
	bool		m_bConfigureWithDhcpIPv6;
	QString		m_qsDefaultGatewayIPv6;
	QList<QString>		m_lstDnsIPAddress;
	QList<QString>		m_lstSearchDomain;

	void Copy(const CVmGenericNetworkAdapter& rObject);

signals:

	void signalBoundAdapterIndexChanged(int value, QString object_id = QString());
	void signalBoundAdapterNameChanged(QString value, QString object_id = QString());
	void signalMacAddressChanged(QString value, QString object_id = QString());
	void signalHostMacAddressChanged(QString value, QString object_id = QString());
	void signalHostInterfaceNameChanged(QString value, QString object_id = QString());
	void signalRouterChanged(bool value, QString object_id = QString());
	void signalDHCPUseHostMacChanged(unsigned int value, QString object_id = QString());
	void signalForceHostMacAddressChanged(bool value, QString object_id = QString());
	void signalVirtualNetworkIDChanged(QString value, QString object_id = QString());
	void signalAdapterTypeChanged(PRL_VM_NET_ADAPTER_TYPE value, QString object_id = QString());
	void signalStaticAddressChanged(bool value, QString object_id = QString());
	void signalAutoApplyChanged(bool value, QString object_id = QString());
	void signalNetAddressesChanged(QList<QString> value, QString object_id = QString());
	void signalConfigureWithDhcpChanged(bool value, QString object_id = QString());
	void signalDefaultGatewayChanged(QString value, QString object_id = QString());
	void signalConfigureWithDhcpIPv6Changed(bool value, QString object_id = QString());
	void signalDefaultGatewayIPv6Changed(QString value, QString object_id = QString());
	void signalDnsIPAddressesChanged(QList<QString> value, QString object_id = QString());
	void signalSearchDomainsChanged(QList<QString> value, QString object_id = QString());

private slots:

	void slotChangeBoundAdapterIndex(int value);
	void slotChangeBoundAdapterName(QString value);
	void slotChangeMacAddress(QString value);
	void slotChangeHostMacAddress(QString value);
	void slotChangeHostInterfaceName(QString value);
	void slotChangeRouter(bool value);
	void slotChangeDHCPUseHostMac(unsigned int value);
	void slotChangeForceHostMacAddress(bool value);
	void slotChangeVirtualNetworkID(QString value);
	void slotChangeAdapterType(PRL_VM_NET_ADAPTER_TYPE value);
	void slotChangeStaticAddress(bool value);
	void slotChangeAutoApply(bool value);
	void slotChangeNetAddresses(QList<QString> value);
	void slotChangeConfigureWithDhcp(bool value);
	void slotChangeDefaultGateway(QString value);
	void slotChangeConfigureWithDhcpIPv6(bool value);
	void slotChangeDefaultGatewayIPv6(QString value);
	void slotChangeDnsIPAddresses(QList<QString> value);
	void slotChangeSearchDomains(QList<QString> value);

};

#ifndef DM_795237
#define DM_795237
Q_DECLARE_METATYPE(PVE::DeviceEnabledState)
#endif
#ifndef DM_21711685
#define DM_21711685
Q_DECLARE_METATYPE(PVE::DeviceConnectedState)
#endif
#ifndef DM_48196997
#define DM_48196997
Q_DECLARE_METATYPE(PRL_VM_NET_ADAPTER_TYPE)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif


#endif
