////////////////////////////////////////////////////////////////////////////////
///
/// CVmGenericPciDevice.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmGenericPciDevice.h"


CVmGenericPciDevice::CVmGenericPciDevice()
{
	InitLists();
	setDefaults();
}

CVmGenericPciDevice::CVmGenericPciDevice(const CVmGenericPciDevice& rObject)
: CVmClusteredDevice()
{
	Copy(rObject);
}

CVmGenericPciDevice::CVmGenericPciDevice(const CVmGenericPciDevice* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmGenericPciDevice& CVmGenericPciDevice::operator=(const CVmGenericPciDevice& rObject)
{
	Copy(rObject);
	return *this;
}

CVmGenericPciDevice::CVmGenericPciDevice(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmGenericPciDevice::~CVmGenericPciDevice()
{
	ClearLists();
}


PRL_GENERIC_PCI_DEVICE_CLASS CVmGenericPciDevice::getType() const
{
	return m_ctType;
}

void CVmGenericPciDevice::setType(PRL_GENERIC_PCI_DEVICE_CLASS value)
{
	bool bValueChanged = (m_ctType != value);
	m_ctType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTypeChanged(value, getObjectId());
	}
}

void CVmGenericPciDevice::slotChangeType(PRL_GENERIC_PCI_DEVICE_CLASS value)
{
	setType(value);
}

void CVmGenericPciDevice::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Index").isNull() )
		setIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Connected").isNull() )
		setConnected();
	if ( ! RootElement || ! RootElement->firstChildElement("EmulatedType").isNull() )
		setEmulatedType(PVE::RealGenericDevice);
	if ( ! RootElement || ! RootElement->firstChildElement("SystemName").isNull() )
		setSystemName();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
	if ( ! RootElement || ! RootElement->firstChildElement("Remote").isNull() )
		setRemote();
	if ( ! RootElement || ! RootElement->firstChildElement("InterfaceType").isNull() )
		setInterfaceType(PVE::GenericDevicePci);
	if ( ! RootElement || ! RootElement->firstChildElement("StackIndex").isNull() )
		setStackIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceDescription").isNull() )
		setDescription();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::DeviceEnabledState >("PVE::DeviceEnabledState");
		qRegisterMetaType< PVE::DeviceConnectedState >("PVE::DeviceConnectedState");
		qRegisterMetaType< PRL_MASS_STORAGE_INTERFACE_TYPE >("PRL_MASS_STORAGE_INTERFACE_TYPE");
		qRegisterMetaType< PRL_GENERIC_PCI_DEVICE_CLASS >("PRL_GENERIC_PCI_DEVICE_CLASS");
		first_time = false;
	}

}

QVariant CVmGenericPciDevice::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Index.patch_stamp")
		value.setValue(getFieldPatchedValue("Index"));

	if (path == "Index")
		value.setValue(CVmDevice::getIndex());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue((qlonglong )CVmDevice::getEnabled());

	if (path == "Connected.patch_stamp")
		value.setValue(getFieldPatchedValue("Connected"));

	if (path == "Connected")
		value.setValue((qlonglong )CVmDevice::getConnected());

	if (path == "EmulatedType.patch_stamp")
		value.setValue(getFieldPatchedValue("EmulatedType"));

	if (path == "EmulatedType")
		value.setValue(CVmDevice::getEmulatedType());

	if (path == "SystemName.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemName"));

	if (path == "SystemName")
		value.setValue(CVmDevice::getSystemName());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(CVmDevice::getUserFriendlyName());

	if (path == "Remote.patch_stamp")
		value.setValue(getFieldPatchedValue("Remote"));

	if (path == "Remote")
		value.setValue(CVmDevice::isRemote());

	if (path == "InterfaceType.patch_stamp")
		value.setValue(getFieldPatchedValue("InterfaceType"));

	if (path == "InterfaceType")
		value.setValue((qlonglong )CVmClusteredDevice::getInterfaceType());

	if (path == "StackIndex.patch_stamp")
		value.setValue(getFieldPatchedValue("StackIndex"));

	if (path == "StackIndex")
		value.setValue(CVmClusteredDevice::getStackIndex());

	if (path == "Type.patch_stamp")
		value.setValue(getFieldPatchedValue("Type"));

	if (path == "Type")
		value.setValue((qlonglong )getType());

	if (path == "DeviceDescription.patch_stamp")
		value.setValue(getFieldPatchedValue("DeviceDescription"));

	if (path == "DeviceDescription")
		value.setValue(CVmDevice::getDescription());

	return value;
}

bool CVmGenericPciDevice::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Index.patch_stamp")
	{
		markPatchedField("Index", value.toString());
		return true;
	}

	if (path == "Index")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getIndex() != value.value< unsigned int >());
		CVmDevice::setIndex(value.value< unsigned int >());
		return true;
	}

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEnabled() != (PVE::DeviceEnabledState )value.value< qlonglong >());
		CVmDevice::setEnabled((PVE::DeviceEnabledState )value.value< qlonglong >());
		return true;
	}

	if (path == "Connected.patch_stamp")
	{
		markPatchedField("Connected", value.toString());
		return true;
	}

	if (path == "Connected")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getConnected() != (PVE::DeviceConnectedState )value.value< qlonglong >());
		CVmDevice::setConnected((PVE::DeviceConnectedState )value.value< qlonglong >());
		return true;
	}

	if (path == "EmulatedType.patch_stamp")
	{
		markPatchedField("EmulatedType", value.toString());
		return true;
	}

	if (path == "EmulatedType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEmulatedType() != value.value< unsigned int >());
		CVmDevice::setEmulatedType(value.value< unsigned int >());
		return true;
	}

	if (path == "SystemName.patch_stamp")
	{
		markPatchedField("SystemName", value.toString());
		return true;
	}

	if (path == "SystemName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getSystemName() != value.value< QString >());
		CVmDevice::setSystemName(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getUserFriendlyName() != value.value< QString >());
		CVmDevice::setUserFriendlyName(value.value< QString >());
		return true;
	}

	if (path == "Remote.patch_stamp")
	{
		markPatchedField("Remote", value.toString());
		return true;
	}

	if (path == "Remote")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::isRemote() != value.value< bool >());
		CVmDevice::setRemote(value.value< bool >());
		return true;
	}

	if (path == "InterfaceType.patch_stamp")
	{
		markPatchedField("InterfaceType", value.toString());
		return true;
	}

	if (path == "InterfaceType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmClusteredDevice::getInterfaceType() != (PRL_MASS_STORAGE_INTERFACE_TYPE )value.value< qlonglong >());
		CVmClusteredDevice::setInterfaceType((PRL_MASS_STORAGE_INTERFACE_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "StackIndex.patch_stamp")
	{
		markPatchedField("StackIndex", value.toString());
		return true;
	}

	if (path == "StackIndex")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmClusteredDevice::getStackIndex() != value.value< unsigned int >());
		CVmClusteredDevice::setStackIndex(value.value< unsigned int >());
		return true;
	}

	if (path == "Type.patch_stamp")
	{
		markPatchedField("Type", value.toString());
		return true;
	}

	if (path == "Type")
	{
		if (pbValueChanged)
			*pbValueChanged = (getType() != (PRL_GENERIC_PCI_DEVICE_CLASS )value.value< qlonglong >());
		setType((PRL_GENERIC_PCI_DEVICE_CLASS )value.value< qlonglong >());
		return true;
	}

	if (path == "DeviceDescription.patch_stamp")
	{
		markPatchedField("DeviceDescription", value.toString());
		return true;
	}

	if (path == "DeviceDescription")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getDescription() != value.value< QString >());
		CVmDevice::setDescription(value.value< QString >());
		return true;
	}

	return false;
}

QString CVmGenericPciDevice::getIndex_id() const
{
	return getFullItemId().isEmpty() ? "Index" : getFullItemId() + ".Index";
}
QString CVmGenericPciDevice::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmGenericPciDevice::getConnected_id() const
{
	return getFullItemId().isEmpty() ? "Connected" : getFullItemId() + ".Connected";
}
QString CVmGenericPciDevice::getEmulatedType_id() const
{
	return getFullItemId().isEmpty() ? "EmulatedType" : getFullItemId() + ".EmulatedType";
}
QString CVmGenericPciDevice::getSystemName_id() const
{
	return getFullItemId().isEmpty() ? "SystemName" : getFullItemId() + ".SystemName";
}
QString CVmGenericPciDevice::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}
QString CVmGenericPciDevice::getRemote_id() const
{
	return getFullItemId().isEmpty() ? "Remote" : getFullItemId() + ".Remote";
}
QString CVmGenericPciDevice::getInterfaceType_id() const
{
	return getFullItemId().isEmpty() ? "InterfaceType" : getFullItemId() + ".InterfaceType";
}
QString CVmGenericPciDevice::getStackIndex_id() const
{
	return getFullItemId().isEmpty() ? "StackIndex" : getFullItemId() + ".StackIndex";
}
QString CVmGenericPciDevice::getType_id() const
{
	return getFullItemId().isEmpty() ? "Type" : getFullItemId() + ".Type";
}
QString CVmGenericPciDevice::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "DeviceDescription" : getFullItemId() + ".DeviceDescription";
}

int CVmGenericPciDevice::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmGenericPciDevice::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmGenericPciDevice::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("GenericPciDevice") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Index");
	text_element = Document->createTextNode( QString("%1").arg(getIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(getEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Connected");
	text_element = Document->createTextNode( QString("%1").arg(getConnected()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EmulatedType");
	text_element = Document->createTextNode( QString("%1").arg(getEmulatedType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemName");
	text_element = Document->createTextNode( QString("%1").arg(getSystemName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Remote");
	text_element = Document->createTextNode( QString("%1").arg(isRemote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("InterfaceType");
	text_element = Document->createTextNode( QString("%1").arg(getInterfaceType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("StackIndex");
	text_element = Document->createTextNode( QString("%1").arg(getStackIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceDescription");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmGenericPciDevice::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("GenericPciDevice") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Index_count = 1;
	int Enabled_count = 1;
	int Connected_count = 1;
	int EmulatedType_count = 1;
	int SystemName_count = 1;
	int UserFriendlyName_count = 1;
	int Remote_count = 1;
	int InterfaceType_count = 1;
	int StackIndex_count = 1;
	int Type_count = 0;
	int DeviceDescription_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIndex(text_element.data().toUInt());
			--Index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled((PVE::DeviceEnabledState )text_element.data().toLongLong());
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Connected";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Connected_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Connected")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnected((PVE::DeviceConnectedState )text_element.data().toLongLong());
			--Connected_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EmulatedType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EmulatedType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EmulatedType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEmulatedType(text_element.data().toUInt());
			--EmulatedType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemName(text_element.data());
			--SystemName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Remote";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Remote_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Remote")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemote(text_element.data().toInt() != 0);
			--Remote_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "InterfaceType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (InterfaceType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "InterfaceType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setInterfaceType((PRL_MASS_STORAGE_INTERFACE_TYPE )text_element.data().toLongLong());
			--InterfaceType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "StackIndex";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (StackIndex_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "StackIndex")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setStackIndex(text_element.data().toUInt());
			--StackIndex_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType((PRL_GENERIC_PCI_DEVICE_CLASS )text_element.data().toLongLong());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DeviceDescription";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceDescription_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceDescription")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--DeviceDescription_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'Index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Connected_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'Connected' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EmulatedType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'EmulatedType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SystemName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'SystemName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Remote_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'Remote' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (InterfaceType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'InterfaceType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (StackIndex_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'StackIndex' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Type_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmGenericPciDevice': tag 'Type' is absent";
	}

	if (DeviceDescription_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmGenericPciDevice': tag 'DeviceDescription' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void CVmGenericPciDevice::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmGenericPciDevice::merge(CVmGenericPciDevice* pCur, CVmGenericPciDevice* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "GenericPciDevice";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getIndex() != pCur->getIndex() && getIndex() == pPrev->getIndex())
		setIndex(pCur->getIndex());
	else if (getIndex() != pCur->getIndex() && getIndex() != pPrev->getIndex() && pCur->getIndex() != pPrev->getIndex())
	{
		m_qsErrorMessage += ".Index";
		return false;
	}

	if (getEnabled() != pCur->getEnabled() && getEnabled() == pPrev->getEnabled())
		setEnabled(pCur->getEnabled());
	else if (getEnabled() != pCur->getEnabled() && getEnabled() != pPrev->getEnabled() && pCur->getEnabled() != pPrev->getEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getConnected() != pCur->getConnected() && getConnected() == pPrev->getConnected())
		setConnected(pCur->getConnected());
	else if (getConnected() != pCur->getConnected() && getConnected() != pPrev->getConnected() && pCur->getConnected() != pPrev->getConnected())
	{
		m_qsErrorMessage += ".Connected";
		return false;
	}

	if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() == pPrev->getEmulatedType())
		setEmulatedType(pCur->getEmulatedType());
	else if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() != pPrev->getEmulatedType() && pCur->getEmulatedType() != pPrev->getEmulatedType())
	{
		m_qsErrorMessage += ".EmulatedType";
		return false;
	}

	if (getSystemName() != pCur->getSystemName() && getSystemName() == pPrev->getSystemName())
		setSystemName(pCur->getSystemName());
	else if (getSystemName() != pCur->getSystemName() && getSystemName() != pPrev->getSystemName() && pCur->getSystemName() != pPrev->getSystemName())
	{
		m_qsErrorMessage += ".SystemName";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if (isRemote() != pCur->isRemote() && isRemote() == pPrev->isRemote())
		setRemote(pCur->isRemote());
	else if (isRemote() != pCur->isRemote() && isRemote() != pPrev->isRemote() && pCur->isRemote() != pPrev->isRemote())
	{
		m_qsErrorMessage += ".Remote";
		return false;
	}

	if (getInterfaceType() != pCur->getInterfaceType() && getInterfaceType() == pPrev->getInterfaceType())
		setInterfaceType(pCur->getInterfaceType());
	else if (getInterfaceType() != pCur->getInterfaceType() && getInterfaceType() != pPrev->getInterfaceType() && pCur->getInterfaceType() != pPrev->getInterfaceType())
	{
		m_qsErrorMessage += ".InterfaceType";
		return false;
	}

	if (getStackIndex() != pCur->getStackIndex() && getStackIndex() == pPrev->getStackIndex())
		setStackIndex(pCur->getStackIndex());
	else if (getStackIndex() != pCur->getStackIndex() && getStackIndex() != pPrev->getStackIndex() && pCur->getStackIndex() != pPrev->getStackIndex())
	{
		m_qsErrorMessage += ".StackIndex";
		return false;
	}

	if (getType() != pCur->getType() && getType() == pPrev->getType())
		setType(pCur->getType());
	else if (getType() != pCur->getType() && getType() != pPrev->getType() && pCur->getType() != pPrev->getType())
	{
		m_qsErrorMessage += ".Type";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".DeviceDescription";
		return false;
	}

	return true;
}

void CVmGenericPciDevice::diff(const CVmGenericPciDevice* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIndex() != pOld->getIndex())
		lstDiffFullItemIds += getIndex_id();

	if (getEnabled() != pOld->getEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getConnected() != pOld->getConnected())
		lstDiffFullItemIds += getConnected_id();

	if (getEmulatedType() != pOld->getEmulatedType())
		lstDiffFullItemIds += getEmulatedType_id();

	if (getSystemName() != pOld->getSystemName())
		lstDiffFullItemIds += getSystemName_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	if (isRemote() != pOld->isRemote())
		lstDiffFullItemIds += getRemote_id();

	if (getInterfaceType() != pOld->getInterfaceType())
		lstDiffFullItemIds += getInterfaceType_id();

	if (getStackIndex() != pOld->getStackIndex())
		lstDiffFullItemIds += getStackIndex_id();

	if (getType() != pOld->getType())
		lstDiffFullItemIds += getType_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

}

void CVmGenericPciDevice::Copy(const CVmGenericPciDevice& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIndex(rObject.getIndex());
	setEnabled(rObject.getEnabled());
	setConnected(rObject.getConnected());
	setEmulatedType(rObject.getEmulatedType());
	setSystemName(rObject.getSystemName());
	setUserFriendlyName(rObject.getUserFriendlyName());
	setRemote(rObject.isRemote());
	setInterfaceType(rObject.getInterfaceType());
	setStackIndex(rObject.getStackIndex());
	setType(rObject.getType());
	setDescription(rObject.getDescription());

	CustomCopy(&rObject);

}

void CVmGenericPciDevice::InitLists()
{
	CustomInit();
}

void CVmGenericPciDevice::ClearLists()
{
}

void CVmGenericPciDevice::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

