////////////////////////////////////////////////////////////////////////////////
///
/// CVmGlobalNetwork.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMGLOBALNETWORK_H
#define CVMGLOBALNETWORK_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmNetworkRates.h"


class CVmGlobalNetwork : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmGlobalNetwork();
	CVmGlobalNetwork(const CVmGlobalNetwork& rObject);
	CVmGlobalNetwork(const CVmGlobalNetwork* pObject);
	CVmGlobalNetwork(QFile* pFile);
	CVmGlobalNetwork& operator=(const CVmGlobalNetwork& rObject);
	virtual ~CVmGlobalNetwork();


	QList<CVmNetworkRates* >		m_lstNetworkRates;

	CVmNetworkRates* getNetworkRates() const;
	void setNetworkRates(CVmNetworkRates* pNetworkRates);


	QString getHostName() const;
	void setHostName(QString value = QString());

	QString getDefaultGateway() const;
	void setDefaultGateway(QString value = QString());

	QString getDefaultGatewayIPv6() const;
	void setDefaultGatewayIPv6(QString value = QString());

	bool isOfflineManagementEnabled() const;
	void setOfflineManagementEnabled(bool value = false);

	bool isAutoApplyIpOnly() const;
	void setAutoApplyIpOnly(bool value = false);

	QList<QString> getDnsIPAddresses() const;
	void setDnsIPAddresses(QList<QString> value = QList<QString>());

	QList<QString> getSearchDomains() const;
	void setSearchDomains(QList<QString> value = QList<QString>());

	QList<QString> getOfflineServices() const;
	void setOfflineServices(QList<QString> value = QList<QString>());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getHostName_id() const;
	QString getDefaultGateway_id() const;
	QString getDefaultGatewayIPv6_id() const;
	QString getOfflineManagementEnabled_id() const;
	QString getAutoApplyIpOnly_id() const;
	QString getDnsIPAddresses_id() const;
	QString getSearchDomains_id() const;
	QString getOfflineServices_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmGlobalNetwork* pCur, CVmGlobalNetwork* pPrev, MergeOptions nOptions);

	void diff(const CVmGlobalNetwork* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsHostName;
	QString		m_qsDefaultGateway;
	QString		m_qsDefaultGatewayIPv6;
	bool		m_bOfflineManagementEnabled;
	bool		m_bAutoApplyIpOnly;
	QList<QString>		m_lstDnsIPAddress;
	QList<QString>		m_lstSearchDomain;
	QList<QString>		m_lstOfflineService;

	void Copy(const CVmGlobalNetwork& rObject);

signals:

	void signalHostNameChanged(QString value, QString object_id = QString());
	void signalDefaultGatewayChanged(QString value, QString object_id = QString());
	void signalDefaultGatewayIPv6Changed(QString value, QString object_id = QString());
	void signalOfflineManagementEnabledChanged(bool value, QString object_id = QString());
	void signalAutoApplyIpOnlyChanged(bool value, QString object_id = QString());
	void signalDnsIPAddressesChanged(QList<QString> value, QString object_id = QString());
	void signalSearchDomainsChanged(QList<QString> value, QString object_id = QString());
	void signalOfflineServicesChanged(QList<QString> value, QString object_id = QString());

private slots:

	void slotChangeHostName(QString value);
	void slotChangeDefaultGateway(QString value);
	void slotChangeDefaultGatewayIPv6(QString value);
	void slotChangeOfflineManagementEnabled(bool value);
	void slotChangeAutoApplyIpOnly(bool value);
	void slotChangeDnsIPAddresses(QList<QString> value);
	void slotChangeSearchDomains(QList<QString> value);
	void slotChangeOfflineServices(QList<QString> value);

};

#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif
#ifndef DM_212734958
#define DM_212734958
Q_DECLARE_METATYPE(QList<QString>)
#endif


#endif
