////////////////////////////////////////////////////////////////////////////////
///
/// CVmHardware.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmHardware.h"


CVmHardware::CVmHardware()
{
	InitLists();
	setDefaults();
}

CVmHardware::CVmHardware(const CVmHardware& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmHardware::CVmHardware(const CVmHardware* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmHardware& CVmHardware::operator=(const CVmHardware& rObject)
{
	Copy(rObject);
	return *this;
}

CVmHardware::CVmHardware(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmHardware::~CVmHardware()
{
	ClearLists();
}


#include "CVmSoundInputs.h"
#include "CVmSoundOutputs.h"

void CVmHardware::CustomCopy(const CBaseNode* pBN)
{
    if ( ! pBN ) return;

    CustomInit();
    CVmHardware& rObject(*(CVmHardware* )pBN); 

    m_bAddingTypedDevice = rObject.m_bAddingTypedDevice;
    m_bAddingOpticalDisk = rObject.m_bAddingOpticalDisk;
    m_bAddingHardDisk = rObject.m_bAddingHardDisk;

    m_lstIdeDevices.clear();
    QList<CVmMassStorageDevice* > lstDevs;

    lstDevs += *( (QList<CVmMassStorageDevice* >* )m_aDeviceLists[PDE_HARD_DISK] );
    lstDevs += *( (QList<CVmMassStorageDevice* >* )m_aDeviceLists[PDE_OPTICAL_DISK] );

     foreach(CVmMassStorageDevice* pDev, lstDevs)
    {
        if (pDev->getInterfaceType() == PMS_IDE_DEVICE)
            m_lstIdeDevices += pDev;
    }
}

void CVmHardware::CustomInit()
{
    m_bAddingTypedDevice = false;
    m_bAddingOpticalDisk = false;
    m_bAddingHardDisk = false;
	memset(m_aDeviceLists, 0, sizeof(m_aDeviceLists));
	m_aDeviceLists[PDE_GENERIC_DEVICE]			= &m_lstGenericDevices;
	m_aDeviceLists[PDE_GENERIC_PCI_DEVICE]		= &m_lstGenericPciDevices;
	m_aDeviceLists[PDE_PCI_VIDEO_ADAPTER]		= &m_lstPciVideoAdapters;
	m_aDeviceLists[PDE_GENERIC_SCSI_DEVICE]		= &m_lstGenericScsiDevices;
	m_aDeviceLists[PDE_FLOPPY_DISK]				= &m_lstFloppyDisks;
	m_aDeviceLists[PDE_OPTICAL_DISK]			= &m_lstOpticalDisks;
	m_aDeviceLists[PDE_HARD_DISK]				= &m_lstHardDisks;
	m_aDeviceLists[PDE_GENERIC_NETWORK_ADAPTER]	= &m_lstNetworkAdapters;
	m_aDeviceLists[PDE_SERIAL_PORT]				= &m_lstSerialPorts;
	m_aDeviceLists[PDE_PARALLEL_PORT]			= &m_lstParallelPorts;
	m_aDeviceLists[PDE_SOUND_DEVICE]			= &m_lstSoundDevices;
	m_aDeviceLists[PDE_USB_DEVICE]				= &m_lstUsbDevices;
}

// set all device images path to relative
void CVmHardware::SetDevicesPathToRelative(const QString & strVmDir)
{
	SetDevicesListPathsToRelative(strVmDir,m_lstFloppyDisks);
	SetDevicesListPathsToRelative(strVmDir,m_lstOpticalDisks);
	SetDevicesListPathsToRelative(strVmDir,m_lstHardDisks);
	SetDevicesListPathsToRelative(strVmDir,m_lstSerialPorts);
	SetDevicesListPathsToRelative(strVmDir,m_lstParallelPorts);
}

// revert all device images path to absolute
void CVmHardware::RevertDevicesPathToAbsolute(const QString & strVmDir)
{
	RevertDevicesListPathsToAbsolute(strVmDir,m_lstFloppyDisks);
	RevertDevicesListPathsToAbsolute(strVmDir,m_lstOpticalDisks);
	RevertDevicesListPathsToAbsolute(strVmDir,m_lstHardDisks);
	RevertDevicesListPathsToAbsolute(strVmDir,m_lstSerialPorts);
	RevertDevicesListPathsToAbsolute(strVmDir,m_lstParallelPorts);
}

void CVmHardware::addGenericDevice(CVmGenericDevice* device)
{
    m_lstGenericDevices.append( device );
}

void CVmHardware::addGenericPciDevice(CVmGenericPciDevice* device)
{
     m_lstGenericPciDevices.append( device );
}

void CVmHardware::addGenericScsiDevice(CVmGenericScsiDevice* device)
{
     m_lstGenericScsiDevices.append( device );
}

void CVmHardware::addFloppyDisk(CVmFloppyDisk* device)
{
     m_lstFloppyDisks.append( device );
}

void CVmHardware::addOpticalDisk(CVmOpticalDisk* device)
{
    m_bAddingOpticalDisk = true;
	
    m_lstOpticalDisks.append( device );
	
    if( device->getInterfaceType() == PMS_IDE_DEVICE )
    {
         if( !m_bAddingTypedDevice )
            addIdeDevice( (CVmMassStorageDevice*)device );
    }
	
    m_bAddingOpticalDisk = false;
}

void CVmHardware::addHardDisk(CVmHardDisk* device)
{
    m_bAddingHardDisk = true;
	
    m_lstHardDisks.append( device );
	
    if( device->getInterfaceType() == PMS_IDE_DEVICE )
    {
        if(!m_bAddingTypedDevice )
            addIdeDevice( (CVmMassStorageDevice*)device );
    }
	
     m_bAddingHardDisk = false;
}

void CVmHardware::addSerialPort(CVmSerialPort* device)
{
     m_lstSerialPorts.append( device );
}

void CVmHardware::addParallelPort(CVmParallelPort* device)
{
     m_lstParallelPorts.append( device );
}

void CVmHardware::addNetworkAdapter(CVmGenericNetworkAdapter* device)
{
     m_lstNetworkAdapters.append( device );
}

void CVmHardware::addSoundDevice(CVmSoundDevice* device)
{
     m_lstSoundDevices.append( device );
}

void CVmHardware::addUsbDevice(CVmUsbDevice* device)
{
     m_lstUsbDevices.append( device );
}

void CVmHardware::addIdeDevice(CVmMassStorageDevice* device)
{
	m_bAddingTypedDevice = true;

	m_lstIdeDevices.append( device );
	
	if( device->getDeviceType() == PDE_OPTICAL_DISK )
	{
		if( !m_bAddingOpticalDisk )
			addOpticalDisk( (CVmOpticalDisk*)device );
	}
	else
	if( device->getDeviceType() == PDE_HARD_DISK )
	{
		if( !m_bAddingHardDisk )
			addHardDisk( (CVmHardDisk*)device );
	}

	m_bAddingTypedDevice = false;
}

CVmCpu* CVmHardware::getCpu() const
{
	if (!m_lstCpu.isEmpty())
	{
		return m_lstCpu[0];
	}
	return 0;
}

void CVmHardware::setCpu(CVmCpu* pCpu)
{
	ClearList<CVmCpu>(m_lstCpu);
	if (pCpu)
	{
		m_lstCpu += pCpu;
	}
}

Chipset* CVmHardware::getChipset() const
{
	if (!m_lstChipset.isEmpty())
	{
		return m_lstChipset[0];
	}
	return 0;
}

void CVmHardware::setChipset(Chipset* pChipset)
{
	ClearList<Chipset>(m_lstChipset);
	if (pChipset)
	{
		m_lstChipset += pChipset;
	}
}

Clock* CVmHardware::getClock() const
{
	if (!m_lstClock.isEmpty())
	{
		return m_lstClock[0];
	}
	return 0;
}

void CVmHardware::setClock(Clock* pClock)
{
	ClearList<Clock>(m_lstClock);
	if (pClock)
	{
		m_lstClock += pClock;
	}
}

CVmMemory* CVmHardware::getMemory() const
{
	if (!m_lstMemory.isEmpty())
	{
		return m_lstMemory[0];
	}
	return 0;
}

void CVmHardware::setMemory(CVmMemory* pMemory)
{
	ClearList<CVmMemory>(m_lstMemory);
	if (pMemory)
	{
		m_lstMemory += pMemory;
	}
}

CVmVideo* CVmHardware::getVideo() const
{
	if (!m_lstVideo.isEmpty())
	{
		return m_lstVideo[0];
	}
	return 0;
}

void CVmHardware::setVideo(CVmVideo* pVideo)
{
	ClearList<CVmVideo>(m_lstVideo);
	if (pVideo)
	{
		m_lstVideo += pVideo;
	}
}

CVmFloppyDisk* CVmHardware::getFdd() const
{
	if (!m_lstFloppyDisks.isEmpty())
	{
		return m_lstFloppyDisks[0];
	}
	return 0;
}

void CVmHardware::setFdd(CVmFloppyDisk* pFloppyDisks)
{
	ClearList<CVmFloppyDisk>(m_lstFloppyDisks);
	if (pFloppyDisks)
	{
		m_lstFloppyDisks += pFloppyDisks;
	}
}

void CVmHardware::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant CVmHardware::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "Cpu.";
	if (path.startsWith(list_tag) && ! m_lstCpu.isEmpty() && m_lstCpu.first())
		return m_lstCpu.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Chipset.";
	if (path.startsWith(list_tag) && ! m_lstChipset.isEmpty() && m_lstChipset.first())
		return m_lstChipset.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Clock.";
	if (path.startsWith(list_tag) && ! m_lstClock.isEmpty() && m_lstClock.first())
		return m_lstClock.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Memory.";
	if (path.startsWith(list_tag) && ! m_lstMemory.isEmpty() && m_lstMemory.first())
		return m_lstMemory.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Video.";
	if (path.startsWith(list_tag) && ! m_lstVideo.isEmpty() && m_lstVideo.first())
		return m_lstVideo.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Fdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i] && nItemId == m_lstFloppyDisks[i]->getItemId())
				return m_lstFloppyDisks[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Fdd.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i] && nMaxId < m_lstFloppyDisks[i]->getItemId())
				nMaxId = m_lstFloppyDisks[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Fdd.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i]) lstIds += m_lstFloppyDisks[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "CdRom[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i] && nItemId == m_lstOpticalDisks[i]->getItemId())
				return m_lstOpticalDisks[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("CdRom.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i] && nMaxId < m_lstOpticalDisks[i]->getItemId())
				nMaxId = m_lstOpticalDisks[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("CdRom.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i]) lstIds += m_lstOpticalDisks[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "Hdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i] && nItemId == m_lstHardDisks[i]->getItemId())
				return m_lstHardDisks[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Hdd.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i] && nMaxId < m_lstHardDisks[i]->getItemId())
				nMaxId = m_lstHardDisks[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Hdd.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i]) lstIds += m_lstHardDisks[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "Serial[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i] && nItemId == m_lstSerialPorts[i]->getItemId())
				return m_lstSerialPorts[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Serial.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i] && nMaxId < m_lstSerialPorts[i]->getItemId())
				nMaxId = m_lstSerialPorts[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Serial.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i]) lstIds += m_lstSerialPorts[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "Parallel[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i] && nItemId == m_lstParallelPortOlds[i]->getItemId())
				return m_lstParallelPortOlds[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Parallel.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i] && nMaxId < m_lstParallelPortOlds[i]->getItemId())
				nMaxId = m_lstParallelPortOlds[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Parallel.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i]) lstIds += m_lstParallelPortOlds[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "Printer[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i] && nItemId == m_lstParallelPorts[i]->getItemId())
				return m_lstParallelPorts[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Printer.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i] && nMaxId < m_lstParallelPorts[i]->getItemId())
				nMaxId = m_lstParallelPorts[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Printer.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i]) lstIds += m_lstParallelPorts[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i] && nItemId == m_lstNetworkAdapters[i]->getItemId())
				return m_lstNetworkAdapters[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("NetworkAdapter.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i] && nMaxId < m_lstNetworkAdapters[i]->getItemId())
				nMaxId = m_lstNetworkAdapters[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("NetworkAdapter.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i]) lstIds += m_lstNetworkAdapters[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "Sound[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i] && nItemId == m_lstSoundDevices[i]->getItemId())
				return m_lstSoundDevices[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("Sound.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i] && nMaxId < m_lstSoundDevices[i]->getItemId())
				nMaxId = m_lstSoundDevices[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("Sound.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i]) lstIds += m_lstSoundDevices[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "USB[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i] && nItemId == m_lstUsbDevices[i]->getItemId())
				return m_lstUsbDevices[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("USB.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i] && nMaxId < m_lstUsbDevices[i]->getItemId())
				nMaxId = m_lstUsbDevices[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("USB.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i]) lstIds += m_lstUsbDevices[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "PciVideoAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i] && nItemId == m_lstPciVideoAdapters[i]->getItemId())
				return m_lstPciVideoAdapters[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("PciVideoAdapter.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i] && nMaxId < m_lstPciVideoAdapters[i]->getItemId())
				nMaxId = m_lstPciVideoAdapters[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("PciVideoAdapter.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i]) lstIds += m_lstPciVideoAdapters[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "GenericDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i] && nItemId == m_lstGenericDevices[i]->getItemId())
				return m_lstGenericDevices[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("GenericDevice.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i] && nMaxId < m_lstGenericDevices[i]->getItemId())
				nMaxId = m_lstGenericDevices[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("GenericDevice.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i]) lstIds += m_lstGenericDevices[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "GenericPciDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i] && nItemId == m_lstGenericPciDevices[i]->getItemId())
				return m_lstGenericPciDevices[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("GenericPciDevice.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i] && nMaxId < m_lstGenericPciDevices[i]->getItemId())
				nMaxId = m_lstGenericPciDevices[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("GenericPciDevice.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i]) lstIds += m_lstGenericPciDevices[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "GenericScsiDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i] && nItemId == m_lstGenericScsiDevices[i]->getItemId())
				return m_lstGenericScsiDevices[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("GenericScsiDevice.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i] && nMaxId < m_lstGenericScsiDevices[i]->getItemId())
				nMaxId = m_lstGenericScsiDevices[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("GenericScsiDevice.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i]) lstIds += m_lstGenericScsiDevices[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmHardware::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Cpu.";
	if (path.startsWith(list_tag) && ! m_lstCpu.isEmpty() && m_lstCpu.first())
		return m_lstCpu.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Chipset.";
	if (path.startsWith(list_tag) && ! m_lstChipset.isEmpty() && m_lstChipset.first())
		return m_lstChipset.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Clock.";
	if (path.startsWith(list_tag) && ! m_lstClock.isEmpty() && m_lstClock.first())
		return m_lstClock.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Memory.";
	if (path.startsWith(list_tag) && ! m_lstMemory.isEmpty() && m_lstMemory.first())
		return m_lstMemory.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Video.";
	if (path.startsWith(list_tag) && ! m_lstVideo.isEmpty() && m_lstVideo.first())
		return m_lstVideo.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Fdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i] && nItemId == m_lstFloppyDisks[i]->getItemId())
				return m_lstFloppyDisks[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "CdRom[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i] && nItemId == m_lstOpticalDisks[i]->getItemId())
				return m_lstOpticalDisks[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "Hdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i] && nItemId == m_lstHardDisks[i]->getItemId())
				return m_lstHardDisks[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "Serial[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i] && nItemId == m_lstSerialPorts[i]->getItemId())
				return m_lstSerialPorts[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "Parallel[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i] && nItemId == m_lstParallelPortOlds[i]->getItemId())
				return m_lstParallelPortOlds[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "Printer[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i] && nItemId == m_lstParallelPorts[i]->getItemId())
				return m_lstParallelPorts[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i] && nItemId == m_lstNetworkAdapters[i]->getItemId())
				return m_lstNetworkAdapters[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "Sound[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i] && nItemId == m_lstSoundDevices[i]->getItemId())
				return m_lstSoundDevices[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "USB[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i] && nItemId == m_lstUsbDevices[i]->getItemId())
				return m_lstUsbDevices[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "PciVideoAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i] && nItemId == m_lstPciVideoAdapters[i]->getItemId())
				return m_lstPciVideoAdapters[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "GenericDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i] && nItemId == m_lstGenericDevices[i]->getItemId())
				return m_lstGenericDevices[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "GenericPciDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i] && nItemId == m_lstGenericPciDevices[i]->getItemId())
				return m_lstGenericPciDevices[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "GenericScsiDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i] && nItemId == m_lstGenericScsiDevices[i]->getItemId())
				return m_lstGenericScsiDevices[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

int CVmHardware::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Cpu.";
	if (path.startsWith(list_tag) && ! m_lstCpu.isEmpty() && m_lstCpu.first())
		return m_lstCpu.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Chipset.";
	if (path.startsWith(list_tag) && ! m_lstChipset.isEmpty() && m_lstChipset.first())
		return m_lstChipset.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Clock.";
	if (path.startsWith(list_tag) && ! m_lstClock.isEmpty() && m_lstClock.first())
		return m_lstClock.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Memory.";
	if (path.startsWith(list_tag) && ! m_lstMemory.isEmpty() && m_lstMemory.first())
		return m_lstMemory.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Video.";
	if (path.startsWith(list_tag) && ! m_lstVideo.isEmpty() && m_lstVideo.first())
		return m_lstVideo.first()->addListItem(path.mid(list_tag.size()));

	if (path == "Fdd")
	{
		m_lstFloppyDisks += new CVmFloppyDisk;
		nNewItemId = getMaxItemId<CVmFloppyDisk>(m_lstFloppyDisks, "Fdd");
		m_lstFloppyDisks.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Fdd");
	}

	list_tag = "Fdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i] && nItemId == m_lstFloppyDisks[i]->getItemId())
				return m_lstFloppyDisks[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "CdRom")
	{
		m_lstOpticalDisks += new CVmOpticalDisk;
		nNewItemId = getMaxItemId<CVmOpticalDisk>(m_lstOpticalDisks, "CdRom");
		m_lstOpticalDisks.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "CdRom");
	}

	list_tag = "CdRom[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i] && nItemId == m_lstOpticalDisks[i]->getItemId())
				return m_lstOpticalDisks[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "Hdd")
	{
		m_lstHardDisks += new CVmHardDisk;
		nNewItemId = getMaxItemId<CVmHardDisk>(m_lstHardDisks, "Hdd");
		m_lstHardDisks.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Hdd");
	}

	list_tag = "Hdd[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i] && nItemId == m_lstHardDisks[i]->getItemId())
				return m_lstHardDisks[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "Serial")
	{
		m_lstSerialPorts += new CVmSerialPort;
		nNewItemId = getMaxItemId<CVmSerialPort>(m_lstSerialPorts, "Serial");
		m_lstSerialPorts.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Serial");
	}

	list_tag = "Serial[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i] && nItemId == m_lstSerialPorts[i]->getItemId())
				return m_lstSerialPorts[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "Parallel")
	{
		m_lstParallelPortOlds += new CVmParallelPortOld;
		nNewItemId = getMaxItemId<CVmParallelPortOld>(m_lstParallelPortOlds, "Parallel");
		m_lstParallelPortOlds.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Parallel");
	}

	list_tag = "Parallel[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i] && nItemId == m_lstParallelPortOlds[i]->getItemId())
				return m_lstParallelPortOlds[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "Printer")
	{
		m_lstParallelPorts += new CVmParallelPort;
		nNewItemId = getMaxItemId<CVmParallelPort>(m_lstParallelPorts, "Printer");
		m_lstParallelPorts.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Printer");
	}

	list_tag = "Printer[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i] && nItemId == m_lstParallelPorts[i]->getItemId())
				return m_lstParallelPorts[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "NetworkAdapter")
	{
		m_lstNetworkAdapters += new CVmGenericNetworkAdapter;
		nNewItemId = getMaxItemId<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, "NetworkAdapter");
		m_lstNetworkAdapters.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "NetworkAdapter");
	}

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i] && nItemId == m_lstNetworkAdapters[i]->getItemId())
				return m_lstNetworkAdapters[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "Sound")
	{
		m_lstSoundDevices += new CVmSoundDevice;
		nNewItemId = getMaxItemId<CVmSoundDevice>(m_lstSoundDevices, "Sound");
		m_lstSoundDevices.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "Sound");
	}

	list_tag = "Sound[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i] && nItemId == m_lstSoundDevices[i]->getItemId())
				return m_lstSoundDevices[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "USB")
	{
		m_lstUsbDevices += new CVmUsbDevice;
		nNewItemId = getMaxItemId<CVmUsbDevice>(m_lstUsbDevices, "USB");
		m_lstUsbDevices.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "USB");
	}

	list_tag = "USB[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i] && nItemId == m_lstUsbDevices[i]->getItemId())
				return m_lstUsbDevices[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "PciVideoAdapter")
	{
		m_lstPciVideoAdapters += new CVmPciVideoAdapter;
		nNewItemId = getMaxItemId<CVmPciVideoAdapter>(m_lstPciVideoAdapters, "PciVideoAdapter");
		m_lstPciVideoAdapters.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "PciVideoAdapter");
	}

	list_tag = "PciVideoAdapter[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i] && nItemId == m_lstPciVideoAdapters[i]->getItemId())
				return m_lstPciVideoAdapters[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "GenericDevice")
	{
		m_lstGenericDevices += new CVmGenericDevice;
		nNewItemId = getMaxItemId<CVmGenericDevice>(m_lstGenericDevices, "GenericDevice");
		m_lstGenericDevices.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "GenericDevice");
	}

	list_tag = "GenericDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i] && nItemId == m_lstGenericDevices[i]->getItemId())
				return m_lstGenericDevices[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "GenericPciDevice")
	{
		m_lstGenericPciDevices += new CVmGenericPciDevice;
		nNewItemId = getMaxItemId<CVmGenericPciDevice>(m_lstGenericPciDevices, "GenericPciDevice");
		m_lstGenericPciDevices.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "GenericPciDevice");
	}

	list_tag = "GenericPciDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i] && nItemId == m_lstGenericPciDevices[i]->getItemId())
				return m_lstGenericPciDevices[i]->addListItem(path.mid(idx + 2));
	}

	if (path == "GenericScsiDevice")
	{
		m_lstGenericScsiDevices += new CVmGenericScsiDevice;
		nNewItemId = getMaxItemId<CVmGenericScsiDevice>(m_lstGenericScsiDevices, "GenericScsiDevice");
		m_lstGenericScsiDevices.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "GenericScsiDevice");
	}

	list_tag = "GenericScsiDevice[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i] && nItemId == m_lstGenericScsiDevices[i]->getItemId())
				return m_lstGenericScsiDevices[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmHardware::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Cpu.";
	if (path.startsWith(list_tag) && ! m_lstCpu.isEmpty() && m_lstCpu.first())
		return m_lstCpu.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Chipset.";
	if (path.startsWith(list_tag) && ! m_lstChipset.isEmpty() && m_lstChipset.first())
		return m_lstChipset.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Clock.";
	if (path.startsWith(list_tag) && ! m_lstClock.isEmpty() && m_lstClock.first())
		return m_lstClock.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Memory.";
	if (path.startsWith(list_tag) && ! m_lstMemory.isEmpty() && m_lstMemory.first())
		return m_lstMemory.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Video.";
	if (path.startsWith(list_tag) && ! m_lstVideo.isEmpty() && m_lstVideo.first())
		return m_lstVideo.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Fdd[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstFloppyDisks.size(); ++i)
			if (m_lstFloppyDisks[i] && nItemId == m_lstFloppyDisks[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstFloppyDisks[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstFloppyDisks.takeAt(i);
				return true;
			}
	}

	list_tag = "CdRom[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstOpticalDisks.size(); ++i)
			if (m_lstOpticalDisks[i] && nItemId == m_lstOpticalDisks[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstOpticalDisks[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstOpticalDisks.takeAt(i);
				return true;
			}
	}

	list_tag = "Hdd[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstHardDisks.size(); ++i)
			if (m_lstHardDisks[i] && nItemId == m_lstHardDisks[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstHardDisks[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstHardDisks.takeAt(i);
				return true;
			}
	}

	list_tag = "Serial[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSerialPorts.size(); ++i)
			if (m_lstSerialPorts[i] && nItemId == m_lstSerialPorts[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstSerialPorts[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstSerialPorts.takeAt(i);
				return true;
			}
	}

	list_tag = "Parallel[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParallelPortOlds.size(); ++i)
			if (m_lstParallelPortOlds[i] && nItemId == m_lstParallelPortOlds[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstParallelPortOlds[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstParallelPortOlds.takeAt(i);
				return true;
			}
	}

	list_tag = "Printer[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstParallelPorts.size(); ++i)
			if (m_lstParallelPorts[i] && nItemId == m_lstParallelPorts[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstParallelPorts[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstParallelPorts.takeAt(i);
				return true;
			}
	}

	list_tag = "NetworkAdapter[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkAdapters.size(); ++i)
			if (m_lstNetworkAdapters[i] && nItemId == m_lstNetworkAdapters[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstNetworkAdapters[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstNetworkAdapters.takeAt(i);
				return true;
			}
	}

	list_tag = "Sound[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstSoundDevices.size(); ++i)
			if (m_lstSoundDevices[i] && nItemId == m_lstSoundDevices[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstSoundDevices[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstSoundDevices.takeAt(i);
				return true;
			}
	}

	list_tag = "USB[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstUsbDevices.size(); ++i)
			if (m_lstUsbDevices[i] && nItemId == m_lstUsbDevices[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstUsbDevices[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstUsbDevices.takeAt(i);
				return true;
			}
	}

	list_tag = "PciVideoAdapter[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstPciVideoAdapters.size(); ++i)
			if (m_lstPciVideoAdapters[i] && nItemId == m_lstPciVideoAdapters[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstPciVideoAdapters[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstPciVideoAdapters.takeAt(i);
				return true;
			}
	}

	list_tag = "GenericDevice[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericDevices.size(); ++i)
			if (m_lstGenericDevices[i] && nItemId == m_lstGenericDevices[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstGenericDevices[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstGenericDevices.takeAt(i);
				return true;
			}
	}

	list_tag = "GenericPciDevice[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericPciDevices.size(); ++i)
			if (m_lstGenericPciDevices[i] && nItemId == m_lstGenericPciDevices[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstGenericPciDevices[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstGenericPciDevices.takeAt(i);
				return true;
			}
	}

	list_tag = "GenericScsiDevice[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstGenericScsiDevices.size(); ++i)
			if (m_lstGenericScsiDevices[i] && nItemId == m_lstGenericScsiDevices[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstGenericScsiDevices[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstGenericScsiDevices.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmHardware::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Hardware") : m_qsExtRootTagName);

	for(i = 0; i < m_lstCpu.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmCpu* object = m_lstCpu[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstChipset.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const Chipset* object = m_lstChipset[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstClock.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const Clock* object = m_lstClock[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstMemory.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmMemory* object = m_lstMemory[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstVideo.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmVideo* object = m_lstVideo[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	dyn_lists += "Fdd";
	nMaxItemId = getMaxItemId<CVmFloppyDisk>(m_lstFloppyDisks, "Fdd", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstFloppyDisks.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmFloppyDisk* object = m_lstFloppyDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Fdd", mapMaxDynListIds));

	dyn_lists += "CdRom";
	nMaxItemId = getMaxItemId<CVmOpticalDisk>(m_lstOpticalDisks, "CdRom", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstOpticalDisks.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmOpticalDisk* object = m_lstOpticalDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "CdRom", mapMaxDynListIds));

	dyn_lists += "Hdd";
	nMaxItemId = getMaxItemId<CVmHardDisk>(m_lstHardDisks, "Hdd", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstHardDisks.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmHardDisk* object = m_lstHardDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Hdd", mapMaxDynListIds));

	dyn_lists += "Serial";
	nMaxItemId = getMaxItemId<CVmSerialPort>(m_lstSerialPorts, "Serial", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstSerialPorts.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSerialPort* object = m_lstSerialPorts[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Serial", mapMaxDynListIds));

	dyn_lists += "Parallel";
	nMaxItemId = getMaxItemId<CVmParallelPortOld>(m_lstParallelPortOlds, "Parallel", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstParallelPortOlds.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmParallelPortOld* object = m_lstParallelPortOlds[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Parallel", mapMaxDynListIds));

	dyn_lists += "Printer";
	nMaxItemId = getMaxItemId<CVmParallelPort>(m_lstParallelPorts, "Printer", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstParallelPorts.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmParallelPort* object = m_lstParallelPorts[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Printer", mapMaxDynListIds));

	dyn_lists += "NetworkAdapter";
	nMaxItemId = getMaxItemId<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, "NetworkAdapter", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkAdapters.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmGenericNetworkAdapter* object = m_lstNetworkAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "NetworkAdapter", mapMaxDynListIds));

	dyn_lists += "Sound";
	nMaxItemId = getMaxItemId<CVmSoundDevice>(m_lstSoundDevices, "Sound", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstSoundDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSoundDevice* object = m_lstSoundDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "Sound", mapMaxDynListIds));

	dyn_lists += "USB";
	nMaxItemId = getMaxItemId<CVmUsbDevice>(m_lstUsbDevices, "USB", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstUsbDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmUsbDevice* object = m_lstUsbDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "USB", mapMaxDynListIds));

	dyn_lists += "PciVideoAdapter";
	nMaxItemId = getMaxItemId<CVmPciVideoAdapter>(m_lstPciVideoAdapters, "PciVideoAdapter", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstPciVideoAdapters.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmPciVideoAdapter* object = m_lstPciVideoAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "PciVideoAdapter", mapMaxDynListIds));

	dyn_lists += "GenericDevice";
	nMaxItemId = getMaxItemId<CVmGenericDevice>(m_lstGenericDevices, "GenericDevice", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstGenericDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmGenericDevice* object = m_lstGenericDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "GenericDevice", mapMaxDynListIds));

	dyn_lists += "GenericPciDevice";
	nMaxItemId = getMaxItemId<CVmGenericPciDevice>(m_lstGenericPciDevices, "GenericPciDevice", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstGenericPciDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmGenericPciDevice* object = m_lstGenericPciDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "GenericPciDevice", mapMaxDynListIds));

	dyn_lists += "GenericScsiDevice";
	nMaxItemId = getMaxItemId<CVmGenericScsiDevice>(m_lstGenericScsiDevices, "GenericScsiDevice", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstGenericScsiDevices.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmGenericScsiDevice* object = m_lstGenericScsiDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "GenericScsiDevice", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmHardware::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Hardware") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmHardware': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_Fdd = getMaxItemId2(element, "Fdd");
	QMap<int , QString > mapFdd;
	if (unite_with_loaded)
		fillItemIdMap<CVmFloppyDisk>(m_lstFloppyDisks, mapFdd);
	int nMaxItemId_CdRom = getMaxItemId2(element, "CdRom");
	QMap<int , QString > mapCdRom;
	if (unite_with_loaded)
		fillItemIdMap<CVmOpticalDisk>(m_lstOpticalDisks, mapCdRom);
	int nMaxItemId_Hdd = getMaxItemId2(element, "Hdd");
	QMap<int , QString > mapHdd;
	if (unite_with_loaded)
		fillItemIdMap<CVmHardDisk>(m_lstHardDisks, mapHdd);
	int nMaxItemId_Serial = getMaxItemId2(element, "Serial");
	QMap<int , QString > mapSerial;
	if (unite_with_loaded)
		fillItemIdMap<CVmSerialPort>(m_lstSerialPorts, mapSerial);
	int nMaxItemId_Parallel = getMaxItemId2(element, "Parallel");
	QMap<int , QString > mapParallel;
	if (unite_with_loaded)
		fillItemIdMap<CVmParallelPortOld>(m_lstParallelPortOlds, mapParallel);
	int nMaxItemId_Printer = getMaxItemId2(element, "Printer");
	QMap<int , QString > mapPrinter;
	if (unite_with_loaded)
		fillItemIdMap<CVmParallelPort>(m_lstParallelPorts, mapPrinter);
	int nMaxItemId_NetworkAdapter = getMaxItemId2(element, "NetworkAdapter");
	QMap<int , QString > mapNetworkAdapter;
	if (unite_with_loaded)
		fillItemIdMap<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, mapNetworkAdapter);
	int nMaxItemId_Sound = getMaxItemId2(element, "Sound");
	QMap<int , QString > mapSound;
	if (unite_with_loaded)
		fillItemIdMap<CVmSoundDevice>(m_lstSoundDevices, mapSound);
	int nMaxItemId_USB = getMaxItemId2(element, "USB");
	QMap<int , QString > mapUSB;
	if (unite_with_loaded)
		fillItemIdMap<CVmUsbDevice>(m_lstUsbDevices, mapUSB);
	int nMaxItemId_PciVideoAdapter = getMaxItemId2(element, "PciVideoAdapter");
	QMap<int , QString > mapPciVideoAdapter;
	if (unite_with_loaded)
		fillItemIdMap<CVmPciVideoAdapter>(m_lstPciVideoAdapters, mapPciVideoAdapter);
	int nMaxItemId_GenericDevice = getMaxItemId2(element, "GenericDevice");
	QMap<int , QString > mapGenericDevice;
	if (unite_with_loaded)
		fillItemIdMap<CVmGenericDevice>(m_lstGenericDevices, mapGenericDevice);
	int nMaxItemId_GenericPciDevice = getMaxItemId2(element, "GenericPciDevice");
	QMap<int , QString > mapGenericPciDevice;
	if (unite_with_loaded)
		fillItemIdMap<CVmGenericPciDevice>(m_lstGenericPciDevices, mapGenericPciDevice);
	int nMaxItemId_GenericScsiDevice = getMaxItemId2(element, "GenericScsiDevice");
	QMap<int , QString > mapGenericScsiDevice;
	if (unite_with_loaded)
		fillItemIdMap<CVmGenericScsiDevice>(m_lstGenericScsiDevices, mapGenericScsiDevice);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Cpu_count = 1;
	int Chipset_count = 1;
	int Clock_count = 1;
	int Memory_count = 1;
	int Video_count = 1;
	int FloppyDisks_count = 0;
	int OpticalDisks_count = 0;
	int HardDisks_count = 0;
	int SerialPorts_count = 0;
	int ParallelPortOlds_count = 0;
	int ParallelPorts_count = 0;
	int NetworkAdapters_count = 0;
	int SoundDevices_count = 0;
	int UsbDevices_count = 0;
	int PciVideoAdapters_count = 0;
	int GenericDevices_count = 0;
	int GenericPciDevices_count = 0;
	int GenericScsiDevices_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "Cpu" && Cpu_count > 0)
		{
			unused_tag = false;
			CVmCpu* object = m_lstCpu[1 - Cpu_count];
			object->makeFullItemId(getFullItemId(), "Cpu");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Cpu_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Chipset" && Chipset_count > 0)
		{
			unused_tag = false;
			Chipset* object = m_lstChipset[1 - Chipset_count];
			object->makeFullItemId(getFullItemId(), "Chipset");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Chipset_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Clock" && Clock_count > 0)
		{
			unused_tag = false;
			Clock* object = m_lstClock[1 - Clock_count];
			object->makeFullItemId(getFullItemId(), "Clock");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Clock_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Memory" && Memory_count > 0)
		{
			unused_tag = false;
			CVmMemory* object = m_lstMemory[1 - Memory_count];
			object->makeFullItemId(getFullItemId(), "Memory");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Memory_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Video" && Video_count > 0)
		{
			unused_tag = false;
			CVmVideo* object = m_lstVideo[1 - Video_count];
			object->makeFullItemId(getFullItemId(), "Video");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Video_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Fdd")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Fdd++ : nItemId;
			CVmFloppyDisk* object = new CVmFloppyDisk();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Fdd", object->getItemId());
			if (unite_with_loaded && mapFdd.contains(nItemId))
				object->fromString(mapFdd.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstFloppyDisks += object;
			--FloppyDisks_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "CdRom")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_CdRom++ : nItemId;
			CVmOpticalDisk* object = new CVmOpticalDisk();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "CdRom", object->getItemId());
			if (unite_with_loaded && mapCdRom.contains(nItemId))
				object->fromString(mapCdRom.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstOpticalDisks += object;
			--OpticalDisks_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Hdd")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Hdd++ : nItemId;
			CVmHardDisk* object = new CVmHardDisk();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Hdd", object->getItemId());
			if (unite_with_loaded && mapHdd.contains(nItemId))
				object->fromString(mapHdd.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstHardDisks += object;
			--HardDisks_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Serial")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Serial++ : nItemId;
			CVmSerialPort* object = new CVmSerialPort();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Serial", object->getItemId());
			if (unite_with_loaded && mapSerial.contains(nItemId))
				object->fromString(mapSerial.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstSerialPorts += object;
			--SerialPorts_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Parallel")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Parallel++ : nItemId;
			CVmParallelPortOld* object = new CVmParallelPortOld();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Parallel", object->getItemId());
			if (unite_with_loaded && mapParallel.contains(nItemId))
				object->fromString(mapParallel.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstParallelPortOlds += object;
			--ParallelPortOlds_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Printer")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Printer++ : nItemId;
			CVmParallelPort* object = new CVmParallelPort();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Printer", object->getItemId());
			if (unite_with_loaded && mapPrinter.contains(nItemId))
				object->fromString(mapPrinter.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstParallelPorts += object;
			--ParallelPorts_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "NetworkAdapter")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_NetworkAdapter++ : nItemId;
			CVmGenericNetworkAdapter* object = new CVmGenericNetworkAdapter();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "NetworkAdapter", object->getItemId());
			if (unite_with_loaded && mapNetworkAdapter.contains(nItemId))
				object->fromString(mapNetworkAdapter.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstNetworkAdapters += object;
			--NetworkAdapters_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Sound")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_Sound++ : nItemId;
			CVmSoundDevice* object = new CVmSoundDevice();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "Sound", object->getItemId());
			if (unite_with_loaded && mapSound.contains(nItemId))
				object->fromString(mapSound.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstSoundDevices += object;
			--SoundDevices_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "USB")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_USB++ : nItemId;
			CVmUsbDevice* object = new CVmUsbDevice();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "USB", object->getItemId());
			if (unite_with_loaded && mapUSB.contains(nItemId))
				object->fromString(mapUSB.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstUsbDevices += object;
			--UsbDevices_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "PciVideoAdapter")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_PciVideoAdapter++ : nItemId;
			CVmPciVideoAdapter* object = new CVmPciVideoAdapter();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "PciVideoAdapter", object->getItemId());
			if (unite_with_loaded && mapPciVideoAdapter.contains(nItemId))
				object->fromString(mapPciVideoAdapter.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstPciVideoAdapters += object;
			--PciVideoAdapters_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "GenericDevice")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_GenericDevice++ : nItemId;
			CVmGenericDevice* object = new CVmGenericDevice();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "GenericDevice", object->getItemId());
			if (unite_with_loaded && mapGenericDevice.contains(nItemId))
				object->fromString(mapGenericDevice.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstGenericDevices += object;
			--GenericDevices_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "GenericPciDevice")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_GenericPciDevice++ : nItemId;
			CVmGenericPciDevice* object = new CVmGenericPciDevice();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "GenericPciDevice", object->getItemId());
			if (unite_with_loaded && mapGenericPciDevice.contains(nItemId))
				object->fromString(mapGenericPciDevice.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstGenericPciDevices += object;
			--GenericPciDevices_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "GenericScsiDevice")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_GenericScsiDevice++ : nItemId;
			CVmGenericScsiDevice* object = new CVmGenericScsiDevice();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "GenericScsiDevice", object->getItemId());
			if (unite_with_loaded && mapGenericScsiDevice.contains(nItemId))
				object->fromString(mapGenericScsiDevice.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstGenericScsiDevices += object;
			--GenericScsiDevices_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Cpu_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Cpu' is absent";
	}

	if (Chipset_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Chipset' is absent";
	}

	if (Clock_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Clock' is absent";
	}

	if (Memory_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Memory' is absent";
	}

	if (Video_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Video' is absent";
	}

	if (FloppyDisks_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Fdd' is absent";
	}

	if (OpticalDisks_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'CdRom' is absent";
	}

	if (HardDisks_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Hdd' is absent";
	}

	if (SerialPorts_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Serial' is absent";
	}

	if (ParallelPortOlds_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Parallel' is absent";
	}

	if (ParallelPorts_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Printer' is absent";
	}

	if (NetworkAdapters_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'NetworkAdapter' is absent";
	}

	if (SoundDevices_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'Sound' is absent";
	}

	if (UsbDevices_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'USB' is absent";
	}

	if (PciVideoAdapters_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'PciVideoAdapter' is absent";
	}

	if (GenericDevices_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'GenericDevice' is absent";
	}

	if (GenericPciDevices_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'GenericPciDevice' is absent";
	}

	if (GenericScsiDevices_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmHardware': tag 'GenericScsiDevice' is absent";
	}

	syncMaxItemId(nMaxItemId_Fdd, "Fdd");
	syncMaxItemId(nMaxItemId_CdRom, "CdRom");
	syncMaxItemId(nMaxItemId_Hdd, "Hdd");
	syncMaxItemId(nMaxItemId_Serial, "Serial");
	syncMaxItemId(nMaxItemId_Parallel, "Parallel");
	syncMaxItemId(nMaxItemId_Printer, "Printer");
	syncMaxItemId(nMaxItemId_NetworkAdapter, "NetworkAdapter");
	syncMaxItemId(nMaxItemId_Sound, "Sound");
	syncMaxItemId(nMaxItemId_USB, "USB");
	syncMaxItemId(nMaxItemId_PciVideoAdapter, "PciVideoAdapter");
	syncMaxItemId(nMaxItemId_GenericDevice, "GenericDevice");
	syncMaxItemId(nMaxItemId_GenericPciDevice, "GenericPciDevice");
	syncMaxItemId(nMaxItemId_GenericScsiDevice, "GenericScsiDevice");


	if (Chipset_count >= 1)
	{
		getChipset()->setType(0);
	}

	m_lstIdeDevices.clear();
	QList<CVmMassStorageDevice* > lstDevs;

	lstDevs += *( (QList<CVmMassStorageDevice* >* )m_aDeviceLists[PDE_HARD_DISK] );
	lstDevs += *( (QList<CVmMassStorageDevice* >* )m_aDeviceLists[PDE_OPTICAL_DISK] );

	foreach(CVmMassStorageDevice* pDev, lstDevs)
	{
		if (pDev->getInterfaceType() == PMS_IDE_DEVICE)
			m_lstIdeDevices += pDev;
	}

	foreach(CVmSoundDevice* pSD, m_lstSoundDevices)
	{
		if (pSD->getSoundInputs()->m_lstSoundDevices.isEmpty())
		{
			pSD->getSoundInputs()->m_lstSoundDevices += new CVmSoundDevice();
			pSD->getSoundInputs()->m_lstSoundDevices.last()->setUserFriendlyName(PRL_SOUND_DEFAULT_DEVICE_NAME);
		}
		if (pSD->getSoundOutputs()->m_lstSoundDevices.isEmpty())
		{
			pSD->getSoundOutputs()->m_lstSoundDevices += new CVmSoundDevice();
			pSD->getSoundOutputs()->m_lstSoundDevices.last()->setUserFriendlyName(PRL_SOUND_DEFAULT_DEVICE_NAME);
		}
	}

	return 0;
}

void CVmHardware::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstCpu.size(); ++i)
	{
		CVmCpu* object = m_lstCpu[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Cpu");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstChipset.size(); ++i)
	{
		Chipset* object = m_lstChipset[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Chipset");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstClock.size(); ++i)
	{
		Clock* object = m_lstClock[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Clock");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstMemory.size(); ++i)
	{
		CVmMemory* object = m_lstMemory[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Memory");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstVideo.size(); ++i)
	{
		CVmVideo* object = m_lstVideo[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Video");
		object->syncItemIds();
	}

	nMaxItemId = getMaxItemId<CVmFloppyDisk>(m_lstFloppyDisks, "Fdd");
	setItemIds.clear();
	for(i = 0; i < m_lstFloppyDisks.size(); ++i)
	{
		CVmFloppyDisk* object = m_lstFloppyDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Fdd", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Fdd");

	nMaxItemId = getMaxItemId<CVmOpticalDisk>(m_lstOpticalDisks, "CdRom");
	setItemIds.clear();
	for(i = 0; i < m_lstOpticalDisks.size(); ++i)
	{
		CVmOpticalDisk* object = m_lstOpticalDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "CdRom", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "CdRom");

	nMaxItemId = getMaxItemId<CVmHardDisk>(m_lstHardDisks, "Hdd");
	setItemIds.clear();
	for(i = 0; i < m_lstHardDisks.size(); ++i)
	{
		CVmHardDisk* object = m_lstHardDisks[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Hdd", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Hdd");

	nMaxItemId = getMaxItemId<CVmSerialPort>(m_lstSerialPorts, "Serial");
	setItemIds.clear();
	for(i = 0; i < m_lstSerialPorts.size(); ++i)
	{
		CVmSerialPort* object = m_lstSerialPorts[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Serial", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Serial");

	nMaxItemId = getMaxItemId<CVmParallelPortOld>(m_lstParallelPortOlds, "Parallel");
	setItemIds.clear();
	for(i = 0; i < m_lstParallelPortOlds.size(); ++i)
	{
		CVmParallelPortOld* object = m_lstParallelPortOlds[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Parallel", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Parallel");

	nMaxItemId = getMaxItemId<CVmParallelPort>(m_lstParallelPorts, "Printer");
	setItemIds.clear();
	for(i = 0; i < m_lstParallelPorts.size(); ++i)
	{
		CVmParallelPort* object = m_lstParallelPorts[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Printer", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Printer");

	nMaxItemId = getMaxItemId<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, "NetworkAdapter");
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkAdapters.size(); ++i)
	{
		CVmGenericNetworkAdapter* object = m_lstNetworkAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "NetworkAdapter", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "NetworkAdapter");

	nMaxItemId = getMaxItemId<CVmSoundDevice>(m_lstSoundDevices, "Sound");
	setItemIds.clear();
	for(i = 0; i < m_lstSoundDevices.size(); ++i)
	{
		CVmSoundDevice* object = m_lstSoundDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "Sound", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "Sound");

	nMaxItemId = getMaxItemId<CVmUsbDevice>(m_lstUsbDevices, "USB");
	setItemIds.clear();
	for(i = 0; i < m_lstUsbDevices.size(); ++i)
	{
		CVmUsbDevice* object = m_lstUsbDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "USB", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "USB");

	nMaxItemId = getMaxItemId<CVmPciVideoAdapter>(m_lstPciVideoAdapters, "PciVideoAdapter");
	setItemIds.clear();
	for(i = 0; i < m_lstPciVideoAdapters.size(); ++i)
	{
		CVmPciVideoAdapter* object = m_lstPciVideoAdapters[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "PciVideoAdapter", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "PciVideoAdapter");

	nMaxItemId = getMaxItemId<CVmGenericDevice>(m_lstGenericDevices, "GenericDevice");
	setItemIds.clear();
	for(i = 0; i < m_lstGenericDevices.size(); ++i)
	{
		CVmGenericDevice* object = m_lstGenericDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "GenericDevice", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "GenericDevice");

	nMaxItemId = getMaxItemId<CVmGenericPciDevice>(m_lstGenericPciDevices, "GenericPciDevice");
	setItemIds.clear();
	for(i = 0; i < m_lstGenericPciDevices.size(); ++i)
	{
		CVmGenericPciDevice* object = m_lstGenericPciDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "GenericPciDevice", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "GenericPciDevice");

	nMaxItemId = getMaxItemId<CVmGenericScsiDevice>(m_lstGenericScsiDevices, "GenericScsiDevice");
	setItemIds.clear();
	for(i = 0; i < m_lstGenericScsiDevices.size(); ++i)
	{
		CVmGenericScsiDevice* object = m_lstGenericScsiDevices[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "GenericScsiDevice", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "GenericScsiDevice");

}

bool CVmHardware::merge(CVmHardware* pCur, CVmHardware* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Hardware";

	for(i = 0; i < m_lstCpu.size(); i++)
	{
		if ( m_lstCpu[i]->merge(pCur->m_lstCpu[i], pPrev->m_lstCpu[i], nOptions) ) continue;
		QString qsIdx = (m_lstCpu.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstCpu[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstChipset.size(); i++)
	{
		if ( m_lstChipset[i]->merge(pCur->m_lstChipset[i], pPrev->m_lstChipset[i], nOptions) ) continue;
		QString qsIdx = (m_lstChipset.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstChipset[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstClock.size(); i++)
	{
		if ( m_lstClock[i]->merge(pCur->m_lstClock[i], pPrev->m_lstClock[i], nOptions) ) continue;
		QString qsIdx = (m_lstClock.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstClock[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstMemory.size(); i++)
	{
		if ( m_lstMemory[i]->merge(pCur->m_lstMemory[i], pPrev->m_lstMemory[i], nOptions) ) continue;
		QString qsIdx = (m_lstMemory.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstMemory[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstVideo.size(); i++)
	{
		if ( m_lstVideo[i]->merge(pCur->m_lstVideo[i], pPrev->m_lstVideo[i], nOptions) ) continue;
		QString qsIdx = (m_lstVideo.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstVideo[i]->GetErrorMessage();
		return false;
	}

	if ( ! mergeList<CVmFloppyDisk>(m_lstFloppyDisks, pCur->m_lstFloppyDisks, pPrev->m_lstFloppyDisks, "Fdd", nOptions) )
		return false;

	if ( ! mergeList<CVmOpticalDisk>(m_lstOpticalDisks, pCur->m_lstOpticalDisks, pPrev->m_lstOpticalDisks, "CdRom", nOptions) )
		return false;

	if ( ! mergeList<CVmHardDisk>(m_lstHardDisks, pCur->m_lstHardDisks, pPrev->m_lstHardDisks, "Hdd", nOptions) )
		return false;

	if ( ! mergeList<CVmSerialPort>(m_lstSerialPorts, pCur->m_lstSerialPorts, pPrev->m_lstSerialPorts, "Serial", nOptions) )
		return false;

	if ( ! mergeList<CVmParallelPortOld>(m_lstParallelPortOlds, pCur->m_lstParallelPortOlds, pPrev->m_lstParallelPortOlds, "Parallel", nOptions) )
		return false;

	if ( ! mergeList<CVmParallelPort>(m_lstParallelPorts, pCur->m_lstParallelPorts, pPrev->m_lstParallelPorts, "Printer", nOptions) )
		return false;

	if ( ! mergeList<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, pCur->m_lstNetworkAdapters, pPrev->m_lstNetworkAdapters, "NetworkAdapter", nOptions) )
		return false;

	if ( ! mergeList<CVmSoundDevice>(m_lstSoundDevices, pCur->m_lstSoundDevices, pPrev->m_lstSoundDevices, "Sound", nOptions) )
		return false;

	if ( ! mergeList<CVmUsbDevice>(m_lstUsbDevices, pCur->m_lstUsbDevices, pPrev->m_lstUsbDevices, "USB", nOptions) )
		return false;

	if ( ! mergeList<CVmPciVideoAdapter>(m_lstPciVideoAdapters, pCur->m_lstPciVideoAdapters, pPrev->m_lstPciVideoAdapters, "PciVideoAdapter", nOptions) )
		return false;

	if ( ! mergeList<CVmGenericDevice>(m_lstGenericDevices, pCur->m_lstGenericDevices, pPrev->m_lstGenericDevices, "GenericDevice", nOptions) )
		return false;

	if ( ! mergeList<CVmGenericPciDevice>(m_lstGenericPciDevices, pCur->m_lstGenericPciDevices, pPrev->m_lstGenericPciDevices, "GenericPciDevice", nOptions) )
		return false;

	if ( ! mergeList<CVmGenericScsiDevice>(m_lstGenericScsiDevices, pCur->m_lstGenericScsiDevices, pPrev->m_lstGenericScsiDevices, "GenericScsiDevice", nOptions) )
		return false;

	return true;
}

void CVmHardware::diff(const CVmHardware* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	for(i = 0; i < m_lstCpu.size(); ++i)
		m_lstCpu[i]->diff(pOld->m_lstCpu[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstChipset.size(); ++i)
		m_lstChipset[i]->diff(pOld->m_lstChipset[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstClock.size(); ++i)
		m_lstClock[i]->diff(pOld->m_lstClock[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstMemory.size(); ++i)
		m_lstMemory[i]->diff(pOld->m_lstMemory[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstVideo.size(); ++i)
		m_lstVideo[i]->diff(pOld->m_lstVideo[i], lstDiffFullItemIds);

	diffList<CVmFloppyDisk>(m_lstFloppyDisks, pOld->m_lstFloppyDisks, lstDiffFullItemIds);

	diffList<CVmOpticalDisk>(m_lstOpticalDisks, pOld->m_lstOpticalDisks, lstDiffFullItemIds);

	diffList<CVmHardDisk>(m_lstHardDisks, pOld->m_lstHardDisks, lstDiffFullItemIds);

	diffList<CVmSerialPort>(m_lstSerialPorts, pOld->m_lstSerialPorts, lstDiffFullItemIds);

	diffList<CVmParallelPortOld>(m_lstParallelPortOlds, pOld->m_lstParallelPortOlds, lstDiffFullItemIds);

	diffList<CVmParallelPort>(m_lstParallelPorts, pOld->m_lstParallelPorts, lstDiffFullItemIds);

	diffList<CVmGenericNetworkAdapter>(m_lstNetworkAdapters, pOld->m_lstNetworkAdapters, lstDiffFullItemIds);

	diffList<CVmSoundDevice>(m_lstSoundDevices, pOld->m_lstSoundDevices, lstDiffFullItemIds);

	diffList<CVmUsbDevice>(m_lstUsbDevices, pOld->m_lstUsbDevices, lstDiffFullItemIds);

	diffList<CVmPciVideoAdapter>(m_lstPciVideoAdapters, pOld->m_lstPciVideoAdapters, lstDiffFullItemIds);

	diffList<CVmGenericDevice>(m_lstGenericDevices, pOld->m_lstGenericDevices, lstDiffFullItemIds);

	diffList<CVmGenericPciDevice>(m_lstGenericPciDevices, pOld->m_lstGenericPciDevices, lstDiffFullItemIds);

	diffList<CVmGenericScsiDevice>(m_lstGenericScsiDevices, pOld->m_lstGenericScsiDevices, lstDiffFullItemIds);

}

void CVmHardware::Copy(const CVmHardware& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CVmCpu >(m_lstCpu);
	for(i = 0; i < rObject.m_lstCpu.size(); i++)
		m_lstCpu += new CVmCpu(rObject.m_lstCpu[i]);

	ClearList<Chipset >(m_lstChipset);
	for(i = 0; i < rObject.m_lstChipset.size(); i++)
		m_lstChipset += new Chipset(rObject.m_lstChipset[i]);

	ClearList<Clock >(m_lstClock);
	for(i = 0; i < rObject.m_lstClock.size(); i++)
		m_lstClock += new Clock(rObject.m_lstClock[i]);

	ClearList<CVmMemory >(m_lstMemory);
	for(i = 0; i < rObject.m_lstMemory.size(); i++)
		m_lstMemory += new CVmMemory(rObject.m_lstMemory[i]);

	ClearList<CVmVideo >(m_lstVideo);
	for(i = 0; i < rObject.m_lstVideo.size(); i++)
		m_lstVideo += new CVmVideo(rObject.m_lstVideo[i]);

	ClearList<CVmFloppyDisk >(m_lstFloppyDisks);
	for(i = 0; i < rObject.m_lstFloppyDisks.size(); i++)
		m_lstFloppyDisks += new CVmFloppyDisk(rObject.m_lstFloppyDisks[i]);

	ClearList<CVmOpticalDisk >(m_lstOpticalDisks);
	for(i = 0; i < rObject.m_lstOpticalDisks.size(); i++)
		m_lstOpticalDisks += new CVmOpticalDisk(rObject.m_lstOpticalDisks[i]);

	ClearList<CVmHardDisk >(m_lstHardDisks);
	for(i = 0; i < rObject.m_lstHardDisks.size(); i++)
		m_lstHardDisks += new CVmHardDisk(rObject.m_lstHardDisks[i]);

	ClearList<CVmSerialPort >(m_lstSerialPorts);
	for(i = 0; i < rObject.m_lstSerialPorts.size(); i++)
		m_lstSerialPorts += new CVmSerialPort(rObject.m_lstSerialPorts[i]);

	ClearList<CVmParallelPortOld >(m_lstParallelPortOlds);
	for(i = 0; i < rObject.m_lstParallelPortOlds.size(); i++)
		m_lstParallelPortOlds += new CVmParallelPortOld(rObject.m_lstParallelPortOlds[i]);

	ClearList<CVmParallelPort >(m_lstParallelPorts);
	for(i = 0; i < rObject.m_lstParallelPorts.size(); i++)
		m_lstParallelPorts += new CVmParallelPort(rObject.m_lstParallelPorts[i]);

	ClearList<CVmGenericNetworkAdapter >(m_lstNetworkAdapters);
	for(i = 0; i < rObject.m_lstNetworkAdapters.size(); i++)
		m_lstNetworkAdapters += new CVmGenericNetworkAdapter(rObject.m_lstNetworkAdapters[i]);

	ClearList<CVmSoundDevice >(m_lstSoundDevices);
	for(i = 0; i < rObject.m_lstSoundDevices.size(); i++)
		m_lstSoundDevices += new CVmSoundDevice(rObject.m_lstSoundDevices[i]);

	ClearList<CVmUsbDevice >(m_lstUsbDevices);
	for(i = 0; i < rObject.m_lstUsbDevices.size(); i++)
		m_lstUsbDevices += new CVmUsbDevice(rObject.m_lstUsbDevices[i]);

	ClearList<CVmPciVideoAdapter >(m_lstPciVideoAdapters);
	for(i = 0; i < rObject.m_lstPciVideoAdapters.size(); i++)
		m_lstPciVideoAdapters += new CVmPciVideoAdapter(rObject.m_lstPciVideoAdapters[i]);

	ClearList<CVmGenericDevice >(m_lstGenericDevices);
	for(i = 0; i < rObject.m_lstGenericDevices.size(); i++)
		m_lstGenericDevices += new CVmGenericDevice(rObject.m_lstGenericDevices[i]);

	ClearList<CVmGenericPciDevice >(m_lstGenericPciDevices);
	for(i = 0; i < rObject.m_lstGenericPciDevices.size(); i++)
		m_lstGenericPciDevices += new CVmGenericPciDevice(rObject.m_lstGenericPciDevices[i]);

	ClearList<CVmGenericScsiDevice >(m_lstGenericScsiDevices);
	for(i = 0; i < rObject.m_lstGenericScsiDevices.size(); i++)
		m_lstGenericScsiDevices += new CVmGenericScsiDevice(rObject.m_lstGenericScsiDevices[i]);

	CustomCopy(&rObject);

}

void CVmHardware::InitLists()
{
	InitList<CVmCpu>(1, m_lstCpu);
	InitList<Chipset>(1, m_lstChipset);
	InitList<Clock>(1, m_lstClock);
	InitList<CVmMemory>(1, m_lstMemory);
	InitList<CVmVideo>(1, m_lstVideo);
	CustomInit();
}

void CVmHardware::ClearLists()
{
	ClearList<CVmCpu>(m_lstCpu);
	ClearList<Chipset>(m_lstChipset);
	ClearList<Clock>(m_lstClock);
	ClearList<CVmMemory>(m_lstMemory);
	ClearList<CVmVideo>(m_lstVideo);
	ClearList<CVmFloppyDisk>(m_lstFloppyDisks);
	ClearList<CVmOpticalDisk>(m_lstOpticalDisks);
	ClearList<CVmHardDisk>(m_lstHardDisks);
	ClearList<CVmSerialPort>(m_lstSerialPorts);
	ClearList<CVmParallelPortOld>(m_lstParallelPortOlds);
	ClearList<CVmParallelPort>(m_lstParallelPorts);
	ClearList<CVmGenericNetworkAdapter>(m_lstNetworkAdapters);
	ClearList<CVmSoundDevice>(m_lstSoundDevices);
	ClearList<CVmUsbDevice>(m_lstUsbDevices);
	ClearList<CVmPciVideoAdapter>(m_lstPciVideoAdapters);
	ClearList<CVmGenericDevice>(m_lstGenericDevices);
	ClearList<CVmGenericPciDevice>(m_lstGenericPciDevices);
	ClearList<CVmGenericScsiDevice>(m_lstGenericScsiDevices);
}

void CVmHardware::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Fdd") )
		ClearList<CVmFloppyDisk>(m_lstFloppyDisks);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("CdRom") )
		ClearList<CVmOpticalDisk>(m_lstOpticalDisks);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Hdd") )
		ClearList<CVmHardDisk>(m_lstHardDisks);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Serial") )
		ClearList<CVmSerialPort>(m_lstSerialPorts);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Parallel") )
		ClearList<CVmParallelPortOld>(m_lstParallelPortOlds);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Printer") )
		ClearList<CVmParallelPort>(m_lstParallelPorts);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("NetworkAdapter") )
		ClearList<CVmGenericNetworkAdapter>(m_lstNetworkAdapters);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("Sound") )
		ClearList<CVmSoundDevice>(m_lstSoundDevices);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("USB") )
		ClearList<CVmUsbDevice>(m_lstUsbDevices);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("PciVideoAdapter") )
		ClearList<CVmPciVideoAdapter>(m_lstPciVideoAdapters);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("GenericDevice") )
		ClearList<CVmGenericDevice>(m_lstGenericDevices);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("GenericPciDevice") )
		ClearList<CVmGenericPciDevice>(m_lstGenericPciDevices);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("GenericScsiDevice") )
		ClearList<CVmGenericScsiDevice>(m_lstGenericScsiDevices);
	for(i = 0; i < m_lstCpu.size() && ! unite_with_loaded; i++)
	{
		m_lstCpu[i]->ClearListsInReadXml();
		m_lstCpu[i]->setDefaults();
		m_lstCpu[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstChipset.size() && ! unite_with_loaded; i++)
	{
		m_lstChipset[i]->ClearListsInReadXml();
		m_lstChipset[i]->setDefaults();
		m_lstChipset[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstClock.size() && ! unite_with_loaded; i++)
	{
		m_lstClock[i]->ClearListsInReadXml();
		m_lstClock[i]->setDefaults();
		m_lstClock[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstMemory.size() && ! unite_with_loaded; i++)
	{
		m_lstMemory[i]->ClearListsInReadXml();
		m_lstMemory[i]->setDefaults();
		m_lstMemory[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstVideo.size() && ! unite_with_loaded; i++)
	{
		m_lstVideo[i]->ClearListsInReadXml();
		m_lstVideo[i]->setDefaults();
		m_lstVideo[i]->setSectionFakeFlag(true);
	}
}

