////////////////////////////////////////////////////////////////////////////////
///
/// CVmHardware.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMHARDWARE_H
#define CVMHARDWARE_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmMassStorageDevice.h"
#include "CVmCpu.h"
#include "Chipset.h"
#include "Clock.h"
#include "CVmMemory.h"
#include "CVmVideo.h"
#include "CVmFloppyDisk.h"
#include "CVmOpticalDisk.h"
#include "CVmHardDisk.h"
#include "CVmSerialPort.h"
#include "CVmParallelPortOld.h"
#include "CVmParallelPort.h"
#include "CVmGenericNetworkAdapter.h"
#include "CVmSoundDevice.h"
#include "CVmUsbDevice.h"
#include "CVmPciVideoAdapter.h"
#include "CVmGenericDevice.h"
#include "CVmGenericPciDevice.h"
#include "CVmGenericScsiDevice.h"


class CVmHardware : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmHardware();
	CVmHardware(const CVmHardware& rObject);
	CVmHardware(const CVmHardware* pObject);
	CVmHardware(QFile* pFile);
	CVmHardware& operator=(const CVmHardware& rObject);
	virtual ~CVmHardware();


    virtual void CustomCopy(const CBaseNode* pBN);

    virtual void CustomInit();
	// Devices Lists array
	void* m_aDeviceLists[PDE_MAX];
	
	template <typename T>
	QList<T*>* GetDeviceListPtr()
	{
		T objDevice;
		return reinterpret_cast< QList<T*>* >(m_aDeviceLists[ objDevice.getDeviceType() ]);
	}

private:

// set images path to relative
template<class T>
void SetDevicesListPathsToRelative(const QString & strVmDir,QList<T*> listToProcess)
{
	for( int iDevListIndex = 0; iDevListIndex < listToProcess.count(); iDevListIndex++ )
	{
		listToProcess[iDevListIndex]->setRelativeSystemName(strVmDir);
	}
}

// revert devices images path to absolute
template<class T>
void RevertDevicesListPathsToAbsolute(const QString & strVmDir,QList<T*> listToProcess)
{
	for( int iDevListIndex = 0; iDevListIndex < listToProcess.count(); iDevListIndex++ )
	{
		listToProcess[iDevListIndex]->RevertToInitialSystemName(strVmDir);
	}
}

public:
    // set all device images path to relative
    void SetDevicesPathToRelative(const QString & strVmDir);
    // revert all device images path to absolute
    void RevertDevicesPathToAbsolute(const QString & strVmDir);

    void addGenericDevice(CVmGenericDevice* device);
    void addGenericPciDevice(CVmGenericPciDevice* device);
    void addGenericScsiDevice(CVmGenericScsiDevice* device);
    void addFloppyDisk(CVmFloppyDisk* device);
    void addOpticalDisk(CVmOpticalDisk* device);
    void addHardDisk(CVmHardDisk* device);
    void addSerialPort(CVmSerialPort* device);
    void addParallelPort(CVmParallelPort* device);
    void addNetworkAdapter(CVmGenericNetworkAdapter* device);
    void addSoundDevice(CVmSoundDevice* device);
    void addUsbDevice(CVmUsbDevice* device);

    QList<CVmMassStorageDevice* >    m_lstIdeDevices;

    void addIdeDevice(CVmMassStorageDevice* device);

private:

    bool m_bAddingTypedDevice;
    bool m_bAddingOpticalDisk;
    bool m_bAddingHardDisk;

public:

	QList<CVmCpu* >		m_lstCpu;
	QList<Chipset* >		m_lstChipset;
	QList<Clock* >		m_lstClock;
	QList<CVmMemory* >		m_lstMemory;
	QList<CVmVideo* >		m_lstVideo;
	QList<CVmFloppyDisk* >		m_lstFloppyDisks;
	QList<CVmOpticalDisk* >		m_lstOpticalDisks;
	QList<CVmHardDisk* >		m_lstHardDisks;
	QList<CVmSerialPort* >		m_lstSerialPorts;
	QList<CVmParallelPortOld* >		m_lstParallelPortOlds;
	QList<CVmParallelPort* >		m_lstParallelPorts;
	QList<CVmGenericNetworkAdapter* >		m_lstNetworkAdapters;
	QList<CVmSoundDevice* >		m_lstSoundDevices;
	QList<CVmUsbDevice* >		m_lstUsbDevices;
	QList<CVmPciVideoAdapter* >		m_lstPciVideoAdapters;
	QList<CVmGenericDevice* >		m_lstGenericDevices;
	QList<CVmGenericPciDevice* >		m_lstGenericPciDevices;
	QList<CVmGenericScsiDevice* >		m_lstGenericScsiDevices;

	CVmCpu* getCpu() const;
	void setCpu(CVmCpu* pCpu);

	Chipset* getChipset() const;
	void setChipset(Chipset* pChipset);

	Clock* getClock() const;
	void setClock(Clock* pClock);

	CVmMemory* getMemory() const;
	void setMemory(CVmMemory* pMemory);

	CVmVideo* getVideo() const;
	void setVideo(CVmVideo* pVideo);

	CVmFloppyDisk* getFdd() const;
	void setFdd(CVmFloppyDisk* pFloppyDisks);


	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmHardware* pCur, CVmHardware* pPrev, MergeOptions nOptions);

	void diff(const CVmHardware* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:


	void Copy(const CVmHardware& rObject);

};



#endif
