////////////////////////////////////////////////////////////////////////////////
///
/// CVmHostSharing.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMHOSTSHARING_H
#define CVMHOSTSHARING_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmSharedFolder.h"


class CVmHostSharing : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmHostSharing();
	CVmHostSharing(const CVmHostSharing& rObject);
	CVmHostSharing(const CVmHostSharing* pObject);
	CVmHostSharing(QFile* pFile);
	CVmHostSharing& operator=(const CVmHostSharing& rObject);
	virtual ~CVmHostSharing();


    // Add shared folder to the list
    void addSharedFolder(CVmSharedFolder* item);

	QList<CVmSharedFolder* >		m_lstSharedFolders;


	bool isEnabled() const;
	void setEnabled(bool value = false);

	bool isShareAllMacDisks() const;
	void setShareAllMacDisks(bool value = false);

	bool isShareUserHomeDir() const;
	void setShareUserHomeDir(bool value = false);

	bool isMapSharedFoldersOnLetters() const;
	void setMapSharedFoldersOnLetters(bool value = true);

	bool isUserDefinedFoldersEnabled() const;
	void setUserDefinedFoldersEnabled(bool value = false);

	bool isSetExecBitForFiles() const;
	void setSetExecBitForFiles(bool value = false);

	bool isVirtualLinks() const;
	void setVirtualLinks(bool value = false);

	bool isEnableDos8dot3Names() const;
	void setEnableDos8dot3Names(bool value = true);

	bool isSharedCloud() const;
	void setSharedCloud(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getEnabled_id() const;
	QString getShareAllMacDisks_id() const;
	QString getShareUserHomeDir_id() const;
	QString getMapSharedFoldersOnLetters_id() const;
	QString getUserDefinedFoldersEnabled_id() const;
	QString getSetExecBitForFiles_id() const;
	QString getVirtualLinks_id() const;
	QString getEnableDos8dot3Names_id() const;
	QString getSharedCloud_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmHostSharing* pCur, CVmHostSharing* pPrev, MergeOptions nOptions);

	void diff(const CVmHostSharing* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	bool		m_bEnabled;
	bool		m_bShareAllMacDisks;
	bool		m_bShareUserHomeDir;
	bool		m_bMapSharedFoldersOnLetters;
	bool		m_bUserDefinedFoldersEnabled;
	bool		m_bSetExecBitForFiles;
	bool		m_bVirtualLinks;
	bool		m_bEnableDos8dot3Names;
	bool		m_bSharedCloud;

	void Copy(const CVmHostSharing& rObject);

signals:

	void signalEnabledChanged(bool value, QString object_id = QString());
	void signalShareAllMacDisksChanged(bool value, QString object_id = QString());
	void signalShareUserHomeDirChanged(bool value, QString object_id = QString());
	void signalMapSharedFoldersOnLettersChanged(bool value, QString object_id = QString());
	void signalUserDefinedFoldersEnabledChanged(bool value, QString object_id = QString());
	void signalSetExecBitForFilesChanged(bool value, QString object_id = QString());
	void signalVirtualLinksChanged(bool value, QString object_id = QString());
	void signalEnableDos8dot3NamesChanged(bool value, QString object_id = QString());
	void signalSharedCloudChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeEnabled(bool value);
	void slotChangeShareAllMacDisks(bool value);
	void slotChangeShareUserHomeDir(bool value);
	void slotChangeMapSharedFoldersOnLetters(bool value);
	void slotChangeUserDefinedFoldersEnabled(bool value);
	void slotChangeSetExecBitForFiles(bool value);
	void slotChangeVirtualLinks(bool value);
	void slotChangeEnableDos8dot3Names(bool value);
	void slotChangeSharedCloud(bool value);

};



#endif
