////////////////////////////////////////////////////////////////////////////////
///
/// CVmIdentification.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMIDENTIFICATION_H
#define CVMIDENTIFICATION_H


#include <prlcommon/PrlObjects/CBaseNode.h>


class CVmIdentification : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmIdentification();
	CVmIdentification(const CVmIdentification& rObject);
	CVmIdentification(const CVmIdentification* pObject);
	CVmIdentification(QFile* pFile);
	CVmIdentification& operator=(const CVmIdentification& rObject);
	virtual ~CVmIdentification();




	QString getVmUuid() const;
	void setVmUuid(QString value = QString());

	QString getSourceVmUuid() const;
	void setSourceVmUuid(QString value = QString());

	QString getLinkedVmUuid() const;
	void setLinkedVmUuid(QString value = QString());

	QString getVmName() const;
	void setVmName(QString value = QString());

	QString getServerUuid() const;
	void setServerUuid(QString value = QString());

	QString getLastServerUuid() const;
	void setLastServerUuid(QString value = QString());

	QString getServerHost() const;
	void setServerHost(QString value = QString());

	QString getHomePath() const;
	void setHomePath(QString value = QString());

	PRL_VM_LOCATION getVmFilesLocation() const;
	void setVmFilesLocation(PRL_VM_LOCATION value = PVL_UNKNOWN);

	QString getModifierName() const;
	void setModifierName(QString value = QString());

	QDateTime getLastModifDate() const;
	void setLastModifDate(QDateTime value = QDateTime::currentDateTime());

	QDateTime getCreationDate() const;
	void setCreationDate(QDateTime value = QDateTime::currentDateTime());

	QDateTime getVmUptimeStartDateTime() const;
	void setVmUptimeStartDateTime(QDateTime value = QDateTime::currentDateTime().toUTC());

	quint64 getVmUptimeInSeconds() const;
	void setVmUptimeInSeconds(quint64 value = 0);

	unsigned int getEnvId() const;
	void setEnvId(unsigned int value = 0);

	QString getCtId() const;
	void setCtId(QString value = QString());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getVmUuid_id() const;
	QString getSourceVmUuid_id() const;
	QString getLinkedVmUuid_id() const;
	QString getVmName_id() const;
	QString getServerUuid_id() const;
	QString getLastServerUuid_id() const;
	QString getServerHost_id() const;
	QString getHomePath_id() const;
	QString getVmFilesLocation_id() const;
	QString getModifierName_id() const;
	QString getLastModifDate_id() const;
	QString getCreationDate_id() const;
	QString getVmUptimeStartDateTime_id() const;
	QString getVmUptimeInSeconds_id() const;
	QString getEnvId_id() const;
	QString getCtId_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmIdentification* pCur, CVmIdentification* pPrev, MergeOptions nOptions);

	void diff(const CVmIdentification* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsVmUuid;
	QString		m_qsSourceVmUuid;
	QString		m_qsLinkedVmUuid;
	QString		m_qsVmName;
	QString		m_qsServerUuid;
	QString		m_qsLastServerUuid;
	QString		m_qsServerHost;
	QString		m_qsVmHome;
	PRL_VM_LOCATION		m_ctVmFilesLocation;
	QString		m_qsChangedBy;
	QDateTime		m_dtChangeDateTime;
	QDateTime		m_dtVmCreationDate;
	QDateTime		m_dtVmUptimeStartDateTime;
	quint64		m_ctVmUptimeInSeconds;
	unsigned int		m_uiEnvId;
	QString		m_qsCtId;

	void Copy(const CVmIdentification& rObject);

signals:

	void signalVmUuidChanged(QString value, QString object_id = QString());
	void signalSourceVmUuidChanged(QString value, QString object_id = QString());
	void signalLinkedVmUuidChanged(QString value, QString object_id = QString());
	void signalVmNameChanged(QString value, QString object_id = QString());
	void signalServerUuidChanged(QString value, QString object_id = QString());
	void signalLastServerUuidChanged(QString value, QString object_id = QString());
	void signalServerHostChanged(QString value, QString object_id = QString());
	void signalHomePathChanged(QString value, QString object_id = QString());
	void signalVmFilesLocationChanged(PRL_VM_LOCATION value, QString object_id = QString());
	void signalModifierNameChanged(QString value, QString object_id = QString());
	void signalLastModifDateChanged(QDateTime value, QString object_id = QString());
	void signalCreationDateChanged(QDateTime value, QString object_id = QString());
	void signalVmUptimeStartDateTimeChanged(QDateTime value, QString object_id = QString());
	void signalVmUptimeInSecondsChanged(quint64 value, QString object_id = QString());
	void signalEnvIdChanged(unsigned int value, QString object_id = QString());
	void signalCtIdChanged(QString value, QString object_id = QString());

private slots:

	void slotChangeVmUuid(QString value);
	void slotChangeSourceVmUuid(QString value);
	void slotChangeLinkedVmUuid(QString value);
	void slotChangeVmName(QString value);
	void slotChangeServerUuid(QString value);
	void slotChangeLastServerUuid(QString value);
	void slotChangeServerHost(QString value);
	void slotChangeHomePath(QString value);
	void slotChangeVmFilesLocation(PRL_VM_LOCATION value);
	void slotChangeModifierName(QString value);
	void slotChangeLastModifDate(QDateTime value);
	void slotChangeCreationDate(QDateTime value);
	void slotChangeVmUptimeStartDateTime(QDateTime value);
	void slotChangeVmUptimeInSeconds(quint64 value);
	void slotChangeEnvId(unsigned int value);
	void slotChangeCtId(QString value);

};

#ifndef DM_132234206
#define DM_132234206
Q_DECLARE_METATYPE(PRL_VM_LOCATION)
#endif
#ifndef DM_146823028
#define DM_146823028
Q_DECLARE_METATYPE(quint64)
#endif


#endif
