////////////////////////////////////////////////////////////////////////////////
///
/// CVmNetFirewall.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmNetFirewall.h"


CVmNetFirewall::CVmNetFirewall()
{
	InitLists();
	setDefaults();
}

CVmNetFirewall::CVmNetFirewall(const CVmNetFirewall& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmNetFirewall::CVmNetFirewall(const CVmNetFirewall* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmNetFirewall& CVmNetFirewall::operator=(const CVmNetFirewall& rObject)
{
	Copy(rObject);
	return *this;
}

CVmNetFirewall::CVmNetFirewall(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmNetFirewall::~CVmNetFirewall()
{
	ClearLists();
}


CVmNetFirewallIncoming* CVmNetFirewall::getIncoming() const
{
	if (!m_lstIncoming.isEmpty())
	{
		return m_lstIncoming[0];
	}
	return 0;
}

void CVmNetFirewall::setIncoming(CVmNetFirewallIncoming* pIncoming)
{
	ClearList<CVmNetFirewallIncoming>(m_lstIncoming);
	if (pIncoming)
	{
		m_lstIncoming += pIncoming;
	}
}

CVmNetFirewallOutgoing* CVmNetFirewall::getOutgoing() const
{
	if (!m_lstOutgoing.isEmpty())
	{
		return m_lstOutgoing[0];
	}
	return 0;
}

void CVmNetFirewall::setOutgoing(CVmNetFirewallOutgoing* pOutgoing)
{
	ClearList<CVmNetFirewallOutgoing>(m_lstOutgoing);
	if (pOutgoing)
	{
		m_lstOutgoing += pOutgoing;
	}
}

bool CVmNetFirewall::isEnabled() const
{
	return m_bEnabled;
}

void CVmNetFirewall::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void CVmNetFirewall::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

void CVmNetFirewall::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
}

QVariant CVmNetFirewall::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	list_tag = "Incoming.";
	if (path.startsWith(list_tag) && ! m_lstIncoming.isEmpty() && m_lstIncoming.first())
		return m_lstIncoming.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "Outgoing.";
	if (path.startsWith(list_tag) && ! m_lstOutgoing.isEmpty() && m_lstOutgoing.first())
		return m_lstOutgoing.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmNetFirewall::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	list_tag = "Incoming.";
	if (path.startsWith(list_tag) && ! m_lstIncoming.isEmpty() && m_lstIncoming.first())
		return m_lstIncoming.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "Outgoing.";
	if (path.startsWith(list_tag) && ! m_lstOutgoing.isEmpty() && m_lstOutgoing.first())
		return m_lstOutgoing.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmNetFirewall::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}

int CVmNetFirewall::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Incoming.";
	if (path.startsWith(list_tag) && ! m_lstIncoming.isEmpty() && m_lstIncoming.first())
		return m_lstIncoming.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "Outgoing.";
	if (path.startsWith(list_tag) && ! m_lstOutgoing.isEmpty() && m_lstOutgoing.first())
		return m_lstOutgoing.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmNetFirewall::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "Incoming.";
	if (path.startsWith(list_tag) && ! m_lstIncoming.isEmpty() && m_lstIncoming.first())
		return m_lstIncoming.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "Outgoing.";
	if (path.startsWith(list_tag) && ! m_lstOutgoing.isEmpty() && m_lstOutgoing.first())
		return m_lstOutgoing.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmNetFirewall::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Firewall") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstIncoming.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmNetFirewallIncoming* object = m_lstIncoming[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstOutgoing.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmNetFirewallOutgoing* object = m_lstOutgoing[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmNetFirewall::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Firewall") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmNetFirewall': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Incoming_count = 1;
	int Outgoing_count = 1;
	int Enabled_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		if (tag_name == "Incoming" && Incoming_count > 0)
		{
			unused_tag = false;
			CVmNetFirewallIncoming* object = m_lstIncoming[1 - Incoming_count];
			object->makeFullItemId(getFullItemId(), "Incoming");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Incoming_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "Outgoing" && Outgoing_count > 0)
		{
			unused_tag = false;
			CVmNetFirewallOutgoing* object = m_lstOutgoing[1 - Outgoing_count];
			object->makeFullItemId(getFullItemId(), "Outgoing");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--Outgoing_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Incoming_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmNetFirewall': tag 'Incoming' is absent";
	}

	if (Outgoing_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmNetFirewall': tag 'Outgoing' is absent";
	}

	if (Enabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmNetFirewall': tag 'Enabled' is absent";
	}



	return 0;
}

void CVmNetFirewall::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstIncoming.size(); ++i)
	{
		CVmNetFirewallIncoming* object = m_lstIncoming[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Incoming");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstOutgoing.size(); ++i)
	{
		CVmNetFirewallOutgoing* object = m_lstOutgoing[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "Outgoing");
		object->syncItemIds();
	}

}

bool CVmNetFirewall::merge(CVmNetFirewall* pCur, CVmNetFirewall* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Firewall";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	for(i = 0; i < m_lstIncoming.size(); i++)
	{
		if ( m_lstIncoming[i]->merge(pCur->m_lstIncoming[i], pPrev->m_lstIncoming[i], nOptions) ) continue;
		QString qsIdx = (m_lstIncoming.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstIncoming[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstOutgoing.size(); i++)
	{
		if ( m_lstOutgoing[i]->merge(pCur->m_lstOutgoing[i], pPrev->m_lstOutgoing[i], nOptions) ) continue;
		QString qsIdx = (m_lstOutgoing.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstOutgoing[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmNetFirewall::diff(const CVmNetFirewall* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	for(i = 0; i < m_lstIncoming.size(); ++i)
		m_lstIncoming[i]->diff(pOld->m_lstIncoming[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstOutgoing.size(); ++i)
		m_lstOutgoing[i]->diff(pOld->m_lstOutgoing[i], lstDiffFullItemIds);

}

void CVmNetFirewall::Copy(const CVmNetFirewall& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());

	ClearList<CVmNetFirewallIncoming >(m_lstIncoming);
	for(i = 0; i < rObject.m_lstIncoming.size(); i++)
		m_lstIncoming += new CVmNetFirewallIncoming(rObject.m_lstIncoming[i]);

	ClearList<CVmNetFirewallOutgoing >(m_lstOutgoing);
	for(i = 0; i < rObject.m_lstOutgoing.size(); i++)
		m_lstOutgoing += new CVmNetFirewallOutgoing(rObject.m_lstOutgoing[i]);

	CustomCopy(&rObject);

}

void CVmNetFirewall::InitLists()
{
	InitList<CVmNetFirewallIncoming>(1, m_lstIncoming);
	InitList<CVmNetFirewallOutgoing>(1, m_lstOutgoing);
	CustomInit();
}

void CVmNetFirewall::ClearLists()
{
	ClearList<CVmNetFirewallIncoming>(m_lstIncoming);
	ClearList<CVmNetFirewallOutgoing>(m_lstOutgoing);
}

void CVmNetFirewall::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstIncoming.size() && ! unite_with_loaded; i++)
	{
		m_lstIncoming[i]->ClearListsInReadXml();
		m_lstIncoming[i]->setDefaults();
		m_lstIncoming[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstOutgoing.size() && ! unite_with_loaded; i++)
	{
		m_lstOutgoing[i]->ClearListsInReadXml();
		m_lstOutgoing[i]->setDefaults();
		m_lstOutgoing[i]->setSectionFakeFlag(true);
	}
}

