////////////////////////////////////////////////////////////////////////////////
///
/// CVmNetworkRates.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmNetworkRates.h"


CVmNetworkRates::CVmNetworkRates()
{
	InitLists();
	setDefaults();
}

CVmNetworkRates::CVmNetworkRates(const CVmNetworkRates& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmNetworkRates::CVmNetworkRates(const CVmNetworkRates* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmNetworkRates& CVmNetworkRates::operator=(const CVmNetworkRates& rObject)
{
	Copy(rObject);
	return *this;
}

CVmNetworkRates::CVmNetworkRates(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmNetworkRates::~CVmNetworkRates()
{
	ClearLists();
}


bool CVmNetworkRates::isRateBound() const
{
	return m_bRateBound;
}

void CVmNetworkRates::setRateBound(bool value)
{
	bool bValueChanged = (m_bRateBound != value);
	m_bRateBound = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalRateBoundChanged(value);
	}
}

void CVmNetworkRates::slotChangeRateBound(bool value)
{
	setRateBound(value);
}

void CVmNetworkRates::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("RateBound").isNull() )
		setRateBound();
}

QVariant CVmNetworkRates::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "RateBound.patch_stamp")
		value.setValue(getFieldPatchedValue("RateBound"));

	if (path == "RateBound")
		value.setValue(isRateBound());

	list_tag = "NetworkRate[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i] && nItemId == m_lstNetworkRates[i]->getItemId())
				return m_lstNetworkRates[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("NetworkRate.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i] && nMaxId < m_lstNetworkRates[i]->getItemId())
				nMaxId = m_lstNetworkRates[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("NetworkRate.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i]) lstIds += m_lstNetworkRates[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmNetworkRates::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "RateBound.patch_stamp")
	{
		markPatchedField("RateBound", value.toString());
		return true;
	}

	if (path == "RateBound")
	{
		if (pbValueChanged)
			*pbValueChanged = (isRateBound() != value.value< bool >());
		setRateBound(value.value< bool >());
		return true;
	}

	list_tag = "NetworkRate[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i] && nItemId == m_lstNetworkRates[i]->getItemId())
				return m_lstNetworkRates[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVmNetworkRates::getRateBound_id() const
{
	return getFullItemId().isEmpty() ? "RateBound" : getFullItemId() + ".RateBound";
}

int CVmNetworkRates::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "NetworkRate")
	{
		m_lstNetworkRates += new CVmNetworkRate;
		nNewItemId = getMaxItemId<CVmNetworkRate>(m_lstNetworkRates, "NetworkRate");
		m_lstNetworkRates.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "NetworkRate");
	}

	list_tag = "NetworkRate[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i] && nItemId == m_lstNetworkRates[i]->getItemId())
				return m_lstNetworkRates[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmNetworkRates::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "NetworkRate[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstNetworkRates.size(); ++i)
			if (m_lstNetworkRates[i] && nItemId == m_lstNetworkRates[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstNetworkRates[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstNetworkRates.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmNetworkRates::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("NetworkRates") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("RateBound");
	text_element = Document->createTextNode( QString("%1").arg(isRateBound()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "NetworkRate";
	nMaxItemId = getMaxItemId<CVmNetworkRate>(m_lstNetworkRates, "NetworkRate", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkRates.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmNetworkRate* object = m_lstNetworkRates[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "NetworkRate", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmNetworkRates::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("NetworkRates") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmNetworkRates': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_NetworkRate = getMaxItemId2(element, "NetworkRate");
	QMap<int , QString > mapNetworkRate;
	if (unite_with_loaded)
		fillItemIdMap<CVmNetworkRate>(m_lstNetworkRates, mapNetworkRate);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int NetworkRates_count = 0;
	int RateBound_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "RateBound";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (RateBound_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "RateBound")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRateBound(text_element.data().toInt() != 0);
			--RateBound_count;
		}


		if (tag_name == "NetworkRate")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_NetworkRate++ : nItemId;
			CVmNetworkRate* object = new CVmNetworkRate();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "NetworkRate", object->getItemId());
			if (unite_with_loaded && mapNetworkRate.contains(nItemId))
				object->fromString(mapNetworkRate.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstNetworkRates += object;
			--NetworkRates_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (NetworkRates_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmNetworkRates': tag 'NetworkRate' is absent";
	}

	if (RateBound_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmNetworkRates': tag 'RateBound' is absent";
	}

	syncMaxItemId(nMaxItemId_NetworkRate, "NetworkRate");


	return 0;
}

void CVmNetworkRates::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CVmNetworkRate>(m_lstNetworkRates, "NetworkRate");
	setItemIds.clear();
	for(i = 0; i < m_lstNetworkRates.size(); ++i)
	{
		CVmNetworkRate* object = m_lstNetworkRates[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "NetworkRate", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "NetworkRate");

}

bool CVmNetworkRates::merge(CVmNetworkRates* pCur, CVmNetworkRates* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "NetworkRates";

	if (isRateBound() != pCur->isRateBound() && isRateBound() == pPrev->isRateBound())
		setRateBound(pCur->isRateBound());
	else if (isRateBound() != pCur->isRateBound() && isRateBound() != pPrev->isRateBound() && pCur->isRateBound() != pPrev->isRateBound())
	{
		m_qsErrorMessage += ".RateBound";
		return false;
	}

	if ( ! mergeList<CVmNetworkRate>(m_lstNetworkRates, pCur->m_lstNetworkRates, pPrev->m_lstNetworkRates, "NetworkRate", nOptions) )
		return false;

	return true;
}

void CVmNetworkRates::diff(const CVmNetworkRates* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isRateBound() != pOld->isRateBound())
		lstDiffFullItemIds += getRateBound_id();

	diffList<CVmNetworkRate>(m_lstNetworkRates, pOld->m_lstNetworkRates, lstDiffFullItemIds);

}

void CVmNetworkRates::Copy(const CVmNetworkRates& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setRateBound(rObject.isRateBound());

	ClearList<CVmNetworkRate >(m_lstNetworkRates);
	for(i = 0; i < rObject.m_lstNetworkRates.size(); i++)
		m_lstNetworkRates += new CVmNetworkRate(rObject.m_lstNetworkRates[i]);

	CustomCopy(&rObject);

}

void CVmNetworkRates::InitLists()
{
	CustomInit();
}

void CVmNetworkRates::ClearLists()
{
	ClearList<CVmNetworkRate>(m_lstNetworkRates);
}

void CVmNetworkRates::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("NetworkRate") )
		ClearList<CVmNetworkRate>(m_lstNetworkRates);
}

