////////////////////////////////////////////////////////////////////////////////
///
/// CVmProfile.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmProfile.h"


CVmProfile::CVmProfile()
{
	InitLists();
	setDefaults();
}

CVmProfile::CVmProfile(const CVmProfile& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmProfile::CVmProfile(const CVmProfile* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmProfile& CVmProfile::operator=(const CVmProfile& rObject)
{
	Copy(rObject);
	return *this;
}

CVmProfile::CVmProfile(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmProfile::~CVmProfile()
{
	ClearLists();
}


PRL_VIRTUAL_MACHINE_PROFILE CVmProfile::getType() const
{
	return m_ctType;
}

void CVmProfile::setType(PRL_VIRTUAL_MACHINE_PROFILE value)
{
	bool bValueChanged = (m_ctType != value);
	m_ctType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTypeChanged(value);
	}
}

void CVmProfile::slotChangeType(PRL_VIRTUAL_MACHINE_PROFILE value)
{
	setType(value);
}

bool CVmProfile::isCustom() const
{
	return m_bCustom;
}

void CVmProfile::setCustom(bool value)
{
	bool bValueChanged = (m_bCustom != value);
	m_bCustom = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCustomChanged(value);
	}
}

void CVmProfile::slotChangeCustom(bool value)
{
	setCustom(value);
}

void CVmProfile::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("Custom").isNull() )
		setCustom();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_VIRTUAL_MACHINE_PROFILE >("PRL_VIRTUAL_MACHINE_PROFILE");
		first_time = false;
	}

}

QVariant CVmProfile::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Type.patch_stamp")
		value.setValue(getFieldPatchedValue("Type"));

	if (path == "Type")
		value.setValue((qlonglong )getType());

	if (path == "Custom.patch_stamp")
		value.setValue(getFieldPatchedValue("Custom"));

	if (path == "Custom")
		value.setValue(isCustom());

	return value;
}

bool CVmProfile::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Type.patch_stamp")
	{
		markPatchedField("Type", value.toString());
		return true;
	}

	if (path == "Type")
	{
		if (pbValueChanged)
			*pbValueChanged = (getType() != (PRL_VIRTUAL_MACHINE_PROFILE )value.value< qlonglong >());
		setType((PRL_VIRTUAL_MACHINE_PROFILE )value.value< qlonglong >());
		return true;
	}

	if (path == "Custom.patch_stamp")
	{
		markPatchedField("Custom", value.toString());
		return true;
	}

	if (path == "Custom")
	{
		if (pbValueChanged)
			*pbValueChanged = (isCustom() != value.value< bool >());
		setCustom(value.value< bool >());
		return true;
	}

	return false;
}

QString CVmProfile::getType_id() const
{
	return getFullItemId().isEmpty() ? "Type" : getFullItemId() + ".Type";
}
QString CVmProfile::getCustom_id() const
{
	return getFullItemId().isEmpty() ? "Custom" : getFullItemId() + ".Custom";
}

int CVmProfile::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmProfile::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmProfile::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Profile") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Custom");
	text_element = Document->createTextNode( QString("%1").arg(isCustom()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmProfile::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Profile") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmProfile': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Type_count = 1;
	int Custom_count = 0;

	QString Custom_patch_stamp = RootElement->attribute("Custom_patch");
	if (unite_with_loaded && RootElement->firstChildElement("Custom").isNull())
		Custom_patch_stamp = getFieldPatchedValue("Custom");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType((PRL_VIRTUAL_MACHINE_PROFILE )text_element.data().toLongLong());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Custom";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Custom_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Custom")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCustom(text_element.data().toInt() != 0);
			--Custom_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmProfile': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Custom_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmProfile': tag 'Custom' is absent";
	}



	m_mapPatchedFields.insert("Custom", Custom_patch_stamp);


	return 0;
}

void CVmProfile::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmProfile::merge(CVmProfile* pCur, CVmProfile* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Profile";

	if (getType() != pCur->getType() && getType() == pPrev->getType())
		setType(pCur->getType());
	else if (getType() != pCur->getType() && getType() != pPrev->getType() && pCur->getType() != pPrev->getType())
	{
		m_qsErrorMessage += ".Type";
		return false;
	}

	if (isCustom() != pCur->isCustom() && isCustom() == pPrev->isCustom())
		setCustom(pCur->isCustom());
	else if (isCustom() != pCur->isCustom() && isCustom() != pPrev->isCustom() && pCur->isCustom() != pPrev->isCustom())
	{
		m_qsErrorMessage += ".Custom";
		return false;
	}

	return true;
}

void CVmProfile::diff(const CVmProfile* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getType() != pOld->getType())
		lstDiffFullItemIds += getType_id();

	if (isCustom() != pOld->isCustom())
		lstDiffFullItemIds += getCustom_id();

}

void CVmProfile::Copy(const CVmProfile& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setType(rObject.getType());
	setCustom(rObject.isCustom());

	CustomCopy(&rObject);

}

void CVmProfile::InitLists()
{
	CustomInit();
}

void CVmProfile::ClearLists()
{
}

void CVmProfile::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

