////////////////////////////////////////////////////////////////////////////////
///
/// CVmProtection.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmProtection.h"


CVmProtection::CVmProtection()
{
	InitLists();
	setDefaults();
}

CVmProtection::CVmProtection(const CVmProtection& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmProtection::CVmProtection(const CVmProtection* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmProtection& CVmProtection::operator=(const CVmProtection& rObject)
{
	Copy(rObject);
	return *this;
}

CVmProtection::CVmProtection(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmProtection::~CVmProtection()
{
	ClearLists();
}


CVmExpiration* CVmProtection::getExpirationInfo() const
{
	if (!m_lstExpirationInfo.isEmpty())
	{
		return m_lstExpirationInfo[0];
	}
	return 0;
}

void CVmProtection::setExpirationInfo(CVmExpiration* pExpirationInfo)
{
	ClearList<CVmExpiration>(m_lstExpirationInfo);
	if (pExpirationInfo)
	{
		m_lstExpirationInfo += pExpirationInfo;
	}
}

bool CVmProtection::isEnabled() const
{
	return m_bEnabled;
}

void CVmProtection::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void CVmProtection::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

QString CVmProtection::getProtectionReference() const
{
	return m_qsHash1;
}

void CVmProtection::setProtectionReference(QString value)
{
	bool bValueChanged = (m_qsHash1 != value);
	m_qsHash1 = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalProtectionReferenceChanged(value);
	}
}

void CVmProtection::slotChangeProtectionReference(QString value)
{
	setProtectionReference(value);
}

QString CVmProtection::getProtectionHash() const
{
	return m_qsHash2;
}

void CVmProtection::setProtectionHash(QString value)
{
	bool bValueChanged = (m_qsHash2 != value);
	m_qsHash2 = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalProtectionHashChanged(value);
	}
}

void CVmProtection::slotChangeProtectionHash(QString value)
{
	setProtectionHash(value);
}

QString CVmProtection::getExpirationStartDateHash() const
{
	return m_qsHash3;
}

void CVmProtection::setExpirationStartDateHash(QString value)
{
	bool bValueChanged = (m_qsHash3 != value);
	m_qsHash3 = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalExpirationStartDateHashChanged(value);
	}
}

void CVmProtection::slotChangeExpirationStartDateHash(QString value)
{
	setExpirationStartDateHash(value);
}

void CVmProtection::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Hash1").isNull() )
		setProtectionReference();
	if ( ! RootElement || ! RootElement->firstChildElement("Hash2").isNull() )
		setProtectionHash();
	if ( ! RootElement || ! RootElement->firstChildElement("Hash3").isNull() )
		setExpirationStartDateHash();
}

QVariant CVmProtection::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "Hash1.patch_stamp")
		value.setValue(getFieldPatchedValue("Hash1"));

	if (path == "Hash1")
		value.setValue(getProtectionReference());

	if (path == "Hash2.patch_stamp")
		value.setValue(getFieldPatchedValue("Hash2"));

	if (path == "Hash2")
		value.setValue(getProtectionHash());

	if (path == "Hash3.patch_stamp")
		value.setValue(getFieldPatchedValue("Hash3"));

	if (path == "Hash3")
		value.setValue(getExpirationStartDateHash());

	list_tag = "ExpirationInfo.";
	if (path.startsWith(list_tag) && ! m_lstExpirationInfo.isEmpty() && m_lstExpirationInfo.first())
		return m_lstExpirationInfo.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmProtection::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "Hash1.patch_stamp")
	{
		markPatchedField("Hash1", value.toString());
		return true;
	}

	if (path == "Hash1")
	{
		if (pbValueChanged)
			*pbValueChanged = (getProtectionReference() != value.value< QString >());
		setProtectionReference(value.value< QString >());
		return true;
	}

	if (path == "Hash2.patch_stamp")
	{
		markPatchedField("Hash2", value.toString());
		return true;
	}

	if (path == "Hash2")
	{
		if (pbValueChanged)
			*pbValueChanged = (getProtectionHash() != value.value< QString >());
		setProtectionHash(value.value< QString >());
		return true;
	}

	if (path == "Hash3.patch_stamp")
	{
		markPatchedField("Hash3", value.toString());
		return true;
	}

	if (path == "Hash3")
	{
		if (pbValueChanged)
			*pbValueChanged = (getExpirationStartDateHash() != value.value< QString >());
		setExpirationStartDateHash(value.value< QString >());
		return true;
	}

	list_tag = "ExpirationInfo.";
	if (path.startsWith(list_tag) && ! m_lstExpirationInfo.isEmpty() && m_lstExpirationInfo.first())
		return m_lstExpirationInfo.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmProtection::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmProtection::getProtectionReference_id() const
{
	return getFullItemId().isEmpty() ? "Hash1" : getFullItemId() + ".Hash1";
}
QString CVmProtection::getProtectionHash_id() const
{
	return getFullItemId().isEmpty() ? "Hash2" : getFullItemId() + ".Hash2";
}
QString CVmProtection::getExpirationStartDateHash_id() const
{
	return getFullItemId().isEmpty() ? "Hash3" : getFullItemId() + ".Hash3";
}

int CVmProtection::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ExpirationInfo.";
	if (path.startsWith(list_tag) && ! m_lstExpirationInfo.isEmpty() && m_lstExpirationInfo.first())
		return m_lstExpirationInfo.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmProtection::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ExpirationInfo.";
	if (path.startsWith(list_tag) && ! m_lstExpirationInfo.isEmpty() && m_lstExpirationInfo.first())
		return m_lstExpirationInfo.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmProtection::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VmProtectionInfo") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Hash1");
	text_element = Document->createTextNode( QString("%1").arg(getProtectionReference()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Hash2");
	text_element = Document->createTextNode( QString("%1").arg(getProtectionHash()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Hash3");
	text_element = Document->createTextNode( QString("%1").arg(getExpirationStartDateHash()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstExpirationInfo.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmExpiration* object = m_lstExpirationInfo[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmProtection::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VmProtectionInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmProtection': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int ExpirationInfo_count = 1;
	int Enabled_count = 1;
	int Hash1_count = 1;
	int Hash2_count = 1;
	int Hash3_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Hash1";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Hash1_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Hash1")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setProtectionReference(text_element.data());
			--Hash1_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Hash2";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Hash2_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Hash2")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setProtectionHash(text_element.data());
			--Hash2_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Hash3";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Hash3_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Hash3")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setExpirationStartDateHash(text_element.data());
			--Hash3_count;
		}


		if (tag_name == "ExpirationInfo" && ExpirationInfo_count > 0)
		{
			unused_tag = false;
			CVmExpiration* object = m_lstExpirationInfo[1 - ExpirationInfo_count];
			object->makeFullItemId(getFullItemId(), "ExpirationInfo");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--ExpirationInfo_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (ExpirationInfo_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmProtection': tag 'ExpirationInfo' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmProtection': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Hash1_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmProtection': tag 'Hash1' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Hash2_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmProtection': tag 'Hash2' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Hash3_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmProtection': tag 'Hash3' is absent";
	}



	return 0;
}

void CVmProtection::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstExpirationInfo.size(); ++i)
	{
		CVmExpiration* object = m_lstExpirationInfo[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "ExpirationInfo");
		object->syncItemIds();
	}

}

bool CVmProtection::merge(CVmProtection* pCur, CVmProtection* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "VmProtectionInfo";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getProtectionReference() != pCur->getProtectionReference() && getProtectionReference() == pPrev->getProtectionReference())
		setProtectionReference(pCur->getProtectionReference());
	else if (getProtectionReference() != pCur->getProtectionReference() && getProtectionReference() != pPrev->getProtectionReference() && pCur->getProtectionReference() != pPrev->getProtectionReference())
	{
		m_qsErrorMessage += ".Hash1";
		return false;
	}

	if (getProtectionHash() != pCur->getProtectionHash() && getProtectionHash() == pPrev->getProtectionHash())
		setProtectionHash(pCur->getProtectionHash());
	else if (getProtectionHash() != pCur->getProtectionHash() && getProtectionHash() != pPrev->getProtectionHash() && pCur->getProtectionHash() != pPrev->getProtectionHash())
	{
		m_qsErrorMessage += ".Hash2";
		return false;
	}

	if (getExpirationStartDateHash() != pCur->getExpirationStartDateHash() && getExpirationStartDateHash() == pPrev->getExpirationStartDateHash())
		setExpirationStartDateHash(pCur->getExpirationStartDateHash());
	else if (getExpirationStartDateHash() != pCur->getExpirationStartDateHash() && getExpirationStartDateHash() != pPrev->getExpirationStartDateHash() && pCur->getExpirationStartDateHash() != pPrev->getExpirationStartDateHash())
	{
		m_qsErrorMessage += ".Hash3";
		return false;
	}

	for(i = 0; i < m_lstExpirationInfo.size(); i++)
	{
		if ( m_lstExpirationInfo[i]->merge(pCur->m_lstExpirationInfo[i], pPrev->m_lstExpirationInfo[i], nOptions) ) continue;
		QString qsIdx = (m_lstExpirationInfo.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstExpirationInfo[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmProtection::diff(const CVmProtection* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getProtectionReference() != pOld->getProtectionReference())
		lstDiffFullItemIds += getProtectionReference_id();

	if (getProtectionHash() != pOld->getProtectionHash())
		lstDiffFullItemIds += getProtectionHash_id();

	if (getExpirationStartDateHash() != pOld->getExpirationStartDateHash())
		lstDiffFullItemIds += getExpirationStartDateHash_id();

	for(i = 0; i < m_lstExpirationInfo.size(); ++i)
		m_lstExpirationInfo[i]->diff(pOld->m_lstExpirationInfo[i], lstDiffFullItemIds);

}

void CVmProtection::Copy(const CVmProtection& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());
	setProtectionReference(rObject.getProtectionReference());
	setProtectionHash(rObject.getProtectionHash());
	setExpirationStartDateHash(rObject.getExpirationStartDateHash());

	ClearList<CVmExpiration >(m_lstExpirationInfo);
	for(i = 0; i < rObject.m_lstExpirationInfo.size(); i++)
		m_lstExpirationInfo += new CVmExpiration(rObject.m_lstExpirationInfo[i]);

	CustomCopy(&rObject);

}

void CVmProtection::InitLists()
{
	InitList<CVmExpiration>(1, m_lstExpirationInfo);
	CustomInit();
}

void CVmProtection::ClearLists()
{
	ClearList<CVmExpiration>(m_lstExpirationInfo);
}

void CVmProtection::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstExpirationInfo.size() && ! unite_with_loaded; i++)
	{
		m_lstExpirationInfo[i]->ClearListsInReadXml();
		m_lstExpirationInfo[i]->setDefaults();
		m_lstExpirationInfo[i]->setSectionFakeFlag(true);
	}
}

