////////////////////////////////////////////////////////////////////////////////
///
/// CVmRunTimeOptions.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmRunTimeOptions.h"


CVmRunTimeOptions::CVmRunTimeOptions()
{
	InitLists();
	setDefaults();
}

CVmRunTimeOptions::CVmRunTimeOptions(const CVmRunTimeOptions& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmRunTimeOptions::CVmRunTimeOptions(const CVmRunTimeOptions* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmRunTimeOptions& CVmRunTimeOptions::operator=(const CVmRunTimeOptions& rObject)
{
	Copy(rObject);
	return *this;
}

CVmRunTimeOptions::CVmRunTimeOptions(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmRunTimeOptions::~CVmRunTimeOptions()
{
	ClearLists();
}


bool CVmRunTimeOptions::isOptimizeForVM() const
{
	// Right now DiskCachePolicy config option represents the whole class of
	// optimizations for VM (historical reasons)
	return getDiskCachePolicy() == PVE::DiskCacheWritebackEnabled;
}

PRL_UNDO_DISKS_MODE CVmRunTimeOptions::getUndoDisksModeEx() const
{
    return isSafeMode() ? PUD_PROMPT_BEHAVIOUR : getUndoDisksMode();
}
void CVmRunTimeOptions::CustomInit()
{
	getVmFullScreen()->setCornerAction(PWC_TOP_LEFT_CORNER, PCA_WINDOWED);
}

CVmIoLimit* CVmRunTimeOptions::getIoLimit() const
{
	if (!m_lstIoLimit.isEmpty())
	{
		return m_lstIoLimit[0];
	}
	return 0;
}

void CVmRunTimeOptions::setIoLimit(CVmIoLimit* pIoLimit)
{
	ClearList<CVmIoLimit>(m_lstIoLimit);
	if (pIoLimit)
	{
		m_lstIoLimit += pIoLimit;
	}
}

CVmOnCrash* CVmRunTimeOptions::getOnCrash() const
{
	if (!m_lstOnCrash.isEmpty())
	{
		return m_lstOnCrash[0];
	}
	return 0;
}

void CVmRunTimeOptions::setOnCrash(CVmOnCrash* pOnCrash)
{
	ClearList<CVmOnCrash>(m_lstOnCrash);
	if (pOnCrash)
	{
		m_lstOnCrash += pOnCrash;
	}
}

CVmFullScreen* CVmRunTimeOptions::getVmFullScreen() const
{
	if (!m_lstFullScreen.isEmpty())
	{
		return m_lstFullScreen[0];
	}
	return 0;
}

void CVmRunTimeOptions::setVmFullScreen(CVmFullScreen* pFullScreen)
{
	ClearList<CVmFullScreen>(m_lstFullScreen);
	if (pFullScreen)
	{
		m_lstFullScreen += pFullScreen;
	}
}

InternalVmInfo* CVmRunTimeOptions::getInternalVmInfo() const
{
	if (!m_lstInternalVmInfo.isEmpty())
	{
		return m_lstInternalVmInfo[0];
	}
	return 0;
}

void CVmRunTimeOptions::setInternalVmInfo(InternalVmInfo* pInternalVmInfo)
{
	ClearList<InternalVmInfo>(m_lstInternalVmInfo);
	if (pInternalVmInfo)
	{
		m_lstInternalVmInfo += pInternalVmInfo;
	}
}

PRL_VM_PRIORITY CVmRunTimeOptions::getForegroundPriority() const
{
	return m_ctForegroundPriority;
}

void CVmRunTimeOptions::setForegroundPriority(PRL_VM_PRIORITY value)
{
	bool bValueChanged = (m_ctForegroundPriority != value);
	m_ctForegroundPriority = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalForegroundPriorityChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeForegroundPriority(PRL_VM_PRIORITY value)
{
	setForegroundPriority(value);
}

PRL_VM_PRIORITY CVmRunTimeOptions::getBackgroundPriority() const
{
	return m_ctBackgroundPriority;
}

void CVmRunTimeOptions::setBackgroundPriority(PRL_VM_PRIORITY value)
{
	bool bValueChanged = (m_ctBackgroundPriority != value);
	m_ctBackgroundPriority = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalBackgroundPriorityChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeBackgroundPriority(PRL_VM_PRIORITY value)
{
	setBackgroundPriority(value);
}

unsigned int CVmRunTimeOptions::getIoPriority() const
{
	return m_uiIoPriority;
}

void CVmRunTimeOptions::setIoPriority(unsigned int value)
{
	bool bValueChanged = (m_uiIoPriority != value);
	m_uiIoPriority = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalIoPriorityChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeIoPriority(unsigned int value)
{
	setIoPriority(value);
}

unsigned int CVmRunTimeOptions::getIopsLimit() const
{
	return m_uiIopsLimit;
}

void CVmRunTimeOptions::setIopsLimit(unsigned int value)
{
	bool bValueChanged = (m_uiIopsLimit != value);
	m_uiIopsLimit = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalIopsLimitChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeIopsLimit(unsigned int value)
{
	setIopsLimit(value);
}

PVE::DiskCacheWritebackOption CVmRunTimeOptions::getDiskCachePolicy() const
{
	return m_ctDiskCachePolicy;
}

void CVmRunTimeOptions::setDiskCachePolicy(PVE::DiskCacheWritebackOption value)
{
	bool bValueChanged = (m_ctDiskCachePolicy != value);
	m_ctDiskCachePolicy = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDiskCachePolicyChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeDiskCachePolicy(PVE::DiskCacheWritebackOption value)
{
	setDiskCachePolicy(value);
}

bool CVmRunTimeOptions::isCloseAppOnShutdown() const
{
	return m_bCloseAppOnShutdown;
}

void CVmRunTimeOptions::setCloseAppOnShutdown(bool value)
{
	bool bValueChanged = (m_bCloseAppOnShutdown != value);
	m_bCloseAppOnShutdown = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCloseAppOnShutdownChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeCloseAppOnShutdown(bool value)
{
	setCloseAppOnShutdown(value);
}

PRL_VM_ACTION_ON_STOP CVmRunTimeOptions::getActionOnStop() const
{
	return m_ctActionOnStop;
}

void CVmRunTimeOptions::setActionOnStop(PRL_VM_ACTION_ON_STOP value)
{
	bool bValueChanged = (m_ctActionOnStop != value);
	m_ctActionOnStop = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalActionOnStopChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeActionOnStop(PRL_VM_ACTION_ON_STOP value)
{
	setActionOnStop(value);
}

PRL_DOCK_ICON_TYPE CVmRunTimeOptions::getDockIconType() const
{
	return m_ctDockIcon;
}

void CVmRunTimeOptions::setDockIconType(PRL_DOCK_ICON_TYPE value)
{
	bool bValueChanged = (m_ctDockIcon != value);
	m_ctDockIcon = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDockIconTypeChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeDockIconType(PRL_DOCK_ICON_TYPE value)
{
	setDockIconType(value);
}

bool CVmRunTimeOptions::isOsResolutionInFullScreen() const
{
	return m_bOsResolutionInFullScreen;
}

void CVmRunTimeOptions::setOsResolutionInFullScreen(bool value)
{
	bool bValueChanged = (m_bOsResolutionInFullScreen != value);
	m_bOsResolutionInFullScreen = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOsResolutionInFullScreenChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeOsResolutionInFullScreen(bool value)
{
	setOsResolutionInFullScreen(value);
}

PRL_UNDO_DISKS_MODE CVmRunTimeOptions::getUndoDisksMode() const
{
	return m_ctUndoDisks;
}

void CVmRunTimeOptions::setUndoDisksMode(PRL_UNDO_DISKS_MODE value)
{
	bool bValueChanged = (m_ctUndoDisks != value);
	m_ctUndoDisks = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUndoDisksModeChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeUndoDisksMode(PRL_UNDO_DISKS_MODE value)
{
	setUndoDisksMode(value);
}

bool CVmRunTimeOptions::isSafeMode() const
{
	return m_bSafeMode;
}

void CVmRunTimeOptions::setSafeMode(bool value)
{
	bool bValueChanged = (m_bSafeMode != value);
	m_bSafeMode = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalSafeModeChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeSafeMode(bool value)
{
	setSafeMode(value);
}

QString CVmRunTimeOptions::getSystemFlags() const
{
	return m_qsSystemFlags;
}

void CVmRunTimeOptions::setSystemFlags(QString value)
{
	bool bValueChanged = (m_qsSystemFlags != value);
	m_qsSystemFlags = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalSystemFlagsChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeSystemFlags(QString value)
{
	setSystemFlags(value);
}

bool CVmRunTimeOptions::isDisableAPIC() const
{
	return m_bDisableAPIC;
}

void CVmRunTimeOptions::setDisableAPIC(bool value)
{
	bool bValueChanged = (m_bDisableAPIC != value);
	m_bDisableAPIC = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDisableAPICChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeDisableAPIC(bool value)
{
	setDisableAPIC(value);
}

PVE::OptimizePowerConsumptionMode CVmRunTimeOptions::getOptimizePowerConsumptionMode() const
{
	return m_ctOptimizePowerConsumptionMode;
}

void CVmRunTimeOptions::setOptimizePowerConsumptionMode(PVE::OptimizePowerConsumptionMode value)
{
	bool bValueChanged = (m_ctOptimizePowerConsumptionMode != value);
	m_ctOptimizePowerConsumptionMode = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOptimizePowerConsumptionModeChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeOptimizePowerConsumptionMode(PVE::OptimizePowerConsumptionMode value)
{
	setOptimizePowerConsumptionMode(value);
}

bool CVmRunTimeOptions::isShowBatteryStatus() const
{
	return m_bShowBatteryStatus;
}

void CVmRunTimeOptions::setShowBatteryStatus(bool value)
{
	bool bValueChanged = (m_bShowBatteryStatus != value);
	m_bShowBatteryStatus = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalShowBatteryStatusChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeShowBatteryStatus(bool value)
{
	setShowBatteryStatus(value);
}

bool CVmRunTimeOptions::isEnabled() const
{
	return m_bEnabled;
}

void CVmRunTimeOptions::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

bool CVmRunTimeOptions::isEnableAdaptiveHypervisor() const
{
	return m_bEnableAdaptiveHypervisor;
}

void CVmRunTimeOptions::setEnableAdaptiveHypervisor(bool value)
{
	bool bValueChanged = (m_bEnableAdaptiveHypervisor != value);
	m_bEnableAdaptiveHypervisor = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnableAdaptiveHypervisorChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEnableAdaptiveHypervisor(bool value)
{
	setEnableAdaptiveHypervisor(value);
}

bool CVmRunTimeOptions::isUseSMBiosData() const
{
	return m_bUseSMBiosData;
}

void CVmRunTimeOptions::setUseSMBiosData(bool value)
{
	bool bValueChanged = (m_bUseSMBiosData != value);
	m_bUseSMBiosData = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUseSMBiosDataChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeUseSMBiosData(bool value)
{
	setUseSMBiosData(value);
}

bool CVmRunTimeOptions::isDisableSpeaker() const
{
	return m_bDisableSpeaker;
}

void CVmRunTimeOptions::setDisableSpeaker(bool value)
{
	bool bValueChanged = (m_bDisableSpeaker != value);
	m_bDisableSpeaker = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDisableSpeakerChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeDisableSpeaker(bool value)
{
	setDisableSpeaker(value);
}

bool CVmRunTimeOptions::isHideBiosOnStartEnabled() const
{
	return m_bHideBiosOnStartEnabled;
}

void CVmRunTimeOptions::setHideBiosOnStartEnabled(bool value)
{
	bool bValueChanged = (m_bHideBiosOnStartEnabled != value);
	m_bHideBiosOnStartEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalHideBiosOnStartEnabledChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeHideBiosOnStartEnabled(bool value)
{
	setHideBiosOnStartEnabled(value);
}

bool CVmRunTimeOptions::isUseDefaultAnswers() const
{
	return m_bUseDefaultAnswers;
}

void CVmRunTimeOptions::setUseDefaultAnswers(bool value)
{
	bool bValueChanged = (m_bUseDefaultAnswers != value);
	m_bUseDefaultAnswers = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUseDefaultAnswersChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeUseDefaultAnswers(bool value)
{
	setUseDefaultAnswers(value);
}

unsigned int CVmRunTimeOptions::getCompactHddMask() const
{
	return m_uiCompactHddMask;
}

void CVmRunTimeOptions::setCompactHddMask(unsigned int value)
{
	bool bValueChanged = (m_uiCompactHddMask != value);
	m_uiCompactHddMask = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCompactHddMaskChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeCompactHddMask(unsigned int value)
{
	setCompactHddMask(value);
}

bool CVmRunTimeOptions::isCompactMode() const
{
	return m_bCompactMode;
}

void CVmRunTimeOptions::setCompactMode(bool value)
{
	bool bValueChanged = (m_bCompactMode != value);
	m_bCompactMode = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCompactModeChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeCompactMode(bool value)
{
	setCompactMode(value);
}

bool CVmRunTimeOptions::isDisableWin7Logo() const
{
	return m_bDisableWin7Logo;
}

void CVmRunTimeOptions::setDisableWin7Logo(bool value)
{
	bool bValueChanged = (m_bDisableWin7Logo != value);
	m_bDisableWin7Logo = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDisableWin7LogoChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeDisableWin7Logo(bool value)
{
	setDisableWin7Logo(value);
}

PRL_OPTIMIZE_MODIFIERS_MODE CVmRunTimeOptions::getOptimizeModifiers() const
{
	return m_ctOptimizeModifiers;
}

void CVmRunTimeOptions::setOptimizeModifiers(PRL_OPTIMIZE_MODIFIERS_MODE value)
{
	bool bValueChanged = (m_ctOptimizeModifiers != value);
	m_ctOptimizeModifiers = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOptimizeModifiersChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeOptimizeModifiers(PRL_OPTIMIZE_MODIFIERS_MODE value)
{
	setOptimizeModifiers(value);
}

bool CVmRunTimeOptions::isStickyMouse() const
{
	return m_bStickyMouse;
}

void CVmRunTimeOptions::setStickyMouse(bool value)
{
	bool bValueChanged = (m_bStickyMouse != value);
	m_bStickyMouse = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalStickyMouseChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeStickyMouse(bool value)
{
	setStickyMouse(value);
}

bool CVmRunTimeOptions::isPauseOnDeactivation() const
{
	return m_bPauseOnDeactivation;
}

void CVmRunTimeOptions::setPauseOnDeactivation(bool value)
{
	bool bValueChanged = (m_bPauseOnDeactivation != value);
	m_bPauseOnDeactivation = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalPauseOnDeactivationChanged(value);
	}
}

void CVmRunTimeOptions::slotChangePauseOnDeactivation(bool value)
{
	setPauseOnDeactivation(value);
}

unsigned int CVmRunTimeOptions::getFEATURES_MASK() const
{
	return m_uiFEATURES_MASK;
}

void CVmRunTimeOptions::setFEATURES_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiFEATURES_MASK != value);
	m_uiFEATURES_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalFEATURES_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeFEATURES_MASK(unsigned int value)
{
	setFEATURES_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_FEATURES_MASK() const
{
	return m_uiEXT_FEATURES_MASK;
}

void CVmRunTimeOptions::setEXT_FEATURES_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_FEATURES_MASK != value);
	m_uiEXT_FEATURES_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_FEATURES_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_FEATURES_MASK(unsigned int value)
{
	setEXT_FEATURES_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_80000001_ECX_MASK() const
{
	return m_uiEXT_80000001_ECX_MASK;
}

void CVmRunTimeOptions::setEXT_80000001_ECX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_80000001_ECX_MASK != value);
	m_uiEXT_80000001_ECX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_80000001_ECX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_80000001_ECX_MASK(unsigned int value)
{
	setEXT_80000001_ECX_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_80000001_EDX_MASK() const
{
	return m_uiEXT_80000001_EDX_MASK;
}

void CVmRunTimeOptions::setEXT_80000001_EDX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_80000001_EDX_MASK != value);
	m_uiEXT_80000001_EDX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_80000001_EDX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_80000001_EDX_MASK(unsigned int value)
{
	setEXT_80000001_EDX_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_80000007_EDX_MASK() const
{
	return m_uiEXT_80000007_EDX_MASK;
}

void CVmRunTimeOptions::setEXT_80000007_EDX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_80000007_EDX_MASK != value);
	m_uiEXT_80000007_EDX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_80000007_EDX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_80000007_EDX_MASK(unsigned int value)
{
	setEXT_80000007_EDX_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_80000008_EAX() const
{
	return m_uiEXT_80000008_EAX;
}

void CVmRunTimeOptions::setEXT_80000008_EAX(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_80000008_EAX != value);
	m_uiEXT_80000008_EAX = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_80000008_EAXChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_80000008_EAX(unsigned int value)
{
	setEXT_80000008_EAX(value);
}

unsigned int CVmRunTimeOptions::getEXT_00000007_EBX_MASK() const
{
	return m_uiEXT_00000007_EBX_MASK;
}

void CVmRunTimeOptions::setEXT_00000007_EBX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_00000007_EBX_MASK != value);
	m_uiEXT_00000007_EBX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_00000007_EBX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_00000007_EBX_MASK(unsigned int value)
{
	setEXT_00000007_EBX_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_00000007_EDX_MASK() const
{
	return m_uiEXT_00000007_EDX_MASK;
}

void CVmRunTimeOptions::setEXT_00000007_EDX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_00000007_EDX_MASK != value);
	m_uiEXT_00000007_EDX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_00000007_EDX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_00000007_EDX_MASK(unsigned int value)
{
	setEXT_00000007_EDX_MASK(value);
}

unsigned int CVmRunTimeOptions::getEXT_0000000D_EAX_MASK() const
{
	return m_uiEXT_0000000D_EAX_MASK;
}

void CVmRunTimeOptions::setEXT_0000000D_EAX_MASK(unsigned int value)
{
	bool bValueChanged = (m_uiEXT_0000000D_EAX_MASK != value);
	m_uiEXT_0000000D_EAX_MASK = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEXT_0000000D_EAX_MASKChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeEXT_0000000D_EAX_MASK(unsigned int value)
{
	setEXT_0000000D_EAX_MASK(value);
}

bool CVmRunTimeOptions::isCpuFeaturesMaskValid() const
{
	return m_bCpuFeaturesMaskValid;
}

void CVmRunTimeOptions::setCpuFeaturesMaskValid(bool value)
{
	bool bValueChanged = (m_bCpuFeaturesMaskValid != value);
	m_bCpuFeaturesMaskValid = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCpuFeaturesMaskValidChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeCpuFeaturesMaskValid(bool value)
{
	setCpuFeaturesMaskValid(value);
}

QString CVmRunTimeOptions::getUnattendedInstallLocale() const
{
	return m_qsUnattendedInstallLocale;
}

void CVmRunTimeOptions::setUnattendedInstallLocale(QString value)
{
	bool bValueChanged = (m_qsUnattendedInstallLocale != value);
	m_qsUnattendedInstallLocale = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUnattendedInstallLocaleChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeUnattendedInstallLocale(QString value)
{
	setUnattendedInstallLocale(value);
}

QString CVmRunTimeOptions::getUnattendedInstallEdition() const
{
	return m_qsUnattendedInstallEdition;
}

void CVmRunTimeOptions::setUnattendedInstallEdition(QString value)
{
	bool bValueChanged = (m_qsUnattendedInstallEdition != value);
	m_qsUnattendedInstallEdition = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUnattendedInstallEditionChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeUnattendedInstallEdition(QString value)
{
	setUnattendedInstallEdition(value);
}

bool CVmRunTimeOptions::isHostRetinaEnabled() const
{
	return m_bHostRetinaEnabled;
}

void CVmRunTimeOptions::setHostRetinaEnabled(bool value)
{
	bool bValueChanged = (m_bHostRetinaEnabled != value);
	m_bHostRetinaEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalHostRetinaEnabledChanged(value);
	}
}

void CVmRunTimeOptions::slotChangeHostRetinaEnabled(bool value)
{
	setHostRetinaEnabled(value);
}

void CVmRunTimeOptions::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("ForegroundPriority").isNull() )
		setForegroundPriority();
	if ( ! RootElement || ! RootElement->firstChildElement("BackgroundPriority").isNull() )
		setBackgroundPriority();
	if ( ! RootElement || ! RootElement->firstChildElement("IoPriority").isNull() )
		setIoPriority();
	if ( ! RootElement || ! RootElement->firstChildElement("IopsLimit").isNull() )
		setIopsLimit();
	if ( ! RootElement || ! RootElement->firstChildElement("DiskCachePolicy").isNull() )
		setDiskCachePolicy();
	if ( ! RootElement || ! RootElement->firstChildElement("CloseAppOnShutdown").isNull() )
		setCloseAppOnShutdown();
	if ( ! RootElement || ! RootElement->firstChildElement("ActionOnStop").isNull() )
		setActionOnStop();
	if ( ! RootElement || ! RootElement->firstChildElement("DockIcon").isNull() )
		setDockIconType();
	if ( ! RootElement || ! RootElement->firstChildElement("OsResolutionInFullScreen").isNull() )
		setOsResolutionInFullScreen();
	if ( ! RootElement || ! RootElement->firstChildElement("UndoDisks").isNull() )
		setUndoDisksMode();
	if ( ! RootElement || ! RootElement->firstChildElement("SafeMode").isNull() )
		setSafeMode();
	if ( ! RootElement || ! RootElement->firstChildElement("SystemFlags").isNull() )
		setSystemFlags();
	if ( ! RootElement || ! RootElement->firstChildElement("DisableAPIC").isNull() )
		setDisableAPIC();
	if ( ! RootElement || ! RootElement->firstChildElement("OptimizePowerConsumptionMode").isNull() )
		setOptimizePowerConsumptionMode();
	if ( ! RootElement || ! RootElement->firstChildElement("ShowBatteryStatus").isNull() )
		setShowBatteryStatus();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("EnableAdaptiveHypervisor").isNull() )
		setEnableAdaptiveHypervisor();
	if ( ! RootElement || ! RootElement->firstChildElement("UseSMBiosData").isNull() )
		setUseSMBiosData();
	if ( ! RootElement || ! RootElement->firstChildElement("DisableSpeaker").isNull() )
		setDisableSpeaker();
	if ( ! RootElement || ! RootElement->firstChildElement("HideBiosOnStartEnabled").isNull() )
		setHideBiosOnStartEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("UseDefaultAnswers").isNull() )
		setUseDefaultAnswers();
	if ( ! RootElement || ! RootElement->firstChildElement("CompactHddMask").isNull() )
		setCompactHddMask();
	if ( ! RootElement || ! RootElement->firstChildElement("CompactMode").isNull() )
		setCompactMode();
	if ( ! RootElement || ! RootElement->firstChildElement("DisableWin7Logo").isNull() )
		setDisableWin7Logo();
	if ( ! RootElement || ! RootElement->firstChildElement("OptimizeModifiers").isNull() )
		setOptimizeModifiers();
	if ( ! RootElement || ! RootElement->firstChildElement("StickyMouse").isNull() )
		setStickyMouse();
	if ( ! RootElement || ! RootElement->firstChildElement("PauseOnDeactivation").isNull() )
		setPauseOnDeactivation();
	if ( ! RootElement || ! RootElement->firstChildElement("FEATURES_MASK").isNull() )
		setFEATURES_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_FEATURES_MASK").isNull() )
		setEXT_FEATURES_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_80000001_ECX_MASK").isNull() )
		setEXT_80000001_ECX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_80000001_EDX_MASK").isNull() )
		setEXT_80000001_EDX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_80000007_EDX_MASK").isNull() )
		setEXT_80000007_EDX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_80000008_EAX").isNull() )
		setEXT_80000008_EAX();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_00000007_EBX_MASK").isNull() )
		setEXT_00000007_EBX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_00000007_EDX_MASK").isNull() )
		setEXT_00000007_EDX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("EXT_0000000D_EAX_MASK").isNull() )
		setEXT_0000000D_EAX_MASK();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuFeaturesMaskValid").isNull() )
		setCpuFeaturesMaskValid();
	if ( ! RootElement || ! RootElement->firstChildElement("UnattendedInstallLocale").isNull() )
		setUnattendedInstallLocale();
	if ( ! RootElement || ! RootElement->firstChildElement("UnattendedInstallEdition").isNull() )
		setUnattendedInstallEdition();
	if ( ! RootElement || ! RootElement->firstChildElement("HostRetinaEnabled").isNull() )
		setHostRetinaEnabled();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_VM_PRIORITY >("PRL_VM_PRIORITY");
		qRegisterMetaType< PRL_VM_PRIORITY >("PRL_VM_PRIORITY");
		qRegisterMetaType< PVE::DiskCacheWritebackOption >("PVE::DiskCacheWritebackOption");
		qRegisterMetaType< PRL_VM_ACTION_ON_STOP >("PRL_VM_ACTION_ON_STOP");
		qRegisterMetaType< PRL_DOCK_ICON_TYPE >("PRL_DOCK_ICON_TYPE");
		qRegisterMetaType< PRL_UNDO_DISKS_MODE >("PRL_UNDO_DISKS_MODE");
		qRegisterMetaType< PVE::OptimizePowerConsumptionMode >("PVE::OptimizePowerConsumptionMode");
		qRegisterMetaType< PRL_OPTIMIZE_MODIFIERS_MODE >("PRL_OPTIMIZE_MODIFIERS_MODE");
		first_time = false;
	}

}

QVariant CVmRunTimeOptions::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "ForegroundPriority.patch_stamp")
		value.setValue(getFieldPatchedValue("ForegroundPriority"));

	if (path == "ForegroundPriority")
		value.setValue((qlonglong )getForegroundPriority());

	if (path == "BackgroundPriority.patch_stamp")
		value.setValue(getFieldPatchedValue("BackgroundPriority"));

	if (path == "BackgroundPriority")
		value.setValue((qlonglong )getBackgroundPriority());

	if (path == "IoPriority.patch_stamp")
		value.setValue(getFieldPatchedValue("IoPriority"));

	if (path == "IoPriority")
		value.setValue(getIoPriority());

	if (path == "IopsLimit.patch_stamp")
		value.setValue(getFieldPatchedValue("IopsLimit"));

	if (path == "IopsLimit")
		value.setValue(getIopsLimit());

	if (path == "DiskCachePolicy.patch_stamp")
		value.setValue(getFieldPatchedValue("DiskCachePolicy"));

	if (path == "DiskCachePolicy")
		value.setValue((qlonglong )getDiskCachePolicy());

	if (path == "CloseAppOnShutdown.patch_stamp")
		value.setValue(getFieldPatchedValue("CloseAppOnShutdown"));

	if (path == "CloseAppOnShutdown")
		value.setValue(isCloseAppOnShutdown());

	if (path == "ActionOnStop.patch_stamp")
		value.setValue(getFieldPatchedValue("ActionOnStop"));

	if (path == "ActionOnStop")
		value.setValue((qlonglong )getActionOnStop());

	if (path == "DockIcon.patch_stamp")
		value.setValue(getFieldPatchedValue("DockIcon"));

	if (path == "DockIcon")
		value.setValue((qlonglong )getDockIconType());

	if (path == "OsResolutionInFullScreen.patch_stamp")
		value.setValue(getFieldPatchedValue("OsResolutionInFullScreen"));

	if (path == "OsResolutionInFullScreen")
		value.setValue(isOsResolutionInFullScreen());

	if (path == "UndoDisks.patch_stamp")
		value.setValue(getFieldPatchedValue("UndoDisks"));

	if (path == "UndoDisks")
		value.setValue((qlonglong )getUndoDisksMode());

	if (path == "SafeMode.patch_stamp")
		value.setValue(getFieldPatchedValue("SafeMode"));

	if (path == "SafeMode")
		value.setValue(isSafeMode());

	if (path == "SystemFlags.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemFlags"));

	if (path == "SystemFlags")
		value.setValue(getSystemFlags());

	if (path == "DisableAPIC.patch_stamp")
		value.setValue(getFieldPatchedValue("DisableAPIC"));

	if (path == "DisableAPIC")
		value.setValue(isDisableAPIC());

	if (path == "OptimizePowerConsumptionMode.patch_stamp")
		value.setValue(getFieldPatchedValue("OptimizePowerConsumptionMode"));

	if (path == "OptimizePowerConsumptionMode")
		value.setValue((qlonglong )getOptimizePowerConsumptionMode());

	if (path == "ShowBatteryStatus.patch_stamp")
		value.setValue(getFieldPatchedValue("ShowBatteryStatus"));

	if (path == "ShowBatteryStatus")
		value.setValue(isShowBatteryStatus());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "EnableAdaptiveHypervisor.patch_stamp")
		value.setValue(getFieldPatchedValue("EnableAdaptiveHypervisor"));

	if (path == "EnableAdaptiveHypervisor")
		value.setValue(isEnableAdaptiveHypervisor());

	if (path == "UseSMBiosData.patch_stamp")
		value.setValue(getFieldPatchedValue("UseSMBiosData"));

	if (path == "UseSMBiosData")
		value.setValue(isUseSMBiosData());

	if (path == "DisableSpeaker.patch_stamp")
		value.setValue(getFieldPatchedValue("DisableSpeaker"));

	if (path == "DisableSpeaker")
		value.setValue(isDisableSpeaker());

	if (path == "HideBiosOnStartEnabled.patch_stamp")
		value.setValue(getFieldPatchedValue("HideBiosOnStartEnabled"));

	if (path == "HideBiosOnStartEnabled")
		value.setValue(isHideBiosOnStartEnabled());

	if (path == "UseDefaultAnswers.patch_stamp")
		value.setValue(getFieldPatchedValue("UseDefaultAnswers"));

	if (path == "UseDefaultAnswers")
		value.setValue(isUseDefaultAnswers());

	if (path == "CompactHddMask.patch_stamp")
		value.setValue(getFieldPatchedValue("CompactHddMask"));

	if (path == "CompactHddMask")
		value.setValue(getCompactHddMask());

	if (path == "CompactMode.patch_stamp")
		value.setValue(getFieldPatchedValue("CompactMode"));

	if (path == "CompactMode")
		value.setValue(isCompactMode());

	if (path == "DisableWin7Logo.patch_stamp")
		value.setValue(getFieldPatchedValue("DisableWin7Logo"));

	if (path == "DisableWin7Logo")
		value.setValue(isDisableWin7Logo());

	if (path == "OptimizeModifiers.patch_stamp")
		value.setValue(getFieldPatchedValue("OptimizeModifiers"));

	if (path == "OptimizeModifiers")
		value.setValue((qlonglong )getOptimizeModifiers());

	if (path == "StickyMouse.patch_stamp")
		value.setValue(getFieldPatchedValue("StickyMouse"));

	if (path == "StickyMouse")
		value.setValue(isStickyMouse());

	if (path == "PauseOnDeactivation.patch_stamp")
		value.setValue(getFieldPatchedValue("PauseOnDeactivation"));

	if (path == "PauseOnDeactivation")
		value.setValue(isPauseOnDeactivation());

	if (path == "FEATURES_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("FEATURES_MASK"));

	if (path == "FEATURES_MASK")
		value.setValue(getFEATURES_MASK());

	if (path == "EXT_FEATURES_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_FEATURES_MASK"));

	if (path == "EXT_FEATURES_MASK")
		value.setValue(getEXT_FEATURES_MASK());

	if (path == "EXT_80000001_ECX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_80000001_ECX_MASK"));

	if (path == "EXT_80000001_ECX_MASK")
		value.setValue(getEXT_80000001_ECX_MASK());

	if (path == "EXT_80000001_EDX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_80000001_EDX_MASK"));

	if (path == "EXT_80000001_EDX_MASK")
		value.setValue(getEXT_80000001_EDX_MASK());

	if (path == "EXT_80000007_EDX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_80000007_EDX_MASK"));

	if (path == "EXT_80000007_EDX_MASK")
		value.setValue(getEXT_80000007_EDX_MASK());

	if (path == "EXT_80000008_EAX.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_80000008_EAX"));

	if (path == "EXT_80000008_EAX")
		value.setValue(getEXT_80000008_EAX());

	if (path == "EXT_00000007_EBX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_00000007_EBX_MASK"));

	if (path == "EXT_00000007_EBX_MASK")
		value.setValue(getEXT_00000007_EBX_MASK());

	if (path == "EXT_00000007_EDX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_00000007_EDX_MASK"));

	if (path == "EXT_00000007_EDX_MASK")
		value.setValue(getEXT_00000007_EDX_MASK());

	if (path == "EXT_0000000D_EAX_MASK.patch_stamp")
		value.setValue(getFieldPatchedValue("EXT_0000000D_EAX_MASK"));

	if (path == "EXT_0000000D_EAX_MASK")
		value.setValue(getEXT_0000000D_EAX_MASK());

	if (path == "CpuFeaturesMaskValid.patch_stamp")
		value.setValue(getFieldPatchedValue("CpuFeaturesMaskValid"));

	if (path == "CpuFeaturesMaskValid")
		value.setValue(isCpuFeaturesMaskValid());

	if (path == "UnattendedInstallLocale.patch_stamp")
		value.setValue(getFieldPatchedValue("UnattendedInstallLocale"));

	if (path == "UnattendedInstallLocale")
		value.setValue(getUnattendedInstallLocale());

	if (path == "UnattendedInstallEdition.patch_stamp")
		value.setValue(getFieldPatchedValue("UnattendedInstallEdition"));

	if (path == "UnattendedInstallEdition")
		value.setValue(getUnattendedInstallEdition());

	if (path == "HostRetinaEnabled.patch_stamp")
		value.setValue(getFieldPatchedValue("HostRetinaEnabled"));

	if (path == "HostRetinaEnabled")
		value.setValue(isHostRetinaEnabled());

	list_tag = "IoLimit[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i] && nItemId == m_lstIoLimit[i]->getItemId())
				return m_lstIoLimit[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("IoLimit.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i] && nMaxId < m_lstIoLimit[i]->getItemId())
				nMaxId = m_lstIoLimit[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("IoLimit.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i]) lstIds += m_lstIoLimit[i]->getItemId();
		value.setValue(lstIds);
	}

	list_tag = "OnCrash.";
	if (path.startsWith(list_tag) && ! m_lstOnCrash.isEmpty() && m_lstOnCrash.first())
		return m_lstOnCrash.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "FullScreen.";
	if (path.startsWith(list_tag) && ! m_lstFullScreen.isEmpty() && m_lstFullScreen.first())
		return m_lstFullScreen.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "InternalVmInfo.";
	if (path.startsWith(list_tag) && ! m_lstInternalVmInfo.isEmpty() && m_lstInternalVmInfo.first())
		return m_lstInternalVmInfo.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmRunTimeOptions::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "ForegroundPriority.patch_stamp")
	{
		markPatchedField("ForegroundPriority", value.toString());
		return true;
	}

	if (path == "ForegroundPriority")
	{
		if (pbValueChanged)
			*pbValueChanged = (getForegroundPriority() != (PRL_VM_PRIORITY )value.value< qlonglong >());
		setForegroundPriority((PRL_VM_PRIORITY )value.value< qlonglong >());
		return true;
	}

	if (path == "BackgroundPriority.patch_stamp")
	{
		markPatchedField("BackgroundPriority", value.toString());
		return true;
	}

	if (path == "BackgroundPriority")
	{
		if (pbValueChanged)
			*pbValueChanged = (getBackgroundPriority() != (PRL_VM_PRIORITY )value.value< qlonglong >());
		setBackgroundPriority((PRL_VM_PRIORITY )value.value< qlonglong >());
		return true;
	}

	if (path == "IoPriority.patch_stamp")
	{
		markPatchedField("IoPriority", value.toString());
		return true;
	}

	if (path == "IoPriority")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIoPriority() != value.value< unsigned int >());
		setIoPriority(value.value< unsigned int >());
		return true;
	}

	if (path == "IopsLimit.patch_stamp")
	{
		markPatchedField("IopsLimit", value.toString());
		return true;
	}

	if (path == "IopsLimit")
	{
		if (pbValueChanged)
			*pbValueChanged = (getIopsLimit() != value.value< unsigned int >());
		setIopsLimit(value.value< unsigned int >());
		return true;
	}

	if (path == "DiskCachePolicy.patch_stamp")
	{
		markPatchedField("DiskCachePolicy", value.toString());
		return true;
	}

	if (path == "DiskCachePolicy")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDiskCachePolicy() != (PVE::DiskCacheWritebackOption )value.value< qlonglong >());
		setDiskCachePolicy((PVE::DiskCacheWritebackOption )value.value< qlonglong >());
		return true;
	}

	if (path == "CloseAppOnShutdown.patch_stamp")
	{
		markPatchedField("CloseAppOnShutdown", value.toString());
		return true;
	}

	if (path == "CloseAppOnShutdown")
	{
		if (pbValueChanged)
			*pbValueChanged = (isCloseAppOnShutdown() != value.value< bool >());
		setCloseAppOnShutdown(value.value< bool >());
		return true;
	}

	if (path == "ActionOnStop.patch_stamp")
	{
		markPatchedField("ActionOnStop", value.toString());
		return true;
	}

	if (path == "ActionOnStop")
	{
		if (pbValueChanged)
			*pbValueChanged = (getActionOnStop() != (PRL_VM_ACTION_ON_STOP )value.value< qlonglong >());
		setActionOnStop((PRL_VM_ACTION_ON_STOP )value.value< qlonglong >());
		return true;
	}

	if (path == "DockIcon.patch_stamp")
	{
		markPatchedField("DockIcon", value.toString());
		return true;
	}

	if (path == "DockIcon")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDockIconType() != (PRL_DOCK_ICON_TYPE )value.value< qlonglong >());
		setDockIconType((PRL_DOCK_ICON_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "OsResolutionInFullScreen.patch_stamp")
	{
		markPatchedField("OsResolutionInFullScreen", value.toString());
		return true;
	}

	if (path == "OsResolutionInFullScreen")
	{
		if (pbValueChanged)
			*pbValueChanged = (isOsResolutionInFullScreen() != value.value< bool >());
		setOsResolutionInFullScreen(value.value< bool >());
		return true;
	}

	if (path == "UndoDisks.patch_stamp")
	{
		markPatchedField("UndoDisks", value.toString());
		return true;
	}

	if (path == "UndoDisks")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUndoDisksMode() != (PRL_UNDO_DISKS_MODE )value.value< qlonglong >());
		setUndoDisksMode((PRL_UNDO_DISKS_MODE )value.value< qlonglong >());
		return true;
	}

	if (path == "SafeMode.patch_stamp")
	{
		markPatchedField("SafeMode", value.toString());
		return true;
	}

	if (path == "SafeMode")
	{
		if (pbValueChanged)
			*pbValueChanged = (isSafeMode() != value.value< bool >());
		setSafeMode(value.value< bool >());
		return true;
	}

	if (path == "SystemFlags.patch_stamp")
	{
		markPatchedField("SystemFlags", value.toString());
		return true;
	}

	if (path == "SystemFlags")
	{
		if (pbValueChanged)
			*pbValueChanged = (getSystemFlags() != value.value< QString >());
		setSystemFlags(value.value< QString >());
		return true;
	}

	if (path == "DisableAPIC.patch_stamp")
	{
		markPatchedField("DisableAPIC", value.toString());
		return true;
	}

	if (path == "DisableAPIC")
	{
		if (pbValueChanged)
			*pbValueChanged = (isDisableAPIC() != value.value< bool >());
		setDisableAPIC(value.value< bool >());
		return true;
	}

	if (path == "OptimizePowerConsumptionMode.patch_stamp")
	{
		markPatchedField("OptimizePowerConsumptionMode", value.toString());
		return true;
	}

	if (path == "OptimizePowerConsumptionMode")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOptimizePowerConsumptionMode() != (PVE::OptimizePowerConsumptionMode )value.value< qlonglong >());
		setOptimizePowerConsumptionMode((PVE::OptimizePowerConsumptionMode )value.value< qlonglong >());
		return true;
	}

	if (path == "ShowBatteryStatus.patch_stamp")
	{
		markPatchedField("ShowBatteryStatus", value.toString());
		return true;
	}

	if (path == "ShowBatteryStatus")
	{
		if (pbValueChanged)
			*pbValueChanged = (isShowBatteryStatus() != value.value< bool >());
		setShowBatteryStatus(value.value< bool >());
		return true;
	}

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "EnableAdaptiveHypervisor.patch_stamp")
	{
		markPatchedField("EnableAdaptiveHypervisor", value.toString());
		return true;
	}

	if (path == "EnableAdaptiveHypervisor")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnableAdaptiveHypervisor() != value.value< bool >());
		setEnableAdaptiveHypervisor(value.value< bool >());
		return true;
	}

	if (path == "UseSMBiosData.patch_stamp")
	{
		markPatchedField("UseSMBiosData", value.toString());
		return true;
	}

	if (path == "UseSMBiosData")
	{
		if (pbValueChanged)
			*pbValueChanged = (isUseSMBiosData() != value.value< bool >());
		setUseSMBiosData(value.value< bool >());
		return true;
	}

	if (path == "DisableSpeaker.patch_stamp")
	{
		markPatchedField("DisableSpeaker", value.toString());
		return true;
	}

	if (path == "DisableSpeaker")
	{
		if (pbValueChanged)
			*pbValueChanged = (isDisableSpeaker() != value.value< bool >());
		setDisableSpeaker(value.value< bool >());
		return true;
	}

	if (path == "HideBiosOnStartEnabled.patch_stamp")
	{
		markPatchedField("HideBiosOnStartEnabled", value.toString());
		return true;
	}

	if (path == "HideBiosOnStartEnabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isHideBiosOnStartEnabled() != value.value< bool >());
		setHideBiosOnStartEnabled(value.value< bool >());
		return true;
	}

	if (path == "UseDefaultAnswers.patch_stamp")
	{
		markPatchedField("UseDefaultAnswers", value.toString());
		return true;
	}

	if (path == "UseDefaultAnswers")
	{
		if (pbValueChanged)
			*pbValueChanged = (isUseDefaultAnswers() != value.value< bool >());
		setUseDefaultAnswers(value.value< bool >());
		return true;
	}

	if (path == "CompactHddMask.patch_stamp")
	{
		markPatchedField("CompactHddMask", value.toString());
		return true;
	}

	if (path == "CompactHddMask")
	{
		if (pbValueChanged)
			*pbValueChanged = (getCompactHddMask() != value.value< unsigned int >());
		setCompactHddMask(value.value< unsigned int >());
		return true;
	}

	if (path == "CompactMode.patch_stamp")
	{
		markPatchedField("CompactMode", value.toString());
		return true;
	}

	if (path == "CompactMode")
	{
		if (pbValueChanged)
			*pbValueChanged = (isCompactMode() != value.value< bool >());
		setCompactMode(value.value< bool >());
		return true;
	}

	if (path == "DisableWin7Logo.patch_stamp")
	{
		markPatchedField("DisableWin7Logo", value.toString());
		return true;
	}

	if (path == "DisableWin7Logo")
	{
		if (pbValueChanged)
			*pbValueChanged = (isDisableWin7Logo() != value.value< bool >());
		setDisableWin7Logo(value.value< bool >());
		return true;
	}

	if (path == "OptimizeModifiers.patch_stamp")
	{
		markPatchedField("OptimizeModifiers", value.toString());
		return true;
	}

	if (path == "OptimizeModifiers")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOptimizeModifiers() != (PRL_OPTIMIZE_MODIFIERS_MODE )value.value< qlonglong >());
		setOptimizeModifiers((PRL_OPTIMIZE_MODIFIERS_MODE )value.value< qlonglong >());
		return true;
	}

	if (path == "StickyMouse.patch_stamp")
	{
		markPatchedField("StickyMouse", value.toString());
		return true;
	}

	if (path == "StickyMouse")
	{
		if (pbValueChanged)
			*pbValueChanged = (isStickyMouse() != value.value< bool >());
		setStickyMouse(value.value< bool >());
		return true;
	}

	if (path == "PauseOnDeactivation.patch_stamp")
	{
		markPatchedField("PauseOnDeactivation", value.toString());
		return true;
	}

	if (path == "PauseOnDeactivation")
	{
		if (pbValueChanged)
			*pbValueChanged = (isPauseOnDeactivation() != value.value< bool >());
		setPauseOnDeactivation(value.value< bool >());
		return true;
	}

	if (path == "FEATURES_MASK.patch_stamp")
	{
		markPatchedField("FEATURES_MASK", value.toString());
		return true;
	}

	if (path == "FEATURES_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getFEATURES_MASK() != value.value< unsigned int >());
		setFEATURES_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_FEATURES_MASK.patch_stamp")
	{
		markPatchedField("EXT_FEATURES_MASK", value.toString());
		return true;
	}

	if (path == "EXT_FEATURES_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_FEATURES_MASK() != value.value< unsigned int >());
		setEXT_FEATURES_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_80000001_ECX_MASK.patch_stamp")
	{
		markPatchedField("EXT_80000001_ECX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_80000001_ECX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_80000001_ECX_MASK() != value.value< unsigned int >());
		setEXT_80000001_ECX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_80000001_EDX_MASK.patch_stamp")
	{
		markPatchedField("EXT_80000001_EDX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_80000001_EDX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_80000001_EDX_MASK() != value.value< unsigned int >());
		setEXT_80000001_EDX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_80000007_EDX_MASK.patch_stamp")
	{
		markPatchedField("EXT_80000007_EDX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_80000007_EDX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_80000007_EDX_MASK() != value.value< unsigned int >());
		setEXT_80000007_EDX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_80000008_EAX.patch_stamp")
	{
		markPatchedField("EXT_80000008_EAX", value.toString());
		return true;
	}

	if (path == "EXT_80000008_EAX")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_80000008_EAX() != value.value< unsigned int >());
		setEXT_80000008_EAX(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_00000007_EBX_MASK.patch_stamp")
	{
		markPatchedField("EXT_00000007_EBX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_00000007_EBX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_00000007_EBX_MASK() != value.value< unsigned int >());
		setEXT_00000007_EBX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_00000007_EDX_MASK.patch_stamp")
	{
		markPatchedField("EXT_00000007_EDX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_00000007_EDX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_00000007_EDX_MASK() != value.value< unsigned int >());
		setEXT_00000007_EDX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "EXT_0000000D_EAX_MASK.patch_stamp")
	{
		markPatchedField("EXT_0000000D_EAX_MASK", value.toString());
		return true;
	}

	if (path == "EXT_0000000D_EAX_MASK")
	{
		if (pbValueChanged)
			*pbValueChanged = (getEXT_0000000D_EAX_MASK() != value.value< unsigned int >());
		setEXT_0000000D_EAX_MASK(value.value< unsigned int >());
		return true;
	}

	if (path == "CpuFeaturesMaskValid.patch_stamp")
	{
		markPatchedField("CpuFeaturesMaskValid", value.toString());
		return true;
	}

	if (path == "CpuFeaturesMaskValid")
	{
		if (pbValueChanged)
			*pbValueChanged = (isCpuFeaturesMaskValid() != value.value< bool >());
		setCpuFeaturesMaskValid(value.value< bool >());
		return true;
	}

	if (path == "UnattendedInstallLocale.patch_stamp")
	{
		markPatchedField("UnattendedInstallLocale", value.toString());
		return true;
	}

	if (path == "UnattendedInstallLocale")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUnattendedInstallLocale() != value.value< QString >());
		setUnattendedInstallLocale(value.value< QString >());
		return true;
	}

	if (path == "UnattendedInstallEdition.patch_stamp")
	{
		markPatchedField("UnattendedInstallEdition", value.toString());
		return true;
	}

	if (path == "UnattendedInstallEdition")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUnattendedInstallEdition() != value.value< QString >());
		setUnattendedInstallEdition(value.value< QString >());
		return true;
	}

	if (path == "HostRetinaEnabled.patch_stamp")
	{
		markPatchedField("HostRetinaEnabled", value.toString());
		return true;
	}

	if (path == "HostRetinaEnabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isHostRetinaEnabled() != value.value< bool >());
		setHostRetinaEnabled(value.value< bool >());
		return true;
	}

	list_tag = "IoLimit[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i] && nItemId == m_lstIoLimit[i]->getItemId())
				return m_lstIoLimit[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	list_tag = "OnCrash.";
	if (path.startsWith(list_tag) && ! m_lstOnCrash.isEmpty() && m_lstOnCrash.first())
		return m_lstOnCrash.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "FullScreen.";
	if (path.startsWith(list_tag) && ! m_lstFullScreen.isEmpty() && m_lstFullScreen.first())
		return m_lstFullScreen.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "InternalVmInfo.";
	if (path.startsWith(list_tag) && ! m_lstInternalVmInfo.isEmpty() && m_lstInternalVmInfo.first())
		return m_lstInternalVmInfo.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmRunTimeOptions::getForegroundPriority_id() const
{
	return getFullItemId().isEmpty() ? "ForegroundPriority" : getFullItemId() + ".ForegroundPriority";
}
QString CVmRunTimeOptions::getBackgroundPriority_id() const
{
	return getFullItemId().isEmpty() ? "BackgroundPriority" : getFullItemId() + ".BackgroundPriority";
}
QString CVmRunTimeOptions::getIoPriority_id() const
{
	return getFullItemId().isEmpty() ? "IoPriority" : getFullItemId() + ".IoPriority";
}
QString CVmRunTimeOptions::getIopsLimit_id() const
{
	return getFullItemId().isEmpty() ? "IopsLimit" : getFullItemId() + ".IopsLimit";
}
QString CVmRunTimeOptions::getDiskCachePolicy_id() const
{
	return getFullItemId().isEmpty() ? "DiskCachePolicy" : getFullItemId() + ".DiskCachePolicy";
}
QString CVmRunTimeOptions::getCloseAppOnShutdown_id() const
{
	return getFullItemId().isEmpty() ? "CloseAppOnShutdown" : getFullItemId() + ".CloseAppOnShutdown";
}
QString CVmRunTimeOptions::getActionOnStop_id() const
{
	return getFullItemId().isEmpty() ? "ActionOnStop" : getFullItemId() + ".ActionOnStop";
}
QString CVmRunTimeOptions::getDockIconType_id() const
{
	return getFullItemId().isEmpty() ? "DockIcon" : getFullItemId() + ".DockIcon";
}
QString CVmRunTimeOptions::getOsResolutionInFullScreen_id() const
{
	return getFullItemId().isEmpty() ? "OsResolutionInFullScreen" : getFullItemId() + ".OsResolutionInFullScreen";
}
QString CVmRunTimeOptions::getUndoDisksMode_id() const
{
	return getFullItemId().isEmpty() ? "UndoDisks" : getFullItemId() + ".UndoDisks";
}
QString CVmRunTimeOptions::getSafeMode_id() const
{
	return getFullItemId().isEmpty() ? "SafeMode" : getFullItemId() + ".SafeMode";
}
QString CVmRunTimeOptions::getSystemFlags_id() const
{
	return getFullItemId().isEmpty() ? "SystemFlags" : getFullItemId() + ".SystemFlags";
}
QString CVmRunTimeOptions::getDisableAPIC_id() const
{
	return getFullItemId().isEmpty() ? "DisableAPIC" : getFullItemId() + ".DisableAPIC";
}
QString CVmRunTimeOptions::getOptimizePowerConsumptionMode_id() const
{
	return getFullItemId().isEmpty() ? "OptimizePowerConsumptionMode" : getFullItemId() + ".OptimizePowerConsumptionMode";
}
QString CVmRunTimeOptions::getShowBatteryStatus_id() const
{
	return getFullItemId().isEmpty() ? "ShowBatteryStatus" : getFullItemId() + ".ShowBatteryStatus";
}
QString CVmRunTimeOptions::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmRunTimeOptions::getEnableAdaptiveHypervisor_id() const
{
	return getFullItemId().isEmpty() ? "EnableAdaptiveHypervisor" : getFullItemId() + ".EnableAdaptiveHypervisor";
}
QString CVmRunTimeOptions::getUseSMBiosData_id() const
{
	return getFullItemId().isEmpty() ? "UseSMBiosData" : getFullItemId() + ".UseSMBiosData";
}
QString CVmRunTimeOptions::getDisableSpeaker_id() const
{
	return getFullItemId().isEmpty() ? "DisableSpeaker" : getFullItemId() + ".DisableSpeaker";
}
QString CVmRunTimeOptions::getHideBiosOnStartEnabled_id() const
{
	return getFullItemId().isEmpty() ? "HideBiosOnStartEnabled" : getFullItemId() + ".HideBiosOnStartEnabled";
}
QString CVmRunTimeOptions::getUseDefaultAnswers_id() const
{
	return getFullItemId().isEmpty() ? "UseDefaultAnswers" : getFullItemId() + ".UseDefaultAnswers";
}
QString CVmRunTimeOptions::getCompactHddMask_id() const
{
	return getFullItemId().isEmpty() ? "CompactHddMask" : getFullItemId() + ".CompactHddMask";
}
QString CVmRunTimeOptions::getCompactMode_id() const
{
	return getFullItemId().isEmpty() ? "CompactMode" : getFullItemId() + ".CompactMode";
}
QString CVmRunTimeOptions::getDisableWin7Logo_id() const
{
	return getFullItemId().isEmpty() ? "DisableWin7Logo" : getFullItemId() + ".DisableWin7Logo";
}
QString CVmRunTimeOptions::getOptimizeModifiers_id() const
{
	return getFullItemId().isEmpty() ? "OptimizeModifiers" : getFullItemId() + ".OptimizeModifiers";
}
QString CVmRunTimeOptions::getStickyMouse_id() const
{
	return getFullItemId().isEmpty() ? "StickyMouse" : getFullItemId() + ".StickyMouse";
}
QString CVmRunTimeOptions::getPauseOnDeactivation_id() const
{
	return getFullItemId().isEmpty() ? "PauseOnDeactivation" : getFullItemId() + ".PauseOnDeactivation";
}
QString CVmRunTimeOptions::getFEATURES_MASK_id() const
{
	return getFullItemId().isEmpty() ? "FEATURES_MASK" : getFullItemId() + ".FEATURES_MASK";
}
QString CVmRunTimeOptions::getEXT_FEATURES_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_FEATURES_MASK" : getFullItemId() + ".EXT_FEATURES_MASK";
}
QString CVmRunTimeOptions::getEXT_80000001_ECX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_80000001_ECX_MASK" : getFullItemId() + ".EXT_80000001_ECX_MASK";
}
QString CVmRunTimeOptions::getEXT_80000001_EDX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_80000001_EDX_MASK" : getFullItemId() + ".EXT_80000001_EDX_MASK";
}
QString CVmRunTimeOptions::getEXT_80000007_EDX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_80000007_EDX_MASK" : getFullItemId() + ".EXT_80000007_EDX_MASK";
}
QString CVmRunTimeOptions::getEXT_80000008_EAX_id() const
{
	return getFullItemId().isEmpty() ? "EXT_80000008_EAX" : getFullItemId() + ".EXT_80000008_EAX";
}
QString CVmRunTimeOptions::getEXT_00000007_EBX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_00000007_EBX_MASK" : getFullItemId() + ".EXT_00000007_EBX_MASK";
}
QString CVmRunTimeOptions::getEXT_00000007_EDX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_00000007_EDX_MASK" : getFullItemId() + ".EXT_00000007_EDX_MASK";
}
QString CVmRunTimeOptions::getEXT_0000000D_EAX_MASK_id() const
{
	return getFullItemId().isEmpty() ? "EXT_0000000D_EAX_MASK" : getFullItemId() + ".EXT_0000000D_EAX_MASK";
}
QString CVmRunTimeOptions::getCpuFeaturesMaskValid_id() const
{
	return getFullItemId().isEmpty() ? "CpuFeaturesMaskValid" : getFullItemId() + ".CpuFeaturesMaskValid";
}
QString CVmRunTimeOptions::getUnattendedInstallLocale_id() const
{
	return getFullItemId().isEmpty() ? "UnattendedInstallLocale" : getFullItemId() + ".UnattendedInstallLocale";
}
QString CVmRunTimeOptions::getUnattendedInstallEdition_id() const
{
	return getFullItemId().isEmpty() ? "UnattendedInstallEdition" : getFullItemId() + ".UnattendedInstallEdition";
}
QString CVmRunTimeOptions::getHostRetinaEnabled_id() const
{
	return getFullItemId().isEmpty() ? "HostRetinaEnabled" : getFullItemId() + ".HostRetinaEnabled";
}

int CVmRunTimeOptions::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "IoLimit")
	{
		m_lstIoLimit += new CVmIoLimit;
		nNewItemId = getMaxItemId<CVmIoLimit>(m_lstIoLimit, "IoLimit");
		m_lstIoLimit.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "IoLimit");
	}

	list_tag = "IoLimit[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i] && nItemId == m_lstIoLimit[i]->getItemId())
				return m_lstIoLimit[i]->addListItem(path.mid(idx + 2));
	}

	list_tag = "OnCrash.";
	if (path.startsWith(list_tag) && ! m_lstOnCrash.isEmpty() && m_lstOnCrash.first())
		return m_lstOnCrash.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "FullScreen.";
	if (path.startsWith(list_tag) && ! m_lstFullScreen.isEmpty() && m_lstFullScreen.first())
		return m_lstFullScreen.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "InternalVmInfo.";
	if (path.startsWith(list_tag) && ! m_lstInternalVmInfo.isEmpty() && m_lstInternalVmInfo.first())
		return m_lstInternalVmInfo.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmRunTimeOptions::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "IoLimit[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstIoLimit.size(); ++i)
			if (m_lstIoLimit[i] && nItemId == m_lstIoLimit[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstIoLimit[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstIoLimit.takeAt(i);
				return true;
			}
	}

	list_tag = "OnCrash.";
	if (path.startsWith(list_tag) && ! m_lstOnCrash.isEmpty() && m_lstOnCrash.first())
		return m_lstOnCrash.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "FullScreen.";
	if (path.startsWith(list_tag) && ! m_lstFullScreen.isEmpty() && m_lstFullScreen.first())
		return m_lstFullScreen.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "InternalVmInfo.";
	if (path.startsWith(list_tag) && ! m_lstInternalVmInfo.isEmpty() && m_lstInternalVmInfo.first())
		return m_lstInternalVmInfo.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmRunTimeOptions::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Runtime") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ForegroundPriority");
	text_element = Document->createTextNode( QString("%1").arg(getForegroundPriority()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("BackgroundPriority");
	text_element = Document->createTextNode( QString("%1").arg(getBackgroundPriority()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IoPriority");
	text_element = Document->createTextNode( QString("%1").arg(getIoPriority()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "IoLimit";
	nMaxItemId = getMaxItemId<CVmIoLimit>(m_lstIoLimit, "IoLimit", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstIoLimit.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmIoLimit* object = m_lstIoLimit[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "IoLimit", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IopsLimit");
	text_element = Document->createTextNode( QString("%1").arg(getIopsLimit()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DiskCachePolicy");
	text_element = Document->createTextNode( QString("%1").arg(getDiskCachePolicy()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CloseAppOnShutdown");
	text_element = Document->createTextNode( QString("%1").arg(isCloseAppOnShutdown()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ActionOnStop");
	text_element = Document->createTextNode( QString("%1").arg(getActionOnStop()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstOnCrash.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmOnCrash* object = m_lstOnCrash[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DockIcon");
	text_element = Document->createTextNode( QString("%1").arg(getDockIconType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OsResolutionInFullScreen");
	text_element = Document->createTextNode( QString("%1").arg(isOsResolutionInFullScreen()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstFullScreen.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmFullScreen* object = m_lstFullScreen[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UndoDisks");
	text_element = Document->createTextNode( QString("%1").arg(getUndoDisksMode()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SafeMode");
	text_element = Document->createTextNode( QString("%1").arg(isSafeMode()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemFlags");
	text_element = Document->createTextNode( QString("%1").arg(getSystemFlags()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DisableAPIC");
	text_element = Document->createTextNode( QString("%1").arg(isDisableAPIC()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OptimizePowerConsumptionMode");
	text_element = Document->createTextNode( QString("%1").arg(getOptimizePowerConsumptionMode()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ShowBatteryStatus");
	text_element = Document->createTextNode( QString("%1").arg(isShowBatteryStatus()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EnableAdaptiveHypervisor");
	text_element = Document->createTextNode( QString("%1").arg(isEnableAdaptiveHypervisor()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UseSMBiosData");
	text_element = Document->createTextNode( QString("%1").arg(isUseSMBiosData()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DisableSpeaker");
	text_element = Document->createTextNode( QString("%1").arg(isDisableSpeaker()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("HideBiosOnStartEnabled");
	text_element = Document->createTextNode( QString("%1").arg(isHideBiosOnStartEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UseDefaultAnswers");
	text_element = Document->createTextNode( QString("%1").arg(isUseDefaultAnswers()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CompactHddMask");
	text_element = Document->createTextNode( QString("%1").arg(getCompactHddMask()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CompactMode");
	text_element = Document->createTextNode( QString("%1").arg(isCompactMode()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DisableWin7Logo");
	text_element = Document->createTextNode( QString("%1").arg(isDisableWin7Logo()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OptimizeModifiers");
	text_element = Document->createTextNode( QString("%1").arg(getOptimizeModifiers()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("StickyMouse");
	text_element = Document->createTextNode( QString("%1").arg(isStickyMouse()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("PauseOnDeactivation");
	text_element = Document->createTextNode( QString("%1").arg(isPauseOnDeactivation()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("FEATURES_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getFEATURES_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_FEATURES_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_FEATURES_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_80000001_ECX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_80000001_ECX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_80000001_EDX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_80000001_EDX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_80000007_EDX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_80000007_EDX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_80000008_EAX");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_80000008_EAX()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_00000007_EBX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_00000007_EBX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_00000007_EDX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_00000007_EDX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EXT_0000000D_EAX_MASK");
	text_element = Document->createTextNode( QString("%1").arg(getEXT_0000000D_EAX_MASK()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuFeaturesMaskValid");
	text_element = Document->createTextNode( QString("%1").arg(isCpuFeaturesMaskValid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstInternalVmInfo.size() && ( ! no_save_option ); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const InternalVmInfo* object = m_lstInternalVmInfo[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UnattendedInstallLocale");
	text_element = Document->createTextNode( QString("%1").arg(getUnattendedInstallLocale()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UnattendedInstallEdition");
	text_element = Document->createTextNode( QString("%1").arg(getUnattendedInstallEdition()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("HostRetinaEnabled");
	text_element = Document->createTextNode( QString("%1").arg(isHostRetinaEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmRunTimeOptions::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Runtime") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_IoLimit = getMaxItemId2(element, "IoLimit");
	QMap<int , QString > mapIoLimit;
	if (unite_with_loaded)
		fillItemIdMap<CVmIoLimit>(m_lstIoLimit, mapIoLimit);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int IoLimit_count = 0;
	int OnCrash_count = 1;
	int FullScreen_count = 1;
	int InternalVmInfo_count = 1;
	int ForegroundPriority_count = 1;
	int BackgroundPriority_count = 1;
	int IoPriority_count = 0;
	int IopsLimit_count = 0;
	int DiskCachePolicy_count = 1;
	int CloseAppOnShutdown_count = 1;
	int ActionOnStop_count = 0;
	int DockIcon_count = 1;
	int OsResolutionInFullScreen_count = 1;
	int UndoDisks_count = 1;
	int SafeMode_count = 0;
	int SystemFlags_count = 1;
	int DisableAPIC_count = 0;
	int OptimizePowerConsumptionMode_count = 0;
	int ShowBatteryStatus_count = 0;
	int Enabled_count = 0;
	int EnableAdaptiveHypervisor_count = 0;
	int UseSMBiosData_count = 0;
	int DisableSpeaker_count = 0;
	int HideBiosOnStartEnabled_count = 0;
	int UseDefaultAnswers_count = 0;
	int CompactHddMask_count = 0;
	int CompactMode_count = 0;
	int DisableWin7Logo_count = 0;
	int OptimizeModifiers_count = 0;
	int StickyMouse_count = 0;
	int PauseOnDeactivation_count = 0;
	int FEATURES_MASK_count = 0;
	int EXT_FEATURES_MASK_count = 0;
	int EXT_80000001_ECX_MASK_count = 0;
	int EXT_80000001_EDX_MASK_count = 0;
	int EXT_80000007_EDX_MASK_count = 0;
	int EXT_80000008_EAX_count = 0;
	int EXT_00000007_EBX_MASK_count = 0;
	int EXT_00000007_EDX_MASK_count = 0;
	int EXT_0000000D_EAX_MASK_count = 0;
	int CpuFeaturesMaskValid_count = 0;
	int UnattendedInstallLocale_count = 0;
	int UnattendedInstallEdition_count = 0;
	int HostRetinaEnabled_count = 0;

	QString OptimizePowerConsumptionMode_patch_stamp = RootElement->attribute("OptimizePowerConsumptionMode_patch");
	if (unite_with_loaded && RootElement->firstChildElement("OptimizePowerConsumptionMode").isNull())
		OptimizePowerConsumptionMode_patch_stamp = getFieldPatchedValue("OptimizePowerConsumptionMode");
	QString StickyMouse_patch_stamp = RootElement->attribute("StickyMouse_patch");
	if (unite_with_loaded && RootElement->firstChildElement("StickyMouse").isNull())
		StickyMouse_patch_stamp = getFieldPatchedValue("StickyMouse");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "ForegroundPriority";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ForegroundPriority_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ForegroundPriority")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setForegroundPriority((PRL_VM_PRIORITY )text_element.data().toLongLong());
			--ForegroundPriority_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "BackgroundPriority";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (BackgroundPriority_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "BackgroundPriority")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setBackgroundPriority((PRL_VM_PRIORITY )text_element.data().toLongLong());
			--BackgroundPriority_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IoPriority";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IoPriority_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IoPriority")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIoPriority(text_element.data().toUInt());
			--IoPriority_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IopsLimit";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IopsLimit_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IopsLimit")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIopsLimit(text_element.data().toUInt());
			--IopsLimit_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DiskCachePolicy";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DiskCachePolicy_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DiskCachePolicy")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDiskCachePolicy((PVE::DiskCacheWritebackOption )text_element.data().toLongLong());
			--DiskCachePolicy_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CloseAppOnShutdown";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CloseAppOnShutdown_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CloseAppOnShutdown")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCloseAppOnShutdown(text_element.data().toInt() != 0);
			--CloseAppOnShutdown_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ActionOnStop";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ActionOnStop_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ActionOnStop")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setActionOnStop((PRL_VM_ACTION_ON_STOP )text_element.data().toLongLong());
			--ActionOnStop_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DockIcon";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DockIcon_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DockIcon")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDockIconType((PRL_DOCK_ICON_TYPE )text_element.data().toLongLong());
			--DockIcon_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OsResolutionInFullScreen";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OsResolutionInFullScreen_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OsResolutionInFullScreen")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOsResolutionInFullScreen(text_element.data().toInt() != 0);
			--OsResolutionInFullScreen_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UndoDisks";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UndoDisks_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UndoDisks")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUndoDisksMode((PRL_UNDO_DISKS_MODE )text_element.data().toLongLong());
			--UndoDisks_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SafeMode";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SafeMode_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SafeMode")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSafeMode(text_element.data().toInt() != 0);
			--SafeMode_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemFlags";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemFlags_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemFlags")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemFlags(text_element.data());
			--SystemFlags_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DisableAPIC";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DisableAPIC_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DisableAPIC")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDisableAPIC(text_element.data().toInt() != 0);
			--DisableAPIC_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OptimizePowerConsumptionMode";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OptimizePowerConsumptionMode_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OptimizePowerConsumptionMode")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOptimizePowerConsumptionMode((PVE::OptimizePowerConsumptionMode )text_element.data().toLongLong());
			--OptimizePowerConsumptionMode_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ShowBatteryStatus";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ShowBatteryStatus_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ShowBatteryStatus")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setShowBatteryStatus(text_element.data().toInt() != 0);
			--ShowBatteryStatus_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EnableAdaptiveHypervisor";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EnableAdaptiveHypervisor_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EnableAdaptiveHypervisor")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnableAdaptiveHypervisor(text_element.data().toInt() != 0);
			--EnableAdaptiveHypervisor_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UseSMBiosData";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UseSMBiosData_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UseSMBiosData")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUseSMBiosData(text_element.data().toInt() != 0);
			--UseSMBiosData_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DisableSpeaker";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DisableSpeaker_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DisableSpeaker")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDisableSpeaker(text_element.data().toInt() != 0);
			--DisableSpeaker_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "HideBiosOnStartEnabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (HideBiosOnStartEnabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "HideBiosOnStartEnabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHideBiosOnStartEnabled(text_element.data().toInt() != 0);
			--HideBiosOnStartEnabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UseDefaultAnswers";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UseDefaultAnswers_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UseDefaultAnswers")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUseDefaultAnswers(text_element.data().toInt() != 0);
			--UseDefaultAnswers_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CompactHddMask";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CompactHddMask_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CompactHddMask")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCompactHddMask(text_element.data().toUInt());
			--CompactHddMask_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CompactMode";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CompactMode_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CompactMode")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCompactMode(text_element.data().toInt() != 0);
			--CompactMode_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DisableWin7Logo";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DisableWin7Logo_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DisableWin7Logo")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDisableWin7Logo(text_element.data().toInt() != 0);
			--DisableWin7Logo_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OptimizeModifiers";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OptimizeModifiers_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OptimizeModifiers")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOptimizeModifiers((PRL_OPTIMIZE_MODIFIERS_MODE )text_element.data().toLongLong());
			--OptimizeModifiers_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "StickyMouse";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (StickyMouse_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "StickyMouse")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setStickyMouse(text_element.data().toInt() != 0);
			--StickyMouse_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "PauseOnDeactivation";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (PauseOnDeactivation_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "PauseOnDeactivation")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setPauseOnDeactivation(text_element.data().toInt() != 0);
			--PauseOnDeactivation_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "FEATURES_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (FEATURES_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "FEATURES_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setFEATURES_MASK(text_element.data().toUInt());
			--FEATURES_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_FEATURES_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_FEATURES_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_FEATURES_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_FEATURES_MASK(text_element.data().toUInt());
			--EXT_FEATURES_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_80000001_ECX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_80000001_ECX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_80000001_ECX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_80000001_ECX_MASK(text_element.data().toUInt());
			--EXT_80000001_ECX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_80000001_EDX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_80000001_EDX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_80000001_EDX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_80000001_EDX_MASK(text_element.data().toUInt());
			--EXT_80000001_EDX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_80000007_EDX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_80000007_EDX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_80000007_EDX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_80000007_EDX_MASK(text_element.data().toUInt());
			--EXT_80000007_EDX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_80000008_EAX";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_80000008_EAX_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_80000008_EAX")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_80000008_EAX(text_element.data().toUInt());
			--EXT_80000008_EAX_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_00000007_EBX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_00000007_EBX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_00000007_EBX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_00000007_EBX_MASK(text_element.data().toUInt());
			--EXT_00000007_EBX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_00000007_EDX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_00000007_EDX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_00000007_EDX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_00000007_EDX_MASK(text_element.data().toUInt());
			--EXT_00000007_EDX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EXT_0000000D_EAX_MASK";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EXT_0000000D_EAX_MASK_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EXT_0000000D_EAX_MASK")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEXT_0000000D_EAX_MASK(text_element.data().toUInt());
			--EXT_0000000D_EAX_MASK_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuFeaturesMaskValid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuFeaturesMaskValid_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuFeaturesMaskValid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuFeaturesMaskValid(text_element.data().toInt() != 0);
			--CpuFeaturesMaskValid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UnattendedInstallLocale";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UnattendedInstallLocale_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UnattendedInstallLocale")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUnattendedInstallLocale(text_element.data());
			--UnattendedInstallLocale_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UnattendedInstallEdition";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UnattendedInstallEdition_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UnattendedInstallEdition")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUnattendedInstallEdition(text_element.data());
			--UnattendedInstallEdition_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "HostRetinaEnabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (HostRetinaEnabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "HostRetinaEnabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setHostRetinaEnabled(text_element.data().toInt() != 0);
			--HostRetinaEnabled_count;
		}


		if (tag_name == "IoLimit")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_IoLimit++ : nItemId;
			CVmIoLimit* object = new CVmIoLimit();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "IoLimit", object->getItemId());
			if (unite_with_loaded && mapIoLimit.contains(nItemId))
				object->fromString(mapIoLimit.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstIoLimit += object;
			--IoLimit_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "OnCrash" && OnCrash_count > 0)
		{
			unused_tag = false;
			CVmOnCrash* object = m_lstOnCrash[1 - OnCrash_count];
			object->makeFullItemId(getFullItemId(), "OnCrash");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--OnCrash_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "FullScreen" && FullScreen_count > 0)
		{
			unused_tag = false;
			CVmFullScreen* object = m_lstFullScreen[1 - FullScreen_count];
			object->makeFullItemId(getFullItemId(), "FullScreen");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--FullScreen_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "InternalVmInfo" && InternalVmInfo_count > 0)
		{
			unused_tag = false;
			InternalVmInfo* object = m_lstInternalVmInfo[1 - InternalVmInfo_count];
			object->makeFullItemId(getFullItemId(), "InternalVmInfo");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--InternalVmInfo_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (IoLimit_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'IoLimit' is absent";
	}

	if (OnCrash_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'OnCrash' is absent";
	}

	if (FullScreen_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'FullScreen' is absent";
	}

	if (InternalVmInfo_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'InternalVmInfo' is absent";
	}

	if (ForegroundPriority_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'ForegroundPriority' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (BackgroundPriority_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'BackgroundPriority' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (IoPriority_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'IoPriority' is absent";
	}

	if (IopsLimit_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'IopsLimit' is absent";
	}

	if (DiskCachePolicy_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'DiskCachePolicy' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (CloseAppOnShutdown_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'CloseAppOnShutdown' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ActionOnStop_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'ActionOnStop' is absent";
	}

	if (DockIcon_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'DockIcon' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (OsResolutionInFullScreen_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'OsResolutionInFullScreen' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UndoDisks_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'UndoDisks' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SafeMode_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'SafeMode' is absent";
	}

	if (SystemFlags_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmRunTimeOptions': tag 'SystemFlags' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (DisableAPIC_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'DisableAPIC' is absent";
	}

	if (OptimizePowerConsumptionMode_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'OptimizePowerConsumptionMode' is absent";
	}

	if (ShowBatteryStatus_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'ShowBatteryStatus' is absent";
	}

	if (Enabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'Enabled' is absent";
	}

	if (EnableAdaptiveHypervisor_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EnableAdaptiveHypervisor' is absent";
	}

	if (UseSMBiosData_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'UseSMBiosData' is absent";
	}

	if (DisableSpeaker_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'DisableSpeaker' is absent";
	}

	if (HideBiosOnStartEnabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'HideBiosOnStartEnabled' is absent";
	}

	if (UseDefaultAnswers_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'UseDefaultAnswers' is absent";
	}

	if (CompactHddMask_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'CompactHddMask' is absent";
	}

	if (CompactMode_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'CompactMode' is absent";
	}

	if (DisableWin7Logo_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'DisableWin7Logo' is absent";
	}

	if (OptimizeModifiers_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'OptimizeModifiers' is absent";
	}

	if (StickyMouse_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'StickyMouse' is absent";
	}

	if (PauseOnDeactivation_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'PauseOnDeactivation' is absent";
	}

	if (FEATURES_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'FEATURES_MASK' is absent";
	}

	if (EXT_FEATURES_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_FEATURES_MASK' is absent";
	}

	if (EXT_80000001_ECX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_80000001_ECX_MASK' is absent";
	}

	if (EXT_80000001_EDX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_80000001_EDX_MASK' is absent";
	}

	if (EXT_80000007_EDX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_80000007_EDX_MASK' is absent";
	}

	if (EXT_80000008_EAX_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_80000008_EAX' is absent";
	}

	if (EXT_00000007_EBX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_00000007_EBX_MASK' is absent";
	}

	if (EXT_00000007_EDX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_00000007_EDX_MASK' is absent";
	}

	if (EXT_0000000D_EAX_MASK_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'EXT_0000000D_EAX_MASK' is absent";
	}

	if (CpuFeaturesMaskValid_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'CpuFeaturesMaskValid' is absent";
	}

	if (UnattendedInstallLocale_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'UnattendedInstallLocale' is absent";
	}

	if (UnattendedInstallEdition_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'UnattendedInstallEdition' is absent";
	}

	if (HostRetinaEnabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmRunTimeOptions': tag 'HostRetinaEnabled' is absent";
	}

	syncMaxItemId(nMaxItemId_IoLimit, "IoLimit");


	m_mapPatchedFields.insert("OptimizePowerConsumptionMode", OptimizePowerConsumptionMode_patch_stamp);


	m_mapPatchedFields.insert("StickyMouse", StickyMouse_patch_stamp);


	if ( RootElement->firstChildElement( "ActionOnStop" ).isNull() )
	{
		// pick a value from deprecated isCloseAppOnShutdown() element
		PRL_VM_ACTION_ON_STOP actionOnStop = isCloseAppOnShutdown() ? PAS_CLOSE_VM_WINDOW : PAS_KEEP_VM_WINDOW_OPEN;
		setActionOnStop(actionOnStop);
	}

	return 0;
}

void CVmRunTimeOptions::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CVmIoLimit>(m_lstIoLimit, "IoLimit");
	setItemIds.clear();
	for(i = 0; i < m_lstIoLimit.size(); ++i)
	{
		CVmIoLimit* object = m_lstIoLimit[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "IoLimit", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "IoLimit");

	for(i = 0; i < m_lstOnCrash.size(); ++i)
	{
		CVmOnCrash* object = m_lstOnCrash[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "OnCrash");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstFullScreen.size(); ++i)
	{
		CVmFullScreen* object = m_lstFullScreen[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "FullScreen");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstInternalVmInfo.size(); ++i)
	{
		InternalVmInfo* object = m_lstInternalVmInfo[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "InternalVmInfo");
		object->syncItemIds();
	}

}

bool CVmRunTimeOptions::merge(CVmRunTimeOptions* pCur, CVmRunTimeOptions* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Runtime";

	if (getForegroundPriority() != pCur->getForegroundPriority() && getForegroundPriority() == pPrev->getForegroundPriority())
		setForegroundPriority(pCur->getForegroundPriority());
	else if (getForegroundPriority() != pCur->getForegroundPriority() && getForegroundPriority() != pPrev->getForegroundPriority() && pCur->getForegroundPriority() != pPrev->getForegroundPriority())
	{
		m_qsErrorMessage += ".ForegroundPriority";
		return false;
	}

	if (getBackgroundPriority() != pCur->getBackgroundPriority() && getBackgroundPriority() == pPrev->getBackgroundPriority())
		setBackgroundPriority(pCur->getBackgroundPriority());
	else if (getBackgroundPriority() != pCur->getBackgroundPriority() && getBackgroundPriority() != pPrev->getBackgroundPriority() && pCur->getBackgroundPriority() != pPrev->getBackgroundPriority())
	{
		m_qsErrorMessage += ".BackgroundPriority";
		return false;
	}

	if (getIoPriority() != pCur->getIoPriority() && getIoPriority() == pPrev->getIoPriority())
		setIoPriority(pCur->getIoPriority());
	else if (getIoPriority() != pCur->getIoPriority() && getIoPriority() != pPrev->getIoPriority() && pCur->getIoPriority() != pPrev->getIoPriority())
	{
		m_qsErrorMessage += ".IoPriority";
		return false;
	}

	if (getIopsLimit() != pCur->getIopsLimit() && getIopsLimit() == pPrev->getIopsLimit())
		setIopsLimit(pCur->getIopsLimit());
	else if (getIopsLimit() != pCur->getIopsLimit() && getIopsLimit() != pPrev->getIopsLimit() && pCur->getIopsLimit() != pPrev->getIopsLimit())
	{
		m_qsErrorMessage += ".IopsLimit";
		return false;
	}

	if (getDiskCachePolicy() != pCur->getDiskCachePolicy() && getDiskCachePolicy() == pPrev->getDiskCachePolicy())
		setDiskCachePolicy(pCur->getDiskCachePolicy());
	else if (getDiskCachePolicy() != pCur->getDiskCachePolicy() && getDiskCachePolicy() != pPrev->getDiskCachePolicy() && pCur->getDiskCachePolicy() != pPrev->getDiskCachePolicy())
	{
		m_qsErrorMessage += ".DiskCachePolicy";
		return false;
	}

	if (isCloseAppOnShutdown() != pCur->isCloseAppOnShutdown() && isCloseAppOnShutdown() == pPrev->isCloseAppOnShutdown())
		setCloseAppOnShutdown(pCur->isCloseAppOnShutdown());
	else if (isCloseAppOnShutdown() != pCur->isCloseAppOnShutdown() && isCloseAppOnShutdown() != pPrev->isCloseAppOnShutdown() && pCur->isCloseAppOnShutdown() != pPrev->isCloseAppOnShutdown())
	{
		m_qsErrorMessage += ".CloseAppOnShutdown";
		return false;
	}

	if (getActionOnStop() != pCur->getActionOnStop() && getActionOnStop() == pPrev->getActionOnStop())
		setActionOnStop(pCur->getActionOnStop());
	else if (getActionOnStop() != pCur->getActionOnStop() && getActionOnStop() != pPrev->getActionOnStop() && pCur->getActionOnStop() != pPrev->getActionOnStop())
	{
		m_qsErrorMessage += ".ActionOnStop";
		return false;
	}

	if (getDockIconType() != pCur->getDockIconType() && getDockIconType() == pPrev->getDockIconType())
		setDockIconType(pCur->getDockIconType());
	else if (getDockIconType() != pCur->getDockIconType() && getDockIconType() != pPrev->getDockIconType() && pCur->getDockIconType() != pPrev->getDockIconType())
	{
		m_qsErrorMessage += ".DockIcon";
		return false;
	}

	if (isOsResolutionInFullScreen() != pCur->isOsResolutionInFullScreen() && isOsResolutionInFullScreen() == pPrev->isOsResolutionInFullScreen())
		setOsResolutionInFullScreen(pCur->isOsResolutionInFullScreen());
	else if (isOsResolutionInFullScreen() != pCur->isOsResolutionInFullScreen() && isOsResolutionInFullScreen() != pPrev->isOsResolutionInFullScreen() && pCur->isOsResolutionInFullScreen() != pPrev->isOsResolutionInFullScreen())
	{
		m_qsErrorMessage += ".OsResolutionInFullScreen";
		return false;
	}

	if (getUndoDisksMode() != pCur->getUndoDisksMode() && getUndoDisksMode() == pPrev->getUndoDisksMode())
		setUndoDisksMode(pCur->getUndoDisksMode());
	else if (getUndoDisksMode() != pCur->getUndoDisksMode() && getUndoDisksMode() != pPrev->getUndoDisksMode() && pCur->getUndoDisksMode() != pPrev->getUndoDisksMode())
	{
		m_qsErrorMessage += ".UndoDisks";
		return false;
	}

	if (isSafeMode() != pCur->isSafeMode() && isSafeMode() == pPrev->isSafeMode())
		setSafeMode(pCur->isSafeMode());
	else if (isSafeMode() != pCur->isSafeMode() && isSafeMode() != pPrev->isSafeMode() && pCur->isSafeMode() != pPrev->isSafeMode())
	{
		m_qsErrorMessage += ".SafeMode";
		return false;
	}

	if (getSystemFlags() != pCur->getSystemFlags() && getSystemFlags() == pPrev->getSystemFlags())
		setSystemFlags(pCur->getSystemFlags());
	else if (getSystemFlags() != pCur->getSystemFlags() && getSystemFlags() != pPrev->getSystemFlags() && pCur->getSystemFlags() != pPrev->getSystemFlags())
	{
		m_qsErrorMessage += ".SystemFlags";
		return false;
	}

	if (isDisableAPIC() != pCur->isDisableAPIC() && isDisableAPIC() == pPrev->isDisableAPIC())
		setDisableAPIC(pCur->isDisableAPIC());
	else if (isDisableAPIC() != pCur->isDisableAPIC() && isDisableAPIC() != pPrev->isDisableAPIC() && pCur->isDisableAPIC() != pPrev->isDisableAPIC())
	{
		m_qsErrorMessage += ".DisableAPIC";
		return false;
	}

	if (getOptimizePowerConsumptionMode() != pCur->getOptimizePowerConsumptionMode() && getOptimizePowerConsumptionMode() == pPrev->getOptimizePowerConsumptionMode())
		setOptimizePowerConsumptionMode(pCur->getOptimizePowerConsumptionMode());
	else if (getOptimizePowerConsumptionMode() != pCur->getOptimizePowerConsumptionMode() && getOptimizePowerConsumptionMode() != pPrev->getOptimizePowerConsumptionMode() && pCur->getOptimizePowerConsumptionMode() != pPrev->getOptimizePowerConsumptionMode())
	{
		m_qsErrorMessage += ".OptimizePowerConsumptionMode";
		return false;
	}

	if (isShowBatteryStatus() != pCur->isShowBatteryStatus() && isShowBatteryStatus() == pPrev->isShowBatteryStatus())
		setShowBatteryStatus(pCur->isShowBatteryStatus());
	else if (isShowBatteryStatus() != pCur->isShowBatteryStatus() && isShowBatteryStatus() != pPrev->isShowBatteryStatus() && pCur->isShowBatteryStatus() != pPrev->isShowBatteryStatus())
	{
		m_qsErrorMessage += ".ShowBatteryStatus";
		return false;
	}

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (isEnableAdaptiveHypervisor() != pCur->isEnableAdaptiveHypervisor() && isEnableAdaptiveHypervisor() == pPrev->isEnableAdaptiveHypervisor())
		setEnableAdaptiveHypervisor(pCur->isEnableAdaptiveHypervisor());
	else if (isEnableAdaptiveHypervisor() != pCur->isEnableAdaptiveHypervisor() && isEnableAdaptiveHypervisor() != pPrev->isEnableAdaptiveHypervisor() && pCur->isEnableAdaptiveHypervisor() != pPrev->isEnableAdaptiveHypervisor())
	{
		m_qsErrorMessage += ".EnableAdaptiveHypervisor";
		return false;
	}

	if (isUseSMBiosData() != pCur->isUseSMBiosData() && isUseSMBiosData() == pPrev->isUseSMBiosData())
		setUseSMBiosData(pCur->isUseSMBiosData());
	else if (isUseSMBiosData() != pCur->isUseSMBiosData() && isUseSMBiosData() != pPrev->isUseSMBiosData() && pCur->isUseSMBiosData() != pPrev->isUseSMBiosData())
	{
		m_qsErrorMessage += ".UseSMBiosData";
		return false;
	}

	if (isDisableSpeaker() != pCur->isDisableSpeaker() && isDisableSpeaker() == pPrev->isDisableSpeaker())
		setDisableSpeaker(pCur->isDisableSpeaker());
	else if (isDisableSpeaker() != pCur->isDisableSpeaker() && isDisableSpeaker() != pPrev->isDisableSpeaker() && pCur->isDisableSpeaker() != pPrev->isDisableSpeaker())
	{
		m_qsErrorMessage += ".DisableSpeaker";
		return false;
	}

	if (isHideBiosOnStartEnabled() != pCur->isHideBiosOnStartEnabled() && isHideBiosOnStartEnabled() == pPrev->isHideBiosOnStartEnabled())
		setHideBiosOnStartEnabled(pCur->isHideBiosOnStartEnabled());
	else if (isHideBiosOnStartEnabled() != pCur->isHideBiosOnStartEnabled() && isHideBiosOnStartEnabled() != pPrev->isHideBiosOnStartEnabled() && pCur->isHideBiosOnStartEnabled() != pPrev->isHideBiosOnStartEnabled())
	{
		m_qsErrorMessage += ".HideBiosOnStartEnabled";
		return false;
	}

	if (isUseDefaultAnswers() != pCur->isUseDefaultAnswers() && isUseDefaultAnswers() == pPrev->isUseDefaultAnswers())
		setUseDefaultAnswers(pCur->isUseDefaultAnswers());
	else if (isUseDefaultAnswers() != pCur->isUseDefaultAnswers() && isUseDefaultAnswers() != pPrev->isUseDefaultAnswers() && pCur->isUseDefaultAnswers() != pPrev->isUseDefaultAnswers())
	{
		m_qsErrorMessage += ".UseDefaultAnswers";
		return false;
	}

	if (getCompactHddMask() != pCur->getCompactHddMask() && getCompactHddMask() == pPrev->getCompactHddMask())
		setCompactHddMask(pCur->getCompactHddMask());
	else if (getCompactHddMask() != pCur->getCompactHddMask() && getCompactHddMask() != pPrev->getCompactHddMask() && pCur->getCompactHddMask() != pPrev->getCompactHddMask())
	{
		m_qsErrorMessage += ".CompactHddMask";
		return false;
	}

	if (isCompactMode() != pCur->isCompactMode() && isCompactMode() == pPrev->isCompactMode())
		setCompactMode(pCur->isCompactMode());
	else if (isCompactMode() != pCur->isCompactMode() && isCompactMode() != pPrev->isCompactMode() && pCur->isCompactMode() != pPrev->isCompactMode())
	{
		m_qsErrorMessage += ".CompactMode";
		return false;
	}

	if (isDisableWin7Logo() != pCur->isDisableWin7Logo() && isDisableWin7Logo() == pPrev->isDisableWin7Logo())
		setDisableWin7Logo(pCur->isDisableWin7Logo());
	else if (isDisableWin7Logo() != pCur->isDisableWin7Logo() && isDisableWin7Logo() != pPrev->isDisableWin7Logo() && pCur->isDisableWin7Logo() != pPrev->isDisableWin7Logo())
	{
		m_qsErrorMessage += ".DisableWin7Logo";
		return false;
	}

	if (getOptimizeModifiers() != pCur->getOptimizeModifiers() && getOptimizeModifiers() == pPrev->getOptimizeModifiers())
		setOptimizeModifiers(pCur->getOptimizeModifiers());
	else if (getOptimizeModifiers() != pCur->getOptimizeModifiers() && getOptimizeModifiers() != pPrev->getOptimizeModifiers() && pCur->getOptimizeModifiers() != pPrev->getOptimizeModifiers())
	{
		m_qsErrorMessage += ".OptimizeModifiers";
		return false;
	}

	if (isStickyMouse() != pCur->isStickyMouse() && isStickyMouse() == pPrev->isStickyMouse())
		setStickyMouse(pCur->isStickyMouse());
	else if (isStickyMouse() != pCur->isStickyMouse() && isStickyMouse() != pPrev->isStickyMouse() && pCur->isStickyMouse() != pPrev->isStickyMouse())
	{
		m_qsErrorMessage += ".StickyMouse";
		return false;
	}

	if (isPauseOnDeactivation() != pCur->isPauseOnDeactivation() && isPauseOnDeactivation() == pPrev->isPauseOnDeactivation())
		setPauseOnDeactivation(pCur->isPauseOnDeactivation());
	else if (isPauseOnDeactivation() != pCur->isPauseOnDeactivation() && isPauseOnDeactivation() != pPrev->isPauseOnDeactivation() && pCur->isPauseOnDeactivation() != pPrev->isPauseOnDeactivation())
	{
		m_qsErrorMessage += ".PauseOnDeactivation";
		return false;
	}

	if (getFEATURES_MASK() != pCur->getFEATURES_MASK() && getFEATURES_MASK() == pPrev->getFEATURES_MASK())
		setFEATURES_MASK(pCur->getFEATURES_MASK());
	else if (getFEATURES_MASK() != pCur->getFEATURES_MASK() && getFEATURES_MASK() != pPrev->getFEATURES_MASK() && pCur->getFEATURES_MASK() != pPrev->getFEATURES_MASK())
	{
		m_qsErrorMessage += ".FEATURES_MASK";
		return false;
	}

	if (getEXT_FEATURES_MASK() != pCur->getEXT_FEATURES_MASK() && getEXT_FEATURES_MASK() == pPrev->getEXT_FEATURES_MASK())
		setEXT_FEATURES_MASK(pCur->getEXT_FEATURES_MASK());
	else if (getEXT_FEATURES_MASK() != pCur->getEXT_FEATURES_MASK() && getEXT_FEATURES_MASK() != pPrev->getEXT_FEATURES_MASK() && pCur->getEXT_FEATURES_MASK() != pPrev->getEXT_FEATURES_MASK())
	{
		m_qsErrorMessage += ".EXT_FEATURES_MASK";
		return false;
	}

	if (getEXT_80000001_ECX_MASK() != pCur->getEXT_80000001_ECX_MASK() && getEXT_80000001_ECX_MASK() == pPrev->getEXT_80000001_ECX_MASK())
		setEXT_80000001_ECX_MASK(pCur->getEXT_80000001_ECX_MASK());
	else if (getEXT_80000001_ECX_MASK() != pCur->getEXT_80000001_ECX_MASK() && getEXT_80000001_ECX_MASK() != pPrev->getEXT_80000001_ECX_MASK() && pCur->getEXT_80000001_ECX_MASK() != pPrev->getEXT_80000001_ECX_MASK())
	{
		m_qsErrorMessage += ".EXT_80000001_ECX_MASK";
		return false;
	}

	if (getEXT_80000001_EDX_MASK() != pCur->getEXT_80000001_EDX_MASK() && getEXT_80000001_EDX_MASK() == pPrev->getEXT_80000001_EDX_MASK())
		setEXT_80000001_EDX_MASK(pCur->getEXT_80000001_EDX_MASK());
	else if (getEXT_80000001_EDX_MASK() != pCur->getEXT_80000001_EDX_MASK() && getEXT_80000001_EDX_MASK() != pPrev->getEXT_80000001_EDX_MASK() && pCur->getEXT_80000001_EDX_MASK() != pPrev->getEXT_80000001_EDX_MASK())
	{
		m_qsErrorMessage += ".EXT_80000001_EDX_MASK";
		return false;
	}

	if (getEXT_80000007_EDX_MASK() != pCur->getEXT_80000007_EDX_MASK() && getEXT_80000007_EDX_MASK() == pPrev->getEXT_80000007_EDX_MASK())
		setEXT_80000007_EDX_MASK(pCur->getEXT_80000007_EDX_MASK());
	else if (getEXT_80000007_EDX_MASK() != pCur->getEXT_80000007_EDX_MASK() && getEXT_80000007_EDX_MASK() != pPrev->getEXT_80000007_EDX_MASK() && pCur->getEXT_80000007_EDX_MASK() != pPrev->getEXT_80000007_EDX_MASK())
	{
		m_qsErrorMessage += ".EXT_80000007_EDX_MASK";
		return false;
	}

	if (getEXT_80000008_EAX() != pCur->getEXT_80000008_EAX() && getEXT_80000008_EAX() == pPrev->getEXT_80000008_EAX())
		setEXT_80000008_EAX(pCur->getEXT_80000008_EAX());
	else if (getEXT_80000008_EAX() != pCur->getEXT_80000008_EAX() && getEXT_80000008_EAX() != pPrev->getEXT_80000008_EAX() && pCur->getEXT_80000008_EAX() != pPrev->getEXT_80000008_EAX())
	{
		m_qsErrorMessage += ".EXT_80000008_EAX";
		return false;
	}

	if (getEXT_00000007_EBX_MASK() != pCur->getEXT_00000007_EBX_MASK() && getEXT_00000007_EBX_MASK() == pPrev->getEXT_00000007_EBX_MASK())
		setEXT_00000007_EBX_MASK(pCur->getEXT_00000007_EBX_MASK());
	else if (getEXT_00000007_EBX_MASK() != pCur->getEXT_00000007_EBX_MASK() && getEXT_00000007_EBX_MASK() != pPrev->getEXT_00000007_EBX_MASK() && pCur->getEXT_00000007_EBX_MASK() != pPrev->getEXT_00000007_EBX_MASK())
	{
		m_qsErrorMessage += ".EXT_00000007_EBX_MASK";
		return false;
	}

	if (getEXT_00000007_EDX_MASK() != pCur->getEXT_00000007_EDX_MASK() && getEXT_00000007_EDX_MASK() == pPrev->getEXT_00000007_EDX_MASK())
		setEXT_00000007_EDX_MASK(pCur->getEXT_00000007_EDX_MASK());
	else if (getEXT_00000007_EDX_MASK() != pCur->getEXT_00000007_EDX_MASK() && getEXT_00000007_EDX_MASK() != pPrev->getEXT_00000007_EDX_MASK() && pCur->getEXT_00000007_EDX_MASK() != pPrev->getEXT_00000007_EDX_MASK())
	{
		m_qsErrorMessage += ".EXT_00000007_EDX_MASK";
		return false;
	}

	if (getEXT_0000000D_EAX_MASK() != pCur->getEXT_0000000D_EAX_MASK() && getEXT_0000000D_EAX_MASK() == pPrev->getEXT_0000000D_EAX_MASK())
		setEXT_0000000D_EAX_MASK(pCur->getEXT_0000000D_EAX_MASK());
	else if (getEXT_0000000D_EAX_MASK() != pCur->getEXT_0000000D_EAX_MASK() && getEXT_0000000D_EAX_MASK() != pPrev->getEXT_0000000D_EAX_MASK() && pCur->getEXT_0000000D_EAX_MASK() != pPrev->getEXT_0000000D_EAX_MASK())
	{
		m_qsErrorMessage += ".EXT_0000000D_EAX_MASK";
		return false;
	}

	if (isCpuFeaturesMaskValid() != pCur->isCpuFeaturesMaskValid() && isCpuFeaturesMaskValid() == pPrev->isCpuFeaturesMaskValid())
		setCpuFeaturesMaskValid(pCur->isCpuFeaturesMaskValid());
	else if (isCpuFeaturesMaskValid() != pCur->isCpuFeaturesMaskValid() && isCpuFeaturesMaskValid() != pPrev->isCpuFeaturesMaskValid() && pCur->isCpuFeaturesMaskValid() != pPrev->isCpuFeaturesMaskValid())
	{
		m_qsErrorMessage += ".CpuFeaturesMaskValid";
		return false;
	}

	if (getUnattendedInstallLocale() != pCur->getUnattendedInstallLocale() && getUnattendedInstallLocale() == pPrev->getUnattendedInstallLocale())
		setUnattendedInstallLocale(pCur->getUnattendedInstallLocale());
	else if (getUnattendedInstallLocale() != pCur->getUnattendedInstallLocale() && getUnattendedInstallLocale() != pPrev->getUnattendedInstallLocale() && pCur->getUnattendedInstallLocale() != pPrev->getUnattendedInstallLocale())
	{
		m_qsErrorMessage += ".UnattendedInstallLocale";
		return false;
	}

	if (getUnattendedInstallEdition() != pCur->getUnattendedInstallEdition() && getUnattendedInstallEdition() == pPrev->getUnattendedInstallEdition())
		setUnattendedInstallEdition(pCur->getUnattendedInstallEdition());
	else if (getUnattendedInstallEdition() != pCur->getUnattendedInstallEdition() && getUnattendedInstallEdition() != pPrev->getUnattendedInstallEdition() && pCur->getUnattendedInstallEdition() != pPrev->getUnattendedInstallEdition())
	{
		m_qsErrorMessage += ".UnattendedInstallEdition";
		return false;
	}

	if (isHostRetinaEnabled() != pCur->isHostRetinaEnabled() && isHostRetinaEnabled() == pPrev->isHostRetinaEnabled())
		setHostRetinaEnabled(pCur->isHostRetinaEnabled());
	else if (isHostRetinaEnabled() != pCur->isHostRetinaEnabled() && isHostRetinaEnabled() != pPrev->isHostRetinaEnabled() && pCur->isHostRetinaEnabled() != pPrev->isHostRetinaEnabled())
	{
		m_qsErrorMessage += ".HostRetinaEnabled";
		return false;
	}

	if ( ! mergeList<CVmIoLimit>(m_lstIoLimit, pCur->m_lstIoLimit, pPrev->m_lstIoLimit, "IoLimit", nOptions) )
		return false;

	for(i = 0; i < m_lstOnCrash.size(); i++)
	{
		if ( m_lstOnCrash[i]->merge(pCur->m_lstOnCrash[i], pPrev->m_lstOnCrash[i], nOptions) ) continue;
		QString qsIdx = (m_lstOnCrash.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstOnCrash[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstFullScreen.size(); i++)
	{
		if ( m_lstFullScreen[i]->merge(pCur->m_lstFullScreen[i], pPrev->m_lstFullScreen[i], nOptions) ) continue;
		QString qsIdx = (m_lstFullScreen.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstFullScreen[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstInternalVmInfo.size(); i++)
	{
		if ( m_lstInternalVmInfo[i]->merge(pCur->m_lstInternalVmInfo[i], pPrev->m_lstInternalVmInfo[i], nOptions) ) continue;
		QString qsIdx = (m_lstInternalVmInfo.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstInternalVmInfo[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmRunTimeOptions::diff(const CVmRunTimeOptions* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getForegroundPriority() != pOld->getForegroundPriority())
		lstDiffFullItemIds += getForegroundPriority_id();

	if (getBackgroundPriority() != pOld->getBackgroundPriority())
		lstDiffFullItemIds += getBackgroundPriority_id();

	if (getIoPriority() != pOld->getIoPriority())
		lstDiffFullItemIds += getIoPriority_id();

	if (getIopsLimit() != pOld->getIopsLimit())
		lstDiffFullItemIds += getIopsLimit_id();

	if (getDiskCachePolicy() != pOld->getDiskCachePolicy())
		lstDiffFullItemIds += getDiskCachePolicy_id();

	if (isCloseAppOnShutdown() != pOld->isCloseAppOnShutdown())
		lstDiffFullItemIds += getCloseAppOnShutdown_id();

	if (getActionOnStop() != pOld->getActionOnStop())
		lstDiffFullItemIds += getActionOnStop_id();

	if (getDockIconType() != pOld->getDockIconType())
		lstDiffFullItemIds += getDockIconType_id();

	if (isOsResolutionInFullScreen() != pOld->isOsResolutionInFullScreen())
		lstDiffFullItemIds += getOsResolutionInFullScreen_id();

	if (getUndoDisksMode() != pOld->getUndoDisksMode())
		lstDiffFullItemIds += getUndoDisksMode_id();

	if (isSafeMode() != pOld->isSafeMode())
		lstDiffFullItemIds += getSafeMode_id();

	if (getSystemFlags() != pOld->getSystemFlags())
		lstDiffFullItemIds += getSystemFlags_id();

	if (isDisableAPIC() != pOld->isDisableAPIC())
		lstDiffFullItemIds += getDisableAPIC_id();

	if (getOptimizePowerConsumptionMode() != pOld->getOptimizePowerConsumptionMode())
		lstDiffFullItemIds += getOptimizePowerConsumptionMode_id();

	if (isShowBatteryStatus() != pOld->isShowBatteryStatus())
		lstDiffFullItemIds += getShowBatteryStatus_id();

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (isEnableAdaptiveHypervisor() != pOld->isEnableAdaptiveHypervisor())
		lstDiffFullItemIds += getEnableAdaptiveHypervisor_id();

	if (isUseSMBiosData() != pOld->isUseSMBiosData())
		lstDiffFullItemIds += getUseSMBiosData_id();

	if (isDisableSpeaker() != pOld->isDisableSpeaker())
		lstDiffFullItemIds += getDisableSpeaker_id();

	if (isHideBiosOnStartEnabled() != pOld->isHideBiosOnStartEnabled())
		lstDiffFullItemIds += getHideBiosOnStartEnabled_id();

	if (isUseDefaultAnswers() != pOld->isUseDefaultAnswers())
		lstDiffFullItemIds += getUseDefaultAnswers_id();

	if (getCompactHddMask() != pOld->getCompactHddMask())
		lstDiffFullItemIds += getCompactHddMask_id();

	if (isCompactMode() != pOld->isCompactMode())
		lstDiffFullItemIds += getCompactMode_id();

	if (isDisableWin7Logo() != pOld->isDisableWin7Logo())
		lstDiffFullItemIds += getDisableWin7Logo_id();

	if (getOptimizeModifiers() != pOld->getOptimizeModifiers())
		lstDiffFullItemIds += getOptimizeModifiers_id();

	if (isStickyMouse() != pOld->isStickyMouse())
		lstDiffFullItemIds += getStickyMouse_id();

	if (isPauseOnDeactivation() != pOld->isPauseOnDeactivation())
		lstDiffFullItemIds += getPauseOnDeactivation_id();

	if (getFEATURES_MASK() != pOld->getFEATURES_MASK())
		lstDiffFullItemIds += getFEATURES_MASK_id();

	if (getEXT_FEATURES_MASK() != pOld->getEXT_FEATURES_MASK())
		lstDiffFullItemIds += getEXT_FEATURES_MASK_id();

	if (getEXT_80000001_ECX_MASK() != pOld->getEXT_80000001_ECX_MASK())
		lstDiffFullItemIds += getEXT_80000001_ECX_MASK_id();

	if (getEXT_80000001_EDX_MASK() != pOld->getEXT_80000001_EDX_MASK())
		lstDiffFullItemIds += getEXT_80000001_EDX_MASK_id();

	if (getEXT_80000007_EDX_MASK() != pOld->getEXT_80000007_EDX_MASK())
		lstDiffFullItemIds += getEXT_80000007_EDX_MASK_id();

	if (getEXT_80000008_EAX() != pOld->getEXT_80000008_EAX())
		lstDiffFullItemIds += getEXT_80000008_EAX_id();

	if (getEXT_00000007_EBX_MASK() != pOld->getEXT_00000007_EBX_MASK())
		lstDiffFullItemIds += getEXT_00000007_EBX_MASK_id();

	if (getEXT_00000007_EDX_MASK() != pOld->getEXT_00000007_EDX_MASK())
		lstDiffFullItemIds += getEXT_00000007_EDX_MASK_id();

	if (getEXT_0000000D_EAX_MASK() != pOld->getEXT_0000000D_EAX_MASK())
		lstDiffFullItemIds += getEXT_0000000D_EAX_MASK_id();

	if (isCpuFeaturesMaskValid() != pOld->isCpuFeaturesMaskValid())
		lstDiffFullItemIds += getCpuFeaturesMaskValid_id();

	if (getUnattendedInstallLocale() != pOld->getUnattendedInstallLocale())
		lstDiffFullItemIds += getUnattendedInstallLocale_id();

	if (getUnattendedInstallEdition() != pOld->getUnattendedInstallEdition())
		lstDiffFullItemIds += getUnattendedInstallEdition_id();

	if (isHostRetinaEnabled() != pOld->isHostRetinaEnabled())
		lstDiffFullItemIds += getHostRetinaEnabled_id();

	diffList<CVmIoLimit>(m_lstIoLimit, pOld->m_lstIoLimit, lstDiffFullItemIds);

	for(i = 0; i < m_lstOnCrash.size(); ++i)
		m_lstOnCrash[i]->diff(pOld->m_lstOnCrash[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstFullScreen.size(); ++i)
		m_lstFullScreen[i]->diff(pOld->m_lstFullScreen[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstInternalVmInfo.size(); ++i)
		m_lstInternalVmInfo[i]->diff(pOld->m_lstInternalVmInfo[i], lstDiffFullItemIds);

}

void CVmRunTimeOptions::Copy(const CVmRunTimeOptions& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setForegroundPriority(rObject.getForegroundPriority());
	setBackgroundPriority(rObject.getBackgroundPriority());
	setIoPriority(rObject.getIoPriority());
	setIopsLimit(rObject.getIopsLimit());
	setDiskCachePolicy(rObject.getDiskCachePolicy());
	setCloseAppOnShutdown(rObject.isCloseAppOnShutdown());
	setActionOnStop(rObject.getActionOnStop());
	setDockIconType(rObject.getDockIconType());
	setOsResolutionInFullScreen(rObject.isOsResolutionInFullScreen());
	setUndoDisksMode(rObject.getUndoDisksMode());
	setSafeMode(rObject.isSafeMode());
	setSystemFlags(rObject.getSystemFlags());
	setDisableAPIC(rObject.isDisableAPIC());
	setOptimizePowerConsumptionMode(rObject.getOptimizePowerConsumptionMode());
	setShowBatteryStatus(rObject.isShowBatteryStatus());
	setEnabled(rObject.isEnabled());
	setEnableAdaptiveHypervisor(rObject.isEnableAdaptiveHypervisor());
	setUseSMBiosData(rObject.isUseSMBiosData());
	setDisableSpeaker(rObject.isDisableSpeaker());
	setHideBiosOnStartEnabled(rObject.isHideBiosOnStartEnabled());
	setUseDefaultAnswers(rObject.isUseDefaultAnswers());
	setCompactHddMask(rObject.getCompactHddMask());
	setCompactMode(rObject.isCompactMode());
	setDisableWin7Logo(rObject.isDisableWin7Logo());
	setOptimizeModifiers(rObject.getOptimizeModifiers());
	setStickyMouse(rObject.isStickyMouse());
	setPauseOnDeactivation(rObject.isPauseOnDeactivation());
	setFEATURES_MASK(rObject.getFEATURES_MASK());
	setEXT_FEATURES_MASK(rObject.getEXT_FEATURES_MASK());
	setEXT_80000001_ECX_MASK(rObject.getEXT_80000001_ECX_MASK());
	setEXT_80000001_EDX_MASK(rObject.getEXT_80000001_EDX_MASK());
	setEXT_80000007_EDX_MASK(rObject.getEXT_80000007_EDX_MASK());
	setEXT_80000008_EAX(rObject.getEXT_80000008_EAX());
	setEXT_00000007_EBX_MASK(rObject.getEXT_00000007_EBX_MASK());
	setEXT_00000007_EDX_MASK(rObject.getEXT_00000007_EDX_MASK());
	setEXT_0000000D_EAX_MASK(rObject.getEXT_0000000D_EAX_MASK());
	setCpuFeaturesMaskValid(rObject.isCpuFeaturesMaskValid());
	setUnattendedInstallLocale(rObject.getUnattendedInstallLocale());
	setUnattendedInstallEdition(rObject.getUnattendedInstallEdition());
	setHostRetinaEnabled(rObject.isHostRetinaEnabled());

	ClearList<CVmIoLimit >(m_lstIoLimit);
	for(i = 0; i < rObject.m_lstIoLimit.size(); i++)
		m_lstIoLimit += new CVmIoLimit(rObject.m_lstIoLimit[i]);

	ClearList<CVmOnCrash >(m_lstOnCrash);
	for(i = 0; i < rObject.m_lstOnCrash.size(); i++)
		m_lstOnCrash += new CVmOnCrash(rObject.m_lstOnCrash[i]);

	ClearList<CVmFullScreen >(m_lstFullScreen);
	for(i = 0; i < rObject.m_lstFullScreen.size(); i++)
		m_lstFullScreen += new CVmFullScreen(rObject.m_lstFullScreen[i]);

	ClearList<InternalVmInfo >(m_lstInternalVmInfo);
	for(i = 0; i < rObject.m_lstInternalVmInfo.size(); i++)
		m_lstInternalVmInfo += new InternalVmInfo(rObject.m_lstInternalVmInfo[i]);

	CustomCopy(&rObject);

}

void CVmRunTimeOptions::InitLists()
{
	InitList<CVmOnCrash>(1, m_lstOnCrash);
	InitList<CVmFullScreen>(1, m_lstFullScreen);
	InitList<InternalVmInfo>(1, m_lstInternalVmInfo);
	CustomInit();
}

void CVmRunTimeOptions::ClearLists()
{
	ClearList<CVmIoLimit>(m_lstIoLimit);
	ClearList<CVmOnCrash>(m_lstOnCrash);
	ClearList<CVmFullScreen>(m_lstFullScreen);
	ClearList<InternalVmInfo>(m_lstInternalVmInfo);
}

void CVmRunTimeOptions::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("IoLimit") )
		ClearList<CVmIoLimit>(m_lstIoLimit);
	for(i = 0; i < m_lstOnCrash.size() && ! unite_with_loaded; i++)
	{
		m_lstOnCrash[i]->ClearListsInReadXml();
		m_lstOnCrash[i]->setDefaults();
		m_lstOnCrash[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstFullScreen.size() && ! unite_with_loaded; i++)
	{
		m_lstFullScreen[i]->ClearListsInReadXml();
		m_lstFullScreen[i]->setDefaults();
		m_lstFullScreen[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstInternalVmInfo.size() && ! unite_with_loaded; i++)
	{
		m_lstInternalVmInfo[i]->ClearListsInReadXml();
		m_lstInternalVmInfo[i]->setDefaults();
		m_lstInternalVmInfo[i]->setSectionFakeFlag(true);
	}
}

