////////////////////////////////////////////////////////////////////////////////
///
/// CVmRunTimeOptions.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMRUNTIMEOPTIONS_H
#define CVMRUNTIMEOPTIONS_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmIoLimit.h"
#include "CVmOnCrash.h"
#include "CVmFullScreen.h"
#include "InternalVmInfo.h"


class CVmRunTimeOptions : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmRunTimeOptions();
	CVmRunTimeOptions(const CVmRunTimeOptions& rObject);
	CVmRunTimeOptions(const CVmRunTimeOptions* pObject);
	CVmRunTimeOptions(QFile* pFile);
	CVmRunTimeOptions& operator=(const CVmRunTimeOptions& rObject);
	virtual ~CVmRunTimeOptions();


	bool isOptimizeForVM() const;
    PRL_UNDO_DISKS_MODE getUndoDisksModeEx() const;
    PRL_DOCK_ICON_TYPE getDockIcon() const { return getDockIconType(); }

	virtual void CustomInit();

	QList<CVmIoLimit* >		m_lstIoLimit;
	QList<CVmOnCrash* >		m_lstOnCrash;
	QList<CVmFullScreen* >		m_lstFullScreen;
	QList<InternalVmInfo* >		m_lstInternalVmInfo;

	CVmIoLimit* getIoLimit() const;
	void setIoLimit(CVmIoLimit* pIoLimit);

	CVmOnCrash* getOnCrash() const;
	void setOnCrash(CVmOnCrash* pOnCrash);

	CVmFullScreen* getVmFullScreen() const;
	void setVmFullScreen(CVmFullScreen* pFullScreen);

	InternalVmInfo* getInternalVmInfo() const;
	void setInternalVmInfo(InternalVmInfo* pInternalVmInfo);


	PRL_VM_PRIORITY getForegroundPriority() const;
	void setForegroundPriority(PRL_VM_PRIORITY value = PVR_PRIORITY_NORMAL);

	PRL_VM_PRIORITY getBackgroundPriority() const;
	void setBackgroundPriority(PRL_VM_PRIORITY value = PVR_PRIORITY_NORMAL);

	unsigned int getIoPriority() const;
	void setIoPriority(unsigned int value = 4);

	unsigned int getIopsLimit() const;
	void setIopsLimit(unsigned int value = 0);

	PVE::DiskCacheWritebackOption getDiskCachePolicy() const;
	void setDiskCachePolicy(PVE::DiskCacheWritebackOption value = PVE::DiskCacheWritebackEnabled);

	bool isCloseAppOnShutdown() const;
	void setCloseAppOnShutdown(bool value = false);

	PRL_VM_ACTION_ON_STOP getActionOnStop() const;
	void setActionOnStop(PRL_VM_ACTION_ON_STOP value = PAS_KEEP_VM_WINDOW_OPEN);

	PRL_DOCK_ICON_TYPE getDockIconType() const;
	void setDockIconType(PRL_DOCK_ICON_TYPE value = PIT_DOCK_ICON_SYSTEM);

	bool isOsResolutionInFullScreen() const;
	void setOsResolutionInFullScreen(bool value = false);

	PRL_UNDO_DISKS_MODE getUndoDisksMode() const;
	void setUndoDisksMode(PRL_UNDO_DISKS_MODE value = PUD_DISABLE_UNDO_DISKS);

	bool isSafeMode() const;
	void setSafeMode(bool value = false);

	QString getSystemFlags() const;
	void setSystemFlags(QString value = QString());

	bool isDisableAPIC() const;
	void setDisableAPIC(bool value = false);

	PVE::OptimizePowerConsumptionMode getOptimizePowerConsumptionMode() const;
	void setOptimizePowerConsumptionMode(PVE::OptimizePowerConsumptionMode value = PVE::OptimizePerformance);

	bool isShowBatteryStatus() const;
	void setShowBatteryStatus(bool value = true);

	bool isEnabled() const;
	void setEnabled(bool value = false);

	bool isEnableAdaptiveHypervisor() const;
	void setEnableAdaptiveHypervisor(bool value = false);

	bool isUseSMBiosData() const;
	void setUseSMBiosData(bool value = false);

	bool isDisableSpeaker() const;
	void setDisableSpeaker(bool value = true);

	bool isHideBiosOnStartEnabled() const;
	void setHideBiosOnStartEnabled(bool value = false);

	bool isUseDefaultAnswers() const;
	void setUseDefaultAnswers(bool value = false);

	unsigned int getCompactHddMask() const;
	void setCompactHddMask(unsigned int value = 0);

	bool isCompactMode() const;
	void setCompactMode(bool value = false);

	bool isDisableWin7Logo() const;
	void setDisableWin7Logo(bool value = true);

	PRL_OPTIMIZE_MODIFIERS_MODE getOptimizeModifiers() const;
	void setOptimizeModifiers(PRL_OPTIMIZE_MODIFIERS_MODE value = POD_STANDARD);

	bool isStickyMouse() const;
	void setStickyMouse(bool value = false);

	bool isPauseOnDeactivation() const;
	void setPauseOnDeactivation(bool value = false);

	unsigned int getFEATURES_MASK() const;
	void setFEATURES_MASK(unsigned int value = 0);

	unsigned int getEXT_FEATURES_MASK() const;
	void setEXT_FEATURES_MASK(unsigned int value = 0);

	unsigned int getEXT_80000001_ECX_MASK() const;
	void setEXT_80000001_ECX_MASK(unsigned int value = 0);

	unsigned int getEXT_80000001_EDX_MASK() const;
	void setEXT_80000001_EDX_MASK(unsigned int value = 0);

	unsigned int getEXT_80000007_EDX_MASK() const;
	void setEXT_80000007_EDX_MASK(unsigned int value = 0);

	unsigned int getEXT_80000008_EAX() const;
	void setEXT_80000008_EAX(unsigned int value = 0);

	unsigned int getEXT_00000007_EBX_MASK() const;
	void setEXT_00000007_EBX_MASK(unsigned int value = 0);

	unsigned int getEXT_00000007_EDX_MASK() const;
	void setEXT_00000007_EDX_MASK(unsigned int value = 0);

	unsigned int getEXT_0000000D_EAX_MASK() const;
	void setEXT_0000000D_EAX_MASK(unsigned int value = 0);

	bool isCpuFeaturesMaskValid() const;
	void setCpuFeaturesMaskValid(bool value = false);

	QString getUnattendedInstallLocale() const;
	void setUnattendedInstallLocale(QString value = QString());

	QString getUnattendedInstallEdition() const;
	void setUnattendedInstallEdition(QString value = QString());

	bool isHostRetinaEnabled() const;
	void setHostRetinaEnabled(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getForegroundPriority_id() const;
	QString getBackgroundPriority_id() const;
	QString getIoPriority_id() const;
	QString getIopsLimit_id() const;
	QString getDiskCachePolicy_id() const;
	QString getCloseAppOnShutdown_id() const;
	QString getActionOnStop_id() const;
	QString getDockIconType_id() const;
	QString getOsResolutionInFullScreen_id() const;
	QString getUndoDisksMode_id() const;
	QString getSafeMode_id() const;
	QString getSystemFlags_id() const;
	QString getDisableAPIC_id() const;
	QString getOptimizePowerConsumptionMode_id() const;
	QString getShowBatteryStatus_id() const;
	QString getEnabled_id() const;
	QString getEnableAdaptiveHypervisor_id() const;
	QString getUseSMBiosData_id() const;
	QString getDisableSpeaker_id() const;
	QString getHideBiosOnStartEnabled_id() const;
	QString getUseDefaultAnswers_id() const;
	QString getCompactHddMask_id() const;
	QString getCompactMode_id() const;
	QString getDisableWin7Logo_id() const;
	QString getOptimizeModifiers_id() const;
	QString getStickyMouse_id() const;
	QString getPauseOnDeactivation_id() const;
	QString getFEATURES_MASK_id() const;
	QString getEXT_FEATURES_MASK_id() const;
	QString getEXT_80000001_ECX_MASK_id() const;
	QString getEXT_80000001_EDX_MASK_id() const;
	QString getEXT_80000007_EDX_MASK_id() const;
	QString getEXT_80000008_EAX_id() const;
	QString getEXT_00000007_EBX_MASK_id() const;
	QString getEXT_00000007_EDX_MASK_id() const;
	QString getEXT_0000000D_EAX_MASK_id() const;
	QString getCpuFeaturesMaskValid_id() const;
	QString getUnattendedInstallLocale_id() const;
	QString getUnattendedInstallEdition_id() const;
	QString getHostRetinaEnabled_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmRunTimeOptions* pCur, CVmRunTimeOptions* pPrev, MergeOptions nOptions);

	void diff(const CVmRunTimeOptions* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PRL_VM_PRIORITY		m_ctForegroundPriority;
	PRL_VM_PRIORITY		m_ctBackgroundPriority;
	unsigned int		m_uiIoPriority;
	unsigned int		m_uiIopsLimit;
	PVE::DiskCacheWritebackOption		m_ctDiskCachePolicy;
	bool		m_bCloseAppOnShutdown;
	PRL_VM_ACTION_ON_STOP		m_ctActionOnStop;
	PRL_DOCK_ICON_TYPE		m_ctDockIcon;
	bool		m_bOsResolutionInFullScreen;
	PRL_UNDO_DISKS_MODE		m_ctUndoDisks;
	bool		m_bSafeMode;
	QString		m_qsSystemFlags;
	bool		m_bDisableAPIC;
	PVE::OptimizePowerConsumptionMode		m_ctOptimizePowerConsumptionMode;
	bool		m_bShowBatteryStatus;
	bool		m_bEnabled;
	bool		m_bEnableAdaptiveHypervisor;
	bool		m_bUseSMBiosData;
	bool		m_bDisableSpeaker;
	bool		m_bHideBiosOnStartEnabled;
	bool		m_bUseDefaultAnswers;
	unsigned int		m_uiCompactHddMask;
	bool		m_bCompactMode;
	bool		m_bDisableWin7Logo;
	PRL_OPTIMIZE_MODIFIERS_MODE		m_ctOptimizeModifiers;
	bool		m_bStickyMouse;
	bool		m_bPauseOnDeactivation;
	unsigned int		m_uiFEATURES_MASK;
	unsigned int		m_uiEXT_FEATURES_MASK;
	unsigned int		m_uiEXT_80000001_ECX_MASK;
	unsigned int		m_uiEXT_80000001_EDX_MASK;
	unsigned int		m_uiEXT_80000007_EDX_MASK;
	unsigned int		m_uiEXT_80000008_EAX;
	unsigned int		m_uiEXT_00000007_EBX_MASK;
	unsigned int		m_uiEXT_00000007_EDX_MASK;
	unsigned int		m_uiEXT_0000000D_EAX_MASK;
	bool		m_bCpuFeaturesMaskValid;
	QString		m_qsUnattendedInstallLocale;
	QString		m_qsUnattendedInstallEdition;
	bool		m_bHostRetinaEnabled;

	void Copy(const CVmRunTimeOptions& rObject);

signals:

	void signalForegroundPriorityChanged(PRL_VM_PRIORITY value, QString object_id = QString());
	void signalBackgroundPriorityChanged(PRL_VM_PRIORITY value, QString object_id = QString());
	void signalIoPriorityChanged(unsigned int value, QString object_id = QString());
	void signalIopsLimitChanged(unsigned int value, QString object_id = QString());
	void signalDiskCachePolicyChanged(PVE::DiskCacheWritebackOption value, QString object_id = QString());
	void signalCloseAppOnShutdownChanged(bool value, QString object_id = QString());
	void signalActionOnStopChanged(PRL_VM_ACTION_ON_STOP value, QString object_id = QString());
	void signalDockIconTypeChanged(PRL_DOCK_ICON_TYPE value, QString object_id = QString());
	void signalOsResolutionInFullScreenChanged(bool value, QString object_id = QString());
	void signalUndoDisksModeChanged(PRL_UNDO_DISKS_MODE value, QString object_id = QString());
	void signalSafeModeChanged(bool value, QString object_id = QString());
	void signalSystemFlagsChanged(QString value, QString object_id = QString());
	void signalDisableAPICChanged(bool value, QString object_id = QString());
	void signalOptimizePowerConsumptionModeChanged(PVE::OptimizePowerConsumptionMode value, QString object_id = QString());
	void signalShowBatteryStatusChanged(bool value, QString object_id = QString());
	void signalEnabledChanged(bool value, QString object_id = QString());
	void signalEnableAdaptiveHypervisorChanged(bool value, QString object_id = QString());
	void signalUseSMBiosDataChanged(bool value, QString object_id = QString());
	void signalDisableSpeakerChanged(bool value, QString object_id = QString());
	void signalHideBiosOnStartEnabledChanged(bool value, QString object_id = QString());
	void signalUseDefaultAnswersChanged(bool value, QString object_id = QString());
	void signalCompactHddMaskChanged(unsigned int value, QString object_id = QString());
	void signalCompactModeChanged(bool value, QString object_id = QString());
	void signalDisableWin7LogoChanged(bool value, QString object_id = QString());
	void signalOptimizeModifiersChanged(PRL_OPTIMIZE_MODIFIERS_MODE value, QString object_id = QString());
	void signalStickyMouseChanged(bool value, QString object_id = QString());
	void signalPauseOnDeactivationChanged(bool value, QString object_id = QString());
	void signalFEATURES_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_FEATURES_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_80000001_ECX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_80000001_EDX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_80000007_EDX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_80000008_EAXChanged(unsigned int value, QString object_id = QString());
	void signalEXT_00000007_EBX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_00000007_EDX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalEXT_0000000D_EAX_MASKChanged(unsigned int value, QString object_id = QString());
	void signalCpuFeaturesMaskValidChanged(bool value, QString object_id = QString());
	void signalUnattendedInstallLocaleChanged(QString value, QString object_id = QString());
	void signalUnattendedInstallEditionChanged(QString value, QString object_id = QString());
	void signalHostRetinaEnabledChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeForegroundPriority(PRL_VM_PRIORITY value);
	void slotChangeBackgroundPriority(PRL_VM_PRIORITY value);
	void slotChangeIoPriority(unsigned int value);
	void slotChangeIopsLimit(unsigned int value);
	void slotChangeDiskCachePolicy(PVE::DiskCacheWritebackOption value);
	void slotChangeCloseAppOnShutdown(bool value);
	void slotChangeActionOnStop(PRL_VM_ACTION_ON_STOP value);
	void slotChangeDockIconType(PRL_DOCK_ICON_TYPE value);
	void slotChangeOsResolutionInFullScreen(bool value);
	void slotChangeUndoDisksMode(PRL_UNDO_DISKS_MODE value);
	void slotChangeSafeMode(bool value);
	void slotChangeSystemFlags(QString value);
	void slotChangeDisableAPIC(bool value);
	void slotChangeOptimizePowerConsumptionMode(PVE::OptimizePowerConsumptionMode value);
	void slotChangeShowBatteryStatus(bool value);
	void slotChangeEnabled(bool value);
	void slotChangeEnableAdaptiveHypervisor(bool value);
	void slotChangeUseSMBiosData(bool value);
	void slotChangeDisableSpeaker(bool value);
	void slotChangeHideBiosOnStartEnabled(bool value);
	void slotChangeUseDefaultAnswers(bool value);
	void slotChangeCompactHddMask(unsigned int value);
	void slotChangeCompactMode(bool value);
	void slotChangeDisableWin7Logo(bool value);
	void slotChangeOptimizeModifiers(PRL_OPTIMIZE_MODIFIERS_MODE value);
	void slotChangeStickyMouse(bool value);
	void slotChangePauseOnDeactivation(bool value);
	void slotChangeFEATURES_MASK(unsigned int value);
	void slotChangeEXT_FEATURES_MASK(unsigned int value);
	void slotChangeEXT_80000001_ECX_MASK(unsigned int value);
	void slotChangeEXT_80000001_EDX_MASK(unsigned int value);
	void slotChangeEXT_80000007_EDX_MASK(unsigned int value);
	void slotChangeEXT_80000008_EAX(unsigned int value);
	void slotChangeEXT_00000007_EBX_MASK(unsigned int value);
	void slotChangeEXT_00000007_EDX_MASK(unsigned int value);
	void slotChangeEXT_0000000D_EAX_MASK(unsigned int value);
	void slotChangeCpuFeaturesMaskValid(bool value);
	void slotChangeUnattendedInstallLocale(QString value);
	void slotChangeUnattendedInstallEdition(QString value);
	void slotChangeHostRetinaEnabled(bool value);

};

#ifndef DM_41112569
#define DM_41112569
Q_DECLARE_METATYPE(PRL_VM_PRIORITY)
#endif
#ifndef DM_41112569
#define DM_41112569
Q_DECLARE_METATYPE(PRL_VM_PRIORITY)
#endif
#ifndef DM_60058750
#define DM_60058750
Q_DECLARE_METATYPE(PVE::DiskCacheWritebackOption)
#endif
#ifndef DM_205451168
#define DM_205451168
Q_DECLARE_METATYPE(PRL_VM_ACTION_ON_STOP)
#endif
#ifndef DM_68840101
#define DM_68840101
Q_DECLARE_METATYPE(PRL_DOCK_ICON_TYPE)
#endif
#ifndef DM_134108293
#define DM_134108293
Q_DECLARE_METATYPE(PRL_UNDO_DISKS_MODE)
#endif
#ifndef DM_95855045
#define DM_95855045
Q_DECLARE_METATYPE(PVE::OptimizePowerConsumptionMode)
#endif
#ifndef DM_85351013
#define DM_85351013
Q_DECLARE_METATYPE(PRL_OPTIMIZE_MODIFIERS_MODE)
#endif


#endif
