////////////////////////////////////////////////////////////////////////////////
///
/// CVmScheduleOptions.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSCHEDULEOPTIONS_H
#define CVMSCHEDULEOPTIONS_H


#include <prlcommon/PrlObjects/CBaseNode.h>


class CVmScheduleOptions : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmScheduleOptions();
	CVmScheduleOptions(const CVmScheduleOptions& rObject);
	CVmScheduleOptions(const CVmScheduleOptions* pObject);
	CVmScheduleOptions(QFile* pFile);
	CVmScheduleOptions& operator=(const CVmScheduleOptions& rObject);
	virtual ~CVmScheduleOptions();




	PVE::VmScheduleBasis getScheduleBasis() const;
	void setScheduleBasis(PVE::VmScheduleBasis value = PVE::VmNoSchedule);

	unsigned int getScheduleGranularity() const;
	void setScheduleGranularity(unsigned int value = 0);

	unsigned int getDayOfWeek() const;
	void setDayOfWeek(unsigned int value = 0);

	unsigned int getDayOfMonth() const;
	void setDayOfMonth(unsigned int value = 0);

	unsigned int getDay() const;
	void setDay(unsigned int value = 0);

	unsigned int getWeek() const;
	void setWeek(unsigned int value = 0);

	unsigned int getMonth() const;
	void setMonth(unsigned int value = 0);

	QDate getStartDate() const;
	void setStartDate(QDate value = QDate::currentDate());

	QTime getStartTime() const;
	void setStartTime(QTime value = QTime::currentTime());

	QDate getStopDate() const;
	void setStopDate(QDate value = QDate::currentDate());

	QTime getStopTime() const;
	void setStopTime(QTime value = QTime::currentTime());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getScheduleBasis_id() const;
	QString getScheduleGranularity_id() const;
	QString getDayOfWeek_id() const;
	QString getDayOfMonth_id() const;
	QString getDay_id() const;
	QString getWeek_id() const;
	QString getMonth_id() const;
	QString getStartDate_id() const;
	QString getStartTime_id() const;
	QString getStopDate_id() const;
	QString getStopTime_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmScheduleOptions* pCur, CVmScheduleOptions* pPrev, MergeOptions nOptions);

	void diff(const CVmScheduleOptions* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PVE::VmScheduleBasis		m_ctSchedBasis;
	unsigned int		m_uiSchedGranularity;
	unsigned int		m_uiSchedDayOfWeek;
	unsigned int		m_uiSchedDayOfMonth;
	unsigned int		m_uiSchedDay;
	unsigned int		m_uiSchedWeek;
	unsigned int		m_uiSchedMonth;
	QDate		m_dateSchedStartDate;
	QTime		m_timeSchedStartTime;
	QDate		m_dateSchedStopDate;
	QTime		m_timeSchedStopTime;

	void Copy(const CVmScheduleOptions& rObject);

signals:

	void signalScheduleBasisChanged(PVE::VmScheduleBasis value, QString object_id = QString());
	void signalScheduleGranularityChanged(unsigned int value, QString object_id = QString());
	void signalDayOfWeekChanged(unsigned int value, QString object_id = QString());
	void signalDayOfMonthChanged(unsigned int value, QString object_id = QString());
	void signalDayChanged(unsigned int value, QString object_id = QString());
	void signalWeekChanged(unsigned int value, QString object_id = QString());
	void signalMonthChanged(unsigned int value, QString object_id = QString());
	void signalStartDateChanged(QDate value, QString object_id = QString());
	void signalStartTimeChanged(QTime value, QString object_id = QString());
	void signalStopDateChanged(QDate value, QString object_id = QString());
	void signalStopTimeChanged(QTime value, QString object_id = QString());

private slots:

	void slotChangeScheduleBasis(PVE::VmScheduleBasis value);
	void slotChangeScheduleGranularity(unsigned int value);
	void slotChangeDayOfWeek(unsigned int value);
	void slotChangeDayOfMonth(unsigned int value);
	void slotChangeDay(unsigned int value);
	void slotChangeWeek(unsigned int value);
	void slotChangeMonth(unsigned int value);
	void slotChangeStartDate(QDate value);
	void slotChangeStartTime(QTime value);
	void slotChangeStopDate(QDate value);
	void slotChangeStopTime(QTime value);

};

#ifndef DM_194126691
#define DM_194126691
Q_DECLARE_METATYPE(PVE::VmScheduleBasis)
#endif


#endif
