////////////////////////////////////////////////////////////////////////////////
///
/// CVmScreenResolutions.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmScreenResolutions.h"


CVmScreenResolutions::CVmScreenResolutions()
{
	InitLists();
	setDefaults();
}

CVmScreenResolutions::CVmScreenResolutions(const CVmScreenResolutions& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmScreenResolutions::CVmScreenResolutions(const CVmScreenResolutions* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmScreenResolutions& CVmScreenResolutions::operator=(const CVmScreenResolutions& rObject)
{
	Copy(rObject);
	return *this;
}

CVmScreenResolutions::CVmScreenResolutions(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmScreenResolutions::~CVmScreenResolutions()
{
	ClearLists();
}


void CVmScreenResolutions::addScreenResolution(CVmScreenResolution* item)
{
    m_lstScreenResolutions.append( item );
}

bool CVmScreenResolutions::isEnabled() const
{
	return m_bEnabled;
}

void CVmScreenResolutions::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void CVmScreenResolutions::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

void CVmScreenResolutions::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
}

QVariant CVmScreenResolutions::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	list_tag = "ScreenResolution[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i] && nItemId == m_lstScreenResolutions[i]->getItemId())
				return m_lstScreenResolutions[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("ScreenResolution.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i] && nMaxId < m_lstScreenResolutions[i]->getItemId())
				nMaxId = m_lstScreenResolutions[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("ScreenResolution.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i]) lstIds += m_lstScreenResolutions[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmScreenResolutions::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	list_tag = "ScreenResolution[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i] && nItemId == m_lstScreenResolutions[i]->getItemId())
				return m_lstScreenResolutions[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVmScreenResolutions::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}

int CVmScreenResolutions::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "ScreenResolution")
	{
		m_lstScreenResolutions += new CVmScreenResolution;
		nNewItemId = getMaxItemId<CVmScreenResolution>(m_lstScreenResolutions, "ScreenResolution");
		m_lstScreenResolutions.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "ScreenResolution");
	}

	list_tag = "ScreenResolution[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i] && nItemId == m_lstScreenResolutions[i]->getItemId())
				return m_lstScreenResolutions[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmScreenResolutions::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ScreenResolution[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstScreenResolutions.size(); ++i)
			if (m_lstScreenResolutions[i] && nItemId == m_lstScreenResolutions[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstScreenResolutions[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstScreenResolutions.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmScreenResolutions::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ScreenResolutions") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "ScreenResolution";
	nMaxItemId = getMaxItemId<CVmScreenResolution>(m_lstScreenResolutions, "ScreenResolution", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstScreenResolutions.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmScreenResolution* object = m_lstScreenResolutions[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "ScreenResolution", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmScreenResolutions::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ScreenResolutions") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmScreenResolutions': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_ScreenResolution = getMaxItemId2(element, "ScreenResolution");
	QMap<int , QString > mapScreenResolution;
	if (unite_with_loaded)
		fillItemIdMap<CVmScreenResolution>(m_lstScreenResolutions, mapScreenResolution);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int ScreenResolutions_count = 0;
	int Enabled_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		if (tag_name == "ScreenResolution")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_ScreenResolution++ : nItemId;
			CVmScreenResolution* object = new CVmScreenResolution();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "ScreenResolution", object->getItemId());
			if (unite_with_loaded && mapScreenResolution.contains(nItemId))
				object->fromString(mapScreenResolution.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstScreenResolutions += object;
			--ScreenResolutions_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (ScreenResolutions_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmScreenResolutions': tag 'ScreenResolution' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmScreenResolutions': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_ScreenResolution, "ScreenResolution");


	return 0;
}

void CVmScreenResolutions::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CVmScreenResolution>(m_lstScreenResolutions, "ScreenResolution");
	setItemIds.clear();
	for(i = 0; i < m_lstScreenResolutions.size(); ++i)
	{
		CVmScreenResolution* object = m_lstScreenResolutions[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "ScreenResolution", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "ScreenResolution");

}

bool CVmScreenResolutions::merge(CVmScreenResolutions* pCur, CVmScreenResolutions* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ScreenResolutions";

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if ( ! mergeList<CVmScreenResolution>(m_lstScreenResolutions, pCur->m_lstScreenResolutions, pPrev->m_lstScreenResolutions, "ScreenResolution", nOptions) )
		return false;

	return true;
}

void CVmScreenResolutions::diff(const CVmScreenResolutions* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	diffList<CVmScreenResolution>(m_lstScreenResolutions, pOld->m_lstScreenResolutions, lstDiffFullItemIds);

}

void CVmScreenResolutions::Copy(const CVmScreenResolutions& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());

	ClearList<CVmScreenResolution >(m_lstScreenResolutions);
	for(i = 0; i < rObject.m_lstScreenResolutions.size(); i++)
		m_lstScreenResolutions += new CVmScreenResolution(rObject.m_lstScreenResolutions[i]);

	CustomCopy(&rObject);

}

void CVmScreenResolutions::InitLists()
{
	CustomInit();
}

void CVmScreenResolutions::ClearLists()
{
	ClearList<CVmScreenResolution>(m_lstScreenResolutions);
}

void CVmScreenResolutions::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("ScreenResolution") )
		ClearList<CVmScreenResolution>(m_lstScreenResolutions);
}

