////////////////////////////////////////////////////////////////////////////////
///
/// CVmSecurity.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmSecurity.h"


CVmSecurity::CVmSecurity()
{
	InitLists();
	setDefaults();
}

CVmSecurity::CVmSecurity(const CVmSecurity& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmSecurity::CVmSecurity(const CVmSecurity* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmSecurity& CVmSecurity::operator=(const CVmSecurity& rObject)
{
	Copy(rObject);
	return *this;
}

CVmSecurity::CVmSecurity(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmSecurity::~CVmSecurity()
{
	ClearLists();
}


AccessControlList* CVmSecurity::getAccessControlList() const
{
	if (!m_lstAccessControlList.isEmpty())
	{
		return m_lstAccessControlList[0];
	}
	return 0;
}

void CVmSecurity::setAccessControlList(AccessControlList* pAccessControlList)
{
	ClearList<AccessControlList>(m_lstAccessControlList);
	if (pAccessControlList)
	{
		m_lstAccessControlList += pAccessControlList;
	}
}

CVmLockedOperationsList* CVmSecurity::getLockedOperationsList() const
{
	if (!m_lstLockedOperationsList.isEmpty())
	{
		return m_lstLockedOperationsList[0];
	}
	return 0;
}

void CVmSecurity::setLockedOperationsList(CVmLockedOperationsList* pLockedOperationsList)
{
	ClearList<CVmLockedOperationsList>(m_lstLockedOperationsList);
	if (pLockedOperationsList)
	{
		m_lstLockedOperationsList += pLockedOperationsList;
	}
}

QString CVmSecurity::getOwner() const
{
	return m_qsOwner;
}

void CVmSecurity::setOwner(QString value)
{
	bool bValueChanged = (m_qsOwner != value);
	m_qsOwner = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOwnerChanged(value);
	}
}

void CVmSecurity::slotChangeOwner(QString value)
{
	setOwner(value);
}

bool CVmSecurity::isOwnerPresent() const
{
	return m_bIsOwner;
}

void CVmSecurity::setOwnerPresent(bool value)
{
	bool bValueChanged = (m_bIsOwner != value);
	m_bIsOwner = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOwnerPresentChanged(value);
	}
}

void CVmSecurity::slotChangeOwnerPresent(bool value)
{
	setOwnerPresent(value);
}

PRL_VM_ACCESS_FOR_OTHERS CVmSecurity::getAccessForOthers() const
{
	return m_ctAccessForOthers;
}

void CVmSecurity::setAccessForOthers(PRL_VM_ACCESS_FOR_OTHERS value)
{
	bool bValueChanged = (m_ctAccessForOthers != value);
	m_ctAccessForOthers = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAccessForOthersChanged(value);
	}
}

void CVmSecurity::slotChangeAccessForOthers(PRL_VM_ACCESS_FOR_OTHERS value)
{
	setAccessForOthers(value);
}

bool CVmSecurity::isLockedSign() const
{
	return m_bLockedSign;
}

void CVmSecurity::setLockedSign(bool value)
{
	bool bValueChanged = (m_bLockedSign != value);
	m_bLockedSign = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalLockedSignChanged(value);
	}
}

void CVmSecurity::slotChangeLockedSign(bool value)
{
	setLockedSign(value);
}

bool CVmSecurity::isParentalControlEnabled() const
{
	return m_bParentalControlEnabled;
}

void CVmSecurity::setParentalControlEnabled(bool value)
{
	bool bValueChanged = (m_bParentalControlEnabled != value);
	m_bParentalControlEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalParentalControlEnabledChanged(value);
	}
}

void CVmSecurity::slotChangeParentalControlEnabled(bool value)
{
	setParentalControlEnabled(value);
}

void CVmSecurity::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Owner").isNull() )
		setOwner();
	if ( ! RootElement || ! RootElement->firstChildElement("IsOwner").isNull() )
		setOwnerPresent();
	if ( ! RootElement || ! RootElement->firstChildElement("AccessForOthers").isNull() )
		setAccessForOthers();
	if ( ! RootElement || ! RootElement->firstChildElement("LockedSign").isNull() )
		setLockedSign();
	if ( ! RootElement || ! RootElement->firstChildElement("ParentalControlEnabled").isNull() )
		setParentalControlEnabled();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_VM_ACCESS_FOR_OTHERS >("PRL_VM_ACCESS_FOR_OTHERS");
		first_time = false;
	}

}

QVariant CVmSecurity::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Owner.patch_stamp")
		value.setValue(getFieldPatchedValue("Owner"));

	if (path == "Owner")
		value.setValue(getOwner());

	if (path == "IsOwner.patch_stamp")
		value.setValue(getFieldPatchedValue("IsOwner"));

	if (path == "IsOwner")
		value.setValue(isOwnerPresent());

	if (path == "AccessForOthers.patch_stamp")
		value.setValue(getFieldPatchedValue("AccessForOthers"));

	if (path == "AccessForOthers")
		value.setValue((qlonglong )getAccessForOthers());

	if (path == "LockedSign.patch_stamp")
		value.setValue(getFieldPatchedValue("LockedSign"));

	if (path == "LockedSign")
		value.setValue(isLockedSign());

	if (path == "ParentalControlEnabled.patch_stamp")
		value.setValue(getFieldPatchedValue("ParentalControlEnabled"));

	if (path == "ParentalControlEnabled")
		value.setValue(isParentalControlEnabled());

	list_tag = "AccessControlList.";
	if (path.startsWith(list_tag) && ! m_lstAccessControlList.isEmpty() && m_lstAccessControlList.first())
		return m_lstAccessControlList.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "LockedOperationsList.";
	if (path.startsWith(list_tag) && ! m_lstLockedOperationsList.isEmpty() && m_lstLockedOperationsList.first())
		return m_lstLockedOperationsList.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmSecurity::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Owner.patch_stamp")
	{
		markPatchedField("Owner", value.toString());
		return true;
	}

	if (path == "Owner")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOwner() != value.value< QString >());
		setOwner(value.value< QString >());
		return true;
	}

	if (path == "IsOwner.patch_stamp")
	{
		markPatchedField("IsOwner", value.toString());
		return true;
	}

	if (path == "IsOwner")
	{
		if (pbValueChanged)
			*pbValueChanged = (isOwnerPresent() != value.value< bool >());
		setOwnerPresent(value.value< bool >());
		return true;
	}

	if (path == "AccessForOthers.patch_stamp")
	{
		markPatchedField("AccessForOthers", value.toString());
		return true;
	}

	if (path == "AccessForOthers")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAccessForOthers() != (PRL_VM_ACCESS_FOR_OTHERS )value.value< qlonglong >());
		setAccessForOthers((PRL_VM_ACCESS_FOR_OTHERS )value.value< qlonglong >());
		return true;
	}

	if (path == "LockedSign.patch_stamp")
	{
		markPatchedField("LockedSign", value.toString());
		return true;
	}

	if (path == "LockedSign")
	{
		if (pbValueChanged)
			*pbValueChanged = (isLockedSign() != value.value< bool >());
		setLockedSign(value.value< bool >());
		return true;
	}

	if (path == "ParentalControlEnabled.patch_stamp")
	{
		markPatchedField("ParentalControlEnabled", value.toString());
		return true;
	}

	if (path == "ParentalControlEnabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isParentalControlEnabled() != value.value< bool >());
		setParentalControlEnabled(value.value< bool >());
		return true;
	}

	list_tag = "AccessControlList.";
	if (path.startsWith(list_tag) && ! m_lstAccessControlList.isEmpty() && m_lstAccessControlList.first())
		return m_lstAccessControlList.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "LockedOperationsList.";
	if (path.startsWith(list_tag) && ! m_lstLockedOperationsList.isEmpty() && m_lstLockedOperationsList.first())
		return m_lstLockedOperationsList.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmSecurity::getOwner_id() const
{
	return getFullItemId().isEmpty() ? "Owner" : getFullItemId() + ".Owner";
}
QString CVmSecurity::getOwnerPresent_id() const
{
	return getFullItemId().isEmpty() ? "IsOwner" : getFullItemId() + ".IsOwner";
}
QString CVmSecurity::getAccessForOthers_id() const
{
	return getFullItemId().isEmpty() ? "AccessForOthers" : getFullItemId() + ".AccessForOthers";
}
QString CVmSecurity::getLockedSign_id() const
{
	return getFullItemId().isEmpty() ? "LockedSign" : getFullItemId() + ".LockedSign";
}
QString CVmSecurity::getParentalControlEnabled_id() const
{
	return getFullItemId().isEmpty() ? "ParentalControlEnabled" : getFullItemId() + ".ParentalControlEnabled";
}

int CVmSecurity::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "AccessControlList.";
	if (path.startsWith(list_tag) && ! m_lstAccessControlList.isEmpty() && m_lstAccessControlList.first())
		return m_lstAccessControlList.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "LockedOperationsList.";
	if (path.startsWith(list_tag) && ! m_lstLockedOperationsList.isEmpty() && m_lstLockedOperationsList.first())
		return m_lstLockedOperationsList.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmSecurity::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "AccessControlList.";
	if (path.startsWith(list_tag) && ! m_lstAccessControlList.isEmpty() && m_lstAccessControlList.first())
		return m_lstAccessControlList.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "LockedOperationsList.";
	if (path.startsWith(list_tag) && ! m_lstLockedOperationsList.isEmpty() && m_lstLockedOperationsList.first())
		return m_lstLockedOperationsList.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmSecurity::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Security") : m_qsExtRootTagName);

	for(i = 0; i < m_lstAccessControlList.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const AccessControlList* object = m_lstAccessControlList[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstLockedOperationsList.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmLockedOperationsList* object = m_lstLockedOperationsList[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Owner");
	text_element = Document->createTextNode( QString("%1").arg(getOwner()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("IsOwner");
	text_element = Document->createTextNode( QString("%1").arg(isOwnerPresent()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AccessForOthers");
	text_element = Document->createTextNode( QString("%1").arg(getAccessForOthers()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("LockedSign");
	text_element = Document->createTextNode( QString("%1").arg(isLockedSign()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ParentalControlEnabled");
	text_element = Document->createTextNode( QString("%1").arg(isParentalControlEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmSecurity::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Security") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmSecurity': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int AccessControlList_count = 1;
	int LockedOperationsList_count = 1;
	int Owner_count = 0;
	int IsOwner_count = 0;
	int AccessForOthers_count = 0;
	int LockedSign_count = 0;
	int ParentalControlEnabled_count = 0;

	QString ParentalControlEnabled_patch_stamp = RootElement->attribute("ParentalControlEnabled_patch");
	if (unite_with_loaded && RootElement->firstChildElement("ParentalControlEnabled").isNull())
		ParentalControlEnabled_patch_stamp = getFieldPatchedValue("ParentalControlEnabled");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Owner";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Owner_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Owner")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOwner(text_element.data());
			--Owner_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "IsOwner";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (IsOwner_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "IsOwner")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOwnerPresent(text_element.data().toInt() != 0);
			--IsOwner_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AccessForOthers";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AccessForOthers_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AccessForOthers")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAccessForOthers((PRL_VM_ACCESS_FOR_OTHERS )text_element.data().toLongLong());
			--AccessForOthers_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "LockedSign";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (LockedSign_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "LockedSign")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setLockedSign(text_element.data().toInt() != 0);
			--LockedSign_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ParentalControlEnabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ParentalControlEnabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ParentalControlEnabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setParentalControlEnabled(text_element.data().toInt() != 0);
			--ParentalControlEnabled_count;
		}


		if (tag_name == "AccessControlList" && AccessControlList_count > 0)
		{
			unused_tag = false;
			AccessControlList* object = m_lstAccessControlList[1 - AccessControlList_count];
			object->makeFullItemId(getFullItemId(), "AccessControlList");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--AccessControlList_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "LockedOperationsList" && LockedOperationsList_count > 0)
		{
			unused_tag = false;
			CVmLockedOperationsList* object = m_lstLockedOperationsList[1 - LockedOperationsList_count];
			object->makeFullItemId(getFullItemId(), "LockedOperationsList");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--LockedOperationsList_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (AccessControlList_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'AccessControlList' is absent";
	}

	if (LockedOperationsList_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'LockedOperationsList' is absent";
	}

	if (Owner_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'Owner' is absent";
	}

	if (IsOwner_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'IsOwner' is absent";
	}

	if (AccessForOthers_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'AccessForOthers' is absent";
	}

	if (LockedSign_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'LockedSign' is absent";
	}

	if (ParentalControlEnabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSecurity': tag 'ParentalControlEnabled' is absent";
	}



	m_mapPatchedFields.insert("ParentalControlEnabled", ParentalControlEnabled_patch_stamp);


	return 0;
}

void CVmSecurity::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstAccessControlList.size(); ++i)
	{
		AccessControlList* object = m_lstAccessControlList[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "AccessControlList");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstLockedOperationsList.size(); ++i)
	{
		CVmLockedOperationsList* object = m_lstLockedOperationsList[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "LockedOperationsList");
		object->syncItemIds();
	}

}

bool CVmSecurity::merge(CVmSecurity* pCur, CVmSecurity* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Security";

	if (getOwner() != pCur->getOwner() && getOwner() == pPrev->getOwner())
		setOwner(pCur->getOwner());
	else if (getOwner() != pCur->getOwner() && getOwner() != pPrev->getOwner() && pCur->getOwner() != pPrev->getOwner())
	{
		m_qsErrorMessage += ".Owner";
		return false;
	}

	if (isOwnerPresent() != pCur->isOwnerPresent() && isOwnerPresent() == pPrev->isOwnerPresent())
		setOwnerPresent(pCur->isOwnerPresent());
	else if (isOwnerPresent() != pCur->isOwnerPresent() && isOwnerPresent() != pPrev->isOwnerPresent() && pCur->isOwnerPresent() != pPrev->isOwnerPresent())
	{
		m_qsErrorMessage += ".IsOwner";
		return false;
	}

	if (getAccessForOthers() != pCur->getAccessForOthers() && getAccessForOthers() == pPrev->getAccessForOthers())
		setAccessForOthers(pCur->getAccessForOthers());
	else if (getAccessForOthers() != pCur->getAccessForOthers() && getAccessForOthers() != pPrev->getAccessForOthers() && pCur->getAccessForOthers() != pPrev->getAccessForOthers())
	{
		m_qsErrorMessage += ".AccessForOthers";
		return false;
	}

	if (isLockedSign() != pCur->isLockedSign() && isLockedSign() == pPrev->isLockedSign())
		setLockedSign(pCur->isLockedSign());
	else if (isLockedSign() != pCur->isLockedSign() && isLockedSign() != pPrev->isLockedSign() && pCur->isLockedSign() != pPrev->isLockedSign())
	{
		m_qsErrorMessage += ".LockedSign";
		return false;
	}

	if (isParentalControlEnabled() != pCur->isParentalControlEnabled() && isParentalControlEnabled() == pPrev->isParentalControlEnabled())
		setParentalControlEnabled(pCur->isParentalControlEnabled());
	else if (isParentalControlEnabled() != pCur->isParentalControlEnabled() && isParentalControlEnabled() != pPrev->isParentalControlEnabled() && pCur->isParentalControlEnabled() != pPrev->isParentalControlEnabled())
	{
		m_qsErrorMessage += ".ParentalControlEnabled";
		return false;
	}

	for(i = 0; i < m_lstAccessControlList.size(); i++)
	{
		if ( m_lstAccessControlList[i]->merge(pCur->m_lstAccessControlList[i], pPrev->m_lstAccessControlList[i], nOptions) ) continue;
		QString qsIdx = (m_lstAccessControlList.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstAccessControlList[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstLockedOperationsList.size(); i++)
	{
		if ( m_lstLockedOperationsList[i]->merge(pCur->m_lstLockedOperationsList[i], pPrev->m_lstLockedOperationsList[i], nOptions) ) continue;
		QString qsIdx = (m_lstLockedOperationsList.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstLockedOperationsList[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmSecurity::diff(const CVmSecurity* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getOwner() != pOld->getOwner())
		lstDiffFullItemIds += getOwner_id();

	if (isOwnerPresent() != pOld->isOwnerPresent())
		lstDiffFullItemIds += getOwnerPresent_id();

	if (getAccessForOthers() != pOld->getAccessForOthers())
		lstDiffFullItemIds += getAccessForOthers_id();

	if (isLockedSign() != pOld->isLockedSign())
		lstDiffFullItemIds += getLockedSign_id();

	if (isParentalControlEnabled() != pOld->isParentalControlEnabled())
		lstDiffFullItemIds += getParentalControlEnabled_id();

	for(i = 0; i < m_lstAccessControlList.size(); ++i)
		m_lstAccessControlList[i]->diff(pOld->m_lstAccessControlList[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstLockedOperationsList.size(); ++i)
		m_lstLockedOperationsList[i]->diff(pOld->m_lstLockedOperationsList[i], lstDiffFullItemIds);

}

void CVmSecurity::Copy(const CVmSecurity& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setOwner(rObject.getOwner());
	setOwnerPresent(rObject.isOwnerPresent());
	setAccessForOthers(rObject.getAccessForOthers());
	setLockedSign(rObject.isLockedSign());
	setParentalControlEnabled(rObject.isParentalControlEnabled());

	ClearList<AccessControlList >(m_lstAccessControlList);
	for(i = 0; i < rObject.m_lstAccessControlList.size(); i++)
		m_lstAccessControlList += new AccessControlList(rObject.m_lstAccessControlList[i]);

	ClearList<CVmLockedOperationsList >(m_lstLockedOperationsList);
	for(i = 0; i < rObject.m_lstLockedOperationsList.size(); i++)
		m_lstLockedOperationsList += new CVmLockedOperationsList(rObject.m_lstLockedOperationsList[i]);

	CustomCopy(&rObject);

}

void CVmSecurity::InitLists()
{
	InitList<AccessControlList>(1, m_lstAccessControlList);
	InitList<CVmLockedOperationsList>(1, m_lstLockedOperationsList);
	CustomInit();
}

void CVmSecurity::ClearLists()
{
	ClearList<AccessControlList>(m_lstAccessControlList);
	ClearList<CVmLockedOperationsList>(m_lstLockedOperationsList);
}

void CVmSecurity::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstAccessControlList.size() && ! unite_with_loaded; i++)
	{
		m_lstAccessControlList[i]->ClearListsInReadXml();
		m_lstAccessControlList[i]->setDefaults();
		m_lstAccessControlList[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstLockedOperationsList.size() && ! unite_with_loaded; i++)
	{
		m_lstLockedOperationsList[i]->ClearListsInReadXml();
		m_lstLockedOperationsList[i]->setDefaults();
		m_lstLockedOperationsList[i]->setSectionFakeFlag(true);
	}
}

