////////////////////////////////////////////////////////////////////////////////
///
/// CVmSecurity.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSECURITY_H
#define CVMSECURITY_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "AccessControlList.h"
#include "CVmLockedOperationsList.h"


class CVmSecurity : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmSecurity();
	CVmSecurity(const CVmSecurity& rObject);
	CVmSecurity(const CVmSecurity* pObject);
	CVmSecurity(QFile* pFile);
	CVmSecurity& operator=(const CVmSecurity& rObject);
	virtual ~CVmSecurity();


	QList<AccessControlList* >		m_lstAccessControlList;
	QList<CVmLockedOperationsList* >		m_lstLockedOperationsList;

	AccessControlList* getAccessControlList() const;
	void setAccessControlList(AccessControlList* pAccessControlList);

	CVmLockedOperationsList* getLockedOperationsList() const;
	void setLockedOperationsList(CVmLockedOperationsList* pLockedOperationsList);


	QString getOwner() const;
	void setOwner(QString value = QString());

	bool isOwnerPresent() const;
	void setOwnerPresent(bool value = false);

	PRL_VM_ACCESS_FOR_OTHERS getAccessForOthers() const;
	void setAccessForOthers(PRL_VM_ACCESS_FOR_OTHERS value = PAO_VM_NOT_SHARED);

	bool isLockedSign() const;
	void setLockedSign(bool value = false);

	bool isParentalControlEnabled() const;
	void setParentalControlEnabled(bool value = true);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getOwner_id() const;
	QString getOwnerPresent_id() const;
	QString getAccessForOthers_id() const;
	QString getLockedSign_id() const;
	QString getParentalControlEnabled_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmSecurity* pCur, CVmSecurity* pPrev, MergeOptions nOptions);

	void diff(const CVmSecurity* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsOwner;
	bool		m_bIsOwner;
	PRL_VM_ACCESS_FOR_OTHERS		m_ctAccessForOthers;
	bool		m_bLockedSign;
	bool		m_bParentalControlEnabled;

	void Copy(const CVmSecurity& rObject);

signals:

	void signalOwnerChanged(QString value, QString object_id = QString());
	void signalOwnerPresentChanged(bool value, QString object_id = QString());
	void signalAccessForOthersChanged(PRL_VM_ACCESS_FOR_OTHERS value, QString object_id = QString());
	void signalLockedSignChanged(bool value, QString object_id = QString());
	void signalParentalControlEnabledChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeOwner(QString value);
	void slotChangeOwnerPresent(bool value);
	void slotChangeAccessForOthers(PRL_VM_ACCESS_FOR_OTHERS value);
	void slotChangeLockedSign(bool value);
	void slotChangeParentalControlEnabled(bool value);

};

#ifndef DM_117660051
#define DM_117660051
Q_DECLARE_METATYPE(PRL_VM_ACCESS_FOR_OTHERS)
#endif


#endif
