////////////////////////////////////////////////////////////////////////////////
///
/// CVmSerialPort.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmSerialPort.h"


CVmSerialPort::CVmSerialPort()
{
	InitLists();
	setDefaults();
}

CVmSerialPort::CVmSerialPort(const CVmSerialPort& rObject)
: CVmPort()
{
	Copy(rObject);
}

CVmSerialPort::CVmSerialPort(const CVmSerialPort* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmSerialPort& CVmSerialPort::operator=(const CVmSerialPort& rObject)
{
	Copy(rObject);
	return *this;
}

CVmSerialPort::CVmSerialPort(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmSerialPort::~CVmSerialPort()
{
	ClearLists();
}


bool CVmSerialPort::operator==( const CVmSerialPort& cVmSerialPort)
{
	if (CVmPort::operator ==(cVmSerialPort))
	{
		if (getSocketMode() == cVmSerialPort.getSocketMode())
			return true;
	}
	
	return false;
}

PRL_SERIAL_PORT_SOCKET_OPERATION_MODE CVmSerialPort::getSocketMode() const
{
	return m_ctSocketMode;
}

void CVmSerialPort::setSocketMode(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE value)
{
	bool bValueChanged = (m_ctSocketMode != value);
	m_ctSocketMode = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalSocketModeChanged(value, getObjectId());
	}
}

void CVmSerialPort::slotChangeSocketMode(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE value)
{
	setSocketMode(value);
}

bool CVmSerialPort::isOperateAtRealSpeed() const
{
	return m_bOperateAtRealSpeed;
}

void CVmSerialPort::setOperateAtRealSpeed(bool value)
{
	bool bValueChanged = (m_bOperateAtRealSpeed != value);
	m_bOperateAtRealSpeed = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOperateAtRealSpeedChanged(value, getObjectId());
	}
}

void CVmSerialPort::slotChangeOperateAtRealSpeed(bool value)
{
	setOperateAtRealSpeed(value);
}

void CVmSerialPort::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Index").isNull() )
		setIndex();
	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Connected").isNull() )
		setConnected();
	if ( ! RootElement || ! RootElement->firstChildElement("EmulatedType").isNull() )
		setEmulatedType(PVE::RealSerialPort);
	if ( ! RootElement || ! RootElement->firstChildElement("SystemName").isNull() )
		setSystemName();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
	if ( ! RootElement || ! RootElement->firstChildElement("Remote").isNull() )
		setRemote();
	if ( ! RootElement || ! RootElement->firstChildElement("SocketMode").isNull() )
		setSocketMode();
	if ( ! RootElement || ! RootElement->firstChildElement("OperateAtRealSpeed").isNull() )
		setOperateAtRealSpeed();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceDescription").isNull() )
		setDescription();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::DeviceEnabledState >("PVE::DeviceEnabledState");
		qRegisterMetaType< PVE::DeviceConnectedState >("PVE::DeviceConnectedState");
		qRegisterMetaType< PRL_SERIAL_PORT_SOCKET_OPERATION_MODE >("PRL_SERIAL_PORT_SOCKET_OPERATION_MODE");
		first_time = false;
	}

}

QVariant CVmSerialPort::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Index.patch_stamp")
		value.setValue(getFieldPatchedValue("Index"));

	if (path == "Index")
		value.setValue(CVmDevice::getIndex());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue((qlonglong )CVmDevice::getEnabled());

	if (path == "Connected.patch_stamp")
		value.setValue(getFieldPatchedValue("Connected"));

	if (path == "Connected")
		value.setValue((qlonglong )CVmDevice::getConnected());

	if (path == "EmulatedType.patch_stamp")
		value.setValue(getFieldPatchedValue("EmulatedType"));

	if (path == "EmulatedType")
		value.setValue(CVmDevice::getEmulatedType());

	if (path == "SystemName.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemName"));

	if (path == "SystemName")
		value.setValue(CVmDevice::getSystemName());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(CVmDevice::getUserFriendlyName());

	if (path == "Remote.patch_stamp")
		value.setValue(getFieldPatchedValue("Remote"));

	if (path == "Remote")
		value.setValue(CVmDevice::isRemote());

	if (path == "SocketMode.patch_stamp")
		value.setValue(getFieldPatchedValue("SocketMode"));

	if (path == "SocketMode")
		value.setValue((qlonglong )getSocketMode());

	if (path == "OperateAtRealSpeed.patch_stamp")
		value.setValue(getFieldPatchedValue("OperateAtRealSpeed"));

	if (path == "OperateAtRealSpeed")
		value.setValue(isOperateAtRealSpeed());

	if (path == "DeviceDescription.patch_stamp")
		value.setValue(getFieldPatchedValue("DeviceDescription"));

	if (path == "DeviceDescription")
		value.setValue(CVmDevice::getDescription());

	return value;
}

bool CVmSerialPort::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Index.patch_stamp")
	{
		markPatchedField("Index", value.toString());
		return true;
	}

	if (path == "Index")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getIndex() != value.value< unsigned int >());
		CVmDevice::setIndex(value.value< unsigned int >());
		return true;
	}

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEnabled() != (PVE::DeviceEnabledState )value.value< qlonglong >());
		CVmDevice::setEnabled((PVE::DeviceEnabledState )value.value< qlonglong >());
		return true;
	}

	if (path == "Connected.patch_stamp")
	{
		markPatchedField("Connected", value.toString());
		return true;
	}

	if (path == "Connected")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getConnected() != (PVE::DeviceConnectedState )value.value< qlonglong >());
		CVmDevice::setConnected((PVE::DeviceConnectedState )value.value< qlonglong >());
		return true;
	}

	if (path == "EmulatedType.patch_stamp")
	{
		markPatchedField("EmulatedType", value.toString());
		return true;
	}

	if (path == "EmulatedType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEmulatedType() != value.value< unsigned int >());
		CVmDevice::setEmulatedType(value.value< unsigned int >());
		return true;
	}

	if (path == "SystemName.patch_stamp")
	{
		markPatchedField("SystemName", value.toString());
		return true;
	}

	if (path == "SystemName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getSystemName() != value.value< QString >());
		CVmDevice::setSystemName(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getUserFriendlyName() != value.value< QString >());
		CVmDevice::setUserFriendlyName(value.value< QString >());
		return true;
	}

	if (path == "Remote.patch_stamp")
	{
		markPatchedField("Remote", value.toString());
		return true;
	}

	if (path == "Remote")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::isRemote() != value.value< bool >());
		CVmDevice::setRemote(value.value< bool >());
		return true;
	}

	if (path == "SocketMode.patch_stamp")
	{
		markPatchedField("SocketMode", value.toString());
		return true;
	}

	if (path == "SocketMode")
	{
		if (pbValueChanged)
			*pbValueChanged = (getSocketMode() != (PRL_SERIAL_PORT_SOCKET_OPERATION_MODE )value.value< qlonglong >());
		setSocketMode((PRL_SERIAL_PORT_SOCKET_OPERATION_MODE )value.value< qlonglong >());
		return true;
	}

	if (path == "OperateAtRealSpeed.patch_stamp")
	{
		markPatchedField("OperateAtRealSpeed", value.toString());
		return true;
	}

	if (path == "OperateAtRealSpeed")
	{
		if (pbValueChanged)
			*pbValueChanged = (isOperateAtRealSpeed() != value.value< bool >());
		setOperateAtRealSpeed(value.value< bool >());
		return true;
	}

	if (path == "DeviceDescription.patch_stamp")
	{
		markPatchedField("DeviceDescription", value.toString());
		return true;
	}

	if (path == "DeviceDescription")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getDescription() != value.value< QString >());
		CVmDevice::setDescription(value.value< QString >());
		return true;
	}

	return false;
}

QString CVmSerialPort::getIndex_id() const
{
	return getFullItemId().isEmpty() ? "Index" : getFullItemId() + ".Index";
}
QString CVmSerialPort::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmSerialPort::getConnected_id() const
{
	return getFullItemId().isEmpty() ? "Connected" : getFullItemId() + ".Connected";
}
QString CVmSerialPort::getEmulatedType_id() const
{
	return getFullItemId().isEmpty() ? "EmulatedType" : getFullItemId() + ".EmulatedType";
}
QString CVmSerialPort::getSystemName_id() const
{
	return getFullItemId().isEmpty() ? "SystemName" : getFullItemId() + ".SystemName";
}
QString CVmSerialPort::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}
QString CVmSerialPort::getRemote_id() const
{
	return getFullItemId().isEmpty() ? "Remote" : getFullItemId() + ".Remote";
}
QString CVmSerialPort::getSocketMode_id() const
{
	return getFullItemId().isEmpty() ? "SocketMode" : getFullItemId() + ".SocketMode";
}
QString CVmSerialPort::getOperateAtRealSpeed_id() const
{
	return getFullItemId().isEmpty() ? "OperateAtRealSpeed" : getFullItemId() + ".OperateAtRealSpeed";
}
QString CVmSerialPort::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "DeviceDescription" : getFullItemId() + ".DeviceDescription";
}

int CVmSerialPort::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmSerialPort::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmSerialPort::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Serial") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Index");
	text_element = Document->createTextNode( QString("%1").arg(getIndex()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(getEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Connected");
	text_element = Document->createTextNode( QString("%1").arg(getConnected()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EmulatedType");
	text_element = Document->createTextNode( QString("%1").arg(getEmulatedType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemName");
	text_element = Document->createTextNode( QString("%1").arg(getSystemName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Remote");
	text_element = Document->createTextNode( QString("%1").arg(isRemote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ((PVE::SerialPortEmulatedType)getEmulatedType() == PVE::SerialSocket || (PVE::SerialPortEmulatedType)getEmulatedType() == PVE::SerialTCP)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("SocketMode");
		text_element = Document->createTextNode( QString("%1").arg(getSocketMode()) );
		root_element.appendChild(element);
		element.appendChild(text_element);

	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OperateAtRealSpeed");
	text_element = Document->createTextNode( QString("%1").arg(isOperateAtRealSpeed()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceDescription");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmSerialPort::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Serial") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Index_count = 1;
	int Enabled_count = 1;
	int Connected_count = 1;
	int EmulatedType_count = 1;
	int SystemName_count = 1;
	int UserFriendlyName_count = 1;
	int Remote_count = 1;
	int SocketMode_count = 0;
	int OperateAtRealSpeed_count = 0;
	int DeviceDescription_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "index";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Index_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Index")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setIndex(text_element.data().toUInt());
			--Index_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled((PVE::DeviceEnabledState )text_element.data().toLongLong());
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Connected";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Connected_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Connected")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnected((PVE::DeviceConnectedState )text_element.data().toLongLong());
			--Connected_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EmulatedType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EmulatedType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EmulatedType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEmulatedType(text_element.data().toUInt());
			--EmulatedType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemName(text_element.data());
			--SystemName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Remote";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Remote_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Remote")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemote(text_element.data().toInt() != 0);
			--Remote_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SocketMode";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SocketMode_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SocketMode")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSocketMode((PRL_SERIAL_PORT_SOCKET_OPERATION_MODE )text_element.data().toLongLong());
			--SocketMode_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OperateAtRealSpeed";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OperateAtRealSpeed_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OperateAtRealSpeed")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOperateAtRealSpeed(text_element.data().toInt() != 0);
			--OperateAtRealSpeed_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DeviceDescription";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceDescription_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceDescription")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--DeviceDescription_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Index_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'Index' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Connected_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'Connected' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EmulatedType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'EmulatedType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SystemName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'SystemName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Remote_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSerialPort': tag 'Remote' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SocketMode_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSerialPort': tag 'SocketMode' is absent";
	}

	if (OperateAtRealSpeed_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSerialPort': tag 'OperateAtRealSpeed' is absent";
	}

	if (DeviceDescription_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSerialPort': tag 'DeviceDescription' is absent";
	}



	return 0;
}

void CVmSerialPort::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmSerialPort::merge(CVmSerialPort* pCur, CVmSerialPort* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Serial";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getIndex() != pCur->getIndex() && getIndex() == pPrev->getIndex())
		setIndex(pCur->getIndex());
	else if (getIndex() != pCur->getIndex() && getIndex() != pPrev->getIndex() && pCur->getIndex() != pPrev->getIndex())
	{
		m_qsErrorMessage += ".Index";
		return false;
	}

	if (getEnabled() != pCur->getEnabled() && getEnabled() == pPrev->getEnabled())
		setEnabled(pCur->getEnabled());
	else if (getEnabled() != pCur->getEnabled() && getEnabled() != pPrev->getEnabled() && pCur->getEnabled() != pPrev->getEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getConnected() != pCur->getConnected() && getConnected() == pPrev->getConnected())
		setConnected(pCur->getConnected());
	else if (getConnected() != pCur->getConnected() && getConnected() != pPrev->getConnected() && pCur->getConnected() != pPrev->getConnected())
	{
		m_qsErrorMessage += ".Connected";
		return false;
	}

	if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() == pPrev->getEmulatedType())
		setEmulatedType(pCur->getEmulatedType());
	else if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() != pPrev->getEmulatedType() && pCur->getEmulatedType() != pPrev->getEmulatedType())
	{
		m_qsErrorMessage += ".EmulatedType";
		return false;
	}

	if (getSystemName() != pCur->getSystemName() && getSystemName() == pPrev->getSystemName())
		setSystemName(pCur->getSystemName());
	else if (getSystemName() != pCur->getSystemName() && getSystemName() != pPrev->getSystemName() && pCur->getSystemName() != pPrev->getSystemName())
	{
		m_qsErrorMessage += ".SystemName";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if (isRemote() != pCur->isRemote() && isRemote() == pPrev->isRemote())
		setRemote(pCur->isRemote());
	else if (isRemote() != pCur->isRemote() && isRemote() != pPrev->isRemote() && pCur->isRemote() != pPrev->isRemote())
	{
		m_qsErrorMessage += ".Remote";
		return false;
	}

	if (getSocketMode() != pCur->getSocketMode() && getSocketMode() == pPrev->getSocketMode())
		setSocketMode(pCur->getSocketMode());
	else if (getSocketMode() != pCur->getSocketMode() && getSocketMode() != pPrev->getSocketMode() && pCur->getSocketMode() != pPrev->getSocketMode())
	{
		m_qsErrorMessage += ".SocketMode";
		return false;
	}

	if (isOperateAtRealSpeed() != pCur->isOperateAtRealSpeed() && isOperateAtRealSpeed() == pPrev->isOperateAtRealSpeed())
		setOperateAtRealSpeed(pCur->isOperateAtRealSpeed());
	else if (isOperateAtRealSpeed() != pCur->isOperateAtRealSpeed() && isOperateAtRealSpeed() != pPrev->isOperateAtRealSpeed() && pCur->isOperateAtRealSpeed() != pPrev->isOperateAtRealSpeed())
	{
		m_qsErrorMessage += ".OperateAtRealSpeed";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".DeviceDescription";
		return false;
	}

	return true;
}

void CVmSerialPort::diff(const CVmSerialPort* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getIndex() != pOld->getIndex())
		lstDiffFullItemIds += getIndex_id();

	if (getEnabled() != pOld->getEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getConnected() != pOld->getConnected())
		lstDiffFullItemIds += getConnected_id();

	if (getEmulatedType() != pOld->getEmulatedType())
		lstDiffFullItemIds += getEmulatedType_id();

	if (getSystemName() != pOld->getSystemName())
		lstDiffFullItemIds += getSystemName_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	if (isRemote() != pOld->isRemote())
		lstDiffFullItemIds += getRemote_id();

	if (getSocketMode() != pOld->getSocketMode())
		lstDiffFullItemIds += getSocketMode_id();

	if (isOperateAtRealSpeed() != pOld->isOperateAtRealSpeed())
		lstDiffFullItemIds += getOperateAtRealSpeed_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

}

void CVmSerialPort::Copy(const CVmSerialPort& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setIndex(rObject.getIndex());
	setEnabled(rObject.getEnabled());
	setConnected(rObject.getConnected());
	setEmulatedType(rObject.getEmulatedType());
	setSystemName(rObject.getSystemName());
	setUserFriendlyName(rObject.getUserFriendlyName());
	setRemote(rObject.isRemote());
	setSocketMode(rObject.getSocketMode());
	setOperateAtRealSpeed(rObject.isOperateAtRealSpeed());
	setDescription(rObject.getDescription());

	CustomCopy(&rObject);

}

void CVmSerialPort::InitLists()
{
	CustomInit();
}

void CVmSerialPort::ClearLists()
{
}

void CVmSerialPort::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

