////////////////////////////////////////////////////////////////////////////////
///
/// CVmSerialPort.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSERIALPORT_H
#define CVMSERIALPORT_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmPort.h"


class CVmSerialPort : public CVmPort
{
	Q_OBJECT

public:

	CVmSerialPort();
	CVmSerialPort(const CVmSerialPort& rObject);
	CVmSerialPort(const CVmSerialPort* pObject);
	CVmSerialPort(QFile* pFile);
	CVmSerialPort& operator=(const CVmSerialPort& rObject);
	virtual ~CVmSerialPort();


    PVE::SerialPortEmulatedType getEmulatedType() const { return (PVE::SerialPortEmulatedType )CVmDevice::getEmulatedType(); }

    virtual PRL_DEVICE_TYPE getDeviceType() const { return PDE_SERIAL_PORT; }

    virtual bool operator==( const CVmSerialPort& cVmSerialPort);



	PRL_SERIAL_PORT_SOCKET_OPERATION_MODE getSocketMode() const;
	void setSocketMode(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE value = PSP_SERIAL_SOCKET_SERVER);

	bool isOperateAtRealSpeed() const;
	void setOperateAtRealSpeed(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getIndex_id() const;
	QString getEnabled_id() const;
	QString getConnected_id() const;
	QString getEmulatedType_id() const;
	QString getSystemName_id() const;
	QString getUserFriendlyName_id() const;
	QString getRemote_id() const;
	QString getSocketMode_id() const;
	QString getOperateAtRealSpeed_id() const;
	QString getDescription_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmSerialPort* pCur, CVmSerialPort* pPrev, MergeOptions nOptions);

	void diff(const CVmSerialPort* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PRL_SERIAL_PORT_SOCKET_OPERATION_MODE		m_ctSocketMode;
	bool		m_bOperateAtRealSpeed;

	void Copy(const CVmSerialPort& rObject);

signals:

	void signalSocketModeChanged(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE value, QString object_id = QString());
	void signalOperateAtRealSpeedChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeSocketMode(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE value);
	void slotChangeOperateAtRealSpeed(bool value);

};

#ifndef DM_795237
#define DM_795237
Q_DECLARE_METATYPE(PVE::DeviceEnabledState)
#endif
#ifndef DM_21711685
#define DM_21711685
Q_DECLARE_METATYPE(PVE::DeviceConnectedState)
#endif
#ifndef DM_111150501
#define DM_111150501
Q_DECLARE_METATYPE(PRL_SERIAL_PORT_SOCKET_OPERATION_MODE)
#endif


#endif
