////////////////////////////////////////////////////////////////////////////////
///
/// CVmSettings.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSETTINGS_H
#define CVMSETTINGS_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmCommonOptions.h"
#include "CVmStartupOptions.h"
#include "Shutdown.h"
#include "ClusterOptions.h"
#include "CVmRunTimeOptions.h"
#include "CVmScheduleOptions.h"
#include "CVmRemoteDisplay.h"
#include "CVmTools.h"
#include "CVmAutoprotect.h"
#include "CVmAutoCompress.h"
#include "CVmGlobalNetwork.h"
#include "CVmProtection.h"
#include "CVmSharedCamera.h"
#include "CVmVirtualPrintersInfo.h"
#include "CVmSharedBluetooth.h"
#include "CVmLockDown.h"
#include "CVmUsbController.h"
#include "CVmHighAvailability.h"
#include "CVmOnlineCompact.h"


class CVmSettings : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmSettings();
	CVmSettings(const CVmSettings& rObject);
	CVmSettings(const CVmSettings* pObject);
	CVmSettings(QFile* pFile);
	CVmSettings& operator=(const CVmSettings& rObject);
	virtual ~CVmSettings();


	QList<CVmCommonOptions* >		m_lstGeneral;
	QList<CVmStartupOptions* >		m_lstStartup;
	QList<Shutdown* >		m_lstShutdown;
	QList<ClusterOptions* >		m_lstClusterOptions;
	QList<CVmRunTimeOptions* >		m_lstRuntime;
	QList<CVmScheduleOptions* >		m_lstSchedule;
	QList<CVmRemoteDisplay* >		m_lstRemoteDisplay;
	QList<CVmTools* >		m_lstTools;
	QList<CVmAutoprotect* >		m_lstAutoprotect;
	QList<CVmAutoCompress* >		m_lstAutoCompress;
	QList<CVmGlobalNetwork* >		m_lstGlobalNetwork;
	QList<CVmProtection* >		m_lstVmProtectionInfo;
	QList<CVmSharedCamera* >		m_lstSharedCamera;
	QList<CVmVirtualPrintersInfo* >		m_lstVirtualPrintersInfo;
	QList<CVmSharedBluetooth* >		m_lstSharedBluetooth;
	QList<CVmLockDown* >		m_lstLockDown;
	QList<CVmUsbController* >		m_lstUsbController;
	QList<CVmHighAvailability* >		m_lstHighAvailability;
	QList<CVmOnlineCompact* >		m_lstOnlineCompact;

	CVmCommonOptions* getVmCommonOptions() const;
	void setVmCommonOptions(CVmCommonOptions* pGeneral);

	CVmStartupOptions* getVmStartupOptions() const;
	void setVmStartupOptions(CVmStartupOptions* pStartup);

	Shutdown* getShutdown() const;
	void setShutdown(Shutdown* pShutdown);

	ClusterOptions* getClusterOptions() const;
	void setClusterOptions(ClusterOptions* pClusterOptions);

	CVmRunTimeOptions* getVmRuntimeOptions() const;
	void setVmRuntimeOptions(CVmRunTimeOptions* pRuntime);

	CVmScheduleOptions* getVmScheduleOptions() const;
	void setVmScheduleOptions(CVmScheduleOptions* pSchedule);

	CVmRemoteDisplay* getVmRemoteDisplay() const;
	void setVmRemoteDisplay(CVmRemoteDisplay* pRemoteDisplay);

	CVmTools* getVmTools() const;
	void setVmTools(CVmTools* pTools);

	CVmAutoprotect* getVmAutoprotect() const;
	void setVmAutoprotect(CVmAutoprotect* pAutoprotect);

	CVmAutoCompress* getVmAutoCompress() const;
	void setVmAutoCompress(CVmAutoCompress* pAutoCompress);

	CVmGlobalNetwork* getGlobalNetwork() const;
	void setGlobalNetwork(CVmGlobalNetwork* pGlobalNetwork);

	CVmProtection* getVmProtection() const;
	void setVmProtection(CVmProtection* pVmProtectionInfo);

	CVmSharedCamera* getSharedCamera() const;
	void setSharedCamera(CVmSharedCamera* pSharedCamera);

	CVmVirtualPrintersInfo* getVirtualPrintersInfo() const;
	void setVirtualPrintersInfo(CVmVirtualPrintersInfo* pVirtualPrintersInfo);

	CVmSharedBluetooth* getSharedBluetooth() const;
	void setSharedBluetooth(CVmSharedBluetooth* pSharedBluetooth);

	CVmLockDown* getLockDown() const;
	void setLockDown(CVmLockDown* pLockDown);

	CVmUsbController* getUsbController() const;
	void setUsbController(CVmUsbController* pUsbController);

	CVmHighAvailability* getHighAvailability() const;
	void setHighAvailability(CVmHighAvailability* pHighAvailability);

	CVmOnlineCompact* getOnlineCompact() const;
	void setOnlineCompact(CVmOnlineCompact* pOnlineCompact);


	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmSettings* pCur, CVmSettings* pPrev, MergeOptions nOptions);

	void diff(const CVmSettings* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:


	void Copy(const CVmSettings& rObject);

};



#endif
