////////////////////////////////////////////////////////////////////////////////
///
/// CVmSoundDevice.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmSoundDevice.h"


CVmSoundDevice::CVmSoundDevice()
{
	InitLists();
	setDefaults();
}

CVmSoundDevice::CVmSoundDevice(const CVmSoundDevice& rObject)
: CVmDevice()
{
	Copy(rObject);
}

CVmSoundDevice::CVmSoundDevice(const CVmSoundDevice* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmSoundDevice& CVmSoundDevice::operator=(const CVmSoundDevice& rObject)
{
	Copy(rObject);
	return *this;
}

CVmSoundDevice::CVmSoundDevice(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmSoundDevice::~CVmSoundDevice()
{
	ClearLists();
}


#include "CVmSoundInputs.h"
#include "CVmSoundOutputs.h"

bool CVmSoundDevice::operator==( const CVmSoundDevice& cVmSoundDevice )
{
	if (CVmDevice::operator ==(cVmSoundDevice))
	{
		if (
			(getOutputDevice() == cVmSoundDevice.getOutputDevice())
			 && (getMixerDevice() == cVmSoundDevice.getMixerDevice())
			 && getSoundInputs()->toString() == cVmSoundDevice.getSoundInputs()->toString()
			 && getSoundOutputs()->toString() == cVmSoundDevice.getSoundOutputs()->toString()
			)
			return true;
		
	}
	return false;
}

CVmSoundInputs* CVmSoundDevice::getSoundInputs() const
{
	if (!m_lstSoundInputs.isEmpty())
	{
		return m_lstSoundInputs[0];
	}
	return 0;
}

void CVmSoundDevice::setSoundInputs(CVmSoundInputs* pSoundInputs)
{
	ClearList<CVmSoundInputs>(m_lstSoundInputs);
	if (pSoundInputs)
	{
		m_lstSoundInputs += pSoundInputs;
	}
}

CVmSoundOutputs* CVmSoundDevice::getSoundOutputs() const
{
	if (!m_lstSoundOutputs.isEmpty())
	{
		return m_lstSoundOutputs[0];
	}
	return 0;
}

void CVmSoundDevice::setSoundOutputs(CVmSoundOutputs* pSoundOutputs)
{
	ClearList<CVmSoundOutputs>(m_lstSoundOutputs);
	if (pSoundOutputs)
	{
		m_lstSoundOutputs += pSoundOutputs;
	}
}

QString CVmSoundDevice::getOutputDevice() const
{
	return m_qsOutput;
}

void CVmSoundDevice::setOutputDevice(QString value)
{
	bool bValueChanged = (m_qsOutput != value);
	m_qsOutput = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOutputDeviceChanged(value, getObjectId());
	}
}

void CVmSoundDevice::slotChangeOutputDevice(QString value)
{
	setOutputDevice(value);
}

QString CVmSoundDevice::getMixerDevice() const
{
	return m_qsMixer;
}

void CVmSoundDevice::setMixerDevice(QString value)
{
	bool bValueChanged = (m_qsMixer != value);
	m_qsMixer = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalMixerDeviceChanged(value, getObjectId());
	}
}

void CVmSoundDevice::slotChangeMixerDevice(QString value)
{
	setMixerDevice(value);
}

PRL_SOUND_CHANNEL_TYPE CVmSoundDevice::getChannel() const
{
	return m_ctChannel;
}

void CVmSoundDevice::setChannel(PRL_SOUND_CHANNEL_TYPE value)
{
	bool bValueChanged = (m_ctChannel != value);
	m_ctChannel = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalChannelChanged(value, getObjectId());
	}
}

void CVmSoundDevice::slotChangeChannel(PRL_SOUND_CHANNEL_TYPE value)
{
	setChannel(value);
}

void CVmSoundDevice::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Connected").isNull() )
		setConnected();
	if ( ! RootElement || ! RootElement->firstChildElement("EmulatedType").isNull() )
		setEmulatedType(PVE::AC97);
	if ( ! RootElement || ! RootElement->firstChildElement("SystemName").isNull() )
		setSystemName();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
	if ( ! RootElement || ! RootElement->firstChildElement("Remote").isNull() )
		setRemote();
	if ( ! RootElement || ! RootElement->firstChildElement("Output").isNull() )
		setOutputDevice();
	if ( ! RootElement || ! RootElement->firstChildElement("Mixer").isNull() )
		setMixerDevice();
	if ( ! RootElement || ! RootElement->firstChildElement("Channel").isNull() )
		setChannel();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceDescription").isNull() )
		setDescription();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::DeviceEnabledState >("PVE::DeviceEnabledState");
		qRegisterMetaType< PVE::DeviceConnectedState >("PVE::DeviceConnectedState");
		qRegisterMetaType< PRL_SOUND_CHANNEL_TYPE >("PRL_SOUND_CHANNEL_TYPE");
		first_time = false;
	}

}

QVariant CVmSoundDevice::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue((qlonglong )CVmDevice::getEnabled());

	if (path == "Connected.patch_stamp")
		value.setValue(getFieldPatchedValue("Connected"));

	if (path == "Connected")
		value.setValue((qlonglong )CVmDevice::getConnected());

	if (path == "EmulatedType.patch_stamp")
		value.setValue(getFieldPatchedValue("EmulatedType"));

	if (path == "EmulatedType")
		value.setValue(CVmDevice::getEmulatedType());

	if (path == "SystemName.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemName"));

	if (path == "SystemName")
		value.setValue(CVmDevice::getSystemName());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(CVmDevice::getUserFriendlyName());

	if (path == "Remote.patch_stamp")
		value.setValue(getFieldPatchedValue("Remote"));

	if (path == "Remote")
		value.setValue(CVmDevice::isRemote());

	if (path == "Output.patch_stamp")
		value.setValue(getFieldPatchedValue("Output"));

	if (path == "Output")
		value.setValue(getOutputDevice());

	if (path == "Mixer.patch_stamp")
		value.setValue(getFieldPatchedValue("Mixer"));

	if (path == "Mixer")
		value.setValue(getMixerDevice());

	if (path == "Channel.patch_stamp")
		value.setValue(getFieldPatchedValue("Channel"));

	if (path == "Channel")
		value.setValue((qlonglong )getChannel());

	if (path == "DeviceDescription.patch_stamp")
		value.setValue(getFieldPatchedValue("DeviceDescription"));

	if (path == "DeviceDescription")
		value.setValue(CVmDevice::getDescription());

	list_tag = "SoundInputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundInputs.isEmpty() && m_lstSoundInputs.first())
		return m_lstSoundInputs.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "SoundOutputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundOutputs.isEmpty() && m_lstSoundOutputs.first())
		return m_lstSoundOutputs.first()->getPropertyValue(path.mid(list_tag.size()));

	return value;
}

bool CVmSoundDevice::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEnabled() != (PVE::DeviceEnabledState )value.value< qlonglong >());
		CVmDevice::setEnabled((PVE::DeviceEnabledState )value.value< qlonglong >());
		return true;
	}

	if (path == "Connected.patch_stamp")
	{
		markPatchedField("Connected", value.toString());
		return true;
	}

	if (path == "Connected")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getConnected() != (PVE::DeviceConnectedState )value.value< qlonglong >());
		CVmDevice::setConnected((PVE::DeviceConnectedState )value.value< qlonglong >());
		return true;
	}

	if (path == "EmulatedType.patch_stamp")
	{
		markPatchedField("EmulatedType", value.toString());
		return true;
	}

	if (path == "EmulatedType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEmulatedType() != value.value< unsigned int >());
		CVmDevice::setEmulatedType(value.value< unsigned int >());
		return true;
	}

	if (path == "SystemName.patch_stamp")
	{
		markPatchedField("SystemName", value.toString());
		return true;
	}

	if (path == "SystemName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getSystemName() != value.value< QString >());
		CVmDevice::setSystemName(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getUserFriendlyName() != value.value< QString >());
		CVmDevice::setUserFriendlyName(value.value< QString >());
		return true;
	}

	if (path == "Remote.patch_stamp")
	{
		markPatchedField("Remote", value.toString());
		return true;
	}

	if (path == "Remote")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::isRemote() != value.value< bool >());
		CVmDevice::setRemote(value.value< bool >());
		return true;
	}

	if (path == "Output.patch_stamp")
	{
		markPatchedField("Output", value.toString());
		return true;
	}

	if (path == "Output")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOutputDevice() != value.value< QString >());
		setOutputDevice(value.value< QString >());
		return true;
	}

	if (path == "Mixer.patch_stamp")
	{
		markPatchedField("Mixer", value.toString());
		return true;
	}

	if (path == "Mixer")
	{
		if (pbValueChanged)
			*pbValueChanged = (getMixerDevice() != value.value< QString >());
		setMixerDevice(value.value< QString >());
		return true;
	}

	if (path == "Channel.patch_stamp")
	{
		markPatchedField("Channel", value.toString());
		return true;
	}

	if (path == "Channel")
	{
		if (pbValueChanged)
			*pbValueChanged = (getChannel() != (PRL_SOUND_CHANNEL_TYPE )value.value< qlonglong >());
		setChannel((PRL_SOUND_CHANNEL_TYPE )value.value< qlonglong >());
		return true;
	}

	if (path == "DeviceDescription.patch_stamp")
	{
		markPatchedField("DeviceDescription", value.toString());
		return true;
	}

	if (path == "DeviceDescription")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getDescription() != value.value< QString >());
		CVmDevice::setDescription(value.value< QString >());
		return true;
	}

	list_tag = "SoundInputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundInputs.isEmpty() && m_lstSoundInputs.first())
		return m_lstSoundInputs.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "SoundOutputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundOutputs.isEmpty() && m_lstSoundOutputs.first())
		return m_lstSoundOutputs.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	return false;
}

QString CVmSoundDevice::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmSoundDevice::getConnected_id() const
{
	return getFullItemId().isEmpty() ? "Connected" : getFullItemId() + ".Connected";
}
QString CVmSoundDevice::getEmulatedType_id() const
{
	return getFullItemId().isEmpty() ? "EmulatedType" : getFullItemId() + ".EmulatedType";
}
QString CVmSoundDevice::getSystemName_id() const
{
	return getFullItemId().isEmpty() ? "SystemName" : getFullItemId() + ".SystemName";
}
QString CVmSoundDevice::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}
QString CVmSoundDevice::getRemote_id() const
{
	return getFullItemId().isEmpty() ? "Remote" : getFullItemId() + ".Remote";
}
QString CVmSoundDevice::getOutputDevice_id() const
{
	return getFullItemId().isEmpty() ? "Output" : getFullItemId() + ".Output";
}
QString CVmSoundDevice::getMixerDevice_id() const
{
	return getFullItemId().isEmpty() ? "Mixer" : getFullItemId() + ".Mixer";
}
QString CVmSoundDevice::getChannel_id() const
{
	return getFullItemId().isEmpty() ? "Channel" : getFullItemId() + ".Channel";
}
QString CVmSoundDevice::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "DeviceDescription" : getFullItemId() + ".DeviceDescription";
}

int CVmSoundDevice::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "SoundInputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundInputs.isEmpty() && m_lstSoundInputs.first())
		return m_lstSoundInputs.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "SoundOutputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundOutputs.isEmpty() && m_lstSoundOutputs.first())
		return m_lstSoundOutputs.first()->addListItem(path.mid(list_tag.size()));

	return nNewItemId;
}

bool CVmSoundDevice::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "SoundInputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundInputs.isEmpty() && m_lstSoundInputs.first())
		return m_lstSoundInputs.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "SoundOutputs.";
	if (path.startsWith(list_tag) && ! m_lstSoundOutputs.isEmpty() && m_lstSoundOutputs.first())
		return m_lstSoundOutputs.first()->deleteListItem(path.mid(list_tag.size()));

	return false;
}

QDomElement CVmSoundDevice::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Sound") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(getEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Connected");
	text_element = Document->createTextNode( QString("%1").arg(getConnected()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EmulatedType");
	text_element = Document->createTextNode( QString("%1").arg(getEmulatedType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemName");
	text_element = Document->createTextNode( QString("%1").arg(getSystemName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Remote");
	text_element = Document->createTextNode( QString("%1").arg(isRemote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Output");
	text_element = Document->createTextNode( QString("%1").arg(getOutputDevice()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Mixer");
	text_element = Document->createTextNode( QString("%1").arg(getMixerDevice()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Channel");
	text_element = Document->createTextNode( QString("%1").arg(getChannel()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	for(i = 0; i < m_lstSoundInputs.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSoundInputs* object = m_lstSoundInputs[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstSoundOutputs.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmSoundOutputs* object = m_lstSoundOutputs[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceDescription");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmSoundDevice::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Sound") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int SoundInputs_count = 1;
	int SoundOutputs_count = 1;
	int Enabled_count = 1;
	int Connected_count = 1;
	int EmulatedType_count = 1;
	int SystemName_count = 1;
	int UserFriendlyName_count = 1;
	int Remote_count = 1;
	int Output_count = 1;
	int Mixer_count = 0;
	int Channel_count = 0;
	int DeviceDescription_count = 0;

	QString Output_patch_stamp = RootElement->attribute("Output_patch");
	if (unite_with_loaded && RootElement->firstChildElement("Output").isNull())
		Output_patch_stamp = getFieldPatchedValue("Output");
	QString Mixer_patch_stamp = RootElement->attribute("Mixer_patch");
	if (unite_with_loaded && RootElement->firstChildElement("Mixer").isNull())
		Mixer_patch_stamp = getFieldPatchedValue("Mixer");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled((PVE::DeviceEnabledState )text_element.data().toLongLong());
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Connected";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Connected_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Connected")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnected((PVE::DeviceConnectedState )text_element.data().toLongLong());
			--Connected_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EmulatedType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EmulatedType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EmulatedType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEmulatedType(text_element.data().toUInt());
			--EmulatedType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemName(text_element.data());
			--SystemName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Remote";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Remote_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Remote")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemote(text_element.data().toInt() != 0);
			--Remote_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Output";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Output_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Output")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOutputDevice(text_element.data());
			--Output_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Mixer";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Mixer_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Mixer")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setMixerDevice(text_element.data());
			--Mixer_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Channel";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Channel_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Channel")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setChannel((PRL_SOUND_CHANNEL_TYPE )text_element.data().toLongLong());
			--Channel_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DeviceDescription";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceDescription_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceDescription")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--DeviceDescription_count;
		}


		if (tag_name == "SoundInputs" && SoundInputs_count > 0)
		{
			unused_tag = false;
			CVmSoundInputs* object = m_lstSoundInputs[1 - SoundInputs_count];
			object->makeFullItemId(getFullItemId(), "SoundInputs");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--SoundInputs_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "SoundOutputs" && SoundOutputs_count > 0)
		{
			unused_tag = false;
			CVmSoundOutputs* object = m_lstSoundOutputs[1 - SoundOutputs_count];
			object->makeFullItemId(getFullItemId(), "SoundOutputs");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--SoundOutputs_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (SoundInputs_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmSoundDevice': tag 'SoundInputs' is absent";
	}

	if (SoundOutputs_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmSoundDevice': tag 'SoundOutputs' is absent";
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Connected_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'Connected' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EmulatedType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'EmulatedType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SystemName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'SystemName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Remote_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'Remote' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Output_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmSoundDevice': tag 'Output' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Mixer_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSoundDevice': tag 'Mixer' is absent";
	}

	if (Channel_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSoundDevice': tag 'Channel' is absent";
	}

	if (DeviceDescription_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmSoundDevice': tag 'DeviceDescription' is absent";
	}



	if ( Output_patch_stamp != "1" )
	{
		if (getOutputDevice().isEmpty())
			setOutputDevice(PRL_SOUND_DEFAULT_DEVICE_NAME);
		Output_patch_stamp = "1";
	}
	m_mapPatchedFields.insert("Output", Output_patch_stamp);


	if ( Mixer_patch_stamp != "1" )
	{
		if (getMixerDevice().isEmpty())
			setMixerDevice(PRL_SOUND_DEFAULT_DEVICE_NAME);
		Mixer_patch_stamp = "1";
	}
	m_mapPatchedFields.insert("Mixer", Mixer_patch_stamp);


	return 0;
}

void CVmSoundDevice::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstSoundInputs.size(); ++i)
	{
		CVmSoundInputs* object = m_lstSoundInputs[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "SoundInputs");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstSoundOutputs.size(); ++i)
	{
		CVmSoundOutputs* object = m_lstSoundOutputs[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "SoundOutputs");
		object->syncItemIds();
	}

}

bool CVmSoundDevice::merge(CVmSoundDevice* pCur, CVmSoundDevice* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Sound";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getEnabled() != pCur->getEnabled() && getEnabled() == pPrev->getEnabled())
		setEnabled(pCur->getEnabled());
	else if (getEnabled() != pCur->getEnabled() && getEnabled() != pPrev->getEnabled() && pCur->getEnabled() != pPrev->getEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getConnected() != pCur->getConnected() && getConnected() == pPrev->getConnected())
		setConnected(pCur->getConnected());
	else if (getConnected() != pCur->getConnected() && getConnected() != pPrev->getConnected() && pCur->getConnected() != pPrev->getConnected())
	{
		m_qsErrorMessage += ".Connected";
		return false;
	}

	if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() == pPrev->getEmulatedType())
		setEmulatedType(pCur->getEmulatedType());
	else if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() != pPrev->getEmulatedType() && pCur->getEmulatedType() != pPrev->getEmulatedType())
	{
		m_qsErrorMessage += ".EmulatedType";
		return false;
	}

	if (getSystemName() != pCur->getSystemName() && getSystemName() == pPrev->getSystemName())
		setSystemName(pCur->getSystemName());
	else if (getSystemName() != pCur->getSystemName() && getSystemName() != pPrev->getSystemName() && pCur->getSystemName() != pPrev->getSystemName())
	{
		m_qsErrorMessage += ".SystemName";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if (isRemote() != pCur->isRemote() && isRemote() == pPrev->isRemote())
		setRemote(pCur->isRemote());
	else if (isRemote() != pCur->isRemote() && isRemote() != pPrev->isRemote() && pCur->isRemote() != pPrev->isRemote())
	{
		m_qsErrorMessage += ".Remote";
		return false;
	}

	if (getOutputDevice() != pCur->getOutputDevice() && getOutputDevice() == pPrev->getOutputDevice())
		setOutputDevice(pCur->getOutputDevice());
	else if (getOutputDevice() != pCur->getOutputDevice() && getOutputDevice() != pPrev->getOutputDevice() && pCur->getOutputDevice() != pPrev->getOutputDevice())
	{
		m_qsErrorMessage += ".Output";
		return false;
	}

	if (getMixerDevice() != pCur->getMixerDevice() && getMixerDevice() == pPrev->getMixerDevice())
		setMixerDevice(pCur->getMixerDevice());
	else if (getMixerDevice() != pCur->getMixerDevice() && getMixerDevice() != pPrev->getMixerDevice() && pCur->getMixerDevice() != pPrev->getMixerDevice())
	{
		m_qsErrorMessage += ".Mixer";
		return false;
	}

	if (getChannel() != pCur->getChannel() && getChannel() == pPrev->getChannel())
		setChannel(pCur->getChannel());
	else if (getChannel() != pCur->getChannel() && getChannel() != pPrev->getChannel() && pCur->getChannel() != pPrev->getChannel())
	{
		m_qsErrorMessage += ".Channel";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".DeviceDescription";
		return false;
	}

	for(i = 0; i < m_lstSoundInputs.size(); i++)
	{
		if ( m_lstSoundInputs[i]->merge(pCur->m_lstSoundInputs[i], pPrev->m_lstSoundInputs[i], nOptions) ) continue;
		QString qsIdx = (m_lstSoundInputs.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstSoundInputs[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstSoundOutputs.size(); i++)
	{
		if ( m_lstSoundOutputs[i]->merge(pCur->m_lstSoundOutputs[i], pPrev->m_lstSoundOutputs[i], nOptions) ) continue;
		QString qsIdx = (m_lstSoundOutputs.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstSoundOutputs[i]->GetErrorMessage();
		return false;
	}

	return true;
}

void CVmSoundDevice::diff(const CVmSoundDevice* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getEnabled() != pOld->getEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getConnected() != pOld->getConnected())
		lstDiffFullItemIds += getConnected_id();

	if (getEmulatedType() != pOld->getEmulatedType())
		lstDiffFullItemIds += getEmulatedType_id();

	if (getSystemName() != pOld->getSystemName())
		lstDiffFullItemIds += getSystemName_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	if (isRemote() != pOld->isRemote())
		lstDiffFullItemIds += getRemote_id();

	if (getOutputDevice() != pOld->getOutputDevice())
		lstDiffFullItemIds += getOutputDevice_id();

	if (getMixerDevice() != pOld->getMixerDevice())
		lstDiffFullItemIds += getMixerDevice_id();

	if (getChannel() != pOld->getChannel())
		lstDiffFullItemIds += getChannel_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

	for(i = 0; i < m_lstSoundInputs.size(); ++i)
		m_lstSoundInputs[i]->diff(pOld->m_lstSoundInputs[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstSoundOutputs.size(); ++i)
		m_lstSoundOutputs[i]->diff(pOld->m_lstSoundOutputs[i], lstDiffFullItemIds);

}

void CVmSoundDevice::Copy(const CVmSoundDevice& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.getEnabled());
	setConnected(rObject.getConnected());
	setEmulatedType(rObject.getEmulatedType());
	setSystemName(rObject.getSystemName());
	setUserFriendlyName(rObject.getUserFriendlyName());
	setRemote(rObject.isRemote());
	setOutputDevice(rObject.getOutputDevice());
	setMixerDevice(rObject.getMixerDevice());
	setChannel(rObject.getChannel());
	setDescription(rObject.getDescription());

	ClearList<CVmSoundInputs >(m_lstSoundInputs);
	for(i = 0; i < rObject.m_lstSoundInputs.size(); i++)
		m_lstSoundInputs += new CVmSoundInputs(rObject.m_lstSoundInputs[i]);

	ClearList<CVmSoundOutputs >(m_lstSoundOutputs);
	for(i = 0; i < rObject.m_lstSoundOutputs.size(); i++)
		m_lstSoundOutputs += new CVmSoundOutputs(rObject.m_lstSoundOutputs[i]);

	CustomCopy(&rObject);

}

void CVmSoundDevice::InitLists()
{
	InitList<CVmSoundInputs>(1, m_lstSoundInputs);
	InitList<CVmSoundOutputs>(1, m_lstSoundOutputs);
	CustomInit();
}

void CVmSoundDevice::ClearLists()
{
	ClearList<CVmSoundInputs>(m_lstSoundInputs);
	ClearList<CVmSoundOutputs>(m_lstSoundOutputs);
}

void CVmSoundDevice::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstSoundInputs.size() && ! unite_with_loaded; i++)
	{
		m_lstSoundInputs[i]->ClearListsInReadXml();
		m_lstSoundInputs[i]->setDefaults();
		m_lstSoundInputs[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstSoundOutputs.size() && ! unite_with_loaded; i++)
	{
		m_lstSoundOutputs[i]->ClearListsInReadXml();
		m_lstSoundOutputs[i]->setDefaults();
		m_lstSoundOutputs[i]->setSectionFakeFlag(true);
	}
}

