////////////////////////////////////////////////////////////////////////////////
///
/// CVmSoundDevice.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSOUNDDEVICE_H
#define CVMSOUNDDEVICE_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmDevice.h"

class CVmSoundInputs;
class CVmSoundOutputs;
#define CVMSOUNDINPUTS_H
#define CVMSOUNDOUTPUTS_H
#include "CVmSoundInputs.h"
#include "CVmSoundOutputs.h"


class CVmSoundDevice : public CVmDevice
{
	Q_OBJECT

public:

	CVmSoundDevice();
	CVmSoundDevice(const CVmSoundDevice& rObject);
	CVmSoundDevice(const CVmSoundDevice* pObject);
	CVmSoundDevice(QFile* pFile);
	CVmSoundDevice& operator=(const CVmSoundDevice& rObject);
	virtual ~CVmSoundDevice();


    PVE::SoundDeviceEmulatedType getEmulatedType() const { return (PVE::SoundDeviceEmulatedType )CVmDevice::getEmulatedType(); }

    virtual PRL_DEVICE_TYPE getDeviceType() const { return PDE_SOUND_DEVICE; }

    virtual bool operator==( const CVmSoundDevice& cVmSoundDevice );

	QList<CVmSoundInputs* >		m_lstSoundInputs;
	QList<CVmSoundOutputs* >		m_lstSoundOutputs;

	CVmSoundInputs* getSoundInputs() const;
	void setSoundInputs(CVmSoundInputs* pSoundInputs);

	CVmSoundOutputs* getSoundOutputs() const;
	void setSoundOutputs(CVmSoundOutputs* pSoundOutputs);


	QString getOutputDevice() const;
	void setOutputDevice(QString value = PRL_SOUND_DEFAULT_DEVICE_NAME);

	QString getMixerDevice() const;
	void setMixerDevice(QString value = PRL_SOUND_DEFAULT_DEVICE_NAME);

	PRL_SOUND_CHANNEL_TYPE getChannel() const;
	void setChannel(PRL_SOUND_CHANNEL_TYPE value = PSCT_AUTO);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getEnabled_id() const;
	QString getConnected_id() const;
	QString getEmulatedType_id() const;
	QString getSystemName_id() const;
	QString getUserFriendlyName_id() const;
	QString getRemote_id() const;
	QString getOutputDevice_id() const;
	QString getMixerDevice_id() const;
	QString getChannel_id() const;
	QString getDescription_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmSoundDevice* pCur, CVmSoundDevice* pPrev, MergeOptions nOptions);

	void diff(const CVmSoundDevice* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsOutput;
	QString		m_qsMixer;
	PRL_SOUND_CHANNEL_TYPE		m_ctChannel;

	void Copy(const CVmSoundDevice& rObject);

signals:

	void signalOutputDeviceChanged(QString value, QString object_id = QString());
	void signalMixerDeviceChanged(QString value, QString object_id = QString());
	void signalChannelChanged(PRL_SOUND_CHANNEL_TYPE value, QString object_id = QString());

private slots:

	void slotChangeOutputDevice(QString value);
	void slotChangeMixerDevice(QString value);
	void slotChangeChannel(PRL_SOUND_CHANNEL_TYPE value);

};

#ifndef DM_795237
#define DM_795237
Q_DECLARE_METATYPE(PVE::DeviceEnabledState)
#endif
#ifndef DM_21711685
#define DM_21711685
Q_DECLARE_METATYPE(PVE::DeviceConnectedState)
#endif
#ifndef DM_249916325
#define DM_249916325
Q_DECLARE_METATYPE(PRL_SOUND_CHANNEL_TYPE)
#endif

#undef CVMSOUNDINPUTS_H
#undef CVMSOUNDOUTPUTS_H


#endif
