////////////////////////////////////////////////////////////////////////////////
///
/// CVmStartupBios.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmStartupBios.h"


CVmStartupBios::CVmStartupBios()
{
	InitLists();
	setDefaults();
}

CVmStartupBios::CVmStartupBios(const CVmStartupBios& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

CVmStartupBios::CVmStartupBios(const CVmStartupBios* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmStartupBios& CVmStartupBios::operator=(const CVmStartupBios& rObject)
{
	Copy(rObject);
	return *this;
}

CVmStartupBios::CVmStartupBios(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmStartupBios::~CVmStartupBios()
{
	ClearLists();
}


bool CVmStartupBios::isEfiEnabled() const
{
	return m_bEfiEnabled;
}

void CVmStartupBios::setEfiEnabled(bool value)
{
	bool bValueChanged = (m_bEfiEnabled != value);
	m_bEfiEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEfiEnabledChanged(value);
	}
}

void CVmStartupBios::slotChangeEfiEnabled(bool value)
{
	setEfiEnabled(value);
}

QString CVmStartupBios::getNVRAM() const
{
	return m_qsNVRAM;
}

void CVmStartupBios::setNVRAM(QString value)
{
	bool bValueChanged = (m_qsNVRAM != value);
	m_qsNVRAM = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalNVRAMChanged(value);
	}
}

void CVmStartupBios::slotChangeNVRAM(QString value)
{
	setNVRAM(value);
}

void CVmStartupBios::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("EfiEnabled").isNull() )
		setEfiEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("NVRAM").isNull() )
		setNVRAM();
}

QVariant CVmStartupBios::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "EfiEnabled.patch_stamp")
		value.setValue(getFieldPatchedValue("EfiEnabled"));

	if (path == "EfiEnabled")
		value.setValue(isEfiEnabled());

	if (path == "NVRAM.patch_stamp")
		value.setValue(getFieldPatchedValue("NVRAM"));

	if (path == "NVRAM")
		value.setValue(getNVRAM());

	return value;
}

bool CVmStartupBios::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "EfiEnabled.patch_stamp")
	{
		markPatchedField("EfiEnabled", value.toString());
		return true;
	}

	if (path == "EfiEnabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEfiEnabled() != value.value< bool >());
		setEfiEnabled(value.value< bool >());
		return true;
	}

	if (path == "NVRAM.patch_stamp")
	{
		markPatchedField("NVRAM", value.toString());
		return true;
	}

	if (path == "NVRAM")
	{
		if (pbValueChanged)
			*pbValueChanged = (getNVRAM() != value.value< QString >());
		setNVRAM(value.value< QString >());
		return true;
	}

	return false;
}

QString CVmStartupBios::getEfiEnabled_id() const
{
	return getFullItemId().isEmpty() ? "EfiEnabled" : getFullItemId() + ".EfiEnabled";
}
QString CVmStartupBios::getNVRAM_id() const
{
	return getFullItemId().isEmpty() ? "NVRAM" : getFullItemId() + ".NVRAM";
}

int CVmStartupBios::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmStartupBios::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmStartupBios::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Bios") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EfiEnabled");
	text_element = Document->createTextNode( QString("%1").arg(isEfiEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("NVRAM");
	text_element = Document->createTextNode( QString("%1").arg(getNVRAM()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmStartupBios::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Bios") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmStartupBios': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int EfiEnabled_count = 0;
	int NVRAM_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "EfiEnabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EfiEnabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EfiEnabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEfiEnabled(text_element.data().toInt() != 0);
			--EfiEnabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "NVRAM";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (NVRAM_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "NVRAM")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setNVRAM(text_element.data());
			--NVRAM_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (EfiEnabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmStartupBios': tag 'EfiEnabled' is absent";
	}

	if (NVRAM_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmStartupBios': tag 'NVRAM' is absent";
	}



	return 0;
}

void CVmStartupBios::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmStartupBios::merge(CVmStartupBios* pCur, CVmStartupBios* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Bios";

	if (isEfiEnabled() != pCur->isEfiEnabled() && isEfiEnabled() == pPrev->isEfiEnabled())
		setEfiEnabled(pCur->isEfiEnabled());
	else if (isEfiEnabled() != pCur->isEfiEnabled() && isEfiEnabled() != pPrev->isEfiEnabled() && pCur->isEfiEnabled() != pPrev->isEfiEnabled())
	{
		m_qsErrorMessage += ".EfiEnabled";
		return false;
	}

	if (getNVRAM() != pCur->getNVRAM() && getNVRAM() == pPrev->getNVRAM())
		setNVRAM(pCur->getNVRAM());
	else if (getNVRAM() != pCur->getNVRAM() && getNVRAM() != pPrev->getNVRAM() && pCur->getNVRAM() != pPrev->getNVRAM())
	{
		m_qsErrorMessage += ".NVRAM";
		return false;
	}

	return true;
}

void CVmStartupBios::diff(const CVmStartupBios* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEfiEnabled() != pOld->isEfiEnabled())
		lstDiffFullItemIds += getEfiEnabled_id();

	if (getNVRAM() != pOld->getNVRAM())
		lstDiffFullItemIds += getNVRAM_id();

}

void CVmStartupBios::Copy(const CVmStartupBios& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEfiEnabled(rObject.isEfiEnabled());
	setNVRAM(rObject.getNVRAM());

	CustomCopy(&rObject);

}

void CVmStartupBios::InitLists()
{
	CustomInit();
}

void CVmStartupBios::ClearLists()
{
}

void CVmStartupBios::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

