////////////////////////////////////////////////////////////////////////////////
///
/// CVmStartupOptionsBase.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMSTARTUPOPTIONSBASE_H
#define CVMSTARTUPOPTIONSBASE_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "BootingOrder.h"
#include "CVmStartupBios.h"


class CVmStartupOptionsBase : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmStartupOptionsBase();
	CVmStartupOptionsBase(const CVmStartupOptionsBase& rObject);
	CVmStartupOptionsBase(const CVmStartupOptionsBase* pObject);
	CVmStartupOptionsBase(QFile* pFile);
	CVmStartupOptionsBase& operator=(const CVmStartupOptionsBase& rObject);
	virtual ~CVmStartupOptionsBase();


	QList<BootingOrder* >		m_lstBootingOrder;
	QList<CVmStartupBios* >		m_lstBios;

	BootingOrder* getBootingOrder() const;
	void setBootingOrder(BootingOrder* pBootingOrder);

	CVmStartupBios* getBios() const;
	void setBios(CVmStartupBios* pBios);


	PRL_VM_AUTOSTART_OPTION getAutoStart() const;
	void setAutoStart(PRL_VM_AUTOSTART_OPTION value = PAO_VM_START_MANUAL);

	unsigned int getAutoStartDelay() const;
	void setAutoStartDelay(unsigned int value = 0);

	PRL_VM_START_LOGIN_MODE getVmStartLoginMode() const;
	void setVmStartLoginMode(PRL_VM_START_LOGIN_MODE value = PLM_START_ACCOUNT);

	QString getVmFastRebootUser() const;
	void setVmFastRebootUser(QString value = QString());

	QString getVmStartAsUser() const;
	void setVmStartAsUser(QString value = QString());

	QString getVmStartAsPassword() const;
	void setVmStartAsPassword(QString value = QString());

	bool isChangedPassword() const;
	void setChangedPassword(bool value = false);

	PRL_VM_WINDOW_MODE getWindowMode() const;
	void setWindowMode(PRL_VM_WINDOW_MODE value = PWM_DEFAULT_WINDOW_MODE);

	bool isLockInFullScreenMode() const;
	void setLockInFullScreenMode(bool value = false);

	bool isStartInDetachedWindow() const;
	void setStartInDetachedWindow(bool value = false);

	bool isAllowSelectBootDevice() const;
	void setAllowSelectBootDevice(bool value = false);

	bool isFastReboot() const;
	void setFastReboot(bool value = false);

	unsigned int getBootOrderPrio() const;
	void setBootOrderPrio(unsigned int value = 0);

	QString getExternalDeviceSystemName() const;
	void setExternalDeviceSystemName(QString value = QString());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getAutoStart_id() const;
	QString getAutoStartDelay_id() const;
	QString getVmStartLoginMode_id() const;
	QString getVmFastRebootUser_id() const;
	QString getVmStartAsUser_id() const;
	QString getVmStartAsPassword_id() const;
	QString getChangedPassword_id() const;
	QString getWindowMode_id() const;
	QString getLockInFullScreenMode_id() const;
	QString getStartInDetachedWindow_id() const;
	QString getAllowSelectBootDevice_id() const;
	QString getFastReboot_id() const;
	QString getBootOrderPrio_id() const;
	QString getExternalDeviceSystemName_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmStartupOptionsBase* pCur, CVmStartupOptionsBase* pPrev, MergeOptions nOptions);

	void diff(const CVmStartupOptionsBase* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PRL_VM_AUTOSTART_OPTION		m_ctAutoStart;
	unsigned int		m_uiAutoStartDelay;
	PRL_VM_START_LOGIN_MODE		m_ctVmStartLoginMode;
	QString		m_qsVmFastRebootUser;
	QString		m_qsVmStartAsUser;
	QString		m_qsVmStartAsPassword;
	bool		m_bChangedPassword;
	PRL_VM_WINDOW_MODE		m_ctWindowMode;
	bool		m_bLockInFullScreenMode;
	bool		m_bStartInDetachedWindow;
	bool		m_bAllowSelectBootDevice;
	bool		m_bFastReboot;
	unsigned int		m_uiBootOrderPrio;
	QString		m_qsExternalDeviceSystemName;

	void Copy(const CVmStartupOptionsBase& rObject);

signals:

	void signalAutoStartChanged(PRL_VM_AUTOSTART_OPTION value, QString object_id = QString());
	void signalAutoStartDelayChanged(unsigned int value, QString object_id = QString());
	void signalVmStartLoginModeChanged(PRL_VM_START_LOGIN_MODE value, QString object_id = QString());
	void signalVmFastRebootUserChanged(QString value, QString object_id = QString());
	void signalVmStartAsUserChanged(QString value, QString object_id = QString());
	void signalVmStartAsPasswordChanged(QString value, QString object_id = QString());
	void signalChangedPasswordChanged(bool value, QString object_id = QString());
	void signalWindowModeChanged(PRL_VM_WINDOW_MODE value, QString object_id = QString());
	void signalLockInFullScreenModeChanged(bool value, QString object_id = QString());
	void signalStartInDetachedWindowChanged(bool value, QString object_id = QString());
	void signalAllowSelectBootDeviceChanged(bool value, QString object_id = QString());
	void signalFastRebootChanged(bool value, QString object_id = QString());
	void signalBootOrderPrioChanged(unsigned int value, QString object_id = QString());
	void signalExternalDeviceSystemNameChanged(QString value, QString object_id = QString());

private slots:

	void slotChangeAutoStart(PRL_VM_AUTOSTART_OPTION value);
	void slotChangeAutoStartDelay(unsigned int value);
	void slotChangeVmStartLoginMode(PRL_VM_START_LOGIN_MODE value);
	void slotChangeVmFastRebootUser(QString value);
	void slotChangeVmStartAsUser(QString value);
	void slotChangeVmStartAsPassword(QString value);
	void slotChangeChangedPassword(bool value);
	void slotChangeWindowMode(PRL_VM_WINDOW_MODE value);
	void slotChangeLockInFullScreenMode(bool value);
	void slotChangeStartInDetachedWindow(bool value);
	void slotChangeAllowSelectBootDevice(bool value);
	void slotChangeFastReboot(bool value);
	void slotChangeBootOrderPrio(unsigned int value);
	void slotChangeExternalDeviceSystemName(QString value);

};

#ifndef DM_120814974
#define DM_120814974
Q_DECLARE_METATYPE(PRL_VM_AUTOSTART_OPTION)
#endif
#ifndef DM_374597
#define DM_374597
Q_DECLARE_METATYPE(PRL_VM_START_LOGIN_MODE)
#endif
#ifndef DM_119239749
#define DM_119239749
Q_DECLARE_METATYPE(PRL_VM_WINDOW_MODE)
#endif


#endif
