////////////////////////////////////////////////////////////////////////////////
///
/// CVmTools.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMTOOLS_H
#define CVMTOOLS_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmCoherence.h"
#include "CVmSharing.h"
#include "CVmSharedProfile.h"
#include "CVmSharedApplications.h"
#include "AutoUpdate.h"
#include "ClipboardSync.h"
#include "DragAndDrop.h"
#include "CVmKeyboardLayoutSync.h"
#include "MouseSync.h"
#include "MouseVtdSync.h"
#include "SmartMouse.h"
#include "SmoothScrolling.h"
#include "CVmToolsTimeSync.h"
#include "TisDatabase.h"
#include "CVmModality.h"
#include "CVmSharedVolumes.h"
#include "CVmGestures.h"
#include "CVmRemoteControl.h"
#include "CVmNativeLook.h"
#include "CVmAutoSyncOSType.h"
#include "CVmWin7Look.h"


class CVmTools : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmTools();
	CVmTools(const CVmTools& rObject);
	CVmTools(const CVmTools* pObject);
	CVmTools(QFile* pFile);
	CVmTools& operator=(const CVmTools& rObject);
	virtual ~CVmTools();


	QList<CVmCoherence* >		m_lstCoherence;
	QList<CVmSharing* >		m_lstSharedFolders;
	QList<CVmSharedProfile* >		m_lstSharedProfile;
	QList<CVmSharedApplications* >		m_lstSharedApplications;
	QList<AutoUpdate* >		m_lstAutoUpdate;
	QList<ClipboardSync* >		m_lstClipboardSync;
	QList<DragAndDrop* >		m_lstDragAndDrop;
	QList<CVmKeyboardLayoutSync* >		m_lstKeyboardLayoutSync;
	QList<MouseSync* >		m_lstMouseSync;
	QList<MouseVtdSync* >		m_lstMouseVtdSync;
	QList<SmartMouse* >		m_lstSmartMouse;
	QList<SmoothScrolling* >		m_lstSmoothScrolling;
	QList<CVmToolsTimeSync* >		m_lstTimeSync;
	QList<TisDatabase* >		m_lstTisDatabase;
	QList<CVmModality* >		m_lstModality;
	QList<CVmSharedVolumes* >		m_lstSharedVolumes;
	QList<CVmGestures* >		m_lstGestures;
	QList<CVmRemoteControl* >		m_lstRemoteControl;
	QList<CVmNativeLook* >		m_lstNativeLook;
	QList<CVmAutoSyncOSType* >		m_lstAutoSyncOSType;
	QList<CVmWin7Look* >		m_lstWin7Look;

	CVmCoherence* getVmCoherence() const;
	void setVmCoherence(CVmCoherence* pCoherence);

	CVmSharing* getVmSharing() const;
	void setVmSharing(CVmSharing* pSharedFolders);

	CVmSharedProfile* getVmSharedProfile() const;
	void setVmSharedProfile(CVmSharedProfile* pSharedProfile);

	CVmSharedApplications* getVmSharedApplications() const;
	void setVmSharedApplications(CVmSharedApplications* pSharedApplications);

	AutoUpdate* getAutoUpdate() const;
	void setAutoUpdate(AutoUpdate* pAutoUpdate);

	ClipboardSync* getClipboardSync() const;
	void setClipboardSync(ClipboardSync* pClipboardSync);

	DragAndDrop* getDragAndDrop() const;
	void setDragAndDrop(DragAndDrop* pDragAndDrop);

	CVmKeyboardLayoutSync* getKeyboardLayoutSync() const;
	void setKeyboardLayoutSync(CVmKeyboardLayoutSync* pKeyboardLayoutSync);

	MouseSync* getMouseSync() const;
	void setMouseSync(MouseSync* pMouseSync);

	MouseVtdSync* getMouseVtdSync() const;
	void setMouseVtdSync(MouseVtdSync* pMouseVtdSync);

	SmartMouse* getSmartMouse() const;
	void setSmartMouse(SmartMouse* pSmartMouse);

	SmoothScrolling* getSmoothScrolling() const;
	void setSmoothScrolling(SmoothScrolling* pSmoothScrolling);

	CVmToolsTimeSync* getTimeSync() const;
	void setTimeSync(CVmToolsTimeSync* pTimeSync);

	TisDatabase* getTisDatabase() const;
	void setTisDatabase(TisDatabase* pTisDatabase);

	CVmModality* getModality() const;
	void setModality(CVmModality* pModality);

	CVmSharedVolumes* getSharedVolumes() const;
	void setSharedVolumes(CVmSharedVolumes* pSharedVolumes);

	CVmGestures* getGestures() const;
	void setGestures(CVmGestures* pGestures);

	CVmRemoteControl* getRemoteControl() const;
	void setRemoteControl(CVmRemoteControl* pRemoteControl);

	CVmNativeLook* getNativeLook() const;
	void setNativeLook(CVmNativeLook* pNativeLook);

	CVmAutoSyncOSType* getAutoSyncOSType() const;
	void setAutoSyncOSType(CVmAutoSyncOSType* pAutoSyncOSType);

	CVmWin7Look* getWin7Look() const;
	void setWin7Look(CVmWin7Look* pWin7Look);


	QString getAgentVersion() const;
	void setAgentVersion(QString value = QString());

	bool isIsolatedVm() const;
	void setIsolatedVm(bool value = false);

	bool isNonAdminToolsUpgrade() const;
	void setNonAdminToolsUpgrade(bool value = true);

	bool isLockGuestOnSuspend() const;
	void setLockGuestOnSuspend(bool value = false);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getAgentVersion_id() const;
	QString getIsolatedVm_id() const;
	QString getNonAdminToolsUpgrade_id() const;
	QString getLockGuestOnSuspend_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmTools* pCur, CVmTools* pPrev, MergeOptions nOptions);

	void diff(const CVmTools* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsAgentVersion;
	bool		m_bIsolatedVm;
	bool		m_bNonAdminToolsUpgrade;
	bool		m_bLockGuestOnSuspend;

	void Copy(const CVmTools& rObject);

signals:

	void signalAgentVersionChanged(QString value, QString object_id = QString());
	void signalIsolatedVmChanged(bool value, QString object_id = QString());
	void signalNonAdminToolsUpgradeChanged(bool value, QString object_id = QString());
	void signalLockGuestOnSuspendChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeAgentVersion(QString value);
	void slotChangeIsolatedVm(bool value);
	void slotChangeNonAdminToolsUpgrade(bool value);
	void slotChangeLockGuestOnSuspend(bool value);

};



#endif
