////////////////////////////////////////////////////////////////////////////////
///
/// CVmUsbDevice.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmUsbDevice.h"


CVmUsbDevice::CVmUsbDevice()
{
	InitLists();
	setDefaults();
}

CVmUsbDevice::CVmUsbDevice(const CVmUsbDevice& rObject)
: CVmDevice()
{
	Copy(rObject);
}

CVmUsbDevice::CVmUsbDevice(const CVmUsbDevice* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmUsbDevice& CVmUsbDevice::operator=(const CVmUsbDevice& rObject)
{
	Copy(rObject);
	return *this;
}

CVmUsbDevice::CVmUsbDevice(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmUsbDevice::~CVmUsbDevice()
{
	ClearLists();
}


bool CVmUsbDevice::operator==( const CVmUsbDevice& cVmUsbDevice )
{
	if (CVmDevice::operator ==(cVmUsbDevice ))
	{
		if (getAutoconnectDevices() == cVmUsbDevice.getAutoconnectDevices())
			return true;
		
	}
	return false;
}

PRL_USB_DEVICE_AUTO_CONNECT_OPTION CVmUsbDevice::getAutoconnectDevices() const
{
	return m_ctAutoConnect;
}

void CVmUsbDevice::setAutoconnectDevices(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value)
{
	bool bValueChanged = (m_ctAutoConnect != value);
	m_ctAutoConnect = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAutoconnectDevicesChanged(value, getObjectId());
	}
}

void CVmUsbDevice::slotChangeAutoconnectDevices(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value)
{
	setAutoconnectDevices(value);
}

PRL_USB_DEVICE_CONNECT_REASON CVmUsbDevice::getConnectReason() const
{
	return m_ctConnectReason;
}

void CVmUsbDevice::setConnectReason(PRL_USB_DEVICE_CONNECT_REASON value)
{
	bool bValueChanged = (m_ctConnectReason != value);
	m_ctConnectReason = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalConnectReasonChanged(value, getObjectId());
	}
}

void CVmUsbDevice::slotChangeConnectReason(PRL_USB_DEVICE_CONNECT_REASON value)
{
	setConnectReason(value);
}

bool CVmUsbDevice::isCACSupportEnabled() const
{
	return m_bCACSupportEnabled;
}

void CVmUsbDevice::setCACSupportEnabled(bool value)
{
	bool bValueChanged = (m_bCACSupportEnabled != value);
	m_bCACSupportEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalCACSupportEnabledChanged(value, getObjectId());
	}
}

void CVmUsbDevice::slotChangeCACSupportEnabled(bool value)
{
	setCACSupportEnabled(value);
}

PRL_USB_DEVICE_TYPE CVmUsbDevice::getUsbType() const
{
	return m_ctUsbType;
}

void CVmUsbDevice::setUsbType(PRL_USB_DEVICE_TYPE value)
{
	bool bValueChanged = (m_ctUsbType != value);
	m_ctUsbType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalUsbTypeChanged(value, getObjectId());
	}
}

void CVmUsbDevice::slotChangeUsbType(PRL_USB_DEVICE_TYPE value)
{
	setUsbType(value);
}

void CVmUsbDevice::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("Connected").isNull() )
		setConnected();
	if ( ! RootElement || ! RootElement->firstChildElement("EmulatedType").isNull() )
		setEmulatedType(PVE::RealUsbDevice);
	if ( ! RootElement || ! RootElement->firstChildElement("SystemName").isNull() )
		setSystemName();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
	if ( ! RootElement || ! RootElement->firstChildElement("Remote").isNull() )
		setRemote();
	if ( ! RootElement || ! RootElement->firstChildElement("AutoConnect").isNull() )
		setAutoconnectDevices();
	if ( ! RootElement || ! RootElement->firstChildElement("ConnectReason").isNull() )
		setConnectReason();
	if ( ! RootElement || ! RootElement->firstChildElement("DeviceDescription").isNull() )
		setDescription();
	if ( ! RootElement || ! RootElement->firstChildElement("CACSupportEnabled").isNull() )
		setCACSupportEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("UsbType").isNull() )
		setUsbType(PUDT_OTHER);

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PVE::DeviceEnabledState >("PVE::DeviceEnabledState");
		qRegisterMetaType< PVE::DeviceConnectedState >("PVE::DeviceConnectedState");
		qRegisterMetaType< PRL_USB_DEVICE_AUTO_CONNECT_OPTION >("PRL_USB_DEVICE_AUTO_CONNECT_OPTION");
		qRegisterMetaType< PRL_USB_DEVICE_CONNECT_REASON >("PRL_USB_DEVICE_CONNECT_REASON");
		qRegisterMetaType< PRL_USB_DEVICE_TYPE >("PRL_USB_DEVICE_TYPE");
		first_time = false;
	}

}

QVariant CVmUsbDevice::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue((qlonglong )CVmDevice::getEnabled());

	if (path == "Connected.patch_stamp")
		value.setValue(getFieldPatchedValue("Connected"));

	if (path == "Connected")
		value.setValue((qlonglong )CVmDevice::getConnected());

	if (path == "EmulatedType.patch_stamp")
		value.setValue(getFieldPatchedValue("EmulatedType"));

	if (path == "EmulatedType")
		value.setValue(CVmDevice::getEmulatedType());

	if (path == "SystemName.patch_stamp")
		value.setValue(getFieldPatchedValue("SystemName"));

	if (path == "SystemName")
		value.setValue(CVmDevice::getSystemName());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(CVmDevice::getUserFriendlyName());

	if (path == "Remote.patch_stamp")
		value.setValue(getFieldPatchedValue("Remote"));

	if (path == "Remote")
		value.setValue(CVmDevice::isRemote());

	if (path == "AutoConnect.patch_stamp")
		value.setValue(getFieldPatchedValue("AutoConnect"));

	if (path == "AutoConnect")
		value.setValue((qlonglong )getAutoconnectDevices());

	if (path == "ConnectReason.patch_stamp")
		value.setValue(getFieldPatchedValue("ConnectReason"));

	if (path == "ConnectReason")
		value.setValue((qlonglong )getConnectReason());

	if (path == "DeviceDescription.patch_stamp")
		value.setValue(getFieldPatchedValue("DeviceDescription"));

	if (path == "DeviceDescription")
		value.setValue(CVmDevice::getDescription());

	if (path == "CACSupportEnabled.patch_stamp")
		value.setValue(getFieldPatchedValue("CACSupportEnabled"));

	if (path == "CACSupportEnabled")
		value.setValue(isCACSupportEnabled());

	if (path == "UsbType.patch_stamp")
		value.setValue(getFieldPatchedValue("UsbType"));

	if (path == "UsbType")
		value.setValue((qlonglong )getUsbType());

	return value;
}

bool CVmUsbDevice::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEnabled() != (PVE::DeviceEnabledState )value.value< qlonglong >());
		CVmDevice::setEnabled((PVE::DeviceEnabledState )value.value< qlonglong >());
		return true;
	}

	if (path == "Connected.patch_stamp")
	{
		markPatchedField("Connected", value.toString());
		return true;
	}

	if (path == "Connected")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getConnected() != (PVE::DeviceConnectedState )value.value< qlonglong >());
		CVmDevice::setConnected((PVE::DeviceConnectedState )value.value< qlonglong >());
		return true;
	}

	if (path == "EmulatedType.patch_stamp")
	{
		markPatchedField("EmulatedType", value.toString());
		return true;
	}

	if (path == "EmulatedType")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getEmulatedType() != value.value< unsigned int >());
		CVmDevice::setEmulatedType(value.value< unsigned int >());
		return true;
	}

	if (path == "SystemName.patch_stamp")
	{
		markPatchedField("SystemName", value.toString());
		return true;
	}

	if (path == "SystemName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getSystemName() != value.value< QString >());
		CVmDevice::setSystemName(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getUserFriendlyName() != value.value< QString >());
		CVmDevice::setUserFriendlyName(value.value< QString >());
		return true;
	}

	if (path == "Remote.patch_stamp")
	{
		markPatchedField("Remote", value.toString());
		return true;
	}

	if (path == "Remote")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::isRemote() != value.value< bool >());
		CVmDevice::setRemote(value.value< bool >());
		return true;
	}

	if (path == "AutoConnect.patch_stamp")
	{
		markPatchedField("AutoConnect", value.toString());
		return true;
	}

	if (path == "AutoConnect")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAutoconnectDevices() != (PRL_USB_DEVICE_AUTO_CONNECT_OPTION )value.value< qlonglong >());
		setAutoconnectDevices((PRL_USB_DEVICE_AUTO_CONNECT_OPTION )value.value< qlonglong >());
		return true;
	}

	if (path == "ConnectReason.patch_stamp")
	{
		markPatchedField("ConnectReason", value.toString());
		return true;
	}

	if (path == "ConnectReason")
	{
		if (pbValueChanged)
			*pbValueChanged = (getConnectReason() != (PRL_USB_DEVICE_CONNECT_REASON )value.value< qlonglong >());
		setConnectReason((PRL_USB_DEVICE_CONNECT_REASON )value.value< qlonglong >());
		return true;
	}

	if (path == "DeviceDescription.patch_stamp")
	{
		markPatchedField("DeviceDescription", value.toString());
		return true;
	}

	if (path == "DeviceDescription")
	{
		if (pbValueChanged)
			*pbValueChanged = (CVmDevice::getDescription() != value.value< QString >());
		CVmDevice::setDescription(value.value< QString >());
		return true;
	}

	if (path == "CACSupportEnabled.patch_stamp")
	{
		markPatchedField("CACSupportEnabled", value.toString());
		return true;
	}

	if (path == "CACSupportEnabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isCACSupportEnabled() != value.value< bool >());
		setCACSupportEnabled(value.value< bool >());
		return true;
	}

	if (path == "UsbType.patch_stamp")
	{
		markPatchedField("UsbType", value.toString());
		return true;
	}

	if (path == "UsbType")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUsbType() != (PRL_USB_DEVICE_TYPE )value.value< qlonglong >());
		setUsbType((PRL_USB_DEVICE_TYPE )value.value< qlonglong >());
		return true;
	}

	return false;
}

QString CVmUsbDevice::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString CVmUsbDevice::getConnected_id() const
{
	return getFullItemId().isEmpty() ? "Connected" : getFullItemId() + ".Connected";
}
QString CVmUsbDevice::getEmulatedType_id() const
{
	return getFullItemId().isEmpty() ? "EmulatedType" : getFullItemId() + ".EmulatedType";
}
QString CVmUsbDevice::getSystemName_id() const
{
	return getFullItemId().isEmpty() ? "SystemName" : getFullItemId() + ".SystemName";
}
QString CVmUsbDevice::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}
QString CVmUsbDevice::getRemote_id() const
{
	return getFullItemId().isEmpty() ? "Remote" : getFullItemId() + ".Remote";
}
QString CVmUsbDevice::getAutoconnectDevices_id() const
{
	return getFullItemId().isEmpty() ? "AutoConnect" : getFullItemId() + ".AutoConnect";
}
QString CVmUsbDevice::getConnectReason_id() const
{
	return getFullItemId().isEmpty() ? "ConnectReason" : getFullItemId() + ".ConnectReason";
}
QString CVmUsbDevice::getDescription_id() const
{
	return getFullItemId().isEmpty() ? "DeviceDescription" : getFullItemId() + ".DeviceDescription";
}
QString CVmUsbDevice::getCACSupportEnabled_id() const
{
	return getFullItemId().isEmpty() ? "CACSupportEnabled" : getFullItemId() + ".CACSupportEnabled";
}
QString CVmUsbDevice::getUsbType_id() const
{
	return getFullItemId().isEmpty() ? "UsbType" : getFullItemId() + ".UsbType";
}

int CVmUsbDevice::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool CVmUsbDevice::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement CVmUsbDevice::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("USB") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(getEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Connected");
	text_element = Document->createTextNode( QString("%1").arg(getConnected()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("EmulatedType");
	text_element = Document->createTextNode( QString("%1").arg(getEmulatedType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("SystemName");
	text_element = Document->createTextNode( QString("%1").arg(getSystemName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Remote");
	text_element = Document->createTextNode( QString("%1").arg(isRemote()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AutoConnect");
	text_element = Document->createTextNode( QString("%1").arg(getAutoconnectDevices()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ConnectReason");
	text_element = Document->createTextNode( QString("%1").arg(getConnectReason()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DeviceDescription");
	text_element = Document->createTextNode( QString("%1").arg(getDescription()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CACSupportEnabled");
	text_element = Document->createTextNode( QString("%1").arg(isCACSupportEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UsbType");
	text_element = Document->createTextNode( QString("%1").arg(getUsbType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmUsbDevice::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("USB") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Enabled_count = 1;
	int Connected_count = 1;
	int EmulatedType_count = 1;
	int SystemName_count = 1;
	int UserFriendlyName_count = 1;
	int Remote_count = 1;
	int AutoConnect_count = 1;
	int ConnectReason_count = 0;
	int DeviceDescription_count = 0;
	int CACSupportEnabled_count = 0;
	int UsbType_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled((PVE::DeviceEnabledState )text_element.data().toLongLong());
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Connected";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Connected_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Connected")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnected((PVE::DeviceConnectedState )text_element.data().toLongLong());
			--Connected_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "EmulatedType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (EmulatedType_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "EmulatedType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEmulatedType(text_element.data().toUInt());
			--EmulatedType_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "SystemName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (SystemName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "SystemName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setSystemName(text_element.data());
			--SystemName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Remote";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Remote_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Remote")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRemote(text_element.data().toInt() != 0);
			--Remote_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "AutoConnect";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AutoConnect_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AutoConnect")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAutoconnectDevices((PRL_USB_DEVICE_AUTO_CONNECT_OPTION )text_element.data().toLongLong());
			--AutoConnect_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ConnectReason";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ConnectReason_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ConnectReason")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setConnectReason((PRL_USB_DEVICE_CONNECT_REASON )text_element.data().toLongLong());
			--ConnectReason_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DeviceDescription";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DeviceDescription_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DeviceDescription")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDescription(text_element.data());
			--DeviceDescription_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CACSupportEnabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CACSupportEnabled_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CACSupportEnabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCACSupportEnabled(text_element.data().toInt() != 0);
			--CACSupportEnabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UsbType";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UsbType_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UsbType")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUsbType((PRL_USB_DEVICE_TYPE )text_element.data().toLongLong());
			--UsbType_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Connected_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'Connected' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (EmulatedType_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'EmulatedType' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (SystemName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'SystemName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Remote_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'Remote' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (AutoConnect_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmUsbDevice': tag 'AutoConnect' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (ConnectReason_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmUsbDevice': tag 'ConnectReason' is absent";
	}

	if (DeviceDescription_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmUsbDevice': tag 'DeviceDescription' is absent";
	}

	if (CACSupportEnabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmUsbDevice': tag 'CACSupportEnabled' is absent";
	}

	if (UsbType_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmUsbDevice': tag 'UsbType' is absent";
	}



	return 0;
}

void CVmUsbDevice::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool CVmUsbDevice::merge(CVmUsbDevice* pCur, CVmUsbDevice* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "USB";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (getEnabled() != pCur->getEnabled() && getEnabled() == pPrev->getEnabled())
		setEnabled(pCur->getEnabled());
	else if (getEnabled() != pCur->getEnabled() && getEnabled() != pPrev->getEnabled() && pCur->getEnabled() != pPrev->getEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (getConnected() != pCur->getConnected() && getConnected() == pPrev->getConnected())
		setConnected(pCur->getConnected());
	else if (getConnected() != pCur->getConnected() && getConnected() != pPrev->getConnected() && pCur->getConnected() != pPrev->getConnected())
	{
		m_qsErrorMessage += ".Connected";
		return false;
	}

	if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() == pPrev->getEmulatedType())
		setEmulatedType(pCur->getEmulatedType());
	else if (getEmulatedType() != pCur->getEmulatedType() && getEmulatedType() != pPrev->getEmulatedType() && pCur->getEmulatedType() != pPrev->getEmulatedType())
	{
		m_qsErrorMessage += ".EmulatedType";
		return false;
	}

	if (getSystemName() != pCur->getSystemName() && getSystemName() == pPrev->getSystemName())
		setSystemName(pCur->getSystemName());
	else if (getSystemName() != pCur->getSystemName() && getSystemName() != pPrev->getSystemName() && pCur->getSystemName() != pPrev->getSystemName())
	{
		m_qsErrorMessage += ".SystemName";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if (isRemote() != pCur->isRemote() && isRemote() == pPrev->isRemote())
		setRemote(pCur->isRemote());
	else if (isRemote() != pCur->isRemote() && isRemote() != pPrev->isRemote() && pCur->isRemote() != pPrev->isRemote())
	{
		m_qsErrorMessage += ".Remote";
		return false;
	}

	if (getAutoconnectDevices() != pCur->getAutoconnectDevices() && getAutoconnectDevices() == pPrev->getAutoconnectDevices())
		setAutoconnectDevices(pCur->getAutoconnectDevices());
	else if (getAutoconnectDevices() != pCur->getAutoconnectDevices() && getAutoconnectDevices() != pPrev->getAutoconnectDevices() && pCur->getAutoconnectDevices() != pPrev->getAutoconnectDevices())
	{
		m_qsErrorMessage += ".AutoConnect";
		return false;
	}

	if (getConnectReason() != pCur->getConnectReason() && getConnectReason() == pPrev->getConnectReason())
		setConnectReason(pCur->getConnectReason());
	else if (getConnectReason() != pCur->getConnectReason() && getConnectReason() != pPrev->getConnectReason() && pCur->getConnectReason() != pPrev->getConnectReason())
	{
		m_qsErrorMessage += ".ConnectReason";
		return false;
	}

	if (getDescription() != pCur->getDescription() && getDescription() == pPrev->getDescription())
		setDescription(pCur->getDescription());
	else if (getDescription() != pCur->getDescription() && getDescription() != pPrev->getDescription() && pCur->getDescription() != pPrev->getDescription())
	{
		m_qsErrorMessage += ".DeviceDescription";
		return false;
	}

	if (isCACSupportEnabled() != pCur->isCACSupportEnabled() && isCACSupportEnabled() == pPrev->isCACSupportEnabled())
		setCACSupportEnabled(pCur->isCACSupportEnabled());
	else if (isCACSupportEnabled() != pCur->isCACSupportEnabled() && isCACSupportEnabled() != pPrev->isCACSupportEnabled() && pCur->isCACSupportEnabled() != pPrev->isCACSupportEnabled())
	{
		m_qsErrorMessage += ".CACSupportEnabled";
		return false;
	}

	if (getUsbType() != pCur->getUsbType() && getUsbType() == pPrev->getUsbType())
		setUsbType(pCur->getUsbType());
	else if (getUsbType() != pCur->getUsbType() && getUsbType() != pPrev->getUsbType() && pCur->getUsbType() != pPrev->getUsbType())
	{
		m_qsErrorMessage += ".UsbType";
		return false;
	}

	return true;
}

void CVmUsbDevice::diff(const CVmUsbDevice* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getEnabled() != pOld->getEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (getConnected() != pOld->getConnected())
		lstDiffFullItemIds += getConnected_id();

	if (getEmulatedType() != pOld->getEmulatedType())
		lstDiffFullItemIds += getEmulatedType_id();

	if (getSystemName() != pOld->getSystemName())
		lstDiffFullItemIds += getSystemName_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	if (isRemote() != pOld->isRemote())
		lstDiffFullItemIds += getRemote_id();

	if (getAutoconnectDevices() != pOld->getAutoconnectDevices())
		lstDiffFullItemIds += getAutoconnectDevices_id();

	if (getConnectReason() != pOld->getConnectReason())
		lstDiffFullItemIds += getConnectReason_id();

	if (getDescription() != pOld->getDescription())
		lstDiffFullItemIds += getDescription_id();

	if (isCACSupportEnabled() != pOld->isCACSupportEnabled())
		lstDiffFullItemIds += getCACSupportEnabled_id();

	if (getUsbType() != pOld->getUsbType())
		lstDiffFullItemIds += getUsbType_id();

}

void CVmUsbDevice::Copy(const CVmUsbDevice& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.getEnabled());
	setConnected(rObject.getConnected());
	setEmulatedType(rObject.getEmulatedType());
	setSystemName(rObject.getSystemName());
	setUserFriendlyName(rObject.getUserFriendlyName());
	setRemote(rObject.isRemote());
	setAutoconnectDevices(rObject.getAutoconnectDevices());
	setConnectReason(rObject.getConnectReason());
	setDescription(rObject.getDescription());
	setCACSupportEnabled(rObject.isCACSupportEnabled());
	setUsbType(rObject.getUsbType());

	CustomCopy(&rObject);

}

void CVmUsbDevice::InitLists()
{
	CustomInit();
}

void CVmUsbDevice::ClearLists()
{
}

void CVmUsbDevice::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

