////////////////////////////////////////////////////////////////////////////////
///
/// CVmUsbDevice.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMUSBDEVICE_H
#define CVMUSBDEVICE_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmDevice.h"


class CVmUsbDevice : public CVmDevice
{
	Q_OBJECT

public:

	CVmUsbDevice();
	CVmUsbDevice(const CVmUsbDevice& rObject);
	CVmUsbDevice(const CVmUsbDevice* pObject);
	CVmUsbDevice(QFile* pFile);
	CVmUsbDevice& operator=(const CVmUsbDevice& rObject);
	virtual ~CVmUsbDevice();


    PVE::UsbDeviceEmulatedType getEmulatedType() const { return (PVE::UsbDeviceEmulatedType )CVmDevice::getEmulatedType(); }

    virtual PRL_DEVICE_TYPE getDeviceType() const { return PDE_USB_DEVICE; }

    virtual bool operator==( const CVmUsbDevice& cVmUsbDevice );



	PRL_USB_DEVICE_AUTO_CONNECT_OPTION getAutoconnectDevices() const;
	void setAutoconnectDevices(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value = PUD_CONNECT_TO_GUEST_OS);

	PRL_USB_DEVICE_CONNECT_REASON getConnectReason() const;
	void setConnectReason(PRL_USB_DEVICE_CONNECT_REASON value = PUD_CONNECTED_MANUALLY);

	bool isCACSupportEnabled() const;
	void setCACSupportEnabled(bool value = false);

	PRL_USB_DEVICE_TYPE getUsbType() const;
	void setUsbType(PRL_USB_DEVICE_TYPE value = (PRL_USB_DEVICE_TYPE )0);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getEnabled_id() const;
	QString getConnected_id() const;
	QString getEmulatedType_id() const;
	QString getSystemName_id() const;
	QString getUserFriendlyName_id() const;
	QString getRemote_id() const;
	QString getAutoconnectDevices_id() const;
	QString getConnectReason_id() const;
	QString getDescription_id() const;
	QString getCACSupportEnabled_id() const;
	QString getUsbType_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmUsbDevice* pCur, CVmUsbDevice* pPrev, MergeOptions nOptions);

	void diff(const CVmUsbDevice* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	PRL_USB_DEVICE_AUTO_CONNECT_OPTION		m_ctAutoConnect;
	PRL_USB_DEVICE_CONNECT_REASON		m_ctConnectReason;
	bool		m_bCACSupportEnabled;
	PRL_USB_DEVICE_TYPE		m_ctUsbType;

	void Copy(const CVmUsbDevice& rObject);

signals:

	void signalAutoconnectDevicesChanged(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value, QString object_id = QString());
	void signalConnectReasonChanged(PRL_USB_DEVICE_CONNECT_REASON value, QString object_id = QString());
	void signalCACSupportEnabledChanged(bool value, QString object_id = QString());
	void signalUsbTypeChanged(PRL_USB_DEVICE_TYPE value, QString object_id = QString());

private slots:

	void slotChangeAutoconnectDevices(PRL_USB_DEVICE_AUTO_CONNECT_OPTION value);
	void slotChangeConnectReason(PRL_USB_DEVICE_CONNECT_REASON value);
	void slotChangeCACSupportEnabled(bool value);
	void slotChangeUsbType(PRL_USB_DEVICE_TYPE value);

};

#ifndef DM_795237
#define DM_795237
Q_DECLARE_METATYPE(PVE::DeviceEnabledState)
#endif
#ifndef DM_21711685
#define DM_21711685
Q_DECLARE_METATYPE(PVE::DeviceConnectedState)
#endif
#ifndef DM_154204158
#define DM_154204158
Q_DECLARE_METATYPE(PRL_USB_DEVICE_AUTO_CONNECT_OPTION)
#endif
#ifndef DM_161774110
#define DM_161774110
Q_DECLARE_METATYPE(PRL_USB_DEVICE_CONNECT_REASON)
#endif
#ifndef DM_168616069
#define DM_168616069
Q_DECLARE_METATYPE(PRL_USB_DEVICE_TYPE)
#endif


#endif
