////////////////////////////////////////////////////////////////////////////////
///
/// CVmVideo.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMVIDEO_H
#define CVMVIDEO_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmScreenResolutions.h"


class CVmVideo : public CBaseNodeSignals
{
	Q_OBJECT

public:

	CVmVideo();
	CVmVideo(const CVmVideo& rObject);
	CVmVideo(const CVmVideo* pObject);
	CVmVideo(QFile* pFile);
	CVmVideo& operator=(const CVmVideo& rObject);
	virtual ~CVmVideo();


	QList<CVmScreenResolutions* >		m_lstScreenResolutions;

	CVmScreenResolutions* getVmScreenResolutions() const;
	void setVmScreenResolutions(CVmScreenResolutions* pScreenResolutions);


	bool isEnabled() const;
	void setEnabled(bool value = true);

	unsigned int getMemorySize() const;
	void setMemorySize(unsigned int value = XML_DEFAULT_VIDEO_SIZE);

	bool isEnableDirectXShaders() const;
	void setEnableDirectXShaders(bool value = true);

	PRL_VIDEO_3D_ACCELERATION getEnable3DAcceleration() const;
	void setEnable3DAcceleration(PRL_VIDEO_3D_ACCELERATION value = P3D_DISABLED);

	bool isEnableVSync() const;
	void setEnableVSync(bool value = true);

	unsigned int getMaxDisplays() const;
	void setMaxDisplays(unsigned int value = 0);

	bool isEnableHiResDrawing() const;
	void setEnableHiResDrawing(bool value = true);

	bool isUseHiResInGuest() const;
	void setUseHiResInGuest(bool value = true);

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getEnabled_id() const;
	QString getMemorySize_id() const;
	QString getEnableDirectXShaders_id() const;
	QString getEnable3DAcceleration_id() const;
	QString getEnableVSync_id() const;
	QString getMaxDisplays_id() const;
	QString getEnableHiResDrawing_id() const;
	QString getUseHiResInGuest_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmVideo* pCur, CVmVideo* pPrev, MergeOptions nOptions);

	void diff(const CVmVideo* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	bool		m_bEnabled;
	unsigned int		m_uiVideoMemorySize;
	bool		m_bEnableDirectXShaders;
	PRL_VIDEO_3D_ACCELERATION		m_ctEnable3DAcceleration;
	bool		m_bEnableVSync;
	unsigned int		m_uiMaxDisplays;
	bool		m_bEnableHiResDrawing;
	bool		m_bUseHiResInGuest;

	void Copy(const CVmVideo& rObject);

signals:

	void signalEnabledChanged(bool value, QString object_id = QString());
	void signalMemorySizeChanged(unsigned int value, QString object_id = QString());
	void signalEnableDirectXShadersChanged(bool value, QString object_id = QString());
	void signalEnable3DAccelerationChanged(PRL_VIDEO_3D_ACCELERATION value, QString object_id = QString());
	void signalEnableVSyncChanged(bool value, QString object_id = QString());
	void signalMaxDisplaysChanged(unsigned int value, QString object_id = QString());
	void signalEnableHiResDrawingChanged(bool value, QString object_id = QString());
	void signalUseHiResInGuestChanged(bool value, QString object_id = QString());

private slots:

	void slotChangeEnabled(bool value);
	void slotChangeMemorySize(unsigned int value);
	void slotChangeEnableDirectXShaders(bool value);
	void slotChangeEnable3DAcceleration(PRL_VIDEO_3D_ACCELERATION value);
	void slotChangeEnableVSync(bool value);
	void slotChangeMaxDisplays(unsigned int value);
	void slotChangeEnableHiResDrawing(bool value);
	void slotChangeUseHiResInGuest(bool value);

};

#ifndef DM_114217022
#define DM_114217022
Q_DECLARE_METATYPE(PRL_VIDEO_3D_ACCELERATION)
#endif


#endif
