////////////////////////////////////////////////////////////////////////////////
///
/// Chipset.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "Chipset.h"


Chipset::Chipset()
{
	InitLists();
	setDefaults();
}

Chipset::Chipset(const Chipset& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

Chipset::Chipset(const Chipset* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

Chipset& Chipset::operator=(const Chipset& rObject)
{
	Copy(rObject);
	return *this;
}

Chipset::Chipset(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

Chipset::~Chipset()
{
	ClearLists();
}


unsigned int Chipset::getType() const
{
	return m_uiType;
}

void Chipset::setType(unsigned int value)
{
	bool bValueChanged = (m_uiType != value);
	m_uiType = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTypeChanged(value);
	}
}

void Chipset::slotChangeType(unsigned int value)
{
	setType(value);
}

unsigned int Chipset::getVersion() const
{
	return m_uiVersion;
}

void Chipset::setVersion(unsigned int value)
{
	bool bValueChanged = (m_uiVersion != value);
	m_uiVersion = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalVersionChanged(value);
	}
}

void Chipset::slotChangeVersion(unsigned int value)
{
	setVersion(value);
}

QString Chipset::getAlias() const
{
	return m_qsAlias;
}

void Chipset::setAlias(QString value)
{
	bool bValueChanged = (m_qsAlias != value);
	m_qsAlias = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAliasChanged(value);
	}
}

void Chipset::slotChangeAlias(QString value)
{
	setAlias(value);
}

void Chipset::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Type").isNull() )
		setType();
	if ( ! RootElement || ! RootElement->firstChildElement("Version").isNull() )
		setVersion();
	if ( ! RootElement || ! RootElement->firstChildElement("Alias").isNull() )
		setAlias();
}

QVariant Chipset::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Type.patch_stamp")
		value.setValue(getFieldPatchedValue("Type"));

	if (path == "Type")
		value.setValue(getType());

	if (path == "Version.patch_stamp")
		value.setValue(getFieldPatchedValue("Version"));

	if (path == "Version")
		value.setValue(getVersion());

	if (path == "Alias.patch_stamp")
		value.setValue(getFieldPatchedValue("Alias"));

	if (path == "Alias")
		value.setValue(getAlias());

	return value;
}

bool Chipset::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Type.patch_stamp")
	{
		markPatchedField("Type", value.toString());
		return true;
	}

	if (path == "Type")
	{
		if (pbValueChanged)
			*pbValueChanged = (getType() != value.value< unsigned int >());
		setType(value.value< unsigned int >());
		return true;
	}

	if (path == "Version.patch_stamp")
	{
		markPatchedField("Version", value.toString());
		return true;
	}

	if (path == "Version")
	{
		if (pbValueChanged)
			*pbValueChanged = (getVersion() != value.value< unsigned int >());
		setVersion(value.value< unsigned int >());
		return true;
	}

	if (path == "Alias.patch_stamp")
	{
		markPatchedField("Alias", value.toString());
		return true;
	}

	if (path == "Alias")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAlias() != value.value< QString >());
		setAlias(value.value< QString >());
		return true;
	}

	return false;
}

QString Chipset::getType_id() const
{
	return getFullItemId().isEmpty() ? "Type" : getFullItemId() + ".Type";
}
QString Chipset::getVersion_id() const
{
	return getFullItemId().isEmpty() ? "Version" : getFullItemId() + ".Version";
}
QString Chipset::getAlias_id() const
{
	return getFullItemId().isEmpty() ? "Alias" : getFullItemId() + ".Alias";
}

int Chipset::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool Chipset::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement Chipset::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Chipset") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Type");
	text_element = Document->createTextNode( QString("%1").arg(getType()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Version");
	text_element = Document->createTextNode( QString("%1").arg(getVersion()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Alias");
	text_element = Document->createTextNode( QString("%1").arg(getAlias()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int Chipset::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Chipset") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'Chipset': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Type_count = 1;
	int Version_count = 0;
	int Alias_count = 0;

	QString Version_patch_stamp = RootElement->attribute("Version_patch");
	if (unite_with_loaded && RootElement->firstChildElement("Version").isNull())
		Version_patch_stamp = getFieldPatchedValue("Version");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Type";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Type_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Type")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setType(text_element.data().toUInt());
			--Type_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Version";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Version_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Version")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setVersion(text_element.data().toUInt());
			--Version_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "Alias";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Alias_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Alias")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAlias(text_element.data());
			--Alias_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Type_count > 0)
	{
		m_qsErrorMessage = "Error in class 'Chipset': tag 'Type' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Version_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Chipset': tag 'Version' is absent";
	}

	if (Alias_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Chipset': tag 'Alias' is absent";
	}



	m_mapPatchedFields.insert("Version", Version_patch_stamp);


	return 0;
}

void Chipset::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool Chipset::merge(Chipset* pCur, Chipset* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Chipset";

	if (getType() != pCur->getType() && getType() == pPrev->getType())
		setType(pCur->getType());
	else if (getType() != pCur->getType() && getType() != pPrev->getType() && pCur->getType() != pPrev->getType())
	{
		m_qsErrorMessage += ".Type";
		return false;
	}

	if (getVersion() != pCur->getVersion() && getVersion() == pPrev->getVersion())
		setVersion(pCur->getVersion());
	else if (getVersion() != pCur->getVersion() && getVersion() != pPrev->getVersion() && pCur->getVersion() != pPrev->getVersion())
	{
		m_qsErrorMessage += ".Version";
		return false;
	}

	if (getAlias() != pCur->getAlias() && getAlias() == pPrev->getAlias())
		setAlias(pCur->getAlias());
	else if (getAlias() != pCur->getAlias() && getAlias() != pPrev->getAlias() && pCur->getAlias() != pPrev->getAlias())
	{
		m_qsErrorMessage += ".Alias";
		return false;
	}

	return true;
}

void Chipset::diff(const Chipset* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getType() != pOld->getType())
		lstDiffFullItemIds += getType_id();

	if (getVersion() != pOld->getVersion())
		lstDiffFullItemIds += getVersion_id();

	if (getAlias() != pOld->getAlias())
		lstDiffFullItemIds += getAlias_id();

}

void Chipset::Copy(const Chipset& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setType(rObject.getType());
	setVersion(rObject.getVersion());
	setAlias(rObject.getAlias());

	CustomCopy(&rObject);

}

void Chipset::InitLists()
{
	CustomInit();
}

void Chipset::ClearLists()
{
}

void Chipset::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

