////////////////////////////////////////////////////////////////////////////////
///
/// ClipboardSync.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "ClipboardSync.h"


ClipboardSync::ClipboardSync()
{
	InitLists();
	setDefaults();
}

ClipboardSync::ClipboardSync(const ClipboardSync& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

ClipboardSync::ClipboardSync(const ClipboardSync* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

ClipboardSync& ClipboardSync::operator=(const ClipboardSync& rObject)
{
	Copy(rObject);
	return *this;
}

ClipboardSync::ClipboardSync(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

ClipboardSync::~ClipboardSync()
{
	ClearLists();
}


bool ClipboardSync::isEnabled() const
{
	return m_bEnabled;
}

void ClipboardSync::setEnabled(bool value)
{
	bool bValueChanged = (m_bEnabled != value);
	m_bEnabled = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalEnabledChanged(value);
	}
}

void ClipboardSync::slotChangeEnabled(bool value)
{
	setEnabled(value);
}

bool ClipboardSync::isPreserveTextFormatting() const
{
	return m_bPreserveTextFormatting;
}

void ClipboardSync::setPreserveTextFormatting(bool value)
{
	bool bValueChanged = (m_bPreserveTextFormatting != value);
	m_bPreserveTextFormatting = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalPreserveTextFormattingChanged(value);
	}
}

void ClipboardSync::slotChangePreserveTextFormatting(bool value)
{
	setPreserveTextFormatting(value);
}

void ClipboardSync::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Enabled").isNull() )
		setEnabled();
	if ( ! RootElement || ! RootElement->firstChildElement("PreserveTextFormatting").isNull() )
		setPreserveTextFormatting();
}

QVariant ClipboardSync::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Enabled.patch_stamp")
		value.setValue(getFieldPatchedValue("Enabled"));

	if (path == "Enabled")
		value.setValue(isEnabled());

	if (path == "PreserveTextFormatting.patch_stamp")
		value.setValue(getFieldPatchedValue("PreserveTextFormatting"));

	if (path == "PreserveTextFormatting")
		value.setValue(isPreserveTextFormatting());

	return value;
}

bool ClipboardSync::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Enabled.patch_stamp")
	{
		markPatchedField("Enabled", value.toString());
		return true;
	}

	if (path == "Enabled")
	{
		if (pbValueChanged)
			*pbValueChanged = (isEnabled() != value.value< bool >());
		setEnabled(value.value< bool >());
		return true;
	}

	if (path == "PreserveTextFormatting.patch_stamp")
	{
		markPatchedField("PreserveTextFormatting", value.toString());
		return true;
	}

	if (path == "PreserveTextFormatting")
	{
		if (pbValueChanged)
			*pbValueChanged = (isPreserveTextFormatting() != value.value< bool >());
		setPreserveTextFormatting(value.value< bool >());
		return true;
	}

	return false;
}

QString ClipboardSync::getEnabled_id() const
{
	return getFullItemId().isEmpty() ? "Enabled" : getFullItemId() + ".Enabled";
}
QString ClipboardSync::getPreserveTextFormatting_id() const
{
	return getFullItemId().isEmpty() ? "PreserveTextFormatting" : getFullItemId() + ".PreserveTextFormatting";
}

int ClipboardSync::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool ClipboardSync::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement ClipboardSync::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ClipboardSync") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Enabled");
	text_element = Document->createTextNode( QString("%1").arg(isEnabled()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	if ( m_mapPatchedFields.contains(element.tagName()) )
	{
		root_element.setAttribute( element.tagName() + "_patch", m_mapPatchedFields.value(element.tagName()) );
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("PreserveTextFormatting");
	text_element = Document->createTextNode( QString("%1").arg(isPreserveTextFormatting()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int ClipboardSync::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ClipboardSync") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'ClipboardSync': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Enabled_count = 1;
	int PreserveTextFormatting_count = 0;

	QString Enabled_patch_stamp = RootElement->attribute("Enabled_patch");
	if (unite_with_loaded && RootElement->firstChildElement("Enabled").isNull())
		Enabled_patch_stamp = getFieldPatchedValue("Enabled");

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Enabled";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Enabled_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Enabled")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setEnabled(text_element.data().toInt() != 0);
			--Enabled_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "PreserveTextFormatting";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (PreserveTextFormatting_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "PreserveTextFormatting")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setPreserveTextFormatting(text_element.data().toInt() != 0);
			--PreserveTextFormatting_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Enabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'ClipboardSync': tag 'Enabled' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (PreserveTextFormatting_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ClipboardSync': tag 'PreserveTextFormatting' is absent";
	}



	m_mapPatchedFields.insert("Enabled", Enabled_patch_stamp);


	return 0;
}

void ClipboardSync::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool ClipboardSync::merge(ClipboardSync* pCur, ClipboardSync* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ClipboardSync";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (isEnabled() != pCur->isEnabled() && isEnabled() == pPrev->isEnabled())
		setEnabled(pCur->isEnabled());
	else if (isEnabled() != pCur->isEnabled() && isEnabled() != pPrev->isEnabled() && pCur->isEnabled() != pPrev->isEnabled())
	{
		m_qsErrorMessage += ".Enabled";
		return false;
	}

	if (isPreserveTextFormatting() != pCur->isPreserveTextFormatting() && isPreserveTextFormatting() == pPrev->isPreserveTextFormatting())
		setPreserveTextFormatting(pCur->isPreserveTextFormatting());
	else if (isPreserveTextFormatting() != pCur->isPreserveTextFormatting() && isPreserveTextFormatting() != pPrev->isPreserveTextFormatting() && pCur->isPreserveTextFormatting() != pPrev->isPreserveTextFormatting())
	{
		m_qsErrorMessage += ".PreserveTextFormatting";
		return false;
	}

	return true;
}

void ClipboardSync::diff(const ClipboardSync* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isEnabled() != pOld->isEnabled())
		lstDiffFullItemIds += getEnabled_id();

	if (isPreserveTextFormatting() != pOld->isPreserveTextFormatting())
		lstDiffFullItemIds += getPreserveTextFormatting_id();

}

void ClipboardSync::Copy(const ClipboardSync& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setEnabled(rObject.isEnabled());
	setPreserveTextFormatting(rObject.isPreserveTextFormatting());

	CustomCopy(&rObject);

}

void ClipboardSync::InitLists()
{
	CustomInit();
}

void ClipboardSync::ClearLists()
{
}

void ClipboardSync::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

