////////////////////////////////////////////////////////////////////////////////
///
/// Clock.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "Clock.h"


Clock::Clock()
{
	InitLists();
	setDefaults();
}

Clock::Clock(const Clock& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

Clock::Clock(const Clock* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

Clock& Clock::operator=(const Clock& rObject)
{
	Copy(rObject);
	return *this;
}

Clock::Clock(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

Clock::~Clock()
{
	ClearLists();
}


qlonglong Clock::getTimeShift() const
{
	return m_llTimeShift;
}

void Clock::setTimeShift(qlonglong value)
{
	bool bValueChanged = (m_llTimeShift != value);
	m_llTimeShift = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalTimeShiftChanged(value);
	}
}

void Clock::slotChangeTimeShift(qlonglong value)
{
	setTimeShift(value);
}

void Clock::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("TimeShift").isNull() )
		setTimeShift();
}

QVariant Clock::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "TimeShift.patch_stamp")
		value.setValue(getFieldPatchedValue("TimeShift"));

	if (path == "TimeShift")
		value.setValue(getTimeShift());

	return value;
}

bool Clock::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "TimeShift.patch_stamp")
	{
		markPatchedField("TimeShift", value.toString());
		return true;
	}

	if (path == "TimeShift")
	{
		if (pbValueChanged)
			*pbValueChanged = (getTimeShift() != value.value< qlonglong >());
		setTimeShift(value.value< qlonglong >());
		return true;
	}

	return false;
}

QString Clock::getTimeShift_id() const
{
	return getFullItemId().isEmpty() ? "TimeShift" : getFullItemId() + ".TimeShift";
}

int Clock::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool Clock::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement Clock::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Clock") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("TimeShift");
	text_element = Document->createTextNode( QString("%1").arg(getTimeShift()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int Clock::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Clock") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'Clock': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int TimeShift_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "TimeShift";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (TimeShift_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "TimeShift")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setTimeShift(text_element.data().toLongLong());
			--TimeShift_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (TimeShift_count > 0)
	{
		m_qsErrorMessage = "Error in class 'Clock': tag 'TimeShift' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void Clock::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool Clock::merge(Clock* pCur, Clock* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Clock";

	if (getTimeShift() != pCur->getTimeShift() && getTimeShift() == pPrev->getTimeShift())
		setTimeShift(pCur->getTimeShift());
	else if (getTimeShift() != pCur->getTimeShift() && getTimeShift() != pPrev->getTimeShift() && pCur->getTimeShift() != pPrev->getTimeShift())
	{
		m_qsErrorMessage += ".TimeShift";
		return false;
	}

	return true;
}

void Clock::diff(const Clock* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getTimeShift() != pOld->getTimeShift())
		lstDiffFullItemIds += getTimeShift_id();

}

void Clock::Copy(const Clock& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setTimeShift(rObject.getTimeShift());

	CustomCopy(&rObject);

}

void Clock::InitLists()
{
	CustomInit();
}

void Clock::ClearLists()
{
}

void Clock::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

