////////////////////////////////////////////////////////////////////////////////
///
/// ClusterOptions.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "ClusterOptions.h"


ClusterOptions::ClusterOptions()
{
	InitLists();
	setDefaults();
}

ClusterOptions::ClusterOptions(const ClusterOptions& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

ClusterOptions::ClusterOptions(const ClusterOptions* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

ClusterOptions& ClusterOptions::operator=(const ClusterOptions& rObject)
{
	Copy(rObject);
	return *this;
}

ClusterOptions::ClusterOptions(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

ClusterOptions::~ClusterOptions()
{
	ClearLists();
}


bool ClusterOptions::isRunning() const
{
	return m_bRunning;
}

void ClusterOptions::setRunning(bool value)
{
	bool bValueChanged = (m_bRunning != value);
	m_bRunning = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalRunningChanged(value);
	}
}

void ClusterOptions::slotChangeRunning(bool value)
{
	setRunning(value);
}

QString ClusterOptions::getServiceName() const
{
	return m_qsServiceName;
}

void ClusterOptions::setServiceName(QString value)
{
	bool bValueChanged = (m_qsServiceName != value);
	m_qsServiceName = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalServiceNameChanged(value);
	}
}

void ClusterOptions::slotChangeServiceName(QString value)
{
	setServiceName(value);
}

void ClusterOptions::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Running").isNull() )
		setRunning();
	if ( ! RootElement || ! RootElement->firstChildElement("ServiceName").isNull() )
		setServiceName();
}

QVariant ClusterOptions::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Running.patch_stamp")
		value.setValue(getFieldPatchedValue("Running"));

	if (path == "Running")
		value.setValue(isRunning());

	if (path == "ServiceName.patch_stamp")
		value.setValue(getFieldPatchedValue("ServiceName"));

	if (path == "ServiceName")
		value.setValue(getServiceName());

	return value;
}

bool ClusterOptions::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Running.patch_stamp")
	{
		markPatchedField("Running", value.toString());
		return true;
	}

	if (path == "Running")
	{
		if (pbValueChanged)
			*pbValueChanged = (isRunning() != value.value< bool >());
		setRunning(value.value< bool >());
		return true;
	}

	if (path == "ServiceName.patch_stamp")
	{
		markPatchedField("ServiceName", value.toString());
		return true;
	}

	if (path == "ServiceName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getServiceName() != value.value< QString >());
		setServiceName(value.value< QString >());
		return true;
	}

	return false;
}

QString ClusterOptions::getRunning_id() const
{
	return getFullItemId().isEmpty() ? "Running" : getFullItemId() + ".Running";
}
QString ClusterOptions::getServiceName_id() const
{
	return getFullItemId().isEmpty() ? "ServiceName" : getFullItemId() + ".ServiceName";
}

int ClusterOptions::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool ClusterOptions::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement ClusterOptions::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ClusterOptions") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Running");
	text_element = Document->createTextNode( QString("%1").arg(isRunning()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("ServiceName");
	text_element = Document->createTextNode( QString("%1").arg(getServiceName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int ClusterOptions::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ClusterOptions") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'ClusterOptions': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Running_count = 0;
	int ServiceName_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Running";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Running_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Running")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setRunning(text_element.data().toInt() != 0);
			--Running_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "ServiceName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (ServiceName_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "ServiceName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setServiceName(text_element.data());
			--ServiceName_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Running_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ClusterOptions': tag 'Running' is absent";
	}

	if (ServiceName_count >= 0)
	{
		m_lstWarningList += "Warning in class 'ClusterOptions': tag 'ServiceName' is absent";
	}



	return 0;
}

void ClusterOptions::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool ClusterOptions::merge(ClusterOptions* pCur, ClusterOptions* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ClusterOptions";

	if (nOptions & moEnableRestrictSections)
	{
		if (toString() != pCur->toString() && toString() == pPrev->toString())
			fromString(pCur->toString());
		else if (toString() != pCur->toString() && toString() != pPrev->toString() && pCur->toString() != pPrev->toString())
			return false;
		return true;
	}

	if (isRunning() != pCur->isRunning() && isRunning() == pPrev->isRunning())
		setRunning(pCur->isRunning());
	else if (isRunning() != pCur->isRunning() && isRunning() != pPrev->isRunning() && pCur->isRunning() != pPrev->isRunning())
	{
		m_qsErrorMessage += ".Running";
		return false;
	}

	if (getServiceName() != pCur->getServiceName() && getServiceName() == pPrev->getServiceName())
		setServiceName(pCur->getServiceName());
	else if (getServiceName() != pCur->getServiceName() && getServiceName() != pPrev->getServiceName() && pCur->getServiceName() != pPrev->getServiceName())
	{
		m_qsErrorMessage += ".ServiceName";
		return false;
	}

	return true;
}

void ClusterOptions::diff(const ClusterOptions* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (isRunning() != pOld->isRunning())
		lstDiffFullItemIds += getRunning_id();

	if (getServiceName() != pOld->getServiceName())
		lstDiffFullItemIds += getServiceName_id();

}

void ClusterOptions::Copy(const ClusterOptions& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setRunning(rObject.isRunning());
	setServiceName(rObject.getServiceName());

	CustomCopy(&rObject);

}

void ClusterOptions::InitLists()
{
	CustomInit();
}

void ClusterOptions::ClearLists()
{
}

void ClusterOptions::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

