////////////////////////////////////////////////////////////////////////////////
///
/// Shutdown.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "Shutdown.h"


Shutdown::Shutdown()
{
	InitLists();
	setDefaults();
}

Shutdown::Shutdown(const Shutdown& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

Shutdown::Shutdown(const Shutdown* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

Shutdown& Shutdown::operator=(const Shutdown& rObject)
{
	Copy(rObject);
	return *this;
}

Shutdown::Shutdown(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

Shutdown::~Shutdown()
{
	ClearLists();
}


PRL_VM_AUTOSTOP_OPTION Shutdown::getAutoStop() const
{
	return m_ctAutoStop;
}

void Shutdown::setAutoStop(PRL_VM_AUTOSTOP_OPTION value)
{
	bool bValueChanged = (m_ctAutoStop != value);
	m_ctAutoStop = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalAutoStopChanged(value);
	}
}

void Shutdown::slotChangeAutoStop(PRL_VM_AUTOSTOP_OPTION value)
{
	setAutoStop(value);
}

PRL_VM_ACTION_ON_WINDOW_CLOSE Shutdown::getOnVmWindowClose() const
{
	return m_ctOnVmWindowClose;
}

void Shutdown::setOnVmWindowClose(PRL_VM_ACTION_ON_WINDOW_CLOSE value)
{
	bool bValueChanged = (m_ctOnVmWindowClose != value);
	m_ctOnVmWindowClose = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalOnVmWindowCloseChanged(value);
	}
}

void Shutdown::slotChangeOnVmWindowClose(PRL_VM_ACTION_ON_WINDOW_CLOSE value)
{
	setOnVmWindowClose(value);
}

int Shutdown::getWindowOnShutdown() const
{
	return m_iWindowOnShutdown;
}

void Shutdown::setWindowOnShutdown(int value)
{
	bool bValueChanged = (m_iWindowOnShutdown != value);
	m_iWindowOnShutdown = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalWindowOnShutdownChanged(value);
	}
}

void Shutdown::slotChangeWindowOnShutdown(int value)
{
	setWindowOnShutdown(value);
}

void Shutdown::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("AutoStop").isNull() )
		setAutoStop();
	if ( ! RootElement || ! RootElement->firstChildElement("OnVmWindowClose").isNull() )
		setOnVmWindowClose();
	if ( ! RootElement || ! RootElement->firstChildElement("WindowOnShutdown").isNull() )
		setWindowOnShutdown();

	static bool first_time = true;
	if ( first_time )
	{
		qRegisterMetaType< PRL_VM_AUTOSTOP_OPTION >("PRL_VM_AUTOSTOP_OPTION");
		qRegisterMetaType< PRL_VM_ACTION_ON_WINDOW_CLOSE >("PRL_VM_ACTION_ON_WINDOW_CLOSE");
		first_time = false;
	}

}

QVariant Shutdown::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "AutoStop.patch_stamp")
		value.setValue(getFieldPatchedValue("AutoStop"));

	if (path == "AutoStop")
		value.setValue((qlonglong )getAutoStop());

	if (path == "OnVmWindowClose.patch_stamp")
		value.setValue(getFieldPatchedValue("OnVmWindowClose"));

	if (path == "OnVmWindowClose")
		value.setValue((qlonglong )getOnVmWindowClose());

	if (path == "WindowOnShutdown.patch_stamp")
		value.setValue(getFieldPatchedValue("WindowOnShutdown"));

	if (path == "WindowOnShutdown")
		value.setValue(getWindowOnShutdown());

	return value;
}

bool Shutdown::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "AutoStop.patch_stamp")
	{
		markPatchedField("AutoStop", value.toString());
		return true;
	}

	if (path == "AutoStop")
	{
		if (pbValueChanged)
			*pbValueChanged = (getAutoStop() != (PRL_VM_AUTOSTOP_OPTION )value.value< qlonglong >());
		setAutoStop((PRL_VM_AUTOSTOP_OPTION )value.value< qlonglong >());
		return true;
	}

	if (path == "OnVmWindowClose.patch_stamp")
	{
		markPatchedField("OnVmWindowClose", value.toString());
		return true;
	}

	if (path == "OnVmWindowClose")
	{
		if (pbValueChanged)
			*pbValueChanged = (getOnVmWindowClose() != (PRL_VM_ACTION_ON_WINDOW_CLOSE )value.value< qlonglong >());
		setOnVmWindowClose((PRL_VM_ACTION_ON_WINDOW_CLOSE )value.value< qlonglong >());
		return true;
	}

	if (path == "WindowOnShutdown.patch_stamp")
	{
		markPatchedField("WindowOnShutdown", value.toString());
		return true;
	}

	if (path == "WindowOnShutdown")
	{
		if (pbValueChanged)
			*pbValueChanged = (getWindowOnShutdown() != value.value< int >());
		setWindowOnShutdown(value.value< int >());
		return true;
	}

	return false;
}

QString Shutdown::getAutoStop_id() const
{
	return getFullItemId().isEmpty() ? "AutoStop" : getFullItemId() + ".AutoStop";
}
QString Shutdown::getOnVmWindowClose_id() const
{
	return getFullItemId().isEmpty() ? "OnVmWindowClose" : getFullItemId() + ".OnVmWindowClose";
}
QString Shutdown::getWindowOnShutdown_id() const
{
	return getFullItemId().isEmpty() ? "WindowOnShutdown" : getFullItemId() + ".WindowOnShutdown";
}

int Shutdown::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool Shutdown::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement Shutdown::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("Shutdown") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("AutoStop");
	text_element = Document->createTextNode( QString("%1").arg(getAutoStop()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("OnVmWindowClose");
	text_element = Document->createTextNode( QString("%1").arg(getOnVmWindowClose()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("WindowOnShutdown");
	text_element = Document->createTextNode( QString("%1").arg(getWindowOnShutdown()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int Shutdown::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("Shutdown") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'Shutdown': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int AutoStop_count = 1;
	int OnVmWindowClose_count = 0;
	int WindowOnShutdown_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "AutoStop";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (AutoStop_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "AutoStop")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setAutoStop((PRL_VM_AUTOSTOP_OPTION )text_element.data().toLongLong());
			--AutoStop_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "OnVmWindowClose";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (OnVmWindowClose_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "OnVmWindowClose")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setOnVmWindowClose((PRL_VM_ACTION_ON_WINDOW_CLOSE )text_element.data().toLongLong());
			--OnVmWindowClose_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "WindowOnShutdown";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (WindowOnShutdown_count - 0) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "WindowOnShutdown")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setWindowOnShutdown(text_element.data().toInt());
			--WindowOnShutdown_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (AutoStop_count > 0)
	{
		m_qsErrorMessage = "Error in class 'Shutdown': tag 'AutoStop' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (OnVmWindowClose_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Shutdown': tag 'OnVmWindowClose' is absent";
	}

	if (WindowOnShutdown_count >= 0)
	{
		m_lstWarningList += "Warning in class 'Shutdown': tag 'WindowOnShutdown' is absent";
	}



	return 0;
}

void Shutdown::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool Shutdown::merge(Shutdown* pCur, Shutdown* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "Shutdown";

	if (getAutoStop() != pCur->getAutoStop() && getAutoStop() == pPrev->getAutoStop())
		setAutoStop(pCur->getAutoStop());
	else if (getAutoStop() != pCur->getAutoStop() && getAutoStop() != pPrev->getAutoStop() && pCur->getAutoStop() != pPrev->getAutoStop())
	{
		m_qsErrorMessage += ".AutoStop";
		return false;
	}

	if (getOnVmWindowClose() != pCur->getOnVmWindowClose() && getOnVmWindowClose() == pPrev->getOnVmWindowClose())
		setOnVmWindowClose(pCur->getOnVmWindowClose());
	else if (getOnVmWindowClose() != pCur->getOnVmWindowClose() && getOnVmWindowClose() != pPrev->getOnVmWindowClose() && pCur->getOnVmWindowClose() != pPrev->getOnVmWindowClose())
	{
		m_qsErrorMessage += ".OnVmWindowClose";
		return false;
	}

	if (getWindowOnShutdown() != pCur->getWindowOnShutdown() && getWindowOnShutdown() == pPrev->getWindowOnShutdown())
		setWindowOnShutdown(pCur->getWindowOnShutdown());
	else if (getWindowOnShutdown() != pCur->getWindowOnShutdown() && getWindowOnShutdown() != pPrev->getWindowOnShutdown() && pCur->getWindowOnShutdown() != pPrev->getWindowOnShutdown())
	{
		m_qsErrorMessage += ".WindowOnShutdown";
		return false;
	}

	return true;
}

void Shutdown::diff(const Shutdown* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getAutoStop() != pOld->getAutoStop())
		lstDiffFullItemIds += getAutoStop_id();

	if (getOnVmWindowClose() != pOld->getOnVmWindowClose())
		lstDiffFullItemIds += getOnVmWindowClose_id();

	if (getWindowOnShutdown() != pOld->getWindowOnShutdown())
		lstDiffFullItemIds += getWindowOnShutdown_id();

}

void Shutdown::Copy(const Shutdown& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setAutoStop(rObject.getAutoStop());
	setOnVmWindowClose(rObject.getOnVmWindowClose());
	setWindowOnShutdown(rObject.getWindowOnShutdown());

	CustomCopy(&rObject);

}

void Shutdown::InitLists()
{
	CustomInit();
}

void Shutdown::ClearLists()
{
}

void Shutdown::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

