////////////////////////////////////////////////////////////////////////////////
///
/// TisDatabase.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "TisDatabase.h"


TisDatabase::TisDatabase()
{
	InitLists();
	setDefaults();
}

TisDatabase::TisDatabase(const TisDatabase& rObject)
: CBaseNodeSignals()
{
	Copy(rObject);
}

TisDatabase::TisDatabase(const TisDatabase* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

TisDatabase& TisDatabase::operator=(const TisDatabase& rObject)
{
	Copy(rObject);
	return *this;
}

TisDatabase::TisDatabase(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

TisDatabase::~TisDatabase()
{
	ClearLists();
}


QString TisDatabase::getData() const
{
	return m_qsData;
}

void TisDatabase::setData(QString value)
{
	bool bValueChanged = (m_qsData != value);
	m_qsData = value;
	if (isSignalsEnabled() && bValueChanged)
	{
		emit signalDataChanged(value);
	}
}

void TisDatabase::slotChangeData(QString value)
{
	setData(value);
}

void TisDatabase::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Data").isNull() )
		setData();
}

QVariant TisDatabase::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Data.patch_stamp")
		value.setValue(getFieldPatchedValue("Data"));

	if (path == "Data")
		value.setValue(getData());

	return value;
}

bool TisDatabase::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Data.patch_stamp")
	{
		markPatchedField("Data", value.toString());
		return true;
	}

	if (path == "Data")
	{
		if (pbValueChanged)
			*pbValueChanged = (getData() != value.value< QString >());
		setData(value.value< QString >());
		return true;
	}

	return false;
}

QString TisDatabase::getData_id() const
{
	return getFullItemId().isEmpty() ? "Data" : getFullItemId() + ".Data";
}

int TisDatabase::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return nNewItemId;
}

bool TisDatabase::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	return false;
}

QDomElement TisDatabase::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("TisDatabase") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Data");
	text_element = Document->createTextNode( QString("%1").arg(getData()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int TisDatabase::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("TisDatabase") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'TisDatabase': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Data_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "Data";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Data_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Data")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setData(text_element.data());
			--Data_count;
		}


		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Data_count > 0)
	{
		m_qsErrorMessage = "Error in class 'TisDatabase': tag 'Data' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}



	return 0;
}

void TisDatabase::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

bool TisDatabase::merge(TisDatabase* pCur, TisDatabase* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "TisDatabase";

	if (getData() != pCur->getData() && getData() == pPrev->getData())
		setData(pCur->getData());
	else if (getData() != pCur->getData() && getData() != pPrev->getData() && pCur->getData() != pPrev->getData())
	{
		m_qsErrorMessage += ".Data";
		return false;
	}

	return true;
}

void TisDatabase::diff(const TisDatabase* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getData() != pOld->getData())
		lstDiffFullItemIds += getData_id();

}

void TisDatabase::Copy(const TisDatabase& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setData(rObject.getData());

	CustomCopy(&rObject);

}

void TisDatabase::InitLists()
{
	CustomInit();
}

void TisDatabase::ClearLists()
{
}

void TisDatabase::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

