////////////////////////////////////////////////////////////////////////////////
///
/// CVmDirectories.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmDirectories.h"


CVmDirectories::CVmDirectories()
{
	InitLists();
	setDefaults();
}

CVmDirectories::CVmDirectories(const CVmDirectories& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CVmDirectories::CVmDirectories(const CVmDirectories* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmDirectories& CVmDirectories::operator=(const CVmDirectories& rObject)
{
	Copy(rObject);
	return *this;
}

CVmDirectories::CVmDirectories(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmDirectories::~CVmDirectories()
{
	ClearLists();
}


QString CVmDirectories::getOutFileName() const
{
    return m_qsFileName.isEmpty() ? m_strFile : m_qsFileName;
}

void CVmDirectories::setCatalogueFileName(QString value)
{
	m_strFile = value;

	if ( !m_qsFileName.isEmpty() )
		m_qsFileName = m_strFile;
}

QString CVmDirectories::getCatalogueFileName() const
{
	return m_strFile;
}

void CVmDirectories::addVmDirectory(CVmDirectory* item)
{
	m_lstVmDirectory.append( item );
}


CVmDirectory*	CVmDirectories::getVmDirectoryByUuid( const QString& uuid)
{
	foreach ( CVmDirectory* p, m_lstVmDirectory )
	{
		if ( p->getUuid() ==  uuid )
			return p;
	}

	return 0;
}

CVmServerIdentification* CVmDirectories::getVmServerIdentification() const
{
	if (!m_lstServerIdentification.isEmpty())
	{
		return m_lstServerIdentification[0];
	}
	return 0;
}

void CVmDirectories::setVmServerIdentification(CVmServerIdentification* pServerIdentification)
{
	ClearList<CVmServerIdentification>(m_lstServerIdentification);
	if (pServerIdentification)
	{
		m_lstServerIdentification += pServerIdentification;
	}
}

CVmDirCommonLockedOperations* CVmDirectories::getCommonLockedOperations() const
{
	if (!m_lstCommonLockedOperations.isEmpty())
	{
		return m_lstCommonLockedOperations[0];
	}
	return 0;
}

void CVmDirectories::setCommonLockedOperations(CVmDirCommonLockedOperations* pCommonLockedOperations)
{
	ClearList<CVmDirCommonLockedOperations>(m_lstCommonLockedOperations);
	if (pCommonLockedOperations)
	{
		m_lstCommonLockedOperations += pCommonLockedOperations;
	}
}

void CVmDirectories::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QVariant CVmDirectories::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	list_tag = "ServerIdentification.";
	if (path.startsWith(list_tag) && ! m_lstServerIdentification.isEmpty() && m_lstServerIdentification.first())
		return m_lstServerIdentification.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "CommonLockedOperations.";
	if (path.startsWith(list_tag) && ! m_lstCommonLockedOperations.isEmpty() && m_lstCommonLockedOperations.first())
		return m_lstCommonLockedOperations.first()->getPropertyValue(path.mid(list_tag.size()));

	list_tag = "VmDirectory[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i] && nItemId == m_lstVmDirectory[i]->getItemId())
				return m_lstVmDirectory[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("VmDirectory.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i] && nMaxId < m_lstVmDirectory[i]->getItemId())
				nMaxId = m_lstVmDirectory[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("VmDirectory.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i]) lstIds += m_lstVmDirectory[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmDirectories::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ServerIdentification.";
	if (path.startsWith(list_tag) && ! m_lstServerIdentification.isEmpty() && m_lstServerIdentification.first())
		return m_lstServerIdentification.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "CommonLockedOperations.";
	if (path.startsWith(list_tag) && ! m_lstCommonLockedOperations.isEmpty() && m_lstCommonLockedOperations.first())
		return m_lstCommonLockedOperations.first()->setPropertyValue(path.mid(list_tag.size()), value, pbValueChanged);

	list_tag = "VmDirectory[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i] && nItemId == m_lstVmDirectory[i]->getItemId())
				return m_lstVmDirectory[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

int CVmDirectories::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ServerIdentification.";
	if (path.startsWith(list_tag) && ! m_lstServerIdentification.isEmpty() && m_lstServerIdentification.first())
		return m_lstServerIdentification.first()->addListItem(path.mid(list_tag.size()));

	list_tag = "CommonLockedOperations.";
	if (path.startsWith(list_tag) && ! m_lstCommonLockedOperations.isEmpty() && m_lstCommonLockedOperations.first())
		return m_lstCommonLockedOperations.first()->addListItem(path.mid(list_tag.size()));

	if (path == "VmDirectory")
	{
		m_lstVmDirectory += new CVmDirectory;
		nNewItemId = getMaxItemId<CVmDirectory>(m_lstVmDirectory, "VmDirectory");
		m_lstVmDirectory.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "VmDirectory");
	}

	list_tag = "VmDirectory[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i] && nItemId == m_lstVmDirectory[i]->getItemId())
				return m_lstVmDirectory[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmDirectories::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "ServerIdentification.";
	if (path.startsWith(list_tag) && ! m_lstServerIdentification.isEmpty() && m_lstServerIdentification.first())
		return m_lstServerIdentification.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "CommonLockedOperations.";
	if (path.startsWith(list_tag) && ! m_lstCommonLockedOperations.isEmpty() && m_lstCommonLockedOperations.first())
		return m_lstCommonLockedOperations.first()->deleteListItem(path.mid(list_tag.size()));

	list_tag = "VmDirectory[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVmDirectory.size(); ++i)
			if (m_lstVmDirectory[i] && nItemId == m_lstVmDirectory[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstVmDirectory[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstVmDirectory.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmDirectories::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("ParallelsVmDirectories") : m_qsExtRootTagName);

	for(i = 0; i < m_lstServerIdentification.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmServerIdentification* object = m_lstServerIdentification[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	for(i = 0; i < m_lstCommonLockedOperations.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmDirCommonLockedOperations* object = m_lstCommonLockedOperations[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	dyn_lists += "VmDirectory";
	nMaxItemId = getMaxItemId<CVmDirectory>(m_lstVmDirectory, "VmDirectory", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVmDirectory.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmDirectory* object = m_lstVmDirectory[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VmDirectory", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmDirectories::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("ParallelsVmDirectories") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmDirectories': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VmDirectory = getMaxItemId2(element, "VmDirectory");
	QMap<int , QString > mapVmDirectory;
	if (unite_with_loaded)
		fillItemIdMap<CVmDirectory>(m_lstVmDirectory, mapVmDirectory);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int ServerIdentification_count = 1;
	int CommonLockedOperations_count = 1;
	int VmDirectory_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "ServerIdentification" && ServerIdentification_count > 0)
		{
			unused_tag = false;
			CVmServerIdentification* object = m_lstServerIdentification[1 - ServerIdentification_count];
			object->makeFullItemId(getFullItemId(), "ServerIdentification");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--ServerIdentification_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "CommonLockedOperations" && CommonLockedOperations_count > 0)
		{
			unused_tag = false;
			CVmDirCommonLockedOperations* object = m_lstCommonLockedOperations[1 - CommonLockedOperations_count];
			object->makeFullItemId(getFullItemId(), "CommonLockedOperations");
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--CommonLockedOperations_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "VmDirectory")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VmDirectory++ : nItemId;
			CVmDirectory* object = new CVmDirectory();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "VmDirectory", object->getItemId());
			if (unite_with_loaded && mapVmDirectory.contains(nItemId))
				object->fromString(mapVmDirectory.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVmDirectory += object;
			--VmDirectory_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (ServerIdentification_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmDirectories': tag 'ServerIdentification' is absent";
	}

	if (CommonLockedOperations_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmDirectories': tag 'CommonLockedOperations' is absent";
	}

	if (VmDirectory_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmDirectories': tag 'VmDirectory' is absent";
	}

	syncMaxItemId(nMaxItemId_VmDirectory, "VmDirectory");


	return 0;
}

void CVmDirectories::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstServerIdentification.size(); ++i)
	{
		CVmServerIdentification* object = m_lstServerIdentification[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "ServerIdentification");
		object->syncItemIds();
	}

	for(i = 0; i < m_lstCommonLockedOperations.size(); ++i)
	{
		CVmDirCommonLockedOperations* object = m_lstCommonLockedOperations[i];
		if ( ! object ) continue;
		object->makeFullItemId(getFullItemId(), "CommonLockedOperations");
		object->syncItemIds();
	}

	nMaxItemId = getMaxItemId<CVmDirectory>(m_lstVmDirectory, "VmDirectory");
	setItemIds.clear();
	for(i = 0; i < m_lstVmDirectory.size(); ++i)
	{
		CVmDirectory* object = m_lstVmDirectory[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "VmDirectory", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VmDirectory");

}

bool CVmDirectories::merge(CVmDirectories* pCur, CVmDirectories* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "ParallelsVmDirectories";

	for(i = 0; i < m_lstServerIdentification.size(); i++)
	{
		if ( m_lstServerIdentification[i]->merge(pCur->m_lstServerIdentification[i], pPrev->m_lstServerIdentification[i], nOptions) ) continue;
		QString qsIdx = (m_lstServerIdentification.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstServerIdentification[i]->GetErrorMessage();
		return false;
	}

	for(i = 0; i < m_lstCommonLockedOperations.size(); i++)
	{
		if ( m_lstCommonLockedOperations[i]->merge(pCur->m_lstCommonLockedOperations[i], pPrev->m_lstCommonLockedOperations[i], nOptions) ) continue;
		QString qsIdx = (m_lstCommonLockedOperations.size() > 1 ? ("[" + QString::number(i) + "]") : QString());
		m_qsErrorMessage += "." + qsIdx + m_lstCommonLockedOperations[i]->GetErrorMessage();
		return false;
	}

	if ( ! mergeList<CVmDirectory>(m_lstVmDirectory, pCur->m_lstVmDirectory, pPrev->m_lstVmDirectory, "VmDirectory", nOptions) )
		return false;

	return true;
}

void CVmDirectories::diff(const CVmDirectories* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	for(i = 0; i < m_lstServerIdentification.size(); ++i)
		m_lstServerIdentification[i]->diff(pOld->m_lstServerIdentification[i], lstDiffFullItemIds);

	for(i = 0; i < m_lstCommonLockedOperations.size(); ++i)
		m_lstCommonLockedOperations[i]->diff(pOld->m_lstCommonLockedOperations[i], lstDiffFullItemIds);

	diffList<CVmDirectory>(m_lstVmDirectory, pOld->m_lstVmDirectory, lstDiffFullItemIds);

}

void CVmDirectories::Copy(const CVmDirectories& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CVmServerIdentification >(m_lstServerIdentification);
	for(i = 0; i < rObject.m_lstServerIdentification.size(); i++)
		m_lstServerIdentification += new CVmServerIdentification(rObject.m_lstServerIdentification[i]);

	ClearList<CVmDirCommonLockedOperations >(m_lstCommonLockedOperations);
	for(i = 0; i < rObject.m_lstCommonLockedOperations.size(); i++)
		m_lstCommonLockedOperations += new CVmDirCommonLockedOperations(rObject.m_lstCommonLockedOperations[i]);

	ClearList<CVmDirectory >(m_lstVmDirectory);
	for(i = 0; i < rObject.m_lstVmDirectory.size(); i++)
		m_lstVmDirectory += new CVmDirectory(rObject.m_lstVmDirectory[i]);

	CustomCopy(&rObject);

}

void CVmDirectories::InitLists()
{
	InitList<CVmServerIdentification>(1, m_lstServerIdentification);
	InitList<CVmDirCommonLockedOperations>(1, m_lstCommonLockedOperations);
	CustomInit();
}

void CVmDirectories::ClearLists()
{
	ClearList<CVmServerIdentification>(m_lstServerIdentification);
	ClearList<CVmDirCommonLockedOperations>(m_lstCommonLockedOperations);
	ClearList<CVmDirectory>(m_lstVmDirectory);
}

void CVmDirectories::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VmDirectory") )
		ClearList<CVmDirectory>(m_lstVmDirectory);
	for(i = 0; i < m_lstServerIdentification.size() && ! unite_with_loaded; i++)
	{
		m_lstServerIdentification[i]->ClearListsInReadXml();
		m_lstServerIdentification[i]->setDefaults();
		m_lstServerIdentification[i]->setSectionFakeFlag(true);
	}
	for(i = 0; i < m_lstCommonLockedOperations.size() && ! unite_with_loaded; i++)
	{
		m_lstCommonLockedOperations[i]->ClearListsInReadXml();
		m_lstCommonLockedOperations[i]->setDefaults();
		m_lstCommonLockedOperations[i]->setSectionFakeFlag(true);
	}
}

