////////////////////////////////////////////////////////////////////////////////
///
/// CVmDirectories.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMDIRECTORIES_H
#define CVMDIRECTORIES_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmServerIdentification.h"
#include "CVmDirCommonLockedOperations.h"
#include "CVmDirectory.h"


class CVmDirectories : public CBaseNode
{

public:

	CVmDirectories();
	CVmDirectories(const CVmDirectories& rObject);
	CVmDirectories(const CVmDirectories* pObject);
	CVmDirectories(QFile* pFile);
	CVmDirectories& operator=(const CVmDirectories& rObject);
	virtual ~CVmDirectories();


	// Get output file name
	QString getOutFileName() const;
	// Set catalogue file name
	void setCatalogueFileName(QString value);
	// Get catalogue file name
	QString getCatalogueFileName() const;
private:
    QString m_strFile;
public:

	// List of VM directory 
	QList<CVmDirectory* >* getVmDirectoriesList()
	{
		return &m_lstVmDirectory;
	}

	// Add VM directory to the list
	void addVmDirectory(CVmDirectory* item); 

	CVmDirectory*	getVmDirectoryByUuid( const QString& uuid);

	QList<CVmServerIdentification* >		m_lstServerIdentification;
	QList<CVmDirCommonLockedOperations* >		m_lstCommonLockedOperations;
	QList<CVmDirectory* >		m_lstVmDirectory;

	CVmServerIdentification* getVmServerIdentification() const;
	void setVmServerIdentification(CVmServerIdentification* pServerIdentification);

	CVmDirCommonLockedOperations* getCommonLockedOperations() const;
	void setCommonLockedOperations(CVmDirCommonLockedOperations* pCommonLockedOperations);


	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmDirectories* pCur, CVmDirectories* pPrev, MergeOptions nOptions);

	void diff(const CVmDirectories* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:


	void Copy(const CVmDirectories& rObject);

};



#endif
