////////////////////////////////////////////////////////////////////////////////
///
/// CVmDirectory.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmDirectory.h"


CVmDirectory::CVmDirectory()
{
	InitLists();
	setDefaults();
}

CVmDirectory::CVmDirectory(const CVmDirectory& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CVmDirectory::CVmDirectory(const CVmDirectory* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmDirectory& CVmDirectory::operator=(const CVmDirectory& rObject)
{
	Copy(rObject);
	return *this;
}

CVmDirectory::CVmDirectory(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmDirectory::~CVmDirectory()
{
	ClearLists();
}


void CVmDirectory::addVmDirectoryItem(CVmDirectoryItem* item)
{
	m_lstVmDirectoryItems.append( item );
}

CVmDirectory::CTemporaryCatalogue* CVmDirectory::getTemporaryCatalogue()
{
   return &m_temporaryCatalogue;
}

CVmDirectory::TemporaryCatalogueItem::TemporaryCatalogueItem(const QString& vmUuid, const QString& vmXmlPath, const QString& vmName)
: m_sItemId( Uuid::createUuid().toString() ),
  vmUuid(vmUuid),vmXmlPath(vmXmlPath),vmName(vmName)
{
}


CVmDirectory::CVmDirectory(const Uuid& uuid, const QString& defaultVmFolder,
				 const QString& userFriendlyName)
{
	cleanupClassProperties();
	
	setUuid( uuid.toString() );
	setDefaultVmFolder( defaultVmFolder );
	setUserFriendlyName( userFriendlyName );
}

QString CVmDirectory::getUuid() const
{
	return m_qsUuid;
}

void CVmDirectory::setUuid(QString value)
{
	m_qsUuid = value;
}

QString CVmDirectory::getDefaultVmFolder() const
{
	return m_qsDefaultVmFolder;
}

void CVmDirectory::setDefaultVmFolder(QString value)
{
	m_qsDefaultVmFolder = value;
}

QString CVmDirectory::getUserFriendlyName() const
{
	return m_qsUserFriendlyName;
}

void CVmDirectory::setUserFriendlyName(QString value)
{
	m_qsUserFriendlyName = value;
}

void CVmDirectory::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("Uuid").isNull() )
		setUuid(Uuid::createUuid().toString());
	if ( ! RootElement || ! RootElement->firstChildElement("DefaultVmFolder").isNull() )
		setDefaultVmFolder();
	if ( ! RootElement || ! RootElement->firstChildElement("UserFriendlyName").isNull() )
		setUserFriendlyName();
}

QVariant CVmDirectory::getPropertyValue(QString path) const
{
	QVariant value;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "itemId")
		value.setValue(getItemId());

	if (path == "Uuid.patch_stamp")
		value.setValue(getFieldPatchedValue("Uuid"));

	if (path == "Uuid")
		value.setValue(getUuid());

	if (path == "DefaultVmFolder.patch_stamp")
		value.setValue(getFieldPatchedValue("DefaultVmFolder"));

	if (path == "DefaultVmFolder")
		value.setValue(getDefaultVmFolder());

	if (path == "UserFriendlyName.patch_stamp")
		value.setValue(getFieldPatchedValue("UserFriendlyName"));

	if (path == "UserFriendlyName")
		value.setValue(getUserFriendlyName());

	list_tag = "VirtualMachine[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return value;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return value;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i] && nItemId == m_lstVmDirectoryItems[i]->getItemId())
				return m_lstVmDirectoryItems[i]->getPropertyValue(path.mid(idx + 2));
	}
	else if (path.startsWith("VirtualMachine.maxItemId"))
	{
		int nMaxId = -1;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i] && nMaxId < m_lstVmDirectoryItems[i]->getItemId())
				nMaxId = m_lstVmDirectoryItems[i]->getItemId();
		value.setValue(nMaxId);
	}
	else if (path.startsWith("VirtualMachine.listItemIds"))
	{
		QList<int > lstIds;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i]) lstIds += m_lstVmDirectoryItems[i]->getItemId();
		value.setValue(lstIds);
	}

	return value;
}

bool CVmDirectory::setPropertyValue(QString path, QVariant value, bool* pbValueChanged)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(value);
	Q_UNUSED(pbValueChanged);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "Uuid.patch_stamp")
	{
		markPatchedField("Uuid", value.toString());
		return true;
	}

	if (path == "Uuid")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUuid() != value.value< QString >());
		setUuid(value.value< QString >());
		return true;
	}

	if (path == "DefaultVmFolder.patch_stamp")
	{
		markPatchedField("DefaultVmFolder", value.toString());
		return true;
	}

	if (path == "DefaultVmFolder")
	{
		if (pbValueChanged)
			*pbValueChanged = (getDefaultVmFolder() != value.value< QString >());
		setDefaultVmFolder(value.value< QString >());
		return true;
	}

	if (path == "UserFriendlyName.patch_stamp")
	{
		markPatchedField("UserFriendlyName", value.toString());
		return true;
	}

	if (path == "UserFriendlyName")
	{
		if (pbValueChanged)
			*pbValueChanged = (getUserFriendlyName() != value.value< QString >());
		setUserFriendlyName(value.value< QString >());
		return true;
	}

	list_tag = "VirtualMachine[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i] && nItemId == m_lstVmDirectoryItems[i]->getItemId())
				return m_lstVmDirectoryItems[i]->setPropertyValue(path.mid(idx + 2), value, pbValueChanged);
	}

	return false;
}

QString CVmDirectory::getUuid_id() const
{
	return getFullItemId().isEmpty() ? "Uuid" : getFullItemId() + ".Uuid";
}
QString CVmDirectory::getDefaultVmFolder_id() const
{
	return getFullItemId().isEmpty() ? "DefaultVmFolder" : getFullItemId() + ".DefaultVmFolder";
}
QString CVmDirectory::getUserFriendlyName_id() const
{
	return getFullItemId().isEmpty() ? "UserFriendlyName" : getFullItemId() + ".UserFriendlyName";
}

int CVmDirectory::addListItem(QString path)
{
	int nNewItemId = -1;
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(nNewItemId);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	if (path == "VirtualMachine")
	{
		m_lstVmDirectoryItems += new CVmDirectoryItem;
		nNewItemId = getMaxItemId<CVmDirectoryItem>(m_lstVmDirectoryItems, "VirtualMachine");
		m_lstVmDirectoryItems.last()->setItemId(nNewItemId);
		syncMaxItemId(nNewItemId + 1, "VirtualMachine");
	}

	list_tag = "VirtualMachine[";
	if (path.startsWith(list_tag))
	{
		int idx = path.indexOf("].");
		if (idx == -1) return -1;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return -1;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i] && nItemId == m_lstVmDirectoryItems[i]->getItemId())
				return m_lstVmDirectoryItems[i]->addListItem(path.mid(idx + 2));
	}

	return nNewItemId;
}

bool CVmDirectory::deleteListItem(QString path)
{
	QString list_tag;
	bool bOk = false;
	Q_UNUSED(path);
	Q_UNUSED(list_tag);
	Q_UNUSED(bOk);

	list_tag = "VirtualMachine[";
	if (path.startsWith(list_tag))
	{
		bool bDel = false;
		int idx = path.indexOf("].");
		if (idx == -1 && (idx = path.indexOf("]")) != -1) bDel = true;
		if (idx == -1) return false;
		QString qsItemId = path.mid(list_tag.size(), idx - list_tag.size());
		int nItemId = qsItemId.toInt(&bOk);
		if ( ! bOk ) return false;
		for(int i = 0; i < m_lstVmDirectoryItems.size(); ++i)
			if (m_lstVmDirectoryItems[i] && nItemId == m_lstVmDirectoryItems[i]->getItemId())
			{
				if ( ! bDel )
					return m_lstVmDirectoryItems[i]->deleteListItem(path.mid(idx + 2));
				delete m_lstVmDirectoryItems.takeAt(i);
				return true;
			}
	}

	return false;
}

QDomElement CVmDirectory::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VmDirectory") : m_qsExtRootTagName);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("Uuid");
	text_element = Document->createTextNode( QString("%1").arg(getUuid()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("DefaultVmFolder");
	text_element = Document->createTextNode( QString("%1").arg(getDefaultVmFolder()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("UserFriendlyName");
	text_element = Document->createTextNode( QString("%1").arg(getUserFriendlyName()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "VirtualMachine";
	nMaxItemId = getMaxItemId<CVmDirectoryItem>(m_lstVmDirectoryItems, "VirtualMachine", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstVmDirectoryItems.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmDirectoryItem* object = m_lstVmDirectoryItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "VirtualMachine", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmDirectory::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VmDirectory") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmDirectory': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_VirtualMachine = getMaxItemId2(element, "VirtualMachine");
	QMap<int , QString > mapVirtualMachine;
	if (unite_with_loaded)
		fillItemIdMap<CVmDirectoryItem>(m_lstVmDirectoryItems, mapVirtualMachine);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int VmDirectoryItems_count = 0;
	int Uuid_count = 1;
	int DefaultVmFolder_count = 1;
	int UserFriendlyName_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "uuid";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (Uuid_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "Uuid")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUuid(text_element.data());
			--Uuid_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "DefaultVmFolder";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (DefaultVmFolder_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "DefaultVmFolder")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setDefaultVmFolder(text_element.data());
			--DefaultVmFolder_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "UserFriendlyName";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (UserFriendlyName_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "UserFriendlyName")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setUserFriendlyName(text_element.data());
			--UserFriendlyName_count;
		}


		if (tag_name == "VirtualMachine")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_VirtualMachine++ : nItemId;
			CVmDirectoryItem* object = new CVmDirectoryItem();
			object->setItemId(nItemId);
			object->makeFullItemId(getFullItemId(), "VirtualMachine", object->getItemId());
			if (unite_with_loaded && mapVirtualMachine.contains(nItemId))
				object->fromString(mapVirtualMachine.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstVmDirectoryItems += object;
			--VmDirectoryItems_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (VmDirectoryItems_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CVmDirectory': tag 'VirtualMachine' is absent";
	}

	if (Uuid_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmDirectory': tag 'Uuid' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (DefaultVmFolder_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmDirectory': tag 'DefaultVmFolder' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (UserFriendlyName_count > 0)
	{
		m_qsErrorMessage = "Error in class 'CVmDirectory': tag 'UserFriendlyName' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_VirtualMachine, "VirtualMachine");


	return 0;
}

void CVmDirectory::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<CVmDirectoryItem>(m_lstVmDirectoryItems, "VirtualMachine");
	setItemIds.clear();
	for(i = 0; i < m_lstVmDirectoryItems.size(); ++i)
	{
		CVmDirectoryItem* object = m_lstVmDirectoryItems[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->makeFullItemId(getFullItemId(), "VirtualMachine", object->getItemId());
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "VirtualMachine");

}

bool CVmDirectory::merge(CVmDirectory* pCur, CVmDirectory* pPrev, MergeOptions nOptions)
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pCur);
	Q_UNUSED(pPrev);
	Q_UNUSED(nOptions);

	m_qsErrorMessage = "VmDirectory";

	if (getUuid() != pCur->getUuid() && getUuid() == pPrev->getUuid())
		setUuid(pCur->getUuid());
	else if (getUuid() != pCur->getUuid() && getUuid() != pPrev->getUuid() && pCur->getUuid() != pPrev->getUuid())
	{
		m_qsErrorMessage += ".Uuid";
		return false;
	}

	if (getDefaultVmFolder() != pCur->getDefaultVmFolder() && getDefaultVmFolder() == pPrev->getDefaultVmFolder())
		setDefaultVmFolder(pCur->getDefaultVmFolder());
	else if (getDefaultVmFolder() != pCur->getDefaultVmFolder() && getDefaultVmFolder() != pPrev->getDefaultVmFolder() && pCur->getDefaultVmFolder() != pPrev->getDefaultVmFolder())
	{
		m_qsErrorMessage += ".DefaultVmFolder";
		return false;
	}

	if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() == pPrev->getUserFriendlyName())
		setUserFriendlyName(pCur->getUserFriendlyName());
	else if (getUserFriendlyName() != pCur->getUserFriendlyName() && getUserFriendlyName() != pPrev->getUserFriendlyName() && pCur->getUserFriendlyName() != pPrev->getUserFriendlyName())
	{
		m_qsErrorMessage += ".UserFriendlyName";
		return false;
	}

	if ( ! mergeList<CVmDirectoryItem>(m_lstVmDirectoryItems, pCur->m_lstVmDirectoryItems, pPrev->m_lstVmDirectoryItems, "VirtualMachine", nOptions) )
		return false;

	return true;
}

void CVmDirectory::diff(const CVmDirectory* pOld, QStringList& lstDiffFullItemIds) const
{
	int i = -1;
	Q_UNUSED(i);
	Q_UNUSED(pOld);
	Q_UNUSED(lstDiffFullItemIds);

	if (getUuid() != pOld->getUuid())
		lstDiffFullItemIds += getUuid_id();

	if (getDefaultVmFolder() != pOld->getDefaultVmFolder())
		lstDiffFullItemIds += getDefaultVmFolder_id();

	if (getUserFriendlyName() != pOld->getUserFriendlyName())
		lstDiffFullItemIds += getUserFriendlyName_id();

	diffList<CVmDirectoryItem>(m_lstVmDirectoryItems, pOld->m_lstVmDirectoryItems, lstDiffFullItemIds);

}

void CVmDirectory::Copy(const CVmDirectory& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setUuid(rObject.getUuid());
	setDefaultVmFolder(rObject.getDefaultVmFolder());
	setUserFriendlyName(rObject.getUserFriendlyName());

	ClearList<CVmDirectoryItem >(m_lstVmDirectoryItems);
	for(i = 0; i < rObject.m_lstVmDirectoryItems.size(); i++)
		m_lstVmDirectoryItems += new CVmDirectoryItem(rObject.m_lstVmDirectoryItems[i]);

	CustomCopy(&rObject);

}

void CVmDirectory::InitLists()
{
	CustomInit();
}

void CVmDirectory::ClearLists()
{
	ClearList<CVmDirectoryItem>(m_lstVmDirectoryItems);
}

void CVmDirectory::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("VirtualMachine") )
		ClearList<CVmDirectoryItem>(m_lstVmDirectoryItems);
}

