////////////////////////////////////////////////////////////////////////////////
///
/// CVmDirectory.h
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#ifndef CVMDIRECTORY_H
#define CVMDIRECTORY_H


#include <prlcommon/PrlObjects/CBaseNode.h>
#include "CVmDirectoryItem.h"


class CVmDirectory : public CBaseNode
{

public:

	CVmDirectory();
	CVmDirectory(const CVmDirectory& rObject);
	CVmDirectory(const CVmDirectory* pObject);
	CVmDirectory(QFile* pFile);
	CVmDirectory& operator=(const CVmDirectory& rObject);
	virtual ~CVmDirectory();


	// Add VM directory item to the list
	void addVmDirectoryItem(CVmDirectoryItem* item); 

   struct TemporaryCatalogueItem
   {  TemporaryCatalogueItem(const QString& vmUuid, const QString& vmXmlPath, const QString& vmName);
      QString m_sItemId;
      QString vmUuid;
      QString vmXmlPath;
      QString vmName;
   };
   typedef QList<TemporaryCatalogueItem > CTemporaryCatalogue;

   CTemporaryCatalogue*  getTemporaryCatalogue();
private:
   CTemporaryCatalogue  m_temporaryCatalogue;
public:

	CVmDirectory(const Uuid& uuid, const QString& defaultVmFolder,
		const QString& userFriendlyName);

	QList<CVmDirectoryItem* >		m_lstVmDirectoryItems;


	QString getUuid() const;
	void setUuid(QString value = QString());

	QString getDefaultVmFolder() const;
	void setDefaultVmFolder(QString value = QString());

	QString getUserFriendlyName() const;
	void setUserFriendlyName(QString value = QString());

	virtual void setDefaults(QDomElement* RootElement = 0);

	virtual QVariant getPropertyValue(QString path) const;
	virtual bool setPropertyValue(QString path, QVariant value, bool* pbValueChanged = 0);

	QString getUuid_id() const;
	QString getDefaultVmFolder_id() const;
	QString getUserFriendlyName_id() const;

	int addListItem(QString path);
	bool deleteListItem(QString path);

	virtual QDomElement getXml(QDomDocument* Document, bool no_save_option = false) const;
	virtual int readXml(QDomElement* RootElement, QString ext_tag_name = QString(), bool unite_with_loaded = false);
	virtual void syncItemIds();

	bool merge(CVmDirectory* pCur, CVmDirectory* pPrev, MergeOptions nOptions);

	void diff(const CVmDirectory* pOld, QStringList& lstDiffFullItemIds) const;

	virtual void InitLists();
	virtual void ClearLists();
	virtual void ClearListsInReadXml(bool unite_with_loaded = false, const QStringList& dyn_lists = QStringList(), bool bSupportDynList = true);

protected:

	QString		m_qsUuid;
	QString		m_qsDefaultVmFolder;
	QString		m_qsUserFriendlyName;

	void Copy(const CVmDirectory& rObject);

};



#endif
