////////////////////////////////////////////////////////////////////////////////
///
/// CVmInfo.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CVmInfo.h"


CVmInfo::CVmInfo()
{
	InitLists();
	setDefaults();
}

CVmInfo::CVmInfo(const CVmInfo& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CVmInfo::CVmInfo(const CVmInfo* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CVmInfo& CVmInfo::operator=(const CVmInfo& rObject)
{
	Copy(rObject);
	return *this;
}

CVmInfo::CVmInfo(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CVmInfo::~CVmInfo()
{
	ClearLists();
}


CVmGuestOsInformation* CVmInfo::getGuestOsInformation() const
{
	if (!m_lstGuestOsInformation.isEmpty())
	{
		return m_lstGuestOsInformation[0];
	}
	return 0;
}

void CVmInfo::setGuestOsInformation(CVmGuestOsInformation* pGuestOsInformation)
{
	ClearList<CVmGuestOsInformation>(m_lstGuestOsInformation);
	if (pGuestOsInformation)
	{
		m_lstGuestOsInformation += pGuestOsInformation;
	}
}

void CVmInfo::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement CVmInfo::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VmInfo") : m_qsExtRootTagName);

	for(i = 0; i < m_lstGuestOsInformation.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVmGuestOsInformation* object = m_lstGuestOsInformation[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CVmInfo::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VmInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CVmInfo': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int GuestOsInformation_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "GuestOsInformation" && GuestOsInformation_count > 0)
		{
			unused_tag = false;
			CVmGuestOsInformation* object = m_lstGuestOsInformation[1 - GuestOsInformation_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--GuestOsInformation_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (GuestOsInformation_count >= 1)
	{
		m_lstWarningList += "Warning in class 'CVmInfo': tag 'GuestOsInformation' is absent";
	}



	return 0;
}

void CVmInfo::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstGuestOsInformation.size(); ++i)
	{
		CVmGuestOsInformation* object = m_lstGuestOsInformation[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void CVmInfo::Copy(const CVmInfo& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CVmGuestOsInformation >(m_lstGuestOsInformation);
	for(i = 0; i < rObject.m_lstGuestOsInformation.size(); i++)
		m_lstGuestOsInformation += new CVmGuestOsInformation(rObject.m_lstGuestOsInformation[i]);

	CustomCopy(&rObject);

}

void CVmInfo::InitLists()
{
	InitList<CVmGuestOsInformation>(1, m_lstGuestOsInformation);
	CustomInit();
}

void CVmInfo::ClearLists()
{
	ClearList<CVmGuestOsInformation>(m_lstGuestOsInformation);
}

void CVmInfo::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstGuestOsInformation.size() && ! unite_with_loaded; i++)
	{
		m_lstGuestOsInformation[i]->ClearListsInReadXml();
		m_lstGuestOsInformation[i]->setDefaults();
		m_lstGuestOsInformation[i]->setSectionFakeFlag(true);
	}
}

