////////////////////////////////////////////////////////////////////////////////
///
/// CpuFeatures.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "CpuFeatures.h"


CpuFeatures::CpuFeatures()
{
	InitLists();
	setDefaults();
}

CpuFeatures::CpuFeatures(const CpuFeatures& rObject)
: CBaseNode()
{
	Copy(rObject);
}

CpuFeatures::CpuFeatures(const CpuFeatures* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

CpuFeatures& CpuFeatures::operator=(const CpuFeatures& rObject)
{
	Copy(rObject);
	return *this;
}

CpuFeatures::CpuFeatures(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

CpuFeatures::~CpuFeatures()
{
	ClearLists();
}


QList<QString> CpuFeatures::getRequired() const
{
	return m_lstRequired;
}

void CpuFeatures::setRequired(QList<QString> value)
{
	m_lstRequired = value;
}

QList<QString> CpuFeatures::getDisabled() const
{
	return m_lstDisabled;
}

void CpuFeatures::setDisabled(QList<QString> value)
{
	m_lstDisabled = value;
}

void CpuFeatures::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || dyn_lists.contains("Required") )
		setRequired();
	if ( ! RootElement || dyn_lists.contains("Disabled") )
		setDisabled();
}

QDomElement CpuFeatures::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("CpuFeatures") : m_qsExtRootTagName);

	dyn_lists += "Required";
	for(i = 0; i < m_lstRequired.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("Required");
		text_element = Document->createTextNode( QString("%1").arg(m_lstRequired[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	dyn_lists += "Disabled";
	for(i = 0; i < m_lstDisabled.size(); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		element = Document->createElement("Disabled");
		text_element = Document->createTextNode( QString("%1").arg(m_lstDisabled[i]) );
		root_element.appendChild(element);
		element.appendChild(text_element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int CpuFeatures::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("CpuFeatures") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'CpuFeatures': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int Required_count = 0;
	int Disabled_count = 0;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		if (tag_name == "Required")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstRequired += text_element.data();
			--Required_count;
		}
		if (tag_name == "Disabled")
		{
			unused_tag = false;
			text_element = element.firstChild().toText();
			m_lstDisabled += text_element.data();
			--Disabled_count;
		}
		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (Required_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CpuFeatures': tag 'Required' is absent";
	}

	if (Disabled_count >= 0)
	{
		m_lstWarningList += "Warning in class 'CpuFeatures': tag 'Disabled' is absent";
	}



	return 0;
}

void CpuFeatures::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

}

void CpuFeatures::Copy(const CpuFeatures& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setRequired(rObject.getRequired());
	setDisabled(rObject.getDisabled());

	CustomCopy(&rObject);

}

void CpuFeatures::InitLists()
{
	CustomInit();
}

void CpuFeatures::ClearLists()
{
}

void CpuFeatures::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
}

