////////////////////////////////////////////////////////////////////////////////
///
/// QemuKvm.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "QemuKvm.h"


QemuKvm::QemuKvm()
{
	InitLists();
	setDefaults();
}

QemuKvm::QemuKvm(const QemuKvm& rObject)
: CBaseNode()
{
	Copy(rObject);
}

QemuKvm::QemuKvm(const QemuKvm* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

QemuKvm& QemuKvm::operator=(const QemuKvm& rObject)
{
	Copy(rObject);
	return *this;
}

QemuKvm::QemuKvm(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

QemuKvm::~QemuKvm()
{
	ClearLists();
}


CVCpuInfo* QemuKvm::getVCpuInfo() const
{
	if (!m_lstVCpuInfo.isEmpty())
	{
		return m_lstVCpuInfo[0];
	}
	return 0;
}

void QemuKvm::setVCpuInfo(CVCpuInfo* pVCpuInfo)
{
	ClearList<CVCpuInfo>(m_lstVCpuInfo);
	if (pVCpuInfo)
	{
		m_lstVCpuInfo += pVCpuInfo;
	}
}

void QemuKvm::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

}

QDomElement QemuKvm::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("QemuKvm") : m_qsExtRootTagName);

	for(i = 0; i < m_lstVCpuInfo.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CVCpuInfo* object = m_lstVCpuInfo[i];
		if ( ! object ) continue;
		element = object->getXml(Document, no_save_option);
		root_element.appendChild(element);
	}

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int QemuKvm::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("QemuKvm") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'QemuKvm': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();


	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int VCpuInfo_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		if (tag_name == "VCpuInfo" && VCpuInfo_count > 0)
		{
			unused_tag = false;
			CVCpuInfo* object = m_lstVCpuInfo[1 - VCpuInfo_count];
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			--VCpuInfo_count;
			object->setSectionFakeFlag(false);
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (VCpuInfo_count >= 1)
	{
		m_lstWarningList += "Warning in class 'QemuKvm': tag 'VCpuInfo' is absent";
	}



	return 0;
}

void QemuKvm::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	for(i = 0; i < m_lstVCpuInfo.size(); ++i)
	{
		CVCpuInfo* object = m_lstVCpuInfo[i];
		if ( ! object ) continue;
		object->syncItemIds();
	}

}

void QemuKvm::Copy(const QemuKvm& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);


	ClearList<CVCpuInfo >(m_lstVCpuInfo);
	for(i = 0; i < rObject.m_lstVCpuInfo.size(); i++)
		m_lstVCpuInfo += new CVCpuInfo(rObject.m_lstVCpuInfo[i]);

	CustomCopy(&rObject);

}

void QemuKvm::InitLists()
{
	InitList<CVCpuInfo>(1, m_lstVCpuInfo);
	CustomInit();
}

void QemuKvm::ClearLists()
{
	ClearList<CVCpuInfo>(m_lstVCpuInfo);
}

void QemuKvm::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	for(i = 0; i < m_lstVCpuInfo.size() && ! unite_with_loaded; i++)
	{
		m_lstVCpuInfo[i]->ClearListsInReadXml();
		m_lstVCpuInfo[i]->setDefaults();
		m_lstVCpuInfo[i]->setSectionFakeFlag(true);
	}
}

