////////////////////////////////////////////////////////////////////////////////
///
/// VtInfo.cpp
///
/// ***DO NOT EDIT THIS FILE***
/// ***IT IS GENERATED AUTOMATICALLY BY xsd2src UTILITY***
///
////////////////////////////////////////////////////////////////////////////////

#include "VtInfo.h"


VtInfo::VtInfo()
{
	InitLists();
	setDefaults();
}

VtInfo::VtInfo(const VtInfo& rObject)
: CBaseNode()
{
	Copy(rObject);
}

VtInfo::VtInfo(const VtInfo* pObject)
{
	if (pObject)
	{
		Copy(*pObject);
	}
	else
	{
		InitLists();
		setDefaults();
	}
}

VtInfo& VtInfo::operator=(const VtInfo& rObject)
{
	Copy(rObject);
	return *this;
}

VtInfo::VtInfo(QFile* pFile)
{
	InitLists();
	loadFromFile(pFile);
}

VtInfo::~VtInfo()
{
	ClearLists();
}


QemuKvm* VtInfo::getQemuKvm() const
{
	if (!m_lstQemuKvm.isEmpty())
	{
		return m_lstQemuKvm[0];
	}
	return 0;
}

void VtInfo::setQemuKvm(QemuKvm* pQemuKvm)
{
	ClearList<QemuKvm>(m_lstQemuKvm);
	if (pQemuKvm)
	{
		m_lstQemuKvm += pQemuKvm;
	}
}

CpuFeatures* VtInfo::getCpuFeatures() const
{
	if (!m_lstDisabled.isEmpty())
	{
		return m_lstDisabled[0];
	}
	return 0;
}

void VtInfo::setCpuFeatures(CpuFeatures* pDisabled)
{
	ClearList<CpuFeatures>(m_lstDisabled);
	if (pDisabled)
	{
		m_lstDisabled += pDisabled;
	}
}

bool VtInfo::isGlobalCpuLimit() const
{
	return m_bGlobalCpuLimit;
}

void VtInfo::setGlobalCpuLimit(bool value)
{
	m_bGlobalCpuLimit = value;
}

QString VtInfo::getCpuModel() const
{
	return m_qsCpuModel;
}

void VtInfo::setCpuModel(QString value)
{
	m_qsCpuModel = value;
}

void VtInfo::setDefaults(QDomElement* RootElement)
{
	Q_UNUSED(RootElement);

	QStringList dyn_lists;
	if (RootElement)
		dyn_lists = RootElement->attribute("dyn_lists").split(" ");

	if ( ! RootElement || ! RootElement->firstChildElement("GlobalCpuLimit").isNull() )
		setGlobalCpuLimit();
	if ( ! RootElement || ! RootElement->firstChildElement("CpuModel").isNull() )
		setCpuModel();
}

QDomElement VtInfo::getXml(QDomDocument* Document, bool no_save_option) const
{
	Q_UNUSED(no_save_option);
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	int nElemIdx = 0;
	Q_UNUSED(nElemIdx);
	QDomElement element;
	QDomText text_element;
	QDomCDATASection cdata_element;
	QStringList dyn_lists;
	QSet<int > setItemIds;
	QMap<QString , int > mapMaxDynListIds = m_mapMaxDynListIds;

	QDomElement root_element = Document->createElement(m_qsExtRootTagName.isEmpty() ? QString("VtInfo") : m_qsExtRootTagName);

	dyn_lists += "QemuKvm";
	nMaxItemId = getMaxItemId<QemuKvm>(m_lstQemuKvm, "QemuKvm", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstQemuKvm.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const QemuKvm* object = m_lstQemuKvm[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "QemuKvm", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("GlobalCpuLimit");
	text_element = Document->createTextNode( QString("%1").arg(isGlobalCpuLimit()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	dyn_lists += "CpuFeatures";
	nMaxItemId = getMaxItemId<CpuFeatures>(m_lstDisabled, "CpuFeatures", mapMaxDynListIds);
	setItemIds.clear();
	for(i = 0; i < m_lstDisabled.size() && (true); ++i)
	{
		checkAndInsertExtDocElement(root_element, nElemIdx);
		const CpuFeatures* object = m_lstDisabled[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		element = object->getXml(Document, no_save_option);
		element.setAttribute("id", QString::number(nItemId));
		root_element.appendChild(element);
	}
	dyn_lists += QString::number(syncMaxItemId(nMaxItemId, "CpuFeatures", mapMaxDynListIds));

	checkAndInsertExtDocElement(root_element, nElemIdx);
	element = Document->createElement("CpuModel");
	text_element = Document->createTextNode( QString("%1").arg(getCpuModel()) );
	root_element.appendChild(element);
	element.appendChild(text_element);

	checkAndInsertExtDocElement(root_element, nElemIdx);

	root_element.setAttribute("dyn_lists", dyn_lists.join(" "));

	return root_element;
}

int VtInfo::readXml(QDomElement* RootElement, QString ext_tag_name, bool unite_with_loaded)
{
	QDomDocument temp_doc;
	QString tag_name;
	QString attribute;
	QDomText text_element;
	QDomCDATASection cdata_element;

	tag_name = RootElement->tagName();
	m_qsTagName = tag_name;
	m_qsExtRootTagName = ext_tag_name;
	if (tag_name != (ext_tag_name.isEmpty() ? QString("VtInfo") : ext_tag_name))
	{
		m_qsErrorMessage = "Error in class 'VtInfo': wrong root element with tag name '" + tag_name + "'";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	bool bSupportDynList = RootElement->hasAttribute("dyn_lists");
	QStringList dyn_lists = RootElement->attribute("dyn_lists").split(" ");
	initMaxItemIds(dyn_lists);
	QDomElement element = RootElement->firstChildElement();

	int nMaxItemId_QemuKvm = getMaxItemId2(element, "QemuKvm");
	QMap<int , QString > mapQemuKvm;
	if (unite_with_loaded)
		fillItemIdMap<QemuKvm>(m_lstQemuKvm, mapQemuKvm);
	int nMaxItemId_CpuFeatures = getMaxItemId2(element, "CpuFeatures");
	QMap<int , QString > mapCpuFeatures;
	if (unite_with_loaded)
		fillItemIdMap<CpuFeatures>(m_lstDisabled, mapCpuFeatures);

	m_qsErrorMessage.clear();
	m_lstWarningList.clear();
	ClearListsInReadXml(unite_with_loaded, dyn_lists, bSupportDynList);
	setDefaults(unite_with_loaded ? RootElement : 0);
	m_mapPatchedFields.clear();

	int QemuKvm_count = 1;
	int Disabled_count = 1;
	int GlobalCpuLimit_count = 1;
	int CpuModel_count = 1;

	int nElemIdx = 0;
	m_mapExtDoc.clear();
	m_doc = QDomDocument();
	while(!element.isNull())
	{
		tag_name = element.tagName();

		bool unused_tag = true;

		QDomElement* pElement = 0;
		Q_UNUSED(pElement);
		bool is_set = false;
		Q_UNUSED(is_set);

		pElement = 0;
		is_set = false;
		attribute = "GlobalCpuLimit";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (GlobalCpuLimit_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "GlobalCpuLimit")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setGlobalCpuLimit(text_element.data().toInt() != 0);
			--GlobalCpuLimit_count;
		}


		pElement = 0;
		is_set = false;
		attribute = "CpuModel";
		if (RootElement->hasAttribute(attribute))
		{
			pElement = RootElement;
		}
		else if (element.hasAttribute(attribute))
		{
			pElement = &element;
		}

		if (pElement && (CpuModel_count - 1) == 0)
		{
			text_element = temp_doc.createTextNode( pElement->attribute(attribute) );
			is_set = true;
		}
		else if (tag_name == "CpuModel")
		{
			is_set = true;
			text_element = element.firstChild().toText();
		}

		if (is_set)
		{
			unused_tag = false;
			setCpuModel(text_element.data());
			--CpuModel_count;
		}


		if (tag_name == "QemuKvm")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_QemuKvm++ : nItemId;
			QemuKvm* object = new QemuKvm();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapQemuKvm.contains(nItemId))
				object->fromString(mapQemuKvm.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstQemuKvm += object;
			--QemuKvm_count;
			m_lstWarningList += object->GetWarningList();
		}

		if (tag_name == "CpuFeatures")
		{
			unused_tag = false;
			int nItemId = element.attribute("id", "-1").toInt();
			nItemId = nItemId == -1 ? nMaxItemId_CpuFeatures++ : nItemId;
			CpuFeatures* object = new CpuFeatures();
			object->setItemId(nItemId);
			if (unite_with_loaded && mapCpuFeatures.contains(nItemId))
				object->fromString(mapCpuFeatures.value(nItemId));
			if (object->readXml(&element, tag_name, unite_with_loaded))
			{
				m_qsErrorMessage = object->GetErrorMessage();
				delete object;
				return PRL_ERR_PARSE_VM_CONFIG;
			}
			m_lstDisabled += object;
			--Disabled_count;
			m_lstWarningList += object->GetWarningList();
		}

		if ( unused_tag )
			m_mapExtDoc.insert(nElemIdx, m_doc.importNode(element, true).toElement());
		nElemIdx++;
		element = element.nextSiblingElement();
	}

	if (QemuKvm_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VtInfo': tag 'QemuKvm' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (Disabled_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VtInfo': tag 'CpuFeatures' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (GlobalCpuLimit_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VtInfo': tag 'GlobalCpuLimit' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	if (CpuModel_count > 0)
	{
		m_qsErrorMessage = "Error in class 'VtInfo': tag 'CpuModel' does not satisfy 'minOccurs = 1' condition";
		return PRL_ERR_PARSE_VM_CONFIG;
	}

	syncMaxItemId(nMaxItemId_QemuKvm, "QemuKvm");
	syncMaxItemId(nMaxItemId_CpuFeatures, "CpuFeatures");


	return 0;
}

void VtInfo::syncItemIds()
{
	int i = -1;
	Q_UNUSED(i);
	int nMaxItemId = -1;
	Q_UNUSED(nMaxItemId);
	QSet<int > setItemIds;

	nMaxItemId = getMaxItemId<QemuKvm>(m_lstQemuKvm, "QemuKvm");
	setItemIds.clear();
	for(i = 0; i < m_lstQemuKvm.size(); ++i)
	{
		QemuKvm* object = m_lstQemuKvm[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "QemuKvm");

	nMaxItemId = getMaxItemId<CpuFeatures>(m_lstDisabled, "CpuFeatures");
	setItemIds.clear();
	for(i = 0; i < m_lstDisabled.size(); ++i)
	{
		CpuFeatures* object = m_lstDisabled[i];
		if ( ! object ) continue;
		int nItemId = object->getItemId();
		do {
			nItemId = nItemId == -1 ? nMaxItemId++ : nItemId;
			if ( ! setItemIds.contains(nItemId) ) break;
			nItemId = -1;
		} while(1);
		setItemIds.insert(nItemId);
		object->setItemId(nItemId);
		object->syncItemIds();
	}
	syncMaxItemId(nMaxItemId, "CpuFeatures");

}

void VtInfo::Copy(const VtInfo& rObject)
{
	if (this == &rObject)
		return;

	int i = -1;
	Q_UNUSED(i);

	CopyBase(&rObject);

	setGlobalCpuLimit(rObject.isGlobalCpuLimit());
	setCpuModel(rObject.getCpuModel());

	ClearList<QemuKvm >(m_lstQemuKvm);
	for(i = 0; i < rObject.m_lstQemuKvm.size(); i++)
		m_lstQemuKvm += new QemuKvm(rObject.m_lstQemuKvm[i]);

	ClearList<CpuFeatures >(m_lstDisabled);
	for(i = 0; i < rObject.m_lstDisabled.size(); i++)
		m_lstDisabled += new CpuFeatures(rObject.m_lstDisabled[i]);

	CustomCopy(&rObject);

}

void VtInfo::InitLists()
{
	InitList<QemuKvm>(1, m_lstQemuKvm);
	InitList<CpuFeatures>(1, m_lstDisabled);
	CustomInit();
}

void VtInfo::ClearLists()
{
	ClearList<QemuKvm>(m_lstQemuKvm);
	ClearList<CpuFeatures>(m_lstDisabled);
}

void VtInfo::ClearListsInReadXml(bool unite_with_loaded, const QStringList& dyn_lists, bool bSupportDynList)
{
	Q_UNUSED(unite_with_loaded);
	Q_UNUSED(dyn_lists);
	Q_UNUSED(bSupportDynList);
	QDomElement element;
	int i = -1;
	Q_UNUSED(i);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("QemuKvm") )
		ClearList<QemuKvm>(m_lstQemuKvm);
	if ( ! unite_with_loaded || ! bSupportDynList || dyn_lists.contains("CpuFeatures") )
		ClearList<CpuFeatures>(m_lstDisabled);
}

